#include <stdio.h>
#include <stdlib.h>
#include <math.h>
/*
the following #include is okay as long as this file is in a first-level 
sub-directory from /ss2/harry.
*/
#include "../gui/src/dps/util/util_def.h"
#include "../gui/src/dps/util/util.h"
#define MOSFLM_INDEX TRUE
void fortran_transform_(float Xmm[],float Ymm[],float dist,float rot_mat[2][2],
                        float lambda,float phi_start,float phi_end,
                        int count,float x[],float y[],float z[],
                        detector_setting det_set, float resmin, float resmax)
     /*  =  =  =  =  =  =  =  =  =  =  =  =  =  =  =  =  =  =  =  =  =  = 
      *                                                                 *
      * this is to convert a number of variables from the FORTRAN side  *
      * to C structures, then call rs_2_xyz and cut_xyz, which are in   *
      * dps/util/ind_transform.c and return reciprocal space            *
      * co-ordinates, cut down to the specified maximum resolution,     *
      * in a form suitable for the calling FORTRAN programs             * 
      * Of course, I could have re-written the C routine, but that      *
      * doesn't seem as neat.                                           *
      *                                                                 *
      *  =  =  =  =  =  =  =  =  =  =  =  =  =  =  =  =  =  =  =  =  =  */
{
  int   i, called_from_mosflm;
  int   number_xyz;
 /* struct detector_setting det_set;*/
  struct rs_coord *rs;
  struct vector xyz_all[5000];
  struct vector xyz[5000];
  called_from_mosflm = 1;
  for (i=0;i<count;i++)
    {
      rs[i].r = Xmm[i];
      rs[i].s = Ymm[i];
      rs[i].phi_start = phi_start;
      rs[i].phi_end = phi_end;
    };
  det_set.lambda = lambda;
  det_set.dist_mm = dist;
  det_set.film_rot_mat[0][0] = rot_mat[0][0];
  det_set.film_rot_mat[0][1] = rot_mat[0][1];
  det_set.film_rot_mat[1][0] = rot_mat[1][0];
  det_set.film_rot_mat[1][1] = rot_mat[1][1];

  rs_2_xyz(count, det_set, rs, &xyz_all[0],called_from_mosflm);
  number_xyz = cut_xyz(count, xyz_all, resmin, resmax, &xyz[0]);
}
