C
C       $Id: mosflm.f,v 1.145 2010/01/26 11:44:42 harry Exp $
C
C==     MAIN ==
        PROGRAM MOSFLM
C       ==============
        IMPLICIT NONE
C       
C       This version currently maintained by A.G.W. Leslie and
C       H.R. Powell
C       MRC Laboratory of Molecular Biology
C       Hills Road,
C       Cambridge
C       CB2 2QH
C       
C       Tel. 01223-248011 Ext 2212,2235
C       E-mail address: andrew@mrc-lmb.cam.ac.uk
C       
C       This version has been developed from the Imperial College
C       VAX version due to:
C       
C       A.G.W. LESLIE, A.J. WONACOTT, P. BRICK AND S. DOCKERILL
C       BLACKETT LABORATORY,IMPERIAL COLLEGE,LONDON SW7 2BZ UK
C       
C       Based in turn on the Nova version of
C       A.J. WONACOTT, S. DOCKERILL AND P. BRICK.
C       
C       and derived originally from the Cambridge version of
C       J. NYBORG and A.J.WONACOTT
C       
C       Last format 6460
C       
C       Common block PARAMETER
C       .. Include files ..
C&&*&& include  ../inc/parameter.f
C
C $Id: parameter.f,v 1.17 2009/10/28 16:43:34 harry Exp $
C
C--- awk generated include file  parameter.h
C---- START of include file parameter.h
C
C       PARAMETERS
C       IYLENGTH.. maximum number of I*2 words of data in the 
C                  "fast" (ie most rapidly changing) direction in the
C                  digitised image. This will be HALF the number of pixels
C                  for film data (each pixel is stored in one byte)
C                  but will equal the number of pixels for IP data.
C       IXWDTH...  The maximum number of "stripes" of data in the scanned image
C                  ie the number of pixels in the "slow" direction
C                  (This is the Y direction in the MOSFLM convention)
C                  Note that the array "IMAGE" used to store the image is
C                  declared as size IYLENGTH*IXWDTH I*2 words for IP data
C                  and 2*IYLENGTH*IXWDTH BYTES for film data.
C                  If this exceeds the
C                  available memory, set ixwdth=1, recompile program
C                  and use keyword "NOCORE" when running program.
C                  Note that for the POSTREF and ADDPART options,
C                  two images have to be stored in memory at once so
C                  IXWDTH should be twice the number of records in an
C                  image.
C       MAXHEAD    maximum length of image header (in 4 byte words)
C       NREFLS.... maximum number of spots per film in generate file (250,000)
C       MAXBOX.... maximum number of pixels in measurement box (1500)
C       MAXDIM.... maximum box size in either direction (pixels) (41)
C       MAXPAX.... maximum number of packs per generate file (10000)
C       MXDOV2..... maxdim/2
C       MAXBUFF... maximum size of buffer (I*2) for storing ods
C                  of active spots in subroutine meas(21,000).
C                  Must be .GE.  MAXBOX*(NNLINE-1) for subroutine process
C       MREF...... maximum number of reflections to be used in post
C                  refinement (6000)
C       NEXPAND... maximum number of expansions of the input measurement
C                  box (2)
C       NMASKS.... maximum number of different profiles (25). Note the
C                  connection between this parameter and NNLINE
C       NVECT..... maximum number of vectors for storing scanned image
C                  in filmplot (10000)
C       NIMAX..... maximum number of images to be used together in 
C                  postrefinement (NADD or WIDTH options) (100)
C       NNLINE...  maximum number of boundary lines for setting up
C                  the areas for profile fitting. The maximum possible
C                  number of standard profiles will be (NNLINE-1)**2
C                  although for a circular detector the actual number
C                  may be less than this as some boxes will lie entirely
C                  outside the detector.
C       NREJMAX... Maximum number of rejected background pixels, resulting
C                  either from overlap of adjacent spots or outliers from
C                  the background plane
C       NSPOTS...  Maximum number of found spots (for autoindexing) that can
C                  be stored (for all images). Also maximum number in 
C                  a file wriitten by IMSTILLS that can be 
C                  stored/displayed/edited. THis must be an even number
C       MCOLS....  Number of columns in output MTZ file
C       MCOLSTR..  Number of columns in output MTZ file for strategy option
C     
C       MTZ Orientation block
C        MBLENG is total length of block, MBLINT, MBLREA are numbers
C          of integers & reals
C       NDETREF    Maximum number of reflections used for detector parameter
C                  refinement (previously 62)
C       NRPAR....  Maximum number of refineable parameters for detector
C                  positional refinement (subroutine RDIST)
C       NSEGMAX..  Maximum number of segments in STRATEGY
C       NSEGMAXPR  Maximum number of segments in POST-REFINEMENT
C       MULTMAX... Maximum number of observations with same hkl in COMPLETE
C       MAXDIFF... Maximum number of different packs that a given hkl occurs on
C       NRESBIN... Maximum number of resolution bins (COMPLETE)
C
C       MAXIMG...  Maximum number of images that can be read in using the IMAGE
C                  keyword or the "read Image" menu option.
C       MXSPOT...  Maximum number of spots that can be found on one image
C                  (before rejection on spot size).
C       MXCENT...  Maximum number of active spots during spot finding 
C                  (findspots)
C
C       MGRA, NGRA... maximum number of reflections and images over which a 
C                     reflection can be spread for postrefinement.
C       MAXBGBOX    Maximum number of local background background boxes 
C                   in X and Y
C
C       MAXNPEAKS   Maximum number of local maxima within one spot
C       MAXEXCL     Maximum number of excluded areas of the same type
C                   eg reactangles, quadrilaterals, arcs, resolution shells
C
C     .. Parameters ..
      INTEGER IXWDTH
c      PARAMETER (IXWDTH=8192)
      PARAMETER (IXWDTH=12288)
      INTEGER IYLENGTH
c      PARAMETER (IYLENGTH=4096)
      PARAMETER (IYLENGTH=6144)
      INTEGER MAXHEAD
      PARAMETER (MAXHEAD=5120)
      INTEGER MAXBOX
      PARAMETER (MAXBOX=3000)
      INTEGER MAXDIM
      PARAMETER (MAXDIM=41)
      INTEGER MAXPAX
      PARAMETER (MAXPAX=10000)
      INTEGER MXDOV2
      PARAMETER (MXDOV2=MAXDIM/2)
      INTEGER NEXPAND
      PARAMETER (NEXPAND=2)
      INTEGER NNLINE
      PARAMETER (NNLINE=8)
      INTEGER NMASKS
      PARAMETER (NMASKS=49)
      INTEGER MAXBUFF
      PARAMETER (MAXBUFF=21000)
      INTEGER NREFLS
      PARAMETER (NREFLS=250000)
      INTEGER MREF
      PARAMETER (MREF=6000)
      INTEGER NVECT
      PARAMETER (NVECT=10000)
      INTEGER NIMAX
      PARAMETER (NIMAX=100)
      INTEGER NREJMAX
      PARAMETER (NREJMAX=1000)
      INTEGER NSPOTS
      PARAMETER (NSPOTS=5000)
      INTEGER MCOLS
      PARAMETER (MCOLS=18)
      INTEGER MCOLSTR
      PARAMETER (MCOLSTR=6)
      INTEGER NREFSTR
C
C---- Each reflection for strategy run needs MCOLSTR I*2 words
C     plus an I*4 word for the merging
C
      PARAMETER (NREFSTR = IXWDTH*IYLENGTH/(2+MCOLSTR))
      INTEGER MBLENG,MBLINT,MBLREA
      PARAMETER (MBLENG=185,MBLINT=29,MBLREA=156)
      INTEGER NDETREF
      PARAMETER (NDETREF=400)
      INTEGER NRPAR
      PARAMETER (NRPAR=14)
      INTEGER NSEGMAX
      PARAMETER (NSEGMAX=100)
      INTEGER NSEGMAXPR
      PARAMETER (NSEGMAXPR=100)
      INTEGER MULTMAX
      PARAMETER (MULTMAX=100)
      INTEGER MAXDIFF
      PARAMETER (MAXDIFF=100)
      INTEGER NRESBIN
      PARAMETER (NRESBIN=20)
      INTEGER MXSPOT
      PARAMETER (MXSPOT=5000)      
      INTEGER MAXIMG
      PARAMETER (MAXIMG=100)      
      INTEGER NPIXBG
      PARAMETER (NPIXBG=51)
      INTEGER MXCENT
      PARAMETER (MXCENT=500)
      INTEGER    NGRA,MGRA
      PARAMETER (NGRA=20)
      PARAMETER (MGRA=50000)
      INTEGER MAXBGBOX
      PARAMETER (MAXBGBOX=500)
      INTEGER MAXNPEAKS
      PARAMETER (MAXNPEAKS=500)
      INTEGER MAXEXCL
      PARAMETER (MAXEXCL=50)
C&&*&& end_include  ../inc/parameter.f
C&&*&& include  ../inc/mxdinc.f
C
C $Id: mxdinc.f,v 1.1 2002/05/02 10:47:00 harry Exp $
C
C--- awk generated include file  mxdinc.h
C---- START of include file mxdinc.h
C
C
c common block for mxd routines: various parameters for XDL routines
c
c     base_width    width of base frame
c     base_height   height of base frame
c     men_x,men_y   position of menu area
c     par_x,par_y   position of parameter area
C     

C     IORDER    (R)   Order of the data in the input image 
c                with respect to two local axes ax1, ax2 e.g.
c                (xf, yf) as a number from 1 to 8.
c                    1   +ax1 slow   +ax2 fast    (+xf, +yf)
c                    2   +ax1 slow   -ax2 fast    (+xf, -yf)
c                    3   -ax1 slow   +ax2 fast    (-xf, +yf)
c                    4   -ax1 slow   -ax2 fast    (-xf, -yf)
c                    5   +ax2 slow   +ax1 fast    (+yf, +xf)
c                    6   +ax2 slow   -ax1 fast    (+yf, -xf)
c                    7   -ax2 slow   +ax1 fast    (-yf, +xf)
c                    8   -ax2 slow   -ax1 fast    (-yf, -xf)
c
c
c     JORDER    (R)   Display order with respect to the two
c                local axes (1 to 8) along the X-windows
c                axes X horizontal (left to right), Y vertical 
c                (top to bottom ) with origin at top left
c                1  +ax1 X (horiz)   +ax2 Y (vert)   (+xf, +yf)
c                2  +ax1 X (horiz)   -ax2 Y (vert)   (+xf, -yf)
c                3  -ax1 X (horiz)   +ax2 Y (vert)   (-xf, +yf)
c                4  -ax1 X (horiz)   -ax2 Y (vert)   (-xf, -yf)
c                5  +ax2 X (horiz)   +ax1 Y (vert)   (+yf, +xf)
c                6  +ax2 X (horiz)   -ax1 Y (vert)   (+yf, -xf)
c                7  -ax2 X (horiz)   +ax1 Y (vert)   (-yf, +xf)
c                8  -ax2 X (horiz)   -ax1 Y (vert)   (-yf, -xf)
c                    
c                    (2 was standard for Laue programs)
c
c     nxp_cmp       number of pixels compressed to 1 in horizontal
c                   display direction
c     nyp_cmp       number of pixels compressed to 1 in vertical
c                   display direction
c     nxdpx         number of horizontal pixels in displayed image
c     nydpx         number of vertical pixels in displayed image
c     img_horiz     image direction for horizontal display (=1 fast, 2 slow)
c     img_vert      image direction for vertical display   (=1 fast, 2 slow)
c     img_map(4)    mapping of image to display
c                    imgmap(1)   1st point on fast axis (Yms)
c                    imgmap(2)   1st point on slow axis (Zms)
c                    imgmap(3)   increment on fast axis
c                    imgmap(4)   increment on slow
c     img_x,img_y   x, y position of image
c     men_x, men_y  x, y position of menu
c     par_x, par_y  x, y position of parameter table
c     io_x, io_y    x, y position of IO area
c     not_x, not_y    x, y position of notice area (parameter table
c                     with no values)
c     pmn_x, pmn_y  x, y position of popup abort menu
c     ppb_x, ppb_y  x, y position of popup progress bar
c     busy_x, busy_y x, y position of busy window
c     img_width,img_height   width, height of image window
c     men_width, men_height  width, height of menu window  
c     par_width, par_height  width, height of parameter window
c     io_width, io_height    width, height of IO window
c     not_width, not_height  width, height of notice area
c     pmn_width, pmn_height  width, height of Abort menu
c     ppb_width              width of progress bar
c     busy_width, busy_height  width, height of busy box
c     sub_process    .true. if program is sub-process of eg clips, .false.
c                    if standalone
c
C     IFTYPE      1 = unsigned byte data
C                 2 = unsigned two-byte data (i2)
C                 3 = signed integer data
C                 4 = 'squashed i2' data (if Intensity>32767 
C                    store as 65536-Intensity/8)
      INTEGER BASE_WIDTH,BASE_HEIGHT,
     $     IMAGE_ORDER,JIMAGE_ORDER,NXP_CMP,NYP_CMP,
     $     NXDPX,NYDPX,
     $     IMG_HORIZ,IMG_VERT,IMG_MAP(4),
     $     IMG_X,IMG_Y,MEN_X,MEN_Y,PAR_X,PAR_Y,IO_X,IO_Y,
     $     NOT_X,NOT_Y,PMN_X, PMN_Y,PPB_X, PPB_Y, BUSY_X, BUSY_Y,
     $     BUSY_Y2,IFTYPE
      INTEGER IMG_WIDTH, IMG_HEIGHT, MEN_WIDTH, MEN_HEIGHT,
     $     PAR_WIDTH, PAR_HEIGHT, IO_WIDTH, IO_HEIGHT,
     $     NOT_WIDTH, NOT_HEIGHT, PMN_WIDTH, PMN_HEIGHT,
     $     PPB_WIDTH, BUSY_WIDTH, BUSY_HEIGHT
      LOGICAL SUB_PROCESS, BLANK
C

c  DON'T forget to declare function xdlstr as integer
      INTEGER XDLSTR
      EXTERNAL XDLSTR

c
c     ivhbas        view object handle for base frame
c     ivhimg        view object handle for image
c     ivhpar        view object handle for parameter table
c     ivhmen        view object handle for menu
c     ivhio         view object handle for io area
c     ivhio2        view object handle for second io area (pick option)
c     ivhio3        view object handle for third io area (output)
c     ivhnot        view object handle for notice area (parameter table)
c     ivhpmn        view object handle for popup wait menu
c     ivhppb        view object handle for popup progress bar
c     ivhblank      view object handle for blank object
c     ivhbusy       view object handle for busy object
c     ivhbusy2      view object handle for second (2 line) busy object
      INTEGER IVHBAS, IVHIMG, IVHPAR, IVHMEN, IVHIO, IVHNOT, IVHPMN,
     $     IVHPPB, IVHBLANK, IVHBUSY, IVHIO2, IVHBUSY2, IVHIO3
      PARAMETER (IVHBAS=1, IVHIMG=2, IVHPAR=3, IVHMEN=4, IVHIO=5,
     $     IVHNOT=6, IVHPMN=7, IVHPPB=8, IVHBLANK=9, IVHBUSY=10,
     $     IVHIO2=11, IVHBUSY2=12, IVHIO3=13)

c  Border  boundary between windows
      INTEGER BORDER
      PARAMETER (BORDER = 4)

c     icset   colour set number
      INTEGER ICSET
      PARAMETER (ICSET=1)
c
c     iord    axis order of image
c             = 1  xf slow, yf fast
      INTEGER IORD
      PARAMETER (IORD = 1)
c
c     minw,minh   minimum width and height for image display object
      INTEGER MINW,MINH
      PARAMETER (MINW=0, MINH=0)
c
c     ixopix, iyopix      pixel origin of displayed part
      INTEGER IXOPIX,IYOPIX
      PARAMETER (IXOPIX=1, IYOPIX=1)
c
c     ibg     background menu, =0 for none
      INTEGER IBG
      PARAMETER (IBG=0)
c
c     iovly   overlay option
      INTEGER IOVLY
      PARAMETER (IOVLY=1)
c
c     max_pixel   maximum number of pixels to use for image display:
c                 this will be used to control possible compression
c                 of the image
      INTEGER MAX_PIXEL
      PARAMETER (MAX_PIXEL = 800)
c  Image stuff
c     disp_img        true if image has been displayed
c
      LOGICAL DISP_IMG
c
c     ifd     file descriptor, = -1 for no file
      INTEGER IFD
      PARAMETER (IFD=0)
c

c  Parameter table stuff
c     max_par_col     maximum number of parameter columns
c     max_par_rows    maximum number of parameter rows
c     max_par_name    maximum length of name
c     max_par_str     maximum value length
c     par_title       = -1 no title +1 title present
c     par_font        font (3=medium)
c     par_menu        = 1 if popup menus allowed
c     disp_par        true if parameter table hsa been displayed
c
      LOGICAL DISP_PAR
      INTEGER MAX_PAR_COL, MAX_PAR_ROWS, MAX_PAR_NAME, MAX_PAR_STR,
     $        PAR_TITLE, PAR_FONT, PAR_MENU
      PARAMETER (MAX_PAR_COL = 1, MAX_PAR_ROWS = 50,
     $           MAX_PAR_NAME = 17, MAX_PAR_STR = 7,
     $           PAR_TITLE = 1, PAR_FONT = 2, PAR_MENU = 0)
C
c  Menu stuff
c     max_men_itms    maximum number of menu items
c     max_men_name    maximum number of characters in menu item
c     men_font        menu font number (3=medium)
c     men_quit_flag   = 1 to allow for quit box
c     max_men_title   maximum length of menu title
c     disp_menu       true if menu displayed
      LOGICAL DISP_MENU
      INTEGER MAX_MEN_ITMS, MAX_MEN_NAME, MEN_FONT, MEN_QUIT_FLAG,
     $        MAX_MEN_TITLE 
      PARAMETER (MAX_MEN_ITMS = 19, MAX_MEN_NAME = 19, MEN_FONT = 4,
     $     MEN_QUIT_FLAG = 1, MAX_MEN_TITLE = 9)

c
c IO area stuff
c     io_font         font number
c     disp_io         true if io area displayed
c     disp_io2        true if SECOND io area displayed
c     disp_io3        true if THIRD io area displayed
C     NSCROLL         number of pages to hold for scrolling
      LOGICAL DISP_IO,DISP_IO2,DISP_IO3
      INTEGER IO_FONT,NSCROLL
      PARAMETER (IO_FONT=2)
      PARAMETER (NSCROLL=0)


c  Notice area stuff (notice area is a parameter table with no values)
c     max_not_col     maximum number of parameter columns
c     max_not_rows    maximum number of parameter rows
c     max_not_name    maximum length of name
c     max_not_str     maximum value length
c     not_title       = -1 no title +1 title present
c     not_font        font (3=medium)
c     not_menu        = 1 if popup menus allowed
c     disp_not       true if menu displayed
      LOGICAL DISP_NOT
      INTEGER MAX_NOT_COL, MAX_NOT_ROWS, MAX_NOT_NAME, MAX_NOT_STR,
     $        NOT_TITLE, NOT_FONT, NOT_MENU
      PARAMETER (MAX_NOT_COL = 1, MAX_NOT_ROWS = 18,
     $           MAX_NOT_NAME = 23,
     $           MAX_NOT_STR = 0,
     $           NOT_TITLE = +1, NOT_FONT = 2, NOT_MENU = 0)
c
c  Menu stuff for Abort menu
c     max_pmn_itms    maximum number of menu items
c     max_pmn_name    maximum number of characters in menu item
c     pmn_font        menu font number (3=medium)
c     pmn_quit_flag   = 1 to allow for quit box
c     max_pmn_title   maximum length of menu title
      INTEGER MAX_PMN_ITMS, MAX_PMN_NAME, PMN_FONT, PMN_QUIT_FLAG,
     $        MAX_PMN_TITLE 
      PARAMETER (MAX_PMN_ITMS = 0, MAX_PMN_NAME = 12, PMN_FONT = 4,
     $     PMN_QUIT_FLAG = 1, MAX_PMN_TITLE = 15)

c   Stuff for progress bar
c     ppb_font   font number (3=medium)
c     ppb_colr   colour
      INTEGER PPB_FONT, PPB_COLR
      PARAMETER (PPB_FONT = 4, PPB_COLR=3)

c   Busy box
      INTEGER BUSY_FONT
      PARAMETER (BUSY_FONT = 3)
c
c len_dialog    length of dialog box
      INTEGER LEN_DIALOG
      PARAMETER (LEN_DIALOG = 60)

c
c  Overlays
c
c  Circles
c     cir_ivec    vector set number for circles
c     cir_colr    colour for circles
c     cir_iovl    overlay number for circles
c     cir_symb   symbol for centre
      INTEGER CIR_IVEC, CIR_COLR, CIR_IOVL, CIR_SYMB
      PARAMETER (CIR_IVEC=3, CIR_COLR=6, CIR_IOVL=2, CIR_SYMB=4)

C
C---- Residual vectors
C     IRV_VEC Vector set number
C     IRV_COL Colour  (1 red, 2 yellow, 3 green)
C     IRV_OVL Overlay number
      INTEGER IRV_VEC, IRV_COL, IRV_OVL
      PARAMETER (IRV_VEC=4, IRV_COL=1, IRV_OVL=2)
c  Measure
c
c     mes_colr    colour for measure crosses
      INTEGER MES_COLR
      PARAMETER (MES_COLR=1)

c   Vertical Crosses
c     cross_iovl    overlay number for circles
c     cross_symb   symbol for centre
      INTEGER CROSS_IOVL, CROSS_SYMB
      PARAMETER (CROSS_IOVL=2, CROSS_SYMB=3)
c  Boxes
c     box_iovl    overlay number for boxes
c     box_symb   symbol for centre
      INTEGER BOX_IOVL, BOX_SYMB, BOX_VEC
      PARAMETER (BOX_VEC=2,BOX_IOVL=2, BOX_SYMB=13)
c  Circles
c     CIRC_iovl    overlay number for circles
c     CIRC_symb   symbol for centre
      INTEGER CIRC_IOVL, CIRC_VEC
      PARAMETER (CIRC_VEC=5,CIRC_IOVL=2)
c   Crosses
c     cross_iovl    overlay number for circles
c     cross_symb   symbol for centre
      INTEGER XCROSS_IOVL, XCROSS_SYMB
      PARAMETER (XCROSS_IOVL=2, XCROSS_SYMB=13)
C
C---- common block last of all
C
      COMMON /MXDCMI/ BASE_WIDTH,BASE_HEIGHT,
     $     IMAGE_ORDER,JIMAGE_ORDER,NXP_CMP,NYP_CMP,
     $     NXDPX,NYDPX,
     $     IMG_HORIZ,IMG_VERT,IMG_MAP,
     $     IMG_X,IMG_Y,MEN_X,MEN_Y,PAR_X,PAR_Y,IO_X,IO_Y,
     $     NOT_X,NOT_Y,PMN_X, PMN_Y,PPB_X, PPB_Y, BUSY_X, BUSY_Y,
     $     BUSY_Y2, IFTYPE,
     $     IMG_WIDTH, IMG_HEIGHT, MEN_WIDTH, MEN_HEIGHT,
     $     PAR_WIDTH, PAR_HEIGHT, IO_WIDTH, IO_HEIGHT,
     $     NOT_WIDTH, NOT_HEIGHT, PMN_WIDTH, PMN_HEIGHT,
     $     PPB_WIDTH, BUSY_WIDTH, BUSY_HEIGHT,
     $     SUB_PROCESS,BLANK,DISP_IMG,DISP_PAR,DISP_MENU,
     $     DISP_IO,DISP_IO2,DISP_IO3,DISP_NOT
  
C&&*&& end_include  ../inc/mxdinc.f
C       
        INTEGER NPARM
        PARAMETER (NPARM = 200)
C       ..
C       .. Local Scalars ..
        REAL CCXS,CCYS,ELIMIT,ELIMIT2,ELIMIT3,OMEGA0,SAVECCOM,
     +       SBULGE,STILT,STWIST,
     +       SXTOFRA,SYSCAL,TEMP,X,SBULGE2,STOFF,RESID,
     +       RDIVH,RDIVV,RETA,
     +       WELIMIT,XLIMIT,CCOMLAST,CCOMAX,ROFFLAST,ROFFMAX,WRMAX,
     +       PHIXLAST,PHIYLAST,PHIZLAST,DELPHIMAX,AVBGRMAX,AVBGRMIN,
     +       ROFFSAVE,CCOMSAVE,TOFFLAST,TOFFMAX,TOFFSAVE,SROFF,
     +       SDMISS,YSCALERR,RFP
        INTEGER I,IBULGE,ICASSP,ICTF,ICYC,IIF,IFAIL,IFILM,
     +       IFIRSTGOOD,IFIRSTPACK,IPACK,IREP,
     +       IXERRI,J,JPACK,K,MODE,MODEWR,NACFLM,NCC,MINREFAV,
     +       NFILMS,NFIRSTI,NFLMO,NFOUND,NFP,NMR,NPROFL,NRSOLD,
     +       NRX,NRY,NXS,NYS,SAVECCX,SAVECCY,LDUM,
     +       ITOFF,NPACKSAVE,NOWRITE,NREPEAT,NADDP,MTZPRT,
     +       MODEOP,JFILMS,JSTART,IFIRSTP,IPT,IPTR,
     +       NUMBLOCK,NBADMAX,IROFF,ISEG,IDTMP,MODEG,NFULLF,
     +       MODECTRL,ISUB,IFIRSTPSEG,MINREFS,IERR,ISTAT,
     +       MODEDISP,IERR2,IXP,IYP,IBUTTON,L,IXM,IYM,
     +       LINELEN,NUMLIN,MODEGSR,NIMAGSV,
     +       LASTREC,NADD_STORE,portno,INIT_MODE,NSINGRPT,
     +       IRPTPACK,NFRPT,PRDFLAG,NIMGSM,PRNSAVE
        LOGICAL AVPROFILE,BADSTART,CENTRE,DOPROFILE,FAIL,FILMPLT,
     +       FIRSTTIME,FORCE,GENLIST,GENOPEN,GWRITE,LIST,NEWGENF,
     +       OLDLIST,OVRLDS,PARTLS,PROCESSA,RESCAN,TREAT_AS_AFILM,
     +       UPDATE,YES,ADDPP,STORCELL,PRFIRST,FINAL,
     +       RRWEIGHT,USEWEIGHT,OKREF,EXTRAIMG,CENTRAL,PACK,LAST,
     +       RPTFIRST,BIGSHIFT,FIRSTPACK,DONEONCE,CENTRSRPT,
     +       FORCEREAD,COORDOPN,FIXPARTLS,RPTIMG,FIRSTWARN,
     $       PRFINISH,INERR,XMLONLY,XMLABORT
        CHARACTER ABC*3,CELLSTR*50,LINE*80,STR1*1,LINE2*80,
     $       REMOTEMOSFLMHOST*32, longline*1024,CALLEDFROM*80,
     +       LINE400*400,KEY6*6

C       ..
C       .. Local Arrays ..
        REAL RSUMM(12,MAXPAX),XERR(MAXPAX),PRFSUM(25,MAXPAX),SCELL(6),
     +       SDELPHI(3),SVXCEN(NIMAX),SVYCEN(NIMAX),RPTSHIFT(3,6),
     +     OLDCELL(6)
        INTEGER ISUMM(20,MAXPAX),IXERR(MAXPAX),NERR(MAXPAX),
     +       PRFSUMI(MAXPAX),ISKIPI(2*MAXPAX),IRSAVE(NDETREF),
     +       IPACKSTART(MAXPAX),MODE2(2),LASTFILM(NSEGMAXPR),INTDUM(2)
        LOGICAL BADPACK(MAXPAX,3),SUMP(MAXPAX),PRFRPT1(MAXPAX),
     +       ADDP(MAXPAX),PRF(MAXPAX),PRFHS(MAXPAX),PRNEGM(MAXPAX),
     +       PRFRPT2(MAXPAX)
        CHARACTER SUMMCH(MAXPAX)*1, ARGV(200)*80
C       
C----   Things for parser
C       
        INTEGER IBEG(NPARM),IDEC(NPARM),IEND(NPARM),ITYP(NPARM)
        REAL VALUE(NPARM)
        INTEGER NTOK
C       ..
C       .. External Functions ..
        INTEGER LENSTR,CCPE2I
        LOGICAL CCPONL,VAXVMS
        EXTERNAL CCPONL,LENSTR,VAXVMS,CCPE2I
C       ..
C       .. External Subroutines ..
        EXTERNAL AUTOMATCH,BELL,CENTRS,CHKRAS,CONTROL,FIDUS,
     +       FINDPACK,GENERATE,GENSORT,
     +       MEAS,NEXT,NOYES,OPENODS,PFINDPACK,
     +       PROCESS,PSTART,PWRGEN,QCLOSE,QSEEK,RDIST,RMAXR,
     +       SEEKRS,MSELECT,SUMMERR,WRGEN,YESNO,POSTREFL,
     +       CCPFYP,UGTENV,WARNINGS,PRSETUP,CCPOPN,CCPDPN,VERSION,
     +       DET,XDISP,OVERLAP2,SHUTDOWN,MXD_FLU,STARTMTZ,
     +       MXDBSY,GETSEPRAS,MXDWIO,MXDRIO,WRMTZ,NEWFN,PRSUMMARY,
     +       CELLREFSET
C       ..
        EXTERNAL MOSDATA
C       ..
C       .. Intrinsic Functions ..
        INTRINSIC COS,NINT,SIN
C       ..
C       .. Common blocks ..
C&&*&& include  ../inc/amatch.f
C
C $Id: amatch.f,v 1.1 2002/05/02 10:46:40 harry Exp $
C
C--- awk generated include file  amatch.h
C---- START of include file amatch.h
C
C
C     .. Scalars in Common /AMATCH/ ..
C     ..
      REAL RCONV,OVRLAP,RESOL1,RESOL2,AELIMIT,ARMSLIM,
     +     SECANGLE,DAMP,TRUECCOM,ETAMAX,AWRMSLIM,MOSNEW,
     $     SLOPE,INTERCEPT
      INTEGER NSTEP,NCYCA,NPASS,N2,N3,N4,N5,N6,N7,N8,N9,N10,NBEAM
      LOGICAL MATCH,NOCENT,NOREFINE,RMOSAIC
C     ..
C     .. Common block /AMATCH/  ..
      COMMON /AMATCH/RCONV,OVRLAP,RESOL1,RESOL2,AELIMIT,ARMSLIM,
     +     SECANGLE,DAMP,TRUECCOM,ETAMAX,AWRMSLIM,MOSNEW,
     $     SLOPE,INTERCEPT,NSTEP,NCYCA,NPASS,N2,N3,N4,N5,N6,N7,
     $     N8,N9,N10,NBEAM,MATCH,NOCENT,NOREFINE,RMOSAIC
C     ..
C
C
C&&*&& end_include  ../inc/amatch.f
C&&*&& include  ../inc/ccondata.f
C
C $Id: ccondata.f,v 1.8 2010/01/04 17:03:18 harry Exp $
C
C--- awk generated include file  ccondata.h
C---- START of include file ccondata.h
C
C
C     .. Scalars in Common /CCONDATA/ ..
      CHARACTER GENFILE*200,CCFILE*200,ODEXT*8,WAXFN*134,
     +     GTITLE*80,IDENT*40,NEWMATNAM*200,MTZNAM*200,MTZDIR*200,
     $     PGNAME*10,
     +     SPGNAM*10,ODFILE*480,SEPCHAR*1,SNEWMATNAM*200,
     +     TEMPLSTART*100,TEMPLEND*100,TEMPLSAV*100,BITMAPTYPE*12,
     $     CCP4VERSION*10
C     ..
C     ..  Arrays in Common /CCONDATA/ ..
      CHARACTER FDISK(10)*400,INLINE(1000)*400
C     ..
C     .. Common block /CCONDATA/ ..
      COMMON /CCONDATA/GENFILE,CCFILE,ODEXT,WAXFN,GTITLE,IDENT,
     +     NEWMATNAM,MTZNAM,MTZDIR,PGNAME,SPGNAM,ODFILE,
     +     SEPCHAR,SNEWMATNAM,TEMPLSTART,TEMPLEND,
     $     TEMPLSAV,BITMAPTYPE,CCP4VERSION,FDISK,INLINE
C     ..
C
C
C&&*&& end_include  ../inc/ccondata.f
C&&*&& include  ../inc/cconst8.f
C
C $Id: cconst8.f,v 1.1 2002/05/02 10:46:42 harry Exp $
C
C--- awk generated include file  cconst8.h
C---- START of include file cconst8.h
C
C
C     .. Arrays in Common /CCONST8/ ..
      REAL CCOMA
      INTEGER CCXA,CCYA,CBARA
C     ..
C     .. Common block /CCONST8/ ..
      COMMON /CCONST8/CCOMA(8),CCXA(8),CCYA(8),CBARA(8)
C     ..
C
C
C
C&&*&& end_include  ../inc/cconst8.f
C&&*&& include  ../inc/cell.f
C
C $Id: cell.f,v 1.3 2005/05/20 15:05:07 harry Exp $
C
C--- awk generated include file  cell.h
C---- START of include file cell.h
C
C     CELL cell dimensions (real space)
C     RCELL reciprocal cell parameters in dimensionless rlu
C
C     .. Arrays in Common /CELLCOM/ ..
      REAL UMAT,BMAT,GMAT,CELL,RCELL,UMATCELL,SOFTCELL,VOLUME
      INTEGER LCELL,ICRYST,NUMSPG,NLAUE
C     ..
C     .. Common Block /CELLCOM/ ..
      COMMON /CELLCOM/UMAT(3,3),BMAT(3,3),GMAT(3,3),CELL(6),RCELL(6),
     $       UMATCELL(6),SOFTCELL,VOLUME,LCELL(6),ICRYST,NUMSPG,NLAUE
C     ..
C
C
C&&*&& end_include  ../inc/cell.f
C&&*&& include  ../inc/condata.f
C
C $Id: condata.f,v 1.32 2009/09/03 16:24:33 harry Exp $
C
C--- awk generated include file condata.h 
C---- START of include file condata.h 
C 
C
C     FIXSWAP     Forces reversal of normal byte-swapping choice.
C
C---- SUMPART True if two images are to be stored in memory at the
C               same time. This will be the case if post-refinement
C               (other than POSTHOC post-refinement for off-line
C               scanners) is being performed. Note that SUMPART is NOT
C               used to determine if partials should be added across
C               images (this is ADDPART)
C
C---- NEWPREF True if allowing partials over multiple images in post-
C             refinement.
C
C---- ADDPART True if partials are to be summed across images. This is
C               only appropriate for fixed origin (ie on-line)
C               scanners where the X-ray dose is identical for
C               each image.
C     Direct beam coordinates
C             These are read into XMM(3), YMM(3) where (3) is for A,B,C packs
C             Immediately on reading in, these values are transferred
C             into XCENMM, YCENMM, XCENMMIN(J,3) where J=1->MAXPAX.
C
C             If an IMAGE keyword has been given, XCENMM(1,1)=XMM(1) and
C             YCENMM(1)=YSCAL*YMM(1). If swung out, YCENMM(1,1) is updated.
C             If a BEAM keyword has not been given, XMM,YMM, XCENMM,YCENMM,
C             XCENMMIN are all set to the middle of the image.


C             Then, when reflecting input to logfile, it AGAIN sets up
C             XCENMM,YCENMM for all images using XMM,YMM, this time
C             using YSCAL to set up YCENMM, and updating YCENMM if the
C             detctor is swung out. (label 708), DO loop 710. If image
C             is "inverted", corrects XCENMM for all images.


C             XCEN,YCEN are set in "mosflm" to XCENF, YCENF plus
C             camera constants, and XCENF,YCENF are in turn set from
C             XCENMM,YCENMM. Thus XCENMM,YCENMM are what is actually
C             used to define the beam position.

C
C     LPREF   If TRUE, return to display after refinement over entire
C             image. Only active when integrating interactively. Set by
C             toggle button in Parameter window.
C

C     LOVERLAP  If TRUE, do not call the OVERLAP subroutine

C     ALLOUT  If TRUE, all reflections (whether measured or not, or
C             classified as BADSPOTS or not, will be written to the
C             output MTZ file.
C
C     NTDIG   Number of digits in image number, returned as zero if
C             there is an error in the template. Only used if TEMPLATE
C             keyword given.
C
C     TEMPLATE is TRUE if a TEMPLATE keyword has been given.
C
C     NOLP    If TRUE, do NOT apply the Lorentz Polarisation corrections
C
C     MULTIMTZ True if writing each "block" of images to a separate MTZ file
C
C     DISPMENU True if the run was started with a IMAGE keyword. Not to be
C              confused with WINOPEN which is true if the X-window display
C              is being used, but this is not necessarily starting with
C              a "IMAGE" keyword.
c     newgui - this means that we're talking through the new GUI.
c              except that we can't have it here because the prsummary 
c              subroutine, where we REALLY want it, clashes with this common
C
C     HACTIVEMASK,LACTIVEMASK,LACTIVE - only for Rigaku images which 
C     contain a compressed "active mask" (size=HACTIVEMASK bytes)
C     at the end of the image. Compression uses a modified run length encoding
C     at present (10.01.2003).
C
C     MINBATCH Minimum allowed batch number to be written to an open
C              MTZ file (MTZ library imposes that batch numbers must 
C              increase as file is written).
C     ..
C     .. Arrays in common /CONDATA/ ..
      REAL XCENMM,YCENMM,THFOIL,PHIBEGA,PHIENDA,RSYM,XMM,YMM,
     +     XCENMMIN,YCENMMIN
      REAL RMSLIM,WRMSLIM,VLIM,XMID,SEP,THICK,PTMIN,REFREJ,WAIT,
     +     YSCALIN,FULLFRAC,WTIME
C     ..
C     .. Arrays in common /CONDATA/ ..
      INTEGER IDPACK,NFPACK,NFIRST,ICASSET
      INTEGER IPACK1A,IPACK2A,ISERAR,PICKER
      LOGICAL AVPROF,FILMPLOT,FORCEB,FORCEC
C
C     .. Scalars in common /CONDATA/ ..
C     ..
      INTEGER NPACK,NCYC,MAXNX,MAXNY,ITHRESHF,NSIG,IRFMIN,
     +        IRFINC,IXSHIFT,IYSHIFT,LIMIT,NBLOCK,INOGEN,NFGEN,MINREF,
     +        ISERADD,NSEG,NSYM,NSYMP,NRUN,NSERTOT,IWAVE,ISWUNG,
     $        IBEAMMU,ITILT,ITWIST,IPIX,IRMINXY,ICUT,IPRCUT,ILIMIT
      INTEGER IMAT,ICELL,IUMAT,LSYMM,IDIST,IBEAM,ISCAN,NLINE,NRLINE,
     +        NTLINE,ISTARTP,IRAST,INEWMAT,ISEP,NSAVELINE,IPTIME,
     +        ISTRT,IANGLE,IBACKS,IPOLAR,IDIVH,IDIVV,IGAIN,IBLOCK,
     +        IHKLOUT,IGENF,INRES,NTDIG,DELAY,IMULTI,IMISS,IMISSMAT,
     +        IIDENT,HACTIVEMASK,ITWOTHETA,MINBATCH,ILABVIEW,INVVIEW,
     $     IINVVIEW,IHKLDIR,IBGSIG,NRLEFT
      LOGICAL FINDCC,READCC,NOFID,INTERPOL,CONVOL,NOMEAS,
     +        USEPAR,USEOVR,SUMPART,USEBOX,POSTREF,ADDPART,
     +        FIXED,POWDER,RWEIGHT,NOREF,MULTISEG,FIXSWAP,POSTHOC,
     +        LPREF,LPINTG,DISPMENU,PRMODE,PRCELL,TEMPLATE,
     +        LOVERLAP,ALLOUT,NOLP,NEWPREF,NOBACK,MOSEST,NUSPOT,
     $        NUBACK,NUFIND,HARVESTREADY,HEADINFO,MULTIMTZ,ANDREW, 
     +        spostref,newgui,LACTIVEMASK,USERSPOT,HEADONLY,PHIONLY,
     $        NO_XML,TESTSOCK,PICKLOG,EXPLICIT_CELL,LSIMULATE,
     $     LONGERNAME
C     ..
C real arrays, then scalars, integer arrays, scalars, logicals
      COMMON /CONDATA/
     $       XCENMM(MAXPAX,3),
     +       YCENMM(MAXPAX,3), THFOIL(3),PHIBEGA(MAXPAX),
     $       PHIENDA(MAXPAX),RSYM(4,4,96),XMM(3),YMM(3),
     $       XCENMMIN(MAXPAX),YCENMMIN(MAXPAX),
     $       RMSLIM,WRMSLIM,VLIM,XMID,SEP,THICK,PTMIN,REFREJ,WAIT,
     +       YSCALIN,FULLFRAC,WTIME,
     $        IDPACK(MAXPAX),NFPACK(MAXPAX),NFIRST(MAXPAX),
     +        ICASSET(MAXPAX),IPACK1A(50),
     +        IPACK2A(50),ISERAR(50),PICKER(4),
     $        AVPROF(MAXPAX),FILMPLOT(MAXPAX),FORCEB(MAXPAX),
     +        FORCEC(MAXPAX),
     $        NPACK,NCYC,MAXNX,MAXNY,ITHRESHF,NSIG,IRFMIN,
     +        IRFINC,IXSHIFT,IYSHIFT,LIMIT,NBLOCK,INOGEN,NFGEN,MINREF,
     +        ISERADD,NSEG,NSYM,NSYMP,NRUN,NSERTOT,IWAVE,ISWUNG,
     $        IBEAMMU,ITILT,ITWIST,IPIX,IRMINXY,ICUT,IPRCUT,ILIMIT,
     $        IMAT,ICELL,IUMAT,LSYMM,IDIST,IBEAM,ISCAN,NLINE,NRLINE,
     +        NTLINE,ISTARTP,IRAST,INEWMAT,ISEP,NSAVELINE,IPTIME,
     +        ISTRT,IANGLE,IBACKS,IPOLAR,IDIVH,IDIVV,IGAIN,IBLOCK,
     +        IHKLOUT,IGENF,INRES,NTDIG,DELAY,IMULTI,IMISS,IMISSMAT,
     +        IIDENT,HACTIVEMASK,ITWOTHETA,MINBATCH,ILABVIEW,INVVIEW,
     $        IINVVIEW,IHKLDIR,IBGSIG,NRLEFT,FINDCC,READCC,NOFID,
     +        INTERPOL,CONVOL,NOMEAS,USEPAR,USEOVR,SUMPART,USEBOX,
     +        POSTREF,spostref, ADDPART,FIXED,POWDER,RWEIGHT,NOREF,
     +        MULTISEG,FIXSWAP,POSTHOC,LPREF,LPINTG,DISPMENU,PRMODE,
     $        PRCELL,TEMPLATE,
     +        LOVERLAP,ALLOUT,NOLP,NEWPREF,NOBACK,MOSEST,NUSPOT,
     $        NUBACK,NUFIND,HARVESTREADY,HEADINFO,MULTIMTZ,ANDREW,
     $        newgui,LACTIVEMASK,USERSPOT,HEADONLY,PHIONLY,NO_XML,
     $        TESTSOCK,PICKLOG,EXPLICIT_CELL,LSIMULATE,
     $     LONGERNAME


C&&*&& end_include  ../inc/condata.f
C&&*&& include  ../inc/debug.f
C
C $Id: debug.f,v 1.2 2008/07/24 09:42:21 andrew Exp $
C
C--- awk generated include file  debug.h
C---- START of include file debug.h
C
C
C
C     .. Arrays in common /DEBUG/ ..
      REAL XWARN
      INTEGER NDEBUG,IWARN
      LOGICAL DEBUG,LPRINT,DUMP,WARN
C
C     .. Scalars in common /DEBUG/ ..
      REAL BGRLIM
      INTEGER NDUMP,IDUMP,MXDUMP
      LOGICAL SPOT
C     
C     ..
C     .. Common Block /DEBUG/..
      COMMON /DEBUG/XWARN(20,100),BGRLIM,NDEBUG(100),IWARN(20,100),
     $       NDUMP,IDUMP,MXDUMP,DEBUG(100),LPRINT(20),DUMP(30),
     +       WARN(100),SPOT
C     ..
C
C&&*&& end_include  ../inc/debug.f
C&&*&& include  ../inc/dsplyc.f
C
C $Id: dsplyc.f,v 1.6 2009/02/18 14:39:17 harry Exp $
C
C--- awk generated include file  dsplyc.h
C---- START of include file dsplyc.h
C
C*******************************************************************
C
C  COMMON  /DSPLYC/
C
C       IMGLOW, IMGHI   low & high values of 16-bit image for scaling
C                       integer*2 to byte: IMGLOW maps to  0; 
C                       IMGHI to maximum. Note that these are not
C                       necessarily the actual limits of the data
C       IMGMAX          maximum value recorded on the image. Necessary for 
C                       iMosflm.
C       JDSPWD          .LT. 0  before image window has been created
C                       = +-1 for image display that can be panned
C                       = +-2 for non-interactive image display
C       MAXDEN          highest level in colour table to fill up to
C                       must be less than ~240 - number of overlay colours
C       LDSPSG          if .true., treat image as signed, ie after dark
C                          subtraction
C                       if .false., treat image as unsigned
C       NZOOM           zoom factor for image, = 0 if no zoom
C       JYZOOM, JZZOOM  1st pixel in zoomed image
C
C----   WINOPEN Flag for whether or not window is open. Do not
C               confuse with DISPMENU (/CONDATA/)which is true if the run was
C               started with a IMAGE keyword.
C
C
C       CDSPTL          banner title
C
      REAL FTOTAL,AVERAG,IMAGERMS
      INTEGER IMGLOW, IMGHI, IMGMAX,JDSPWD, MAXDEN,
     $     NZOOM, JYZOOM, JZZOOM
      INTEGER PIXEL_INTENSITIES(514)
      LOGICAL LDSPSG,WINOPEN,LPAUSE,LHELP
      COMMON /DSPLYC/ FTOTAL,AVERAG,IMAGERMS,IMGLOW, IMGHI, IMGMAX,
     *     JDSPWD,MAXDEN, NZOOM, JYZOOM, JZZOOM, PIXEL_INTENSITIES,
     $     LDSPSG,WINOPEN,LPAUSE,LHELP
C
      CHARACTER  CDSPTL*200,SHORTFN*200
      COMMON /DSPLCC/  CDSPTL,SHORTFN
C                                                           
C
C*******************************************************************


C&&*&& end_include  ../inc/dsplyc.f
C&&*&& include  ../inc/extras.f
C
C $Id: extras.f,v 1.2 2003/04/04 14:22:01 harry Exp $
C
C--- awk generated include file  extras.h
C---- START of include file extras.h
C
C
C     .. Scalars in common /EXTRAS/ ..
      INTEGER JUMPAX,NPACKS
      LOGICAL ISKIP,AFILM,BFILM,CFILM,STARTA,STARTB,STARTC,NOSTOP
C     ..
C     .. Common block /EXTRAS/ ..
      COMMON /EXTRAS/JUMPAX,NPACKS,ISKIP,AFILM,BFILM,CFILM,STARTA,
     +       STARTB,STARTC,NOSTOP
C     ..
C
C
C&&*&& end_include  ../inc/extras.f
C&&*&& include  ../inc/fid.f
C
C $Id: fid.f,v 1.5 2007/11/06 12:49:03 harry Exp $
C
C--- awk generated include file  fid.h
C---- START of include file fid.h
C
C     XCENF,YCENF  Coordinates (in 10 micron units) of the direct beam
C                  position relative to an origin at the position of the
C                  first pixel in the digitised image.(The SCANNER
C                  coordinate frame).
C                  For IP data this comes from the defined
C                  direct beam coordinates, for film data it is the
C                  midpoint of fiducials 1 and 3.
C
C     CCX,CCY      The difference (in 10 micron units) between the
C                  refined position of the direct beam (XCEN,YCEN) and
C                  the ideal direct beam coordinates (XCENF,YCENF),
C                  in the SCANNER coordinate frame.
C                  CCX,CCY are updated in RDIST. They are in "pixels"
C                  rather than mm (but expressed in 10micron units).
C
C     DTOFD        The distance (in 10 micron units) from the crystal
C                  to the detector along a normal to the detector.
C                  For flat, unswung detectors, or swung on a 2 theta arm,
C                  this is the same as CTOFD and XTOFD. It differs for
C                  Vee shaped cassettes. Assigned in START and never changed.
C                  Only actually used in RMAXR for calculating box sizes.
C
C     .. Arrays in common /FID/ ..
      REAL CCOMABC
      INTEGER FSPOS,CCXABC,CCYABC
C     ..
C     .. Scalars in common /FID/ ..
      REAL OMEGAF,OMEGAFD,CCOM,DTOFD,XCENF,YCENF
      INTEGER MM,MMDB,NFID,CCX,CCY,IYOFF,LABVIEW
      CHARACTER SPOTFILEORIGIN*2,SPOTFILEAXISORDER*2,SWINGAXIS*2
C     ..
C     .. Common block /FID/ ..
      COMMON /FID/CCOMABC(3),OMEGAF,OMEGAFD,CCOM,DTOFD,XCENF,YCENF,
     $     FSPOS(4,2),
     +     CCXABC(3),CCYABC(3),MM,MMDB,NFID,CCX,CCY,IYOFF,LABVIEW,
     $     SPOTFILEORIGIN,SPOTFILEAXISORDER,SWINGAXIS
C     ..
C
C
C&&*&& end_include  ../inc/fid.f
C&&*&& include  ../inc/film_no.f
C
C $Id: film_no.f,v 1.2 2004/07/20 12:36:58 harry Exp $
C
        INTEGER ID
        COMMON /FILM_NUM/ ID
C&&*&& end_include  ../inc/film_no.f
C&&*&& include  ../inc/gendata.f
C
C $Id: gendata.f,v 1.2 2003/01/10 16:17:53 andrew Exp $
C
C--- awk generated include file  gendata.h
C---- START of include file gendata.h
C
C     IMG       Partiality indicator. 0 for full reflections, 1 to 100
C                   for partials. Negative for partials at the start of the
C                   rotation range, +ve for partials at the end of the 
C                   rotation. Set in subroutine REEK using DELEPS calculated
C                   in subroutine DSTAR
C
C     IRG       Reflection flag  (Set by SPTEST called from DSTAR)
C               =  0  Spot can be measured
C               =  1  Outside R, X, Y limits
C               =  2  Overlapping spot (set later)
C               =  3  Too wide in phi (more than NWMAX images)
C               =  4  DST .GT. DSTMAX  Not included in final film list -
C                       used only to check for overlaps at edge of film.
C               = 10  Spot is within cusp, but will be observed...not included
C                     in final spot list but must be included in predicted
C                      pattern
C
C               =  21  Spot present on 2 images, this is 1st
C               =  22  Spot present on 2 images, this is 2nd
C
C               =  31  Spot present on 3 images, this is 1st
C               =  32  Spot present on 3 images, this is 2nd
C               =  33  Spot present on 3 images, this is 3rd
C
C               =  41  Spot present on 4 images, this is 1st
C               =  42  Spot present on 4 images, this is 2nd
C               =  43  Spot present on 3 images, this is 3rd
C               =  44  Spot present on 4 images, this is 4th
C
C                 etc etc
C
C     XG        Virtual detector X coordinate in 10 micron units, relative to
C               an origin at the direct beam position. X is parallel to the
C               Y axis in the laboratory frame, ie orthogonal to the rotation
C               axis.
C
C     YG        Virtual detector Y coordinate in 10 micron units, relative to
C               an origin at the direct beam position. Y is parallel to the
C               Z axis in the laboratory frame, ie  the rotation axis.
C
C     IX,IY     are the coordinates of the reflection in pixels
C               (integers) wrt the first pixel in the image (lower left corner
C               cameramans view). For testing for spot overlap, these
C               coordinates are in 10 micron units. Also used for display
C               pixel coordinates when displaying predicted pattern.
C
C     IREC      Pointer to the record number of a particular spot in the
C               list of generated reflections.
C
C
C     ..
C     .. Arrays in common /GENDATA/ ..
      REAL FRACG,PHIG,PHIWG,XG,YG,GOODFIT
      INTEGER INTG,IPRO,IX,IY,IREC
      INTEGER*2 IRG,IMG,IGFLAG,ISDPRO,ISDG,IHG,IKG,ILG,IMPARTG,
     +          MISYMG
C     .. Scalars in common /GENDATA/ ..
      INTEGER IPACKREC,IPACKHEAD,IRECLAST
C     ..
C     .. Common block /GENDATA/ ..
      COMMON /GENDATA/FRACG(NREFLS),PHIG(NREFLS),PHIWG(NREFLS),
     $       XG(NREFLS),YG(NREFLS),INTG(NREFLS),IPRO(NREFLS),
     $       IX(NREFLS),IY(NREFLS),IREC(NREFLS),IRG(NREFLS),IMG(NREFLS),
     +       IGFLAG(NREFLS),ISDPRO(NREFLS),ISDG(NREFLS),
     +       IHG(NREFLS),IKG(NREFLS),ILG(NREFLS),IMPARTG(NREFLS),
     +       MISYMG(NREFLS),GOODFIT(NREFLS),IPACKREC,IPACKHEAD,
     +       IRECLAST
C     ..
C
C

C&&*&& end_include  ../inc/gendata.f
C&&*&& include  ../inc/graphics.f
C
C $Id: graphics.f,v 1.1 2002/05/02 10:46:48 harry Exp $
C
C--- awk generated include file  graphics.h
C---- START of include file graphics.h
C
C
C     .. Scalars in common /GRAPHICS/ ..
      REAL GRFACT,DISPLAY
      INTEGER NGR,NGX,NGY,NHX,NHY,NLI
C     ..
C     .. Common block /GRAPHICS/ ..
      COMMON /GRAPHICS/GRFACT,DISPLAY,NGR,NGX,NGY,NHX,NHY,NLI
C     ..
C
C
C&&*&& end_include  ../inc/graphics.f
C&&*&& include  ../inc/gui.f
c     gui.h
c     maintained by G.Winter
c     16th April 2002
c     $Id: gui.f,v 1.16 2003/04/04 14:22:01 harry Exp $
c     
c     This defines the variables and common blocks which are used by the
c     new gui control routine. This will also be used in xdisp and control,
c     to switch the new gui on!
c     
c     

      logical gui_switch, refine_cell(6), refine_detector(11),
     +     autocomplete, autoreturn, newmatstore
      integer nargs
      integer imageno, nstart
      parameter (nargs = 200)

c     refine_detector logical block index:
c     1: beam x 2: beam y 3: ccomega 4: yscale
c     5: distance 6: tilt 7: twist 8: roff 9: toff
c     
c     refine_cell logical block index:
c     1: a 2: b 3: c
c     4: alpha 5: beta 6: gamma
c     
c     
c     

      integer keep_phi_segments, keep_phi_start(20), 
     +     keep_phi_end(20)

      real storemeanmult

      common /gui/ gui_switch, imageno, refine_cell, refine_detector,
     +     autocomplete, nstart, autoreturn, newmatstore

      common /keep_phi/ keep_phi_segments, keep_phi_start, 
     +     keep_phi_end, storemeanmult


c     refine_cell(i) is true if you wish to refine cell(i)
C&&*&& end_include  ../inc/gui.f
C&&*&& include  ../inc/header.f
C
C $Id: header.f,v 1.13 2009/09/03 16:24:33 harry Exp $
C
C--- awk generated include file  header.h
C---- START of include file header.h
C     .. Scalars in common block /HEADER/
      REAL HDIST,HWAVE,HRAST,HTOR,HPHIS,HPHIE,HPHIR,HOMEGAS,
     $     HOMEGAE,HTWOTHETA,HKAPPA,HCHI,
     $     HBEAMX,HBEAMY,HCCOMEGA,HTWIST,HTILT,HSIZED
      INTEGER NHEAD,NTAIL,HNULLPIX,HSERIAL,HYEAR,HDATE,HCOMPR,
     $     HBIAS,SUMBYTES,HUNDER,HDATEC,HCUTOFF,HPRCUTOFF
      LOGICAL USEHDR,USETAIL,USEDIST,USEWAVE,USEPHI,HDRSIZE
C     ..
C     .. Arrays in common block /HEADER/
      INTEGER IHEAD,HOVER
C     ..
C     .. Common Block /HEADER/
      COMMON /HEADER/ HDIST,HWAVE,HRAST,HTOR,HPHIS,HPHIE,HPHIR,
     $     HOMEGAS,HOMEGAE,HTWOTHETA,HKAPPA,HCHI,
     $     HBEAMX,HBEAMY,HCCOMEGA,HTWIST,HTILT,HSIZED,
     $     IHEAD(MAXHEAD),
     $     HOVER(3),NHEAD,NTAIL,HNULLPIX,HSERIAL,HYEAR,HDATE,
     +     HCOMPR,HBIAS,SUMBYTES,HUNDER,HDATEC,HCUTOFF,HPRCUTOFF,
     $     USEHDR,USETAIL,
     +     USEDIST,USEWAVE,USEPHI,HDRSIZE
C     ..
      CHARACTER HCOMPRESS*3,HMONTH*3,HOSCAXIS*6
      COMMON /CHEADER/ HCOMPRESS,HMONTH,HOSCAXIS
C&&*&& end_include  ../inc/header.f
C&&*&& include  ../inc/ioo.f
C
C $Id: ioo.f,v 1.7 2009/05/13 11:57:53 harry Exp $
C
C--- awk generated include file  ioo.h
C---- START of include file ioo.h
C
C
C
C     .. Scalars in common block /IOO/ ..
      INTEGER IOUT,IUNIT,ITIN,ITOUT,INOD,INMO,IDU,NWRN,IBRIEF,ISUMMR,
     +        ICOORD,SERVERFD,SERVERFDIN,NSHUTERR,dnafd
      LOGICAL ONLINE,ONEFILE,FHEADER,BRIEF,GRAPH,IOERR,
     $     NODISPLAY,LBELL,JPGOUT,SOCKLO,LBEST,dnaout,INMOOPEN,
     $     XMLOPEN
      CHARACTER dna_image*80,xmlfile*80
C     ..
C     .. Common block /IOO/ ..
c      COMMON /IOO/IOUT,IUNIT,ONLINE,ITIN,ITOUT,INOD,INMO,IDU,NWRN,
c     +            ONEFILE,FHEADER,BRIEF,IBRIEF,GRAPH,ISUMMR,ICOORD,
c     +            IOERR,NODISPLAY,LBELL
C     ..
C
C
      COMMON /IOO/IOUT,IUNIT,ITIN,ITOUT,INOD,INMO,IDU,NWRN,IBRIEF,
     +        ISUMMR,ICOORD,SERVERFD,SERVERFDIN,NSHUTERR,ONLINE,ONEFILE,
     +        FHEADER,BRIEF,GRAPH,IOERR,NODISPLAY,LBELL,JPGOUT,
     $        SOCKLO,LBEST, dnafd, dnaout,INMOOPEN,XMLOPEN
      COMMON /CIOO/dna_image,xmlfile

C&&*&& end_include  ../inc/ioo.f
C&&*&& include  ../inc/iosp.f
C
C $Id: iosp.f,v 1.1 2002/05/02 10:46:53 harry Exp $
C
C--- awk generated include file  iosp.h
C---- START of include file iosp.h
C
C
C     .. Scalars in common block /IOSP/ ..
      INTEGER NSPOT,NFULL,NOUTGEN
C     ..
C     .. Common Block /IOSP/ ..
      COMMON /IOSP/NSPOT,NFULL,NOUTGEN
C     ..
C
C
C&&*&& end_include  ../inc/iosp.f
C&&*&& include  ../inc/lmb.f
C
C $Id: lmb.f,v 1.8 2009/01/08 18:03:14 harry Exp $
C
C--- awk generated include file  lmb.h
C---- START of include file lmb.h
C ODSCAL is to scale image numbers into the range 0-255 for plotting
C average profiles.
C  GAIN should be equal to the overall gain (image counts per X-ray photon)
C of the system, and is used to evaluate standard deviations based on
C counting statistics assuming independent pixels (ie point spread function
C less than pixel size).
C INVERTX true if image is inverted in the slow (X) direction when read in.
C ISCAL is to scale final integrated intensities and sigmas
C IDIVIDE is the adc offset
C ICONST is a constant to be added to all pixels (normally zero) to
C        allow processing of images with zero pixel values in the scanned
C        area.
C IMGP is true if working with image plate data
C SPIRAL is true for scanners with a spiral readout (Mar, DIP2000)
C ORTHOG is true for scanners with orthogonal scan (FUJI, RAXIS, MD)
C NULLPIX is the value of pixels within the image but not in the active
C area of the detector
C TILED is true if there are inactive areas of the detector within the
C       inscribing circle or square.
C
C NTILEX Number of tiles in X direction
C NTILEY Number of tiles in Y direction
C TILEX  X Coordinates of the midpoints of the null areas between tiles
C TILEY  Y Coordinates of the midpoints of the null areas between tiles
C TILEWX Width of the null areas between tiles in X
C TILEWY Width of the null areas between tiles in Y


C MACHINE and MODEL denote the type of detector. 
C
C MACHINE is used in the following subroutines:
C GETBLK, GETHDR, INTPXL, INTPXL2, MXDSPL, OPENODS, PROCESS, PUTPXL
C Currently coded types are:
C
C         MACHINE        MODEL               COMMENTS
C         =======        =====               ========
C         MAR            180, 300, 345
C         RAXI(S)        RAXISII, RAXISIV
C         MD
C         FUJI
C         CCD1           CCD1                Princetown CCD at CHESS,Tiff format
C         CCD2           CCD ?               ESRF CCD detector
C         ADSC           QUAD1               ADSC 2x2 CCD detector
C
C TRUSTED whether or not the image header information can be trusted for 
C         automatic processing
C     .. Scalars in Common Block /LMB/ ..
        REAL ODSCAL,GAIN,LOGA,LOGB
        INTEGER ISCAL,IDIVIDE,ICONST,NULLPIX,NTILEX,NTILEY,
     $    RAXISCOMP,IIDIVIDE,COMPRESSION
        LOGICAL IMGP,INVERTX,SPIRAL,ORTHOG,CIRCULAR,TILED,SETADC,
     $    NEWRAXIS,BRUKNEW,TRUSTED
        CHARACTER MACHINE*4,MODEL*8

C     ..
C     .. Arrays in common /LMB/
        INTEGER TILEX,TILEY,TILEWX,TILEWY
C
C     .. Common Block /LMB/ ..
        COMMON /LMB/ ODSCAL,GAIN,LOGA,LOGB,ISCAL,IDIVIDE,ICONST,
     +       NULLPIX,NTILEX,NTILEY,RAXISCOMP,IIDIVIDE,COMPRESSION,
     +       TILEX(20),TILEY(20),TILEWX(20),TILEWY(20),IMGP,
     +       INVERTX,SPIRAL,ORTHOG,CIRCULAR,TILED,SETADC,
     $       NEWRAXIS,BRUKNEW,TRUSTED
        COMMON /LMBC/ MACHINE,MODEL

C&&*&& end_include  ../inc/lmb.f
C&&*&& include  ../inc/mcs.f
C $Id: mcs.f,v 1.1 2002/05/02 10:46:56 harry Exp $
C
C
C--- awk generated include file  mcs.h
C---- START of include file mcs.h
C
C
C     .. Scalars in common block /MCS/ ..
      REAL BASEOD,G1OD,CURV
      INTEGER FILM,FILMS,CTOFD,PCKIDX,TOSPT,N1OD,XSCMIN,XSCMAX
      LOGICAL VEE,VALONGX
C     ..
C     .. Common block /MCS/ ..
      COMMON /MCS/BASEOD,G1OD,CURV,FILM,FILMS,CTOFD,PCKIDX,TOSPT,
     $            N1OD,XSCMIN,XSCMAX,VEE,VALONGX
C     ..
C     CTOFD.... This was the crystal to detector distance (10 micron units)
C               but it has now been replaced by XTOFD in common block /XY/
C
C&&*&& end_include  ../inc/mcs.f
C&&*&& include  ../inc/misc.f
C
C $Id: misc.f,v 1.2 2009/09/03 16:24:33 harry Exp $
C
C--- awk generated include file  misc.h
C---- START of include file misc.h
C
C
C
C     .. Scalars in common /MISC/ ..
      REAL PHIBEG,PHIEND,PHIRNG,RMIN,RMAX,WAVE
      INTEGER IPACKID,MININT,IERRFLG
C     ..
C     .. Arrays in common /MISC/ ..
      REAL DELPHI,RESANI
      INTEGER IAX
C     ..
C     .. LOGICAL
      LOGICAL ANITES

C     ..
C     .. Common Block /MISC/ ..
      COMMON /MISC/DELPHI(3),RESANI(3),PHIBEG,PHIEND,PHIRNG,RMIN,RMAX,
     $       WAVE,IAX(3),IPACKID,MININT,IERRFLG,ANITES
C     ..
C
C
C&&*&& end_include  ../inc/misc.f
C&&*&& include  ../inc/misset.f
C
C $Id: misset.f,v 1.1 2002/05/02 10:46:57 harry Exp $
C
C---- START of include file misset.h 
C 
C     ..
C     .. Arrays in common /MISSET/ ..
      REAL RMISSETS,SDMISSETS
C     ..
      COMMON /MISSET/ RMISSETS(MAXPAX,3),SDMISSETS(MAXPAX,2)
C&&*&& end_include  ../inc/misset.f
C&&*&& include  ../inc/myprof.f
C
C $Id: myprof.f,v 1.2 2007/06/25 16:18:20 andrew Exp $
C
C--- awk generated include file  myprof.h
C---- START of include file myprof.h
C
C
C     .. Arrays in Common Block /MYPROF/ ..
      REAL PRSCALE,XPMAX,YPMAX,XLINE,YLINE,WPROFL,WPRSUMS
      INTEGER ISIZE,NRFBOX,IPROFL,IBOX,IXBOX,IYBOX,NPFIRST
      LOGICAL BOX
C     ..
C     .. Scalars in Common Block /MYPROF/
      REAL TOL,BGPKRAT,FRACREJ,BADTOL,TOLMIN,RECLEVEL
      INTEGER NXLINE,NYLINE,NUMBOX,IBOUND,ITRIM,NOVERLAP,MINPKSIZ
      LOGICAL HIGHRES,LOWRES,PRSET,OFFDET,PROPT,FIXBOX,LINESET,
     +        PROPTCEN,RECOVER,NOFIXBOX
C     ..
C     .. Common Block /MYPROF/ ..
      COMMON /MYPROF/PRSCALE(NMASKS,2),XPMAX(NMASKS),YPMAX(NMASKS),
     $       XLINE(NNLINE),YLINE(NNLINE),
     +       WPROFL(MAXBOX,NMASKS),WPRSUMS(MAXBOX,NMASKS),TOL,
     +       BGPKRAT,FRACREJ,BADTOL,TOLMIN,RECLEVEL,
     $       ISIZE(NMASKS,2),NRFBOX(NMASKS),
     +       IPROFL(MAXBOX,NMASKS+1),IBOX(0:NNLINE,0:NNLINE),
     +       IXBOX(NMASKS,2),IYBOX(NMASKS,2),
     +       NPFIRST(NNLINE-1),NXLINE,NYLINE,NUMBOX,IBOUND,ITRIM,
     $       NOVERLAP,MINPKSIZ,BOX(NMASKS),HIGHRES,LOWRES,PRSET,
     +       OFFDET,PROPT,FIXBOX,LINESET,PROPTCEN,RECOVER,NOFIXBOX
C     ..
C
C
C&&*&& end_include  ../inc/myprof.f
C&&*&& include  ../inc/ioomtz.f
C
C $Id: ioomtz.f,v 1.4 2005/06/10 13:36:59 harry Exp $
C
C--- awk generated include file  ioomtz.h
C---- START of include file ioomtz.h
C
C
C     .. Scalars in common block /IOOMTZ/ ..
      INTEGER MTZOUT,BESTHKL
      LOGICAL MTZOPEN,BESTOPEN
      CHARACTER*100 BSTHKL
C     ..
C     .. Common block /IOOMTZ/ ..
      COMMON /IOOMTZ/ MTZOUT,BESTHKL,MTZOPEN,BESTOPEN,BSTHKL
C&&*&& end_include  ../inc/ioomtz.f
C&&*&& include  ../inc/ioosum.f
C
C $Id: ioosum.f,v 1.2 2004/08/16 13:26:27 harry Exp $
C
C--- awk generated include file  ioosum.h
C---- START of include file ioosum.h
C
C     .. Scalars in common block /IOOSUM/
      INTEGER NLSUM1,NLSUM2,NSUMSTART1,NSUMSTART2
C
C     .. Arrays in common block /IOOSUMC/ ..
      CHARACTER*150 LINESUM1(MAXPAX),LINESUM2(MAXPAX)
      CHARACTER*101  IOLINE(100)
C     ..
C     .. Common block /IOOSUM/ ..
      COMMON /IOOSUM/ NLSUM1,NLSUM2,NSUMSTART1,NSUMSTART2
C     ..
C     .. Common block /IOOSUMC/ ..
      COMMON /IOOSUMC/ LINESUM1,LINESUM2,IOLINE
C&&*&& end_include  ../inc/ioosum.f
C&&*&& include  ../inc/ori.f
C
C $Id: ori.f,v 1.2 2007/07/12 13:25:56 andrew Exp $
C
C--- awk generated include file  ori.h
C---- START of include file ori.h
C
C     XCEN,YCEN    Coordinates (in 10 micron units) of the direct beam
C                  position relative to an origin at the position of the
C                  first pixel in the digitised image.(The SCANNER
C                  coordinate frame). These parameters are refined for
C                  each image. 
C
C     XCEN0,YCEN0  Coordinates of direct beam position at zero swing angle.
C                  (Needed for pxtomm conversion for swung detectors)
C                  These values are assigned on the basis of input direct
C                  beam coordinates, corrected for swing angle if necessary.
C                  They are not (currently) updated during refinement.
C
C     XOFF,YOFF    Distance between centre of detector and direct beam.
C
C     ..
C     .. Arrays in common /ORI/ ..
      LOGICAL FIXPAR
C
C     .. Scalars in common block /ORI/ ..
      REAL COSOM0,SINOM0,XTOFRA,YSCAL,TILT,TWIST,BULGE,
     +     VBNEG,VBPOS,VTILT,VTWIST,VVERT,TOFF,BULGE2,PBULGE,ROFF,
     +     RDTOFF,RDROFF,ROFFPHI,TOFFPHI,JUNK3,XCEN,YCEN,XCEN0,YCEN0,
     +     XOFF,YOFF,TILTMAT,TWISTMAT,DETNOR,DPSIX,SMTWIST,SMTILT,
     +     SMOMEGA0,SMYSCAL,SMTOFF,SMROFF,SMXTOFRA
      INTEGER CBAR,NODES,NPHI,NSM1,NSM2
      LOGICAL RESETCCOM,NOSMOOTH
C     ..
C     .. Common Block /ORI/ ..
      COMMON /ORI/COSOM0,SINOM0,XTOFRA,YSCAL,TILT,TWIST,BULGE,
     $       VBNEG,VBPOS,VTILT,VTWIST,VVERT,TOFF,BULGE2,PBULGE,ROFF,
     $       RDTOFF,RDROFF,ROFFPHI,TOFFPHI,JUNK3,XCEN,YCEN,XCEN0,
     +       YCEN0,XOFF,YOFF,TILTMAT,TWISTMAT,DPSIX,DETNOR(3),CBAR,
     +       NODES,NPHI,FIXPAR(NRPAR),
     $       RESETCCOM,SMTWIST,SMTILT,SMOMEGA0,SMYSCAL,SMTOFF,SMROFF,
     +       SMXTOFRA,NSM1,NSM2,NOSMOOTH
C     ..
C
C
C&&*&& end_include  ../inc/ori.f
C&&*&& include  ../inc/over.f
C
C $Id: over.f,v 1.1 2002/05/02 10:47:03 harry Exp $
C
C--- awk generated include file  over.h
C---- START of include file over.h
C
C
C     .. Scalars in Common Block /OVER/ ..
C
C     ..
C     .. Scalars in common /OVER/ ..
      INTEGER MINDTX,MINDTY,NPOVL,IXSEP,IYSEP
C     ..
C     .. ARRAYS in common /OVER/ ..
      INTEGER HKLPOVL
C     ..
C     .. Common Block /OVER/ ..
      COMMON /OVER/MINDTX,MINDTY,NPOVL,IXSEP,IYSEP,HKLPOVL(NREFLS/2)
C     ..
C
C
C&&*&& end_include  ../inc/over.f
C&&*&& include  ../inc/parm1.f
C
C $Id: parm1.f,v 1.1 2002/05/02 10:47:05 harry Exp $
C
C--- awk generated include file  parm1.h
C---- START of include file parm1.h
C
C
C
C     .. Scalars in common block /PARM1/ ..
      REAL BGSIG,EFAC,EFACSQ,BGFREJ,GRADMAX,GRADMAXR,BGRAT,PKRAT,
     +     RESD,RESDLOW
      INTEGER CUTOFF,NOVPIX,NDSTART,NDTOT,IXDMIN,IXDMAX,IYDMIN,IYDMAX,
     +     IDMIN,IDMAX
      LOGICAL DUMPSPOT,BADPLOT,DUMPALL,BADPLOT2
C     ..
C     .. Common Block /PARM1/ ..
      COMMON /PARM1/BGSIG,EFAC,EFACSQ,BGFREJ,GRADMAX,GRADMAXR,
     +              BGRAT,PKRAT,RESD,RESDLOW,CUTOFF,NOVPIX,
     +              NDSTART,NDTOT,IXDMIN,IXDMAX,IYDMIN,IYDMAX,
     +              IDMIN,IDMAX,DUMPSPOT,BADPLOT,DUMPALL,BADPLOT2
C     ..
C
C
C&&*&& end_include  ../inc/parm1.f
C&&*&& include  ../inc/parm2.f
C
C $Id: parm2.f,v 1.1 2002/05/02 10:47:06 harry Exp $
C
C--- awk generated include file  parm2.h
C---- START of include file parm2.h
C
C
C     .. Scalars in common block /PARM2/ ..
      REAL PRBGSIG,RMSBGPR,DISCRIM,PKWDLIM1,PKWDLIM2,PKWDLIM3,PKWDOUTL
      INTEGER ISDRATIO,PRCUTOFF,IPLOT,NRFMIN,NHKLD,IOUTL1,IOUTL2
      LOGICAL PROFILE,PROCES,SAVEFILE,CHANGEMASK,PRBFILM,PRCFILM,
     +        PRREAD,PRSAVE,WEIGHT,PRPART,USEOVRLD,USEDGE,VARPRO,
     +        WTPROFILE,DISCRIMINATE,PUPDATE,PKONLY,DENSE,PRFULLS,
     +        DECONV
C     ..
C     .. Arrays in common blocks /PEL/ and /PELC/ ..
      INTEGER IHD
C     ..
C     .. Common Block /PARM2/ ..
      COMMON /PARM2/PRBGSIG,RMSBGPR,DISCRIM,PKWDLIM1,PKWDLIM2,
     $       PKWDLIM3,PKWDOUTL,
     $       ISDRATIO,PRCUTOFF,IPLOT,NRFMIN,NHKLD,IOUTL1,IOUTL2,
     $       IHD(3,50),
     $       PROFILE,PROCES,SAVEFILE,CHANGEMASK,PRBFILM,PRCFILM,
     +       PRREAD,PRSAVE,WEIGHT,
     +       PRPART,USEOVRLD,USEDGE,VARPRO,
     +       WTPROFILE,DISCRIMINATE,
     +       PUPDATE,PKONLY,DENSE,
     +       PRFULLS,DECONV
C     ..
C
C
C&&*&& end_include  ../inc/parm2.f
C&&*&& include  ../inc/pel.f
C     **** This is the IMAGE PLATE version of this common block ****
C
C
C---- START of include file pel.h
C
C
C     .. Scalars in common blocks /PEL/ and /PELC/ ..
      INTEGER IBA,IPOINT,ISTART
      LOGICAL INCORE
C     ..
C     .. Arrays in common blocks /PEL/ and /PELC/ ..
      LOGICAL RDSTRIP
      INTEGER*2 BOXOD,IMAGE
C     ..
C     .. Common Blocks /PEL/ and /PELC/ ..
      COMMON /PEL/IBA,IPOINT,INCORE,RDSTRIP(IXWDTH),BOXOD(MAXBOX),
     +            ISTART
      COMMON /PELC/ IMAGE(IYLENGTH*IXWDTH)
C     ..
C
C
C---- END of include file pel.h
C
C&&*&& end_include  ../inc/pel.f
C&&*&& include  ../inc/postchk.f
C
C $Id: postchk.f,v 1.1 2002/05/02 10:47:07 harry Exp $
C
C--- awk generated include file  postchk.h
C---- START of include file postchk.h
C
C     DELPHIV   stores the missets for the first NADD images only,
C               so that once NADD images have been processed their
C               refined missets can be saved for writing to the
C               summary file.
C
C     .. Arrays in Common /POSTCHK/
      REAL SDBEAM,SDCELL,SDDELPHI,DELPHIV,SHIFT
      LOGICAL FCELL
C
C     .. Scalars in Common /POSTCHK/ ..
C     ..
      REAL PRRES1,PRRES2,RESIDMAX,SDFAC,SHIFTMAX,SHIFTFAC,
     +     ANGWIDTH,CELLSHIFT,FRACMIN,FRACMAX,FRCSHIFT
      INTEGER PRNS,NREFPR,NADD,NRPT,IPRINTP,NPRMIN
      LOGICAL USEBEAM,REFCELL
C     ..
C     .. Common block /POSTCHK/  ..
      COMMON /POSTCHK/ SDBEAM(6),SDCELL(6),SDDELPHI(2*NIMAX),
     +             DELPHIV(3*NIMAX),SHIFT(3),PRRES1,PRRES2,RESIDMAX,
     +             SDFAC,SHIFTMAX,SHIFTFAC,ANGWIDTH,CELLSHIFT, 
     $             FRACMIN,FRACMAX,FRCSHIFT,
     +             PRNS,NREFPR,NADD,NRPT,IPRINTP,
     +             NPRMIN,FCELL(6),USEBEAM,REFCELL
C     ..
C
C
C&&*&& end_include  ../inc/postchk.f
C&&*&& include  ../inc/praccum.f
C
C $Id: praccum.f,v 1.1 2002/05/02 10:47:08 harry Exp $
C
C--- awk generated include file  praccum.h
C---- START of include file praccum.h
C
C
C     ..
C     .. Arrays in common block /PRACCUM/ ..
      REAL PRDATA
C
C     .. Scalars in common block /PRACCUM/ ..
      LOGICAL ACCUMULATE,FIRSTPASS,SECONDPASS,THIRDPASS,FIRSTFILM,
     +        NOTREAD
C     ..
C     .. Common Block /PRACCUM/ ..
      COMMON /PRACCUM/PRDATA(4,50),ACCUMULATE,FIRSTPASS,SECONDPASS,
     +       THIRDPASS,FIRSTFILM,NOTREAD
C     ..
C
C
C&&*&& end_include  ../inc/praccum.f
C&&*&& include  ../inc/precession.f
C
C $Id: precession.f,v 1.1 2002/05/02 10:47:08 harry Exp $
C
C--- awk generated include file  precession.h
C---- START of include file precession.h
C
C
C     .. Scalars in common block /PRECESSION/ ..
      REAL D1,D2,PHIPREC,PSIPREC,PCTOFD,XLAMBDA
      LOGICAL PRECESS
C     ..
C     .. Common Block /PRECESSION/ ..
      COMMON /PRECESSION/D1,D2,PHIPREC,PSIPREC,PCTOFD,XLAMBDA,PRECESS
C     ..
C
C
C&&*&& end_include  ../inc/precession.f
C&&*&& include  ../inc/pro.f
C
C $Id: pro.f,v 1.1 2002/05/02 10:47:09 harry Exp $
C
C--- awk generated include file  pro.h
C---- START of include file pro.h
C
C
C     .. Arrays in common block /PRO/ ..
      INTEGER*2 IDUM
C     ..
C     .. Common Block /PRO/ ..
      COMMON /PRO/IDUM(MAXBUFF)
C     ..
C
C
C&&*&& end_include  ../inc/pro.f
C&&*&& include  ../inc/ras.f
C
C $Id: ras.f,v 1.1 2002/05/02 10:47:10 harry Exp $
C
C--- awk generated include file  ras.h
C---- START of include file ras.h
C
C
C     .. Scalars in common block /RAS/ ..
      INTEGER NEWRAS,MINT
C     ..
C     .. Arrays in common block /RAS/ ..
      INTEGER IRAS
      REAL VARAS
C     ..
C     .. Common Block /RAS/ ..
      COMMON /RAS/VARAS(5),IRAS(5),NEWRAS,MINT
C     ..
C
C
C&&*&& end_include  ../inc/ras.f
C&&*&& include  ../inc/reeke.f
C
C $Id: reeke.f,v 1.15 2008/10/22 08:50:48 andrew Exp $
C
C--- awk generated include file  reeke.h
C---- START of include file reeke.h
C
C     TOR     For synchrotron sources, degree of polarisation of the beam
C     IMONO   Collimation flag for polarisation.
C             = 0   Pinhole or mirrors
C             = 1   Graphite Monochromator
C             = 2   Synchrotron, use TOR
C     NWMAX   Maximum reflection width in images
C     DSTMAX  dimensionless rlu, = WAVE/RES where RES is the maximum
C             resolution in Angstrom.
C     DSTMIN  dimensionless rlu, = WAVE/DMAX where DMAX is the maximum
C              Bragg spacing
C     S0      radiation source vector (-1,0,0), may be modified by MU values
C     SOURCE  radiation source vector - basis for s0
C     GONIO_angle:  machine angles for generalized goniostats
C     GONIO_angle_SET: fixed offset angles for 3- and 4-circle goniostats
C                      i.e. currently 54.74 deg for Bruker CHI, 50.0deg for
C                      Nonius and Oxford KAPPA 
C     ..
C     .. Arrays in common block /REEKE/ ..
      REAL RMC,AMAT,SCAXIS,S0,s0unit,CAMCON,BEAMMU
C     ..
C     .. Scalars in common block /REEKE/ ..
      REAL X1,X2,Y1,Y2,Z1,Z2,XYS,DSTAR2,DSTMAX,DSTPL,DSTPL2,
     +     DIVH,DIVV,DELAMB,ETA,DELCOR,DSTMAXS,TOR,DSTMIN,WMAX,
     +     ETAFRAC,ETASM,
     $     GON_CHI,GON_PHIS,GON_KAPPA,GON_OMEGAS,GON_2THETA,
     $     GON_PHIE,GON_OMEGAE,
     +     GON_CHI_SET,GON_KAPPA_SET,
     +     BLKSIZE
      INTEGER ISYN,IMONO,NWMAX,IPAD,NSMOOTH,IGON_CHI,IGON_PHI,
     $     IGON_KAPPA,IGON_OMEGA,IGON_2THETA,
     +     IGON_CHI_SET,IGON_KAPPA_SET,IHOSCAXIS
C     ..
C     .. logicals in common block /REEKE/ ..
      LOGICAL LOGETA,NUREEK,LCAMCON,GENGON,FOURCIRCLE,THREECIRCLE
C     ..
C     .. Common Block /REEKE/ ..
      COMMON /REEKE/RMC(3,3),AMAT(3,3),SCAXIS(3),S0(3),s0unit(3),
     $     CAMCON(8),BEAMMU(2),X1,X2,Y1,Y2,
     +     Z1,Z2,XYS,DSTAR2,DSTMAX,DSTPL,DSTPL2,DIVH,DIVV,DELAMB,
     +     ETA,DELCOR,DSTMAXS,TOR,DSTMIN,WMAX,ETAFRAC,ETASM,
     $     GON_CHI,GON_PHIS,GON_KAPPA,GON_OMEGAS,GON_2THETA,
     $     GON_PHIE,GON_OMEGAE,
     +     GON_CHI_SET,GON_KAPPA_SET,ISYN,IMONO,
     $     NWMAX,IPAD,
     $     NSMOOTH,IGON_CHI,IGON_PHI,
     $     IGON_KAPPA,IGON_OMEGA,IGON_2THETA,
     +     IGON_CHI_SET,IGON_KAPPA_SET,IHOSCAXIS,LOGETA,NUREEK,LCAMCON,
     $     GENGON,FOURCIRCLE,THREECIRCLE,
     +     BLKSIZE
C     ..
C
C
C&&*&& end_include  ../inc/reeke.f
C&&*&& include  ../inc/reprt.f
C--- awk generated include file  reprt.h
C---- START of include file reprt.h
C
C
C
C     .. Scalars in common block /REPRT/ ..
      REAL AVBGRATIO,AVSIG,RFULL,RPART,AVPKRATIO,PKRMAXI,BGRMAXI,
     +     RFACOV,SDRATOV,SDMON,RESCUT,STHCUT
      INTEGER NREF,NOFR,NOLO,MAXBSI,MINBSI,NEDGE,NBOX,NBZERO,NNEG,
     +        NBAD,NBGRJ,NEDGE1,NPARTEND,NSPOVL,NRSYM,NHALF,NSUMPART
      LOGICAL PKACCEPT
C     ..
C     .. Arrays in common block /REPRT/ ..
      REAL RATIO,AVSD,AVSDP,AVSIG1,AVSIG2,AVINTI1,AVINTI2,AVPRI1,
     +     AVPRI2,RMSDELI1,RMSDELI2,ABSDELI1,ABSDELI2,AVPRSIG1,
     +     AVPRSIG2,AVDELSIG1,AVDELSIG2,PKRATIO,RSIGVSM,
     +     FIOVSDP,FIOVSDS,PIOVSDP,PIOVSDS,DBIN
      INTEGER IRANGE,IANAL,IANALF,NRFLS1,NRFLS2,MEANDELI1,MEANDELI2,
     +        NBGRHIST,IVSM,NIVSM,NRESPF,NRESPP,NRESSF,NRESSP,
     +        IRESPF,IRESPP,IRESSF,IRESSP,ISDRESPF,ISDRESPP,
     +        ISDRESSF,ISDRESSP
C     ..
C     .. Common Block /REPRT/ ..
      COMMON /REPRT/RATIO(10),AVSD(10),AVSDP(10),AVSIG1(10,2),
     $       AVSIG2(NMASKS,2),AVINTI1(10,2),AVINTI2(NMASKS,2),
     $       AVPRI1(10,2),AVPRI2(NMASKS,2),RMSDELI1(10,2),
     +       RMSDELI2(NMASKS,2),ABSDELI1(10,2),ABSDELI2(NMASKS,2),
     +       AVPRSIG1(10,2),AVPRSIG2(NMASKS,2),AVDELSIG1(10,2),
     +       AVDELSIG2(NMASKS,2),PKRATIO(10),RSIGVSM(13),FIOVSDP(9),
     $       FIOVSDS(9),PIOVSDP(9),PIOVSDS(9),DBIN(9),
     $       AVBGRATIO,AVSIG,RFULL,RPART,AVPKRATIO,PKRMAXI,BGRMAXI,
     $       RFACOV,SDRATOV,SDMON,RESCUT,STHCUT,
     $       IRANGE(9),IANAL(10),IANALF(10),NRFLS1(10,2),
     +       NRFLS2(NMASKS,2),MEANDELI1(10,2),MEANDELI2(NMASKS,2),
     +       NBGRHIST(32),IVSM(13),NIVSM(13),
     +       NRESPF(9),NRESPP(9),NRESSF(9),NRESSP(9),
     +       IRESPF(9),IRESPP(9),IRESSF(9),IRESSP(9),ISDRESPF(9),
     +       ISDRESPP(9),ISDRESSF(9),ISDRESSP(9),NREF,NOFR,NOLO,
     $       MAXBSI,MINBSI,NEDGE,NBOX,NBZERO,NNEG,NBAD,
     +       NBGRJ,NEDGE1,NPARTEND,NSPOVL,
     +       NRSYM,NHALF,NSUMPART,PKACCEPT
C     ..
C
C
C&&*&& end_include  ../inc/reprt.f
C&&*&& include  ../inc/restart.f
C
C $Id: restart.f,v 1.2 2005/09/20 16:41:57 andrew Exp $
C
C---- START of include file restart.h
C
C---- Saves image ID, IDENT and phi values in case of an abort or 
C     when current run has finished, determines which image will be
C     displayed with GUI at this point.
C
C     .. Scalars in common block /RESTART/ ..
      REAL RESTPHIB, RESTPHIE
      INTEGER RESTID,RNTDIG
      CHARACTER RESTIDENT*40,RTEMPLSTART*100,RTEMPLEND*100
C     ..
C     .. Arrays in common block /RESTART/ ..
C
C     .. Common Block /RESTART/ ..
      COMMON /RESTART/ RESTPHIB,RESTPHIE,RESTID,RNTDIG
C
C
      COMMON /RESTARTC/ RESTIDENT,RTEMPLSTART,RTEMPLEND
C     ..
C     ..
C
C
C&&*&& end_include  ../inc/restart.f
C&&*&& include  ../inc/rfs.f
C
C $Id: rfs.f,v 1.2 2007/07/12 13:25:57 andrew Exp $
C
C--- awk generated include file  rfs.h
C---- START of include file rfs.h
C
C
C
C     .. Scalars in common block /RFS/ ..
      REAL FDIST,ESTART,RMSRES,WRMSRES,WESTART
      INTEGER MAXREF,MAXX,MAXY,NRS,MAXR,NREJS,NCENTREF
C     ..
C     .. Arrays in common block /RFS/ ..
      REAL XRS,YRS,WXRS,WYRS
      INTEGER RRS,IHKLR
C     ..
C     .. Common Block /RFS/ ..
      COMMON /RFS/ XRS(NDETREF),YRS(NDETREF),WXRS(NDETREF),
     +       WYRS(NDETREF),FDIST,ESTART,RMSRES,WRMSRES,
     $       WESTART,RRS(NDETREF),IHKLR(3,NDETREF),MAXREF,MAXX,
     +       MAXY,NRS,MAXR,NREJS,NCENTREF
C     ..
C
C
C&&*&& end_include  ../inc/rfs.f
C&&*&& include  ../inc/savall.f
C
C $Id: savall.f,v 1.1 2002/05/02 10:47:15 harry Exp $
C
C---- START of include file savall.h
C
C      NSAVIMG      Number of images used in autoindexing
C      ISAVIMG      Array storing image numbers used in last autoindexing
C      NSAVSEG      Number of segments used in last postref run
C      ISFIRST      Array storing image number of the first image
C                   in all segments of last postref run.
C      SAVMATSR     Indicates whether last matrix was determined by
C                   autoindexing (Autoindexing) or by postref (Post refinement)
C      SAVMATNAM    Name of the matrix file
C      SAVENAM      Name of savefile
C      SVSCN        SCANNER keyword
C      SVSITE       SITE keyword
C      RES          High resolution limit given on RESOL keyword
C      RESLOW       Low resolution limit given on RESOL keyword
C
C     .. Scalars in common block /SAVALL/ ..
      REAL RES,RESLOW
      INTEGER NSAVIMG,NDIR,NSAVSEG
      CHARACTER SAVMATSTR*80,SAVMATNAM*80,SAVENAM*80,SVSCN*80,
     +          SVSITE*80
      LOGICAL IISCN,IISITE,IIWAVE,IIDIV,IIDISP,IINULL,IIRAST,IISEP,
     +        IIOVER,IIPIX,IIBACK,IIRES
C     ..
C     .. Arrays in common block /SAVALL/ ..
C
      INTEGER ISAVIMG(MAXIMG),ISFIRST(100)
C     .. Common Block /SAVALL/ ..
      COMMON /SAVALL/ RES,RESLOW,ISAVIMG,ISFIRST,NSAVIMG,NDIR,NSAVSEG,
     +       IISCN,IISITE,IIWAVE,IIDIV,IIDISP,IINULL,IIRAST,IISEP,
     +        IIOVER,IIPIX,IIBACK,IIRES
C
C
      COMMON /SAVALLC/ SAVMATSTR,SAVMATNAM,SAVENAM,SVSCN,SVSITE
C     ..
C
C
C&&*&& end_include  ../inc/savall.f
C&&*&& include  ../inc/scn.f
C
C $Id: scn.f,v 1.3 2004/08/16 13:26:48 harry Exp $
C
C--- awk generated include file  scn.h
C---- START of include file scn.h
C
C     SCNSZ   is pixel size (in microns) divided by 25
C     RAST    pixel size in slow direction in mm
C     FACT    multiplying by FACT converts from 10 micron units 
C             (the standard unit internal to the program) into pixels
C     IYLEN   The number of pixels in the Y (fastest changing) direction
C             in the digitised image.
C     NREC    The number of pixels in the X (slow) direction in the 
C             digitised image.
C     NWORD   The number of I*2 words in the Y direction.
C     NBYTE   The number of bytes in Y direction = NWORD/2
C     NHBYTE  Number of bytes in header
C
C     ICURR   When several images are stored in a single file, ICURR is the
C             pointer to the first record of the current image in the direct
C             access file (only implemented for film data)
C     NEXTRA  The number of additional (unused) bytes padding the end of
C             each record in image file
C     BYTSWAP True if the "endedness" (Big-endian/Little-endian) of the 
C             machine that MOSFLM is running on is different to that of the
C             machine on which the image was written. This is determined by
C             looking at the value of NXPIX in the header record of the
C             image file (subroutine GETHDR)
C
C     LACTIVE True if using Rigaku active mask, False if ignoring it
C
C     .. Scalars in common block /SCN/ ..
      REAL FACT,SCNSZ,RAST,RASTY
      INTEGER NBYTE,NREC,NWORD,IYLEN,ICURR,NEXTRA,NHBYTE
      LOGICAL BYTSWAP,LACTIVE
C     ..
C     .. Common Block /SCN/ ..
      COMMON /SCN/ FACT,SCNSZ,RAST,RASTY,NBYTE,NREC,NWORD,IYLEN,
     +     ICURR,NEXTRA,NHBYTE,BYTSWAP,LACTIVE
C&&*&& end_include  ../inc/scn.f
C&&*&& include  ../inc/spots2.f
C
C $Id: spots2.f,v 1.14 2009/02/09 22:47:02 harry Exp $
C
C--- awk generated include file  spots.h
C---- START of include file spots.h
C
C---- These stores variables associated with spot-finding routines.
C     Note that the final coordinates are kept in XSPT,YSPT in /SPOTS/
C
C     XSPOT...  X coordinates (in mm) of all spots found on current
C               image, before rejections based on spot size
C     YSPOT...  Y coordinates (in mm) of all spots found on current
C               image, before rejections based on spot size
C     INSPOT... Intensities of all spots found on current
C               image, before rejections based on spot size
C     ISIGSP... Standard deviations of intensities
C     NOIMG     The pack or image number.
C     PHI..     Phi value of the mid-point of the image
C     NIMAG     Total number of images read in (for autoindexing)
C     NEWSPT    If TRUE, new format spot coordinate file, otherwise old
C               format.
C     MEDWXSPOT Median spot size in pixels in X determined in PICKSPOTS
C     MEDWYSPOT Median spot size in pixels in Y determined in PICKSPOTS
C     IRSTRT    Number of the image on which to restart after an abort
C
C     SPXMIN    Minimum X coord (relative to direct beam position) for
C               spots
C     SPYMIN    Minimum Y coord (relative to direct beam position) for
C               spots
C     NSPTD     Number of displayed spots
C     THRESH    Threshold for pixel to be considered part of a spot,
C               is (background + THRESH*sigma)
C     NSPK      Number of maxima in a spot
C     MAXPKS    Maximum number of local maxima in a spot
C     RMSFAC    For multiple peaks treated as a single spot, the rms
C               variation over the pixels in the spot must be more than
C               RMSFAC times the variation expected from counting statistics
C               if all pixels had the background value.
C     MAXYEXT   Maximum extent of a "spot" in Y direction.
C     ANISOMAX  Maximum allowed ratio of spot size in X and Y
C
C     The following are for local background determination
C
C     LOCBG     Logical, TRUE if using local background (default)
C     NXBOX     Size of box for local background determination in X
C     NYBOX     Size of box for local background determination in Y
C     BGLOCAL   Array dimension (MAXBGBOX,MAXBGBOX,4) square holding 
C               local background values.
C---- BGLOCAL(I,J,1) ...   Mean background for box I,J
C---- BGLOCAL(I,J,2) ...   Poissonian sigma (uses GAIN) for box I,J
C---- BGLOCAL(I,J,3) ...   Rms variation in counts for box I,J
C---- BGLOCAL(I,J,4) ...   Average +ve difference between mean background
C                          of box I,J and its neighbours, expressed as
C                          a multiple of the rms variation of box I,J
C                          Used to identify boxes in shadow.
C     IWTBG     Array dimension (MAXBGBOX,MAXBGBOX) holding weight for
C               each local background area.
C     EXCLDICE  True if spots in resolution shells of ice rings are to be 
C               excluded
C     AUTORESLN Set resolution limit to 4A if spots between 4-6 are much
C               weaker than those between 6A and infinity.
C     AUTORES1  The lower resolution bin boundary (default 6A) for AUTORESLN
C     AUTORES2  The higher resolution bin boundary (default 4A) for AUTORESLN
C     AUTOFAC1  The intensity factor (default 0.2) for AUTORESLN
C     AUTOFAC2  The reflection number factor (default 0.25) for AUTORESLN
C     AUTORING  Automatically exclude radial bins that have too many spots
C               eg due to ice rings.
C     RINGFACT  Rings with more than RINGFACT*(average number of spots) are
C               rejected as potential ice/powder rings. Default 4.0.
C
C
C     .. Scalars in Common Block /SPOTS2/ and /SPOTS2C/ ..
      REAL CUTPIXMAX,CUTPIXMIN,CUTWXMAX,CUTWXMIN,CUTWYMAX,CUTWYMIN,
     +     XSPLIT,YSPLIT,YOFFSET,XOFFSET,THRESH,RMINSP,RMAXSP,
     +     RMINSRCH,RMAXSRCH,SCALSRCH,SPXMIN,SPYMIN,THRESHMIN,
     +     THRESHMAX,RMSFAC,ANISOMAX,AUTORES1,AUTORES2,AUTOFAC1,
     +     AUTOFAC2,RINGFACT
      INTEGER NBINR,NBINT,IBINLIM,NPIXMIN,NPIXMAX,IIMAG,NIMAG,
     +     MEDWXSPOT,MEDWYSPOT,NSEARCH,ITHSET,ISAFE,IRSTRT,
     +     NSPTD,MAXPKS,MAXYEXT,NXBOX,NYBOX
      LOGICAL RADX,RADY,NEWSPT,DOFIND,FOUND(20),LOCBG,EXCLDICE,
     +     AUTORESLN,AUTORING
      CHARACTER IMGTEMPL*100,IMGFN*100,IMGNUM*9
C     ..
C     .. Arrays in common /SPOTS2/  and /SPOTS2C/ ....
      INTEGER NPIX,IWXSPOT,IWYSPOT,IORDER,INSPOT,NOIMG,ISDSPOT,NSPK,
     +        IWTBG,AVBG
      REAL BGOD,PHI,XSPOT,YSPOT,RESOLU,RSPOT,PHISTIM,PHIRNGA,
     $     BGODA2,BGLOCAL
C     ..
C     .. Common Block /SPOTS2/  and /SPOTS2C/ ....
c      COMMON /SPOTS2/XSPLIT,YSPLIT,NBINR,NBINT,
c     +       IBINLIM,PHI(MAXIMG),NPIXMIN,NPIXMAX,CUTPIXMIN,CUTPIXMAX,
c     +       CUTWXMIN,CUTWXMAX,CUTWYMIN,CUTWYMAX,
c     +       BGOD(IXWDTH),YOFFSET,XOFFSET,RADX,RADY,THRESH,IIMAG,NIMAG,
c     +       NPIX(MXSPOT),IWXSPOT(MXSPOT),IWYSPOT(MXSPOT),
c     +       IORDER(MXSPOT),INSPOT(MXSPOT),XSPOT(MXSPOT),
c     +       YSPOT(MXSPOT),RSPOT(MXSPOT),RMINSP,RMAXSP,NOIMG(MAXIMG),
c     +       NEWSPT,DOFIND,ISDSPOT(MXSPOT),MEDWXSPOT,MEDWYSPOT,
c     +       PHISTIM(MAXIMG),RMINSRCH,RMAXSRCH,NSEARCH,SCALSRCH,
c     +       ITHSET,ISAFE,IRSTRT,SPXMIN,SPYMIN,THRESHMIN,THRESHMAX,
c     +       NSPTD
       common /spots2/CUTPIXMAX,CUTPIXMIN,CUTWXMAX,CUTWXMIN,CUTWYMAX,
     +     CUTWYMIN,XSPLIT,YSPLIT,YOFFSET,XOFFSET,THRESH,RMINSP,RMAXSP,
     +     RMINSRCH,RMAXSRCH,SCALSRCH,SPXMIN,SPYMIN,THRESHMIN,
     +     THRESHMAX,NBINR,NBINT,IBINLIM,NPIXMIN,NPIXMAX,IIMAG,NIMAG,
     +     MEDWXSPOT,MEDWYSPOT,NSEARCH,ITHSET,ISAFE,IRSTRT,
     +     NSPTD,RADX,RADY,NEWSPT,DOFIND,FOUND,
     $  NPIX(MXSPOT),IWXSPOT(MXSPOT),IWYSPOT(MXSPOT),
     $  IORDER(MXSPOT),INSPOT(MXSPOT),NOIMG(MAXIMG),ISDSPOT(MXSPOT),
     $  BGOD(IXWDTH),AVBG(IXWDTH),
     $  PHI(MAXIMG),XSPOT(MXSPOT),YSPOT(MXSPOT),RESOLU(MXSPOT),
     $  RSPOT(MXSPOT),PHISTIM(MAXIMG),PHIRNGA(MAXIMG),BGODA2(21,21,3),
     +  NSPK(MXSPOT),MAXPKS,RMSFAC,MAXYEXT,LOCBG,
     +  NXBOX,NYBOX,EXCLDICE,ANISOMAX,AUTORESLN,AUTORING,
     +  AUTORES1,AUTORES2,AUTOFAC1,AUTOFAC2,RINGFACT
       
       COMMON /SPOTS3/BGLOCAL(MAXBGBOX,MAXBGBOX,4),
     +  IWTBG(MAXBGBOX,MAXBGBOX)
      COMMON /SPOTS2C/ IMGTEMPL,IMGFN,IMGNUM
C&&*&& end_include  ../inc/spots2.f
C&&*&& include  ../inc/strat.f
C--- awk generated include file  strat.h
C---- START of include file strat.h
C
C---- Stores variables for use in STRATEGY option
C     IROTAX is the axis closest to the rotation axis
C     PHIROTAX is the angle this axis makes with the rotation axis
C
C     PHIZONE is the phi value at which axis "IZONEAX" is along the
C     X-ray beam. (IZONEAX = 1 is a, =2 is b, =3 is c)
C     PHIPAD  is the rotation to be added to PHILAUE to ensure generation
C             of all unique data, and will depend on angle between the
C             unique axis and the rotation axis.
C     AUTANOM if true tries to maximise number of anomalous pairs
C     CELLSCAL is the scale factor applied to the cell edges to
C              speed up the calculation.
C     SHRUNK   is TRUE if the cell has been scaled by CELLSCAL
C     ISTRUN   is used to increment input phi angles by multiples of
C              360 degrees, so that phi values in different parts can
C              be recognised. It starts at zero.
C     FIRSTRAT Starts as TRUE (set in MOSDATA) and is set to FALSE once
C              the MTZ file has been opened for a STRATEGY run.
C              Reset TRUE after EXITing from STRATGEY prompt.
C
C     .. Scalars in common /STRAT/ ..
      INTEGER NSEGM,IPCKCUR,NSTRAT,NUNIQ,NSTRUN,ISTRUN,NSEGAUTO,
     +        IZONEAX,IROTAX,NLAST,NNPACKS,NLASTPACK
      LOGICAL STRATEGY,AUTO,SIZESET,AUTANOM,SHRUNK,FIRSTRAT,
     +         NEWSTRAT,WAITINP,OFFPHI
      REAL ROTAUTO,PHILAUE,PHIPAD,PHIZONE,PHIROTAX,CELLSCAL
C     ..
C     .. Arrays in common /STRAT/ ..
      REAL PHIST,PHIFIN,PHIINC,PHIADD,PHISEGA
      INTEGER IFIRSTONE
C     ..
C     .. Common Block /STRAT/ ..
      COMMON /STRAT/ PHIST(NSEGMAX),PHIFIN(NSEGMAX),PHIINC(NSEGMAX),
     +       PHIADD(NSEGMAX),PHISEGA(NSEGMAX),ROTAUTO,PHILAUE,PHIPAD,
     $       PHIZONE,PHIROTAX,CELLSCAL,IFIRSTONE(NSEGMAX),
     $       NSEGM,IPCKCUR,NSTRAT,NUNIQ,
     +       NSTRUN,ISTRUN,NSEGAUTO,
     +       IZONEAX,IROTAX,NLAST,NNPACKS,NLASTPACK,
     +       STRATEGY,AUTO,SIZESET,AUTANOM,SHRUNK,
     +       FIRSTRAT,NEWSTRAT,WAITINP,
     +       OFFPHI
C     ..
C
C


      
C&&*&& end_include  ../inc/strat.f
C&&*&& include  ../inc/tgen.f
C
C $Id: tgen.f,v 1.1 2002/05/02 10:47:23 harry Exp $
C
C--- awk generated include file  tgen.h
C---- START of include file tgen.h
C
C---- Stores variables for use in TESTGEN option
C
C     .. Arrays in common /TGEN/ ..
c      REAL XOVER
c      INTEGER ISTATS
C
C     .. Scalars in common /TGEN/ ..
      REAL XOVER,PHSTART,PHEND,PHSTEP,OSCMIN,OSCMAX,SDIVH,SDIVV,
     +     SDELCOR,SDELAMB,SETA,OSCANG,PCMAX
      INTEGER ISTATS
      LOGICAL TESTGEN,TESTRAT
C     ..
C     ..
C     .. Common Block /TGEN/ ..
      COMMON /TGEN/XOVER(2),PHSTART,PHEND,PHSTEP,OSCMIN,OSCMAX,
     +     SDIVH,SDIVV,SDELCOR,SDELAMB,SETA,OSCANG,PCMAX,
     $     ISTATS(MAXPAX,3),TESTGEN,TESTRAT

C&&*&& end_include  ../inc/tgen.f
C&&*&& include  ../inc/tiltlog.f
C
C $Id: tiltlog.f,v 1.1 2002/05/02 10:47:23 harry Exp $
C
C---- awk generated include file tiltlog.h
C---- START of include file tiltlog.h
C
C    for things connected with the new definitions of TILT and TWIST 
C
C     .. Scalars in common block /TILTLOG/ ..
      LOGICAL NUTWIST
      COMMON /TILTLOG/NUTWIST
C&&*&& end_include  ../inc/tiltlog.f
C&&*&& include  ../inc/trigparam.f
C 
C $Id: trigparam.f,v 1.3 2008/07/31 11:46:02 harry Exp $
C
C
C     Trigonometric parameters - set here to highly precise values, don't 
C     calculate in code; values from Clemens Vonrhein
C
C     DTOR.. convert degrees to radians
C     RTOD.. convert radians to degrees
C     PI..   value of PI
      REAL PI
      PARAMETER   ( PI = 3.1415926536 )
      REAL          TWOPI
      PARAMETER   ( TWOPI = 6.2831853072 )
      REAL RTOD
      PARAMETER   ( RTOD = 57.2957795131 )
      REAL          DTOR
      PARAMETER   ( DTOR = 0.0174532925 )
C DOUBLE PRECISION...
      DOUBLE PRECISION PI_DOUBLE
      PARAMETER ( PI_DOUBLE = 3.1415926535897932384626433832795029D0 )
      DOUBLE PRECISION TWOPI_DOUBLE
      PARAMETER ( TWOPI_DOUBLE = 
     $     6.2831853071795864769252867665590058D0 )
      DOUBLE PRECISION RTOD_DOUBLE
      PARAMETER ( RTOD_DOUBLE = 57.2957795130823208768D0 )
      DOUBLE PRECISION DTOR_DOUBLE
      PARAMETER ( DTOR_DOUBLE = 0.01745329251994329576D0 )
c

c
C&&*&& end_include  ../inc/trigparam.f
C&&*&& include  ../inc/virbat.f
C
C $Id: virbat.f,v 1.2 2003/11/28 12:34:49 harry Exp $
C
C
C----  include file header  for virtual batches in post-refinement
C
       INTEGER NIVB,NVIRBAT,NADDMISSET,IVIRBAT
       LOGICAL NUPR_INT
       COMMON /VIRBAT/ NIVB,NVIRBAT,NADDMISSET,
     +                 IVIRBAT,NUPR_INT
C&&*&& end_include  ../inc/virbat.f
C&&*&& include  ../inc/xy.f
C
C $Id: xy.f,v 1.1 2002/05/02 10:47:25 harry Exp $
C
C--- awk generated include file  xy.h
C---- START of include file xy.h
C
C     .. Scalars in common block /XY/ ..
      REAL XTOFD,SINV,COSV,TANV,TWOTHETA
      INTEGER ICASS
C     ..
C     .. Common Block /XY/ ..
      COMMON /XY/XTOFD,SINV,COSV,TANV,TWOTHETA,ICASS
C     ..
C
C     XTOFD....  Crystal to detector distance in 10 micron units. Read from
C                keyworded input and never changed.
C
C                Spot positions are calculated in S/R XYSPOT (Called from
C                REEK) and are for an "ideal" detector at a distance of XTOFD.
C                These are converted into pixel positions in S/R MMTOPX
C                which applies the multiplicative factor XTOFRA to allow
C                for refinement of the distance. XTOFRA is the parameter
C                that is actually refined (in RDIST), rather than XTOFD.
C                The refined distance that is printed in the logfile is
C                actually XTOFRA*XTOFD
C
C     ICASS....  Indicates detector type:
C                0     Flat film
C                1     Vee shaped cassettes
C                2     FAST detector (only used in TESTGEN mode of OSCGEN)
C                3     Swung out FAST (ditto)
C                4     IP detector
C     TWOTHETA   Detector swing angle (degrees)
C&&*&& end_include  ../inc/xy.f
c       -harvest
C&&*&& include  ../inc/mharvest.f
c      INTEGER MCOLS
c      PARAMETER (MCOLS = 18)
C     .. Scalars in common block /CHARVEST/ ..
      CHARACTER HVERSION*100,ProjectName*64,Crystalname*64,
     +          DataSetName*64,HBEAMLINE*10,Precipitant*80,
     +          XNAME_COLS(MCOLS)*64,
     +          DNAME_COLS(MCOLS)*64
C     .. Scalars in common block /IHARVEST/ ..
      LOGICAL USECWD,PNAMEgiven,XNAMEgiven,DNAMEgiven,DOHARVEST
      REAL    PHhar,Hartemp,
     +     HARETA(MAXPAX),HARDIV(MAXPAX),HARDIH(MAXPAX)
      CHARACTER*3 MKDIRMODE,CHMODMODE
      INTEGER KHFLMS
C     ..
C     .. Common block /CHARVEST/ ..
      COMMON /CHARVEST/HVERSION,ProjectName,Crystalname,
     +                 DataSetName,HBEAMLINE,Precipitant,
     +                 XNAME_COLS,DNAME_COLS
C     .. Common block /IHARVEST/ ..
      COMMON /IHARVEST/USECWD,PHhar,Hartemp,KHFLMS,
     +                 PNAMEgiven,XNAMEgiven,DNAMEgiven,DOHARVEST,
     +                 HARETA,HARDIV,HARDIH,MKDIRMODE,CHMODMODE
C     ..
C&&*&& end_include  ../inc/mharvest.f
c       -harvest
C       
C       ..
C       .. Equivalences ..

        character*80 dnafile

        EQUIVALENCE (IRAS(1),NXS), (IRAS(2),NYS), (IRAS(3),NCC)
        EQUIVALENCE (IRAS(4),NRX), (IRAS(5),NRY)
C       ..
        SAVE
C       .. Data statements ..
C       
C----   CENTRS refinement is repeated (once) if initial residual ESTART is
C       greater than ELIMIT (set to 8 below). Outer refinement is repeated
C       (once only) if initial residual is greater than ELIMIT2 or if final
C       residual is greater then ELIMIT3
C       For weighted refinement, the limit is WELIMIT for all 3 cases
C       
        DATA ELIMIT/8.0/,ELIMIT2/3.0/,ELIMIT3/1.5/,WELIMIT/2/
        DATA YSCALERR/0.0/,RPTIMG/.FALSE./,BIGSHIFT/.FALSE./
        DATA FIRSTWARN/.TRUE./, reta/0.0/
        DATA PORTNO /0/
        DATA PRFINISH /.FALSE./
        DATA CALLEDFROM / 'MOSFLM' /
        DATA NFOUND /0/
C        CALLEDFROM = 'MOSFLM'
        MODECTRL = 0
        CENTRE = .FALSE.
C       
C----   First check to see if the version of CCP4 supports harvesting
C       
        CALL CCP4_VERSION(CCP4VERSION)
        HARVESTREADY = .TRUE.
C        IF(CCP4VERSION.LT.'4.0')HARVESTREADY = .FALSE.
C       
C----   
C       
        CALL CCPFYP
C
        XMLOPEN = .FALSE.
        CALL UGTENV('XMLFILE',XMLFILE)
        IF(XMLFILE .NE. ' ')THEN
          WRITE(ITOUT,fmt=6450)XMLFILE(1:LENSTR(XMLFILE))
 6450     format('The output XML will be stored in a file called ',A)
          PORTNO = -1
          CALL OPEN_FILE(PORTNO,SERVERFD,XMLFILE,LENSTR(XMLFILE))
          SOCKLO = .TRUE.
          XMLOPEN = .TRUE.
          IISCN = .FALSE.
          CALL VERSION(IMGP)
        ELSE
          PORTNO = CCPE2I('MOSFLMSOCKET',PORTNO)
          IF(PORTNO.NE.0)THEN
C     ..
C     .. i.e. we have a socket open
            CALL UGTENV('REMMOSHOST',REMOTEMOSFLMHOST)
            CALL OPEN_SOCKET(REMOTEMOSFLMHOST,portno,SERVERFD)
            SOCKLO = .TRUE.
            IISCN = .FALSE.
            CALL VERSION(IMGP)
c     WRITE(LONGLINE,FMT=7200)
c     7200     FORMAT('<Mosflm version 7.0.4 3rd March 2008>')
c     CALL WRITE_SOCKET_LENGTH(SERVERFD,LENSTR(LONGLINE),LONGLINE)
          ELSE
            SOCKLO = .FALSE.
          ENDIF
        ENDIF
C
C---- new call to initialize everything
C
        INIT_MODE = 0
        CALL INITIALIZE(INIT_MODE,GENOPEN,NEWGENF)
        CALL MHARVEST(0)
c     DNA
        call ugtenv('DNA', dnafile)
C     .. some compilers don't like zero length strings indicated by ''
        if(LENSTR(dnafile) .GT. 0) then
           open(file = dnafile, unit = dnafd, status = 'unknown')
           dnaout = .true.
           call dna_start_output('mosflm')
        else
           dnaout = .false.
        end if
C
C----   items which are declared locally in mosflm.f
C
        FIXPARTLS = .FALSE.
        PROCESSA = .FALSE.
        LAST = .FALSE.
        FORCEREAD = .FALSE.
        COORDOPN = .FALSE.
C
C---- g77 compiler wants these initialized - anything _not_ zero 
C     here has already been tried and it seems to make no difference to
C     running the program.
C
        NSINGRPT = 0!1
        NIMAGSV = 0!1
        MINREFS =  0!1
        IROFF = 0
        ITOFF = 0
        NPACKSAVE =  0!1
        CCOMLAST = 0
        ROFFLAST = 0
        PHIXLAST = 0 
        PHIYLAST = 0 
        PHIZLAST = 0 
        CCOMSAVE = 0
        TOFFLAST = 0
        RFP = 0
        NRSOLD =  0!1
C
C---- end of g77 objections - some more initializations
C
        ierr = 0
        istat = 0
        resid = 0.0
C
C---- end of initializations
C
        LDUM = 80
c     initialise this to prevent mosflm from core dumping due to the 
c     fact that this is not initialised - this is most likely a fault 
c     in another variable, but let's do this anyway.
        nfilms = 0
C       
C----   NFLMO is number of films written to MOSFLM.OUT.
C       This is only greater than one when accumulating
C       profiles from A films.
C       
        NFLMO = 1
        ABC = 'ABC'
C
        DO 20 J = 1,3
          DO 10 I = 1,MAXPAX
            IF (J.EQ.1) THEN
              PRFRPT1(I) = .FALSE.
              PRFRPT2(I) = .FALSE.
              PRFHS(I) = .FALSE.
              PRF(I) = .FALSE.
              PRNEGM(I) = .FALSE.
            END IF
            BADPACK(I,J) = .FALSE.
 10       CONTINUE
 20     CONTINUE   
          FIRSTTIME = .TRUE.
          RPTFIRST = .FALSE.
C       
C----   ISEG keeps track of how many times CONTROL has been called, used
C       in multisegment postrefinement
C       
        ISEG = 0
        NREPEAT = 0
C       
C----   Read control information (keyworded) up to next "RUN" card
C       
C       ******************************************************
 30     CONTINUE
        CALL CONTROL(FIRSTTIME,IFIRSTPACK,NEWGENF,GENOPEN,RPTFIRST,
     +       CELLSTR,MODECTRL)
C       ******************************************************
C       
C----   If doing data collection strategy, do it now
C       
        FIRSTWARN = .TRUE.
C
Chrp 15022002
C----   If FIRSTTIME is .TRUE., then ISEG should = 0. This is necessary 
C       for automated jobs run through the Mosflm server, and should be 
C       true anyway.
C
        IF(FIRSTTIME)ISEG = 0
C
C----   If using the new GUI and this is an integration run (not cell 
C       refinement), we need ISEG =0 or else it will not set up
C       NVIRBAT (and NADDMISSET) correctly. At present, for example,
C       ISEG gets incremented every time a prediction is done from
C       the new gui.
        IF (SOCKLO.AND.(.NOT.MULTISEG).AND.(.NOT.STRATEGY)
     +            .AND.(.NOT.TESTGEN)) ISEG = 0
c
c---- Because new gui is invoked by an image keyword, it comes to this point
c     with ISEG=1 instead of zero.
c     (and this was breaking things)
        
chrp 16.04.2007        if(gui_switch) then

 3332      format('Warning - resetting the iseg value to zero',
     +          ' because gui_switch = .true.')

chrp 16.04.2007            if(online) then
chrp 16.04.2007               write(itout, 3332)
chrp 16.04.2007            end if
chrp 16.04.2007            write(iout, 3332)
chrp 16.04.2007            iseg = 0
chrp 16.04.2007         end if
 34     IF (STRATEGY) THEN
           XCEN = 100.0*XCENMM(1,1)
           YCEN = 100.0*YCENMM(1,1)
           SETA = ETA
           SDIVH = DIVH
           SDIVV = DIVV
          SDELCOR = DELCOR
          SDELAMB = DELAMB
          CALL ROTATE
C       
C----   If STRATEGY has more than one run, then ICELL is set to 1.
C       Reset it to zero now so cell is not fixed.
C       
          ICELL = 0
          ETA = SETA
          DIVH = SDIVH
          DIVV = SDIVV
          DELCOR = SDELCOR
          DELAMB = SDELAMB
          FIRSTTIME = .FALSE.
C       
C----   If window display active, return there providing all runs have been
C       generated
C       
          IF (ISTRUN+1.LT.NSTRUN) GOTO 30
          IF (DISPMENU .or. newgui) THEN
            ADDPART = .FALSE.
            SUMPART = .FALSE.
            POWDER = .TRUE.
            STRATEGY = .FALSE.
            FORCEREAD = .TRUE.
            NRUN = 1
C       
C----   Need to set ISEG to zero in case a multiseg refinement run is done
C       
            ISEG = 0
            NIMAG = NIMAGSV
C
C----  If using new gui, have finished strategy now so return to CONTROL.
C
            IF (SOCKLO) GOTO 30            
            GOTO 36
          END IF
          GOTO 30
        END IF
C       
C----   TESTGEN option
C       
        IF (TESTGEN) THEN
C       
          XCEN = 100.0*XCENMM(1,1)
          YCEN = 100.0*YCENMM(1,1)
C       ********
          CALL TESTOVER
C       ********
          FIRSTTIME = .FALSE.
C       
          TESTGEN = .FALSE.
          GOTO 30
        END IF
C       
C----   Open coordinate file if DENSE image
C       
C       *******************************************************
 36     IF (DENSE) THEN
          IF (COORDOPN) CLOSE(ICOORD)
          CALL CCPDPN(-ICOORD,'COORDS','UNKNOWN','U',0,IFAIL)
          COORDOPN = .TRUE.
        END IF
C       *******************************************************
C       
        ISEG = ISEG + 1
        RPTFIRST = .FALSE.
        DONEONCE = .FALSE.
        CENTRSRPT = .FALSE.
        IRPTPACK = -999
C       
C----   If doing multi-segment post-refinement, set NBLOCK to NADD, and
C       set SUMPART to TRUE as it will have been set FALSE for the last image
C       of the preceeding segment (for second etc segments) in code below.
C       However, if only one segment, set NBLOCK = NADD + 1
C       
 6232   CONTINUE
c       if(online)write(itout,6233)ifirstpack,npack,nblock,naddp
c       write(iout,6233)ifirstpack,npack,nblock,naddp
c       6233 format(/,'Ifirstpack = ',i4,', Npack = ',i4,' Nblock = ',
c       $     I4,' Naddp = ',I4/)
        IF (MULTISEG) THEN
          IF (NSEG.GT.1) THEN
            NBLOCK = NADD
          ELSE
            NBLOCK = NADD + 1
          END IF
          IF (.NOT.NEWPREF) SUMPART = .TRUE.
        END IF
C       
C----   Set up partial summation flag for all packs. Note that this
C       may be changed for an individual pack on calling OPENODS if
C       the required following image does not exit
C       
C       Note that IFIRSTPACK is a pack counter, NOT the serial number of the
C       pack. Thus it starts at 1 and runs to NPACK/NPACKSAVE
C       
        DO 32 IPACK = IFIRSTPACK,NPACK
          SUMP(IPACK) = SUMPART
          ADDP(IPACK) = ADDPART
 32     CONTINUE
C       
C----   Number of the current block of images
C       
        NUMBLOCK = 0
        IF (NBLOCK.EQ.0) NUMBLOCK = 1
        IF (NBLOCK.NE.0) FIRSTPASS = .FALSE.
        EXTRAIMG  = .FALSE.
C       
C----   IFIRSTP is used as a flag controlling initialisation done in call to
C       POSTREFL and IFIRSTPSEG is used in NEWPREF SINGLE mode to decide if we
C       need to do post-refinement on this image and also go back to the very
C       first image or not
C       
        IF (FIRSTTIME.OR.(.NOT.MULTISEG)) IFIRSTP = IFIRSTPACK
        IFIRSTPSEG = IFIRSTP
        IF (NEWPREF.AND.MULTISEG) IFIRSTPSEG = IFIRSTPACK
        NWRN = 0
        IF (.NOT.MULTISEG) NREPEAT = 0
        PRFIRST = .TRUE.
        ROFFMAX = 0.0
        TOFFMAX = 0.0
        CCOMAX = 0.0
        WRMAX = 0.0
        DELPHIMAX = 0.0
        NBADMAX = 0
        YSCALERR = 0.0
        IF (DEBUG(1)) THEN
          WRITE(IOUT,FMT=6001) FIRSTTIME,MULTISEG,IFIRSTPACK,NPACK,
     +         NBLOCK,SUMPART,ADDPART,ISEG,NADD,NREPEAT,
     +         NEWPREF,IFIRSTP,IFIRSTPSEG,POSTREF,NIMAG
          IF (ONLINE) WRITE(ITOUT,FMT=6001) FIRSTTIME,MULTISEG,
     +         IFIRSTPACK,NPACK,NBLOCK,SUMPART,ADDPART,ISEG,NADD,
     +         NREPEAT,NEWPREF,IFIRSTP,IFIRSTPSEG,POSTREF,NIMAG
 6001     FORMAT(//,1X,'In MAIN after calling CONTROL',/,1X,
     $         'FIRSTTIME ',
     +         L2,' MULTISEG',L2,' IFIRSTPACK',I4,' NPACK',I4,' NBLOCK',
     +         I3,/,1X,'SUMPART',L2,' ADDPART',L2,'  ISEG=',I2,
     +         '  NADD=',I2,'  NREPEAT=',I3,' NEWPREF ',L2,
     +         ' IFIRSTP=',I3,' IFIRSTPSEG=',I3,/,1X,'POSTREF',L2,
     +         ' NIMAG',I3)
        END IF
C       
C----   Initialisation flags for FINDPACK, OPENODS, storing cell.
        MODEOP = 1
        STORCELL = .FALSE.
C       
C---    Initialize big array for multi-image post-refinement
C
        INTDUM(1) = 0
        INTDUM(2) = 0
        IF(NEWPREF)CALL MODARRAY(0, 0.0, 0,0,INTDUM,INTDUM)
C       
C---    If POWDER option, display image etc now
C       
        IF (POWDER) THEN
C       
C----   Always display the image given on IMAGE keyword at MOSFLM prompt
C       even if other images have been read in subsequently in MXDSPL
C       
C       AL        NIMAG = IRSTRT
C       AL        ID = NOIMG(IRSTRT)
C       
C----   In case this is restart after an aborted run, need to reassign
C       PHIBEG, PHIEND. Note that the menu is only put up again after an
C       "Abort" if the IMAGE keyword was used when starting the program
C       (which sets DISPMENU true).
C       
C       AL        PHIBEG = PHISTIM(IRSTRT)
C       AL        PHIEND = PHIBEG + 2.0*(PHI(IRSTRT) - PHIBEG)
          NIMAG = 1
          ID = RESTID
          PHIBEG = RESTPHIB
          PHIEND = RESTPHIE
          IDENT = RESTIDENT
          WAXFN = IDENT
          IF (TEMPLATE) THEN
            TEMPLSTART = RTEMPLSTART
            TEMPLEND = RTEMPLEND
            NTDIG = RNTDIG
          END IF
C       ********************************************************
C----   OPENODS called in POWDER mode
C     
          CALL OPENODS(WAXFN,ID,FILM,ODEXT,FDISK,MODEOP,
     +         PACK,ODFILE,SEPCHAR,FORCEREAD,NIMAG,
     +         TEMPLSTART,TEMPLEND,IERR)
C       *******************************************************
c
c---- calculate average, rms of this image
c
           CALL DSPSCL(ID,IMAGE,NREC,IYLEN)
C       
C----   If this is a DIP2, this is the first time the image has been read
C       
C       
C----   If file does not exist, return to CONTROL
C       
          IF (ID.EQ.-999)GOTO 30
C       
C----   Assign PHIBEG, PHIEND if these are being read from header
C       
          IF ((ISTRT.EQ.0).OR.(IANGLE.EQ.0)) THEN
C     .. HRP 22.03.2004 - DIPS don't seem to have their tail records
C     .. read properly following refinement

            IF((MACHINE.EQ.'DIP2').AND.((ABS(RESTPHIB).GT.1E-3)
     $           .OR.(ABS(RESTPHIE).GT.1E-3)))THEN
              PHIBEG = RESTPHIB
              PHIEND = RESTPHIE
            ELSE
              PHIBEG = HPHIS
              PHIEND = HPHIE
              RESTPHIB = PHIBEG
              RESTPHIE = PHIEND
            ENDIF
          END IF   
          XCEN = 100.0*XCENMM(1,1) + CCX
          YCEN = 100.0*YCENMM(1,1) + CCY
          IF (NGR.EQ.7) THEN
C       AL          MODEDISP = 4
C       
C----   Mosaicity estimation immediately prior to starting MXDisplay
C       
C            IF(MOSEST)CALL ESTMOS(NIMAG)


            MODEDISP = 0
            
            CALL XDISP(MODEDISP,FIRSTPACK,PACK,IFIRSTPACK,FIRSTFILM,
     +           GENOPEN)
C       
C----   Trap call to integrate images or postref segment
C       
            IF ((MODEDISP.EQ.9).OR.(MODEDISP.EQ.10)) THEN
C       
C----   For post-refinement, set up first image number, as it will not
C       be set below and FIRSTTIME will not necessarily be true
C       
CAL              IF (MODEDISP.EQ.10) IFIRSTP = IFIRSTPACK
              IFIRSTP = IFIRSTPACK
C
C---- Also need to assign IFIRSTPSEG if NOT doing MULTISEG (in which case
C     it is assigned below). Otherwise it will still be set to the value
C    for a previous run (which might be a multiseg post-ref) al 13/1/03
C
              IF (.NOT.MULTISEG) IFIRSTPSEG = IFIRSTP
              POWDER = .FALSE.
              MODEDISP = 0
C       
C----   Need to set up SUMP,ADDP again when integrating via MXDSPL
C       
              DO 37 IPACK = IFIRSTPACK,NPACK
                SUMP(IPACK) = SUMPART
                ADDP(IPACK) = ADDPART
 37           CONTINUE
C       
C----   Open coordinate file if DENSE image
C       
C       *******************************************************
              IF (DENSE.AND.(.NOT.COORDOPN)) 
     +             CALL CCPDPN(-ICOORD,'COORDS','UNKNOWN','U',0,
     +             IFAIL)
C       *******************************************************
              GOTO 31
C       
C----   Trap call to STRATEGY option from window
C       
            ELSE IF (MODEDISP.EQ.20) THEN
              MODECTRL = 10
c
c---- -O2 optimization on DEC Alpha cunningly omits the previous line
C     unless we access the variable...
c
              WRITE(LINE,FMT='(I3)') MODECTRL
              FIRSTTIME = .FALSE.
C       
C----   Set NRUN to zero so that if multiple runs are being used in STRATEGY
C       it will count them correctly
C       
              NRUN = 0
C       
C----   Save the current value of NIMAG as it is set to zero in CONTROL
C       
              NIMAGSV = NIMAG
              GOTO 30
            ELSE IF (MODEDISP.EQ.99) THEN
              CALL MRESET(ISEG,RPTFIRST,GENOPEN,COORDOPN)
              IF (DISPMENU) THEN
                GOTO 34
              ELSE
                GOTO 30
              END IF
            END IF
          END IF
          FIRSTTIME = .FALSE.
          GOTO 30 
        END IF
C       
C****** CALL START taken from here
C       
C       
C----   Store initial missettings
C       
 31     DO 33 I = 1,3
          SDELPHI(I) = DELPHI(I)
 33     CONTINUE
C       
C       
C       
C       
C----   Save camera constants etc input by keywords to reinitialise
C       these variables for each new pack. Note that this is NOT done for
C       IP data, where the values should not change from image so the 
C       refined values are better than the input ones.
C       
        SAVECCX = CCX
        SAVECCY = CCY
        SAVECCOM = CCOM
        SXTOFRA = XTOFRA
        SYSCAL = YSCAL
        STILT = TILT
        STWIST = TWIST
        SROFF = ROFF
        SBULGE = BULGE
        SBULGE2 = BULGE2
        STOFF = TOFF
C       
C----   Store input beam parameters, note these are now half-widths in radians
C       (Converted in call to START from CONTROL)
C       
        SETA = ETA
        SDIVH = DIVH
        SDIVV = DIVV
C       
        FIRSTTIME = .FALSE.
C       
C       
C       
C----   Initialise jpack, keeps track of packs in generate file
C       
        JPACK = 0
C       
C----   if using profile fitting, open the "SPOTS" file SPOTOD.OUT
C       but ONLY if NBLOCK.EQ.0, otherwise it is done below.
C       
        IF (PROFILE.AND.(NBLOCK.EQ.0)) THEN
          IF (PROCES) THEN             
            IFAIL = 1
C       
C       **********************************
            IF(.NOT.MULTISEG)THEN
              IF(NUSPOT)THEN
                IF(.NOT.INMOOPEN)CALL QOPEN(INMO,'SPOTOD','SCRATCH')
                INMOOPEN = .TRUE.
              ELSE
                CALL CCPDPN(-INMO,'SPOTOD','SCRATCH','U',0,IFAIL)
              ENDIF
            ENDIF
C       **********************************
C       
            SECONDPASS = .TRUE.
            FIRSTPASS = .FALSE.
            PROCESSA = .TRUE.
            NFLMO = NPACK - IFIRSTPACK + 1
            NOTREAD = .TRUE.
          ELSE
            IFAIL = 1
C       
C       **********************************
c           CALL CCPDPN(-INMO,'SPOTOD','UNKNOWN','U',80,IFAIL)
            IF(.NOT.MULTISEG)THEN
              IF(NUSPOT)THEN
                IF(.NOT.INMOOPEN)CALL QOPEN(INMO,'SPOTOD','SCRATCH')
                INMOOPEN = .TRUE.
              ELSE
                CALL CCPDPN(-INMO,'SPOTOD','SCRATCH','U',80,IFAIL)
              ENDIF
            ENDIF
C       **********************************
C       
          END IF
        END IF
C       
C----   Loop over packs to be processed from this generate file in
C       this "run"
C       
        IF (MULTISEG) THEN
          IF ((ISEG.EQ.1).AND.(NREPEAT.EQ.0)) NFILMS = 0
          IF (NREPEAT.EQ.0) THEN
            DO 29 I = 1,6
              OLDCELL(I) = CELL(I)
 29         CONTINUE
          END IF
        ELSE
          NFILMS = 0
        END IF
        AVBGRMAX = 0.0
        AVBGRMIN = 10000.0
        ROFFSAVE = -999.0
        TOFFSAVE = -999.0
        NOWRITE = 0
        NFRPT = 0
        NIMGSM = 0
C       
C----   Flag for whether profiles have been read in yet
C       
        NOTREAD = .TRUE.
        IFIRSTGOOD = IFIRSTPACK
C       
C----   If processing a large number
C       of packs in a single run, it may be advantageous to accumulate
C       profiles over a block of images rather than all of them (because
C       the profiles may well change on rotating the crystal). This is done
C       using the BLOCK subkeyword on the PROCESS keyword line
C       
        IF (NBLOCK.NE.0) THEN
          IFIRSTPACK = IFIRSTPACK - NBLOCK
          NPACKSAVE = NPACK
          NPACK = 0
        END IF
C       
 35     CONTINUE
        IF (NBLOCK.NE.0) THEN
          NUMBLOCK = NUMBLOCK + 1
          IFIRSTPACK = IFIRSTPACK + NBLOCK
          NPACK = IFIRSTPACK + NBLOCK - 1
C       
C----   If ADDPART generate one image beyond that being processed so that
C       spatially overlapped partials can be detected. Only generation of
C       the reflection list will be done for this additional image.
C       Note this is NOT necessary when using NEWPREF post-refinement.
C----   Can't get this to work when reading profiles without further effort,
C       leave it for now
C       
          IF (ADDPART.AND.(.NOT.PRREAD).AND.(.NOT.NEWPREF)) THEN
            NPACK = NPACK + 1
            EXTRAIMG = .TRUE.
          END IF
C       
          IF (NPACK.GT.NPACKSAVE) THEN
            NPACK = NPACKSAVE
            EXTRAIMG = .FALSE.
          END IF
          IFIRSTGOOD = IFIRSTPACK
          IF (.NOT.PRREAD) FIRSTPASS = .TRUE.

          IF (MULTISEG) THEN
            IF ((ISEG.EQ.1).AND.(NREPEAT.EQ.0)) NFILMS = 0
          ELSE
            NFILMS = 0
          END IF

          IF (DEBUG(1)) THEN
            WRITE(IOUT,FMT=6420) NFILMS
            IF (ONLINE) WRITE(ITOUT,FMT=6420) NFILMS
 6420       FORMAT(1X,'NFILMS initialised (or not), now',I3)
          END IF
          AVBGRMAX = 0.0        
          AVBGRMIN = 10000.0
          IFAIL = 1
          NOWRITE = 0
          NOTREAD = .TRUE.
          IF (NREPEAT.EQ.0) WRITE(ISUMMR,FMT=6007)
 6007     FORMAT(/,/)
C       
C       **********************************
          IF (NREPEAT.EQ.0)THEN 
            IF(.NOT.MULTISEG)THEN
              IF(NUSPOT)THEN
                IF(.NOT.INMOOPEN)CALL QOPEN(INMO,'SPOTOD','SCRATCH')
                INMOOPEN = .TRUE.
              ELSE
                CALL CCPDPN(-INMO,'SPOTOD','SCRATCH','U',80,IFAIL)
              ENDIF
            ENDIF
          ENDIF
c     +         CALL CCPDPN(-INMO,'SPOTOD','UNKNOWN','U',80,IFAIL)
C       **********************************
        END IF
C       
C----   Write header to summary file (don't repeat this if repeating
C       processing of first NADD images after post-refinement)
C       
        IF (NREPEAT.EQ.0) THEN
          IF (IMGP) THEN
            IF (.NOT.USEOVRLD) WRITE(ISUMMR,FMT=6096)
 6096       FORMAT(1X,'*** WARNING *** No attempt will be made to',
     +           ' measure overloaded reflections',/,1X,'Use keywo',
     +           'rds PROFILE OVERLOAD to estimate overloads by p',
     +           'rofile fitting')
            WRITE (ISUMMR,FMT=6005) WAVE/DSTMAX
          ELSE
            WRITE (ISUMMR,FMT=6004) WAVE/DSTMAX
          END IF
C       
C----   Film summary heading
C       
 6004     FORMAT(1X,'PACK   CCX   CCY  CCOM  DIST YSCALE TILT TWIST',
     +         ' BULGE RESID  WRESID  FULL  PART OVRL  NEG BAD',
     +         '  I/SIGI   I/SIGI',/,102X,'overall (at',F4.1,'A)')
C       
C----   Image plate summary heading
C       
 6005     FORMAT(1X,'IMAGE    CCX    CCY    CCOM   DIST YSCALE  TILT ',
     +         'TWIST   ROFF   TOFF  RESID  WRESID    FULL   PART   ',
     +         'OVRL  NEG  BAD  I/SIGI  I/SIGI   Rsym  Nsym SDRAT',/,
     $         109X,'overall (at',F4.1,'A)')
        ENDIF
C       
C       
C*****************************************************************************
C       
C----   LOOP OVER PACKS
C       
C*****************************************************************************
 40     CONTINUE

c     can we break here before we start with the actual integration?

        if(socklo .and. proces .and. (nimag .gt. 1)) then
           call xdisp(modedisp,firstpack,pack,ifirstpack,
     +                 firstfilm,genopen)
        end if


C       
C       
C----   generate list of spots but don't write generate file...
C       
C       HRP 21121999
C----   Assign oscillation angles
C       
C       
C----   If the spot separation OR raster parameters were not defined
C       by the user, determine appropriate values now from the very first
C       image to be processed.
C       
cdms21.09.2004   Check IFIRSTPACK instead of IPACK.
chrp17.02.2005        IF (IFIRSTPACK.EQ.IFIRSTP) THEN  
        IF (IPACK.EQ.IFIRSTP) THEN
          IF ((ISEP.EQ.0).OR.(IRAST.EQ.0)) THEN
            MODEGSR = 0
            CALL GETSEPRAS(IRAST,ISEP,IRAS,ID,MINDTX,MINDTY,
     +           IXSEP,IYSEP,MODEGSR,IERR)
            IF (IERR.NE.0) THEN
              NSHUTERR = 1
              CALL SHUTDOWN(CALLEDFROM,NSHUTERR)
            END IF
          END IF
        END IF
C       
C---    need to set up PHI range and beam position before calling GENERATE
C    PHIBEGA,PHIENDA have been set up in CONTROL, based on the phi
C    values for the first image (when header read to determine image size).
C    Note that other values in PHIBEGA,PHIENDA will only be correct if all
C    images have the same oscillation angle. They are updated (in OPENODS)
C    as each image is read in.
C
C---- Call GENERATE in MODE=2 (do not write generate file) to work out
C     NADD, NVIRBAT and whether NEWPREF is required.
C       
        PHIBEG = PHIBEGA(IFIRSTPACK)
        PHIEND = PHIENDA(IFIRSTPACK)
        XCEN = 100.0*XCENMM(1,1)
        YCEN = 100.0*YCENMM(1,1)
        CALL GENERATE(2,IFIRSTPACK,.true.,.true.,LIMIT,.true.,
     +       NEWPREF,NFGEN,.false.,NFULLF)
C
C---- Decide whether to use NEWPREF, but only if a keyword has not been
C     set explicitly (POSTREF MULTI or NOMULTI)
C
        IF ((IMULTI.EQ.0).AND.(ISEG.EQ.1).AND.(NUMBLOCK.EQ.1).AND.
     +       FIRSTPASS) THEN
          IF (NIVB.GT.2) THEN
            IF (.NOT.NEWPREF) THEN
              NEWPREF = .TRUE.
              IF (ADDPART.AND.(.NOT.PRREAD)) THEN
                NPACK = NPACK -1
                EXTRAIMG = .FALSE.
              END IF
              INTDUM(1) = 0
              INTDUM(2) = 0
              CALL MODARRAY(0, 0.0, 0,0,INTDUM,INTDUM)
              SUMPART = .FALSE.
            END IF
          END IF
        END IF
        WRITE(IOUT,FMT=1234) NEWPREF,ISEG,NUMBLOCK,FIRSTPASS
        IF (ONLINE) WRITE(ITOUT,FMT=1234) NEWPREF,ISEG,NUMBLOCK,
     +       FIRSTPASS
 1234   FORMAT(1X,'NEWPREF ',L1,'  ISEG',I3,'  NUMBLOCK',I3,
     +         '  FIRSTPASS ',L1)
        IF (NEWPREF.AND.(ISEG.EQ.1).AND.(NUMBLOCK.EQ.1).AND.
     +       FIRSTPASS) THEN
C
C---- Do not assign NVIRBAT if it has been set by a keyword
C
C
          IF (IVIRBAT.EQ.0) NVIRBAT = MAX(NIVB-1,1)
          NADDMISSET = NIVB + NIVB/2
C
C---- If NADD keyword given for integration (not cell refinement)
C     use that value for NADDMISSET
C
          IF (PRMODE.AND.(.NOT.MULTISEG)) NADDMISSET = NADD
C
C---- Ensure NADDMISSET is a multiple of NVIRBAT
C
          IF (MOD(NADDMISSET,NVIRBAT).NE.0)
     +       NADDMISSET = (NADDMISSET/NVIRBAT)*NVIRBAT +NVIRBAT
          IF (NADDMISSET.LT.1) NADDMISSET = NVIRBAT
          IF (MULTISEG) THEN
            IFIRSTPSEG = IFIRSTPACK
          ELSE
            NADD = NADDMISSET
          END IF
          WRITE(IOUT,FMT=6400) 
          IF (ONLINE) WRITE(ITOUT,FMT=6400) 
 6400       FORMAT(//,1X,'*** Post-refinement will use partials ',
     +        'extending over several images ***',/,1X,'This is',
     +        ' equivalent to including a POSTREF MULTI keyword.',/,
     +      1X,'(To prevent this, include keywords POSTREF NOMULTI.)')
          IF (NVIRBAT.GT.1) THEN
            WRITE(IOUT,FMT=6402) NVIRBAT
            IF (ONLINE) WRITE(ITOUT,FMT=6402) NVIRBAT
 6402       FORMAT(1X,'Separate missetting angles will be refined for',
     +            ' groups of',I3,' images.')
          END IF
          WRITE(IOUT,FMT=6404) NADDMISSET
          IF (ONLINE) WRITE(ITOUT,FMT=6404) NADDMISSET
 6404       FORMAT(1X,'Reflections from up to',I3,' images will be',
     +       ' used in the refinement of missetting angles.'/,/)
       END IF
C       HRP 21121999
C
C---- Initialise RESETCCOM
C
        RESETCCOM = .FALSE.
C
C---- If doing a cell refinement run, save (first round) or restore
C     parameters required.

        IF (MULTISEG.AND.(NREPEAT.EQ.0).AND.
     +       (ISEG.EQ.1)) then
C
           CALL CELLREFSET(IFIRSTPACK,NREPEAT,ISEG,RPTFIRST,
     +          FIRSTTIME,INERR)
           IF (INERR) THEN
C     
C---- Abort current run
C       
              CALL MRESET(ISEG,RPTFIRST,GENOPEN,COORDOPN)
              IF (DISPMENU) THEN
                 GOTO 34
              ELSE
                 GOTO 30
              END IF
           END IF
        end if
C
C
C---- Need to reset large cell error warning flags which may have
C     been set by a previous cycle of this run or by a
C     previous cell refinement run. Need to reset SDs as well
C     otherwise test on inaccurate cell will use sd'd from a previous
C     refinement. AGWL 27/7/07
C
        IF (MULTISEG.AND.(ISEG.EQ.1)) THEN
           WARN(18) = .FALSE.
           DO I = 1,6
             XWARN(I,18) = 0.0
             IWARN(I,18) = 0
             SDCELL(I) = 0.0
           END DO
        END IF
C       
C
C---- xml to GUI, this is a break between postrefining and 
C     integrating in a block.
C
        IF(SOCKLO.AND.PROCES.AND..NOT.MULTISEG)THEN

 6440      FORMAT('<?xml version="1.0"?>',
     $          '<!DOCTYPE block_integrate_begin SYSTEM "">',
     $          '<block_integrate_begin>',
     $          '<status>',
     $          '<code>ok</code>',
     $          '</status>',
     $          '</block_integrate_begin>')
           WRITE(LONGLINE,FMT=6440)
           CALL WRITE_SOCKET_LENGTH(SERVERFD,
     $          LENSTR(LONGLINE),LONGLINE)
        ENDIF
C
        DO 250 IPACK = IFIRSTPACK,NPACK
C       
          FIRSTPACK = (IPACK.EQ.1)
C
C---- Set pointer to last image in this segment
C
          IF (ISEG.GT.0) LASTFILM(ISEG) = NPACK
C       
          IF (DEBUG(1)) THEN
            WRITE(IOUT,FMT=6009) IPACK,IFIRSTPACK,NPACK,FIRSTPASS,
     +           SECONDPASS,THIRDPASS
            IF (ONLINE) WRITE(ITOUT,FMT=6009) IPACK,IFIRSTPACK,NPACK,
     +           FIRSTPASS,SECONDPASS,THIRDPASS
 6009       FORMAT(1X,'In Loop over packs',/,1X,'IPACK=',I3,
     +           ' IFIRSTPACK=',I4,' NPACK=',I4,' FIRSTPASS',L2,
     +           ' SECONDPASS',L2,' THIRDPASS',L2)
          END IF
C       
C----   If this is the final (extra) image which is only processed up
C       to the point of generating the reflection list so that spatially
C       overlapped summed partials can be flagged, then skip to end of
C       this loop if this is the second or third pass (Cannot test on
C       FIRSTPASS because this is never true when reading in profiles)
C       
          IF (EXTRAIMG.AND.(IPACK.EQ.NPACK).AND.
     +         (SECONDPASS.OR.THIRDPASS)) GOTO 250
C       
C----   If this is multi-segment post-refinement, and this is the last pack of
C       the current segment, then there is no need to process it UNLESS using
C       NEWPREF refinement.
          IF ((MULTISEG).AND.(.NOT.NEWPREF).AND.(IPACK.EQ.NPACK))
     +         GOTO 250
C       
C----   NACFLM is the number of films in each pack to be included in
C       profile accumulation. Note that this will depend on
C       whether processing is starting with the A, B or C film
C       (hence NFIRST(IPACK),
C       which is 1, 2 or 3 respectively).
C       
          NACFLM = 1
          IF (PRBFILM) NACFLM = 2 - NFIRST(IPACK) + 1
          IF (PRCFILM) NACFLM = 3 - NFIRST(IPACK) + 1
C       
          ID = IDPACK(IPACK)
C       
C----   Determine which serial keyword this pack belongs to
C       
          DO 42 I = 1,50
            IF ((ID.GE.IPACK1A(I)).AND.(ID.LE.IPACK2A(I))) THEN
              ISERADD = ISERAR(I)
              GOTO 44
            END IF
 42       CONTINUE
C       
C----   Assign oscillation angles
C       
 44       PHIBEG = PHIBEGA(IPACK)
          PHIEND = PHIENDA(IPACK)
C       
C----   If on thirdpass, write out summary file information for the
C       A film of this pack
C       
          IF (THIRDPASS) THEN
C       
C----   First check if this film has been rejected, and
C       write message to summary file.
C       
            DO 50 IIF = 1,NACFLM
              IF (BADPACK(IPACK,IIF)) THEN
                IXERRI = IXERR(IPACK)
                X = XERR(IPACK)
C       
C       *****************************************************
                CALL SUMMERR(ISUMMR,ID,NERR(IPACK),NFPACK(IPACK),
     +               NFGEN,IIF,IXERRI,X)
C       *****************************************************
C       
                GO TO 250
              END IF
C       
C       
              NFILMS = NFILMS + 1
              IF (DEBUG(1)) THEN
                WRITE(IOUT,FMT=6422) NFILMS
                IF (ONLINE) WRITE(ITOUT,FMT=6422) NFILMS
 6422           FORMAT(1X,'NFILMS set to',I4,' for writing',
     +                ' to summary file')
              END IF
C       
C       
              IF (IMGP) THEN
C       
C----   Writes summary information for ip on detector refinement etc
C       needed for xloggraph
C       
C       IMAGE   CCX  CCY   CCOM  DIST YSCALE TILT TWIST ROFF  TOFF RESID  WRESID
C       FULL  PART OVRL  NEG BAD  I/SIGI   I/SIGI  Rsym Nsym SDRAT
c       -harvest
c       cxEBI if the format 6067 changes then harvest mharvest.f needs to change
c       -harvest
C       

                 write(dna_image, *) isumm(1,nfilms)

                 call dna_output_table_start('summary_information')
                 call dna_output_list_start('summary')
                 call dna_output_integer_item('pack', 
     +                isumm(1,nfilms))
                 call dna_output_real_item('ccx', 
     +                0.01 * isumm(2, nfilms))
                 call dna_output_real_item('ccy', 
     +                0.01 * isumm(3, nfilms))
                 call dna_output_real_item('ccom',
     +                rsumm(1, nfilms))
                 call dna_output_real_item('distance',
     +                0.01 * isumm(4, nfilms))
                 call dna_output_real_item('yscale',
     +                rsumm(2, nfilms))
                 call dna_output_real_item('isigall',
     +                rsumm(5, nfilms))
                 call dna_output_real_item('isigout',
     +                rsumm(6, nfilms))
                 call dna_output_list_end
                 call dna_output_list_start('spots')
                 call dna_output_integer_item('full',
     +                isumm(9, nfilms))
                 call dna_output_integer_item('partial',
     +                isumm(10, nfilms))
                 call dna_output_integer_item('overlap',
     +                isumm(11, nfilms))
                 call dna_output_integer_item('negative',
     +                isumm(12, nfilms))
                 call dna_output_integer_item('bad_spots',
     +                isumm(13, nfilms))
                 call dna_output_list_end
                 call dna_output_table_end


                WRITE (ISUMMR,FMT=6067) ISUMM(1,NFILMS),
     +               (0.01*ISUMM(K,NFILMS),K=2,3),RSUMM(1,NFILMS),
     +               0.01*ISUMM(4,NFILMS),
     +               RSUMM(2,NFILMS),(ISUMM(K,NFILMS),K=5,6),
     +               0.01*ISUMM(7,NFILMS),0.01*ISUMM(19,NFILMS)
     +               ,0.01*RSUMM(3,NFILMS),RSUMM(4,NFILMS),
     +               (ISUMM(K,NFILMS),K=9,13),
     +               (RSUMM(K,NFILMS),K=5,7),
     +               ISUMM(20,NFILMS),RSUMM(8,NFILMS)
                NLSUM1 = NLSUM1 + 1
                WRITE (LINESUM1(NLSUM1),FMT=6067) ISUMM(1,NFILMS),
     +               (0.01*ISUMM(K,NFILMS),K=2,3),RSUMM(1,NFILMS),
     +               0.01*ISUMM(4,NFILMS),
     +               RSUMM(2,NFILMS),(ISUMM(K,NFILMS),K=5,6),
     +               0.01*ISUMM(7,NFILMS),0.01*ISUMM(19,NFILMS)
     +               ,0.01*RSUMM(3,NFILMS),RSUMM(4,NFILMS),
     +               (ISUMM(K,NFILMS),K=9,13),
     +               (RSUMM(K,NFILMS),K=5,7),
     +               ISUMM(20,NFILMS),RSUMM(8,NFILMS)
              ELSE
                WRITE (ISUMMR,FMT=6066) ISUMM(1,NFILMS),
     +               SUMMCH(NFILMS),(0.01*ISUMM(K,NFILMS),K=2,3),
     +               RSUMM(1,NFILMS),0.01*ISUMM(4,NFILMS),
     +               RSUMM(2,NFILMS),(ISUMM(K,NFILMS),K=5,6),
     +               0.01*ISUMM(7,NFILMS),
     +               0.01*RSUMM(3,NFILMS),RSUMM(4,NFILMS),
     +               (ISUMM(K,NFILMS),K=9,13),
     +               (RSUMM(K,NFILMS),K=5,6)
              END IF
C       
C----   Film format
C       PACK ID  CCX   CCY  CCOM  DIST YSCALE TILT TWIST BULGE
C       RESID  WRESID  FULL  PART OVRL  NEG BAD  I/SIGI
C       
 6066         FORMAT (1X,I3,A,3F6.2,F6.1,F6.3,I5,I6,F7.2,
     +             F6.3,F7.1,I7,I6,2I5,I4,2F7.1)
C       
C----   IP format
C       PACK   CCX  CCY   CCOM  DIST YSCALE TILT TWIST ROFF  TOFF RESID  WRESID
C       FULL  PART OVRL  NEG BAD  I/SIGI   I/SIGI  Rsym Nsym SDRAT
C       
cdms21.09.2004   Make columns line up better with heading.
C6067         FORMAT (1X,I4,3F6.2,F7.1,F6.3,2I5,1X,2F6.2,F6.3,F7.1,
C    +             I5,I6,2I4,I4,2F8.1,F8.3,I4,F6.1)
CHRP 09.08.2006 - add explicit spaces between number fields
c 6067         FORMAT (2X,I4,1X,2(F6.2,1X),F7.2,1X,F6.1,1X,F6.3,1X,
c     $             2(I5,1X),2(F6.2,1X),F6.3,1X,F7.1,1X,I7,1X,I6,1X,
c     +             2(I5,1X),I4,1X,2(F7.1,1X),F8.3,1X,I5,1X,F6.1)
 6067         FORMAT (2X,I4,1X,2(F6.2,1X),F7.2,1X,F6.1,1X,F6.3,1X,
     $             2(I5,1X),2(F6.2,1X),F6.3,1X,F7.1,1X,I7,1X,I6,1X,
     +             2(I5,1X),I4,2(F7.1,1X),F8.3,I5,F6.1)      
 50         CONTINUE
          END IF
C       
C----   Test if this pack has been rejected already. This test only
C       necessary when accumulating profiles, and one of the
C       'A' films has been rejected
C       
          IF (BADPACK(IPACK,1)) GO TO 250
C       
C----   Set flags for average spot profile, FILMPLOT,
C       and firstfilm for use in profile accumulation
C       
          AVPROFILE = AVPROF(IPACK)
          FILMPLT = FILMPLOT(IPACK)
C       
C----   CAUTION ! ... be sure that previous packs have not been rejected
C       when assigning firstfilm
C       
          FIRSTFILM = (IPACK.EQ.IFIRSTGOOD)
C       
C----   Locate the required pack in the generate file
C       
C----   NFIRST(IPACK) stores film number (1,2 or 3) of first
C       film to be processed
C       
          NFIRSTI = NFIRST(IPACK)
C       
C----   If profiles have been accumulated from several a films,
C       then on thirdpass, when b and c films are to be processed
C       we must start with the b film
C       just in case the profiles were actually accumulated using
C       the b films, increment nfirsti rather than setting to 2
C       
          IF (THIRDPASS) THEN
            NFIRSTI = NFIRSTI + 1
C       
C----   If B films were included in forming profiles
C       increment NFIRTSI appropriately.
C       If C films were included there is no more to be done.
C       
            IF (PRBFILM) NFIRSTI = NFIRSTI + 1
            IF (PRCFILM) GO TO 250
          END IF
C       
          STARTA = (NFIRSTI.EQ.1)
          STARTB = (NFIRSTI.EQ.2)
          STARTC = (NFIRSTI.GE.3)
C       
C----   If using profile fitting, must start with the A film
C       
          IF ((.NOT.THIRDPASS) .AND. PROFILE .AND. (.NOT.PRREAD) .AND.
     +         ((STARTB.AND. (.NOT.PRBFILM)).OR.
     +         (STARTC.AND. (.NOT.PRCFILM)))) THEN
            WRITE (IOUT,FMT=6008)
 6008       FORMAT (//1X,'******* FATAL ERROR ******',/1X,'When using',
     +           ' PROFILE FITTING the A film must be processed first ',
     +           'unless profile fitting has been',/1X,'EXPLICITLY ',
     +           'requested for B or C films on PROFILE keyword')
            IF (ONLINE) WRITE (ITOUT,FMT=6008)
            NSHUTERR = 2
            CALL SHUTDOWN(CALLEDFROM,NSHUTERR)
          END IF
C       
          FORCE = ((STARTB.AND.FORCEB(IPACK)) .OR.
     +         (STARTC.AND.FORCEC(IPACK)))
C       
C**********************************************************al
C----   How many films in this pack to be processed?
C       
          NFP = 1
C       
C**********************************************************al
C       
C----   If accumulating profiles and now on thirdpass, check that
C       there is another film in the pack to be processed
C       
          IF (THIRDPASS .AND. (NFP.EQ.NACFLM)) GO TO 250
C       
C       AL
C----   Only call FINDPACK if this pack has already been generated,
C       ie if this is the second pass of accumulate or if this is the
C       B or C film (ie thirdpass), OR if this is the first image of
C       the second or subsequent block of images which has already been
C       generated in order to flag spatially overlapping summed partials.
C       However, I have not yet got this to work if reading profiles,
C       so don't do this when reading profiles
C       
          IF ((SECONDPASS.OR.THIRDPASS).OR.
     +         ((IPACK.EQ.IFIRSTPACK).AND.(ADDPART.AND.(.NOT.NEWPREF))
     +         .AND.(NUMBLOCK.GT.1)
     +         .AND.(.NOT.PRREAD)))
     +         THEN
C       
C       ***************************************************
            CALL FINDPACK(ID,FILMPLT,NFGEN,JPACK,FORCE,READCC,NOFID,
     +           NPACK)
C       ***************************************************
C       
C----   If running interactively, so that the pattern is regenerated after
C       refinement (MODEG=3), then if this is the first image of a new block
C       and ADDPART is TRUE so that spatial overlaps are checked, then
C       must reposition generate file now to start of this pack, or this
C       image will get generated twice.
C       
            IF (((IPACK.EQ.IFIRSTPACK).AND.(ADDPART.AND.(.NOT.NEWPREF))
     +           .AND.(NUMBLOCK.GT.1).AND.(.NOT.PRREAD)).AND.FILMPLT
     +           .AND.(.NOT.MATCH)) THEN
              CALL QSEEK(IUNIT,IPACKHEAD,1,36)
              IPACKREC = IPACKHEAD
            END IF
          END IF
C       
C       
C----   Check if pack not found, or previous film not measured
C       
          IF (ID.LT.0) THEN
            BADPACK(IPACK,1) = .TRUE.
C       
C----   If this is a multi-segment refinement, abandon it.
C       
            IF (MULTISEG) THEN
              WRITE(IOUT,FMT=6210)
              IF (ONLINE) WRITE(ITOUT,FMT=6210)
 6210         FORMAT(//1X,' A multisegment post-refinement will NOT ',
     +             'work if images have been rejected',/,1X,
     $             'Run aborted')
              STOP
            END IF
C       
C----   If this was the firstfilm,
C       change pack number of first good film
C       
            IF (FIRSTFILM) IFIRSTGOOD = IFIRSTGOOD + 1
            NWRN = NWRN + 1
C       
C----   If on firstpass of accumulate run, just store the error,
C       otherwise write message to summary file now.
C       
            IF (FIRSTPASS) THEN
              NERR(IPACK) = -ID
            ELSE
C       
C       ****************************************************
              CALL SUMMERR(ISUMMR,ID,-ID,NFPACK(IPACK),NFGEN,FILM,IX,X)
C       ****************************************************
C       
            END IF
            GO TO 250
          END IF
C       
C----   Note that if accumulating profiles, proces is set true
C       for the second pass   
C       set NFP=NACFLM if going straight into process
C       
          IF (PROCES) THEN
            NFP = NACFLM
            GO TO 60
          END IF
C       
C----   If accumulating profiles, then on first and second passes
C       only do A films,and on thirdpass do remaining films
C       
          IF (ACCUMULATE) THEN
            IF (FIRSTPASS) THEN
              NFP = NACFLM
            ELSE
              NFP = NFP - NACFLM
            END IF
          END IF
C       
C----   loop over the images to be integrated. Note that in SECONDPASS, this
C       is all the images in the block.
C       
 60       CONTINUE
C       
       
          DO 240 IFILM = 1,NFP
C       
            LIST = .FALSE.
            RESCAN = .TRUE.
C       
C----   Define initial value of MAXR, required when 'NEXT' is called
C       for central region of film. ONLY assign it for the firstfilm
C       because for subsequent films it has been assigned the correct
C       maximum from RMAXR
            IF (FIRSTFILM) MAXR = NXS*NYS
C       
C----   Is this film an A,B or C?
C       
            FILM = NFIRSTI + IFILM - 1
C       
C       
            ID = IDPACK(IPACK)
C       
C----   Call OPENODS if one film per file
C       Don't read image file if doing PROCES
            IF ((ONEFILE).AND.(.NOT.PROCES)) THEN
C       
C----   If doing SUMPART, don't read images beyond last image to be processed
C       
              IF (SUMPART.AND.(IPACK.EQ.NPACKSAVE)) THEN
                IF (ISTART.EQ.0) THEN
                  ISTART = NREC
                ELSE IF (ISTART.EQ.NREC) THEN
                  ISTART = 0
                END IF
                SUMPART = .FALSE.
C       
C----   set display filename to the PREVIOUS image that was read in.
C       
                CDSPTL = ODFILE
              ELSE
C       
C----   If this is the "extra" image only used to flag spatially overlapped
C       summed partials, then don't read in the image
C       
                IF ((EXTRAIMG).AND.(IPACK.EQ.NPACK)) GOTO 62
                IF (BRIEF) WRITE(IBRIEF,FMT=6204)
 6204           FORMAT(1X,'Reading image into memory')
C       ********************************************************
C----   OPENODS called in normal mode
C       
                CALL OPENODS(IDENT,ID,FILM,ODEXT,FDISK,MODEOP,
     +               PACK,ODFILE,SEPCHAR,FORCEREAD,IPACK,
     +               TEMPLSTART,TEMPLEND,IERR)
C
C---- hrp 03062008 for calculating average and rms for this image.
C
           call dspscl(ID,image,nrec,iylen)
C       *******************************************************
C----   If phi angles are being read from the image header, PHIBEG and
C       PHIEND will not yet have been assigned, so need to do that now.
C       Also need to assign NWMAX, maximum reflection width in images.
C       
                IF ((ISTRT.EQ.0).OR.(IANGLE.EQ.0)) THEN
                  PHIBEG = PHIBEGA(IPACK)
                  PHIEND = PHIENDA(IPACK)
                  PHIRNG = PHIEND - PHIBEG
C       
C----   Set maximum reflection width in number of images, hard limit of IPAD
C       
                  IF (PHIRNG.NE.0.0) NWMAX = NINT(WMAX/PHIRNG)
                  IF (NWMAX.GT.10) THEN
                    IPAD = 100
                    WARN(27) = .TRUE.
                  END IF
                  NWMAX = MIN(NWMAX,IPAD)
C       
C----   Limit NWMAX to minimum of 2, otherwise will not integrate partials
C       under any circumstances
C       
                  NWMAX = MAX(NWMAX,2)
                END IF
              END IF
C       

C----   Update SUMPARTIALS flag (may not have next image). Don't need to
C       do this for NEWPREF refinement.
C       
              SUMP(IPACK) = SUMPART
              IF (.NOT.NEWPREF) ADDP(IPACK) = (SUMPART.AND.ADDP(IPACK))
C       
C----   If od file does not exist (id set to -999 in openods), or error in read
C       ID = -1001, or in decoding header (id = -1002) skip to next pack
C       
              IF (ID.LE.-999) THEN
C       
C----   ABANDON job if image file does not exist...otherwise it can get into
C       all sorts of problems.
C       
                IF (ID.EQ.-999) THEN
                  WRITE(IOUT,FMT=6205)
                  IF (ONLINE) WRITE(ITOUT,FMT=6205)
 6205             FORMAT(/,/,1X,' ***** FATAL ERROR ***',/,1X,
     +                 'Image file not found, abandoning processing')
                ELSE
                  WRITE(IOUT,FMT=6380)
                  IF (ONLINE) WRITE(ITOUT,FMT=6380)
 6380             FORMAT(/,/,1X,' ***** FATAL ERROR ***',/,1X,
     +                 'Error in reading image, abandoning ',
     $                 'processing')
                END IF
                IF (WINOPEN .AND. DISPMENU) THEN
                  IXM = 200
                  IYM = 200
                  LINELEN = 60
                  NUMLIN = 3
C       
C       Create IO window
C       
                  CALL MXDCIO(0,LINELEN, NUMLIN, IXM,IYM)
                  LINE = ' '
                  IF (ID.EQ.-999) THEN
                    WRITE (LINE, 6207) 
 6207               FORMAT (1X,'Image does not exist (see terminal ',
     +                   'window).   Hit return to continue')
                  ELSE 
                    WRITE (LINE, 6390) 
 6390               FORMAT (1X,'Error reading image (see terminal ',
     +                   'window).   Hit return to continue')
                  END IF
                  CALL MXDWIO(LINE, 1)
                  CALL MXDRIO(LINE2)
                  CALL MXD_FLU(I)
                  CALL MXDCIO(1,0,0,0,0)

                  GOTO 280
                END IF
                NSHUTERR = 3
                CALL SHUTDOWN(CALLEDFROM,NSHUTERR)
C       
C----   if this was the firstfilm, change pack number of first good film
C       
                IF (FIRSTFILM) IFIRSTGOOD = IFIRSTGOOD + 1
                BADPACK(IPACK,1) = .TRUE.
                NWRN = NWRN + 1
C       
C       
C----   If this is a multi-segment refinement, abandon it.
C       
                IF (MULTISEG) THEN
                  WRITE(IOUT,FMT=6210)
                  IF (ONLINE) WRITE(ITOUT,FMT=6210)
                  STOP
                END IF
C       
                IF (FIRSTPASS) THEN
                  NERR(IPACK) = 3
                ELSE
                  ID = IDPACK(IPACK)
C       
C       **************************************************
                  CALL SUMMERR(ISUMMR,ID,3,NFPACK(IPACK),NFGEN,
     $                 FILM,IX,X)
C       **************************************************
C       
                END IF
                GO TO 250
              END IF
            END IF
C       
            AFILM = (FILM.EQ.1)
            BFILM = (FILM.EQ.2)
            CFILM = (FILM.EQ.3)
C       
C----   Go straight to process if keyword has been set
C       
 62         IF (ONLINE) THEN
C       
                IF (IMGP) THEN
                  IF (PROCES) THEN
                    WRITE (ITOUT,FMT=6015) ID,PHIBEG,PHIEND
                    IF (BRIEF) WRITE (IBRIEF,FMT=6015) ID,PHIBEG,
     $                   PHIEND
                  ELSE
                    WRITE (ITOUT,FMT=6011) ID,PHIBEG,PHIEND
                    IF (BRIEF) WRITE (IBRIEF,FMT=6011) ID,PHIBEG,
     $                   PHIEND
                  END IF
                ELSE
                  WRITE (ITOUT,FMT=6010) ID,ABC(FILM:FILM)
                END IF
                IF (EXTRAIMG.AND.(IPACK.EQ.NPACK)) WRITE(ITOUT,FMT=6013)
              END IF
C       
 6010         FORMAT (/1X,'********************',/1X,'PROCESSING FILM',
     +             I4,A,/1X,'********************')
 6011         FORMAT (/1X,'*******************************************',
     +             '*****',/1X,'Processing Image',I5,'  Phi',F8.2,' to',
     +             F8.2,/1X,'*****************************************',
     $             '*******')
 6013         FORMAT(/1X,'This image will only be processed up to the ',
     +             'point of generating the reflection list',/,1X,'so ',
     +             'that spatial overlapped summed partials are dealt ',
     $             'with.')
 6015         FORMAT (/1X,'*******************************************',
     +             '*****',/1X,'Integrating Image',I5,'  Phi',F8.2,
     +             ' to',F8.2,/1X,'***********************************',
     $             '*************')
C       
              IF (IMGP) THEN
                IF (PROCES) THEN
c     if not proces then we're processing????
                   write(dna_image, *) id
                   call dna_output_table_start('integrating_image')
                   call dna_output_list_start('image')
                   call dna_output_integer_item('number', id)
                   call dna_output_real_item('phi_start', phibeg)
                   call dna_output_real_item('phi_end', phiend)
                   call dna_output_list_end
                   call dna_output_table_end
                  WRITE (IOUT,FMT=6015) ID,PHIBEG,PHIEND
                ELSE
                   write(dna_image, *) id
                   call dna_output_table_start('processing_image')
                   call dna_output_list_start('image')
                   call dna_output_integer_item('number', id)
                   call dna_output_real_item('phi_start', phibeg)
                   call dna_output_real_item('phi_end', phiend)
                   call dna_output_list_end
                   call dna_output_table_end
                   WRITE (IOUT,FMT=6011) ID,PHIBEG,PHIEND
                   IF (EXTRAIMG.AND.(IPACK.EQ.NPACK)) 
     $                 WRITE(IOUT,FMT=6013)
                   IF(SOCKLO)THEN
 6020                 FORMAT('<?xml version="1.0"?>',
     $                     '<!DOCTYPE image_process_begin SYSTEM "">',
     $                     '<image_process_begin>',
     $                     '<status>',
     $                     '<code>ok</code>',
     $                     '</status>',
     $                     '<image_name>',A,'</image_name>',
     $                     '</image_process_begin>')
                      WRITE(LONGLINE,FMT=6020)
     $                     SHORTFN(1:LENSTR(SHORTFN))
                      CALL WRITE_SOCKET_LENGTH(SERVERFD,
     $                     LENSTR(LONGLINE),LONGLINE)
                   ENDIF
                END IF
             ELSE
                 
                WRITE (IOUT,FMT=6010) ID,ABC(FILM:FILM)
              END IF
              IF (PROCES)THEN
C       
C----   For accumulated profiles this is the second pass.
C       for the firstfilm, the whole of the SPOTOD file will
C       be read and the profiles accumulated. For second and
C       subsequent films, these profiles will be used in measuring.
C       
                ADDPP = ADDP(IPACK)
C       
                IF (WINOPEN) THEN
                  CALL MXD_FLU(I)
                  CALL MXDBSY(0,'Integrating image')
                END IF
C       ******************************************
                IF (.NOT.NOMEAS) CALL PROCESS(NFLMO,IXSHIFT,IYSHIFT,
     +   ADDPP,ISKIPI,LPINTG,NEWPREF,NUSPOT,LPINTG,NOBACK,ID,NUMBLOCK,
     +   XMLABORT)
C       ******************************************
C
C---- Abort run if flag set.
C
                IF (XMLABORT) THEN
                  CALL MRESET(ISEG,RPTFIRST,GENOPEN,COORDOPN)
                  GOTO 30
                END IF

                IF (WINOPEN) THEN
                  CALL MXD_FLU(I)
                  CALL MXDBSY(-1, ' ')
                END IF
C       
C----   Display residual vectors if requested, allows bad spot changes
C       
                IF (LPINTG.AND.FILMPLT) THEN
C       
C----   If processing more than a single image, need to read in the
C       image again as it will no longer be stored in memory. However,
C       the image must always be read into the same "half" of array
C       IMAGE because we need to keep the last image of the current BLOCK
C       of images in memory because it has not yet been processed.
C       To do this, must disable updating of the pointer ISTART in
C       OPENODS. Do this by setting MODEOP=3
C       
C       Note that ID has to be decremented by 1 (IDTMP=ID-1) when
C       SUMPART is true because OPENODS increments it by one.
C       
                  IF (NPACK.GT.1) THEN
                    IDTMP = ID
                    IF (SUMPART) IDTMP = ID - 1
                    MODEOP = 3
C       ********************************************************
C----   OPENODS called to display residual vectors
C       
                    CALL OPENODS(IDENT,IDTMP,FILM,ODEXT,FDISK,
     +                   MODEOP,PACK,ODFILE,SEPCHAR,FORCEREAD,IPACK,
     +                   TEMPLSTART,TEMPLEND,IERR)
C       *******************************************************
                    MODEOP = 0
                  END IF
C       
C----   Need to set flag to repredict the pattern
C       ***** Displaying image after integration *****
C       
                  MODEDISP = 5
                  CALL XDISP(MODEDISP,FIRSTPACK,PACK,IFIRSTPACK,
     +                 FIRSTFILM,GENOPEN)
                  IF (MODEDISP.EQ.99) THEN
C       
C----   Abort current run
C       
                    CALL MRESET(ISEG,RPTFIRST,GENOPEN,COORDOPN)
                    IF (DISPMENU) THEN
                      GOTO 34
                    ELSE
                      GOTO 30
                    END IF
                  END IF
                  IF (IPACK.EQ.NPACK) LPINTG = .FALSE.
C       
C----   End of display image block
C       
                END IF
C       
C       
C----   Write MTZ file
C       
c
c---- hrp07052002 - mtzout should have been set properly elsewhere, but
C     it seems not to be set if GENFILE hasn't been set explicity
C     - remind me to fix this properly. 
C
                if(mtzout.lt.1)mtzout = 1
                CALL WRMTZ(ID+ISERADD,ADDPP,NEWPREF,ALLOUT,NOLP,
     +                     USEOVRLD,USEDGE)
                CALL RSYMM(PROFILE)
                WRITE (IOUT,FMT=6142)
 6142           FORMAT (1X,/15 ('@@@@'),/)
                IF (ONLINE) WRITE (ITOUT,FMT=6142)
                IF (BRIEF) WRITE (IBRIEF,FMT=6142)
C       ****************************
                NFLMO = 1
C       
C----   Store information for summary file
C       
                NFILMS = NFILMS + 1
                IF (DEBUG(1)) THEN
                  WRITE(IOUT,FMT=6424) NFILMS
                  IF (ONLINE) WRITE(ITOUT,FMT=6424) NFILMS
 6424             FORMAT(1X,'NFILMS set to',I4,' for storing',
     +                ' info on integration')
                END IF
                ISUMM(9,NFILMS) = NOFR
                ISUMM(10,NFILMS) = NREF - NOFR
                ISUMM(11,NFILMS) = NOLO
                ISUMM(12,NFILMS) = NNEG
                ISUMM(13,NFILMS) = NBAD
                ISUMM(14,NFILMS) = NBGRJ
                ISUMM(20,NFILMS) = NRSYM
C----   I/sig(i) overall and in highest resolution bin
                RSUMM(5,NFILMS) = FIOVSDP(9)
                RSUMM(6,NFILMS) = FIOVSDP(8)
C----   If NO fully recorded reflections, use partials
C       
                IF (NRESPF(9).EQ.0) RSUMM(5,NFILMS) = PIOVSDP(9)
                IF (NRESPF(8).EQ.0) RSUMM(6,NFILMS) = PIOVSDP(8)
C----   Rsym
                RSUMM(7,NFILMS) = RFACOV
C----   SDRATIO for symmetry related reflections
                RSUMM(8,NFILMS) = SDRATOV
                IF (DEBUG(1)) THEN
                  WRITE(IOUT,FMT=6330) AVBGRATIO
                  IF (ONLINE) WRITE(ITOUT,FMT=6330) AVBGRATIO
 6330             FORMAT(1X,' AVBGRATIO =',F8.3)
                END IF
                AVBGRMAX = MAX(AVBGRMAX,AVBGRATIO)
                AVBGRMIN = MIN(AVBGRMIN,AVBGRATIO)
                GO TO 240
C       
C----   End of "IF (PROCES) block
C       
              END IF

C       
C----   Is this film to be treated as an A film ?
C       
              TREAT_AS_AFILM = ((BFILM.AND.FORCEB(IPACK)) .OR.
     +             (CFILM.AND.FORCEC(IPACK)))
C       
C       
              IF (TREAT_AS_AFILM) THEN
                IF (ONLINE) WRITE (ITOUT,FMT=6012)
 6012           FORMAT (1X,'This film will be processed as an ''A'' ',
     $               'FILM for positional refinement')
                WRITE (IOUT,FMT=6012)
              END IF
C       
C----   Assign camera constants for this pack if these have been
C       supplied. Skip this if readcc has been specified because
C       we want to use the values read from generate file.
C       Also skip this if Mar or R-axis image plate data because these
C       parameters should be constant from one image to the next.
C       
C----   Note that when using NOFID option, we want to reassign
C       camera constants for B and C films as well, because
C       they will not normally be the same as the A film.
C       
              IF ((AFILM.OR.TREAT_AS_AFILM.OR.NOFID) .AND.
     +             (.NOT.READCC).AND.(.NOT.IMGP)) THEN
                ICASSP = ICASSET(IPACK)
C       
C       
                IF (ICASSP.NE.0) THEN
                  CCX = CCXA(ICASSP)
                  CCY = CCYA(ICASSP)
                  CCOM = CCOMA(ICASSP)
                  IF (ONLINE) WRITE (ITOUT,FMT=6014) CCX,CCY,CCOM,CBAR
 6014             FORMAT (1X,'Camera constants assigned to this pack',
     $                 /,1X,'CCX=',I4,
     +                 ' CCY=',I4,' CCOM=',F6.3,' CBAR=',I4)
                  WRITE (IOUT,FMT=6014) CCX,CCY,CCOM,CBAR
                ELSE
C       
C----   Reassign values input via keywords
C       
                  CCX = SAVECCX
                  CCY = SAVECCY
                  CCOM = SAVECCOM
                END IF
C       
C----   Re-initialise other parameters
C       
                XTOFRA = SXTOFRA
                YSCAL = SYSCAL
C       
C       
                TILT = STILT
                TWIST = STWIST
                ROFF = SROFF
                BULGE = SBULGE
                BULGE2 = SBULGE2
                TOFF = STOFF
              END IF
C       
C       
              IF (NOFID .AND. READCC) THEN
C       
C----   Assign camera constants from generate file for this film
C       in the pack
C       
                CCX = CCXABC(FILM)
                CCY = CCYABC(FILM)
                CCOM = CCOMABC(FILM)
              END IF
C       
C       
              IF (DEBUG(1)) THEN
                IF (ONLINE) WRITE (ITOUT,FMT=6016) FILM,CCX,CCY,CCOM
 6016           FORMAT (1X,'Before FIDUS, CCX,CCY,CCOM for FILM',
     $               I3,3X,2I5,F8.3)
                WRITE (IOUT,FMT=6016) FILM,CCX,CCY,CCOM
              END IF
C       
C----   Update pointer to first strip of ods for film being processed
C       (set originally in openods)  (ONLY FOR IMPC style file format)
C       
C       
c       -vms        if (impc) icurr=(film-1)*nrec
              IF (.NOT.ONEFILE) ICURR = (FILM - 1) * NREC * NBYTE
C       
C       
C       
C----   Set flag to indicate which records of film image have been read
C**     Comment out for present, image all read in OPENODS
C       DO 70 I = 1,IXWDTH
C       RDSTRIP(I) = .FALSE.
C       70     CONTINUE
C       
C----   Set pointer in IMAGE in case image is not being store in core
C       
              IPOINT = 1
C       
C----   DOPROFILE indicates if ods have been stored for average
C       spot profile in centrs. this profile determination is controlled
C       by logical avprofile and is only done after at least one cycle
C       of refinement.
C       
              DOPROFILE = .FALSE.
C       
C----   If no fiducials, assign film centre
C       (in 10 mu units in scanner frame)
C       
              IF (NOFID) THEN
                XCENF = XCENMM(IPACK,FILM)*100.0
                YCENF = YCENMM(IPACK,FILM)*100.0
C       
C       
                IF (DEBUG(1)) THEN
                  IF (ONLINE) WRITE (ITOUT,FMT=6018) XCENF,YCENF,MACHINE
 6018             FORMAT (1X,'in MAIN,XCENF,YCENF from direct beam ',
     $                 'coords',2F8.1,/,1X,'MACHINE IS ',A)
                  WRITE (IOUT,FMT=6018) XCENF,YCENF,MACHINE
                END IF
              END IF
C       
C----   Update XTOFRA for B and C films
C       
C----   Note special requirement if starting with the C film,
C       because the value stored on the generate file is for
C       the A film
C       
              IF (FILM.GT.1) XTOFRA = XTOFRA + 
     $             (THICK+THFOIL(FILM))/DTOFD
              IF (STARTC) XTOFRA = XTOFRA + (THICK+THFOIL(2))/DTOFD
C       
C----   Locate fiducial marks
C       
C----   Do this even when NOFID, so that direct beam (if any)
C       can be located.
C----   Note that if READCC is true CCX,CCY are not updated by
C       the position of the direct beam.
C       DO NOT call fidus for NOFID option
C       if READCC is specified (because CCX,CCY are read from
C       generate file),
C       or if using NOFID option and there is no direct beam.
C       
              IF ( (NFID.EQ.0) .AND. (READCC.OR. (MMDB.EQ.0))) GO TO 80
              NFOUND = 0
C       
C       **********************************
              CALL FIDUS(NFOUND,ITHRESHF,NOFID,READCC)
C       **********************************
C       
 80           OMEGA0 = CCOM * DTOR + OMEGAF
              COSOM0 = COS(OMEGA0)
              SINOM0 = SIN(OMEGA0)
C       
C----   Must transform ccx,ccy before adding to xcenf,ycenf
C       ***** NOT ANY MORE ****
C       AL          CCXS = CCX*COSOM0 - CCY*SINOM0
C       AL          CCYS = CCX*SINOM0 + CCY*COSOM0
              CCXS = CCX
              CCYS = CCY
C       
              XCEN = XCENF + CCXS
              YCEN = YCENF + CCYS
              ICTF = XTOFD*XTOFRA
C       
              IF (DEBUG(1)) THEN
C       
C       
C                ITILT = TILT/FDIST
C                ITWIST = TWIST/FDIST
                CALL SETDIS(ITILT,ITWIST,2)
                IF (IMGP) THEN
                  IROFF = NINT(ROFF)
C       AL                IROFF2 = NINT(ROFF2)
                ELSE
                  IBULGE = BULGE/FDIST
                END IF
C       
C       
                WRITE (IOUT,FMT=6022) ICURR,NREC,IFILM,NFIRSTI,AFILM,
     +               STARTA,STARTB,STARTC,CCX,CCY,CCOM,CBAR,XTOFRA,
     +               YSCAL,IRAS,XCENF,YCENF,XCEN,YCEN
 6022           FORMAT (1X,'ICURR=',I6,'  NREC=',I6,' IFILM=',I3,
     +               ' NFIRSTI=',I3,'  AFILM=',L1,'  STARTA=',L1,
     +               ' STARTB=',L1,' STARTC=',L1,/1X,'CAMERA CONSTANTS',
     +               /1X,'CCX=',I4,' CCY=',I4,' CCOM=',F6.4,' CBAR=',I4,
     +               /1X,'XTOFRA=',F6.4,' YSCAL=',F6.4,/,1X,'IRAS',5I4,
     $               ' XCENF,YCENF',2F8.1,'XCEN,YCEN',2F8.1)
C       
C       
                WRITE (IOUT,FMT=6026) ITILT,ITWIST,IBULGE,
     +                      2.0*ETA/DTOR,2.0*SETA/DTOR
 6026           FORMAT (2X,'ITILT=',I4,' ITWIST=',I4,' IBULGE=',I4,
     +                  '  mosaic',F6.3,' saved mosaic',F6.3)
C       
C       
                IF (ONLINE) THEN
                  WRITE (ITOUT,FMT=6022) ICURR,NREC,IFILM,NFIRSTI,AFILM,
     +                 STARTA,STARTB,STARTC,CCX,CCY,CCOM,CBAR,XTOFRA,
     $                 YSCAL
C       
C       
                  WRITE (ITOUT,FMT=6026) ITILT,ITWIST,IBULGE,
     +                      2.0*ETA/DTOR,2.0*SETA/DTOR
                END IF
              END IF
C       
C----   Check all fiducials have been found, if not go to next pack
C       
              IF ((NFOUND.LT.NFID) .AND. (.NOT.NOFID)) THEN
C       
C----   If this was the firstfilm, change pack number of first good film
C       
                IF (FIRSTFILM) IFIRSTGOOD = IFIRSTGOOD + 1
                BADPACK(IPACK,IFILM) = .TRUE.
                NWRN = NWRN + 1
C       
C       
C----   If this is a multi-segment refinement, abandon it.
C       
                IF (MULTISEG) THEN
                  WRITE(IOUT,FMT=6210)
                  IF (ONLINE) WRITE(ITOUT,FMT=6210)
                  STOP
                END IF
C       
                IF (FIRSTPASS) THEN
                  NERR(IPACK) = 4
                  IXERR(IPACK) = NFOUND
                ELSE
C       
C       ****************************************************
                  CALL SUMMERR(ISUMMR,ID,4,NFPACK(IPACK),NFGEN,FILM,
     +                 NFOUND,X)
C       ****************************************************
C       
                END IF
                GO TO 250
              END IF
C       AL
C----   Generate the reflections for this pack
C       
 85           GWRITE = .TRUE.
              UPDATE = .TRUE.
              NRS = 0
C       
C----   If the spot separation OR raster parameters were not defined
C       by the user, determine appropriate values now from the very first
C       image to be processed.
C       
              IF (IPACK.EQ.IFIRSTP) THEN
                IF ((ISEP.EQ.0).OR.(IRAST.EQ.0)) THEN
                  MODEGSR = 0
                  CALL GETSEPRAS(IRAST,ISEP,IRAS,ID,MINDTX,MINDTY,
     +                 IXSEP,IYSEP,MODEGSR,IERR)
                  IF (IERR.NE.0) THEN
                    NSHUTERR = 4
                    CALL SHUTDOWN(CALLEDFROM,NSHUTERR)
                  END IF
                END IF
              END IF
C     
C----   If using "WIDTH" option, and this is a repeat run for the first
C       BLOCK of NADD images (because of an excessive shift in cell or
C       missetting angle), then pick up the refined missets for each image
C       rather than starting at beginning.
C       Introduce different tests for a MULTISEG run and an integration run
C       that uses a WIDTH.
C       
C       However, do not reassign missets if we are repeating this image
C       
              IF ((MULTISEG.AND.(NREPEAT.GT.0).AND.
     +             (.NOT.FIXED).AND.(.NOT.RPTIMG)).OR.
     +             ((NREPEAT.GT.0).AND.(.NOT.FIXED).AND.
     +             (IPACK.LE.NADD).AND.(.NOT.RPTIMG)))THEN
                ISUB = ISEG
                DO 83 I = 1,3
                  DELPHI(I) = DELPHIV((IPACK-ISUB)*3+I)
                  IF (NEWPREF) DELPHI(I) = RMISSETS(IPACK,I)
 83             CONTINUE
C       
C----   Reset direct beam coords
C       
                XCEN = SVXCEN(IPACK)
                YCEN = SVYCEN(IPACK)
                IF (DEBUG(1)) THEN
                  WRITE(IOUT,FMT=6027) NREPEAT,NADD,IPACK,DELPHI,XCEN,
     +                 YCEN            
                  IF (ONLINE) WRITE(ITOUT,FMT=6027) NREPEAT,NADD,
     +                 IPACK,DELPHI,XCEN,YCEN
                END IF
 6027           FORMAT(1X,'On repeat run number',I3,' over',I5,' ima',
     +               'ges reset the missets and beam coords for pack',
     +               I4,/,1X,'New missets:',3F9.3,'   New XCEN,YCEN',
     $               2F10.2)
              END IF
C
C----   Save detector parameters for use in smoothing. These will (in general)
C       be those for the previous image, or starting values for the first image.
C
              SMTWIST = TWIST
              SMTILT = TILT
              SMROFF = ROFF
              SMTOFF = TOFF
              SMOMEGA0 = ATAN2(SINOM0,COSOM0)
              SMXTOFRA = XTOFRA
              SMYSCAL = YSCAL
C       
C----   Generate the reflection list for this image, unless this is the first
C       image of the second (or subsequent) block of images which has
C       already been generated in order to allow for spatial overlap of
C       summed partials. In this case, FINDPACK will have been called (above).
C       Note that if NEWPREF post refinement is being done, this image will
C       NOT have been generated
C       
              IF ((IPACK.EQ.IFIRSTPACK).AND.(ADDPART.AND.(.NOT.NEWPREF))
     +             .AND.(NUMBLOCK.GT.1)) GOTO 87
C       
              IF (IFILM.EQ.1) THEN
                MODEG = 1
                IF (FILMPLT) MODEG = 2
C       
C----   If this image is only being generated to allow for spatial overlap,
C       must write the generate file even if display option is being used.
C       
                IF (EXTRAIMG.AND.(IPACK.EQ.NPACK)) MODEG = 1
                NADD_STORE = NADD
C       ****************************************
                CALL GENERATE(MODEG,ID,GWRITE,UPDATE,LIMIT,POSTREF,
     +               NEWPREF,NFGEN,LOVERLAP,NFULLF)
C       ****************************************
C       
C----   If this is the very first image to be processed, and there is
C       an insufficient number of fully recorded reflections, set flag
C       to use partials in refinement.
C       
                IF (FIRSTPACK) THEN
                  IF (NSPOT.GT.0) RFP = REAL(NFULL)/REAL(NSPOT)
                  IF (RFP.LT.FULLFRAC) FIXPARTLS = .TRUE.
                  IF (FIXPARTLS) THEN
                    WRITE(IOUT,FMT=6230) FULLFRAC
                    IF (ONLINE) WRITE(ITOUT,FMT=6230) FULLFRAC
                  END IF
 6230             FORMAT(/,/,1X,'***** WARNING *****',/,1X,
     +                 '***** WARNING *****',/,1X,
     +                 '***** WARNING *****',/,1X,
     +                 'Because the fraction of fully recorded ',
     +                 'reflections is less than',F5.2,', partials',
     +                 /,1X,' will be included in the positional ',
     +                 'refinement.',/,1X,'This fraction can be ',
     +                 'reset with keywords REFINE FULLFRAC eg:',/,1X,
     +                 '"REFINE FULLFRAC 0.5" will change it to 0.5')
                  IF (WARN(26).AND.POSTREF.AND..NOT.NEWPREF) THEN
                    WRITE(IOUT,FMT=6360) NPRMIN
                    IF (ONLINE) WRITE(ITOUT,FMT=6360) NPRMIN
                  END IF
 6360             FORMAT(/,1X,1X,'***** WARNING *****',/,1X,
     +                 '***** WARNING *****',/,1X,
     +                 '***** WARNING *****',/,1X,
     +                 'There are fewer than ',I3,
     +                 ' partials extending over only',/,1X,'2 images.',
     +                 'Post-refinement can ONLY be carried out using ',
     +                 'reflections that extend',/,1X,'over 2 images.',
     +                 ' Thus if the mosaic spread (plus beam divereg',
     +                 'ence) is more than',/,1X,'twice the oscillati',
     +                 'on angle, post-refinement is not possible.',/,
     +                 1X,'You may want',' to use a larger oscillatio',
     $                 'n angle.')
                END IF
C       
C----   Store the pack header record number for this image. Note that NFILMS
C       has not yet been incremented, so use NFILMS+1 as pointer
C       
                IPACKSTART(NFILMS+1) = IPACKHEAD
C       
C----   If osc angle not specified, give NWMAX
C       
                IF ((ISTRT.EQ.0).OR.(IANGLE.EQ.0)) THEN
                  WRITE(IOUT,FMT=6031) NWMAX
                  IF (ONLINE) WRITE(ITOUT,FMT=6031) NWMAX
 6031             FORMAT(1X,'Partial reflections spanning more than',
     +                 I3,' images',' will NOT be integrated.',/,1X,
     +                 '(use MAXWIDTH to change but maximum width i',
     $                 's 10 images).')
                END IF
C       
C----   If using ADDPART option, then spatially overlapped reflections occuring
C       at the start of the rotation range must be flagged as spatial overlaps
C       on the previous image. Do this by updating the IR flag in the 
C       generate file for the previous image if NPOVL > 0.
C       Do NOT need to do this if using NEWPREF postrefinement.
C       
                IF (ADDPART.AND.(NPOVL.GT.0).AND.(NFILMS.GT.0)
     +               .AND.(.NOT.NEWPREF)) THEN
                  IF (DEBUG(1)) THEN
                    WRITE(IOUT,FMT=6029) NPOVL,ID,NFILMS
                    IF (ONLINE) WRITE(ITOUT,FMT=6029) NPOVL,ID,NFILMS
 6029               FORMAT(1X,I5,' partial spatial overlaps for image',
     +                   I5,'  NFILMS=',I3)
                  END IF
                  CALL OVERLAP2(IPACKSTART(NFILMS))
                END IF
C       
C----   If this is the "extra" image, jump to end of loop now
C       
                IF (EXTRAIMG.AND.(IPACK.EQ.NPACK)) GOTO 250
C       
C----   If not yet done, store starting cell parameters. These are only
C       calculated after call to GENERATE.
C       
                IF (.NOT.STORCELL) THEN
                  DO 86 I=1,6
                    SCELL(I) = CELL(I)
 86               CONTINUE
                  STORCELL = .TRUE.
                END IF
              END IF
C       
C----   Badstart indicates if the starting residual in refinement
C       was poor. if this is the case, centrs will be repeated,
C       but only once.
C       
 87           BADSTART = .FALSE.
C       
C----   For B and C films, choose refinement spots using intensities
C       measured on the A film
C       This option can be overridden in online version
C       If no fiducials, use CENTRS on B and C films.
C       
              IF (FILM.GT.1 .AND. (.NOT.TREAT_AS_AFILM) .AND.
     +             (.NOT.NOFID)) GO TO 210
C       
              IF (FILMPLT) THEN
C       
                IF (NGR.EQ.7) THEN
                  MODEDISP = 0
C       
C----   ***** Display image prior to refinement
C       
                  imageno = id
                  CALL XDISP(MODEDISP,FIRSTPACK,PACK,IFIRSTPACK,
     +                 FIRSTFILM,GENOPEN)
C       
                  IF (MODEDISP.EQ.99) THEN
C       
C----   Abort current run
C       
                    CALL MRESET(ISEG,RPTFIRST,GENOPEN,COORDOPN)
                    IF (DISPMENU) THEN
                      GOTO 34
                    ELSE
                      GOTO 30
                    END IF
                  END IF
C       
C----   If mosaic spread has changed, store new values
C       
                  IF (FIRSTPACK) THEN
                    SETA = ETA
                    SDIVH = DIVH
                    SDIVV = DIVV
                  END IF
                  IF ((MODEDISP.EQ.1).OR.(MODEDISP.EQ.3)) MATCH = .TRUE.
                END IF
C       
              END IF
C       
C       
C----   Automatic pattern matching option
C       

 88           IF (MATCH) THEN
C       
                ADDPP = ADDP(IPACK)
C       
C       
C       ******************************************************
                CALL AUTOMATCH(ID,DOPROFILE,NSIG,IXSHIFT,IYSHIFT,
     +               NPROFL,LIMIT,SEP,VLIM,FAIL,LIST,USEBOX,
     +               ADDPP,RWEIGHT,PTMIN,
     +               REFREJ,THICK,FIRSTFILM,NUMBLOCK,MOSEST,IERR2)
C       ******************************************************
                prfsum(IFIRSTPACK,1) = DELPHI(1)
                prfsum(IFIRSTPACK,2) = DELPHI(2)
                prfsum(IFIRSTPACK,3) = DELPHI(3)
                DELPHIV(1) = DELPHI(1)
                DELPHIV(2)= DELPHI(2)
                DELPHIV(3) = DELPHI(3)
C       
C----   Don't generate reflection list if refining mosaic spread, or if
C       orientation refinement has failed
C       
                IF (FAIL.OR.RMOSAIC) GO TO 260
                UPDATE = .FALSE.
                GWRITE = .TRUE.
C       
C----   Reposition the generate file to start of first pack
C       NB This assumes AUTOMATCH is only ever run on the FIRST image in
C       the generate file, and not for subsequent images. In principle 
C       there is no reason why it should not be run on every image, but
C       this is not yet implemented
C       
                CALL QSEEK(IUNIT,21,1,36)
                IPACKREC = 21
                IPACKHEAD = IPACKREC
                MODEG = 4
C       
C----   If using X-window display, do not want to write the generate file yet
C       as parameters may be updated.
C       
                IF (FILMPLT) MODEG = 2
C       
C       ****************************************
                CALL GENERATE(MODEG,ID,GWRITE,UPDATE,LIMIT,POSTREF,
     +               NEWPREF,NFGEN,LOVERLAP,NFULLF)
C       ****************************************
C       
                IF (WINOPEN) CALL MXD_FLU(I)
                IF (NOMEAS) GO TO 260
                MATCH = .FALSE.
C       
C----   If at least 10 fully recorded reflections in newly generated
C       reflection list don't bother to call CENTRS again
                IF (NFULLF.GT.10) GO TO 140
              END IF
C       
C----   Find refinement spots in central portion of film
C       cycle through the refinement of central part of film
C       NCYC times (default=2)
C       
C----   If NOFID, select refinement spots for B and C films based on
C       measured intensities of preceeding film for CENTRS.
C       
              GENLIST = (NOFID .AND. (FILM.GT.1))
 90           CONTINUE
C       
              IF (BRIEF) WRITE(IBRIEF,FMT=6206)
 6206         FORMAT(1X,'Refining detector parameters using spots from',
     +             ' centre of image')
C       
C----   Do initial call to set up standard profiles and to RMAXR to
C       calculate box sizes, as these are needed by NEXT. For IP data,
C       only need to do this once, but for film data the position of
C       the direct beam in the digitised image can vary from one
C       pack to the next, so need to set it up for every pack.
C       (Same will be true for IP data from an offline scanner)
C       
              IF (.NOT.IMGP) THEN
                CALL PRSETUP
C       ***********************
                IF (FIRSTFILM) CALL RMAXR(LIMIT,THICK,IERR2)
C       ***********************
              ELSE
                IF (FIRSTFILM.AND.NUMBLOCK.EQ.1) THEN
                  CALL PRSETUP
                  CALL RMAXR(LIMIT,THICK,IERR2)
                  IF ((IERR2.EQ.1).AND.DISPMENU.and.winopen) THEN
                    WRITE(LINE,FMT=6208) IRAS(1),IRAS(2)
 6208               FORMAT('Overall dimensions of measurement box ',
     $                   'reduced to:',2I4)
                    L = LENSTR(LINE)
                    IXP = 400
                    IYP = 400
                    CALL MXD_POP(IXP,IYP, XDLSTR(LINE),L,
     +                   XDLSTR(' '),0,XDLSTR('OK'),2,XDLSTR(' '),
     +                   -1,3,0,IBUTTON)
                  END IF
                  IF (IERR2.EQ.2) THEN
                    IF (DISPMENU) THEN
C       
C----   If running interactively, trap measurement box being too big
C       
                      CALL MRESET(ISEG,RPTFIRST,GENOPEN,COORDOPN)
                      GOTO 34
                    ELSE
                      NSHUTERR = 5
                      CALL SHUTDOWN(CALLEDFROM,NSHUTERR)
                    END IF
                  END IF
                END IF
              END IF
C       
              IF (WINOPEN) CALL MXDBSY(0,'Refining detector parameters')
C       
C----   Initialise RRWEIGHT true if using peak/background mask, else false
C       
              RRWEIGHT = USEBOX
C       
              DO 110 ICYC = 1,NCYC
C       
                IF (WINOPEN) CALL MXD_FLU(I)
C       
                FINAL = (ICYC.EQ.NCYC)
                IF (ONLINE) THEN
C       
                  WRITE (ITOUT,FMT=6028) ICYC
 6028             FORMAT (/1X,'Refinement cycle',I3)    
                END IF
C       
C       
                WRITE (IOUT,FMT=6028) ICYC
C       
C----   In CENTRS, the background definition of the measurement box
C       is not used to determine the centre of gravity (the c of g over
C       the whole measurement box is calculated...this gives a greater
C       range of convergence). in second and subsequent cycles, if the
C       final residual of the previous cycle is less then rmslim
C       (default value 6.0, can be changed by keyword "resid"), use the
C       same list of reflections and s/r 'next' to evaluate the true
C       c of g for these reflections
C       
                IF (RRWEIGHT) THEN
                  OKREF = (WRMSRES.LE.WRMSLIM)
                ELSE
                  OKREF = (RMSRES.LE.RMSLIM)
                END IF
 104            IF (ICYC.EQ.1) OKREF = .FALSE.
C       
                IF ((ICYC.GT.1) .AND. (OKREF)) THEN
C       
C----   For 2nd and subsequent cycles use NEXT if refinement is OK
C       
                  LIST = .TRUE.
C       
C----   Restore original list of reflections from CENTRS so they are 
C       all remeasured by NEXT
C       
                  NRS = NRSOLD
                  DO 106 I = 1,NRS
                    RRS(I) = IRSAVE(I)
 106              CONTINUE
                  IF (USEBOX) THEN
                    WRITE(IOUT,FMT=6100) NRS
                    IF (ONLINE) WRITE(ITOUT,FMT=6100) NRS
 6100               FORMAT(/1X,'Repeating refinement using the same ',
     +                   'list of',I4,' reflections')
                  ELSE
                    IF (ONLINE) WRITE (ITOUT,FMT=6058) NRS
 6058               FORMAT (/1X,'Repeating refinement using the ',
     $                   'same list of',I4,' Reflections and using',/,
     $                   1X,'the peak/background mask')
                    WRITE (IOUT,FMT=6058) NRS
                  END IF
C       
                  CENTRAL = .TRUE.
C       *****************************************************
                  CALL NEXT(LIST,IXSHIFT,IYSHIFT,PRECESS,MATCH,IFAIL,
     +                 PARTLS,ADDPP,CENTRAL)
C       *****************************************************
C       
                  USEWEIGHT = .TRUE.
C       
C----   If not enough reflections now, go back to CENTRS, but only allow
C       this to happen once.
C       
                  IF ((NRS.LT.MINREF).AND.(.NOT.DONEONCE)) THEN
                    MINREFS = MINREF
                    CENTRSRPT = .TRUE.
                    DONEONCE = .TRUE.
                    MINREF = MINREF + MINREF/2
                    OKREF = .FALSE.
                    GOTO 104
                  END IF
C       
                ELSE
C       
C----   otherwise use CENTRS
C       
                  USEWEIGHT = .TRUE.
                  MATCH = .FALSE.
                  PARTLS = .FALSE.
                  OVRLDS = .FALSE.
                  OLDLIST = (ICYC.NE.1)
                  IF (FIXPARTLS) THEN
                    PARTLS = .TRUE.
                    FIXPARTLS = .FALSE.
                  END IF
                  IF (USEPAR) PARTLS = .TRUE.
                  IF (USEOVR) OVRLDS = .TRUE.
                  IF (.NOT.USEBOX) THEN
                    WRITE(IOUT,FMT=6057)
                    IF (ONLINE) WRITE(ITOUT,FMT=6057)
C       
C----   If not using the box, can't get sd's of centroids so refinement
C       must be unweighted
C       
                    USEWEIGHT = .FALSE.
C       
C----   If doing weighted refinement, set RMSLIM high so that on next
C       cycle it will use the peak/background mask and weighted refinement.
C       
                    IF (RWEIGHT) RMSLIM = 100.0
                  END IF
 6057             FORMAT(1X,'The peak/background mask will not be ',
     +                 'used in determining centroids and the',/,1X,
     +                 'refinement will not be weighted')
C       
C----   Set ADDPART flag for this image (will always be false for last
C       image to be measured)
C       
                  ADDPP = ADDP(IPACK)
C       ***************************************************
                  CALL CENTRS(DOPROFILE,NSIG,IXSHIFT,IYSHIFT,NPROFL,
     +                 LIMIT,SEP,VLIM,MATCH,PARTLS,OVRLDS,MINREF,
     +                 OLDLIST,GENLIST,USEBOX,ADDPP,PTMIN)
C       ***************************************************
C       
C----   If this was a repeat of CENTRS because a previous call to NEXT
C       did not find enough reflections, restore MINREF to true value
C       
                  IF (CENTRSRPT) THEN
                    MINREF =  MINREFS
                    CENTRSRPT = .FALSE.
                  END IF
C       
C----   IF this is the first image and PARTLS is true and the user has
C       not explicitly requested inclusion of partials in forming profiles,
C       then set flag for including partials in profile fitting also.
C       
                  IF (PARTLS.AND.FIRSTPACK.AND.(.NOT.ADDPART)
     +                 .AND.(.NOT.PRPART)
     +                 .AND.(.NOT.PRFULLS)) THEN
                    IF (USEPAR) THEN
                      WRITE(IOUT,FMT=6102)
                      IF (ONLINE) WRITE(ITOUT,FMT=6102)
                    ELSE
                      WRITE(IOUT,FMT=6103)
                      IF (ONLINE) WRITE(ITOUT,FMT=6103)
                    END IF
 6102               FORMAT(1X,'***** WARNING *****',/,1X,
     +                   '***** WARNING *****',/,1X,
     +                   '***** WARNING *****',/,1X,
     +                   'Because you have requested inclusion ',
     +                   'of partials in refinement (REFINEMENT',
     +                   ' INCLUDE PARTIALS)',/,1X,'partials wi',
     +                   'll be used in forming the standard pr',
     $                   'ofiles.',/,1X,'This is equivalent to ',
     +                   'including keywords: PROFILE PARTIALS',
     +                   /,1X,'If you do NOT want to include pa',
     +                   'rtials in forming profiles, use keywo',
     +                   'rds:  PROFILE FULLS')
C       
 6103               FORMAT(1X,'***** WARNING *****',/,1X,
     +                   '***** WARNING *****',/,1X,
     +                   '***** WARNING *****',/,1X,
     +                   'Because there are very few fully reco',
     +                   'rded reflections in the central region',
     +                   /,1X,'of the image, partials will be u',
     +                   'sed in forming the standard',/,1X,'pr',
     +                   'ofiles. This is equivalent to includi',
     +                   'ng keywords: PROFILE PARTIALS',/,1X,
     +                   'If you do NOT want to include partial',
     +                   's in forming profiles, use keywords: ',
     +                   ' PROFILE FULLS')
                    PRPART = .TRUE.
                    WTPROFILE = .FALSE.
                    WARN(23) = .TRUE.
                  END IF
C       
C----   Update USEPAR if PARTLS has been set true in CENTRS because not enough
C       fully recorded reflections have been found
C       Set warning flag if use of partials was not requested by user
C       
                  IF (PARTLS.AND.(.NOT.WARN(22).AND.(.NOT.USEPAR))) THEN
                    USEPAR = .TRUE.
                    WARN(22) = .TRUE.
                    IWARN(1,22) = ID
                  END IF
                  NRSOLD = NRS
C       
C----   Save this list of reflections for use in subsequent refinement using
C       NEXT
C       
                  DO 108 I = 1,NRS
                    IRSAVE(I) = RRS(I)
 108              CONTINUE
                END IF
C       
C       
                IF (NRS.GE.MINREF) GO TO 100
                WRITE (IOUT,FMT=6030) NRS
 6030           FORMAT (' Only',I6,' Refinement SPOTS found')
                IF (BRIEF) WRITE (IBRIEF,FMT=6030) NRS
                IF (ONLINE) WRITE (ITOUT,FMT=6030) NRS
C       
C----   if online, do FILMPLOT, otherwise go on to the next pack
C       
                IF (ONLINE) THEN
                  WRITE (ITOUT,FMT=6032)
                  IF (BRIEF) WRITE (IBRIEF,FMT=6032)
 6032             FORMAT (1X,'You may either abandon this image or ',
     +                 'inspect the image',/1X,'Do you want to insp',
     $                 'ect the image (Y/N) ? ',$)
C       
C       **********        
c
c     server interaction modifications ...
                  if(socklo) then
                     yes = .false.
                  else
                     CALL YESNO(YES)
                  end if
C       **********
C       
                  IF (YES) THEN
C       
                    MODEDISP = 0
C       
C----   ***** Display after failure of refinement *****
C       
                    CALL XDISP(MODEDISP,FIRSTPACK,PACK,IFIRSTPACK,
     +                   FIRSTFILM,GENOPEN)
C       
                    IF ((MODEDISP.EQ.1).OR.(MODEDISP.EQ.3)) THEN
                      MATCH = .TRUE.
                      GOTO 88
                    ELSE IF (MODEDISP.EQ.99) THEN
C       
C----   Abort current run
C       
                      CALL MRESET(ISEG,RPTFIRST,GENOPEN,COORDOPN)
                      IF (DISPMENU) THEN
                        GOTO 34
                      ELSE
                        GOTO 30
                      END IF
                    END IF
C       
C       
C----   Repeat CENTRS for adjusted pattern
C       
                    GO TO 90
                  END IF
                ELSE
                  IF (LIST) THEN
                    WRITE(IOUT,FMT=6033)
 6033               FORMAT(1X,'If there were only just over 20 refl',
     +                   'ections in the list, try increasing LIMIT',
     $                   'or',/,1X,'decreasing',
     +                   ' NSIG on the REFINEMENT keyword',/,1X,
     +                   '*****  ABANDONING PROCESSING, going on to',
     +                   ' next pack *****',//)
                  ELSE
                    WARN(4) = .TRUE.
                    WRITE (IOUT,FMT=6034)
 6034               FORMAT (///1X,'The failure to find at least 20 ',
     +                   'spots almost certainly means that there i',
     $                   's an',/,1X,'error in either the camera con',
     +                   'stants or the predicted pattern',/,1X,'for ',
     +                   'this image'/,1X,'You are strongly advised',
     +                   ' to use the graphical display option to s',
     +                   'ee what ',/,1X,'is wrong',/,1X,
     +                   '*****  ABANDONING PROCESSING, going on to',
     +                   ' next pack *****',//)
                  END IF
                END IF
C       
C----   If this was the firstfilm, change pack number of first good film
C       
                IF (FIRSTFILM) IFIRSTGOOD = IFIRSTGOOD + 1
                BADPACK(IPACK,IFILM) = .TRUE.
                NWRN = NWRN + 1
C       
C       
C----   If this is a multi-segment refinement, abandon it.
C       
                IF (MULTISEG) THEN
                  WRITE(IOUT,FMT=6212)
                  IF (ONLINE) WRITE(ITOUT,FMT=6212)
 6212             FORMAT(//1X,' A multisegment post-refinement will ',
     +                 'NOT work if images have been rejected',/,1X,
     $                 'Use the interactive graphics to find out why',
     $                 ' the positional',
     +                 /,1X,'residual is so high for this image.')
                  STOP
                END IF
C       
                IF (FIRSTPASS) THEN
                  NERR(IPACK) = 5
                  IXERR(IPACK) = NRS
                ELSE
C       
C       ***************************************************
                  CALL SUMMERR(ISUMMR,ID,5,NFPACK(IPACK),NFGEN,FILM,
     $                 NRS,X)
C       ***************************************************
C       
                END IF
C       
C       
                GO TO 250
C       
C----   REFINEMENT
C       ==========
C       
 100            CONTINUE
                IF (.NOT.NOREF) THEN
C       
C----   In CENTRS, only spots within 'LIMIT' 10 micron units (default 25mm)
C       of film centre are used
C       These limits can be changed by keywords 'limit'
C       in centrs if all central reflections are overloads.
C       
                   CENTRE = .TRUE.
                   XMLONLY = .FALSE.
C       
C       
C       
C       
                   RRWEIGHT = (RWEIGHT.AND.USEWEIGHT)
C       
C       ******************************************
                   CALL RDIST(IPACK,ID,NIMGSM,CENTRE,FINAL,WELIMIT,
     +                  ELIMIT,ELIMIT2,ELIMIT3,BADSTART,RRWEIGHT,
     +                  REFREJ,XMLONLY)
C       ******************************************
C     
                   CENTRE = .FALSE.
                ENDIF
C       
C----   End of loop over refinement cycles
C       
 110         CONTINUE
C       
              IF (RWEIGHT) THEN 
                IF (WRMSRES.LT.WRMSLIM) GO TO 130
              ELSE
                IF (RMSRES.LT.RMSLIM) GO TO 130
              END IF
C
C---- Positional residual exceeds limit. If running interactively,
C     give user possible options (abort or continue with limits reset).
C     If running with new gui, take no action, as options will be given
C     explicitly by the GUI.
C
              IF (SOCKLO) THEN
                LONGLINE = ' '
 7300           FORMAT('<?xml version="1.0"?>',
     $               '<!DOCTYPE refinement_error>',
     $               '<refinement_error>',
     $               '<status>',
     $               '<code>ok</code>',
     $               '</status>',
     $               '<type>weighted_residual</type>',
     $               '<image_name>',A,'</image_name>',
     $               '<absolute_rms_residual>',F8.3,
     $               '</absolute_rms_residual>',
     $               '<absolute_rms_residual_limit>',F8.3,
     $               '</absolute_rms_residual_limit>',
     $               '<weighted_rms_residual>',F7.2,
     $               '</weighted_rms_residual>',
     $               '<weighted_rms_residual_limit>',F7.2,
     $               '</weighted_rms_residual_limit>',
     $               '</refinement_error>')
                WRITE(LONGLINE,FMT=7300)SHORTFN(1:LENSTR(SHORTFN)),
     $               RMSRES,RMSLIM,WRMSRES,WRMSLIM
                CALL WRITE_SOCKET_LENGTH(SERVERFD,
     $               LENSTR(LONGLINE),LONGLINE)
                GOTO 130
              ENDIF
C
              IF (ONLINE) THEN
                IF (WINOPEN) THEN
                  IXM = 200
                  IYM = 200
                  LINELEN = 75
                  NUMLIN = 9
C       
C       Create IO window
C       
                  CALL MXDCIO(0,LINELEN, NUMLIN, IXM,IYM)
                  LINE = ' '
                  WRITE(LINE,FMT=6320) WRMSRES
 6320             FORMAT('Final weighted residual (',F4.1,') is too ',
     $                 'large.')
                  CALL MXDWIO(LINE,1)
                  LINE = ' '
                  WRITE(LINE,FMT=6322) WRMSLIM
 6322             FORMAT('(Maximum is',F5.1,' set by subkeyword RESID',
     +                 ' of keyword REFINEMENT)')
                  CALL MXDWIO(LINE,1)
                  LINE = ' '
                  WRITE(LINE,FMT=6324)
 6324             FORMAT('You can either reset the maximum value and ',
     +                 'continue or abort processing.')
                  CALL MXDWIO(LINE,1)
                  LINE = ' '
 112              WRITE(LINE,FMT=6326)
 6326             FORMAT('Do you want reset the maximum residual (Y):')
                  CALL MXDWIO(LINE, 1)
                  CALL MXDRIO(LINE2)
C       
C----   Parse reply
C       
C       ******************************************
                  CALL MPARSE(LINE2,IBEG,IEND,ITYP,VALUE,IDEC,NTOK)
C       ******************************************
                  IF (NTOK.EQ.0) THEN
                    STR1 = 'Y'
                  ELSE
                    STR1 = LINE2(IBEG(1):IEND(1))
                    CALL CCPUPC(STR1)
                  END IF
                  IF (STR1.EQ.'Y') THEN
C       
C----   Get max residual
C       
                    LINE = ' '
                    WRMSLIM = 100.0
 114                WRITE (LINE, 6328) WRMSLIM
 6328               FORMAT(1X,'New maximum residual (',F6.1,') :')
                    CALL MXDWIO(LINE, 0)
                    CALL MXDRIO(LINE2)
C       
C----   Get numbers using PARSER
C       
C       ******************************************
                    CALL MPARSE(LINE2,IBEG,IEND,ITYP,VALUE,IDEC,NTOK)
C       ******************************************
                    IF (NTOK.EQ.0) THEN
                      CONTINUE
                    ELSE 
                      CALL MKEYNM(1,1,LINE2,IBEG,IEND,ITYP,NTOK)
                      IF (IOERR) GOTO 114
                      WRMSLIM = VALUE(1)
                    END IF
                    RMSLIM = WRMSLIM
                    ELIMIT = WRMSLIM
                    ELIMIT2 = WRMSLIM
                    ELIMIT3 = WRMSLIM
                    CALL MXDCIO(1,0,0,0,0)
                    GOTO 130
                  ELSE
C       
C----   Do NOT want to reset max residual
C       
                    LINE = ' '
                    WRITE(LINE,FMT=6340)
 6340               FORMAT('Do you want abandon processing (Y):')
                    CALL MXDWIO(LINE, 1)
                    CALL MXDRIO(LINE2)
C       
C----   Parse reply
C       
C       ******************************************
                    CALL MPARSE(LINE2,IBEG,IEND,ITYP,VALUE,IDEC,NTOK)
C       ******************************************
                    IF (NTOK.EQ.0) THEN
                      STR1 = 'Y'
                    ELSE
                      STR1 = LINE2(IBEG(1):IEND(1))
                      CALL CCPUPC(STR1)
                    END IF
                    IF (STR1.EQ.'Y') THEN
C       
C---    ABANDON
C       

                      CALL MRESET(ISEG,RPTFIRST,GENOPEN,COORDOPN)
                      CALL MXDCIO(1,0,0,0,0)
                      IF (DISPMENU) THEN
                        GOTO 34
                      ELSE
                        GOTO 30
                      END IF
                    ELSE
C       
C----   Repeat query
C       
                      GOTO 112
                    END IF
                  END IF
C       
C       

                ELSE
C       
C----   This block if NOT WINOPEN
C       
                  IF (RWEIGHT) THEN
                    WRITE (ITOUT,FMT=6037) WRMSLIM
                    IF (BRIEF) WRITE (IBRIEF,FMT=6037) WRMSLIM
                  ELSE
                    WRITE (ITOUT,FMT=6036) RMSLIM
                    IF (BRIEF) WRITE (IBRIEF,FMT=6036) RMSLIM
                  END IF
 6036             FORMAT (1X,'Final  residual too large',/,1X,'(Max',
     +                 'imum ',F4.1,' defined by subkeyword RESID o',
     +                 'f REFINEMENT keyword)',/1X,'Do you want to ',
     +                 'do more cycles of refinement (Y/N) ?',$)
 6037             FORMAT (1X,'Final weighted residual too large',/,
     +                 1X,'(Maximum ',F4.1,' defined by subkeyword ',
     $                 'RESID of REFINEMENT keyword)',/1X,
     +                 'Do you want to do more cycles of refinement',
     $                 ' (Y/N) ?',$)
C       
C       **********
c     "NOSTOP" option.

                  if (nostop) then
                     yes = .false.
                  else
                     CALL YESNO(YES)
                  end if
C       **********
C       
                  IF (YES) GO TO 90
                  WRITE (ITOUT,FMT=6038)
                  IF (BRIEF) WRITE (IBRIEF,FMT=6038)
 6038             FORMAT (1X,'Do you want to inspect the image (Y/N)',
     $                 '? ',$)
C       
C       **********
c       "NOSTOP" option.
                  if (nostop) then
                     yes = .false.
                  else
                     CALL YESNO(YES)
                  end if
C       **********
C       

                  

                  IF (YES) THEN
C       
                    MODEDISP = 0
                    CALL XDISP(MODEDISP,FIRSTPACK,PACK,IFIRSTPACK,
     +                   FIRSTFILM,GENOPEN)
                    IF (MODEDISP.EQ.99) THEN
C       
C----   Abort current run
C       
                      CALL MRESET(ISEG,RPTFIRST,GENOPEN,COORDOPN)
                      IF (DISPMENU) THEN
                        GOTO 34
                      ELSE
                        GOTO 30
                      END IF
                    END IF
C       
C       
C----   Repeat CENTRS for adjusted pattern
C       
                    GO TO 90
                  END IF
                  WRITE (ITOUT,FMT=6040)
                  IF (BRIEF) WRITE (IBRIEF,FMT=6040)
 6040             FORMAT (1X,'You may either abandon this image or car',
     $                 'ry on',/1X,'Do you want to carry on (Y/N) ? ',$)
C       
C       **********
c     "NOSTOP" option.
                  if (nostop) then
                     yes = .true.
                  else
                     CALL YESNO(YES)
                  end if
C       **********
C       
                  IF (YES) THEN
                    RMSLIM = 100.0
                    WRMSLIM = 100.0
                    ELIMIT = 100.0
                    ELIMIT2 = 100.0
                    ELIMIT3 = 100.0
                    WRITE (ITOUT,FMT=6042)
                    IF (BRIEF) WRITE (IBRIEF,FMT=6042)
 6042               FORMAT (/1X,'** WARNING, All RMS residual limits ',
     $                   'set to 100.0 to continue',
     +                   /1X,'**They will not be RESET**')
                    GO TO 130
                  END IF
C       
C----   End of IF (WINOPEN) block
                END IF

C       
C----   If in batch mode
C       

              ELSE
                IF (RWEIGHT) THEN
                  WRITE (IOUT,FMT=6045) WRMSRES,WRMSLIM
 6045             FORMAT (//1X,'The FINAL weighted residual of',F6.1,
     +                 ' is greater than the maximum allowed (',
     $                 F4.1,')',/1X,'(Defined by ',
     +                 'RESID keyword on REFINEMENT card)',/1X,
     +                 'Going on to next image')
                ELSE
                  WRITE (IOUT,FMT=6044) RMSRES,RMSLIM
 6044             FORMAT (//1X,'The FINAL refined residual of',F6.1,
     $                 ' is greater than the maximum allowed (',F4.1,
     $                 ')',/1X,'(Defined by ',
     +                 'RESID keyword on REFINEMENT card)',/1X,
     +                 'Going on to next image')
                END IF
              END IF
C       
C----   If this was the firstfilm, change pack number of first good film
C       
              IF (FIRSTFILM) IFIRSTGOOD = IFIRSTGOOD + 1
              BADPACK(IPACK,IFILM) = .TRUE.
              NWRN = NWRN + 1
C       
C       
C----   If this is a multi-segment refinement, abandon it.
C       
              IF (MULTISEG) THEN
                WRITE(IOUT,FMT=6212)
                IF (ONLINE) WRITE(ITOUT,FMT=6212)
                STOP
              END IF
C       
              IF (FIRSTPASS) THEN
                NERR(IPACK) = 6
                XERR(IPACK) = RMSRES
              ELSE
C       
C       *******************************************************
                CALL SUMMERR(ISUMMR,ID,6,NFPACK(IPACK),NFGEN,FILM,IX,
     $               RMSRES)
C       *******************************************************
C       
              END IF
C       
C       
              GO TO 250
C       
C----   if centrs has already been repeated due to poor initial residual
C       do not allow a second repeat.
C       
 130          CONTINUE
              IF (BADSTART) GO TO 140
              IF (RWEIGHT) THEN
                BADSTART = (WESTART.GT.WELIMIT)
              ELSE
                BADSTART = (ESTART.GT.ELIMIT)
              END IF
C       
C----   Repeat centrs if initial residual high
C       
              IF (BADSTART) THEN
                IF (RWEIGHT) THEN
                  XLIMIT = WELIMIT
                ELSE
                  XLIMIT = ELIMIT
                END IF
                WRITE (IOUT,FMT=6046) XLIMIT
 6046           FORMAT (/1X,'Repeat refinement because INITIAL RESID',
     $               'UAL is greater than ',F5.1)
                IF (ONLINE) WRITE (ITOUT,FMT=6046) XLIMIT
                GO TO 90
              END IF
C       
 140          IF ((.NOT.AVPROFILE).OR.(NOREF)) GO TO 170
C       
C       
              DOPROFILE = .TRUE.
              NRSOLD = NRS
C       
C----   Repeat centrs to accumulate average spot profile
C       
 150          IF (ONLINE) WRITE (ITOUT,FMT=6048)
 6048         FORMAT (1X,'Accumulating spots for SPOT PROFILE')
              MATCH = .FALSE.
              PARTLS = .FALSE.            
              OVRLDS = .FALSE.
              MINREFAV = 3
              IF (MINREF.EQ.0) MINREFAV = 0
              OLDLIST = .FALSE.
              IF (USEPAR) PARTLS = .TRUE.
              IF (USEOVR) OVRLDS = .TRUE.
C       
C----   Set ADDPART flag for this image (will always be false for last
C       image to be measured)
C       
              ADDPP = ADDP(IPACK)
C       
C       ********************************************************
              CALL CENTRS(DOPROFILE,NSIG,IXSHIFT,IYSHIFT,NPROFL,LIMIT,
     +             SEP,VLIM,MATCH,PARTLS,OVRLDS,MINREFAV,OLDLIST,
     +             GENLIST,USEBOX,ADDPP,PTMIN)
C       ********************************************************
C       
C----   Check on measurement box dimensions by displaying average
C       spot profile
C       
              IF (NPROFL.GT.0) THEN
C       
C       *****************************************************
                CALL CHKRAS(ID,AVPROFILE,MAXR,FIRSTFILM,FILM,FINAL,
     +                      NUMBLOCK)
C       *****************************************************
C       
              ELSE
                AVPROFILE = .FALSE.
              END IF
C       
              NRS = NRSOLD
C       
C----   AVPROFILE is updated in CHKRAS and set false if running
C       in batch mode or if the measurement box is not to be
C       changed
C       
              IF (AVPROFILE) GO TO 150
C       
C----   if the "FINDCC" option has been set (used to determine
C       camera constants using FILMPLOT and write them back
C       to generate file without going on to measure the film)
C       then do that here
C       
 170          IF (FINDCC) THEN
                MODEWR = 3
                IF (NOFID) MODEWR = 2 + FILM
C       
                ADDPP = ADDP(IPACK)
C       
C       ****************************
                CALL WRGEN(MODEWR,PROFILE,ADDPP)
C       ****************************
C       
                MODEWR = 0
                WRITE (ITOUT,FMT=6050)
 6050           FORMAT (/1X,'Refined camera constants and distortion',
     +               ' parameters written to generate file')
C       
C----   For NOFID option, need to write separate CCX,CCY
C       for each film in pack
C       
                IF (NOFID) GO TO 240
                GO TO 250
              END IF
C       
C       
C----   For NOFID option and B or C film, goto NEXT to refine whole film
C       
              IF (NOFID .AND. (FILM.GT.1)) GO TO 210
C       
C----   Recalculate the box sizes, as size of measurement box may have
C       changed in CHKRAS
C       
C       ***********************
C       ***********************
              IF (FIRSTFILM) THEN
                CALL RMAXR(LIMIT,THICK,IERR2)
C       ***********************
                IF ((IERR2.EQ.1).AND.DISPMENU.and.winopen) THEN
                  WRITE(LINE,FMT=6208) IRAS(1),IRAS(2)
                  L = LENSTR(LINE)
                  IXP = 400
                  IYP = 400
                  CALL MXD_POP(IXP,IYP, XDLSTR(LINE),L,
     +                 XDLSTR(' '),0,XDLSTR('OK'),2,XDLSTR(' '),
     +                 -1,3,0,IBUTTON)
                END IF
                IF (IERR2.EQ.2) THEN
                  IF (DISPMENU) THEN
C       
C----   If running interactively, trap measurement box being too big
C       
                    CALL MRESET(ISEG,RPTFIRST,GENOPEN,COORDOPN)
                    GOTO 34
                  ELSE
                    NSHUTERR = 6
                    CALL SHUTDOWN(CALLEDFROM,NSHUTERR)
                  END IF
                END IF
              END IF
C       
C----   Go straight to gensort if not refining (NOREF)
C       
              IF (NOREF) GOTO 224
C       
C----   select 20 refinement spots from centrs prior to choosing
C       spots for refinement from the outside of the film
C       
C       ***********
              CALL MSELECT
C       ***********
C       
C----   If not already done in central refinement area, find true
C       centre of gravity for selected 20 spots. Skip this if
C       NOREF is true
C       
              IF (.NOT.LIST) THEN
                LIST = .TRUE.
                CENTRAL = .TRUE.
C       
C       *****************************************************
                CALL NEXT(LIST,IXSHIFT,IYSHIFT,PRECESS,MATCH,IFAIL,
     +               PARTLS,ADDPP,CENTRAL)
C       *****************************************************
C       
              END IF
C       
C----   Sort fully recorded spots from generate file on scanner
C       coordinates prior to selection of refinement spots. Limits
C       reflections to area outside that used in 'centrs' (ie defined
C       by 'limit')
C       
C----   If partials are to be used in SEEKRS, set MODE to 3
C       
              MODE = 0
              IF (USEPAR) MODE = 3
C       
              IF (WINOPEN) CALL MXD_FLU(I)
C       ****************************************************
              CALL GENSORT(MODE,FORCE,LIMIT,VLIM,NMR,ADDPP,PTMIN,LAST)
C       ****************************************************
C       
              FORCE = .FALSE.
C       
C----   Test for no spots found in gensort, mode set to 999
C       Go straight on to measurement.               
              IF (MODE.EQ.999) THEN
                WRITE(IOUT,FMT=6051)
                IF (ONLINE) WRITE(ITOUT,FMT=6051)
 6051           FORMAT(1X,'No spots found outside central region of',
     +               ' image',/,1X,'(defined by REFINEMENT LIMIT key',
     +               'word) no additional refinement will be performed')
C
C---- Write residual to XDL average spot profile window
C
                IF (WINOPEN.AND.DISP_IO3) THEN
                  WRITE(LINE,FMT=6053) 0.01*RMSRES,WRMSRES
 6053             FORMAT('Rms residual',F6.2,'mm, weighted residual',
     +                 F6.1)
                  CALL MXDWIO(LINE,22)
                END IF        
C
C---- Need to write XML for positional refinement (normally done after
C     refinement over whole image).
C
                IF (SOCKLO.AND..NOT.XMLOPEN) THEN
                  XMLONLY = .TRUE.
C       
C       
C       
C       ******************************************
                  CALL RDIST(IPACK,ID,NIMGSM,CENTRE,FINAL,WELIMIT,
     +               ELIMIT,ELIMIT2,ELIMIT3,BADSTART,RWEIGHT,REFREJ,
     +               XMLONLY)
C       ******************************************
C
C---- NB Special case where no spots for refinement in outer region of detector
C     For new GUI, at this point, xml for positional refinement has just
C     been written (from RDIST) and MOSFLM needs to read from socket to see
C     if user has requested display of image, predictions or an abort.
C
 188              CONTINUE
                  CALL READ_SOCKET(SERVERFD,LINE400,IFAIL)
CAL                 read(5,fmt=8888) LINE
CAL 8888            format(a)
                  CALL MPARSE(LINE400,IBEG,IEND,ITYP,VALUE,IDEC,NTOK)
                  KEY6 = LINE400(IBEG(1):IEND(1))
C
                  DO I = 1, NTOK
                     ARGV(I) = LINE400(IBEG(I):IEND(I))
                  END DO
C
C---- 'continue'  continue processing
C
                  IF (KEY6(1:4).EQ.'cont') THEN
                    GOTO 200
C       
C----   'abort' ...  Abort current run
C       
                  ELSE IF (KEY6(1:5).EQ.'abort') THEN
                     CALL MRESET(ISEG,RPTFIRST,GENOPEN,COORDOPN)
                     GOTO 30
C
C----    'create_grey_image' ..Create a jpeg and send to GUI
C
                  ELSE IF (KEY6.EQ.'create') THEN
c                    CALL CREATE_GREY_IMAGE(NTOK, ARGV, ITYP, VALUE,IERR) 
C
C---- HRP once complete, CREATE_IMAGE will replace CREATE_GREY_IMAGE - 26.09.2008
                    NTOK = NTOK + 1
                    ARGV(NTOK) = 'COLOURS'
                    ITYP(NTOK) = 2
                    VALUE(NTOK) = 1
                    CALL CREATE_IMAGE(NTOK, ARGV, ITYP, VALUE,IERR)  
C
C----    'predict' ... Create a list of predictions for GUI
C
                  ELSE IF (KEY6.EQ.'predic') THEN
                    PRDFLAG = 1
                    CALL PREDICT_SPOTS(NTOK, ARGV, ITYP, VALUE,
     +                                 PRDFLAG, IERR)
                  END IF
                  GOTO 188
                END IF
C       
C----   Save the direct beam coords, in case this is a multi-segment
C       post refinement, or if a POSTREF WIDTH run which might be repeated
C       because of a large cell shift
C       
                IF (IPACK.LE.NIMAX) THEN
                  SVXCEN(IPACK) = XCEN
                  SVYCEN(IPACK) = YCEN
                END IF
                GOTO 224
              END IF
C       
C----   Search for refinement spots over whole of film
C       
              NRSOLD = NRS
              BADSTART = .FALSE.
              NRS = NRSOLD
              IF (BRIEF) WRITE (IBRIEF,FMT=6052)
              IF (ONLINE) WRITE (ITOUT,FMT=6052)
 6052         FORMAT (/1X,'Refinement using reflections over entire',
     $             ' image',/)
              WRITE (IOUT,FMT=6052)
              OVRLDS = .FALSE.
              IF (USEOVR) OVRLDS = .TRUE.
C       
              IF (WINOPEN) CALL MXD_FLU(I)
C       ********************************************
              CALL SEEKRS(IRFMIN,IRFINC,IXSHIFT,IYSHIFT,OVRLDS,
     +             ADDPP)
C       ********************************************
              IF (WINOPEN) CALL MXD_FLU(I)
C       
              FINAL = .FALSE.
              XMLONLY = .FALSE.
C       
C       
C       
C       ******************************************
 190          CONTINUE
              CALL RDIST(IPACK,ID,NIMGSM,CENTRE,FINAL,WELIMIT,
     +             ELIMIT,ELIMIT2,ELIMIT3,BADSTART,RWEIGHT,REFREJ,
     +             XMLONLY)
C       ******************************************
C       
C---- For new GUI, at this point, xml for positional refinement has just
C     been written (from RDIST) and MOSFLM needs to read from socket to see
C     if user has requested image display, prediction display, or an abort.
C
              IF (SOCKLO.AND..NOT.XMLOPEN) THEN
                NODISPLAY = .TRUE.
 192            CALL READ_SOCKET(SERVERFD,LINE400,IFAIL)
C     ..
Chrp 05.10.2009 should do something sensible if EOF on read
                IF(IFAIL.LT.0)GOTO 200
CAL                 read(5,fmt=8888) LINE
                 CALL MPARSE(LINE400,IBEG,IEND,ITYP,VALUE,IDEC,NTOK)
                if(ntok.gt.0)KEY6 = LINE400(IBEG(1):IEND(1))
C
                DO I = 1, NTOK
                   ARGV(I) = LINE400(IBEG(I):IEND(I))
                END DO
C
C---- 'continue'  continue processing
C
                IF (KEY6(1:4).EQ.'cont') THEN
                  GOTO 200
C       
C----   'abort' ...  Abort current run
C       
                ELSE IF (KEY6(1:5).EQ.'abort') THEN
                   CALL MRESET(ISEG,RPTFIRST,GENOPEN,COORDOPN)
                   GOTO 30
C
C----    'create_grey_image' ..Create a jpeg and send to GUI
C
                ELSE IF (KEY6.EQ.'create') THEN
c                    CALL CREATE_GREY_IMAGE(NTOK, ARGV, ITYP, VALUE,IERR) 
C
C---- HRP once complete, CREATE_IMAGE will replace CREATE_GREY_IMAGE - 26.09.2008
                  NTOK = NTOK + 1
                  ARGV(NTOK) = 'COLOURS'
                  ITYP(NTOK) = 2
                  VALUE(NTOK) = 1
                  CALL CREATE_IMAGE(NTOK, ARGV, ITYP, VALUE,IERR) 
C
C----    'predict' ... Create a list of predictions for GUI
C
                ELSE IF (KEY6.EQ.'predic') THEN
c                  write(iout,*)'NSPOT is : ',nspot
c                  do i=1,60
c                    write(iout,*)'before: ',i,xg(i),yg(i)
c                  enddo
                  PRDFLAG = 1
                  CALL PREDICT_SPOTS(NTOK, ARGV, ITYP, VALUE,
     +                                 PRDFLAG, IERR)
c                  write(iout,*)'NSPOT is : ',nspot
cc                  do i=1,60
c                    write(iout,*)'after: ',i,xg(i),yg(i)
c                  enddo
                END IF
                GOTO 192
              END IF
C       
C----   Only allow one repeat due to poor
C       
 200          CONTINUE
              IF (BADSTART) GO TO 220
C       
C----   Repeat refinement if either initial or final residuals too high
C       
              IF (RWEIGHT) THEN
                BADSTART = ((WESTART.GT.WELIMIT).OR.
     $               (WRMSRES.GT.WELIMIT))
              ELSE
                BADSTART = ((ESTART.GT.ELIMIT2) .OR. 
     $               (RMSRES.GT.ELIMIT3))
              END IF
              IF (BADSTART) THEN
C       
C----   Repeat refinement using 'next' and existing list of reflections
C       
                IF (RWEIGHT) THEN
                  IF (ONLINE) WRITE (ITOUT,FMT=6060) WELIMIT
 6060             FORMAT(/1X,'Repeat refinement because initial or ',
     +                 'final residual is greater than ',F5.1)
                  WRITE (IOUT,FMT=6060) WELIMIT
                ELSE
                  IF (ONLINE) WRITE (ITOUT,FMT=6055) ELIMIT2,ELIMIT3
 6055             FORMAT(/1X,'Repeat refinement because initial resi',
     +                 'dual is greater than ',F5.1,' or final resid',
     $                 'ual greater than ',F5.1)
                  WRITE (IOUT,FMT=6055) ELIMIT2,ELIMIT3
                END IF
                LIST = .TRUE.
                CENTRAL = .FALSE.
                IF(SOCKLO)THEN
                  LONGLINE = ' '
 7000             FORMAT('<?xml version="1.0"?>',
     $                 '<!DOCTYPE refinement_repeat SYSTEM "">',
     $                 '<refinement_repeat>',
     $                 '<status>',
     $                 '<code>ok</code>',
     $                 '</status>',
     $                 '<image_name>',A,'</image_name>',
     $                 '</refinement_repeat>')
                  WRITE(LONGLINE,FMT=7000)SHORTFN(1:LENSTR(SHORTFN))
                  CALL WRITE_SOCKET_LENGTH(SERVERFD,
     $                 LENSTR(LONGLINE),LONGLINE)
                ENDIF
C       
C       *****************************************************
                CALL NEXT(LIST,IXSHIFT,IYSHIFT,PRECESS,MATCH,IFAIL,
     +               PARTLS,ADDPP,CENTRAL)
C       *****************************************************
C       
C----   Repeat refinement using new spot positions from next
C       
                GO TO 190
              END IF
C       
              GO TO 220
C       
C----   Measure refinement spots on 'B' or 'C' film in a pack
C       
C       ***********************
 210          IF (FIRSTFILM) CALL RMAXR(LIMIT,THICK,IERR2)
C       ***********************
C       
              LIST = .FALSE.
              IF (USEPAR) PARTLS = .TRUE.
              CENTRAL = .FALSE.
C       
C       *****************************************************
              CALL NEXT(LIST,IXSHIFT,IYSHIFT,PRECESS,MATCH,IFAIL,
     +             PARTLS,ADDPP,CENTRAL)
C       *****************************************************
C       
              PARTLS = .FALSE.
C       
C----   If insufficient refinement spots found go on to next pack
C       
              IF (IFAIL.LT.0) THEN
C       
C       **************************************************
                CALL SUMMERR(ISUMMR,ID,7,NFPACK(IPACK),NFGEN,FILM,IX,X)
C       **************************************************
C       
                GO TO 250
              END IF
C       
C       
              IF (ONLINE) WRITE (ITOUT,FMT=6052)
              WRITE (IOUT,FMT=6052)
              XMLONLY = .FALSE.
C       
C       
C       ******************************************
              CALL RDIST(IPACK,ID,NIMGSM,CENTRE,FINAL,WELIMIT,
     +             ELIMIT,ELIMIT2,ELIMIT3,BADSTART,RWEIGHT,REFREJ,
     +             XMLONLY)
C       ******************************************
C       
C----   Only allow one repeat
C       
              IF (BADSTART) GO TO 220
              IF (RWEIGHT) THEN
                BADSTART = ((WESTART.GT.WELIMIT).OR.
     $               (WRMSRES.GT.WELIMIT))
              ELSE
                BADSTART = ((ESTART.GT.ELIMIT2) .OR. 
     $               (RMSRES.GT.ELIMIT3))
              END IF
              IF (BADSTART) GO TO 210
C       
C       
 220          CONTINUE
C       
C----   Save the direct beam coords, in case this is a multi-segment
C       post refinement, or if a POSTREF WIDTH run which might be repeated
C       because of a large cell shift
C       
              IF (IPACK.LE.NIMAX) THEN
                SVXCEN(IPACK) = XCEN
                SVYCEN(IPACK) = YCEN
              END IF
C       
C----   Test final residual
C       
              IF (RWEIGHT) THEN
                OKREF = (WRMSRES.LE.WRMSLIM)
              ELSE
                OKREF = (RMSRES.LE.RMSLIM)
              END IF
              IF (.NOT.OKREF) THEN
                IF (WINOPEN) THEN


                  IXM = 200
                  IYM = 200
                  LINELEN = 75
                  NUMLIN = 9
C       
C       Create IO window
C       
                  CALL MXDCIO(0,LINELEN, NUMLIN, IXM,IYM)
                  LINE = ' '
                  WRITE(LINE,FMT=6320) WRMSRES
                  CALL MXDWIO(LINE,1)
                  LINE = ' '
                  WRITE(LINE,FMT=6322) WRMSLIM
                  CALL MXDWIO(LINE,1)
                  LINE = ' '
                  WRITE(LINE,FMT=6324)
                  CALL MXDWIO(LINE,1)
                  LINE = ' '
 212              WRITE(LINE,FMT=6326)
                  CALL MXDWIO(LINE, 1)
                  CALL MXDRIO(LINE2)
C       
C----   Parse reply
C       
C       ******************************************
                  CALL MPARSE(LINE2,IBEG,IEND,ITYP,VALUE,IDEC,NTOK)
C       ******************************************
                  IF (NTOK.EQ.0) THEN
                    STR1 = 'Y'
                  ELSE
                    STR1 = LINE2(IBEG(1):IEND(1))
                    CALL CCPUPC(STR1)
                  END IF
                  IF (STR1.EQ.'Y') THEN
C       
C----   Get max residual
C       
                    LINE = ' '
                    WRMSLIM = 100.0
 214                WRITE (LINE, 6328) WRMSLIM
                    CALL MXDWIO(LINE, 0)
                    CALL MXDRIO(LINE2)
C       
C----   Get numbers using PARSER
C       
C       ******************************************
                    CALL MPARSE(LINE2,IBEG,IEND,ITYP,VALUE,IDEC,NTOK)
C       ******************************************
                    IF (NTOK.EQ.0) THEN
                      CONTINUE
                    ELSE 
                      CALL MKEYNM(1,1,LINE2,IBEG,IEND,ITYP,NTOK)
                      IF (IOERR) GOTO 214
                      WRMSLIM = VALUE(1)
                    END IF
                    RMSLIM = WRMSLIM
                    ELIMIT = WRMSLIM
                    ELIMIT2 = WRMSLIM
                    ELIMIT3 = WRMSLIM
                    CALL MXDCIO(1,0,0,0,0)
                    GOTO 216
                  ELSE
C       
C----   Do NOT want to reset max residual
C       
                    LINE = ' '
                    WRITE(LINE,FMT=6340)
                    CALL MXDWIO(LINE, 1)
                    CALL MXDRIO(LINE2)
C       
C----   Parse reply
C       
C       ******************************************
                    CALL MPARSE(LINE2,IBEG,IEND,ITYP,VALUE,IDEC,NTOK)
C       ******************************************
                    IF (NTOK.EQ.0) THEN
                      STR1 = 'Y'
                    ELSE
                      STR1 = LINE2(IBEG(1):IEND(1))
                      CALL CCPUPC(STR1)
                    END IF
                    IF (STR1.EQ.'Y') THEN
C       
C---    ABANDON
C       
                      CALL MRESET(ISEG,RPTFIRST,GENOPEN,COORDOPN)
                      IF (DISPMENU) THEN
                        GOTO 34
                      ELSE
                        GOTO 30
                      END IF
                    ELSE
C       
C----   Repeat query
C       
                      GOTO 212
                    END IF
                  END IF
C       
                ELSE
                  IF (RWEIGHT) THEN
                    IF (BRIEF) WRITE (IBRIEF,FMT=6045) WRMSRES,WRMSLIM
                    IF (ONLINE) WRITE (ITOUT,FMT=6045) WRMSRES,WRMSLIM
                    WRITE (IOUT,FMT=6045) WRMSRES,WRMSLIM
                  ELSE
                    IF (BRIEF) WRITE (IBRIEF,FMT=6044) RMSRES,RMSLIM
                    IF (ONLINE) WRITE (ITOUT,FMT=6044) RMSRES,RMSLIM
                    WRITE (IOUT,FMT=6044) RMSRES,RMSLIM
                  END IF
                END IF
C       
C----   If this was the firstfilm, change pack number of first good film
C       
                IF (FIRSTFILM) IFIRSTGOOD = IFIRSTGOOD + 1
                BADPACK(IPACK,IFILM) = .TRUE.
                NWRN = NWRN + 1
C       
C       
C----   If this is a multi-segment refinement, abandon it.
C       
                IF (MULTISEG) THEN
                  WRITE(IOUT,FMT=6212)
                  IF (ONLINE) WRITE(ITOUT,FMT=6212)
                  STOP
                END IF
C       
                IF (FIRSTPASS) THEN
                  NERR(IPACK) = 8
                  XERR(IPACK) = RMSRES
                ELSE
C       
C       ************************************************
                  CALL SUMMERR(ISUMMR,ID,8,NFPACK(IPACK),NFGEN,FILM,IX,
     +                 RMSRES)
C       ************************************************
C       
                END IF
C       
C       
                GO TO 250
              END IF
C       
C----   Sort all reflexions  (fulls and partials) in generate file
C       
C----   First check box size after final refinement
C       
C       ****************************
 216          IF (FIRSTFILM) THEN
                CALL RMAXR(LIMIT,THICK,IERR2)
                IF ((IERR2.EQ.1).AND.DISPMENU.and.winopen) THEN
                  WRITE(LINE,FMT=6208) IRAS(1),IRAS(2)
                  L = LENSTR(LINE)
                  IXP = 400
                  IYP = 400
                  CALL MXD_POP(IXP,IYP, XDLSTR(LINE),L,
     +                 XDLSTR(' '),0,XDLSTR('OK'),2,XDLSTR(' '),
     +                 -1,3,0,IBUTTON)
                END IF
                IF (IERR2.EQ.2) THEN
                  IF (DISPMENU) THEN
C       
C----   If running interactively, trap measurement box being too big
C       
                    CALL MRESET(ISEG,RPTFIRST,GENOPEN,COORDOPN)
                    GOTO 34
                  ELSE
                    NSHUTERR = 7
                    CALL SHUTDOWN(CALLEDFROM,NSHUTERR)
                  END IF
                END IF
              END IF
C       ****************************
C       
              IF (DEBUG(1)) THEN
                IF (ONLINE) WRITE (ITOUT,FMT=6062) MAXR,IRAS
 6062           FORMAT (/1X,'At end of refinement, MAXR from RMAXR ',I6,
     +               /1X,'IRAS',5I4)
                WRITE (IOUT,FMT=6062) MAXR,IRAS
              END IF
C       
C----   Replot image if requested. Always replot if SEPARATION was not
C       given explicitly and this is the first image because SEPARATION
C       will have been updated in CHKRAS and number of overlaps may have
C       changed.
C       
 224          IF ((LPREF).OR.(FILMPLT.AND.FIRSTFILM.AND.(ISEP.NE.2)))
     $             THEN
                MODEDISP = 4
                imageno = id
                CALL XDISP(MODEDISP,FIRSTPACK,PACK,IFIRSTPACK,
     +               FIRSTFILM,GENOPEN)
                IF (MODEDISP.EQ.99) THEN
C       
C----   Abort current run
C       
                  CALL MRESET(ISEG,RPTFIRST,GENOPEN,COORDOPN)
                  IF (DISPMENU) THEN
                    GOTO 34
                  ELSE
                    GOTO 30
                  END IF
                END IF
              END IF
C       
C       
C----   If using interactive display, write the generate file now
C       Also write it if we want all reflections (including spatial
C       overlaps) written to output MTZ file.
C       
              IF ((FILMPLT.AND.(.NOT.MATCH)).OR.ALLOUT) THEN
                WRITE(ITOUT,FMT=6200)
 6200           FORMAT(/,1X,'Generating new reflection list')
                MODEG = 3
                CALL GENERATE(MODEG,ID,GWRITE,UPDATE,LIMIT,POSTREF,
     +               NEWPREF,NFGEN,LOVERLAP,NFULLF)
C       ****************************************
C----   Store the pack header record number for this image. Note that NFILMS
C       has not yet been incremented, so use NFILMS+1 as pointer
C       
                IPACKSTART(NFILMS+1) = IPACKHEAD
              END IF
C       
              IF (WINOPEN) CALL MXD_FLU(I)
C       AL          IF (NOMEAS) CALL SHUTDOWN(CALLEDFROM,LENSTR(CALLEDFROM))
              MODE = 1
C       
C----   If summing partials over adjacent images, set MODE = 4
C       otherwise if doing post-refinement, set MODE = 5.
C       Set LAST true if the is the last image in a run processed
C       with POSTREF or ADDPART
              ADDPP = ADDP(IPACK)
C       
              LAST = ((IPACK.EQ.NPACKSAVE).AND.(ADDPART.OR.POSTREF))
              IF (ADDPART) THEN
                MODE = 4
              ELSE IF (SUMPART) THEN
                MODE = 5
              END IF
C       
              IF (NEWPREF) MODE = 1
C       
              FORCE = (PRBFILM.AND.FILM.EQ.2.OR.PRCFILM.AND.FILM.EQ.3)
C       
C       ****************************************************
              CALL GENSORT(MODE,FORCE,LIMIT,VLIM,NMR,ADDPART,PTMIN,LAST)
C       ****************************************************
              IF (WINOPEN) CALL MXD_FLU(I)
C       
              FORCE = .FALSE.
C       
C----   Select optical densities for all reflections in file.
C       if not using profile fitting, extract integrated intensity
C       etc for each spot once all its ods have been collected.
C       
C       
C----   If refining (cell), orientation using postrefinement, initialise
C       by calling POSTREFL with MODE=0. Have to test SUMPART as well,
C       because for the last image of a series there will be no
C       information to refine orientation
C       
              IF (POSTREF.AND.(SUMPART.OR.NEWPREF)) THEN
                MODE = 0
                MODE2(1) = 0
                MODE2(2) = 0
C       
C----   If this is the very first pack, set MODE negative so that NIMAG is set
C       to zero in POSTREFL (can't use FIRSTPACK as it
C       is incremented when
C       using blocks of data)
C       
                IF (IPACK.EQ.IFIRSTP) THEN
                  MODE = -1
                  MODE2(1) = -1
                  MODE2(2) = -1
                ENDIF
C       
C----   initialize
C       
C
C---- To protect against mosaic spread refining negative because of
C     innacurate cell parameters, if this is the first cycle of cell
C     refinement do not refine mosaic spread until all images have
C     been integrated and a cell refinement is going to be done.
C     Need to do this now, as NS is set to PRNS in POSTREFL
C
                IF (MULTISEG.AND.((NREPEAT.EQ.0).AND.
     +                ((IPACK.LT.NPACK).OR.(ISEG.LT.NSEG)))) THEN
                  PRNSAVE = PRNS
                  PRNS = 0
                END IF
                IF (DEBUG(1)) THEN
                  WRITE(IOUT,FMT=6444) NREPEAT,IPACK,NPACK,ISEG,NSEG,
     +               PRNS,USEBEAM
                  IF (ONLINE) WRITE(ITOUT,FMT=6444) NREPEAT,IPACK,
     +               NPACK,ISEG,NSEG,PRNS,USEBEAM
 6444             FORMAT(1X,'Call POSTREFL to initialise',/,1X,
     +             'NREPEAT=',I3,' IPACK=',I3,' NPACK=',I3,' ISEG=',
     +             I3,' NSEG=',I3,' PRNS=',I3,' USEBEAM',L2)
                END IF
                CALL POSTREFL(MODE,MODE2,MODE2,TEMP,RESID,RETA,RDIVH,
     +           RDIVV,FIXED,ISTAT,LASTREC,NEWPREF,iseg,MULTISEG)
C
C---- Restore PRNS
C
                IF (MULTISEG.AND.((NREPEAT.EQ.0).AND.
     +                ((IPACK.LT.NPACK).OR.(ISEG.LT.NSEG)))) THEN
                  PRNS = PRNSAVE
                END IF
                
              END IF
C       
C----   Keep track of number of images written by MEAS to SPOTOD. If an image
C       is repeated as a result of a large shift in postrefinement, then
C       PROCESS must skip the redundant image from SPOTOD
C       
              NOWRITE = NOWRITE + 1
              ISKIPI(NOWRITE) = 0
C       
              IF (WINOPEN) CALL MXD_FLU(I)

              IF (WINOPEN) THEN
                CALL MXDBSY(-1, ' ')
                CALL MXD_FLU(I)
                CALL MXDBSY(0,
     $               'Writing measurement boxes to scratch file')
              END IF
C       
C       *******************************************************
              IERR = 0
              CALL MEAS(MAXR,PROFILE,INTERPOL,IXSHIFT,IYSHIFT,ADDPP,
     +             POSTREF,ID+ISERADD,MULTISEG,LASTREC,NEWPREF,NUSPOT,
     &             IERR)
C       *******************************************************
C       
C----   Reflections to be used for postrefinement have been accumulated in
C       MEAS. Now call POSTREFL again to actually do the refinement.
C       Note that if adding data from several images, refinement only
C       starts once NADD images have been processed
C       If doing NEWPREF mode, don't attempt to do refinement for the
C       first image
C       
          IF (POSTREF.AND.(SUMPART.OR.
     +               (NEWPREF.AND.(IPACK.NE.IFIRSTPSEG)))) THEN
                MODE = -999
                IF (WINOPEN) THEN
                  CALL MXDBSY(-1, ' ')
                  CALL MXD_FLU(I)
                  CALL MXDBSY(0,'Doing post-refinement')
                  CALL MXD_FLU(I)
                END IF
                MODE2(1) = ID
                MODE2(2) = IPACK
C
C---- To protect against mosaic spread refining negative because of
C     innacurate cell parameters, if this is the first cycle of cell
C     refinement do not refine mosaic spread until all images have
C     been integrated and a cell refinement is going to be done.
C
                IF (MULTISEG.AND.((NREPEAT.EQ.0).AND.
     +                ((IPACK.LT.NPACK).OR.(ISEG.LT.NSEG)))) THEN
                  PRNSAVE = PRNS
                  PRNS = 0
                END IF
C
                IF (DEBUG(1)) THEN
                  WRITE(IOUT,FMT=6442) NREPEAT,IPACK,NPACK,ISEG,NSEG,
     +               PRNS,USEBEAM
                  IF (ONLINE) WRITE(ITOUT,FMT=6442) NREPEAT,IPACK,
     +               NPACK,ISEG,NSEG,PRNS,USEBEAM
 6442             FORMAT(1X,'Call POSTREFL to refine',/,1X,
     +             'NREPEAT=',I3,' IPACK=',I3,' NPACK=',I3,' ISEG=',
     +             I3,' NSEG=',I3,' PRNS=',I3,' USEBEAM',L2)
                END IF
                CALL POSTREFL(MODE,MODE2,MODE2,TEMP,RESID,RETA,RDIVH,
     +           RDIVV,FIXED,ISTAT,LASTREC,NEWPREF,ISEG,MULTISEG) 
C
C---- Restore PRNS
C
                IF (MULTISEG.AND.((NREPEAT.EQ.0).AND.
     +                ((IPACK.LT.NPACK).OR.(ISEG.LT.NSEG)))) THEN
                  PRNS = PRNSAVE
                END IF
C       
C----   Check for error return (singular equations etc).
C       
                IF (ISTAT.NE.0) THEN
                  IF (DISPMENU) THEN
C       
C----   If running interactively, trap failure of postrefinement
C       
                    CALL MRESET(ISEG,RPTFIRST,GENOPEN,COORDOPN)
                    GOTO 34
                  ELSEIF(SOCKLO)THEN
                    CALL MRESET(ISEG,RPTFIRST,GENOPEN,COORDOPN)
                    LONGLINE = ' '
                    WRITE(LONGLINE,FMT=7100)
                    CALL WRITE_SOCKET_LENGTH(SERVERFD,
     $                      LENSTR(LONGLINE),LONGLINE)
 7100               FORMAT('<?xml version="1.0"?>',
     $                   '<!DOCTYPE cell_refine_response>',
     $                   '<cell_refine_response>',
     $                   '<status><code>error</code><message>',
     $                   'Fewer data than parameters - check',
     $                   ' mosaicity and/or matrix',
     $                   '</message></status></cell_refine_response>')
                    XMLABORT = .TRUE.
                    GOTO 30
                  ELSE
                    NSHUTERR = 8
                    CALL SHUTDOWN(CALLEDFROM,NSHUTERR)
                  END IF
                END IF
C       
                IF (WINOPEN) THEN
                  CALL MXD_FLU(I)
                  CALL MXDBSY(-1, ' ')
                END IF
                IF ((RESID.GT.RESIDMAX).OR.(FRCSHIFT.GT.0.10)) THEN
                  IF (RESID.GT.RESIDMAX) THEN
                    WRITE(IOUT,FMT=6061) RESID,RESIDMAX
                    IF (ONLINE) WRITE(ITOUT,FMT=6061) RESID,RESIDMAX
                    IF (BRIEF) WRITE(IBRIEF,FMT=6061) RESID,RESIDMAX
                  END IF
                  IF (FRCSHIFT.GT.0.10) THEN

                     call dna_output_table_start('error')
                     call dna_output_list_start('integration_error')
                     call dna_output_real_item('cell_parameter_shift', 
     +                    frcshift)
                     call dna_output_list_end
                     call dna_output_table_end
                     call dna_end_output

                    WRITE(IOUT,FMT=6130)
                    IF (ONLINE) WRITE(ITOUT,FMT=6130)
                  END IF
 6130             FORMAT(//1X,'***** SERIOUS ERROR ****',/,1X,'One ',
     +                 'or more cell parameters has changed by more ',
     $                 'than 10%.',/,1X,'This means the refinement i',
     $                 's unstable. Try using more images.')

 6061             FORMAT(//1X,'***** SERIOUS ERROR ****',1X,'Refine',
     +                 'ment residual from POSTCHK is',F6.3,' which',
     $                 ' is greater than',/,1X,'maximum allowed val',
     +                 'ue of',F6.3,' (subkeyword MAXRESID on POSTR',
     $                 'EF keyword).',/,1X,'Processing stopped.',/,1X,
     +                 'Check that you are using a sensible value of ',
     +                 'the mosaic spread/beam divergence',/,1X,
     $                 'by predicting the pattern and checking (using',
     +                 ' the X-window graphics)',/,1X,
     +                 'that you are predicting all observed spots.')
C       
                  WRITE(ISUMMR,FMT=6059) ID,RESID,RESIDMAX
 6059             FORMAT(/1X,'The post-refinement residual for pack',I4,
     +                 ' is',F6.3,' which exceeds maximum allowed valu',
     $                 'e of',F6.3,' (set using POSTREF MAXRESID)',/,1X,
     +                 'Check that you are using a sensible value of t',
     +                 'he mosaic spread/beam divergence',/,1X,'by pre',
     $                 'dicting the pattern and checking (using the X',
     +                 '-window graphics)',/,1X,
     +                 'that you are predicting all observed spots.')
                  IF (DISPMENU) THEN
C       
C----   Abort current run
C       
                    CALL MRESET(ISEG,RPTFIRST,GENOPEN,COORDOPN)
                    GOTO 34
                  END IF
                  NSHUTERR = 9
                  CALL SHUTDOWN(CALLEDFROM,NSHUTERR)
                END IF
C       
C----   Test for negative (mosaic spread + divergence)
C       
                IF (((RETA+RDIVH).LT.0.0).OR.((RETA+RDIVV).LT.0.0)) THEN
C
C---- Only set warning flag if the refined mosaic spread is being used
C
                  IF (USEBEAM) WARN(16) = .TRUE.
                  PRNEGM(NFILMS+1) = .TRUE.
                  WRITE(IOUT,FMT=6110)
                  IF (ONLINE) WRITE(ITOUT,FMT=6110)
 6110             FORMAT(/1X,'***** WARNING ****',/,1X,'The refined ',
     +                 'mosaic spread plus beam divergence is negati',
     +                 've',/,1X,'This may be indicative of a large ',
     +                 'crystal slippage or the input oscillation an',
     $                 'gle might be wrong',/)
                  IF (USEBEAM) THEN
                    IF (PRNS.EQ.1) THEN
                      WRITE(IOUT,FMT=6112)
                      IF (ONLINE) WRITE(ITOUT,FMT=6112)
 6112                 FORMAT(1X,'The mosaic spread has been set to ',
     +                     '0.05',/,1X,'It may be advisable NOT to ',
     +                     'use the refined  mosiac spread (use',
     $                     ' POSTREF FIX MOSAIC keywords)')
                      ETA = 0.5*DTOR*0.05
                    ELSE IF (PRNS.EQ.2) THEN
                      IF (RDIVH.LT.0.0) THEN
                        DIVH = 0.5*DTOR*0.05
                        WRITE(IOUT,FMT=6114)
                        IF (ONLINE) WRITE(ITOUT,FMT=6114)
 6114                   FORMAT(1X,'The horizontal divergence has b',
     +                       'een reset to 0.05',/,1X,'It may be a',
     +                       'dvisable NOT to use the refined beam',
     +                   ' parameters (POSTREF USEBEAM OFF keywords)')
                      END IF
                      IF (RDIVV.LT.0.0) THEN
                        DIVV = 0.5*DTOR*0.05
                        WRITE(IOUT,FMT=6116)
                        IF (ONLINE) WRITE(ITOUT,FMT=6116)
 6116                   FORMAT(1X,'The vertical divergence has ',
     +                       'been reset to 0.05',/,1X,'It may ',
     +                       'be advisable NOT to use the refin',
     +                       'ed  beam parameters (POSTREF USEBEAM OFF'
     +                       ,' keywords)')
                      END IF
                    END IF
                  END IF
                END IF
C       
C----   Test for large difference between input and refined mosaic spread
C       or beam divergence.
C       
                IF (PRNS.EQ.1) THEN
                  WARN(19) = (WARN(19).OR.
     +                 (ABS(RETA-2.0*SETA).GT.0.1*2.0*SETA))
                ELSE IF (PRNS.EQ.2) THEN
                  WARN(19) = (WARN(19).OR.
     +                 (ABS(RDIVH-2.0*SDIVH).GT.0.1*2.0*SDIVH)
     +                 .OR.(ABS(RDIVV-2.0*SDIVV).GT.0.1*2.0*SDIVV))
                END IF
                PRF(NFILMS+1) = .TRUE. 
C       
C----   Since we have now done a post-refinement, set UMATCELL(1) to zero
C       so that it does not check for inconsistency due to a different
C       wavelength being used when deriving the AMATRIX to the integration run.
C       
                UMATCELL(1) = 0.0
C       
C       
C----   Test orientation shifts. Need shift to be greater than SHIFTMAX
C       AND also greater than SHIFTFAC*SD to be treated as a large shift.
C       
                BIGSHIFT = .FALSE.
                RPTIMG = .FALSE.
C       
C----   If not using "fixed" mode, where all images are constrained to have
C       the same missets, there are only 2 refined angles and sds (PSIY,PSIZ)
C       so change setup of SDDELPHI
C       
                DO 226 I = 1,3
                  SDMISS = SDDELPHI(I)
                  IF (.NOT.FIXED) THEN
                    IF (I.EQ.2) SDMISS = SDDELPHI(1)
                    IF (I.EQ.3) SDMISS = SDDELPHI(2)
                  END IF
                  IF ((ABS(SHIFT(I)).GT.SHIFTMAX).AND.
     +                 (ABS(SHIFT(I)).GT.SHIFTFAC*SDMISS))
     $                 BIGSHIFT=.TRUE.
 226            CONTINUE
C       
                IF (DEBUG(1)) THEN
                  WRITE(IOUT,FMT=6118) NADD,IPACK,NADDMISSET,
     +              (SHIFT(I),I=1,3),
     +                 (SHIFTFAC*SDDELPHI(I),I=1,3),SHIFTMAX,BIGSHIFT
                  IF (ONLINE) WRITE(ITOUT,FMT=6118) NADD,IPACK,
     +                  NADDMISSET,(SHIFT(I),I=1,3),
     +                 (SHIFTFAC*SDDELPHI(I),I=1,3),SHIFTMAX,BIGSHIFT
 6118             FORMAT(1X,'NADD=',I4,' IPACK=',I4,' NADDMISSET=',I4,
     +                  ' Shift in',
     +                 ' missets',3F7.3,/,1X,'Shiftfac*sd(delphi)',
     +                 3F7.3,/,1X,'Max allowed shift before repeat',
     +                 F7.3,' Logical bigshift is ',L1)
                  IF (NEWPREF) THEN
                    CONTINUE
                  ELSE
                    WRITE(IOUT,FMT=6119) (DELPHIV(I),I=1,3*NADD)
                    IF (ONLINE) WRITE(ITOUT,FMT=6119)
     $                 (DELPHIV(I),I=1,3*NADD)
 6119             FORMAT(1X,'Values in DELPHIV',/,(1X,3F10.3))
                  END IF
                END IF
C       
C----   Single image case, or initial images (up to NADD) of multiple 
C       image case (flagged by setting MODE=-990 in postrefl)
C---    I think this should be Ok to repeat an image even after NADD have
C       been processed in "width" mode...lets try and see.
C----   Special case. If using a block of images to refine (NADD) and this
C       is the NADD'th image, then we must first test for a large shift in
C       cell parameters because if this has happened we want to repeat
C       processing of the whole block of data and not just the current
C       image. Note that when using "NEWPREF" refinement, the condition is
C       that this is the NADD+1'th image rather than NADD'th
C       
                IF ((NADD.GT.1) .AND.
     +               (((IPACK.EQ.NADD).AND.(.NOT.NEWPREF)) .OR.
     +               ((IPACK.EQ.NADD+NSEG).AND.NEWPREF))    .AND.
     +               (CELLSHIFT.GT.SHIFTFAC))GOTO 228
C       
C----   Do the same if this is a multisegment post-refinement
C       
                IF (MULTISEG.AND.(CELLSHIFT.GT.SHIFTFAC)) GOTO 228
C       
C---    Test for large shifts
C       
                IF ((BIGSHIFT).OR.
     +               ((NADD.EQ.1).AND.(CELLSHIFT.GT.SHIFTFAC))) THEN
C       
C----   First deal with orientation shift
C       
                  IF (BIGSHIFT) THEN
                    WRITE(IOUT,FMT=6063)SHIFTMAX,SHIFTFAC
                    IF (ONLINE) WRITE(ITOUT,FMT=6063) 
     +                   SHIFTMAX,SHIFTFAC
                    IF (BRIEF) WRITE(IBRIEF,FMT=6063) 
     +                   SHIFTMAX,SHIFTFAC
 6063               FORMAT(//1X,'*****  shift in one or more missett',
     +                   'ing angles exceeds limit of',F6.3,' degree',
     +                   's  or',F5.2,' standard deviations *****',/,
     +                   1X,' Repeat measurement of this image using',
     +                   ' refined missetting angles')
                    PRFRPT1(NFILMS+1) = .TRUE.
        INTDUM(1) = 0
        INTDUM(2) = 0
                    IF(NEWPREF)call MODARRAY(3,0.0,0,0,INTDUM,INTDUM)

                    IF(SOCKLO)THEN
                       WRITE(LONGLINE,FMT=7000)
     $                     SHORTFN(1:LENSTR(SHORTFN))
                       CALL WRITE_SOCKET_LENGTH(SERVERFD,
     $                      LENSTR(LONGLINE),LONGLINE)
                    ENDIF
                  END IF
C       
C----   Now deal with cell shift
C       
                  IF (CELLSHIFT.GT.SHIFTFAC) THEN
                    WRITE(IOUT,FMT=6065) CELLSHIFT,SHIFTFAC
                    IF (ONLINE) WRITE(ITOUT,FMT=6065) CELLSHIFT,
     $                   SHIFTFAC
                    IF (BRIEF) WRITE(IBRIEF,FMT=6065) CELLSHIFT,
     $                   SHIFTFAC
 6065               FORMAT(//,1X,'***** Cell parameter shift (',F5.1,
     +                   ' sds) exceeds limit of',F5.1,' sds *****',
     +                   /,1X,'Repeat measurement of this image')
                    PRFRPT2(NFILMS+1) = .TRUE.
                  END IF
C
C---- If in NEWPREF mode, want to go back to the first image, not just
C     repeat measurement of the second one !
C
                IF ((.NOT.NEWPREF).OR.(NEWPREF.AND.
     +               (IPACK.GT.(2*NVIRBAT)))) THEN
C
C---- Need to trap oscillating missetting angles, which would result
C     in repeating this image indefinately.
C
                   IF (IPACK.EQ.IRPTPACK) THEN
                     NSINGRPT = NSINGRPT + 1
C
C---- Check shifts against those in previous round
C
                     BIGSHIFT = .FALSE.
                     DO 229 I = 1,3
                       IF ((ABS(SHIFT(I)+RPTSHIFT(I,NSINGRPT-1)).GT.
     +                      SHIFTMAX).AND.
     +                     (ABS(SHIFT(I)+RPTSHIFT(I,NSINGRPT-1))
     +                      .GT.SHIFTFAC*SDMISS)) BIGSHIFT = .TRUE.
 229                 CONTINUE
C
C---- Do not repeat image if shifts are oscillating
C
                     IF (.NOT.BIGSHIFT) THEN
                       WRITE(IOUT,FMT=6412)
                       IF (ONLINE) WRITE(ITOUT,FMT=6412)
 6412                  FORMAT(//,1X,'*** Missets are oscillating ***',
     +                        /,1X,'Going on to the next image.')
                       PRFRPT1(NFILMS+1) = .FALSE.
                       GOTO 232
                     END IF
C
C---- Do not allow more than 5 repeats anyway
C
                     IF (NSINGRPT.GT.5) THEN
                       WRITE(IOUT,FMT=6410)
                       IF (ONLINE) WRITE(ITOUT,FMT=6410)
 6410                  FORMAT(//,1X,'***** TOO MANY REPEATS *****',/,
     +                         1X,'Check orientation. Going on to the',
     +                          ' next image.')
                       PRFRPT1(NFILMS+1) = .FALSE.
                       GOTO 232
                     END IF
                   ELSE
                     IRPTPACK = IPACK
                     NSINGRPT = 1
                     DO 227 I = 1,3
                       RPTSHIFT(I,1) = SHIFT(I)
 227                 CONTINUE
                   END IF
C       
C----   Only set flag to skip an image in SPOTOD if accumulating profiles
C       because if not, then SPOTOD is rewound by MEAS, so the second
C       pass on the image will overwrite the first in SPOTOD
                  IF (FIRSTPASS) ISKIPI(NOWRITE) = 1
                  DOPROFILE = .FALSE.
C       
C----   Reset AVPROFILE as this was set false in CHKRAS
C       
                  AVPROFILE = AVPROF(IPACK)
C       
C----   Position generate file to write pack header
C       
C       *******************************
                  CALL QSEEK(IUNIT,IPACKHEAD,1,36)
C       *******************************
                  IPACKREC = IPACKHEAD
                    RPTIMG = .TRUE.
                    GOTO 85
C       
C----   Restart
C       
                  ELSE
                    NFRPT = NFRPT + 1
                    IF (NFRPT.LE.5) THEN
                      WRITE(IOUT,FMT=6351)
                      IF (ONLINE) WRITE(ITOUT,FMT=6351)
 6351                 FORMAT(/,1X,'*** As this is near to the start, '
     +               ,'repeat integration from the first image ***')
                    ELSE
                      WRITE(IOUT,FMT=6352)
                      IF (ONLINE) WRITE(ITOUT,FMT=6352)
 6352                 FORMAT(/,1X,'*** Too many repeats ***',/,1X,
     +                    'Go on to the next image.')
                      GOTO 232
                    END IF
                    SHIFT(1) = 0.0
                    SHIFT(2) = 0.0
                    SHIFT(3) = 0.0
                    CELLSHIFT = 0.0
C
C---- If this is the first segment, reset the mosaic spread to the starting 
C     value. This is because a poor initial orientation can cause the
C     mosaicity to refine to a very small value, which will then prevent
C     the port-refinement from working on the second run through.
C
                    IF (ISEG.EQ.1) THEN
                      ETA = SETA
                    END IF
                    IF (DEBUG(1)) THEN
                      WRITE(IOUT,FMT=6353) 2.0*ETA/DTOR
                      IF (ONLINE) WRITE(ItOUT,FMT=6353) 2.0*ETA/DTOR
 6353                 FORMAT(/,/,1X,'Mosaic spread reset to',F6.3)
                    END IF
                    IF ((ISEG.EQ.1).AND.(NREPEAT.EQ.0)) THEN
                      NFILMS = 0
                    ELSE
                      NFILMS = NFILMS - (IPACK - IFIRSTPACK)
                    END IF
                    NOWRITE = 0
C
C---- Need to reset NIMAG in POSTREFL if not the first segment,
C     and also adjust PHIIM and IDLAST
C
                   IF (ISEG.GT.1) THEN
                     MODE = -9999
                     MODE2(1) = IPACK - IFIRSTPACK
                     CALL POSTREFL(MODE,MODE2,MODE2,TEMP,RESID,RETA,
     +                            RDIVH,RDIVV,FIXED,ISTAT,LASTREC,
     +                            NEWPREF,ISEG,MULTISEG)
                   END IF
                    IFIRSTGOOD = IFIRSTPACK
                    IF (NBLOCK.NE.0) THEN
                      IFIRSTPACK = IFIRSTPACK - NUMBLOCK*NBLOCK
                      NPACK = 0
                    END IF
C       
C----   Initialisation flags for FINDPACK, OPENODS and reposition 
C       generate file
C       
                    MODEOP = 1
C       ********************
                    CALL QSEEK(IUNIT,21,1,36)
C       ********************
C       
                    JPACK = 0
                    IPACKREC = 21
                    IPACKHEAD = 21
C       
C----   Close the current image file. Note is is opened with DISKIO
C       under Unix, Fortran under VMS, but if packed the file has already
C       been closed.
C       
C       HRP                   IF (VAXVMS()) THEN
C       *************
C       AL                    CLOSE (UNIT=INOD)
C       *************
C       HRP                   ELSE
C       *****************************
C       AL                    IF (.NOT.PACK) CALL QCLOSE(INOD)
C       *****************************
C       HRP                   END IF
C       
C----   Rewind SPOTOD file (contains measurement boxes)
C       
                    IF(.NOT.MULTISEG)THEN
                      IF(NUSPOT)THEN
                        CALL QSEEK(INMO,1,1,1)
                      ELSE
                        REWIND(INMO)
                      ENDIF
                    ENDIF
                    IF (DENSE) REWIND(ICOORD)
                    IF (DEBUG(1)) THEN
                      WRITE(IOUT,FMT=6350) IFIRSTPACK,NUMBLOCK,NBLOCK
                      IF (ONLINE) WRITE(ITOUT,FMT=6350) IFIRSTPACK,
     +                     NUMBLOCK,NBLOCK
 6350                 FORMAT(1X,'RESTART, IFIRSTPACK reset to',I5,
     +                     '  NUMBLOCK, NBLOCK',2I5)
                    END IF
C       
C----   Reset NUMBLOCK
C       
                    NUMBLOCK = 0
C
C---- Call MODARRAY for statistics for this image, then to clear arrays.
                    INTDUM(1) = 0
                    INTDUM(2) = 0
                    IF (NEWPREF) THEN
                      CALL MODARRAY(1, 0.0, 0,0,INTDUM,INTDUM)
                      CALL MODARRAY(0,0.0,0,0,INTDUM,INTDUM)
                    END IF
                    GOTO 35      
                  END IF
                END IF
C       
C----   Multiple image case
C       Only repeat measurement if this is the FIRST postrefinement and
C       in this case remeasure the first NADD packs again, up to a total
C       of NRPT repeats. Note that in NEWPREF mode we need to process
C       the first NADD+1 packs again.
C       Otherwise just print a warning message
C       
 228            IF (MULTISEG.OR.
     +               ((IPACK.EQ.NADD).AND.(.NOT.NEWPREF)).OR.
     +               ((IPACK.EQ.NADD+NSEG).AND.NEWPREF)) THEN
C       
C----   This is the first postref for a "width" case or any image in
C       a "single" case. Tests on cell shifts...no test on
C       orientation required because it is tested for each image.
C       
                  IF (CELLSHIFT.GT.SHIFTFAC) THEN
                    IF (MULTISEG) THEN
                      WRITE(IOUT,FMT=6168) CELLSHIFT,SHIFTFAC
                      IF (ONLINE) WRITE(ITOUT,FMT=6168) CELLSHIFT,
     $                     SHIFTFAC
                      IF (BRIEF) WRITE(IBRIEF,FMT=6168) CELLSHIFT,
     $                     SHIFTFAC
                    ELSE
                      NADDP = NADD
                      IF (NEWPREF) NADDP = NADDP + 1
                      WRITE(IOUT,FMT=6167) CELLSHIFT,SHIFTFAC,NADDP
                      IF (ONLINE) WRITE(ITOUT,FMT=6167) CELLSHIFT,
     $                     SHIFTFAC,
     +                     NADDP
                      IF (BRIEF) WRITE(IBRIEF,FMT=6167) CELLSHIFT,
     $                     SHIFTFAC,
     +                     NADDP
                    END IF
 6167               FORMAT(//,1X,'***** Cell parameter shift (',F5.1,
     +                   ' sds) exceeds limit of',F5.1,' sds *****',
     +                   /,1X,'Repeat measurement of first',I3,
     $                   ' images')
 6168               FORMAT(//,1X,'***** Cell parameter shift (',F5.1,
     $                   ' sds) exceeds limit of',F5.1,' sds *****',
     $                   /,1X,'Repeating the entire run, using the ',
     +                   'refined cell parameters as given above')
C       
C       AL              IF (NADD.GT.1) NREPEAT = NREPEAT + 1
                    IF (MULTISEG.OR.(NADD.GT.1)) NREPEAT = NREPEAT + 1
C       
C----   Write the matrix anyway
C       
                    WRITE(IOUT,FMT=6302) NEWMATNAM(1:LENSTR(NEWMATNAM))
                    IF (ONLINE) WRITE(ITOUT,FMT=6302) 
     +                   NEWMATNAM(1:LENSTR(NEWMATNAM))
 6302               FORMAT(/1X,'New orientation matrix written to',
     +                   ' (keyword NEWMAT): ',A,/,1X,
     +                   'The missetting angles in this file are the',
     +                   ' refined missets for the FIRST image',/,1X,
     +                   'in the post-refinement.')
                    CALL CCPDPN (12,NEWMATNAM,'UNKNOWN','F',80,IFAIL)
                    IF (NEWPREF) THEN
                    WRITE(12,FMT=6300) ((AMAT(I,J),J=1,3),I=1,3),
     +                   (RMISSETS(1,J),J=1,3),
     +                   ((UMAT(I,J),J=1,3),I=1,3),CELL,
     +                   (RMISSETS(1,J),J=1,3)
                    ELSE
                    WRITE(12,FMT=6300) ((AMAT(I,J),J=1,3),I=1,3),
     +                   (DELPHIV(J),J=1,3),
     +                   ((UMAT(I,J),J=1,3),I=1,3),CELL,
     +                   (DELPHIV(J),J=1,3)
                    END IF
 6300               FORMAT(3(3F12.8/),(3F12.3/),3(3F12.8/),6F12.4,/,
     $                   3F12.4)
                    CLOSE (UNIT=12)

                    IF (DISPMENU) THEN
                      SAVMATSTR = 'postrefinement'
                    END IF
C       
C----   Trap too many repeats of entire run
C       
                    IF (NREPEAT.GT.NRPT) THEN
                      WRITE(IOUT,FMT=6073) NRPT
                      IF (ONLINE) WRITE(ITOUT,FMT=6073) NRPT
                      IF (BRIEF) WRITE(IBRIEF,FMT=6073) NRPT
 6073                 FORMAT(//,1X,'****** Only',I3,' repeats allow',
     +                     'ed ***** Processing will be aborted',/,
     +                     1X,'Check if the refinement is unstable',
     +                     ', and if so increase the number of imag',
     $                     'es used',/,1X,'(keywords ADD or WIDTH ',
     +                     'on POSTREF keyword)',/,1X,
     +                     'The number of repeats can be changed ',
     +                     'with keyword REPEAT under POSTREF')
C       
                      IF (MULTISEG) THEN
C       
C----   Abort current run
C       
                        PRFINISH = .TRUE.
                        GOTO 230
                      END IF
                    END IF
C       
C----   If this is a postref segment run, start again by calling CONTROL
C       In this case the generate file is closed in CONTROL.
C       
                    IF (MULTISEG) THEN
                      RPTFIRST = .TRUE.
                      FIRSTTIME = .TRUE.
                      ISEG = 0
                      PRFINISH = .TRUE.
                      SHIFT(1) = 0.0
                      SHIFT(2) = 0.0
                      SHIFT(3) = 0.0
                      GOTO 230
                    END IF
C       
C       
C----   Restart
C       
                    SHIFT(1) = 0.0
                    SHIFT(2) = 0.0
                    SHIFT(3) = 0.0
                    CELLSHIFT = 0.0
                    NFILMS = 0
                    NOWRITE = 0
                    IFIRSTGOOD = IFIRSTPACK
                    IF (NBLOCK.NE.0) THEN
                      IFIRSTPACK = IFIRSTPACK - NUMBLOCK*NBLOCK
                      NPACK = 0
                    END IF
C       
C----   Initialisation flags for FINDPACK, OPENODS and reposition 
C       generate file
C       
                    MODEOP = 1
C       ********************
                    CALL QSEEK(IUNIT,21,1,36)
C       ********************
C       
                    JPACK = 0
                    IPACKREC = 21
                    IPACKHEAD = 21
C       
C----   If the BLOCK size is less than the WIDTH, some images will have been
C       integrated and written to MTZ file when the post-refinement is done.
C       In this case, need to close and re-open the MTZ file
C       
                    IF (NBLOCK.LT.NADD) THEN
                      IF (MTZOPEN) THEN
                        MTZPRT = 0
C       *********************
                        if (debug(1))then
                          write(iout,fmt=7500)
                          if (online) write(itout,fmt=7500)
 7500                     format(1x,'**In MOSFLM closing MTZ file 1 ',
     +                       'and reopening it ***')
                        end if
C
                        CALL LWCLOS(MTZOUT,MTZPRT)
                        IF(LBEST.AND.BESTOPEN)THEN
                          CLOSE(BESTHKL)
                          BESTOPEN = .FALSE.
                        ENDIF
C       *********************
                        CALL STARTMTZ
                        NLSUM1 = 0
                        NLSUM2 = 0
                      END IF
                    END IF
C       
C----   Close the current image file. Note is is opened with DISKIO
C       under Unix, Fortran under VMS, but if packed the file has already
C       been closed.
C       
                    IF (VAXVMS()) THEN
C       *************
C       AL                CLOSE (UNIT=INOD)
C       *************
                    ELSE
C       *****************************
C       AL                IF (.NOT.PACK) CALL QCLOSE(INOD)
C       *****************************
                    END IF
C       

C       
C----   Rewind SPOTOD file (contains measurement boxes)
C       
                    IF(.NOT.MULTISEG)THEN
                      IF(NUSPOT)THEN
                        CALL QSEEK(INMO,1,1,1)
                      ELSE
                        REWIND(INMO)
                      ENDIF
                    ENDIF
                    IF (DENSE) REWIND(ICOORD)
                    IF (DEBUG(1)) THEN
                      WRITE(IOUT,FMT=6350) IFIRSTPACK,NUMBLOCK,
     $                     NBLOCK
                      IF (ONLINE) WRITE(ITOUT,FMT=6350) IFIRSTPACK,
     +                     NUMBLOCK,NBLOCK
                      WRITE(IOUT,FMT=6119) (DELPHIV(I),I=1,3*NADD)
                      IF (ONLINE)WRITE(ITOUT,FMT=6119)(DELPHIV(I),
     $                     I=1,3*NADD)
                    END IF
C       
C----   Reset NUMBLOCK
C       
                    NUMBLOCK = 0
C
C---- Reinitialize arrays if doing NEWPREF
C
                    IF (NEWPREF) THEN
C
C---- Call MODARRAY for statistics for this image, then to clear arrays.
                      INTDUM(1) = 0
                      INTDUM(2) = 0
                      CALL MODARRAY(1, 0.0, 0,0,INTDUM,INTDUM)
                      CALL MODARRAY(0,0.0,0,0,INTDUM,INTDUM)
                    END IF
                    GOTO 35      
                  END IF
                ELSE
C       
C----   Not the first post-refinement, give warning if shift large but
C       do not repeat
                  IF ((BIGSHIFT).OR.(CELLSHIFT.GT.SHIFTFAC)) THEN
                    WRITE(IOUT,FMT=6069) SHIFTMAX,SHIFTFAC
                    IF (ONLINE) WRITE(ITOUT,FMT=6069) SHIFTMAX,
     $                   SHIFTFAC
                    IF (BRIEF) WRITE(IBRIEF,FMT=6069) SHIFTMAX,
     $                   SHIFTFAC
 6069               FORMAT(/,1X,'***** WARNING *****',/,1X,'Shift',
     +                   ' in missetting angles exceeds',F6.3,
     +                   ' degrees',/,1X,'or cell parameter shift',
     +                   ' exceeds',F5.1,' sds',/,1X,'Consider us',
     +                   'ing a smaller angular width (WIDTH or A',
     $                   'DD) if crystal is slipping',/,1X,'or ',
     +                   'a larger angular width if refinement is',
     $                   ' unstable')
                    PRFHS(NFILMS+1) = .TRUE.
                  END IF
                END IF
C       
              END IF
C----   Above is end of IF (POSTREF.AND.SUMPART) block
C       
C       
C----   If this is a multi-segment post-refinement run, stop once refinement is
C       complete for the last pack
C       
 232          CONTINUE
              IF (MULTISEG.AND.(ISEG.EQ.NSEG).AND.
     +             (((IPACK.EQ.NPACK-1).AND.(.NOT.NEWPREF)).OR.
     +             ((IPACK.EQ.NPACK).AND.NEWPREF))) THEN
                
C       
C----   Write new orientation matrix
C       
                WRITE(IOUT,FMT=6302) NEWMATNAM(1:LENSTR(NEWMATNAM))
                IF (ONLINE) WRITE(ITOUT,FMT=6302) 
     +               NEWMATNAM(1:LENSTR(NEWMATNAM))
                CALL CCPDPN (12,NEWMATNAM,'UNKNOWN','F',80,IFAIL)
                IF (NEWPREF) THEN
                WRITE(12,FMT=6300) ((AMAT(I,J),J=1,3),I=1,3),
     +               (RMISSETS(1,J),J=1,3),
     +                   ((UMAT(I,J),J=1,3),I=1,3),CELL,
     +               (RMISSETS(1,J),J=1,3)
                ELSE
                WRITE(12,FMT=6300) ((AMAT(I,J),J=1,3),I=1,3),
     +               (DELPHIV(J),J=1,3),
     +               ((UMAT(I,J),J=1,3),I=1,3),CELL,
     +               (DELPHIV(J),J=1,3)
                END IF
                CLOSE (UNIT=12)
                IF (DISPMENU) THEN
                  SAVMATSTR = 'postrefinement'
                END IF
                PRFINISH = .TRUE.
                GOTO 230
              END IF
C       
              IF (DEBUG(1)) THEN
                IF (ONLINE) WRITE (ITOUT,FMT=6064) MAXR,NOWRITE,
     +               ISKIPI(NOWRITE),IRAS
 6064           FORMAT (/1X,'After calling MEAS,MAXR= ',I6,' NOWRITE=',
     +               I3,' ISKIPI',I3,/1X,'IRAS',5I4)
                WRITE (IOUT,FMT=6064) MAXR,NOWRITE,ISKIPI(NOWRITE),IRAS
              END IF
C       
              IF (FIRSTPASS) THEN
C       
C----   Write refined camera constants back to generate file
C       
                MODEWR = 1
C       
C       ****************************
                CALL WRGEN(MODEWR,PROFILE,ADDPP)
C       ****************************
C       
                MODEWR = 0
C       
C----   If DENSE, (many close spots) write a list of spot coordinates, sorted
C       on scanner X coordinate, to a file (written from GENSORT)
C       
                IF (DENSE) THEN
                  MODE = -2
                  IF (NEWPREF.AND.LAST) LAST = .FALSE.
C       ****************************************************
                  CALL GENSORT(MODE,FORCE,LIMIT,VLIM,NMR,ADDPART,
     $                 PTMIN,LAST)
C       ****************************************************
                  IF (DEBUG(1))THEN
                    WRITE(IOUT,FMT=6220)              
                    IF (ONLINE) WRITE(ITOUT,FMT=6220)              
 6220               FORMAT(1X,'Spot coordinates written to COORDS ',
     $                   'file')
                  END IF
                END IF
                GO TO 230
              END IF
C       
C-----  If not integrating the image, skip call to PROCESS
C       
              IF (NOMEAS) GOTO 230
C       
C----   Process the measurements for each spot if in profile mode
C       unless in second pass of accumulated profile processing
C       
              IF (PROFILE) THEN
C       
C       
                ADDPP = ADDP(IPACK)
cdms21.09.2004   Let user know what is happening.
                IF (IMGP) WRITE (IOUT,FMT=6015) ID,PHIBEG,PHIEND
                IF (WINOPEN) THEN
                  CALL MXD_FLU(I)
                  CALL MXDBSY(0,'Integrating image')
                END IF       
C       
C       ******************************************
                CALL PROCESS(NFLMO,IXSHIFT,IYSHIFT,ADDPP,ISKIPI,
     +                LPINTG,NEWPREF,NUSPOT,LPINTG,NOBACK,ID,NUMBLOCK,
     +                XMLABORT)
C       ******************************************
C
C---- Abort run if flag set.
C
                IF (XMLABORT) THEN
                  CALL MRESET(ISEG,RPTFIRST,GENOPEN,COORDOPN)
                  GOTO 30
                END IF
C
                IF (WINOPEN) THEN
                  CALL MXD_FLU(I)
                  CALL MXDBSY(-1, ' ')
                END IF
C       
C----   Display residual vectors if requested, allows bad spot changes
C
cdms21.09.2004    Use OPENODS to display if FILMPLT is set.
                IF (LPINTG.AND.FILMPLT) THEN
C
C----   If processing more than a single image, need to read in the
C       image again as it will no longer be stored in memory. However,
C       the image must always be read into the same "half" of array
C       IMAGE because we need to keep the last image of the current BLOCK
C       of images in memory because it has not yet been processed.
C       To do this, must disable updating of the pointer ISTART in
C       OPENODS. Do this by setting MODEOP=3
C
C       Note that ID has to be decremented by 1 (IDTMP=ID-1) when
C       SUMPART is true because OPENODS increments it by one.
C
                  IF (NPACK.GT.1) THEN
                    IDTMP = ID
                    IF (SUMPART) IDTMP = ID - 1
                    MODEOP = 3
C       ********************************************************
C----   OPENODS called to display residual vectors
C
                    CALL OPENODS(IDENT,IDTMP,FILM,ODEXT,FDISK,
     +                   MODEOP,PACK,ODFILE,SEPCHAR,FORCEREAD,IPACK,
     +                   TEMPLSTART,TEMPLEND,IERR)
C       *******************************************************
                    MODEOP = 0
                  END IF
C       
C       
C----   Need to set flag to repredict the pattern
C       ***** Displaying image after integration *****
C       
                  MODEDISP = 5
                  CALL XDISP(MODEDISP,FIRSTPACK,PACK,IFIRSTPACK,
     +                 FIRSTFILM,GENOPEN)
                  IF (MODEDISP.EQ.99) THEN
C       
C----   Abort current run
C       
                    CALL MRESET(ISEG,RPTFIRST,GENOPEN,COORDOPN)
                    IF (DISPMENU) THEN
                      GOTO 34
                    ELSE
                      GOTO 30
                    END IF
                  END IF
                  IF (IPACK.EQ.NPACK) LPINTG = .FALSE.
C
C----   End of display image block
C
                END IF
C       
C       
                IF (.NOT.SECONDPASS) THEN
                  IF(.NOT.MULTISEG)THEN
                    IF(NUSPOT)THEN
                      CALL QSEEK(INMO,1,1,1)
                    ELSE
                      REWIND(INMO)
                    ENDIF
                  ENDIF
                  IF (DENSE) REWIND ICOORD
                END IF
              END IF
C       
C----   Write summary information
C       
 230          CONTINUE
              
              ICTF = NINT(XTOFRA*XTOFD)
C              ITILT = TILT/FDIST
C              ITWIST = TWIST/FDIST
              CALL SETDIS(ITILT,ITWIST,2)
              IF (IMGP) THEN
                IROFF = NINT(ROFF)
C       AL              IROFF2 = NINT(ROFF2)
                ITOFF = NINT(TOFF)
              ELSE
                IBULGE = BULGE/FDIST
              END IF
C       
C       
              IF (.NOT.FIRSTPASS) THEN
C       
C----   Store maximum shifts in ROFF,TOFF,CCOMEGA, number bad spots,weighted 
C       residual etc
C       
                IF (ROFFSAVE.GT.-998.0) THEN
                  ROFFMAX = MAX(ROFFMAX,ABS(0.01*IROFF - ROFFSAVE))
                  TOFFMAX = MAX(TOFFMAX,ABS(0.01*ITOFF - TOFFSAVE))
                  X = CCOM-CCOMSAVE
                  IF (X.GT.180) X = X - 360.0
                  IF (X.LT.-180) X = X + 360.0
                  CCOMAX = MAX(CCOMAX,ABS(X))
                END IF
                WRMAX = MAX(WRMAX,WRMSRES)
                NBADMAX = MAX(NBADMAX,NBAD)
                AVBGRMAX = MAX(AVBGRMAX,AVBGRATIO)
                AVBGRMIN = MIN(AVBGRMIN,AVBGRATIO)
                ROFFSAVE = 0.01*IROFF
                TOFFSAVE = 0.01*ITOFF
                CCOMSAVE = CCOM
                IF (IMGP) THEN
                  WRITE (ISUMMR,FMT=6067) ID,0.01*CCX,0.01*CCY,CCOM,
     +                 0.01*ICTF,YSCAL,ITILT,ITWIST,0.01*IROFF,
     +                 0.01*ITOFF,0.01*RMSRES,WRMSRES,
     +                 NOFR,(NREF-NOFR),NOLO,NNEG,NBAD,FIOVSDP(9),
     +                 FIOVSDP(8),RFACOV,NRSYM,SDRATOV
                ELSE
                  WRITE (ISUMMR,FMT=6066) ID,ABC(FILM:FILM),0.01*CCX,
     +                 0.01*CCY,CCOM,0.01*ICTF,YSCAL,ITILT,ITWIST,
     +                 0.01*IBULGE,
     +                 0.01*RMSRES,WRMSRES,NOFR,(NREF-NOFR),NOLO,NNEG,
     +                 NBAD,FIOVSDP(9),FIOVSDP(8)
                END IF
              END IF
cdms21.09.2004    Write summary here in case where we have read in profiles.
                IF (PRREAD) THEN
C
C----   Store information for summary file
C
                  ISUMM(1,NFILMS+1) = ID
                  SUMMCH(NFILMS+1) = ABC(FILM:FILM)
                  ISUMM(2,NFILMS+1) = CCX
                  IF (INVERTX) ISUMM(2,NFILMS+1) = -CCX
                  ISUMM(3,NFILMS+1) = CCY
                  ISUMM(4,NFILMS+1) = ICTF
                  ISUMM(5,NFILMS+1) = ITILT
                  ISUMM(6,NFILMS+1) = ITWIST
                  ISUMM(7,NFILMS+1) = IBULGE
                  IF (IMGP) ISUMM(7,NFILMS+1) = IROFF
                  ISUMM(8,NFILMS+1) = (NRS-NREJS)
                  ISUMM(15,NFILMS+1) = CBAR
                  IF (IMGP) THEN
                    ISUMM(19,NFILMS+1) = ITOFF
                  END IF
                  RSUMM(1,NFILMS+1) = CCOM
C
C---- If CCOM has been reset to TRUECCOM in REFRT1, want to store the
C     actual refined value in summary file.
                  IF (RESETCCOM) RSUMM(1,NFILMS+1) = DPSIX + TRUECCOM
                  IF ((ABS(RSUMM(1,NFILMS+1)).GT.100.0).AND.
     +             (RSUMM(1,NFILMS+1).LT.0))
     +              RSUMM(1,NFILMS+1) = RSUMM(1,NFILMS) + 360.0
                  IF (RSUMM(1,NFILMS+1).GT.100.0)
     +              RSUMM(1,NFILMS+1) = RSUMM(1,NFILMS) - 360.0
                  RSUMM(2,NFILMS+1) = YSCAL
                  YSCALERR = MAX(ABS(YSCAL - YSCALIN),YSCALERR)
                  RSUMM(3,NFILMS+1) = RMSRES
                  IF (RWEIGHT) RSUMM(4,NFILMS+1) = WRMSRES
                  RSUMM(12,NFILMS+1) = TOFF
                  IF (IMGP) THEN
                    NLSUM1 = NLSUM1 + 1
                    WRITE (LINESUM1(NLSUM1),FMT=6067)
     1               ISUMM(1,NFILMS+1),
     +               (0.01*ISUMM(K,NFILMS+1),K=2,3),RSUMM(1,NFILMS+1),
     +               0.01*ISUMM(4,NFILMS+1),
     +               RSUMM(2,NFILMS+1),(ISUMM(K,NFILMS+1),K=5,6),
     +               0.01*ISUMM(7,NFILMS+1),0.01*ISUMM(19,NFILMS+1)
     +               ,0.01*RSUMM(3,NFILMS+1),RSUMM(4,NFILMS+1),
     +               (ISUMM(K,NFILMS+1),K=9,13),
     +               (RSUMM(K,NFILMS+1),K=5,7),
     +               ISUMM(20,NFILMS+1),RSUMM(8,NFILMS+1)
                  ENDIF
                  IF (.NOT.POSTREF) NFILMS=NFILMS+1
                ENDIF
cdms21.09.2004    End addition for PRREAD true.
C       
C----   If accumulating profiles, on first pass do not call process
C       store XCEN,YCEN etc
C       
              IF (FIRSTPASS) THEN
                NFILMS = NFILMS + 1
                IF (DEBUG(1)) THEN
                  WRITE(IOUT,FMT=6426) NFILMS,ID,NREPEAT,ISEG
                  IF (ONLINE) WRITE(ITOUT,FMT=6426) NFILMS,ID,
     +                                  NREPEAT,ISEG
 6426             FORMAT(1X,'NFILMS set to',I4,' for storing',
     +                ' detector parameters for image',I5,  'nrepeat',
     +                 I2,' iseg',I2)
                END IF
C       
C----   Store information for summary file
C       
                ISUMM(1,NFILMS) = ID
                SUMMCH(NFILMS) = ABC(FILM:FILM)
                ISUMM(2,NFILMS) = CCX
                IF (INVERTX) ISUMM(2,NFILMS) = -CCX
                ISUMM(3,NFILMS) = CCY
                ISUMM(4,NFILMS) = ICTF
                ISUMM(5,NFILMS) = ITILT
                ISUMM(6,NFILMS) = ITWIST
                ISUMM(7,NFILMS) = IBULGE
                IF (IMGP) ISUMM(7,NFILMS) = IROFF
                ISUMM(8,NFILMS) = (NRS-NREJS)
                ISUMM(15,NFILMS) = CBAR
                IF (IMGP) THEN
                  ISUMM(19,NFILMS) = ITOFF
                END IF
                RSUMM(1,NFILMS) = CCOM
C
C---- If CCOM has been reset to TRUECCOM in REFRT1, want to store the
C     actual refined value in summary file.
C
            IF (RESETCCOM) RSUMM(1,NFILMS) = DPSIX + TRUECCOM
                IF ((ABS(RSUMM(1,NFILMS)).GT.100.0).AND.
     +               (RSUMM(1,NFILMS).LT.0)) 
     +               RSUMM(1,NFILMS) = RSUMM(1,NFILMS) + 360.0
                IF (RSUMM(1,NFILMS).GT.100.0)
     +               RSUMM(1,NFILMS) = RSUMM(1,NFILMS) - 360.0
                RSUMM(2,NFILMS) = YSCAL
                YSCALERR = MAX(ABS(YSCAL - YSCALIN),YSCALERR)
                RSUMM(3,NFILMS) = RMSRES
                IF (RWEIGHT) RSUMM(4,NFILMS) = WRMSRES
                RSUMM(12,NFILMS) = TOFF
              END IF
C       
C----   Store summary information on post-refinement. 
C       
              IF ((FIRSTPASS.OR.PRREAD).AND.POSTREF) THEN
C       
C---    If reading profiles, then FIRSTPASS is never true, so must
C       increment NFILMS here.
C       
                IF (PRREAD) NFILMS = NFILMS + 1
                ISUMM(1,NFILMS) = ID                             
C       
C----   POSTREF summary information. If NADD>1 AND FIXED, then the parameters
C       for the FIRST NADD images will be identical (because the first postref
C       run is only done once NADD images have been processed). So when the
C       first post-refinement has been done, set postref summary parameters
C       for all these images. NOTE there will be problems if NADD is greater
C       than NBLOCK !! IF NOT FIXED, then all missetting angles and sds
C       will be different, so must pick them up from DELPHIV and SDDELPHI
C       from /POSTCHK/. Note that we also need to check on SUMPART, because
C       if there are only NADD images in total, then even when IPACK=NADD
C       the post-refinement will not have been carried out because the next
C       image was not present !
C       
C       AL             IPT = 0
C       AL             IPTR = 0
C       
C----   IPT is the pointer into DELPHIV to pick up refined missets. If NADD is
C       greater than the number of images in a BLOCK, then we must not start
C       IPT at zero, but 3*NBLOCK*(NADD/NBLOCK)
C       
                IPT = 3*NBLOCK*((NADD-1)/NBLOCK)
                IPTR = IPT
                JSTART = NFILMS
C
C--- NOTE need to take account of multiple segments when working out
C    when to set JSTART to 1 to store all missets. Note this is ONLY
C    done when using POSTREF NOMULTI (ie NOT NEWPREF) 7/10/03
C
                IF ((NADD.GT.1).AND.
     +               (IPACK.EQ.(NADD+ISEG-1)).AND.SUMPART.AND.
     +               (.NOT.NEWPREF)) JSTART = 1

CAL     +               (.NOT.NEWPREF)).OR.((IPACK.EQ.NADD+1)
CAL     $               .AND.NEWPREF)) JSTART = 1
C
                IF (NEWPREF) JSTART = NFILMS
C
                IF (DEBUG(1)) THEN
                  WRITE(IOUT,FMT=6310) JSTART,NFILMS,IPACK,NADD,NBLOCK,
     +                 NUMBLOCK,IPT
                  IF (ONLINE) WRITE(ITOUT,FMT=6310) JSTART,NFILMS,
     +                 IPACK,NADD,NBLOCK,NUMBLOCK,IPT
                END IF
 6310        FORMAT(1X,'In MOSFLM, storing postref info for summary',
     +              ' file, JSTART=',I4,'  NFILMS=',I4,'  IPACK=',I4,
     +               '  IADD=',I4,' NBLOCK=',I3,'  NUMBLOCK=',I3,
     +               ' IPT=',I3)
                DO 237 JFILMS = JSTART,NFILMS
                  DO 234 I = 1,3
                    PRFSUM(16+I,JFILMS) = SDCELL(I)*CELL(I)
                    PRFSUM(19+I,JFILMS) = SDCELL(I+3)
                    PRFSUM(22+I,JFILMS) = SDBEAM(I)/DTOR
                    XWARN(I,18) = MAX(XWARN(I,18),SDCELL(I)*CELL(I))
                    XWARN(I+3,18) = MAX(XWARN(I+3,18),SDCELL(I+3))
C       
C----   Monitor large standard deviations in any cell parameter for
C       warning message. Test for sd in cell edge greater than 0.1A and
C       in cell angle greater than 0.1 degrees
C       

                    IF (SDCELL(I)*CELL(I).GT.0.1) THEN
                      WARN(18) = .TRUE.
                      IWARN(I,18) = 1
                    END IF
                    IF (SDCELL(I+3).GT.0.1) THEN
                      WARN(18) = .TRUE.
                      IWARN(I+3,18) = 1
                    END IF
C       
CAL                 IF ((NADD.GT.1).AND.(.NOT.FIXED).AND.
CAL     +              ((IPACK.EQ.NADD).AND.SUMPART.AND.(.NOT.POSTHOC)
CAL     +               .OR. ((IPACK.EQ.NADD+1).AND.POSTHOC))) THEN
                    IF ((NADD.GT.1).AND.
     +                   (IPACK.EQ.(NADD+ISEG-1)).AND.SUMPART.AND.
     +                   (.NOT.NEWPREF)) THEN
C       
C----   Store values for first NADD images
C       
                      IPT = IPT + 1
                      PRFSUM(I,JFILMS) = DELPHIV(IPT)
                      IF (I.GT.2) GOTO 234
                      IPTR = IPTR + 1
                      PRFSUM(13+I,JFILMS) = SDDELPHI(IPTR)
                    ELSE
C       
C----   Have not yet done a complete post-refinement, get missets from
C       DELPHI
                      PRFSUM(I,JFILMS) = DELPHI(I)
                      IF (I.LT.3) PRFSUM(13+I,JFILMS) = SDDELPHI(I)
                    END IF
C
C---- Special case for NREWPREF refinement
C
                    IF (NEWPREF) THEN
C
C---- In case where NVIRBAT>1, store missets for first images once a
C     refinement has been done.
C
                   IF ((NVIRBAT.GT.1).AND.(IPACK.EQ.(NVIRBAT+1))) THEN
                     DO 233 J = 1,NVIRBAT
                       PRFSUM(I,J) = RMISSETS(J,I)
                       IF (I.LT.3) PRFSUM(13+I,J) = SDMISSETS(J,I)
 233                 CONTINUE
                   END IF
                   PRFSUM(I,JFILMS) = RMISSETS(IPACK,I)
                   IF (I.LT.3) PRFSUM(13+I,JFILMS) = SDMISSETS(IPACK,I)
                 END IF
 234              CONTINUE
c     
c----   missets seem to go missing for last image of first batch if newpref 
C       
                  if(newpref.and.(ipack.eq.nadd+1))then
                    do 235 i=1,3,1
                      PRFSUM(I,JFILMS) = DELPHI(I)
 235                continue
                  endif
                  DO 236 I = 1,6
                    PRFSUM(I+3,JFILMS) = CELL(I)
 236              CONTINUE
                  PRFSUM(10,JFILMS) = RETA/DTOR
                  PRFSUM(11,JFILMS) = RDIVH/DTOR
                  PRFSUM(12,JFILMS) = RDIVV/DTOR
                  PRFSUM(13,JFILMS) = RESID
                  PRFSUMI(JFILMS) = NREFPR
 237            CONTINUE
              END IF
C
C---- If finished a multiseg run, go back
C
              IF (PRFINISH) THEN
                PRFINISH = .FALSE.
                IF (RPTFIRST) THEN
C
C---- Do not call CONTROL, get stored information
C
                  ISEG = 1
                  CALL CELLREFSET(IFIRSTPACK,NREPEAT,ISEG,
     +                            RPTFIRST,FIRSTTIME,INERR)
                  IF (INERR) THEN
C       
C----   Abort current run
C       
                    CALL MRESET(ISEG,RPTFIRST,GENOPEN,COORDOPN)
                    IF (DISPMENU) THEN
                      GOTO 34
                    ELSE
                      GOTO 30
                    END IF
                  END IF
                  ISEG = 0
                  GOTO 36
                END IF
C
C---- Display summary of refinement
C
                CALL PRSUMMARY(NREPEAT,NSEG,LASTFILM,RSUMM,ISUMM,
     +               PRFSUM,CELL,OLDCELL,DELPHI,NEWPREF,DISPMENU,
     +               newgui,NTDIG)
                SAVMATSTR = 'postrefinement'
                SAVMATNAM = NEWMATNAM
C
                CALL MRESET(ISEG,RPTFIRST,GENOPEN,COORDOPN)
                IF (DISPMENU) THEN
                  GOTO 34
                ELSE
                  GOTO 30
                END IF
              END IF
C       
C----   Make call to MODARRAY to remove finished reflections
C       
        INTDUM(1) = 0
        INTDUM(2) = 0
              IF(NEWPREF)CALL MODARRAY(1, 0.0, 0,0,INTDUM,INTDUM)
C       
C----   end of PROCESS section from MOSES2 = .TRUE.
C
chrp06122001            ENDIF

C       
C----   End of loop over films in this pack
C       
 240      CONTINUE
C       
C----   Close the image file. Note is is opened with DISKIO
C       under Unix, Fortran under VMS, but if file is packed it has
C       been closed automatically
C       
          IF (VAXVMS()) THEN
C       *************
C       AL          CLOSE (UNIT=INOD)
C       *************
          ELSE
C       ****************************
C       AL          IF (.NOT.PACK) CALL QCLOSE(INOD)
C       ****************************
          END IF
C       
C----   End of loop over packs in this generate file
C       
c       -harvest
          KHFLMS = KHFLMS + 1
          HARETA(KHFLMS) = RETA/DTOR
          HARDIH(KHFLMS) = RDIVH/DTOR
          HARDIV(KHFLMS) = RDIVV/DTOR
c       -harvest
 250    CONTINUE
C       
C----   If accumulating profiles, prepare for next pass
C       
chrp06122001        IF(MOSES2)THEN
          IF (ACCUMULATE) THEN
            IF (FIRSTPASS) THEN
              FIRSTPASS = .FALSE.
              SECONDPASS = .TRUE.
C       
C----   Position generate file to first pack
C       
C       ********************
              CALL QSEEK(IUNIT,21,1,36)
C       ********************
C       
              JPACK = 0
              IPACKREC = 21
              IPACKHEAD = 21  
              PROCES = .TRUE.
              NFLMO = NFILMS
              IF (.NOT.MULTISEG) NFILMS = 0
              IF (DEBUG(1)) THEN
                WRITE(IOUT,FMT=6428) NFILMS
                IF (ONLINE) WRITE(ITOUT,FMT=6428) NFILMS
 6428           FORMAT(1X,'NFILMS  at end of FIRSTPASS',I4)
              END IF
C       
C----   Rewind mosflm.out, containing "A" film images of all packs
C       plus B/C films if PRBFILM/PRCFILM
C       
              IF(.NOT.MULTISEG)THEN
                IF(NUSPOT)THEN
                  CALL QSEEK(INMO,1,1,1)
                ELSE
                  REWIND(INMO)
                ENDIF
              ENDIF
              IF (DENSE) REWIND ICOORD
C       
C----   If doing multi-segment post-refinement, return to control to get next
C       set of images
              IF (MULTISEG) THEN
                FIRSTPASS = .TRUE.
                SECONDPASS = .FALSE.
                PROCES = .FALSE.
C
C---- Do not call CONTROL, interpret stored keywords
C
                ISEG = ISEG + 1
                CALL CELLREFSET(IFIRSTPACK,NREPEAT,ISEG,
     +                            RPTFIRST,FIRSTTIME,INERR)
                IF (INERR) THEN
C       
C----   Abort current run
C       
                  CALL MRESET(ISEG,RPTFIRST,GENOPEN,COORDOPN)
                  IF (DISPMENU) THEN
                    GOTO 34
                  ELSE
                    GOTO 30
                  END IF
                END IF
                ISEG = ISEG - 1
                GOTO 36
              END IF
C       
C----   Measure all "A" films using accumulated profiles
C       
              GO TO 40
            ELSE IF (SECONDPASS) THEN

              IF (PROCESSA) GO TO 260
              SECONDPASS = .FALSE.
              THIRDPASS = .TRUE.
              PROCES = .FALSE.
              NFILMS = 0
              IF (DEBUG(1)) THEN
                WRITE(IOUT,FMT=6430)
                IF (ONLINE) WRITE(ITOUT,FMT=6430)
 6430           FORMAT(1X,'NFILMS set to zero at end of SECONDPASS')
              END IF
C       
C----   Rewind mosflm.out
C       
              IF(.NOT.MULTISEG)THEN
                IF(NUSPOT)THEN
                  CALL QSEEK(INMO,1,1,1)
                ELSE
                  REWIND(INMO)
                ENDIF
              ENDIF
              IF (DENSE) REWIND ICOORD
C       
C----   Position generate file to first pack
C       
C       ********************
              CALL QSEEK(IUNIT,21,1,36)
C       ********************
C       
              JPACK = 0
              IPACKREC = 21
              IPACKHEAD = 21
C       
C----   Measure subsequent films in each pack
C       
              GO TO 40
            ELSE IF (THIRDPASS) THEN
              THIRDPASS = .FALSE.
            END IF
          END IF
chrp06122001        ENDIF
C       
C----   Read next set of control data
C       
C       *********
 260    IF (ONLINE.AND.LBELL) CALL BELL
C       *********
C       
C----   Close mosflm.out file
C       
        IF(.NOT.MULTISEG)THEN
          IF(NUSPOT)THEN
            IF(INMOOPEN)CALL QCLOSE(INMO)
            INMOOPEN = .FALSE.
          ELSE
            CLOSE (UNIT=INMO)
          ENDIF
        ENDIF
C       
C----   If doing postrefinement, write results to summary file
C       
        IF (POSTREF) THEN
          WRITE (ISUMMR,FMT=6074)
          IF (PRFIRST) THEN
            PRFIRST = .FALSE.
            IF (NADD.GT.1) THEN
              IF (FIXED) THEN
                WRITE (ISUMMR,FMT=6090) NADD,SCELL,SDELPHI
              ELSE
                WRITE (ISUMMR,FMT=6079) NADD,SCELL,SDELPHI
              END IF
            ELSE
              WRITE (ISUMMR,FMT=6085) SCELL,SDELPHI
            END IF
            IF (REFCELL) THEN
              WRITE (ISUMMR,FMT=6080) CELLSTR
            ELSE
              WRITE (ISUMMR,FMT=6082)
            END IF
            IF (PRNS.GT.0) THEN
              IF (USEBEAM) THEN
                WRITE (ISUMMR,FMT=6084) 2.0*SETA/DTOR,2.0*SDIVH/DTOR,
     +               2.0*SDIVV/DTOR
              ELSE
                WRITE (ISUMMR,FMT=6086) 2.0*SETA/DTOR,
     +               2.0*SDIVH/DTOR,2.0*SDIVV/DTOR
              END IF
            ELSE
              WRITE (ISUMMR,FMT=6088) 2.0*SETA/DTOR,
     +             2.0*SDIVH/DTOR,2.0*SDIVV/DTOR
            END IF
          END IF
 6082     FORMAT(1X,'Cell parameters are not refined')
 6080     FORMAT(1X,'The following cell parameters are being refi',
     $         'ned: ',A)
 6088     FORMAT(1X,'Beam parameters are not refined',/,1X,'Input',
     +         ' values (degrees): mosaic spread (EPS)',F6.3,' ho',
     +         'rizontal divergence (DIVH)',F6.3,' vertical diver',
     +         'gence (DIVV)',F6.3)
 6086     FORMAT(1X,'Beam parameters are being refined but input ',
     +         'values will be used',/,1X,'Input values (degrees)',
     +         ': mosaic spread (EPS)',F6.3,' horizontal divergen',
     +         'ce (DIVH)',F6.3,' vertical divergence (DIVV)',
     +         F6.3)
 6084     FORMAT(1X,'Beam parameters are being refined',/,1X,'Inp',
     +         'ut values (degrees): mosaic spread (EPS)',F6.3,
     +         ' horizontal divergence (DIVH)',F6.3,' vertical di',
     $         'vergence (DIVV)',F6.3)
 6074     FORMAT(//1X,'RESULTS OF POSTREFINEMENT')
 6079     FORMAT(1X,I2,' successive pairs of images will be used',
     +         /,1X,'Each image will have its own missetting angl',
     $         'es',/,1X,'Initial cell ',
     +         'parameters',3F8.3,3F7.2,/,1X,'Initial missetting',
     +         ' angles',3F9.3)
 6090     FORMAT(1X,I2,' successive',
     +         ' pairs of images will be used',/,1X,'The missett',
     +         'ing angles will be constrained to be identical f',
     +         'or all images',/,1X,'Initial cell ',
     +         'parameters',3F8.3,3F7.2,/,1X,'Initial missetting',
     +         ' angles',3F9.3)
 6085     FORMAT(1X,'A single',
     +         ' pair of images will be used',/,1X,'Initial cell ',
     +         'parameters',3F8.3,3F7.2,/,1X,'Initial missetting',
     +         ' angles',3F9.3)
          WRITE (ISUMMR,FMT=6075)
cdms21.09.2004    Line up headings with numbers.
 6075     FORMAT(1X,'Image     PHIX     PHIY     PHIZ        A      ',
     +         '  B        C      ALPHA     BETA    GAMMA   MOSAIC   ',
     $         'DIVH   DIVV    Resid      NR')
          IF (NREPEAT.NE.0) WRITE(ISUMMR,FMT=6071) NADD,NREPEAT
 6071     FORMAT(1X,'The first',I3,' images have been remeasured',
     +         I3,' times because of shifts in missetting angles',
     +         ' or cell parameters')
          NREPEAT = 0
          DO 270 I = 1, NFILMS
            IF (PRF(I)) THEN
C       
C----   Needed for xloggraph, post-refinement results
C       
              WRITE(ISUMMR,FMT=6072) ISUMM(1,I),(PRFSUM(K,I),
     +             K=1,13),PRFSUMI(I)
              NLSUM2 = NLSUM2 + 1
              WRITE(LINESUM2(NLSUM2),FMT=6072) ISUMM(1,I),
     +             (PRFSUM(K,I),K=1,13),PRFSUMI(I)
C       
C----   Now sd's
C       
              IF ((NADD.GT.1).AND.(FIXED)) THEN
                WRITE(ISUMMR,FMT=6081) (PRFSUM(K,I),K=14,25)
              ELSE
                WRITE(ISUMMR,FMT=6083) (PRFSUM(K,I),K=14,15),
     +               (PRFSUM(K,I),K=17,25)
              END IF
              IF (PRFRPT1(I)) THEN
                IF (PRFRPT2(I)) THEN
                  WRITE(ISUMMR,FMT=6122) ISUMM(1,I),SHIFTMAX,
     $                 SHIFTFAC
                  PRFRPT2(I) = .FALSE.
                ELSE
                  WRITE(ISUMMR,FMT=6076) ISUMM(1,I),SHIFTMAX
                END IF
                PRFRPT1(I) = .FALSE.
              END IF
              IF (PRFRPT2(I)) THEN
                WRITE(ISUMMR,FMT=6124) ISUMM(1,I),SHIFTFAC
                PRFRPT2(I) = .FALSE.
              END IF
              IF (PRNEGM(I)) WRITE(ISUMMR,FMT=6120)
              PRNEGM(I) = .FALSE.
              IF (PRFHS(I)) WRITE(ISUMMR,FMT=6077) 
              PRFHS(I) = .FALSE.
            ELSE
              WRITE(ISUMMR,FMT=6078) ISUMM(1,I)
            END IF
 270      CONTINUE
c       -harvest
c       cxEBI if this format changes then mharvest.f needs to know
C was 6072     FORMAT(1X,I4,1X,3(1X,F8.2),2X,6(1X,F7.2),1X,3(1X,F6.2),
C     $         1X,F7.3,1X,I5)
 6072     FORMAT(1X,I4,1X,3(1X,F8.2),2X,6(1X,F7.2),1X,3(1X,F6.2),
     $         1X,F7.3,1X,I5)
c       -harvest
 6081     FORMAT(1X,'   sds',3(1X,F8.2),2X,6(1X,F7.2),1X,3(1X,F6.2))
 6083     FORMAT(1X,'   sds PSIY',F7.2,' PSIZ',F7.2,2X,6(1X,F7.2),1X,
     $         3(1X,F6.2))
 6076     FORMAT(1X,'Image',I4,' was remeasured because the shift',
     +         ' in orientation was greater than ',F5.2,' degrees')
 6122     FORMAT(1X,'Image',I4,' remeasured, shift in',
     +         ' orientation > ',F5.2,' degrees and in cell >',
     +         F5.1,' sds')
 6124     FORMAT(1X,'Image',I4,' was remeasured because the shift',
     +         ' in cell was greater than ',F5.2,' sds')
 6077     FORMAT(1X,'** Warning ** large shift in cell or missett',
     +         'ing angles, consult logfile')
 6078     FORMAT(1X,I4,5X,'Post refinement was not performed for ',
     +         'this image')
 6120     FORMAT(1X,'** Warning ** negative (mosaic spread+beam d',
     +         'ivergence). May be large crystal slippage or inpu',
     +         't oscillation angle is wrong')
        END IF
C       
C----   Find largest shift in CCOM, ROFF,TOFF or missets between adjacent images
C       and the largest weighted residual and number of badspots
C       
C       AL      WRITE(6,*),'NUMBLOCK,NFILMS',NUMBLOCK,NFILMS
        DO 274 I=1,NFILMS
          WRMAX = MAX(WRMAX,RSUMM(4,I))
          NBADMAX = MAX(NBADMAX,ISUMM(13,I))
          IF (I.EQ.1) GOTO 274
          ROFFMAX =  MAX(ROFFMAX,0.01*ABS(ISUMM(7,I)-ISUMM(7,I-1)))
          TOFFMAX =  MAX(TOFFMAX,0.01*ABS(ISUMM(19,I)-ISUMM(19,I-1)))
          X = RSUMM(1,I)-RSUMM(1,I-1)
          IF (X.GT.180) X = X - 360.0
          IF (X.LT.-180) X = X + 360.0
          CCOMAX = MAX(CCOMAX,ABS(X))
C
C---- Dont do a check for image 2 vs image 1 because image 1 may
C     not have been assigned missets because officially it was not
C     refined.
C
        IF ((NUMBLOCK.EQ.1).AND.(NEWPREF).AND.(I.LT.3)) GOTO 274
          X = DELPHIMAX
          DELPHIMAX = MAX(DELPHIMAX,ABS(PRFSUM(1,I)-PRFSUM(1,I-1)),
     +         ABS(PRFSUM(2,I)-PRFSUM(2,I-1)),
     +         ABS(PRFSUM(3,I)-PRFSUM(3,I-1)))
          IF (DELPHIMAX.GT.X) IWARN(1,5) = ID
C       AL        WRITE(6,*),'ROFFMAX,CCOMAX,DELPHIMAX',ROFFMAX,CCOMAX,DELPHIMAX
 274    CONTINUE
C       
C----   Now check the first image in this block with the last image in
C       previous block (if any)
C       
        IF (NUMBLOCK.GT.1) THEN
          ROFFMAX = MAX(ROFFMAX,ABS(0.01*ISUMM(7,1)-ROFFLAST))
          TOFFMAX = MAX(TOFFMAX,ABS(0.01*ISUMM(19,1)-TOFFLAST))
          X = RSUMM(1,1)-CCOMLAST
          IF (X.GT.180) X = X - 360.0
          IF (X.LT.-180) X = X + 360.0
          CCOMAX = MAX(CCOMAX,ABS(X))
          X = DELPHIMAX
          DELPHIMAX = MAX(DELPHIMAX,ABS(PRFSUM(1,1)-PHIXLAST),
     +         ABS(PRFSUM(2,1)-PHIYLAST),
     +         ABS(PRFSUM(3,1)-PHIZLAST))
          IF (DELPHIMAX.GT.X) IWARN(1,5) = ID
        END IF
C       AL        WRITE(6,*),'AFTER COMPARISON WITH LAST ROFFMAX,CCOMAX,DELPHIMAX',
C       AL     +         ROFFMAX,CCOMAX,DELPHIMAX
        IF (NFILMS.GT.0) THEN
          ROFFLAST = 0.01*ISUMM(7,NFILMS)
          TOFFLAST = 0.01*ISUMM(19,NFILMS)
          CCOMLAST = RSUMM(1,NFILMS)
          PHIXLAST = PRFSUM(1,NFILMS)
          PHIYLAST = PRFSUM(2,NFILMS)
          PHIZLAST = PRFSUM(3,NFILMS)
C       AL      WRITE(6,*),'ROFFLAST,CCOLAST,PHIXYZLAST',ROFFLAST,CCOMLAST,
C       AL     +     PHIXLAST, PHIYLAST, PHIZLAST
        END IF
C       
C----   If using blocks of images, go on to next block if required
C       
        IF (NBLOCK.NE.0) THEN
C       
C----   Reset repeat measurement and post-refined flags
C       
          DO 272 I = 1,MAXPAX
            PRFRPT1(I) = .FALSE.
            PRFRPT2(I) = .FALSE.
            PRFHS(I) = .FALSE.
            PRF(I) = .FALSE.
            PRNEGM(I) = .FALSE.
 272      CONTINUE
C       
C----   Position generate file at last record ready for next pack, but NOT if
C       using ADDPART because the first image of the next block has already
C       been generated (to trap spatially overlapped summed partials). IN
C       this case can leave generate file where it was.
C       
C       ********************
          IF ((ADDPART).AND.(NPACK.LT.NPACKSAVE)) THEN
            IF (MULTIMTZ) THEN
              WRITE(IOUT,FMT=6372) MTZNAM(1:LENSTR(MTZNAM))
              IF (ONLINE) WRITE(ITOUT,FMT=6372) 
     $             MTZNAM(1:LENSTR(MTZNAM))
 6372         FORMAT(/,1X,'Closing mtz file: ',A)
              MTZPRT = 0
              CALL LWCLOS(MTZOUT,MTZPRT)
              MTZOPEN = .FALSE.
              IF(LBEST.AND.BESTOPEN)THEN
                CLOSE(BESTHKL)
                BESTOPEN = .FALSE.
              ENDIF
C       
C----   Sset up new MTZ filename
C    
              CALL NEWFN(NUMBLOCK+1,MTZNAM)
              if (debug(1)) then
                write(iout,fmt=7510)
                if (online) write(itout,fmt=7510)
 7510           format(1x,'** in mosflm opening mtz file 2 **')
              end if
              CALL STARTMTZ
            END IF
            GOTO 35
          END IF
C       
C----   Special test for case when there is only a single image in the last
C       block...without this test this last image will never be processed
C       
          IF ((ADDPART).AND.(NPACK.EQ.NPACKSAVE).AND.EXTRAIMG) THEN
            IF (MULTIMTZ) THEN
              WRITE(IOUT,FMT=6372) MTZNAM(1:LENSTR(MTZNAM))
              IF (ONLINE) WRITE(ITOUT,FMT=6372) 
     $             MTZNAM(1:LENSTR(MTZNAM))
              MTZPRT = 0
              if (debug(1))then
                write(iout,fmt=7502)
                if (online) write(itout,fmt=7502)
 7502           format(1x,'**In MOSFLM closing MTZ file 2 ',
     +                'and reopening ***')
              end if
              CALL LWCLOS(MTZOUT,MTZPRT)
              MTZOPEN = .FALSE.
              IF(LBEST.AND.BESTOPEN)THEN
                CLOSE(BESTHKL)
                BESTOPEN = .FALSE.
              ENDIF
C       
C----   Sset up new MTZ filename
C       
              CALL NEWFN(NUMBLOCK+1,MTZNAM)
              CALL STARTMTZ
            END IF
            GOTO 35
          END IF
          CALL QSEEK(IUNIT,IRECLAST,1,36)
          IPACKREC = IRECLAST
          IPACKHEAD = IRECLAST
          IF (DEBUG(1)) THEN
            WRITE(IOUT,FMT=6094) IRECLAST
            IF (ONLINE) WRITE(ITOUT,FMT=6094) IRECLAST
 6094       FORMAT(1X,'In MAIN, reposition generate file to record',
     $           I6)
          END IF
C       ********************
          IF (NPACK.LT.NPACKSAVE) THEN
            IF (MULTIMTZ) THEN
              WRITE(IOUT,FMT=6372) MTZNAM(1:LENSTR(MTZNAM))
              IF (ONLINE) WRITE(ITOUT,FMT=6372) 
     $             MTZNAM(1:LENSTR(MTZNAM))
              MTZPRT = 0
              if (debug(1))then
                write(iout,fmt=7504)
                if (online) write(itout,fmt=7504)
 7504           format(1x,'**In MOSFLM closing MTZ file 3 ',
     +             'and reopening it ***')
              end if
              CALL LWCLOS(MTZOUT,MTZPRT)
              MTZOPEN = .FALSE.
              IF(LBEST.AND.BESTOPEN)THEN
                CLOSE(BESTHKL)
                BESTOPEN = .FALSE.
              ENDIF
C       
C----   Sset up new MTZ filename
C       
              CALL NEWFN(NUMBLOCK+1,MTZNAM)
              CALL STARTMTZ
            END IF
            GOTO 35
          END IF
        END IF
C       
C----   Write number of warning messages to summary file
C       
        WARN(2) = (ROFFMAX.GT.0.10)
        XWARN(1,2) = ROFFMAX
        WARN(12) = (TOFFMAX.GT.0.10)
        XWARN(1,12) = TOFFMAX
        WARN(3) = (CCOMAX.GT.0.10)      
        XWARN(1,3) = CCOMAX
        WARN(5) = (DELPHIMAX.GT.0.25*(ETA + MAX(DIVH,DIVV))/DTOR)
        XWARN(1,5) = DELPHIMAX
        WARN(6) = (WRMAX.GT.1.5)
        XWARN(1,6) = WRMAX
        WARN(7) = (NBADMAX.GE.10)
        IWARN(1,7) = NBADMAX
        WARN(9)= ((AVBGRMAX.GT.1.1).OR.(AVBGRMIN.LT.0.9))
        XWARN(1,9) = AVBGRMIN
        XWARN(2,9) = AVBGRMAX
        WARN(25) = (YSCALERR.GT.0.0025)
        XWARN(1,25) = YSCALERR
C
C---- if iMosflm is running this integration, close the MTZ file so 
C     that Pointless has the header there.
C
c        IF(MTZOPEN.AND.SOCKLO)THEN
c          MTZPRT = 1
c          CALL LWCLOS(MTZOUT,MTZPRT)
c          MTZOPEN = .FALSE.
c        ENDIF
        CALL WARNINGS
c test insert this line here hrp 21.01.2010
        NRLEFT = 0
        CALL GROUT
C       
C----   If running interactively, go back to image display, otherwise
C       Call CONTROL again for next "run" (if any). also if doing
C       newpref integration in background or foreground.
C       
 280    IF (DISPMENU) THEN
          CALL MRESET(ISEG,RPTFIRST,GENOPEN,COORDOPN)
C
C---- Fix to stop opening the old GUI
C
          IF (SOCKLO) GOTO 30
          GOTO 34
        END IF
chrp06122001        MOSES2 = .TRUE.
        GO TO 30

        END
C
C $Id: reek.f,v 1.25 2007/12/18 14:55:49 harry Exp $
C
C==   REEK ==
      SUBROUTINE REEK(IHKLSTR,MODE)
C     =============================
C     
      IMPLICIT NONE
C     !
C     !  This routine replaces an earlier version and provides for 
C     !  generalization of goniostat angles etc. This is adapted from 
C     !  routines in MADNES from which the following comments are drawn;
C     !
C     !  This routine replaces an earlier version written by
C     !  Albrecht Messerschmidt.
C     !  The algorithm uses the geometric treatment of G.N. Reeke.
C     !  The code is derived from that originally written by
C     !  R.M. Sweet for prediction of reflections occuring on
C     !  oscillation photographs, but has been generalised to allow
C     !  for a general X-ray beam direction (defined by vector S0).
C     !
C     !  Harry Powell MRC-LMB Cambridge, 08-Mar-2001
C     !
C     !  Peter Brick, Andrew Leslie, Jean Claude Thierry, Alan J. Wonacott
C     !
C     !  10-Feb-1992   J. W. Pflugrath         Cold Spring Harbor Laboratory
C     !     Add ROTS and ROTE to argument list and remove references to PHIS, PHIE
C     !
C     !  29-Jan-1988   J. W. Pflugrath         Cold Spring Harbor Laboratory
C     !       Last update for floating point reflection positions
C     !
C     !    13-Nov-1987   A. G. W. Leslie, P. Brick, A. J. Wonacott   Imperial College
C     !                  Implementation of Reeke algorithm.
C     !
C     ! ***************************************************************
C---- Modified from subroutine OSCF1 from UCLA SCAN-12 SYSTEM
C     
C---- Contains George Reeke's geometric treatment
C     
C     IHKLSTR      Array containing  reflections for strategy option
C     MODE         Indicates where REEK has been called from
C     0  Most places
C     1  Called from NEWLIST
C     2  Called from TESTOVER
C     
C     
C     March 1978    R.M. Sweet
C     
C     On entry:
C     
C     PHIBEG               beginning rotation angle about Z for this pack
C     PHIEND               end rotation angle about Z for this pack
C     DELPHI(I=1,3)        missetting angles for the X, Y and Z axes
C     AMAT(3,3)            contains the orientation matrix X = AMAT . H
C     
C     
C     
C     
C     .. Include files ..
C&&*&& include  ../inc/parameter.f
C
C $Id: parameter.f,v 1.17 2009/10/28 16:43:34 harry Exp $
C
C--- awk generated include file  parameter.h
C---- START of include file parameter.h
C
C       PARAMETERS
C       IYLENGTH.. maximum number of I*2 words of data in the 
C                  "fast" (ie most rapidly changing) direction in the
C                  digitised image. This will be HALF the number of pixels
C                  for film data (each pixel is stored in one byte)
C                  but will equal the number of pixels for IP data.
C       IXWDTH...  The maximum number of "stripes" of data in the scanned image
C                  ie the number of pixels in the "slow" direction
C                  (This is the Y direction in the MOSFLM convention)
C                  Note that the array "IMAGE" used to store the image is
C                  declared as size IYLENGTH*IXWDTH I*2 words for IP data
C                  and 2*IYLENGTH*IXWDTH BYTES for film data.
C                  If this exceeds the
C                  available memory, set ixwdth=1, recompile program
C                  and use keyword "NOCORE" when running program.
C                  Note that for the POSTREF and ADDPART options,
C                  two images have to be stored in memory at once so
C                  IXWDTH should be twice the number of records in an
C                  image.
C       MAXHEAD    maximum length of image header (in 4 byte words)
C       NREFLS.... maximum number of spots per film in generate file (250,000)
C       MAXBOX.... maximum number of pixels in measurement box (1500)
C       MAXDIM.... maximum box size in either direction (pixels) (41)
C       MAXPAX.... maximum number of packs per generate file (10000)
C       MXDOV2..... maxdim/2
C       MAXBUFF... maximum size of buffer (I*2) for storing ods
C                  of active spots in subroutine meas(21,000).
C                  Must be .GE.  MAXBOX*(NNLINE-1) for subroutine process
C       MREF...... maximum number of reflections to be used in post
C                  refinement (6000)
C       NEXPAND... maximum number of expansions of the input measurement
C                  box (2)
C       NMASKS.... maximum number of different profiles (25). Note the
C                  connection between this parameter and NNLINE
C       NVECT..... maximum number of vectors for storing scanned image
C                  in filmplot (10000)
C       NIMAX..... maximum number of images to be used together in 
C                  postrefinement (NADD or WIDTH options) (100)
C       NNLINE...  maximum number of boundary lines for setting up
C                  the areas for profile fitting. The maximum possible
C                  number of standard profiles will be (NNLINE-1)**2
C                  although for a circular detector the actual number
C                  may be less than this as some boxes will lie entirely
C                  outside the detector.
C       NREJMAX... Maximum number of rejected background pixels, resulting
C                  either from overlap of adjacent spots or outliers from
C                  the background plane
C       NSPOTS...  Maximum number of found spots (for autoindexing) that can
C                  be stored (for all images). Also maximum number in 
C                  a file wriitten by IMSTILLS that can be 
C                  stored/displayed/edited. THis must be an even number
C       MCOLS....  Number of columns in output MTZ file
C       MCOLSTR..  Number of columns in output MTZ file for strategy option
C     
C       MTZ Orientation block
C        MBLENG is total length of block, MBLINT, MBLREA are numbers
C          of integers & reals
C       NDETREF    Maximum number of reflections used for detector parameter
C                  refinement (previously 62)
C       NRPAR....  Maximum number of refineable parameters for detector
C                  positional refinement (subroutine RDIST)
C       NSEGMAX..  Maximum number of segments in STRATEGY
C       NSEGMAXPR  Maximum number of segments in POST-REFINEMENT
C       MULTMAX... Maximum number of observations with same hkl in COMPLETE
C       MAXDIFF... Maximum number of different packs that a given hkl occurs on
C       NRESBIN... Maximum number of resolution bins (COMPLETE)
C
C       MAXIMG...  Maximum number of images that can be read in using the IMAGE
C                  keyword or the "read Image" menu option.
C       MXSPOT...  Maximum number of spots that can be found on one image
C                  (before rejection on spot size).
C       MXCENT...  Maximum number of active spots during spot finding 
C                  (findspots)
C
C       MGRA, NGRA... maximum number of reflections and images over which a 
C                     reflection can be spread for postrefinement.
C       MAXBGBOX    Maximum number of local background background boxes 
C                   in X and Y
C
C       MAXNPEAKS   Maximum number of local maxima within one spot
C       MAXEXCL     Maximum number of excluded areas of the same type
C                   eg reactangles, quadrilaterals, arcs, resolution shells
C
C     .. Parameters ..
      INTEGER IXWDTH
c      PARAMETER (IXWDTH=8192)
      PARAMETER (IXWDTH=12288)
      INTEGER IYLENGTH
c      PARAMETER (IYLENGTH=4096)
      PARAMETER (IYLENGTH=6144)
      INTEGER MAXHEAD
      PARAMETER (MAXHEAD=5120)
      INTEGER MAXBOX
      PARAMETER (MAXBOX=3000)
      INTEGER MAXDIM
      PARAMETER (MAXDIM=41)
      INTEGER MAXPAX
      PARAMETER (MAXPAX=10000)
      INTEGER MXDOV2
      PARAMETER (MXDOV2=MAXDIM/2)
      INTEGER NEXPAND
      PARAMETER (NEXPAND=2)
      INTEGER NNLINE
      PARAMETER (NNLINE=8)
      INTEGER NMASKS
      PARAMETER (NMASKS=49)
      INTEGER MAXBUFF
      PARAMETER (MAXBUFF=21000)
      INTEGER NREFLS
      PARAMETER (NREFLS=250000)
      INTEGER MREF
      PARAMETER (MREF=6000)
      INTEGER NVECT
      PARAMETER (NVECT=10000)
      INTEGER NIMAX
      PARAMETER (NIMAX=100)
      INTEGER NREJMAX
      PARAMETER (NREJMAX=1000)
      INTEGER NSPOTS
      PARAMETER (NSPOTS=5000)
      INTEGER MCOLS
      PARAMETER (MCOLS=18)
      INTEGER MCOLSTR
      PARAMETER (MCOLSTR=6)
      INTEGER NREFSTR
C
C---- Each reflection for strategy run needs MCOLSTR I*2 words
C     plus an I*4 word for the merging
C
      PARAMETER (NREFSTR = IXWDTH*IYLENGTH/(2+MCOLSTR))
      INTEGER MBLENG,MBLINT,MBLREA
      PARAMETER (MBLENG=185,MBLINT=29,MBLREA=156)
      INTEGER NDETREF
      PARAMETER (NDETREF=400)
      INTEGER NRPAR
      PARAMETER (NRPAR=14)
      INTEGER NSEGMAX
      PARAMETER (NSEGMAX=100)
      INTEGER NSEGMAXPR
      PARAMETER (NSEGMAXPR=100)
      INTEGER MULTMAX
      PARAMETER (MULTMAX=100)
      INTEGER MAXDIFF
      PARAMETER (MAXDIFF=100)
      INTEGER NRESBIN
      PARAMETER (NRESBIN=20)
      INTEGER MXSPOT
      PARAMETER (MXSPOT=5000)      
      INTEGER MAXIMG
      PARAMETER (MAXIMG=100)      
      INTEGER NPIXBG
      PARAMETER (NPIXBG=51)
      INTEGER MXCENT
      PARAMETER (MXCENT=500)
      INTEGER    NGRA,MGRA
      PARAMETER (NGRA=20)
      PARAMETER (MGRA=50000)
      INTEGER MAXBGBOX
      PARAMETER (MAXBGBOX=500)
      INTEGER MAXNPEAKS
      PARAMETER (MAXNPEAKS=500)
      INTEGER MAXEXCL
      PARAMETER (MAXEXCL=50)
C&&*&& end_include  ../inc/parameter.f
C     
C     ..
C     .. Scalar Arguments ..
      INTEGER MODE
C     ..
C     .. Array Arguments ..
      INTEGER*2 IHKLSTR(MCOLSTR,NREFSTR)
C     
C     
C     .. Local Scalars ..
      real a1,sca1,avecx,vecx,p1,p2,px1,px2
      REAL A,AVEC,DELEPS1,DTEMP,DSTMAX2,FP,FP2,FQ,FR,GAMMAX,PA,PB,
     +     PC,PD,PMAX,PMAXE,PMIN,PMINE,PX,PY,PZ,QMAXE,QMINE,S1,
     +     S1P2R2,S2,S3,S4,S5,S5P,S6,S6P,SIN2T,SINSQ,SINTH,T1,T2,
     +     DELEPS2,DRATIO,PXCEN,PYCEN,EPS,
     +     DSTMIN2,SCHI,CCHI,SOMEGA,COMEGA,FDUM,COSMU1,COSMU2,SINMU1,
     $     SINMU2
      integer istat,j1,j2
      INTEGER I,IER,IFAIL,IFREC,ILOOP,IP,IPLB,IPLE,IQ,IQLB,IQLE,
     +     IQMAX,IQMIN,IR,IRMAX,IRMIN,ISIGN,J,K,
     +     KT,L,NLOOP,NRT,ICOUNT,ISPOT,INVFLAG,IISWUNG,
     +     ISYSAB,IFLAG
      LOGICAL ABSNT
      CHARACTER CALLEDFROM*80
C     ..
C     .. Local Arrays ..
      real pmn(2),pmx(2)
      REAL B0BEG(3,3),B0END(3,3),BBEG(3,3),BEND(3,3),CA(3,3),P(3,3,2),
     +     P0(3,3,2),P0OLD(3,3,2),P1H(2),P1H0(2),P2H(2),P2H0(2),P3H(2),
     +     P3H0(2),POLD(3,3,2),PP(3,4,2),PX0(2),PY0(2),PZ0(2),Q(3,3,2),
     +     QU(2),RLB(2),RLE(2),RMPB(3,3),RMPE(3,3),RS0(2),RS1(2),RT(2),
     +     RU0(2),RU1(2),RU2(2),T(4,4),VEC(3),X12(2),Y12(2),Z12(2),
     $     ORTMAT(3,3),rotmat(3,3),phiaxis(3),phimat(3,3),dummat(3,3),
     $     invphimat(3,3),omegaaxis(3),omegamat(3,3),
     $     invomegamat(3,3),KAPPaaxis(3),MUMAT1(3,3),MUMAT2(3,3),
     $     XYZ(3),XYZNEW(3),XYZAXIS(3)
      INTEGER NRTA(2)
C     ..
C     .. External Functions ..
      INTEGER LENSTR
      EXTERNAL LENSTR
C     ..
C     .. External Subroutines ..
      EXTERNAL DSTAR,JSWTCH,LIMITS,LOOPST,MATMUL3,MINV33,QUAD2,SETAX,
     +     SPTEST,STORSPOT,SURMP,SWITCH,MSYSABS,XYSPOT,WMTZSP,
     +     EPSLON
C     ..
C     .. External Functions ..
      REAL DOT
      EXTERNAL DOT
C     ..
C     .. Intrinsic Functions ..
      INTRINSIC ABS,ATAN,ATAN2,INT,MAX,MIN,MOD,NINT,REAL,SIGN,SIN,SQRT
C     ..
C     .. Common blocks ..
C&&*&& include  ../inc/cell.f
C
C $Id: cell.f,v 1.3 2005/05/20 15:05:07 harry Exp $
C
C--- awk generated include file  cell.h
C---- START of include file cell.h
C
C     CELL cell dimensions (real space)
C     RCELL reciprocal cell parameters in dimensionless rlu
C
C     .. Arrays in Common /CELLCOM/ ..
      REAL UMAT,BMAT,GMAT,CELL,RCELL,UMATCELL,SOFTCELL,VOLUME
      INTEGER LCELL,ICRYST,NUMSPG,NLAUE
C     ..
C     .. Common Block /CELLCOM/ ..
      COMMON /CELLCOM/UMAT(3,3),BMAT(3,3),GMAT(3,3),CELL(6),RCELL(6),
     $       UMATCELL(6),SOFTCELL,VOLUME,LCELL(6),ICRYST,NUMSPG,NLAUE
C     ..
C
C
C&&*&& end_include  ../inc/cell.f
C&&*&& include  ../inc/condata.f
C
C $Id: condata.f,v 1.32 2009/09/03 16:24:33 harry Exp $
C
C--- awk generated include file condata.h 
C---- START of include file condata.h 
C 
C
C     FIXSWAP     Forces reversal of normal byte-swapping choice.
C
C---- SUMPART True if two images are to be stored in memory at the
C               same time. This will be the case if post-refinement
C               (other than POSTHOC post-refinement for off-line
C               scanners) is being performed. Note that SUMPART is NOT
C               used to determine if partials should be added across
C               images (this is ADDPART)
C
C---- NEWPREF True if allowing partials over multiple images in post-
C             refinement.
C
C---- ADDPART True if partials are to be summed across images. This is
C               only appropriate for fixed origin (ie on-line)
C               scanners where the X-ray dose is identical for
C               each image.
C     Direct beam coordinates
C             These are read into XMM(3), YMM(3) where (3) is for A,B,C packs
C             Immediately on reading in, these values are transferred
C             into XCENMM, YCENMM, XCENMMIN(J,3) where J=1->MAXPAX.
C
C             If an IMAGE keyword has been given, XCENMM(1,1)=XMM(1) and
C             YCENMM(1)=YSCAL*YMM(1). If swung out, YCENMM(1,1) is updated.
C             If a BEAM keyword has not been given, XMM,YMM, XCENMM,YCENMM,
C             XCENMMIN are all set to the middle of the image.


C             Then, when reflecting input to logfile, it AGAIN sets up
C             XCENMM,YCENMM for all images using XMM,YMM, this time
C             using YSCAL to set up YCENMM, and updating YCENMM if the
C             detctor is swung out. (label 708), DO loop 710. If image
C             is "inverted", corrects XCENMM for all images.


C             XCEN,YCEN are set in "mosflm" to XCENF, YCENF plus
C             camera constants, and XCENF,YCENF are in turn set from
C             XCENMM,YCENMM. Thus XCENMM,YCENMM are what is actually
C             used to define the beam position.

C
C     LPREF   If TRUE, return to display after refinement over entire
C             image. Only active when integrating interactively. Set by
C             toggle button in Parameter window.
C

C     LOVERLAP  If TRUE, do not call the OVERLAP subroutine

C     ALLOUT  If TRUE, all reflections (whether measured or not, or
C             classified as BADSPOTS or not, will be written to the
C             output MTZ file.
C
C     NTDIG   Number of digits in image number, returned as zero if
C             there is an error in the template. Only used if TEMPLATE
C             keyword given.
C
C     TEMPLATE is TRUE if a TEMPLATE keyword has been given.
C
C     NOLP    If TRUE, do NOT apply the Lorentz Polarisation corrections
C
C     MULTIMTZ True if writing each "block" of images to a separate MTZ file
C
C     DISPMENU True if the run was started with a IMAGE keyword. Not to be
C              confused with WINOPEN which is true if the X-window display
C              is being used, but this is not necessarily starting with
C              a "IMAGE" keyword.
c     newgui - this means that we're talking through the new GUI.
c              except that we can't have it here because the prsummary 
c              subroutine, where we REALLY want it, clashes with this common
C
C     HACTIVEMASK,LACTIVEMASK,LACTIVE - only for Rigaku images which 
C     contain a compressed "active mask" (size=HACTIVEMASK bytes)
C     at the end of the image. Compression uses a modified run length encoding
C     at present (10.01.2003).
C
C     MINBATCH Minimum allowed batch number to be written to an open
C              MTZ file (MTZ library imposes that batch numbers must 
C              increase as file is written).
C     ..
C     .. Arrays in common /CONDATA/ ..
      REAL XCENMM,YCENMM,THFOIL,PHIBEGA,PHIENDA,RSYM,XMM,YMM,
     +     XCENMMIN,YCENMMIN
      REAL RMSLIM,WRMSLIM,VLIM,XMID,SEP,THICK,PTMIN,REFREJ,WAIT,
     +     YSCALIN,FULLFRAC,WTIME
C     ..
C     .. Arrays in common /CONDATA/ ..
      INTEGER IDPACK,NFPACK,NFIRST,ICASSET
      INTEGER IPACK1A,IPACK2A,ISERAR,PICKER
      LOGICAL AVPROF,FILMPLOT,FORCEB,FORCEC
C
C     .. Scalars in common /CONDATA/ ..
C     ..
      INTEGER NPACK,NCYC,MAXNX,MAXNY,ITHRESHF,NSIG,IRFMIN,
     +        IRFINC,IXSHIFT,IYSHIFT,LIMIT,NBLOCK,INOGEN,NFGEN,MINREF,
     +        ISERADD,NSEG,NSYM,NSYMP,NRUN,NSERTOT,IWAVE,ISWUNG,
     $        IBEAMMU,ITILT,ITWIST,IPIX,IRMINXY,ICUT,IPRCUT,ILIMIT
      INTEGER IMAT,ICELL,IUMAT,LSYMM,IDIST,IBEAM,ISCAN,NLINE,NRLINE,
     +        NTLINE,ISTARTP,IRAST,INEWMAT,ISEP,NSAVELINE,IPTIME,
     +        ISTRT,IANGLE,IBACKS,IPOLAR,IDIVH,IDIVV,IGAIN,IBLOCK,
     +        IHKLOUT,IGENF,INRES,NTDIG,DELAY,IMULTI,IMISS,IMISSMAT,
     +        IIDENT,HACTIVEMASK,ITWOTHETA,MINBATCH,ILABVIEW,INVVIEW,
     $     IINVVIEW,IHKLDIR,IBGSIG,NRLEFT
      LOGICAL FINDCC,READCC,NOFID,INTERPOL,CONVOL,NOMEAS,
     +        USEPAR,USEOVR,SUMPART,USEBOX,POSTREF,ADDPART,
     +        FIXED,POWDER,RWEIGHT,NOREF,MULTISEG,FIXSWAP,POSTHOC,
     +        LPREF,LPINTG,DISPMENU,PRMODE,PRCELL,TEMPLATE,
     +        LOVERLAP,ALLOUT,NOLP,NEWPREF,NOBACK,MOSEST,NUSPOT,
     $        NUBACK,NUFIND,HARVESTREADY,HEADINFO,MULTIMTZ,ANDREW, 
     +        spostref,newgui,LACTIVEMASK,USERSPOT,HEADONLY,PHIONLY,
     $        NO_XML,TESTSOCK,PICKLOG,EXPLICIT_CELL,LSIMULATE,
     $     LONGERNAME
C     ..
C real arrays, then scalars, integer arrays, scalars, logicals
      COMMON /CONDATA/
     $       XCENMM(MAXPAX,3),
     +       YCENMM(MAXPAX,3), THFOIL(3),PHIBEGA(MAXPAX),
     $       PHIENDA(MAXPAX),RSYM(4,4,96),XMM(3),YMM(3),
     $       XCENMMIN(MAXPAX),YCENMMIN(MAXPAX),
     $       RMSLIM,WRMSLIM,VLIM,XMID,SEP,THICK,PTMIN,REFREJ,WAIT,
     +       YSCALIN,FULLFRAC,WTIME,
     $        IDPACK(MAXPAX),NFPACK(MAXPAX),NFIRST(MAXPAX),
     +        ICASSET(MAXPAX),IPACK1A(50),
     +        IPACK2A(50),ISERAR(50),PICKER(4),
     $        AVPROF(MAXPAX),FILMPLOT(MAXPAX),FORCEB(MAXPAX),
     +        FORCEC(MAXPAX),
     $        NPACK,NCYC,MAXNX,MAXNY,ITHRESHF,NSIG,IRFMIN,
     +        IRFINC,IXSHIFT,IYSHIFT,LIMIT,NBLOCK,INOGEN,NFGEN,MINREF,
     +        ISERADD,NSEG,NSYM,NSYMP,NRUN,NSERTOT,IWAVE,ISWUNG,
     $        IBEAMMU,ITILT,ITWIST,IPIX,IRMINXY,ICUT,IPRCUT,ILIMIT,
     $        IMAT,ICELL,IUMAT,LSYMM,IDIST,IBEAM,ISCAN,NLINE,NRLINE,
     +        NTLINE,ISTARTP,IRAST,INEWMAT,ISEP,NSAVELINE,IPTIME,
     +        ISTRT,IANGLE,IBACKS,IPOLAR,IDIVH,IDIVV,IGAIN,IBLOCK,
     +        IHKLOUT,IGENF,INRES,NTDIG,DELAY,IMULTI,IMISS,IMISSMAT,
     +        IIDENT,HACTIVEMASK,ITWOTHETA,MINBATCH,ILABVIEW,INVVIEW,
     $        IINVVIEW,IHKLDIR,IBGSIG,NRLEFT,FINDCC,READCC,NOFID,
     +        INTERPOL,CONVOL,NOMEAS,USEPAR,USEOVR,SUMPART,USEBOX,
     +        POSTREF,spostref, ADDPART,FIXED,POWDER,RWEIGHT,NOREF,
     +        MULTISEG,FIXSWAP,POSTHOC,LPREF,LPINTG,DISPMENU,PRMODE,
     $        PRCELL,TEMPLATE,
     +        LOVERLAP,ALLOUT,NOLP,NEWPREF,NOBACK,MOSEST,NUSPOT,
     $        NUBACK,NUFIND,HARVESTREADY,HEADINFO,MULTIMTZ,ANDREW,
     $        newgui,LACTIVEMASK,USERSPOT,HEADONLY,PHIONLY,NO_XML,
     $        TESTSOCK,PICKLOG,EXPLICIT_CELL,LSIMULATE,
     $     LONGERNAME


C&&*&& end_include  ../inc/condata.f
C&&*&& include  ../inc/debug.f
C
C $Id: debug.f,v 1.2 2008/07/24 09:42:21 andrew Exp $
C
C--- awk generated include file  debug.h
C---- START of include file debug.h
C
C
C
C     .. Arrays in common /DEBUG/ ..
      REAL XWARN
      INTEGER NDEBUG,IWARN
      LOGICAL DEBUG,LPRINT,DUMP,WARN
C
C     .. Scalars in common /DEBUG/ ..
      REAL BGRLIM
      INTEGER NDUMP,IDUMP,MXDUMP
      LOGICAL SPOT
C     
C     ..
C     .. Common Block /DEBUG/..
      COMMON /DEBUG/XWARN(20,100),BGRLIM,NDEBUG(100),IWARN(20,100),
     $       NDUMP,IDUMP,MXDUMP,DEBUG(100),LPRINT(20),DUMP(30),
     +       WARN(100),SPOT
C     ..
C
C&&*&& end_include  ../inc/debug.f
C&&*&& include  ../inc/extras.f
C
C $Id: extras.f,v 1.2 2003/04/04 14:22:01 harry Exp $
C
C--- awk generated include file  extras.h
C---- START of include file extras.h
C
C
C     .. Scalars in common /EXTRAS/ ..
      INTEGER JUMPAX,NPACKS
      LOGICAL ISKIP,AFILM,BFILM,CFILM,STARTA,STARTB,STARTC,NOSTOP
C     ..
C     .. Common block /EXTRAS/ ..
      COMMON /EXTRAS/JUMPAX,NPACKS,ISKIP,AFILM,BFILM,CFILM,STARTA,
     +       STARTB,STARTC,NOSTOP
C     ..
C
C
C&&*&& end_include  ../inc/extras.f
C&&*&& include  ../inc/fid.f
C
C $Id: fid.f,v 1.5 2007/11/06 12:49:03 harry Exp $
C
C--- awk generated include file  fid.h
C---- START of include file fid.h
C
C     XCENF,YCENF  Coordinates (in 10 micron units) of the direct beam
C                  position relative to an origin at the position of the
C                  first pixel in the digitised image.(The SCANNER
C                  coordinate frame).
C                  For IP data this comes from the defined
C                  direct beam coordinates, for film data it is the
C                  midpoint of fiducials 1 and 3.
C
C     CCX,CCY      The difference (in 10 micron units) between the
C                  refined position of the direct beam (XCEN,YCEN) and
C                  the ideal direct beam coordinates (XCENF,YCENF),
C                  in the SCANNER coordinate frame.
C                  CCX,CCY are updated in RDIST. They are in "pixels"
C                  rather than mm (but expressed in 10micron units).
C
C     DTOFD        The distance (in 10 micron units) from the crystal
C                  to the detector along a normal to the detector.
C                  For flat, unswung detectors, or swung on a 2 theta arm,
C                  this is the same as CTOFD and XTOFD. It differs for
C                  Vee shaped cassettes. Assigned in START and never changed.
C                  Only actually used in RMAXR for calculating box sizes.
C
C     .. Arrays in common /FID/ ..
      REAL CCOMABC
      INTEGER FSPOS,CCXABC,CCYABC
C     ..
C     .. Scalars in common /FID/ ..
      REAL OMEGAF,OMEGAFD,CCOM,DTOFD,XCENF,YCENF
      INTEGER MM,MMDB,NFID,CCX,CCY,IYOFF,LABVIEW
      CHARACTER SPOTFILEORIGIN*2,SPOTFILEAXISORDER*2,SWINGAXIS*2
C     ..
C     .. Common block /FID/ ..
      COMMON /FID/CCOMABC(3),OMEGAF,OMEGAFD,CCOM,DTOFD,XCENF,YCENF,
     $     FSPOS(4,2),
     +     CCXABC(3),CCYABC(3),MM,MMDB,NFID,CCX,CCY,IYOFF,LABVIEW,
     $     SPOTFILEORIGIN,SPOTFILEAXISORDER,SWINGAXIS
C     ..
C
C
C&&*&& end_include  ../inc/fid.f
C&&*&& include  ../inc/header.f
C
C $Id: header.f,v 1.13 2009/09/03 16:24:33 harry Exp $
C
C--- awk generated include file  header.h
C---- START of include file header.h
C     .. Scalars in common block /HEADER/
      REAL HDIST,HWAVE,HRAST,HTOR,HPHIS,HPHIE,HPHIR,HOMEGAS,
     $     HOMEGAE,HTWOTHETA,HKAPPA,HCHI,
     $     HBEAMX,HBEAMY,HCCOMEGA,HTWIST,HTILT,HSIZED
      INTEGER NHEAD,NTAIL,HNULLPIX,HSERIAL,HYEAR,HDATE,HCOMPR,
     $     HBIAS,SUMBYTES,HUNDER,HDATEC,HCUTOFF,HPRCUTOFF
      LOGICAL USEHDR,USETAIL,USEDIST,USEWAVE,USEPHI,HDRSIZE
C     ..
C     .. Arrays in common block /HEADER/
      INTEGER IHEAD,HOVER
C     ..
C     .. Common Block /HEADER/
      COMMON /HEADER/ HDIST,HWAVE,HRAST,HTOR,HPHIS,HPHIE,HPHIR,
     $     HOMEGAS,HOMEGAE,HTWOTHETA,HKAPPA,HCHI,
     $     HBEAMX,HBEAMY,HCCOMEGA,HTWIST,HTILT,HSIZED,
     $     IHEAD(MAXHEAD),
     $     HOVER(3),NHEAD,NTAIL,HNULLPIX,HSERIAL,HYEAR,HDATE,
     +     HCOMPR,HBIAS,SUMBYTES,HUNDER,HDATEC,HCUTOFF,HPRCUTOFF,
     $     USEHDR,USETAIL,
     +     USEDIST,USEWAVE,USEPHI,HDRSIZE
C     ..
      CHARACTER HCOMPRESS*3,HMONTH*3,HOSCAXIS*6
      COMMON /CHEADER/ HCOMPRESS,HMONTH,HOSCAXIS
C&&*&& end_include  ../inc/header.f
C&&*&& include  ../inc/ioo.f
C
C $Id: ioo.f,v 1.7 2009/05/13 11:57:53 harry Exp $
C
C--- awk generated include file  ioo.h
C---- START of include file ioo.h
C
C
C
C     .. Scalars in common block /IOO/ ..
      INTEGER IOUT,IUNIT,ITIN,ITOUT,INOD,INMO,IDU,NWRN,IBRIEF,ISUMMR,
     +        ICOORD,SERVERFD,SERVERFDIN,NSHUTERR,dnafd
      LOGICAL ONLINE,ONEFILE,FHEADER,BRIEF,GRAPH,IOERR,
     $     NODISPLAY,LBELL,JPGOUT,SOCKLO,LBEST,dnaout,INMOOPEN,
     $     XMLOPEN
      CHARACTER dna_image*80,xmlfile*80
C     ..
C     .. Common block /IOO/ ..
c      COMMON /IOO/IOUT,IUNIT,ONLINE,ITIN,ITOUT,INOD,INMO,IDU,NWRN,
c     +            ONEFILE,FHEADER,BRIEF,IBRIEF,GRAPH,ISUMMR,ICOORD,
c     +            IOERR,NODISPLAY,LBELL
C     ..
C
C
      COMMON /IOO/IOUT,IUNIT,ITIN,ITOUT,INOD,INMO,IDU,NWRN,IBRIEF,
     +        ISUMMR,ICOORD,SERVERFD,SERVERFDIN,NSHUTERR,ONLINE,ONEFILE,
     +        FHEADER,BRIEF,GRAPH,IOERR,NODISPLAY,LBELL,JPGOUT,
     $        SOCKLO,LBEST, dnafd, dnaout,INMOOPEN,XMLOPEN
      COMMON /CIOO/dna_image,xmlfile

C&&*&& end_include  ../inc/ioo.f
C&&*&& include  ../inc/lmb.f
C
C $Id: lmb.f,v 1.8 2009/01/08 18:03:14 harry Exp $
C
C--- awk generated include file  lmb.h
C---- START of include file lmb.h
C ODSCAL is to scale image numbers into the range 0-255 for plotting
C average profiles.
C  GAIN should be equal to the overall gain (image counts per X-ray photon)
C of the system, and is used to evaluate standard deviations based on
C counting statistics assuming independent pixels (ie point spread function
C less than pixel size).
C INVERTX true if image is inverted in the slow (X) direction when read in.
C ISCAL is to scale final integrated intensities and sigmas
C IDIVIDE is the adc offset
C ICONST is a constant to be added to all pixels (normally zero) to
C        allow processing of images with zero pixel values in the scanned
C        area.
C IMGP is true if working with image plate data
C SPIRAL is true for scanners with a spiral readout (Mar, DIP2000)
C ORTHOG is true for scanners with orthogonal scan (FUJI, RAXIS, MD)
C NULLPIX is the value of pixels within the image but not in the active
C area of the detector
C TILED is true if there are inactive areas of the detector within the
C       inscribing circle or square.
C
C NTILEX Number of tiles in X direction
C NTILEY Number of tiles in Y direction
C TILEX  X Coordinates of the midpoints of the null areas between tiles
C TILEY  Y Coordinates of the midpoints of the null areas between tiles
C TILEWX Width of the null areas between tiles in X
C TILEWY Width of the null areas between tiles in Y


C MACHINE and MODEL denote the type of detector. 
C
C MACHINE is used in the following subroutines:
C GETBLK, GETHDR, INTPXL, INTPXL2, MXDSPL, OPENODS, PROCESS, PUTPXL
C Currently coded types are:
C
C         MACHINE        MODEL               COMMENTS
C         =======        =====               ========
C         MAR            180, 300, 345
C         RAXI(S)        RAXISII, RAXISIV
C         MD
C         FUJI
C         CCD1           CCD1                Princetown CCD at CHESS,Tiff format
C         CCD2           CCD ?               ESRF CCD detector
C         ADSC           QUAD1               ADSC 2x2 CCD detector
C
C TRUSTED whether or not the image header information can be trusted for 
C         automatic processing
C     .. Scalars in Common Block /LMB/ ..
        REAL ODSCAL,GAIN,LOGA,LOGB
        INTEGER ISCAL,IDIVIDE,ICONST,NULLPIX,NTILEX,NTILEY,
     $    RAXISCOMP,IIDIVIDE,COMPRESSION
        LOGICAL IMGP,INVERTX,SPIRAL,ORTHOG,CIRCULAR,TILED,SETADC,
     $    NEWRAXIS,BRUKNEW,TRUSTED
        CHARACTER MACHINE*4,MODEL*8

C     ..
C     .. Arrays in common /LMB/
        INTEGER TILEX,TILEY,TILEWX,TILEWY
C
C     .. Common Block /LMB/ ..
        COMMON /LMB/ ODSCAL,GAIN,LOGA,LOGB,ISCAL,IDIVIDE,ICONST,
     +       NULLPIX,NTILEX,NTILEY,RAXISCOMP,IIDIVIDE,COMPRESSION,
     +       TILEX(20),TILEY(20),TILEWX(20),TILEWY(20),IMGP,
     +       INVERTX,SPIRAL,ORTHOG,CIRCULAR,TILED,SETADC,
     $       NEWRAXIS,BRUKNEW,TRUSTED
        COMMON /LMBC/ MACHINE,MODEL

C&&*&& end_include  ../inc/lmb.f
C&&*&& include  ../inc/loop.f
C
C $Id: loop.f,v 1.1 2002/05/02 10:46:55 harry Exp $
C
C--- awk generated include file  loop.h
C---- START of include file loop.h
C
C
C     .. Scalars in Common Block /LOOP/ ..
      INTEGER IRLB,IRLE
C     ..
C     .. Common Block /LOOP/ ..
      COMMON /LOOP/IRLB(2),IRLE(2)
C     ..
C
C
C&&*&& end_include  ../inc/loop.f
C&&*&& include  ../inc/misc.f
C
C $Id: misc.f,v 1.2 2009/09/03 16:24:33 harry Exp $
C
C--- awk generated include file  misc.h
C---- START of include file misc.h
C
C
C
C     .. Scalars in common /MISC/ ..
      REAL PHIBEG,PHIEND,PHIRNG,RMIN,RMAX,WAVE
      INTEGER IPACKID,MININT,IERRFLG
C     ..
C     .. Arrays in common /MISC/ ..
      REAL DELPHI,RESANI
      INTEGER IAX
C     ..
C     .. LOGICAL
      LOGICAL ANITES

C     ..
C     .. Common Block /MISC/ ..
      COMMON /MISC/DELPHI(3),RESANI(3),PHIBEG,PHIEND,PHIRNG,RMIN,RMAX,
     $       WAVE,IAX(3),IPACKID,MININT,IERRFLG,ANITES
C     ..
C
C
C&&*&& end_include  ../inc/misc.f
C&&*&& include  ../inc/ori.f
C
C $Id: ori.f,v 1.2 2007/07/12 13:25:56 andrew Exp $
C
C--- awk generated include file  ori.h
C---- START of include file ori.h
C
C     XCEN,YCEN    Coordinates (in 10 micron units) of the direct beam
C                  position relative to an origin at the position of the
C                  first pixel in the digitised image.(The SCANNER
C                  coordinate frame). These parameters are refined for
C                  each image. 
C
C     XCEN0,YCEN0  Coordinates of direct beam position at zero swing angle.
C                  (Needed for pxtomm conversion for swung detectors)
C                  These values are assigned on the basis of input direct
C                  beam coordinates, corrected for swing angle if necessary.
C                  They are not (currently) updated during refinement.
C
C     XOFF,YOFF    Distance between centre of detector and direct beam.
C
C     ..
C     .. Arrays in common /ORI/ ..
      LOGICAL FIXPAR
C
C     .. Scalars in common block /ORI/ ..
      REAL COSOM0,SINOM0,XTOFRA,YSCAL,TILT,TWIST,BULGE,
     +     VBNEG,VBPOS,VTILT,VTWIST,VVERT,TOFF,BULGE2,PBULGE,ROFF,
     +     RDTOFF,RDROFF,ROFFPHI,TOFFPHI,JUNK3,XCEN,YCEN,XCEN0,YCEN0,
     +     XOFF,YOFF,TILTMAT,TWISTMAT,DETNOR,DPSIX,SMTWIST,SMTILT,
     +     SMOMEGA0,SMYSCAL,SMTOFF,SMROFF,SMXTOFRA
      INTEGER CBAR,NODES,NPHI,NSM1,NSM2
      LOGICAL RESETCCOM,NOSMOOTH
C     ..
C     .. Common Block /ORI/ ..
      COMMON /ORI/COSOM0,SINOM0,XTOFRA,YSCAL,TILT,TWIST,BULGE,
     $       VBNEG,VBPOS,VTILT,VTWIST,VVERT,TOFF,BULGE2,PBULGE,ROFF,
     $       RDTOFF,RDROFF,ROFFPHI,TOFFPHI,JUNK3,XCEN,YCEN,XCEN0,
     +       YCEN0,XOFF,YOFF,TILTMAT,TWISTMAT,DPSIX,DETNOR(3),CBAR,
     +       NODES,NPHI,FIXPAR(NRPAR),
     $       RESETCCOM,SMTWIST,SMTILT,SMOMEGA0,SMYSCAL,SMTOFF,SMROFF,
     +       SMXTOFRA,NSM1,NSM2,NOSMOOTH
C     ..
C
C
C&&*&& end_include  ../inc/ori.f
C&&*&& include  ../inc/gendata.f
C
C $Id: gendata.f,v 1.2 2003/01/10 16:17:53 andrew Exp $
C
C--- awk generated include file  gendata.h
C---- START of include file gendata.h
C
C     IMG       Partiality indicator. 0 for full reflections, 1 to 100
C                   for partials. Negative for partials at the start of the
C                   rotation range, +ve for partials at the end of the 
C                   rotation. Set in subroutine REEK using DELEPS calculated
C                   in subroutine DSTAR
C
C     IRG       Reflection flag  (Set by SPTEST called from DSTAR)
C               =  0  Spot can be measured
C               =  1  Outside R, X, Y limits
C               =  2  Overlapping spot (set later)
C               =  3  Too wide in phi (more than NWMAX images)
C               =  4  DST .GT. DSTMAX  Not included in final film list -
C                       used only to check for overlaps at edge of film.
C               = 10  Spot is within cusp, but will be observed...not included
C                     in final spot list but must be included in predicted
C                      pattern
C
C               =  21  Spot present on 2 images, this is 1st
C               =  22  Spot present on 2 images, this is 2nd
C
C               =  31  Spot present on 3 images, this is 1st
C               =  32  Spot present on 3 images, this is 2nd
C               =  33  Spot present on 3 images, this is 3rd
C
C               =  41  Spot present on 4 images, this is 1st
C               =  42  Spot present on 4 images, this is 2nd
C               =  43  Spot present on 3 images, this is 3rd
C               =  44  Spot present on 4 images, this is 4th
C
C                 etc etc
C
C     XG        Virtual detector X coordinate in 10 micron units, relative to
C               an origin at the direct beam position. X is parallel to the
C               Y axis in the laboratory frame, ie orthogonal to the rotation
C               axis.
C
C     YG        Virtual detector Y coordinate in 10 micron units, relative to
C               an origin at the direct beam position. Y is parallel to the
C               Z axis in the laboratory frame, ie  the rotation axis.
C
C     IX,IY     are the coordinates of the reflection in pixels
C               (integers) wrt the first pixel in the image (lower left corner
C               cameramans view). For testing for spot overlap, these
C               coordinates are in 10 micron units. Also used for display
C               pixel coordinates when displaying predicted pattern.
C
C     IREC      Pointer to the record number of a particular spot in the
C               list of generated reflections.
C
C
C     ..
C     .. Arrays in common /GENDATA/ ..
      REAL FRACG,PHIG,PHIWG,XG,YG,GOODFIT
      INTEGER INTG,IPRO,IX,IY,IREC
      INTEGER*2 IRG,IMG,IGFLAG,ISDPRO,ISDG,IHG,IKG,ILG,IMPARTG,
     +          MISYMG
C     .. Scalars in common /GENDATA/ ..
      INTEGER IPACKREC,IPACKHEAD,IRECLAST
C     ..
C     .. Common block /GENDATA/ ..
      COMMON /GENDATA/FRACG(NREFLS),PHIG(NREFLS),PHIWG(NREFLS),
     $       XG(NREFLS),YG(NREFLS),INTG(NREFLS),IPRO(NREFLS),
     $       IX(NREFLS),IY(NREFLS),IREC(NREFLS),IRG(NREFLS),IMG(NREFLS),
     +       IGFLAG(NREFLS),ISDPRO(NREFLS),ISDG(NREFLS),
     +       IHG(NREFLS),IKG(NREFLS),ILG(NREFLS),IMPARTG(NREFLS),
     +       MISYMG(NREFLS),GOODFIT(NREFLS),IPACKREC,IPACKHEAD,
     +       IRECLAST
C     ..
C
C

C&&*&& end_include  ../inc/gendata.f
C&&*&& include  ../inc/postreek.f
C
C $Id: postreek.f,v 1.1 2002/05/02 10:47:07 harry Exp $
C
C
C common block so we don't have to recalculate values of FRAC, PHIW, PHI
C for new post-refinement
C 
        REAL PHI,PHIW,FRAC
        COMMON /POSTREEK/ PHI,PHIW,FRAC
 
C&&*&& end_include  ../inc/postreek.f
C&&*&& include  ../inc/reek_mod.f
C
C $Id: reek_mod.f,v 1.1 2002/05/02 10:47:11 harry Exp $
C
      REAL X,Y
      INTEGER IHKL,KHF
      COMMON /REEK_MOD/ X,Y,IHKL(3),KHF
C&&*&& end_include  ../inc/reek_mod.f
C&&*&& include  ../inc/reeke.f
C
C $Id: reeke.f,v 1.15 2008/10/22 08:50:48 andrew Exp $
C
C--- awk generated include file  reeke.h
C---- START of include file reeke.h
C
C     TOR     For synchrotron sources, degree of polarisation of the beam
C     IMONO   Collimation flag for polarisation.
C             = 0   Pinhole or mirrors
C             = 1   Graphite Monochromator
C             = 2   Synchrotron, use TOR
C     NWMAX   Maximum reflection width in images
C     DSTMAX  dimensionless rlu, = WAVE/RES where RES is the maximum
C             resolution in Angstrom.
C     DSTMIN  dimensionless rlu, = WAVE/DMAX where DMAX is the maximum
C              Bragg spacing
C     S0      radiation source vector (-1,0,0), may be modified by MU values
C     SOURCE  radiation source vector - basis for s0
C     GONIO_angle:  machine angles for generalized goniostats
C     GONIO_angle_SET: fixed offset angles for 3- and 4-circle goniostats
C                      i.e. currently 54.74 deg for Bruker CHI, 50.0deg for
C                      Nonius and Oxford KAPPA 
C     ..
C     .. Arrays in common block /REEKE/ ..
      REAL RMC,AMAT,SCAXIS,S0,s0unit,CAMCON,BEAMMU
C     ..
C     .. Scalars in common block /REEKE/ ..
      REAL X1,X2,Y1,Y2,Z1,Z2,XYS,DSTAR2,DSTMAX,DSTPL,DSTPL2,
     +     DIVH,DIVV,DELAMB,ETA,DELCOR,DSTMAXS,TOR,DSTMIN,WMAX,
     +     ETAFRAC,ETASM,
     $     GON_CHI,GON_PHIS,GON_KAPPA,GON_OMEGAS,GON_2THETA,
     $     GON_PHIE,GON_OMEGAE,
     +     GON_CHI_SET,GON_KAPPA_SET,
     +     BLKSIZE
      INTEGER ISYN,IMONO,NWMAX,IPAD,NSMOOTH,IGON_CHI,IGON_PHI,
     $     IGON_KAPPA,IGON_OMEGA,IGON_2THETA,
     +     IGON_CHI_SET,IGON_KAPPA_SET,IHOSCAXIS
C     ..
C     .. logicals in common block /REEKE/ ..
      LOGICAL LOGETA,NUREEK,LCAMCON,GENGON,FOURCIRCLE,THREECIRCLE
C     ..
C     .. Common Block /REEKE/ ..
      COMMON /REEKE/RMC(3,3),AMAT(3,3),SCAXIS(3),S0(3),s0unit(3),
     $     CAMCON(8),BEAMMU(2),X1,X2,Y1,Y2,
     +     Z1,Z2,XYS,DSTAR2,DSTMAX,DSTPL,DSTPL2,DIVH,DIVV,DELAMB,
     +     ETA,DELCOR,DSTMAXS,TOR,DSTMIN,WMAX,ETAFRAC,ETASM,
     $     GON_CHI,GON_PHIS,GON_KAPPA,GON_OMEGAS,GON_2THETA,
     $     GON_PHIE,GON_OMEGAE,
     +     GON_CHI_SET,GON_KAPPA_SET,ISYN,IMONO,
     $     NWMAX,IPAD,
     $     NSMOOTH,IGON_CHI,IGON_PHI,
     $     IGON_KAPPA,IGON_OMEGA,IGON_2THETA,
     +     IGON_CHI_SET,IGON_KAPPA_SET,IHOSCAXIS,LOGETA,NUREEK,LCAMCON,
     $     GENGON,FOURCIRCLE,THREECIRCLE,
     +     BLKSIZE
C     ..
C
C
C&&*&& end_include  ../inc/reeke.f
C&&*&& include  ../inc/savall.f
C
C $Id: savall.f,v 1.1 2002/05/02 10:47:15 harry Exp $
C
C---- START of include file savall.h
C
C      NSAVIMG      Number of images used in autoindexing
C      ISAVIMG      Array storing image numbers used in last autoindexing
C      NSAVSEG      Number of segments used in last postref run
C      ISFIRST      Array storing image number of the first image
C                   in all segments of last postref run.
C      SAVMATSR     Indicates whether last matrix was determined by
C                   autoindexing (Autoindexing) or by postref (Post refinement)
C      SAVMATNAM    Name of the matrix file
C      SAVENAM      Name of savefile
C      SVSCN        SCANNER keyword
C      SVSITE       SITE keyword
C      RES          High resolution limit given on RESOL keyword
C      RESLOW       Low resolution limit given on RESOL keyword
C
C     .. Scalars in common block /SAVALL/ ..
      REAL RES,RESLOW
      INTEGER NSAVIMG,NDIR,NSAVSEG
      CHARACTER SAVMATSTR*80,SAVMATNAM*80,SAVENAM*80,SVSCN*80,
     +          SVSITE*80
      LOGICAL IISCN,IISITE,IIWAVE,IIDIV,IIDISP,IINULL,IIRAST,IISEP,
     +        IIOVER,IIPIX,IIBACK,IIRES
C     ..
C     .. Arrays in common block /SAVALL/ ..
C
      INTEGER ISAVIMG(MAXIMG),ISFIRST(100)
C     .. Common Block /SAVALL/ ..
      COMMON /SAVALL/ RES,RESLOW,ISAVIMG,ISFIRST,NSAVIMG,NDIR,NSAVSEG,
     +       IISCN,IISITE,IIWAVE,IIDIV,IIDISP,IINULL,IIRAST,IISEP,
     +        IIOVER,IIPIX,IIBACK,IIRES
C
C
      COMMON /SAVALLC/ SAVMATSTR,SAVMATNAM,SAVENAM,SVSCN,SVSITE
C     ..
C
C
C&&*&& end_include  ../inc/savall.f
C&&*&& include  ../inc/scn.f
C
C $Id: scn.f,v 1.3 2004/08/16 13:26:48 harry Exp $
C
C--- awk generated include file  scn.h
C---- START of include file scn.h
C
C     SCNSZ   is pixel size (in microns) divided by 25
C     RAST    pixel size in slow direction in mm
C     FACT    multiplying by FACT converts from 10 micron units 
C             (the standard unit internal to the program) into pixels
C     IYLEN   The number of pixels in the Y (fastest changing) direction
C             in the digitised image.
C     NREC    The number of pixels in the X (slow) direction in the 
C             digitised image.
C     NWORD   The number of I*2 words in the Y direction.
C     NBYTE   The number of bytes in Y direction = NWORD/2
C     NHBYTE  Number of bytes in header
C
C     ICURR   When several images are stored in a single file, ICURR is the
C             pointer to the first record of the current image in the direct
C             access file (only implemented for film data)
C     NEXTRA  The number of additional (unused) bytes padding the end of
C             each record in image file
C     BYTSWAP True if the "endedness" (Big-endian/Little-endian) of the 
C             machine that MOSFLM is running on is different to that of the
C             machine on which the image was written. This is determined by
C             looking at the value of NXPIX in the header record of the
C             image file (subroutine GETHDR)
C
C     LACTIVE True if using Rigaku active mask, False if ignoring it
C
C     .. Scalars in common block /SCN/ ..
      REAL FACT,SCNSZ,RAST,RASTY
      INTEGER NBYTE,NREC,NWORD,IYLEN,ICURR,NEXTRA,NHBYTE
      LOGICAL BYTSWAP,LACTIVE
C     ..
C     .. Common Block /SCN/ ..
      COMMON /SCN/ FACT,SCNSZ,RAST,RASTY,NBYTE,NREC,NWORD,IYLEN,
     +     ICURR,NEXTRA,NHBYTE,BYTSWAP,LACTIVE
C&&*&& end_include  ../inc/scn.f
C&&*&& include  ../inc/sys.f
C
C $Id: sys.f,v 1.1 2002/05/02 10:47:21 harry Exp $
C
C--- awk generated include file  sys.h
C---- START of include file sys.h
C
C
C     .. Scalars in Common Block /SYS/ ..
      INTEGER ISYS
C     ..
C     .. Arrays in Common Block /SYS/  ..
      INTEGER KSYS
C     ..
C     ..  Common Block /SYS/ ..
      COMMON /SYS/ISYS,KSYS(3)
C     ..
C
C
C&&*&& end_include  ../inc/sys.f
C&&*&& include  ../inc/strat.f
C--- awk generated include file  strat.h
C---- START of include file strat.h
C
C---- Stores variables for use in STRATEGY option
C     IROTAX is the axis closest to the rotation axis
C     PHIROTAX is the angle this axis makes with the rotation axis
C
C     PHIZONE is the phi value at which axis "IZONEAX" is along the
C     X-ray beam. (IZONEAX = 1 is a, =2 is b, =3 is c)
C     PHIPAD  is the rotation to be added to PHILAUE to ensure generation
C             of all unique data, and will depend on angle between the
C             unique axis and the rotation axis.
C     AUTANOM if true tries to maximise number of anomalous pairs
C     CELLSCAL is the scale factor applied to the cell edges to
C              speed up the calculation.
C     SHRUNK   is TRUE if the cell has been scaled by CELLSCAL
C     ISTRUN   is used to increment input phi angles by multiples of
C              360 degrees, so that phi values in different parts can
C              be recognised. It starts at zero.
C     FIRSTRAT Starts as TRUE (set in MOSDATA) and is set to FALSE once
C              the MTZ file has been opened for a STRATEGY run.
C              Reset TRUE after EXITing from STRATGEY prompt.
C
C     .. Scalars in common /STRAT/ ..
      INTEGER NSEGM,IPCKCUR,NSTRAT,NUNIQ,NSTRUN,ISTRUN,NSEGAUTO,
     +        IZONEAX,IROTAX,NLAST,NNPACKS,NLASTPACK
      LOGICAL STRATEGY,AUTO,SIZESET,AUTANOM,SHRUNK,FIRSTRAT,
     +         NEWSTRAT,WAITINP,OFFPHI
      REAL ROTAUTO,PHILAUE,PHIPAD,PHIZONE,PHIROTAX,CELLSCAL
C     ..
C     .. Arrays in common /STRAT/ ..
      REAL PHIST,PHIFIN,PHIINC,PHIADD,PHISEGA
      INTEGER IFIRSTONE
C     ..
C     .. Common Block /STRAT/ ..
      COMMON /STRAT/ PHIST(NSEGMAX),PHIFIN(NSEGMAX),PHIINC(NSEGMAX),
     +       PHIADD(NSEGMAX),PHISEGA(NSEGMAX),ROTAUTO,PHILAUE,PHIPAD,
     $       PHIZONE,PHIROTAX,CELLSCAL,IFIRSTONE(NSEGMAX),
     $       NSEGM,IPCKCUR,NSTRAT,NUNIQ,
     +       NSTRUN,ISTRUN,NSEGAUTO,
     +       IZONEAX,IROTAX,NLAST,NNPACKS,NLASTPACK,
     +       STRATEGY,AUTO,SIZESET,AUTANOM,SHRUNK,
     +       FIRSTRAT,NEWSTRAT,WAITINP,
     +       OFFPHI
C     ..
C
C


      
C&&*&& end_include  ../inc/strat.f
C&&*&& include  ../inc/tgen.f
C
C $Id: tgen.f,v 1.1 2002/05/02 10:47:23 harry Exp $
C
C--- awk generated include file  tgen.h
C---- START of include file tgen.h
C
C---- Stores variables for use in TESTGEN option
C
C     .. Arrays in common /TGEN/ ..
c      REAL XOVER
c      INTEGER ISTATS
C
C     .. Scalars in common /TGEN/ ..
      REAL XOVER,PHSTART,PHEND,PHSTEP,OSCMIN,OSCMAX,SDIVH,SDIVV,
     +     SDELCOR,SDELAMB,SETA,OSCANG,PCMAX
      INTEGER ISTATS
      LOGICAL TESTGEN,TESTRAT
C     ..
C     ..
C     .. Common Block /TGEN/ ..
      COMMON /TGEN/XOVER(2),PHSTART,PHEND,PHSTEP,OSCMIN,OSCMAX,
     +     SDIVH,SDIVV,SDELCOR,SDELAMB,SETA,OSCANG,PCMAX,
     $     ISTATS(MAXPAX,3),TESTGEN,TESTRAT

C&&*&& end_include  ../inc/tgen.f
C&&*&& include  ../inc/tiltlog.f
C
C $Id: tiltlog.f,v 1.1 2002/05/02 10:47:23 harry Exp $
C
C---- awk generated include file tiltlog.h
C---- START of include file tiltlog.h
C
C    for things connected with the new definitions of TILT and TWIST 
C
C     .. Scalars in common block /TILTLOG/ ..
      LOGICAL NUTWIST
      COMMON /TILTLOG/NUTWIST
C&&*&& end_include  ../inc/tiltlog.f
C&&*&& include  ../inc/trigparam.f
C 
C $Id: trigparam.f,v 1.3 2008/07/31 11:46:02 harry Exp $
C
C
C     Trigonometric parameters - set here to highly precise values, don't 
C     calculate in code; values from Clemens Vonrhein
C
C     DTOR.. convert degrees to radians
C     RTOD.. convert radians to degrees
C     PI..   value of PI
      REAL PI
      PARAMETER   ( PI = 3.1415926536 )
      REAL          TWOPI
      PARAMETER   ( TWOPI = 6.2831853072 )
      REAL RTOD
      PARAMETER   ( RTOD = 57.2957795131 )
      REAL          DTOR
      PARAMETER   ( DTOR = 0.0174532925 )
C DOUBLE PRECISION...
      DOUBLE PRECISION PI_DOUBLE
      PARAMETER ( PI_DOUBLE = 3.1415926535897932384626433832795029D0 )
      DOUBLE PRECISION TWOPI_DOUBLE
      PARAMETER ( TWOPI_DOUBLE = 
     $     6.2831853071795864769252867665590058D0 )
      DOUBLE PRECISION RTOD_DOUBLE
      PARAMETER ( RTOD_DOUBLE = 57.2957795130823208768D0 )
      DOUBLE PRECISION DTOR_DOUBLE
      PARAMETER ( DTOR_DOUBLE = 0.01745329251994329576D0 )
c

c
C&&*&& end_include  ../inc/trigparam.f
C&&*&& include  ../inc/xy.f
C
C $Id: xy.f,v 1.1 2002/05/02 10:47:25 harry Exp $
C
C--- awk generated include file  xy.h
C---- START of include file xy.h
C
C     .. Scalars in common block /XY/ ..
      REAL XTOFD,SINV,COSV,TANV,TWOTHETA
      INTEGER ICASS
C     ..
C     .. Common Block /XY/ ..
      COMMON /XY/XTOFD,SINV,COSV,TANV,TWOTHETA,ICASS
C     ..
C
C     XTOFD....  Crystal to detector distance in 10 micron units. Read from
C                keyworded input and never changed.
C
C                Spot positions are calculated in S/R XYSPOT (Called from
C                REEK) and are for an "ideal" detector at a distance of XTOFD.
C                These are converted into pixel positions in S/R MMTOPX
C                which applies the multiplicative factor XTOFRA to allow
C                for refinement of the distance. XTOFRA is the parameter
C                that is actually refined (in RDIST), rather than XTOFD.
C                The refined distance that is printed in the logfile is
C                actually XTOFRA*XTOFD
C
C     ICASS....  Indicates detector type:
C                0     Flat film
C                1     Vee shaped cassettes
C                2     FAST detector (only used in TESTGEN mode of OSCGEN)
C                3     Swung out FAST (ditto)
C                4     IP detector
C     TWOTHETA   Detector swing angle (degrees)
C&&*&& end_include  ../inc/xy.f
C     ..
C     .. Statement Functions ..
      INTEGER INTB,INTE
C     ..
C     .. Equivalences ..
      EQUIVALENCE (P0OLD(1,1,1),BBEG), (P0OLD(1,1,2),BEND)
      EQUIVALENCE (POLD(1,1,1),B0BEG), (POLD(1,1,2),B0END)
      EQUIVALENCE (X12(1),X1), (Y12(1),Y1), (Z12(1),Z1)
C     ..
      SAVE
C     .. Data statements ..
      DATA PP/24*0.0/,ICOUNT/0/ phiaxis/ 0.0, 0.0, 1.0 /
     $     PHIMAT / 1.0,0.0,0.0, 0.0,1.0,0.0, 0.0,0.0,1.0 /
C     
C     Statement functions
C     
      INTB(A) = INT(A - 3.0)
      INTE(A) = INT(A + 3.0)
C 

      CALLEDFROM = 'REEK'
C
C---- set up for 3 and 4 circle goniostats
C
      IF(FOURCIRCLE.AND.(HOSCAXIS.EQ.'PHI'))THEN
         PHIAXIS(1) = 0.0
         PHIAXIS(2) = 0.0
         PHIAXIS(3) = 1.0
         OMEGAAXIS(1) = 0.0
         OMEGAAXIS(2) = 0.0
         OMEGAAXIS(3) = 1.0
         KAPPAAXIS(1) = 0.0
         KAPPAAXIS(2) = COS(GON_KAPPA_SET*DTOR)
         KAPPAAXIS(3) = SIN(GON_KAPPA_SET*DTOR)
C     
C---- don't use either gonio_Omega or gon_Phi in the following calculation?
C     
         CALL GN3CMP(0.0,0.0,0.0,
     $        OMEGAAXIS,KAPPAAXIS,PHIAXIS,0,0,PHIMAT)
      ELSE
C---- Bruker-style 3-circle
        IF(THREECIRCLE.AND.HOSCAXIS.EQ.'PHI')THEN
          cchi = cos(gon_chi_set*dtor)
          schi = sin(gon_chi_set*dtor)
        ELSE
          CCHI = 1.0
          SCHI = 0.0
        ENDIF
C---- e.g. Bruker (omega scans), also for phi-only systems
        PHIAXIS(1) = 0.0
        PHIAXIS(2) = SCHI
        PHIAXIS(3) = CCHI
        PHIMAT(1,1) = 1.0
        PHIMAT(1,2) = 0.0
        PHIMAT(1,3) = 0.0
        PHIMAT(2,1) = 0.0
        PHIMAT(2,2) = CCHI
        PHIMAT(2,3) = -SCHI
        PHIMAT(3,1) = 0.0
        PHIMAT(3,2) = SCHI
        PHIMAT(3,3) = CCHI
      ENDIF
      CALL MINV33(INVPHIMAT,PHIMAT,DTEMP)
C
C---- if beam isn't perpendicular to the spindle axis with all circle angles
C     at datum position, we need to correct for this as well - assume single
C     circle goniostat at the moment
C
      IF(IBEAMMU .NE. 0)THEN
c        XYZAXIS(1) = 0
c        XYZAXIS(2) = 1
c        XYZAXIS(3) = 0
c        phiaxis(1) = 0.0
c        phiaxis(2) = sin(beammu(2))
c        phiaxis(3) = cos(beammu(2))
c        CALL RTMATS(BEAMMU(2),XYZAXIS,0,PHIMAT)
c        CALL MINV33(INVPHIMAT,PHIMAT,DTEMP)
      ENDIF
C
C----
C
      DSTMAX2 = DSTMAX**2
      DSTMIN2 = DSTMIN**2
      DSTPL2 = DSTPL**2
      IF(ANITES)CALL ANIRES(ORTMAT)
      ISTAT = 0
C     
C     
C
      IF (DEBUG(29)) THEN
cdms21.09.2004   Zero counter.
        ICOUNT = 0
         IF (ONLINE) WRITE (ITOUT,FMT=6000) AMAT,CELL,RMC,PHIBEG,
     +        PHIEND,DELPHI,DIVH,DIVV,ETA,DSTMAX,DSTMIN,DSTPL,GMAT
         WRITE (IOUT,FMT=6000) AMAT,CELL,RMC,PHIBEG,PHIEND,DELPHI,
     +        DIVH,DIVV,ETA,DSTMAX,DSTMIN,DSTPL,GMAT
      END IF
 6000 FORMAT (/1X,'In REEKE',/1X,'AMAT',3(/,1X,3F12.6),/,' CELL',/,
     $        3F8.2,3F7.2,
     +     /1X,'RMC',3(/,1X,3F12.6),/1X,'PHI',
     +     'BEG,END ',2F6.1,' DELPHI ',3F6.2,/1X,'DIVH,DIVV,ETA,DSTM',
     +     'AX, DSTMIN, DSTPL',6F9.6,/1X,'GMAT ',3(/,1X,3F12.6))
C     
C---- Test for writing a "spots" file
C     
      IF (DUMP(8)) THEN
         ISPOT = 10
         CALL CCPDPN (ISPOT,'SPOTLIST','UNKNOWN','F',80,IFAIL)
         INVFLAG = 0
         IF (INVERTX) INVFLAG = 1
         IISWUNG = 0
         IF (ABS(TWOTHETA).GT.0.01) IISWUNG = 1
         WRITE(ISPOT,FMT=6020) NREC,IYLEN,RAST,YSCAL,OMEGAF/DTOR,
     +        INVFLAG,IISWUNG
 6020    FORMAT(1X,2I10,F10.3,F10.6,F10.2,2I5)
         PXCEN = 0.01*XCEN
         PYCEN = 0.01*YCEN/YSCAL
         IF (INVERTX) PXCEN = NREC*RAST - PXCEN
         WRITE(ISPOT,FMT=6022) PXCEN,PYCEN
 6022    FORMAT(1X,2F10.3)
      END IF
C     
C---- Calculate setting matrix at each end of scan
C     
C---- Set up beginning rot about z in RMPB
C     
C     ***********************************
      CALL SURMP((PHIBEG+DELPHI(3))*DTOR,RMPB)
      IF(GENGON)THEN
        call matmul3(dummat,invphimat,rmpb)
        call matcopf(rmpb,dummat,3,3)
      ENDIF
C     ***********************************
C     
C---- Set up end rot about z in RMPE
C     
C     ***********************************
      CALL SURMP((PHIEND+DELPHI(3))*DTOR,RMPE)
      IF(GENGON)THEN
        call matmul3(dummat,invphimat,rmpe)
        call matcopf(rmpe,dummat,3,3)
      ENDIF
C     ***********************************
C     
C---- Apply X and Y missetting angles CA = RMC . AMAT
C     
C     *******************
      CALL MATMUL3(CA,RMC,AMAT)
C     *******************
C     
C---- Orientation at beginning of scan BBEG = RMPB . CA
C     
C     ********************
      CALL MATMUL3(BBEG,RMPB,CA)
C     ********************
C     
C---- Orientation at end of scan BEND = RMPE . CA
C     
C     ********************
      CALL MATMUL3(BEND,RMPE,CA)
C     ********************
C     
C---- Now repeat the above but now with the Z rot extended by the
C     maximum possible spot width (corrected 26/7/02 AGWL)
C     
      GAMMAX = WMAX*DTOR
C     
C     ******************************************
      CALL SURMP((PHIBEG+DELPHI(3))*DTOR-GAMMAX,RMPB)
      IF(GENGON)THEN
        call matmul3(dummat,invphimat,rmpb)
        call matcopf(rmpb,dummat,3,3)
      ENDIF
      CALL SURMP((PHIEND+DELPHI(3))*DTOR+GAMMAX,RMPE)
      IF(GENGON)THEN
        call matmul3(dummat,invphimat,rmpe)
        call matcopf(rmpe,dummat,3,3)
      ENDIF
      CALL MATMUL3(CA,RMC,AMAT)
      CALL MATMUL3(B0BEG,RMPB,CA)
      CALL MATMUL3(B0END,RMPE,CA)
C     ******************************************
C     
C---- Determine choice of r.l. axes for loops - IAX(1)
C     (approx along X) will
C     be the fastest varying and IAX(3)
C     (approx along rot axis) the slowest
C     
C     ********************
      CALL SETAX(BBEG,BEND,IAX)
C     ********************
      JUMPAX = IAX(3)
C     
C     Compute start and end of rotation range in radians:
C     
C     hrp 11012001      STARTR = ROTS * DG2RD
C     hrp 11012001       ENDR   = ROTE * DG2RD
C     
C     
C     Consider axis IAX(1) to be IP, IAX(2) to be IQ, IAX(3) to be IR
C     
C     Fix up ordering of setting matrices to be in column
C     order IP, IQ, IR
C     Note that BBEG  and BEND  are equivalenced to POLD
C     and  B0BEG and B0END are equivalenced to P0OLD
C     
      DO 7 I = 1,2
         DO 5 J = 1, 3
            DO 2 K = 1, 3
               P(J,K,I)  = POLD(J,IAX(K),I)
               P0(J,K,I) = P0OLD(J,IAX(K),I)
 2          CONTINUE
 5       CONTINUE
 7    CONTINUE
C     
C     Set PP (Pprime) as a 3x4(x2) matrix. Translation to move origin
C     to center of the Ewald sphere.  S0 is a unit vector antiparallel
C     to the X-ray beam.
C     
      DO 30 I = 1, 2
         DO 20 K = 1, 3
            PP(K,4,I) = -S0(K)
            DO 10 J = 1, 3
               PP(K,J,I) = P(K,J,I)
 10         CONTINUE
 20      CONTINUE
 30   CONTINUE
C     
C     Calculate the reciprocal metric tensor T = PP(trans) . PP
C     The 3*3 portion of matrix is same at beginning and end of rotation
C     Note that RT, RS1, RU2 and QU don't depend on L and thus don't need
C     to be calculated twice.
C     PP is used here to calculate T but is not used again
C     
      DO 80 L = 1, 2
         DO 75 I = 1, 4
            DO 70 J = 1, 4
               T1 = 0.0
               DO 60 K = 1, 3
                  T1 = T1  +  PP(K,I,L) * PP(K,J,L)
 60            ENDDO
               T(I,J) = T1
 70         ENDDO
 75      ENDDO
C     
         RT(L)  =        T(2,3)**2       -  T(3,3) * T(2,2)
         RS1(L) =        T(1,3) * T(2,3) -  T(3,3) * T(1,2)
         RS0(L) =        T(2,3) * T(3,4) -  T(2,4) * T(3,3)
         RU2(L) =        T(1,3)**2       -  T(1,1) * T(3,3)
         RU1(L) = 2.0 * (T(1,3) * T(3,4) -  T(1,4) * T(3,3))
         RU0(L) = T(3,4)**2
         QU(L)  = T(3,3)
         CALL MINV33(Q(1,1,L),P(1,1,L),DTEMP)
 80   CONTINUE
C     
      S1 = T(1,1)
      S2 = T(2,2)
      S3 = T(3,3)
      S4 = T(3,2) + T(2,3)
      S5 = T(1,3) + T(3,1)
      S6 = T(1,2) + T(2,1)
C     
      PA = S4 * S4  -  4.0 * S2 * S3
      PB = S4 * S5  -  2.0 * S3 * S6
      PC = S5 * S5  -  4.0 * S1 * S3
      PD = 4.0 * S3 * DSTMAX2
C     
C     Initialisation complete
C     
C     Get IP looping limits
C     
      PMIN = 1.E20
      PMAX = -1.E20
      SINTH = 0.5 * SQRT(DSTMAX2)
      SINSQ = SINTH**2
      SIN2T = SIN(2.0 * ATAN2(SINTH, SQRT(1.0-SINSQ)))
C     
C     Ewald sphere limit and limiting sphere both computed here.
C     Note that in order to allow for a general X-ray beam direction,
C     the algorithm for calculating the limiting sphere index limits
C     has been changed from that proposed by Reeke, and is now
C     essentially the same as the algorithm used for the Ewald sphere.
C     
C
C
      DO 101 J = 2,5
         I = J/2
         T1 = (-Q(1,1,I)*2.0*SINSQ+ (-1)**J*SIN2T*
     +        SQRT(Q(1,2,I)**2+Q(1,3,I)**2))
         PMIN = MIN(PMIN,T1)
         PMAX = MAX(PMAX,T1)
 101  CONTINUE
C
C
      PMINE =  1.E20
      PMAXE = -1.E20
C     
      DO 120 I = 1, 2
C     
C     Determine if the reciprocal lattice vector closest to the X-ray
C     beam is parallel or antiparallel. Remember S0 is antiparallel to
C     X-ray beam !
C     
         SCA1 = DOT(P(1,1,I), S0)
         ISIGN = -INT( SIGN(1.1, SCA1) )
         DO 100 J = 1, 3
            J1 = MOD(J,3) + 1
            J2 = MOD(J+1,3) + 1
            VEC(J) = P(J1,2,I) * P(J2,3,I) - P(J1,3,I) * P(J2,2,I)
 100     CONTINUE
C     
C     VEC is the vector normal to the reciprocal lattice planes with
C     IP index zero.
C     
         T1 = 0.0
         T2 = 0.0
C
C
         DO 110 J = 1,3
            T1 = T1  +  VEC(J)**2
            T2 = T2  +  P(J,1,I) * VEC(J)
 110     CONTINUE
C     
C     T2 is the volume of the reciprocal space unit cell. Because of
C     the permutation of axes (by IAX), this may be negative.
C     
         AVEC = SQRT(T1)
         T2 = 1.0 / ABS(T2)
C     
C     Limiting sphere limits
C     
         VECX = DOT(S0,VEC)
         AVECX = ABS(VECX)
         A1 = T1  -  AVECX * AVECX
         IF (A1 .GT. 0.0) THEN
            A1 = SQRT(A1)
         ELSE
            A1 = 0.0
         ENDIF
         PX1 = -ISIGN * T2 * (2. * SINSQ * AVECX  +  SIN2T * A1)
         PX2 = -ISIGN * T2 * (2. * SINSQ * AVECX  -  SIN2T * A1)
         P1 = AMIN1(PX1, PX2)
         P2 = AMAX1(PX1, PX2)
C     
C     Ewald sphere limits
C     
         T1 = -ISIGN * T2 * (AVEC + AVECX)
         T2 =  ISIGN * T2 * (AVEC - AVECX)
         PMINE = AMIN1(T1, T2)
         PMAXE = AMAX1(T1, T2)
C     
C     Select limits on basis of ISIGN
C     
         IF (ISIGN .GT. 0) THEN
            PMN(I) = AMAX1(P1, PMINE)
            PMX(I) = AMAX1(P2, PMAXE)
         ELSE
            PMN(I) = AMIN1(P1, PMINE)
            PMX(I) = AMIN1(P2, PMAXE)
         ENDIF
 120  CONTINUE
C     
C     Select overall limits
C     
      PMIN = AMIN1(PMN(1), PMN(2))
      PMAX = AMAX1(PMX(1), PMX(2))
      IPLB = INTB(PMIN)
      IPLE = INTE(PMAX)
      IF (DEBUG(29)) THEN
         WRITE(IOUT,FMT=6006) IPLB,IPLE
         IF (ONLINE) WRITE(ITOUT,FMT=6006) IPLB,IPLE
 6006    FORMAT(1x,'P loop limits',2I5)
      END IF
C     
C     Loop over IP         
C     
      DO 460 IP = IPLB, IPLE
C     
C     Calculate a few P-dependent constants
C     
         FP = FLOAT(IP)
         FP2 = FP * FP
         S5P = S5 * FP
         S6P = S6 * FP
         S1P2R2 = FP2 * S1  -  DSTMAX2
C     
C     Calculate looping limits for IQ
C     limiting sphere
C     
C     hrp 11012001         CALL PRDQD2(PA, FP * PB, (FP2 * PC  +  PD), VEC, NRT)
         CALL QUAD2(NRT,PA,FP*PB, (FP2*PC+PD),VEC)
C     
         IF ((NRT-1).EQ.0) THEN
            IQMIN = INTB(VEC(1))
            IQMAX = INTE(VEC(1))
         ELSE IF ((NRT-1).GT.0) THEN
            IQMIN = INTB(MIN(VEC(1),VEC(2)))
            IQMAX = INTE(MAX(VEC(1),VEC(2)))
         ELSE
            GO TO 460
         END IF
C     
C     Ewald sphere
C     
         QMINE = 1.E20
         QMAXE = -1.E20
C     
c     DO 195 I = 1, 3
c     P1H0(I) = P0(I,1,1) * FP
c     195        CONTINUE
         DO 200 I = 1, 2
            P1H0(I) = P0(1,1,I)*FP
            P2H0(I) = P0(2,1,I)*FP
            P3H0(I) = P0(3,1,I)*FP
            P1H(I) = P(1,1,I) * FP -  S0(1)
            P2H(I) = P(2,1,I) * FP -  S0(2)
            P3H(I) = P(3,1,I) * FP -  S0(3)
            T1 =     RU0(I)  +  FP * (RU1(I)  +  FP * RU2(I))
C     
            CALL QUAD2(NRTA(I),RT(I), (FP*RS1(I)+RS0(I)),T1,VEC)
C     
            IF((NRTA(I)-1).EQ.0)THEN
               QMINE = AMIN1(QMINE, VEC(1))
               QMAXE = AMAX1(QMAXE, VEC(1))
            ELSEIF((NRTA(I)-1).GT.0)THEN
               QMINE = AMIN1(QMINE, VEC(1), VEC(2))
               QMAXE = AMAX1(QMAXE, VEC(1), VEC(2))
            ENDIF
 200     ENDDO
C     
         IF (NRTA(1) .EQ. 0  .AND.  NRTA(2) .EQ. 0) GOTO 460
C     
C     Choose most restrictive limits
C     
         IQLB = INTB(QMINE)
         IQLE = INTE(QMAXE)
         CALL LIMITS(IER,IQLB,IQLE,IQMIN,IQMAX)
         IF (IER .NE. 0) GOTO 460
c         IF (DEBUG(29)) THEN
c            WRITE(IOUT,FMT=6008) IQLB,IQLE
c            IF (ONLINE) WRITE(ITOUT,FMT=6008) IQLB,IQLE
c 6008       FORMAT(1x,'Q loop limits',2I5)
c         END IF
C     
C     Loop over IQ
C     
         DO 450 IQ = IQLB, IQLE
            FQ = REAL(IQ)
C     
C     Get looping limits for IR
C     D* limit
C     
            T1 = S1P2R2  +  FQ * (FQ * S2  +  S6P)
C     
            CALL QUAD2(NRT,S3, (0.5* (S4*FQ+S5P)),T1,VEC)
C     
            IF ((NRT-1).EQ.0) THEN
               IRMIN = INTB(VEC(1))
               IRMAX = INTE(VEC(1))
            ELSE IF ((NRT-1).GT.0) THEN
               IRMIN = INTB(MIN(VEC(1),VEC(2)))
               IRMAX = INTE(MAX(VEC(1),VEC(2)))
            ELSE
               GO TO 450
            END IF
C     
C     Ewald sphere limits
C     
 230        DO 260 I = 1, 2
               PX = P1H(I)  +  P(1,2,I) * FQ
               PY = P2H(I)  +  P(2,2,I) * FQ
               PZ = P3H(I)  +  P(3,2,I) * FQ
               T1 = PX * PX  +  PY * PY  +  PZ * PZ  -  1.0
               T2 = P(1,3,I) * PX  +  P(2,3,I) * PY  +  P(3,3,I) * PZ
C     
               CALL QUAD2(NRTA(I),QU(I),T2,T1,VEC)
C     
               IF ((NRTA(I)-1).EQ.0) THEN
                  RLB(I) = VEC(1)
                  RLE(I) = VEC(1)
               ELSE IF ((NRTA(I)-1).GT.0) THEN
                  RLB(I) = MIN(VEC(1),VEC(2))
                  RLE(I) = MAX(VEC(1),VEC(2))
               END IF
 260        CONTINUE
C     
C     Use quadratic roots to set up loop limits depending on sphere
C     intersections and adjust loops to other limits.
C     
            NLOOP = 1
C     
C     
            IF (NRTA(1).GT.0) THEN
C     
C     
               IF (NRTA(2).GT.0) THEN
                  IF (RLB(1).GT.RLB(2)) THEN
C     
C     ***********************
                     CALL JSWTCH(NRTA(1),NRTA(2))
                     CALL SWITCH(RLB(1),RLB(2))
                     CALL SWITCH(RLE(1),RLE(2))
C     ***********************
C     
                  END IF
C     
C     
                  IF (NRTA(1).NE.1) THEN
                     IF (NRTA(2).EQ.2) THEN
                        IF (RLE(2).LE.RLE(1)) THEN
                           NLOOP = 2
C     
C     *****************************************
                           CALL LOOPST(NLOOP,RLB(1),RLB(2),
     +                          RLE(2),RLE(1))
C     *****************************************
C     
                           GO TO 330
                        ELSE IF (RLB(2).LT.RLE(1)) THEN
                           NLOOP = 2
C     
C     *****************************************
                           CALL LOOPST(NLOOP,RLB(1),RLB(2),
     +                          RLE(1),RLE(2))
C     *****************************************
C     
                           GO TO 330
                        END IF
                     END IF
                  END IF
                  NLOOP = 2
               END IF
C     
C     
            ELSE IF (NRTA(2).LE.0) THEN
               GO TO 450
            ELSE
               NRTA(1) = NRTA(2)
               RLB(1) = RLB(2)
               RLE(1) = RLE(2)
            END IF
C     
C     *****************************************
            CALL LOOPST(NLOOP,RLB(1),RLE(1),RLB(2),RLE(2))
C     *****************************************
C     
C---- Check IR limits
C     
C     ***************************************
 330        CALL LIMITS(IER,IRLB(1),IRLE(1),IRMIN,IRMAX)
C     ***************************************
C     
            IF (IER.NE.0) THEN
C     
C     
               IF (NLOOP.EQ.1) THEN
                  GO TO 450
               ELSE
                  NLOOP = 1
               END IF
C     
C     
            ELSE IF (NLOOP.EQ.1) THEN
               GO TO 370
            END IF
C     
C     ***************************************
            CALL JSWTCH(IRLB(1),IRLB(2))
            CALL JSWTCH(IRLE(1),IRLE(2))
            CALL LIMITS(IER,IRLB(1),IRLE(1),IRMIN,IRMAX)
C     ***************************************
C     
            IF (IER.NE.0) THEN
C     
C     
               IF (NLOOP.EQ.1) THEN
                  GO TO 450
               ELSE
C     
C     ***********************
                  CALL JSWTCH(IRLB(1),IRLB(2))
                  CALL JSWTCH(IRLE(1),IRLE(2))
C     ***********************
C     
                  NLOOP = 1
               END IF
            END IF
 370        CONTINUE
C     
C     Loop over IR
C     
C     
            DO 380 I = 1, 2
               PX0(I) = P0(1,2,I)*FQ + P1H0(I)
               PY0(I) = P0(2,2,I)*FQ + P2H0(I)
               PZ0(I) = P0(3,2,I)*FQ + P3H0(I)
 380        CONTINUE
C
C---- If (nloop.eq.2), check that r limits do not overlap (a.g.w.l.)
C     and if one limit is the same, only do a single loop with
C     extended limits
C
            IF (NLOOP.EQ.2) THEN
C
C
               IF ((IRLE(2).GT.IRLE(1)) .AND.
     +              (IRLB(2).LE.IRLE(1))) IRLB(2) = IRLE(1) + 1
               IF ((IRLE(1).GT.IRLE(2)) .AND.
     +              (IRLB(1).LE.IRLE(2))) IRLB(1) = IRLE(2) + 1
               IF (IRLE(2).EQ.IRLE(1)) THEN
                  IRLB(1) = MIN(IRLB(1),IRLB(2))
                  NLOOP = 1
               END IF
C
C
               IF (IRLB(2).EQ.IRLB(1)) THEN
                  IRLE(1) = MAX(IRLE(1),IRLE(2))
                  NLOOP = 1
               END IF
            END IF

C     
            DO 445 ILOOP = 1, NLOOP
               DO 440 IR = IRLB(ILOOP), IRLE(ILOOP)
                  IHKL(IAX(1)) = IP
                  IHKL(IAX(2)) = IQ
                  IHKL(IAX(3)) = IR
C     
C---- stuff from old Reeke code here...
C     
                  ABSNT = .FALSE.
C     
C---- Test for any systematic absences from centering
C     
C     ***********************
                  IF (ISYS.NE.0) CALL MSYSABS(IHKL,ABSNT)
C     ***********************
C     
C---- For strategy option, need to eliminate axial absences too
C     
                  IF (STRATEGY) THEN
                     ISYSAB = 0
C     
C     ***********************
                     CALL EPSLON(IHKL,EPS,ISYSAB)
C     ***********************
C     
C---- Test for systematic absences
                     ABSNT = .FALSE.
                     IF (ISYSAB .EQ. 1)ABSNT = .TRUE.
                  END IF
                  
                  IF (.NOT.ABSNT) THEN
                     FR = REAL(IR)
C     
C     
                     DO 2000 I = 1,2
                        X12(I) = P0(1,3,I)*FR + PX0(I)
                        Y12(I) = P0(2,3,I)*FR + PY0(I)
                        Z12(I) = P0(3,3,I)*FR + PZ0(I)
 2000                CONTINUE
C     
C     *********************************************
                     CALL DSTAR(IP,IQ,IR,KT,KHF,DELEPS1,DELEPS2,
     +                    PHI,PHIW,DRATIO)
C     *********************************************
C     
                    IF (DEBUG(29).AND.(ICOUNT.LT.NDEBUG(29))) 
     +                    THEN
C     
C     
                        IF (ONLINE) WRITE (ITOUT,FMT=6002) 
     +                       IP,IQ,IR,KT,KHF,DRATIO,DELEPS1,DELEPS2
                        WRITE (IOUT,FMT=6002) IP,IQ,IR,KT,
     +                       KHF,DRATIO,DELEPS1,DELEPS2
                     END IF
C     
C---- Skip this reflection unless good spot OR within cusp (want to
C     plot reflections within cusp)
C     
                     IF ((KT.EQ.0).OR.(KT.EQ.-3)) THEN
C     
C---- Calc detector coords, etc. 
C
C     new code needs correction for real PHI of reflection...
C
                        IF(NUREEK)THEN                          
                           CALL RTMATS(DTOR*(PHI-PHIBEG),
     $                          PHIAXIS,0,ROTMAT)
                           XYZ(1) = X1
                           XYZ(2) = Y1
                           XYZ(3) = Z1
                           CALL MATVEC(XYZNEW,ROTMAT,XYZ)
                           X1 = XYZNEW(1)
                           Y1 = XYZNEW(2)
                           Z1 = XYZNEW(3)
                           CALL PRDDET(x,y,ier)
                           IF(DEBUG(70))THEN
                             WRITE(IOUT,fmt=1815)IP,IQ,IR,X,Y,x1,y1,z1
                             IF(ONLINE)
     $                            WRITE(ITOUT,fmt=1815)IP,IQ,IR,X,Y,
     $                            x1,y1,z1
 1815                        format(3I4,2F10.2,2X,3F10.3)
                           ENDIF
                        ELSE
                           CALL XYSPOT(Y1,Y2,Z1,DSTAR2,XYS,X,Y)
                        ENDIF
C     *******************************
C     
                        IF (DEBUG(29).AND.(ICOUNT.LT.NDEBUG(29))) 
     +                       THEN
                           ICOUNT = ICOUNT + 1
c                           IF (ONLINE) WRITE (ITOUT,FMT=6004) X,Y
C                           WRITE (IOUT,FMT=6004) X,Y
                           WRITE (IOUT,FMT=6004) X,Y,X1,X2,Y1,
     $                          Y2,Z1,Z2,DSTAR2,XYS,PHI,PHIBEG,ROTMAT,
     $                          S0
                        END IF
C     
C     
                        IFREC = 0
                        FRAC = 1.0
C     
C---- Set fraction recorded for fulls to be ratio of distance from
C     sphere at end of oscillation (which ever end is closer) to spot radius.
C     
                        IF (KHF.EQ.0) FRAC = MAX(DRATIO,1.0)
C     
C---- Ensure IFREC never goes to zero
C     
                        IF (KHF.NE.0) THEN
                           IF (ABS(DELEPS2).LE.0.00001) THEN
C     
C---- Partial at start of oscillation only
C     
                              IFREC = NINT(DELEPS1*100.0 +
     +                             SIGN(1.0,DELEPS1))
                              FRAC = 0.5*(1.0 - COS(DELEPS1*PI))
                           ELSE IF (ABS(DELEPS1).LE.0.00001) THEN
C     
C---- Partial at end of oscillation only
C     
                              IFREC = NINT(DELEPS2*100.0 +
     +                             SIGN(1.0,DELEPS2))
                              FRAC = 0.5*(1.0 - COS(DELEPS2*PI))
                           ELSE
C     
C---- Spot is cut off at both ends
C     
                              IFREC = NINT((ABS(DELEPS1) - 
     +                             (1.0 - DELEPS2))*100)
                              IFREC = MAX(1,IFREC)
                              IFREC = MIN(100,IFREC)
                              FRAC = 0.5*(1.0 - COS(DELEPS1*PI))
                              FRAC = FRAC - 
     +                             (1.0 - 0.5*(1.0 - 
     +                             COS(DELEPS2*PI)))
                           END IF
                        END IF
C     
C---- Testing IFREC non-zero for a fully
C     
                        IF ((IFREC.EQ.0).AND.(KHF.NE.0)) THEN
                           WRITE(6,*)'**** ERROR IFREC,KHF',
     +                          IFREC,KHF
                        END IF
C     
C---- Note that for a sinusoid rocking curve the fraction recorded IFREC
C     
C     IFREC = (1-COS(DELEPS*PI))/2.
C     
C     but do we really need to store this - wouldn't DELEPS be better?
C     Alan suggests 100*DELEPS
C     
C     If not within cusp,test this spot for R,X,Y and DSTAR limits.
C     KHF used to test for cut-off both ends.
C     
                        IF (KT.EQ.0) THEN
C     
C---- First test for anisotropic resolution limits for integration 
C     
                           IF(ANITES)THEN
                              DSTMAX2 = 0.0
                              DO 207 I=1,3
                                 DTEMP = 0.0
                                 DO 203 J=1,3
                                    DTEMP = DTEMP + 
     $                                   ORTMAT(I,J)*
     $                                   FLOAT(IHKL(J))
 203                             ENDDO
                                 DSTMAX2 = DSTMAX2 + DTEMP**2
 207                          ENDDO
                              DSTMAX2 = DSTAR2/DSTMAX2
                           ENDIF
C     ************************************
                           CALL SPTEST(X,Y,DSTAR2,DSTMAX2,DSTMIN2,
     +                          KHF,IFAIL)
C     ************************************
                        ELSE
C     
C---- Spot with cups, flag with IFAIL=10, set IFREC to 1 so it is
C     not counted as fully recorded
C     
                           IFREC = 1
                           IFAIL = 10
                        END IF
C     
C---- Write out the whole thing here
C     
C     
C---- For strategy option, only write out fully recorded reflections
C     which do not fail any test
C     
                        IF (STRATEGY) THEN
C     
C     *******************************
                           IF (IFAIL.EQ.0) 
     +                          CALL WMTZSP(IHKL,PHI,IHKLSTR)
C     *******************************
                        ELSE
                           IFLAG = 0
C     ********************************************
                           CALL STORSPOT(IHKL,IFREC,IFAIL,X,Y,
     +                          PHI,PHIW,FRAC,IFLAG)

C     ********************************************
C---- Test error return (more than NREFLS reflections generated)
C     
                           IF (IFLAG.EQ.-1) THEN
                              IF (TESTGEN) THEN
                                 MODE = -2
                                 RETURN
                              ELSE
                                 WRITE (IOUT,FMT=6010) NREFLS
                                 IF (ONLINE) WRITE 
     +                                (ITOUT,FMT=6010) NREFLS
                                 IF (MODE.EQ.1) THEN
                                    MODE = -1
                                    RETURN
                                 ELSE
                                   NSHUTERR = 1
                                   CALL SHUTDOWN(CALLEDFROM,
     $                                  LENSTR(CALLEDFROM))
                                 END IF
                              END IF
                           END IF
 6010                      FORMAT (/1X,'**** ERROR - Too many ',
     +                          'spots generated',/,1X,
     +                          /1X,'The current limit is ',I6,
     +                          /,1X,'You will have to change ',
     +                          'the parameter NREFLS ',/,
     +                          1X,'with a global edit',
     +                          ' and then recompile the program')
C     
                        END IF
                     END IF
                  END IF
C     
C---- Stuff from old Reeke loop above here
C     
C     
C     End of IR loop
C     
 440           CONTINUE
 445        CONTINUE
C     
C     End of IQ loop
C     
 450     CONTINUE
C     
C     End of IP loop
C     
 460  CONTINUE
C     
C
C---- Close SPOTLIST file
C
      IF (DUMP(8)) THEN
         WRITE (ISPOT,FMT='(1X,5F8.2)')
     +        - 999.0,-999.0,-999.0,-999.0,-999.0
         CLOSE(ISPOT)
      END IF
C
C
      RETURN
C     
C---- Format statements
C     
 6002 FORMAT (1X,'IP,IQ,IR',3I4,'  KT=',I2,'  KH=',I4,' dratio=',E10.3,
     $     ' DELEPS1,2 = ',2f8.3)
 6004 FORMAT (1X,'reeke',/,'X AND Y',2(F8.0,1X),/,' X1 - Z2 ',6F16.7,
     $     /,' DSTAR2 = ',F12.5,' XYS = ',F12.5,' PHI, PHIBEG = ',
     $     2F8.2,/,'ROTMAT = ',3(F8.5,1X),2(/,9X,3(F8.5,1X)),/,
     $     ' S0 = ',3F8.5)
C     
      END
C
C $Id: celref.f,v 1.11 2007/09/18 12:22:31 harry Exp $
C
C
C     =================================================================
      SUBROUTINE CELREF(NCYCLE,REIDX,NREF,IH,IK,IL,IX,IY,IPHI,ACHSE,
     @     IC,ICS,Q,ORGX,ORGY,FDIST,S0L,ED,UMAT,RCELL,SDU,SDCELL,SDPHI,
     $     SDXY,SDCUTOFF,NBAD,IER)
C     =================================================================
      IMPLICIT NONE
C
C
C
C*******                                                       *********
C*******            LEAST-SQUARES REFINEMENT OF                *********
C*******          DETECTOR AND CRYSTAL PARAMETERS              *********
C*******                                                       *********
C***********************************************************************
C*******                                                       *********
C*******            W. KABSCH    September 1991                *********
C*******           derived from version 11-1987                *********
C*******                                                       *********
C***********************************************************************
C
C  SUBROUTINES REQUIRED: DGELS,GONSYS,INVERS,MATCOP,RFMATMUL,METRIC,UNORM
C
C***********************************************************************
C
C Harry has done some editing here! To make it easier to follow, I've 
C tidied up the ends of DO loops and tried to eliminate GOTOs wherever 
C relatively easy. I've also changed subroutines to normal MOSFLM routines
C where there's a 1:1 correspondence. This is all because I want to use the
C method but don't need all the functionality that this code provides!
C
C Harry Powell, March 8th 1999
C
C???????????????????????????????????????????????????????????????????????
C
C NCYCLE - NUMBER OF REFINEMENT CYCLES                           (GIVEN)
C  REIDX - INTEGER*2 ARRAY(12) PROVIDING A POSSIBILITY OF        (GIVEN)
C          REINDEXING THE REFLECTIONS.
C          THE MEANING OF THE 12 NUMBERS IS DEFINED AS:
C          H' =REIDX(1)*H+REIDX( 2)*K+REIDX( 3)*L+REIDX( 4)
C          K' =REIDX(5)*H+REIDX( 6)*K+REIDX( 7)*L+REIDX( 8)
C          L' =REIDX(9)*H+REIDX(10)*K+REIDX(11)*L+REIDX(12)
C          WHERE H',K',L' ARE THE NEW INDICES.
C  NREF  - NUMBER OF REFLECTIONS  (INTEGER*4)                    (GIVEN)
C   IH   - INTEGER*2 ARRAY SPECIFYING H-INDICES FOR A LIST       (GIVEN)
C          OF N REFLECTIONS.
C   IK   - INTEGER*2 ARRAY SPECIFYING K-INDICES FOR A LIST       (GIVEN)
C          OF N REFLECTIONS.
C   IL   - INTEGER*2 ARRAY SPECIFYING L-INDICES FOR A LIST       (GIVEN)
C          OF N REFLECTIONS.
C   IX   - INTEGER*4 ARRAY SPECIFYING X-POSITION ON DETECTOR     (GIVEN)
C          FOR EACH SPOT IN THE LIST ( TENTH OF A PIXEL)
C   IY   - INTEGER*4 ARRAY SPECIFYING Y-POSITION ON DETECTOR     (GIVEN)
C          FOR EACH SPOT IN THE LIST ( TENTH OF A PIXEL)
C  IPHI  - INTEGER*4 ARRAY SPECIFYING ANGULAR POSITION OF        (GIVEN)
C          SPINDLE WHERE REFLECTION WITH INDICES IH,IK,IL
C          WAS DIFFRACTING. THE VALUES ARE GIVEN IN UNITS
C          OF A HUNDRETH OF A DEGREE.
C  ACHSE - ARRAY(3) SPECIFYING LAB COORDINATES OF ROTATION AXIS  (GIVEN)
C   IC   - NUMBER SPECIFYING A SUBSET OF PARAMETERS WHICH        (GIVEN)
C          ARE TO BE REFINED. (UNIT CELL PARAMETERS ARE
C          TREATED SEPARATELY BY THE VALUE OF "ICS".)
C           1: REFINE ALL PARAMETERS
C           2: FIX THE ORIENTATION OF THE DETECTOR
C           3: FIX THE ORIENTATION OF THE DETECTOR AND THE
C              DISTANCE BETWEEN DETECTOR AND CRYSTAL.
C           4: FIX THE ORIENTATION OF THE DETECTOR AND THE
C              DIRECTION OF THE DIRECT BEAM.
C           5: FIX THE ORIENTATION OF THE DETECTOR, THE
C              DISTANCE BETWEEN DETECTOR AND CRYSTAL, AND
C              THE DIRECTION OF THE DIRECT BEAM.
C           6: FIX THE DIRECTION OF THE DIRECT BEAM AND THE
C              ORIENTATION OF THE UNIT CELL.
C           7: FIX THE DISTANCE BETWEEN DETECTOR AND CRYSTAL,
C              THE ORIENTATION OF THE DETECTOR, THE DIRECTION
C              OF THE DIRECT BEAM AND THE ORIENTATION OF THE
C              UNIT CELL.
C  ICS   - NUMBER SPECIFYING REFINEMENT CONSTRAINTS ON THE       (GIVEN)
C          UNIT CELL PARAMETERS ARISING FROM SYMMETRY.
C           0: DO NOT REFINE CELL PARAMETERS.
C          >0: REFINE INDEPENDENT CELL PARAMETERS. THE
C              INDEPENDENT PARAMETERS ARE DERIVED FROM
C              THE VALUE OF "ICS".
C           1: TRICLINIC
C           2: MONOCLINIC FIRST SETTING
C           3: MONOCLINIC SECOND SETTING
C           4: ORTHORHOMBIC
C           5: TETRAGONAL
C           6: TRIGONAL
C           7: HEXAGONAL
C           8: CUBIC
cdms21.09.2004  Use ICS = 9 for primitive rhombohedral.
C           9: PRIMITIVE RHOMBOHEDRAL
C   Q    - LENGTH OF A PIXEL IN MILLIMETERS                      (GIVEN)
C ORGX   - X- AND Y-COORDINATES (PIXELS) ON DETECTOR SUCH      (UPDATED)
C ORGY   - THAT THE DETECTOR NORMAL WOULD INTERSECT THE        (UPDATED)
C          CRYSTAL
C FDIST  - CRYSTAL TO DETECTOR DISTANCE (MM).                  (UPDATED)
C  S0L   - COORDINATES OF INCIDENT X-RAY BEAM WAVE VECTOR.     (UPDATED)
C          ONLY THE DIRECTION OF S0L IS REFINED.
C          LENGTH OF S0L IS 1.0/LAMBDA. ( RECIPROCAL ANGSTROEM )
C  ED    - REAL ARRAY(3,3) SPECIFYING LAB COORDINATES OF       (UPDATED)
C          DETECTOR AXES.
C UMAT   - ARRAY(3,3) CONTAINING ORIENTATION MATRIX            (UPDATED)
C RCELL  - ARRAY OF LENGTH 6 OF RECIPROCAL UNIT CELL PARAMETERS(UPDATED)
C          IN RECIPROCAL ANGSTROEM AND DEGREES.
C  SDU   - ESTIMATED STANDARD DEVIATION (DEGREES)               (RESULT)
C          FOR ORIENTATION MATRIX U
C SDCELL - ARRAY(6) OF STANDARD DEVIATIONS                      (RESULT)
C          ( RECIPROCAL ANGSTROEM AND DEGREES ) FOR
C          RECIPROCAL UNIT CELL PARAMETERS.
C SDPHI  - STANDARD DEVIATION OF ANGULAR POSITION OF SPINDLE   (UPDATED)
C          ( DEGREES ). A POSITIVE INPUT VALUE IS
C          USED TO CALCULATE THE WEIGHTS OF THE OBSERVED
C          SPINDLE POSITIONS OF THE REFLECTIONS.
C          A NON-POSITIVE VALUE INDICATES THAT A DEFAULT
C          VALUE OF 0.1 DEGREES SHOULD BE USED.
C          ON RETURN, SDPHI CONTAINS THE ESTIMATED STANDARD
C          DEVIATION OF THE SPINDLE ANGLE AT WHICH THE
C          REFLECTIONS WERE DIFFRACTING.
C  SDXY  - STANDARD DEVIATION OF SPOT POSITION ON DETECTOR     (UPDATED)
C          (PIXELS). A POSITIVE INPUT VALUE IS USED TO
C          CALCULATE THE WEIGHTS OF THE OBSERVED SPOT
C          POSITIONS OF THE REFLECTIONS.
C          A NON-POSITIVE VALUE INDICATES THAT A DEFAULT
C          VALUE OF ONE PIXEL SHOULD BE USED.
C          ON RETURN, SDXY CONTAINS THE ESTIMATED STANDARD
C          DEVIATION OF THE SPOT POSITIONS ON THE DETECTOR.
C  IER   - ERROR INDICATOR SET BY SUBROUTINE . NORMALLY IER IS  (RESULT)
C          NUMBER OF ACCEPTED REFLECTIONS.
C           >0 : NO ERROR.
C            0 : INSUFFICIENT NUMBER OF ACCEPTED REFLECTIONS
C           -1 : Q IS NOT POSITIVE
C           -2 : F IS ZERO OR ILLEGAL DETECTOR ORIENTATION
C           -3 : ILLEGAL CELL PARAMETERS
C           -4 : ILLEGAL ROTATION AXIS OR DIRECT BEAM WAVE VECTOR
C           -5 : ILLEGAL CRYSTAL ORIENTATION MATRIX U
C           -6 : NCYCLE MUST BE BETWEEN 1 AND 10
C           -7 : REINDEXING TRANSFORMATION IS SINGULAR
C
C***********************************************************************
      INTEGER   M,IC,ICS,NCYCLE,ICYCLE,MXFREE,MMFREE,NRIGHT,MXRIGHT,
     1     MFREE,IRANK,I,J,MM,MY1,MY2,SPLIT,NBAD(3)
      INTEGER*4 NREF,NY,IER,NACC,SEED
      PARAMETER (MXFREE=14,MMFREE=(MXFREE*MXFREE+MXFREE)/2,NRIGHT=11,
     1     MXRIGHT=MXFREE*NRIGHT)
      INTEGER*4 IX(*),IY(*),IPHI(*)
      INTEGER*2 IH(*),IK(*),IL(*),IP(6,9),MCS(9),
     1     VAR(MXFREE,7),REIDX(12)
      REAL*8    QD(MMFREE),RD(MXRIGHT),AVGX(MXFREE),AVGY(MXFREE),
     1     AVX(NRIGHT),AVY(NRIGHT),Z,EPS,ONE,ZERO
      REAL      DXCALC(MXFREE),DYCALC(MXFREE),DELX(NRIGHT),DELY(NRIGHT),
     1     ESD(MXFREE),DCPHIC(MXFREE),DSPHIC(MXFREE),RCPHI(NRIGHT),
     2     RSPHI(NRIGHT),B(6),ZELLE(6),RZELLE(6),RCELL(6),CELL(6),
     3     SDCELL(6),ACHSE(3),S0L(3),S0G(3),DS0G(3),A0(3,3),
     4     RFXAMAT(3,3),DA(3,3,6),UMAT(3,3),UG(3,3),DUG(3,3,3),
     5     EG(3,3),ED(3,3),EDG(3,3),EDG0(3,3),DEDG(3,3,3),BASIS(3,3),
     6     XG(3),X0G(3),DX0G(3,MXFREE),DXG(3),SG(3),DSG(3),SD(3),
     7     DSD(3),WPHI,WXY,ESDPHI,ESDXY,SDPHI0,SDXY0,SDPHI,SDXY,SDU,
     8     ERROR,Q,FDIST,ORGX,ORGY,FH,FK,FL,XOBS,YOBS,XCALC,YCALC,
     9     CPHI,SPHI,CPHIC,SPHIC,RHOQ,DRHOQ,R,RR,DRR,T1,T2,T3,T4,
     $     RAD,RAD100,SDCUTOFF
      PARAMETER (RAD=57.29578,RAD100=100.0*RAD,
     1     ZERO=0.0D+0,ONE=1.0D+0,EPS=1.0D-05)
C&&*&& include  ../inc/parameter.f
C
C $Id: parameter.f,v 1.17 2009/10/28 16:43:34 harry Exp $
C
C--- awk generated include file  parameter.h
C---- START of include file parameter.h
C
C       PARAMETERS
C       IYLENGTH.. maximum number of I*2 words of data in the 
C                  "fast" (ie most rapidly changing) direction in the
C                  digitised image. This will be HALF the number of pixels
C                  for film data (each pixel is stored in one byte)
C                  but will equal the number of pixels for IP data.
C       IXWDTH...  The maximum number of "stripes" of data in the scanned image
C                  ie the number of pixels in the "slow" direction
C                  (This is the Y direction in the MOSFLM convention)
C                  Note that the array "IMAGE" used to store the image is
C                  declared as size IYLENGTH*IXWDTH I*2 words for IP data
C                  and 2*IYLENGTH*IXWDTH BYTES for film data.
C                  If this exceeds the
C                  available memory, set ixwdth=1, recompile program
C                  and use keyword "NOCORE" when running program.
C                  Note that for the POSTREF and ADDPART options,
C                  two images have to be stored in memory at once so
C                  IXWDTH should be twice the number of records in an
C                  image.
C       MAXHEAD    maximum length of image header (in 4 byte words)
C       NREFLS.... maximum number of spots per film in generate file (250,000)
C       MAXBOX.... maximum number of pixels in measurement box (1500)
C       MAXDIM.... maximum box size in either direction (pixels) (41)
C       MAXPAX.... maximum number of packs per generate file (10000)
C       MXDOV2..... maxdim/2
C       MAXBUFF... maximum size of buffer (I*2) for storing ods
C                  of active spots in subroutine meas(21,000).
C                  Must be .GE.  MAXBOX*(NNLINE-1) for subroutine process
C       MREF...... maximum number of reflections to be used in post
C                  refinement (6000)
C       NEXPAND... maximum number of expansions of the input measurement
C                  box (2)
C       NMASKS.... maximum number of different profiles (25). Note the
C                  connection between this parameter and NNLINE
C       NVECT..... maximum number of vectors for storing scanned image
C                  in filmplot (10000)
C       NIMAX..... maximum number of images to be used together in 
C                  postrefinement (NADD or WIDTH options) (100)
C       NNLINE...  maximum number of boundary lines for setting up
C                  the areas for profile fitting. The maximum possible
C                  number of standard profiles will be (NNLINE-1)**2
C                  although for a circular detector the actual number
C                  may be less than this as some boxes will lie entirely
C                  outside the detector.
C       NREJMAX... Maximum number of rejected background pixels, resulting
C                  either from overlap of adjacent spots or outliers from
C                  the background plane
C       NSPOTS...  Maximum number of found spots (for autoindexing) that can
C                  be stored (for all images). Also maximum number in 
C                  a file wriitten by IMSTILLS that can be 
C                  stored/displayed/edited. THis must be an even number
C       MCOLS....  Number of columns in output MTZ file
C       MCOLSTR..  Number of columns in output MTZ file for strategy option
C     
C       MTZ Orientation block
C        MBLENG is total length of block, MBLINT, MBLREA are numbers
C          of integers & reals
C       NDETREF    Maximum number of reflections used for detector parameter
C                  refinement (previously 62)
C       NRPAR....  Maximum number of refineable parameters for detector
C                  positional refinement (subroutine RDIST)
C       NSEGMAX..  Maximum number of segments in STRATEGY
C       NSEGMAXPR  Maximum number of segments in POST-REFINEMENT
C       MULTMAX... Maximum number of observations with same hkl in COMPLETE
C       MAXDIFF... Maximum number of different packs that a given hkl occurs on
C       NRESBIN... Maximum number of resolution bins (COMPLETE)
C
C       MAXIMG...  Maximum number of images that can be read in using the IMAGE
C                  keyword or the "read Image" menu option.
C       MXSPOT...  Maximum number of spots that can be found on one image
C                  (before rejection on spot size).
C       MXCENT...  Maximum number of active spots during spot finding 
C                  (findspots)
C
C       MGRA, NGRA... maximum number of reflections and images over which a 
C                     reflection can be spread for postrefinement.
C       MAXBGBOX    Maximum number of local background background boxes 
C                   in X and Y
C
C       MAXNPEAKS   Maximum number of local maxima within one spot
C       MAXEXCL     Maximum number of excluded areas of the same type
C                   eg reactangles, quadrilaterals, arcs, resolution shells
C
C     .. Parameters ..
      INTEGER IXWDTH
c      PARAMETER (IXWDTH=8192)
      PARAMETER (IXWDTH=12288)
      INTEGER IYLENGTH
c      PARAMETER (IYLENGTH=4096)
      PARAMETER (IYLENGTH=6144)
      INTEGER MAXHEAD
      PARAMETER (MAXHEAD=5120)
      INTEGER MAXBOX
      PARAMETER (MAXBOX=3000)
      INTEGER MAXDIM
      PARAMETER (MAXDIM=41)
      INTEGER MAXPAX
      PARAMETER (MAXPAX=10000)
      INTEGER MXDOV2
      PARAMETER (MXDOV2=MAXDIM/2)
      INTEGER NEXPAND
      PARAMETER (NEXPAND=2)
      INTEGER NNLINE
      PARAMETER (NNLINE=8)
      INTEGER NMASKS
      PARAMETER (NMASKS=49)
      INTEGER MAXBUFF
      PARAMETER (MAXBUFF=21000)
      INTEGER NREFLS
      PARAMETER (NREFLS=250000)
      INTEGER MREF
      PARAMETER (MREF=6000)
      INTEGER NVECT
      PARAMETER (NVECT=10000)
      INTEGER NIMAX
      PARAMETER (NIMAX=100)
      INTEGER NREJMAX
      PARAMETER (NREJMAX=1000)
      INTEGER NSPOTS
      PARAMETER (NSPOTS=5000)
      INTEGER MCOLS
      PARAMETER (MCOLS=18)
      INTEGER MCOLSTR
      PARAMETER (MCOLSTR=6)
      INTEGER NREFSTR
C
C---- Each reflection for strategy run needs MCOLSTR I*2 words
C     plus an I*4 word for the merging
C
      PARAMETER (NREFSTR = IXWDTH*IYLENGTH/(2+MCOLSTR))
      INTEGER MBLENG,MBLINT,MBLREA
      PARAMETER (MBLENG=185,MBLINT=29,MBLREA=156)
      INTEGER NDETREF
      PARAMETER (NDETREF=400)
      INTEGER NRPAR
      PARAMETER (NRPAR=14)
      INTEGER NSEGMAX
      PARAMETER (NSEGMAX=100)
      INTEGER NSEGMAXPR
      PARAMETER (NSEGMAXPR=100)
      INTEGER MULTMAX
      PARAMETER (MULTMAX=100)
      INTEGER MAXDIFF
      PARAMETER (MAXDIFF=100)
      INTEGER NRESBIN
      PARAMETER (NRESBIN=20)
      INTEGER MXSPOT
      PARAMETER (MXSPOT=5000)      
      INTEGER MAXIMG
      PARAMETER (MAXIMG=100)      
      INTEGER NPIXBG
      PARAMETER (NPIXBG=51)
      INTEGER MXCENT
      PARAMETER (MXCENT=500)
      INTEGER    NGRA,MGRA
      PARAMETER (NGRA=20)
      PARAMETER (MGRA=50000)
      INTEGER MAXBGBOX
      PARAMETER (MAXBGBOX=500)
      INTEGER MAXNPEAKS
      PARAMETER (MAXNPEAKS=500)
      INTEGER MAXEXCL
      PARAMETER (MAXEXCL=50)
C&&*&& end_include  ../inc/parameter.f
C&&*&& include  ../inc/ioo.f
C
C $Id: ioo.f,v 1.7 2009/05/13 11:57:53 harry Exp $
C
C--- awk generated include file  ioo.h
C---- START of include file ioo.h
C
C
C
C     .. Scalars in common block /IOO/ ..
      INTEGER IOUT,IUNIT,ITIN,ITOUT,INOD,INMO,IDU,NWRN,IBRIEF,ISUMMR,
     +        ICOORD,SERVERFD,SERVERFDIN,NSHUTERR,dnafd
      LOGICAL ONLINE,ONEFILE,FHEADER,BRIEF,GRAPH,IOERR,
     $     NODISPLAY,LBELL,JPGOUT,SOCKLO,LBEST,dnaout,INMOOPEN,
     $     XMLOPEN
      CHARACTER dna_image*80,xmlfile*80
C     ..
C     .. Common block /IOO/ ..
c      COMMON /IOO/IOUT,IUNIT,ONLINE,ITIN,ITOUT,INOD,INMO,IDU,NWRN,
c     +            ONEFILE,FHEADER,BRIEF,IBRIEF,GRAPH,ISUMMR,ICOORD,
c     +            IOERR,NODISPLAY,LBELL
C     ..
C
C
      COMMON /IOO/IOUT,IUNIT,ITIN,ITOUT,INOD,INMO,IDU,NWRN,IBRIEF,
     +        ISUMMR,ICOORD,SERVERFD,SERVERFDIN,NSHUTERR,ONLINE,ONEFILE,
     +        FHEADER,BRIEF,GRAPH,IOERR,NODISPLAY,LBELL,JPGOUT,
     $        SOCKLO,LBEST, dnafd, dnaout,INMOOPEN,XMLOPEN
      COMMON /CIOO/dna_image,xmlfile

C&&*&& end_include  ../inc/ioo.f
C&&*&& include  ../inc/ioosum.f
C
C $Id: ioosum.f,v 1.2 2004/08/16 13:26:27 harry Exp $
C
C--- awk generated include file  ioosum.h
C---- START of include file ioosum.h
C
C     .. Scalars in common block /IOOSUM/
      INTEGER NLSUM1,NLSUM2,NSUMSTART1,NSUMSTART2
C
C     .. Arrays in common block /IOOSUMC/ ..
      CHARACTER*150 LINESUM1(MAXPAX),LINESUM2(MAXPAX)
      CHARACTER*101  IOLINE(100)
C     ..
C     .. Common block /IOOSUM/ ..
      COMMON /IOOSUM/ NLSUM1,NLSUM2,NSUMSTART1,NSUMSTART2
C     ..
C     .. Common block /IOOSUMC/ ..
      COMMON /IOOSUMC/ LINESUM1,LINESUM2,IOLINE
C&&*&& end_include  ../inc/ioosum.f
C&&*&& include  ../inc/debug.f
C
C $Id: debug.f,v 1.2 2008/07/24 09:42:21 andrew Exp $
C
C--- awk generated include file  debug.h
C---- START of include file debug.h
C
C
C
C     .. Arrays in common /DEBUG/ ..
      REAL XWARN
      INTEGER NDEBUG,IWARN
      LOGICAL DEBUG,LPRINT,DUMP,WARN
C
C     .. Scalars in common /DEBUG/ ..
      REAL BGRLIM
      INTEGER NDUMP,IDUMP,MXDUMP
      LOGICAL SPOT
C     
C     ..
C     .. Common Block /DEBUG/..
      COMMON /DEBUG/XWARN(20,100),BGRLIM,NDEBUG(100),IWARN(20,100),
     $       NDUMP,IDUMP,MXDUMP,DEBUG(100),LPRINT(20),DUMP(30),
     +       WARN(100),SPOT
C     ..
C
C&&*&& end_include  ../inc/debug.f
C***********************************************************************
      DATA      IP/ 1,2,3,4,5,6,  1,2,3,0,0,4,
     1     1,2,3,0,4,0,  1,2,3,0,0,0,
     2     1,1,2,0,0,0,  1,1,1,2,2,2,
     3     1,1,2,0,0,0,  1,1,1,0,0,0,
     4     1,1,1,2,2,2/
      DATA      MCS/  6,4,4,3,2,2,2,1,2/
      DATA      VAR/ 1,1,1,1,1,1,1,1,6*1,    1,0,1,0,1,1,1,1,6*1,
     1     0,0,1,0,1,1,1,1,6*1,    1,0,0,0,0,1,1,1,6*1,
     2     0,0,0,0,0,1,1,1,6*1,    1,1,1,1,0,0,0,0,6*1,
     3     0,0,0,0,0,0,0,0,6*1/
C     
C
C
C
      NACC = 0
      IER=-3
      SDU=0.0
      DO 10 MY1=1,6
         IF (RCELL(MY1).LE.0.0) RETURN
         IF ((MY1.GT.3).AND.(RCELL(MY1).GT.179.0))RETURN
 10   SDCELL(MY1)=0.0
C     
C----  get number of independent parameters
C
      IF ((ICS.GT.0).AND.(ICS.LT.10))THEN
         M=MCS(ICS)
      ELSE
         M=0
      ENDIF
      MFREE=M+8
C
C----  check for sufficient number of reflections
C
      IER=0
      IF (NREF.LE.MFREE)RETURN
C
C----  check if crystal orientation and cell parameters
C      should be separated
C
      IF (IC.LT.1)IC=1
      IF (IC.GT.7)IC=7
      IF ((ICS.EQ.1).AND.(IC.LT.6))THEN
        SPLIT=0
      ELSE
        SPLIT=1
      ENDIF
C
C----  check q,f
C
      IF (Q.LE.0.0)IER=-1
      IF (FDIST.le.1e-5)IER=-2
      IF (IER.LT.0)RETURN
C
C----  get weights for observational equations
C
      IF (SDPHI.LE.0.0)SDPHI=0.1
      SDPHI0=SDPHI/RAD
      WPHI=1.0/SDPHI0**2
      IF (SDXY.LE.0.0)SDXY=1.0
      SDXY0=SDXY*Q
      WXY=1.0/SDXY0**2
C
C----  check number of refine cycles
C
      IER=-6
      IF ((NCYCLE.LT.1).OR.(NCYCLE.GT.10))RETURN
C
C----  check reindexing transformation
C
      IER=-7
      I=REIDX(1)*(REIDX(6)*REIDX(11)-REIDX(7)*REIDX(10))
     1     -REIDX(2)*(REIDX(5)*REIDX(11)-REIDX(7)*REIDX( 9))
     2     +REIDX(3)*(REIDX(5)*REIDX(10)-REIDX(6)*REIDX( 9))
      IF (I.EQ.0)RETURN
C     
C----  define goniostat system
C
      CALL GONSYS(ACHSE,S0L,S0G,EG,I)
      IF (I.NE.0)THEN
        IER=-4
        RETURN
      ENDIF
C
C----  renormalize crystal orientation matrix to orthogonal form to
C      prevent accumulation of rounding errors.
C
      CALL UNORM(UMAT,I)
      IF (I.NE.0)THEN
        IER=-5
        RETURN
      ENDIF
C
C----  get representation of crystal orientation matrix
C      with respect to goniostat system
C
      CALL MINV33(RFXAMAT,EG,R)
      CALL MATMUL3(UG,RFXAMAT,UMAT)
C
C----  get representation of detector orientation matrix
C    * with respect to goniostat system
C
      CALL UNORM(ED,I)
      IF (I.NE.0)THEN
        IER=-2
        RETURN
      ENDIF
      CALL MATMUL3(EDG,RFXAMAT,ED)
C
C----  save original detector orientation matrix
C
      CALL MATCOP(EDG,EDG0)
C
C----  refinement loop 
C
C     derivatives of sin/cos of spindle position with respect to
C     distance and orientation of the detector are always zero.
C
      DO 20 J=1,4
         DSPHIC(J)=0.0
         DCPHIC(J)=0.0
 20   ENDDO
      DO 570 ICYCLE=1,NCYCLE
      IF(DEBUG(76))THEN
         CALL RECCEL(CELL,RCELL,1.0)
      IF(ONLINE)WRITE(*,6800)ICYCLE
 6800 FORMAT('CELREF CYCLE NUMBER ',I1,' STARTING')
      IF(ONLINE)WRITE(*,6820)NCYCLE,REIDX,NREF,ACHSE,IC,ICS,
     @            Q,ORGX,ORGY,FDIST,S0L,((ED(I,J),J=1,3),I=1,3),
     1     ((UG(I,J),J=1,3),I=1,3),RCELL,CELL,SDU,SDCELL,SDPHI,
     +     SDXY,IER
      WRITE(IOUT,6800)ICYCLE
      WRITE(IOUT,6820)NCYCLE,REIDX,NREF,ACHSE,IC,ICS,
     @            Q,ORGX,ORGY,FDIST,S0L,((ED(I,J),J=1,3),I=1,3),
     1     ((UG(I,J),J=1,3),I=1,3),RCELL,CELL,SDU,SDCELL,SDPHI,
     +     SDXY,IER
 6820 format(72(1H-),/,'NCYCLE = ',i2,/,'REIDX0 = ',4i2,2(/,9X,4I2),/,
     $     'NREF = ',i5,/,'ACHSE = ',3F5.2,/,
     $     'IC = ',i2,'   ICS = ',i2,'   RAST = ',F8.4,/,
     $     'ORGX = ',F8.2,'  ORGY = ',F8.2,'    XTD = ',F8.2,/,
     $     'S0L = ',3F12.6,/,'ED = ',3F5.2,2(/,5X,3F5.2),/,
     $     'UG =   ',3F10.6,2(/,7X,3F10.6),/,'RCELL = ',
     $     6f9.4,/,'CELL =  ',
     $     6f9.4,/,'SDU = ',f10.6,/,'SDCELL = ',6F10.4,
     $     /,'SDPHI = ',F10.6,'    SDXY = ',F10.6,'  IERR = ',I4,/,
     $     72(1H=),/)
      endif
         ESDPHI=0.0
         ESDXY =0.0
C
C----  clear normal matrix and right hand sides
C
         DO 30 MY1=1,MMFREE
            QD(MY1)=ZERO
 30      ENDDO
         DO 40 MY1=1,MXRIGHT
            RD(MY1)=ZERO
 40      ENDDO
         DO 50 MY1=1,MXFREE
            AVGX(MY1)=ZERO
            AVGY(MY1)=ZERO
 50      ENDDO
         DO 60 MY1=1,NRIGHT
            AVX(MY1)=ZERO
            AVY(MY1)=ZERO
 60      ENDDO
C----  calculate derivative of detector orientation matrix
C
         DO 70 J=1,3
            DEDG(1,J,1)= 0.0
            DEDG(2,J,1)=-EDG(3,J)
            DEDG(3,J,1)= EDG(2,J)
            DEDG(1,J,2)= EDG(3,J)
            DEDG(2,J,2)= 0.0
            DEDG(3,J,2)=-EDG(1,J)
            DEDG(1,J,3)=-EDG(2,J)
            DEDG(2,J,3)= EDG(1,J)
            DEDG(3,J,3)= 0.0
 70      ENDDO
C
C----  calculate derivatives of direct beam wavevector
C
         DS0G(1)= 0.0
         DS0G(2)=-S0G(3)
         DS0G(3)= S0G(2)
C     
C----  calculate derivative of crystal orientation matrix
C
         IF (SPLIT.NE.0)THEN
            DO 80 J=1,3
               DUG(1,J,1)= 0.0
               DUG(2,J,1)=-UG(3,J)
               DUG(3,J,1)= UG(2,J)
               DUG(1,J,2)= UG(3,J)
               DUG(2,J,2)= 0.0
               DUG(3,J,2)=-UG(1,J)
               DUG(1,J,3)=-UG(2,J)
               DUG(2,J,3)= UG(1,J)
               DUG(3,J,3)= 0.0
 80         ENDDO
         ENDIF
C
C----  calculate setting matrix
C
C 90      CONTINUE
         DO 100 I=1,3
            R=RCELL(I+3)/RAD
            B(I)  =COS(R)
            B(I+3)=SIN(R)
            DO 97 J=1,3
               A0(I,J)=0.0
               DO 93 MY1=1,6
                  DA(I,J,MY1)=0.0
 93            ENDDO
 97         ENDDO
 100     ENDDO
         A0(1,1)=RCELL(1)*B(5)
         A0(1,2)=RCELL(2)*(B(3)-B(1)*B(2))/B(5)
         A0(2,2)=SQRT((RCELL(2)*B(4))**2-A0(1,2)**2)
         A0(3,1)=RCELL(1)*B(2)
         A0(3,2)=RCELL(2)*B(1)
         A0(3,3)=RCELL(3)
         IF ((M.GE.1).AND.(SPLIT.NE.0))THEN
C
C----  calculate derivatives of setting matrix with respect to
C       independent cell parameters
C
            DA(1,1,1)=B(5)
            DA(3,1,1)=B(2)
            DA(1,2,2)=A0(1,2)/RCELL(2)
            DA(2,2,2)=A0(2,2)/RCELL(2)
            DA(3,2,2)=A0(3,2)/RCELL(2)
            DA(3,3,3)=1.0
            DA(1,2,4)=RCELL(2)*B(4)*B(2)/B(5)
            DA(2,2,4)=(A0(3,2)*B(4)-A0(1,2)*DA(1,2,4))/A0(2,2)
            DA(3,2,4)=-RCELL(2)*B(4)
            DA(1,1,5)=A0(3,1)
            DA(3,1,5)=-A0(1,1)
            DA(1,2,5)=A0(3,2)-A0(1,2)*B(2)/B(5)
            DA(2,2,5)=-A0(1,2)*DA(1,2,5)/A0(2,2)
            DA(1,2,6)=-RCELL(2)*B(6)/B(5)
            DA(2,2,6)=-A0(1,2)*DA(1,2,6)/A0(2,2)
            DO 130 I=1,3
               DO 127 J=1,3
                  DO 110 MY1=1,M
                     B(MY1)=0.0
 110              ENDDO
                  DO 120 MY1=1,6
                     MY2=IP(MY1,ICS)
                     IF (MY2.GT.0)B(MY2)=B(MY2)+DA(I,J,MY1)
 120              ENDDO
                  DO 123 MY1=1,M
                     DA(I,J,MY1)=B(MY1)
 123              ENDDO
 127           ENDDO
 130        ENDDO
            DO 150 MY1=1,M
               DO 140 I=1,3
                  DO 135 J=1,3
                     RFXAMAT(I,J)=UG(I,1)*DA(1,J,MY1)+UG(I,2)*
     $                    DA(2,J,MY1)+UG(I,3)*DA(3,J,MY1)
 135              ENDDO
 140           ENDDO
               DO 148 I=1,3
                  DO 145 J=1,3
                     DA(I,J,MY1) = RFXAMAT(I,J)
 145              ENDDO
 148           ENDDO
 150        ENDDO
         ENDIF
 160     CALL MATMUL3(RFXAMAT,UG,A0)
C
C----  enter contributions of observational equations 
C
         NACC=0
         SEED=1009
c         DO 165 NY = 1,NREF
c            IF ((IH(NY).EQ.0).AND.(IK(NY).EQ.0).AND.(IL(NY).EQ.0))
c     +           NBAD(1) = NBAD(1) + 1
c 165     ENDDO
         IF(NBAD(1).EQ.NREF)THEN
            IER = 0
            RETURN
         ENDIF 

         DO 330 NY=1,NREF
C
C----  apply reindexing
C
            IF ((IH(NY).NE.0).OR.(IK(NY).NE.0).OR.(IL(NY).NE.0))THEN
               FH=REIDX(1)*IH(NY)+REIDX( 2)*IK(NY)+
     $              REIDX( 3)*IL(NY)+REIDX( 4)
               FK=REIDX(5)*IH(NY)+REIDX( 6)*IK(NY)+
     $              REIDX( 7)*IL(NY)+REIDX( 8)
               FL=REIDX(9)*IH(NY)+REIDX(10)*IK(NY)+
     $              REIDX(11)*IL(NY)+REIDX(12)
               XOBS=(IX(NY)/10.0-ORGX)*Q
               YOBS=(IY(NY)/10.0-ORGY)*Q
               R=IPHI(NY)/RAD100
               CPHI=COS(R)
               SPHI=SIN(R)
C     
C---- get goniostat coordinates of reflection at phi=0
C
               DO 170 I=1,3
                  X0G(I)=RFXAMAT(I,1)*FH+RFXAMAT(I,2)*FK+RFXAMAT(I,3)*FL
 170           ENDDO
C
C----  get goniostat coordinates of reflection at diffraction
C
               RR=X0G(1)**2+X0G(2)**2+X0G(3)**2
               RHOQ=RR-X0G(2)**2
               XG(3)=-(RR*0.5+X0G(2)*S0G(2))/S0G(3)
               XG(2)=X0G(2)
               XG(1)=RHOQ-XG(3)**2
               IF (XG(1).LE.0.0)GO TO 325
               XG(1)=SQRT(XG(1))
               IF ((X0G(1)*CPHI+X0G(3)*SPHI).LT.0.0)XG(1)=-XG(1)
C     
C----  calculate sin/cos of spindle position at diffraction
C
               CPHIC=(XG(1)*X0G(1)+XG(3)*X0G(3))/RHOQ
               SPHIC=(XG(1)*X0G(3)-XG(3)*X0G(1))/RHOQ
C
C----  get goniostat coordinates of diffracted beam wavevector
C
               DO 180 I=1,3
                  SG(I)=S0G(I)+XG(I)
 180           ENDDO
C
C----  get detector coordinates of diffracted beam wavevector
C
               DO 190 I=1,3
                  SD(I)=EDG(1,I)*SG(1)+EDG(2,I)*SG(2)+EDG(3,I)*SG(3)
 190           ENDDO
               IF (SD(3).le.1e-5)GO TO 325
C     
C----  get detector coordinates of intersection point of diffracted
C       beam with detector surface
C
               XCALC = FDIST * SD(1)/SD(3)
               YCALC = FDIST * SD(2)/SD(3)
c 6840          FORMAT('+++++ DPS ++++++',/,
c     $              '   H   K   L   IP(X)  IP(Y)     X(OBS)',
c     $              '      Y(OBS)      X(CALC)     Y(CALC)')
c 6860          FORMAT(3I4,2I7,4F12.5)
c               IF (DEBUG(76))THEN
c                  IF(NY.EQ.1) THEN
c                     IF(ONLINE)WRITE(*,FMT=6840)         
c                     WRITE(IOUT,FMT=6840) 
c                  ENDIF
c                  IF (NY.LE.10) THEN
c                     IF(ONLINE)WRITE(*,FMT=6860)IH(NY),IK(NY),IL(NY),
c     $                 IX(NY),IY(NY),XOBS,YOBS,XCALC,YCALC
c                     WRITE(IOUT,FMT=6860)IH(NY),IK(NY),IL(NY),IX(NY),
c     $                    IY(NY),XOBS,YOBS,XCALC,YCALC
c                  ENDIF
c               ENDIF
               NACC = NACC+1
C     
C----  derivatives with respect to f
C
               DXCALC(1) = SD(1)/SD(3)
               DYCALC(1) = SD(2)/SD(3)
C
C----  derivatives with respect to detector orientation
C
               DO 200 MY1=1,3
                  T1=DEDG(1,1,MY1)*SG(1)+DEDG(2,1,MY1)*SG(2)+
     $                 DEDG(3,1,MY1)*SG(3)
                  T2=DEDG(1,2,MY1)*SG(1)+DEDG(2,2,MY1)*SG(2)+
     $                 DEDG(3,2,MY1)*SG(3)
                  T3=DEDG(1,3,MY1)*SG(1)+DEDG(2,3,MY1)*SG(2)+
     $                 DEDG(3,3,MY1)*SG(3)
                  DXCALC(MY1+1) = (T1 * FDIST - T3 * XCALC)/SD(3)
                  DYCALC(MY1+1) = (T2 * FDIST - T3 * YCALC)/SD(3)
 200           ENDDO
C
C----  derivatives with respect to kappa
C           ..... derivatives of goniostat coordinates "xg"
C
               DXG(3)=X0G(2)-XG(3)*S0G(2)/S0G(3)
               DXG(1)=-XG(3)*DXG(3)/XG(1)
C
C          ..... derivatives of sin/cos of spindle position
C
               DSPHIC(5)=(DXG(1)*X0G(3)-DXG(3)*X0G(1))/RHOQ
               DCPHIC(5)=(DXG(1)*X0G(1)+DXG(3)*X0G(3))/RHOQ
C
C         ..... derivatives of goniostat coordinates of "sg"
C
               DSG(1)=DXG(1)
               DSG(2)=-S0G(3)
               DSG(3)=DXG(3)+S0G(2)
C
C            ..... detector coordinates of derivatives of 
C            diffracted beam wavevector
C
               DO 210 I=1,3
                  DS D(I)=EDG(1,I)*DSG(1)+EDG(2,I)*
     $                 DSG(2)+EDG(3,I)*DSG(3)
 210           ENDDO
C
C           ..... derivatives of calculated detector coordinates
C
               DXCALC(5)=(DSD(1) * FDIST - DSD(3) * XCALC)/SD(3)
               DYCALC(5)=(DSD(2) * FDIST - DSD(3) * YCALC)/SD(3)
C
C----  derivatives with respect to reciprocal cell setting matrix
C
               IF (SPLIT.NE.1)THEN
                  DO 220 I=1,3
                     DO 215 J=1,M+3
                        DX0G(I,J)=0.0
 215                 ENDDO
 220              ENDDO
                  DO 230 I=1,3
                     DX0G(I,I  )=FH
                     DX0G(I,I+3)=FK
                     DX0G(I,I+6)=FL
 230              ENDDO
                  GO TO 260
C
C----  derivatives with respect to unit cell orientation
C     
               ENDIF
 240           DX0G(1,1)= 0.0
               DX0G(2,1)=-X0G(3)
               DX0G(3,1)= X0G(2)
               DX0G(1,2)= X0G(3)
               DX0G(2,2)= 0.0
               DX0G(3,2)=-X0G(1)
               DX0G(1,3)=-X0G(2)
               DX0G(2,3)= X0G(1)
               DX0G(3,3)= 0.0
               IF (M.GE.1)THEN
C
C        ..... derivatives with respect to independent cell parameters
C
                  DO 250 MY1=1,M
                     DO 245 I=1,3
                        DX0G(I,MY1+3)=DA(I,1,MY1)*FH+DA(I,2,MY1)*
     $                       FK+DA(I,3,MY1)*FL
 245                 ENDDO
 250              ENDDO
C
C         ..... derivatives with respect to unit cell orientation and
C                independent cell parameters
C
               ENDIF
 260           DO 280 J=1,M+3
                  DRR=X0G(1)*DX0G(1,J)+X0G(2)*DX0G(2,J)+X0G(3)*DX0G(3,J)
                  DXG(3)=-(DRR+S0G(2)*DX0G(2,J))/S0G(3)
                  DXG(1)=(DRR-X0G(2)*DX0G(2,J)-XG(3)*DXG(3))/XG(1)
                  DRHOQ=2.0*(X0G(1)*DX0G(1,J)+X0G(3)*DX0G(3,J))
                  DSPHIC(J+5)=(DXG(1)*X0G(3)+XG(1)*DX0G(3,J)
     @                 -DXG(3)*X0G(1)-XG(3)*DX0G(1,J)-SPHIC*DRHOQ)/RHOQ
                  DCPHIC(J+5)=(DXG(1)*X0G(1)+XG(1)*DX0G(1,J)
     @                 +DXG(3)*X0G(3)+XG(3)*DX0G(3,J)-CPHIC*DRHOQ)/RHOQ
C
C         ..... derivatives of goniostat coordinates of "sg"
C
                  DSG(1)=DXG(1)
                  DSG(2)=DX0G(2,J)
                  DSG(3)=DXG(3)
C
C          ..... detector coordinates of derivatives of 
C                diffracted beam wavevector
C
                  DO 270 I=1,3
                     DSD(I)=EDG(1,I)*DSG(1)+EDG(2,I)*
     $                    DSG(2)+EDG(3,I)*DSG(3)
 270              ENDDO
C
C          ..... derivatives of calculated detector coordinates
C
                  DXCALC(J+5) = (DSD(1) * FDIST - DSD(3) * XCALC)/SD(3)
                  DYCALC(J+5) = (DSD(2) * FDIST - DSD(3) * YCALC)/SD(3)
 280           ENDDO
C
C----  calculate residuals
C
               RCPHI(1)=CPHIC-CPHI
               RSPHI(1)=SPHIC-SPHI
               DELX(1)=XCALC-XOBS
               DELY(1)=YCALC-YOBS
C
C----  remove outliers from next refinement round
C
               IF((SQRT((DELX(1)**2)+(DELY(1)**2)).GE.SDCUTOFF*
     $              SDXY*Q).AND.(ICYCLE.GT.2))THEN
                  IH(NY) = 0
                  IK(NY) = 0
                  IL(NY) = 0
                  NBAD(1) = NBAD(1) + 1
               ENDIF
C
C----  add normally distributed random errors to residuals
C
               R=SQRT(RR/RHOQ)*SDPHI0
               DO 290 MY1=2,NRIGHT
                  SEED=MOD(151*SEED+1,20011)
                  ERROR=(SEED/20011.0-0.5)*R
                  RCPHI(MY1)=RCPHI(1)+SPHI*ERROR
                  RSPHI(MY1)=RSPHI(1)-CPHI*ERROR
                  SEED=MOD(151*SEED+1,20011)
                  DELX(MY1)=DELX(1)-(SEED/20011.0-0.5)*SDXY0
                  SEED=MOD(151*SEED+1,20011)
                  DELY(MY1)=DELY(1)-(SEED/20011.0-0.5)*SDXY0
 290           ENDDO
C
C----  add contributions to determine root-mean-square of residuals
C
               ESDPHI=ESDPHI+(RCPHI(1)**2+RSPHI(1)**2)*RHOQ/RR
               ESDXY=ESDXY+DELX(1)**2+DELY(1)**2
C
C----  add contribution of this reflection to normal equations
C
               MM=0
               DO 310 MY1=1,MFREE
                  AVGX(MY1)=AVGX(MY1)+DXCALC(MY1)
                  AVGY(MY1)=AVGY(MY1)+DYCALC(MY1)
                  T1=DSPHIC(MY1)*WPHI*RHOQ/RR
                  T2=DCPHIC(MY1)*WPHI*RHOQ/RR
                  T3=DXCALC(MY1)*WXY
                  T4=DYCALC(MY1)*WXY
                  J=MY1
                  DO 300 MY2=1,NRIGHT
                     RD(J)=RD(J)-RSPHI(MY2)*T1-RCPHI(MY2)*T2-DELX(MY2)*
     $                    T3-DELY(MY2)*T4
                     J=J+MFREE
 300              ENDDO
                  DO 305 MY2=1,MY1
                     MM=MM+1
                     QD(MM)=QD(MM)+T1*DSPHIC(MY2)+T2*DCPHIC(MY2)
     @                    +T3*DXCALC(MY2)+T4*DYCALC(MY2)
 305              ENDDO
 310           ENDDO
               DO 320 MY2=1,NRIGHT
                  AVX(MY2)=AVX(MY2)+DELX(MY2)
                  AVY(MY2)=AVY(MY2)+DELY(MY2)
 320           ENDDO
            ENDIF
 325        CONTINUE            ! okay for a GOTO target
 330     ENDDO
C
C---- get estimated standard deviations of observed reflection
C       positions and angles
C
         IF (NACC.LE.MFREE)THEN
            IER=0
            RETURN
         ENDIF
         SDPHI=RAD*SQRT(ESDPHI/(NACC-MFREE))
         SDXY=SQRT(ESDXY/(NACC-MFREE))/Q
C     
C----  get mean-values of residuals
C
         DO 340 MY2=1,NRIGHT
            AVX(MY2)=AVX(MY2)/NACC
            AVY(MY2)=AVY(MY2)/NACC
 340     ENDDO
C
C----  get mean-values of gradients
C
         DO 350 MY1=1,MFREE
            AVGX(MY1)=AVGX(MY1)/NACC
            AVGY(MY1)=AVGY(MY1)/NACC
 350     ENDDO
C
C----  correct origin
C
         ORGX=ORGX-AVX(1)/Q
         ORGY=ORGY-AVY(1)/Q
C
C----  early termination because goal has already been achieved
C
         IF ((SDPHI.GE.0.01).OR.(SDXY.GT.0.05))THEN

C     IF ((SDPHI.LT.0.01).AND.(SDXY.LE.0.05))GO TO 600
C
C----  subtract mean-values of residuals from right-hand side
C      and tensor product of mean gradients from normal matrix
C
            MM=0
            DO 370 MY1=1,MFREE
               J=MY1
               DO 360 MY2=1,NRIGHT
                  RD(J)=RD(J)+WXY*NACC*(AVX(MY2)*AVGX(MY1)+
     $                 AVY(MY2)*AVGY(MY1))
                  J=J+MFREE
 360           ENDDO
               DO 365 MY2=1,MY1
                  MM=MM+1
                  QD(MM)=QD(MM)-WXY*NACC*(AVGX(MY1)*AVGX(MY2)+
     $                 AVGY(MY1)*AVGY(MY2))
 365           ENDDO
 370        ENDDO
C     
C----  rescale system of equations
C
            MM=0
            DO 380 MY1=1,MFREE
               MM=MM+MY1
               Z=QD(MM)
               IF (Z.GT.ZERO)Z=ONE/DSQRT(Z)
               AVGX(MY1)=Z
               ESD(MY1)=Z
               J=MY1
               DO 375 MY2=1,NRIGHT
                  RD(J)=RD(J)*Z
                  J=J+MFREE
 375           ENDDO
 380        ENDDO
            MM=0
            DO 390 MY1=1,MFREE
               DO 385 MY2=1,MY1
                  MM=MM+1
                  QD(MM)=QD(MM)*AVGX(MY1)*AVGX(MY2)
 385           ENDDO
 390        ENDDO
C     
C----  remove fixed parameters from the normal equations
C
            MM=0
            DO 430 MY1=1,MFREE
               IF (VAR(MY1,IC).EQ.0)THEN
                  J=MY1
                  DO 400 MY2=1,NRIGHT
                     RD(J)=ZERO
                     J=J+MFREE
 400              ENDDO
               ENDIF
 410           DO 420 MY2=1,MY1
                  MM=MM+1
                  IF (((VAR(MY1,IC).EQ.0).OR.(VAR(MY2,IC).EQ.0))
     $                 .AND.(MY2.NE.MY1))
     @                 QD(MM)=ZERO
 420           ENDDO
               QD(MM)=ONE
 430        ENDDO
C
C----  solve normal equations
C
            CALL DGELS(RD,QD,MFREE,NRIGHT,EPS,IRANK,AVGX)
            DO 450 MY1=1,MFREE
               Z=ZERO
               MM=MY1
               DO 440 MY2=1,NRIGHT
                  RD(MM)=RD(MM)*ESD(MY1)
                  Z=Z+(RD(MM)-RD(MY1))**2
                  MM=MM+MFREE
 440           ENDDO
               ESD(MY1)=DSQRT(Z/(NRIGHT-1))
 450        ENDDO
C
C----  get scaling factor for standard deviations of cell parameters
C
            T1=SDPHI/SQRT(SDPHI**2+(SDPHI0*RAD)**2)
C
C            t2=sdxy/sqrt(sdxy**2+(sdxy0/q)**2)
C
C----  apply corrections and calculate estimated standard deviations
C        for the refined parameters
C
C            ..... detector distance
C
            FDIST = FDIST + RD(1)
C
C            ..... detector orientation
C
            DO 460 J=1,3
               DO 455 I=1,3
                  EDG(I,J)=EDG(I,J)
     @                 +RD(2)*DEDG(I,J,1)+RD(3)*DEDG(I,J,2)+
     $                 RD(4)*DEDG(I,J,3)
 455           ENDDO
 460        ENDDO
            CALL UNORM(EDG,I)
            IF (I.NE.0)THEN
               IER=-2
               RETURN
            ENDIF
C
C              .....incident x-ray beam (kappa)
C
            R=RD(5)
            CPHI=COS(R)
            SPHI=SIN(R)
            R=S0G(2)*CPHI-S0G(3)*SPHI
            S0G(3)=S0G(3)*CPHI+S0G(2)*SPHI
            S0G(2)=R
            IF (SPLIT.NE.0)THEN
C     
C             .....orientation matrix
C
               DO 470 J=1,3
                  DO 465 I=1,3
                     UG(I,J)=UG(I,J)+RD(6)*DUG(I,J,1)+
     $                    RD(7)*DUG(I,J,2)+RD(8)*DUG(I,J,3)
 465              ENDDO
 470           ENDDO
               CALL UNORM(UG,I)
               IF (I.NE.0)THEN
                  IER=-5
                  RETURN
               ENDIF
               SDU=RAD*SQRT(ESD(6)**2+ESD(7)**2+ESD(8)**2)
C     
C            .....reciprocal cell dimensions
C
               DO 480 MY1=1,6
                  B(MY1)=RCELL(MY1)
                  RZELLE(MY1)=RCELL(MY1)
                  SDCELL(MY1)=0.0
 480           ENDDO
               IF (M.LT.1)GO TO 565
               DO 500 I=1,NRIGHT
                  DO 490 MY1=1,6
                     MY2=IP(MY1,ICS)
                     IF (MY2.GT.0)THEN
                        IF (MY1.LT.4)THEN
                           R=RD(MY2+8+MFREE*(I-1))
                        ELSE
                           R=RAD*RD(MY2+8+MFREE*(I-1))
                        ENDIF
                        RZELLE(MY1)=B(MY1)+R
                     ENDIF
 485                 CONTINUE
 490              ENDDO
c                  CALL INVCEL(ZELLE,RZELLE,R)
                  CALL RECCEL(ZELLE,RZELLE,1.0)
                  DO 495 MY1=1,6
                     IF (I.EQ.1)THEN
                        CELL(MY1)=ZELLE(MY1)
                        RCELL(MY1)=RZELLE(MY1)
                     ELSE
                        SDCELL(MY1)=SDCELL(MY1)+
     $                       (ZELLE(MY1)-CELL(MY1))**2
                     ENDIF
 495              ENDDO
 500           ENDDO
               GO TO 540
C     
C----    update rec. setting matrix and extract cell parameters and
C        crystal orientation
C
            ENDIF
 510        DO 530 MY1=1,NRIGHT
               DO 520 I=1,3
                  DO 515 J=1,3
                     A0(I,J) = RFXAMAT(I,J)+RD(I+3*(J-1)+5+
     $                   MFREE*(MY1-1))
 515              ENDDO
 520           ENDDO
               IF (MY1.EQ.1)CALL MATCOP(A0,UMAT)
               CALL MINV33(BASIS,A0,R)
               CALL METRIC(BASIS,ZELLE,IER)
               CALL RECCEL(RZELLE,ZELLE,1.0)
c               CALL INVCEL(RZELLE,ZELLE,R)
               DO 525 I=1,6
                  IF (MY1.EQ.1)THEN
                     CELL(I)=ZELLE(I)
                     RCELL(I)=RZELLE(I)
                  ELSE
                     SDCELL(I)=SDCELL(I)+(ZELLE(I)-CELL(I))**2
                  ENDIF
 525           ENDDO
 530        ENDDO
            CALL RFSETMAT(RCELL,RFXAMAT)
            CALL MINV33(BASIS,RFXAMAT,R)
            CALL MATMUL3(UG,UMAT,BASIS)
 540        DO 550 I=1,6
               SDCELL(I)=SQRT(T1*SDCELL(I)/(NRIGHT-1))
 550        ENDDO
         ELSE
            GOTO 600 !early termination because goal has already been achieved
         ENDIF
 565     CONTINUE
 570  ENDDO
C
C----  end of refinement loop 
C
C
 600  IF (IC.NE.5)THEN
C     
C---- transform back to laboratory coordinate system
C     
         CPHI=0.0
         SPHI=0.0
         DO 610 I=1,3
            CPHI=CPHI+EDG0(3,I)*EDG(3,I)+EDG0(1,I)*EDG(1,I)
            SPHI=SPHI+EDG0(1,I)*EDG(3,I)-EDG0(3,I)*EDG(1,I)
 610     ENDDO
         R=SQRT(CPHI**2+SPHI**2)
         CPHI=CPHI/R
         SPHI=SPHI/R
         DO 620 I=1,3
            R=EG(1,I)*CPHI+EG(3,I)*SPHI
            EG(3,I)=EG(3,I)*CPHI-EG(1,I)*SPHI
            EG(1,I)=R
 620     ENDDO
      ENDIF
 630  CALL MATMUL3(ED,EG,EDG)
      CALL MATMUL3(UMAT,EG,UG)
      DO 640 I=1,3
         S0L(I)=EG(I,2)*S0G(2)+EG(I,3)*S0G(3)
 640  ENDDO
      IER=NACC
 650  RETURN
      END
      
C $Id: cgfit.f,v 1.13 2009/01/26 13:57:18 harry Exp $
C== CGFIT ==
C
      SUBROUTINE CGFIT(RAS,IRAS,IDR,DELX,DELY,SPOT,SDELX,SDELY,IPART,
     +                 IFLAG)
C     ==============================================================
C
      IMPLICIT NONE
C   Determine the centre of gravity of the spot and its integrated
C   intensity (SPOT)
C   Introduce rejection of background pixels 11/3/91
C
C   Returns:
C           DELX, DELY   c. og g. shift from centre of box
C           SPOT         Integrated intensity
C           SDELX,SDELY  Standard deviations in centre of gravity coords.
C           IFLAG        = 0 Spot is OK
C                        = 1 Too steep background gradient
C                        = 2 Too many background pixels rejected
C                        = 3 Contains zero value pixels
C                        = 4 Overloaded spot
C
C     .. Parameters ..
C&&*&& include  ../inc/parameter.f
C
C $Id: parameter.f,v 1.17 2009/10/28 16:43:34 harry Exp $
C
C--- awk generated include file  parameter.h
C---- START of include file parameter.h
C
C       PARAMETERS
C       IYLENGTH.. maximum number of I*2 words of data in the 
C                  "fast" (ie most rapidly changing) direction in the
C                  digitised image. This will be HALF the number of pixels
C                  for film data (each pixel is stored in one byte)
C                  but will equal the number of pixels for IP data.
C       IXWDTH...  The maximum number of "stripes" of data in the scanned image
C                  ie the number of pixels in the "slow" direction
C                  (This is the Y direction in the MOSFLM convention)
C                  Note that the array "IMAGE" used to store the image is
C                  declared as size IYLENGTH*IXWDTH I*2 words for IP data
C                  and 2*IYLENGTH*IXWDTH BYTES for film data.
C                  If this exceeds the
C                  available memory, set ixwdth=1, recompile program
C                  and use keyword "NOCORE" when running program.
C                  Note that for the POSTREF and ADDPART options,
C                  two images have to be stored in memory at once so
C                  IXWDTH should be twice the number of records in an
C                  image.
C       MAXHEAD    maximum length of image header (in 4 byte words)
C       NREFLS.... maximum number of spots per film in generate file (250,000)
C       MAXBOX.... maximum number of pixels in measurement box (1500)
C       MAXDIM.... maximum box size in either direction (pixels) (41)
C       MAXPAX.... maximum number of packs per generate file (10000)
C       MXDOV2..... maxdim/2
C       MAXBUFF... maximum size of buffer (I*2) for storing ods
C                  of active spots in subroutine meas(21,000).
C                  Must be .GE.  MAXBOX*(NNLINE-1) for subroutine process
C       MREF...... maximum number of reflections to be used in post
C                  refinement (6000)
C       NEXPAND... maximum number of expansions of the input measurement
C                  box (2)
C       NMASKS.... maximum number of different profiles (25). Note the
C                  connection between this parameter and NNLINE
C       NVECT..... maximum number of vectors for storing scanned image
C                  in filmplot (10000)
C       NIMAX..... maximum number of images to be used together in 
C                  postrefinement (NADD or WIDTH options) (100)
C       NNLINE...  maximum number of boundary lines for setting up
C                  the areas for profile fitting. The maximum possible
C                  number of standard profiles will be (NNLINE-1)**2
C                  although for a circular detector the actual number
C                  may be less than this as some boxes will lie entirely
C                  outside the detector.
C       NREJMAX... Maximum number of rejected background pixels, resulting
C                  either from overlap of adjacent spots or outliers from
C                  the background plane
C       NSPOTS...  Maximum number of found spots (for autoindexing) that can
C                  be stored (for all images). Also maximum number in 
C                  a file wriitten by IMSTILLS that can be 
C                  stored/displayed/edited. THis must be an even number
C       MCOLS....  Number of columns in output MTZ file
C       MCOLSTR..  Number of columns in output MTZ file for strategy option
C     
C       MTZ Orientation block
C        MBLENG is total length of block, MBLINT, MBLREA are numbers
C          of integers & reals
C       NDETREF    Maximum number of reflections used for detector parameter
C                  refinement (previously 62)
C       NRPAR....  Maximum number of refineable parameters for detector
C                  positional refinement (subroutine RDIST)
C       NSEGMAX..  Maximum number of segments in STRATEGY
C       NSEGMAXPR  Maximum number of segments in POST-REFINEMENT
C       MULTMAX... Maximum number of observations with same hkl in COMPLETE
C       MAXDIFF... Maximum number of different packs that a given hkl occurs on
C       NRESBIN... Maximum number of resolution bins (COMPLETE)
C
C       MAXIMG...  Maximum number of images that can be read in using the IMAGE
C                  keyword or the "read Image" menu option.
C       MXSPOT...  Maximum number of spots that can be found on one image
C                  (before rejection on spot size).
C       MXCENT...  Maximum number of active spots during spot finding 
C                  (findspots)
C
C       MGRA, NGRA... maximum number of reflections and images over which a 
C                     reflection can be spread for postrefinement.
C       MAXBGBOX    Maximum number of local background background boxes 
C                   in X and Y
C
C       MAXNPEAKS   Maximum number of local maxima within one spot
C       MAXEXCL     Maximum number of excluded areas of the same type
C                   eg reactangles, quadrilaterals, arcs, resolution shells
C
C     .. Parameters ..
      INTEGER IXWDTH
c      PARAMETER (IXWDTH=8192)
      PARAMETER (IXWDTH=12288)
      INTEGER IYLENGTH
c      PARAMETER (IYLENGTH=4096)
      PARAMETER (IYLENGTH=6144)
      INTEGER MAXHEAD
      PARAMETER (MAXHEAD=5120)
      INTEGER MAXBOX
      PARAMETER (MAXBOX=3000)
      INTEGER MAXDIM
      PARAMETER (MAXDIM=41)
      INTEGER MAXPAX
      PARAMETER (MAXPAX=10000)
      INTEGER MXDOV2
      PARAMETER (MXDOV2=MAXDIM/2)
      INTEGER NEXPAND
      PARAMETER (NEXPAND=2)
      INTEGER NNLINE
      PARAMETER (NNLINE=8)
      INTEGER NMASKS
      PARAMETER (NMASKS=49)
      INTEGER MAXBUFF
      PARAMETER (MAXBUFF=21000)
      INTEGER NREFLS
      PARAMETER (NREFLS=250000)
      INTEGER MREF
      PARAMETER (MREF=6000)
      INTEGER NVECT
      PARAMETER (NVECT=10000)
      INTEGER NIMAX
      PARAMETER (NIMAX=100)
      INTEGER NREJMAX
      PARAMETER (NREJMAX=1000)
      INTEGER NSPOTS
      PARAMETER (NSPOTS=5000)
      INTEGER MCOLS
      PARAMETER (MCOLS=18)
      INTEGER MCOLSTR
      PARAMETER (MCOLSTR=6)
      INTEGER NREFSTR
C
C---- Each reflection for strategy run needs MCOLSTR I*2 words
C     plus an I*4 word for the merging
C
      PARAMETER (NREFSTR = IXWDTH*IYLENGTH/(2+MCOLSTR))
      INTEGER MBLENG,MBLINT,MBLREA
      PARAMETER (MBLENG=185,MBLINT=29,MBLREA=156)
      INTEGER NDETREF
      PARAMETER (NDETREF=400)
      INTEGER NRPAR
      PARAMETER (NRPAR=14)
      INTEGER NSEGMAX
      PARAMETER (NSEGMAX=100)
      INTEGER NSEGMAXPR
      PARAMETER (NSEGMAXPR=100)
      INTEGER MULTMAX
      PARAMETER (MULTMAX=100)
      INTEGER MAXDIFF
      PARAMETER (MAXDIFF=100)
      INTEGER NRESBIN
      PARAMETER (NRESBIN=20)
      INTEGER MXSPOT
      PARAMETER (MXSPOT=5000)      
      INTEGER MAXIMG
      PARAMETER (MAXIMG=100)      
      INTEGER NPIXBG
      PARAMETER (NPIXBG=51)
      INTEGER MXCENT
      PARAMETER (MXCENT=500)
      INTEGER    NGRA,MGRA
      PARAMETER (NGRA=20)
      PARAMETER (MGRA=50000)
      INTEGER MAXBGBOX
      PARAMETER (MAXBGBOX=500)
      INTEGER MAXNPEAKS
      PARAMETER (MAXNPEAKS=500)
      INTEGER MAXEXCL
      PARAMETER (MAXEXCL=50)
C&&*&& end_include  ../inc/parameter.f
C     ..
C     .. Scalar Arguments ..
      REAL DELX,DELY,SPOT,SDELX,SDELY
      INTEGER IDR,IPART,IFLAG
C     ..
C     .. Array Arguments ..
      INTEGER IRAS(5)
      INTEGER*2 RAS(*)
C     ..
C     .. Local Scalars ..
      REAL A,B,C,SOD,SPOD,SPP,SQOD,SQQ,TOD,TPOD,TPP,TQOD,TQQ,GRADM,
     +     SP,SQ,SPQ,BGDEVMAX,RMSBG,XSPOT,XFAC,GRAD,ERR,XMULT,XOD
      INTEGER HX,HY,IC,IJ,IOD,IP,IPQ,IQ,IRX,IRY,NXY,NOVER,P,Q,S,T,NBKG,
     +        NRMAX,NRFL,NXX,NYY,I,IODMAX,IODMIN,NPKSIZ,MODE
      LOGICAL P1,P2,DEBG
C     ..
C     .. Local Arrays ..
      INTEGER IA(MAXBOX),MASK(MAXBOX),MASKREJ(NREJMAX)
      REAL PQSUMS(6)
C     ..
C     .. External Subroutines ..
      EXTERNAL BEXPAN4,BGSOLVE,BGTEST
C     ..
C     .. Intrinsic Functions ..
      INTRINSIC ABS
C     ..
C     .. Common blocks ..
C&&*&& include  ../inc/ioo.f
C
C $Id: ioo.f,v 1.7 2009/05/13 11:57:53 harry Exp $
C
C--- awk generated include file  ioo.h
C---- START of include file ioo.h
C
C
C
C     .. Scalars in common block /IOO/ ..
      INTEGER IOUT,IUNIT,ITIN,ITOUT,INOD,INMO,IDU,NWRN,IBRIEF,ISUMMR,
     +        ICOORD,SERVERFD,SERVERFDIN,NSHUTERR,dnafd
      LOGICAL ONLINE,ONEFILE,FHEADER,BRIEF,GRAPH,IOERR,
     $     NODISPLAY,LBELL,JPGOUT,SOCKLO,LBEST,dnaout,INMOOPEN,
     $     XMLOPEN
      CHARACTER dna_image*80,xmlfile*80
C     ..
C     .. Common block /IOO/ ..
c      COMMON /IOO/IOUT,IUNIT,ONLINE,ITIN,ITOUT,INOD,INMO,IDU,NWRN,
c     +            ONEFILE,FHEADER,BRIEF,IBRIEF,GRAPH,ISUMMR,ICOORD,
c     +            IOERR,NODISPLAY,LBELL
C     ..
C
C
      COMMON /IOO/IOUT,IUNIT,ITIN,ITOUT,INOD,INMO,IDU,NWRN,IBRIEF,
     +        ISUMMR,ICOORD,SERVERFD,SERVERFDIN,NSHUTERR,ONLINE,ONEFILE,
     +        FHEADER,BRIEF,GRAPH,IOERR,NODISPLAY,LBELL,JPGOUT,
     $        SOCKLO,LBEST, dnafd, dnaout,INMOOPEN,XMLOPEN
      COMMON /CIOO/dna_image,xmlfile

C&&*&& end_include  ../inc/ioo.f
C&&*&& include  ../inc/lmb.f
C
C $Id: lmb.f,v 1.8 2009/01/08 18:03:14 harry Exp $
C
C--- awk generated include file  lmb.h
C---- START of include file lmb.h
C ODSCAL is to scale image numbers into the range 0-255 for plotting
C average profiles.
C  GAIN should be equal to the overall gain (image counts per X-ray photon)
C of the system, and is used to evaluate standard deviations based on
C counting statistics assuming independent pixels (ie point spread function
C less than pixel size).
C INVERTX true if image is inverted in the slow (X) direction when read in.
C ISCAL is to scale final integrated intensities and sigmas
C IDIVIDE is the adc offset
C ICONST is a constant to be added to all pixels (normally zero) to
C        allow processing of images with zero pixel values in the scanned
C        area.
C IMGP is true if working with image plate data
C SPIRAL is true for scanners with a spiral readout (Mar, DIP2000)
C ORTHOG is true for scanners with orthogonal scan (FUJI, RAXIS, MD)
C NULLPIX is the value of pixels within the image but not in the active
C area of the detector
C TILED is true if there are inactive areas of the detector within the
C       inscribing circle or square.
C
C NTILEX Number of tiles in X direction
C NTILEY Number of tiles in Y direction
C TILEX  X Coordinates of the midpoints of the null areas between tiles
C TILEY  Y Coordinates of the midpoints of the null areas between tiles
C TILEWX Width of the null areas between tiles in X
C TILEWY Width of the null areas between tiles in Y


C MACHINE and MODEL denote the type of detector. 
C
C MACHINE is used in the following subroutines:
C GETBLK, GETHDR, INTPXL, INTPXL2, MXDSPL, OPENODS, PROCESS, PUTPXL
C Currently coded types are:
C
C         MACHINE        MODEL               COMMENTS
C         =======        =====               ========
C         MAR            180, 300, 345
C         RAXI(S)        RAXISII, RAXISIV
C         MD
C         FUJI
C         CCD1           CCD1                Princetown CCD at CHESS,Tiff format
C         CCD2           CCD ?               ESRF CCD detector
C         ADSC           QUAD1               ADSC 2x2 CCD detector
C
C TRUSTED whether or not the image header information can be trusted for 
C         automatic processing
C     .. Scalars in Common Block /LMB/ ..
        REAL ODSCAL,GAIN,LOGA,LOGB
        INTEGER ISCAL,IDIVIDE,ICONST,NULLPIX,NTILEX,NTILEY,
     $    RAXISCOMP,IIDIVIDE,COMPRESSION
        LOGICAL IMGP,INVERTX,SPIRAL,ORTHOG,CIRCULAR,TILED,SETADC,
     $    NEWRAXIS,BRUKNEW,TRUSTED
        CHARACTER MACHINE*4,MODEL*8

C     ..
C     .. Arrays in common /LMB/
        INTEGER TILEX,TILEY,TILEWX,TILEWY
C
C     .. Common Block /LMB/ ..
        COMMON /LMB/ ODSCAL,GAIN,LOGA,LOGB,ISCAL,IDIVIDE,ICONST,
     +       NULLPIX,NTILEX,NTILEY,RAXISCOMP,IIDIVIDE,COMPRESSION,
     +       TILEX(20),TILEY(20),TILEWX(20),TILEWY(20),IMGP,
     +       INVERTX,SPIRAL,ORTHOG,CIRCULAR,TILED,SETADC,
     $       NEWRAXIS,BRUKNEW,TRUSTED
        COMMON /LMBC/ MACHINE,MODEL

C&&*&& end_include  ../inc/lmb.f
C&&*&& include  ../inc/ovrld.f
C
C $Id: ovrld.f,v 1.1 2002/05/02 10:47:03 harry Exp $
C
C--- awk generated include file  ovrld.h
C---- START of include file ovrld.h
C
C
C     .. Scalars in Common Block /OVRLD/ ..
      INTEGER NPMAX
C     ..
C     .. Common Block /OVRLD/ ..
      COMMON /OVRLD/NPMAX
C     ..
C
C
C&&*&& end_include  ../inc/ovrld.f
C&&*&& include  ../inc/parm1.f
C
C $Id: parm1.f,v 1.1 2002/05/02 10:47:05 harry Exp $
C
C--- awk generated include file  parm1.h
C---- START of include file parm1.h
C
C
C
C     .. Scalars in common block /PARM1/ ..
      REAL BGSIG,EFAC,EFACSQ,BGFREJ,GRADMAX,GRADMAXR,BGRAT,PKRAT,
     +     RESD,RESDLOW
      INTEGER CUTOFF,NOVPIX,NDSTART,NDTOT,IXDMIN,IXDMAX,IYDMIN,IYDMAX,
     +     IDMIN,IDMAX
      LOGICAL DUMPSPOT,BADPLOT,DUMPALL,BADPLOT2
C     ..
C     .. Common Block /PARM1/ ..
      COMMON /PARM1/BGSIG,EFAC,EFACSQ,BGFREJ,GRADMAX,GRADMAXR,
     +              BGRAT,PKRAT,RESD,RESDLOW,CUTOFF,NOVPIX,
     +              NDSTART,NDTOT,IXDMIN,IXDMAX,IYDMIN,IYDMAX,
     +              IDMIN,IDMAX,DUMPSPOT,BADPLOT,DUMPALL,BADPLOT2
C     ..
C
C
C&&*&& end_include  ../inc/parm1.f
C&&*&& include  ../inc/scn.f
C
C $Id: scn.f,v 1.3 2004/08/16 13:26:48 harry Exp $
C
C--- awk generated include file  scn.h
C---- START of include file scn.h
C
C     SCNSZ   is pixel size (in microns) divided by 25
C     RAST    pixel size in slow direction in mm
C     FACT    multiplying by FACT converts from 10 micron units 
C             (the standard unit internal to the program) into pixels
C     IYLEN   The number of pixels in the Y (fastest changing) direction
C             in the digitised image.
C     NREC    The number of pixels in the X (slow) direction in the 
C             digitised image.
C     NWORD   The number of I*2 words in the Y direction.
C     NBYTE   The number of bytes in Y direction = NWORD/2
C     NHBYTE  Number of bytes in header
C
C     ICURR   When several images are stored in a single file, ICURR is the
C             pointer to the first record of the current image in the direct
C             access file (only implemented for film data)
C     NEXTRA  The number of additional (unused) bytes padding the end of
C             each record in image file
C     BYTSWAP True if the "endedness" (Big-endian/Little-endian) of the 
C             machine that MOSFLM is running on is different to that of the
C             machine on which the image was written. This is determined by
C             looking at the value of NXPIX in the header record of the
C             image file (subroutine GETHDR)
C
C     LACTIVE True if using Rigaku active mask, False if ignoring it
C
C     .. Scalars in common block /SCN/ ..
      REAL FACT,SCNSZ,RAST,RASTY
      INTEGER NBYTE,NREC,NWORD,IYLEN,ICURR,NEXTRA,NHBYTE
      LOGICAL BYTSWAP,LACTIVE
C     ..
C     .. Common Block /SCN/ ..
      COMMON /SCN/ FACT,SCNSZ,RAST,RASTY,NBYTE,NREC,NWORD,IYLEN,
     +     ICURR,NEXTRA,NHBYTE,BYTSWAP,LACTIVE
C&&*&& end_include  ../inc/scn.f
C&&*&& include  ../inc/sums.f
C
C $Id: sums.f,v 1.1 2002/05/02 10:47:21 harry Exp $
C
C--- awk generated include file  sums.h
C---- START of include file sums.h
C
C
C     Elements of ASPOT
C     1 = Summation integration intensity
C     2 = Total background counts under peak assuming peak has mm symmetry
C     3 = Rms variation in background, after rejecting background points.
C         This is evaluated in BGSOLVE called from EVAL.
C     4 = Centre of gravity in X direction (in pixels)
C     5 = Centre of gravity in Y direction (in pixels)
C         These are wrt an origin at the centre of the measurement box
C     6 = sum p*iod for background pixels
C     7 = sum q*iod for background pixels
C     8 = sum iod for background pixels
C     9 = Background plane constant a (gradient in X direction)
C    10 = Background plane constant b (gradient in Y direction)
C    11 = Background plane constant c 
C    12 = Largest deviation from background plane, excluding rejected pixels
C    13 = Profile fitted intensity
C    14 = Variance of profile fitted intensity = sum (deltasq) for peak
C         pixels only. Used to calculate PKRATIO and also profile fitted
C         sigma(I) in unweighted case only.
C    15 = Number of rejected background pixels
C    16 = Variance of profile fitted intensity in weighted case (default)
C    17 = sum W*DELTA**2 for profile fit
C    18   unused
C     .. Arrays in common block /SUMS/ ..
      REAL ASPOT
C     ..
C     .. Common Block /SUMS/ ..
      COMMON /SUMS/ASPOT(18)
C     ..
C
C
C&&*&& end_include  ../inc/sums.f
C     ..
C     ..
C     .. Equivalences ..
      EQUIVALENCE (ASPOT(3),RMSBG)
      EQUIVALENCE (ASPOT(6),SPOD)
      EQUIVALENCE (ASPOT(7),SQOD), (ASPOT(8),SOD), (ASPOT(9),A)
      EQUIVALENCE (ASPOT(10),B), (ASPOT(11),C), (ASPOT(12),BGDEVMAX)
C
C
      SAVE
C     .. Data statements ..
C
C
      DATA DEBG/.FALSE./
C
C---- Mode for EVAL (signifies we have not flagged overlapped background
C                     pixels)
      MODE = 0
      NRFL = 1
      IFLAG = 0
      NXX = IRAS(1)
      NYY = IRAS(2)
      IF (DEBG) CALL ODPLOT(RAS,NXX,NYY,1)
      HX = IRAS(1)/2
      HY = IRAS(2)/2
      NXY = (2*HX+1)* (2*HY+1)
C
C          *******************
      CALL BEXPAN4(RAS,IA,NXY)
C          *******************
C
      IC = HX + HY - IRAS(3)
      IRX = HX - IRAS(4)
      IRY = HY - IRAS(5)
C
C---- Mean spot size (ie peak area of box) in X and Y
      NPKSIZ = 0.25*(NXX + NYY - 2*(IRAS(4) + IRAS(5)))
C
      SP = 0.0
      SQ = 0.0
      SPQ = 0.0
      SPP = 0.0
      SQQ = 0.0
      SPOD = 0.0
      SQOD = 0.0                                
      SOD = 0.0
      TPP = 0.0
      TQQ = 0.0
      TOD = 0.0
      TPOD = 0.0
      TQOD = 0.0
      IODMAX = 0
      IODMIN = 999999
C
C
      S = 0
      T = 0
      IJ = 0
      NOVER = 0
C
C
      DO 10 I=1,6
        PQSUMS(I) = 0.0
 10   CONTINUE
C
      DO 30 P = -HX,HX
        IP = ABS(P)
        P1 = (IP.GT.IRX)
        P2 = (IP.EQ.IRX)
C
C
        DO 20 Q = -HY,HY
          IJ = IJ + 1
          IQ = ABS(Q)
          IOD = IA(IJ)
C
C---- Reject overloads
C
          IF (IOD.GT.CUTOFF) NOVER = NOVER + 1
C
C---- Trap spots that include pixels outside scanned area
C
          IF (IOD.LE.NULLPIX) GOTO 80
          IF (IOD.GT.IODMAX) IODMAX = IOD
          IF (IOD.LT.IODMIN) IODMIN = IOD
C
C
          IF (NOVER.GT.NPMAX) THEN
            GO TO 70
          ELSE
            IPQ = IP + IQ
C
C
            IF (P1 .OR. IPQ.GT.IC .OR. IQ.GT.IRY) THEN
C
              IF (IRAS(3).NE.0 .OR. IP.LT.IRX .OR. IQ.LT.IRY) THEN
C
C
                IF (IRAS(3).GE.0 .OR. IPQ.LE.IC) THEN
C  Background pixels
              S = S + 1
              SP = P + SP
              SQ = Q + SQ
              SPP = P*P + SPP
              SQQ = Q*Q + SQQ
              SPQ = P*Q + SPQ
              SPOD = P*IOD + SPOD
              SQOD = Q*IOD + SQOD
              SOD = SOD + IOD
              MASK(IJ) = -1
                END IF
              END IF
              ELSE
C
C---- Treat pixles around Peak as OK now, as in integration 16/7/98
CAL            ELSE IF (.NOT.P2 .AND. IPQ.NE.IC .AND. IQ.NE.IRY) THEN
C
C  Peak pixels
              T = T + 1
              TPP = P*P + TPP
              TQQ = Q*Q + TQQ
              TPOD = P*IOD + TPOD
              TQOD = Q*IOD + TQOD
              TOD = TOD + IOD
              MASK(IJ) = 1
            END IF
          END IF
   20   CONTINUE
   30 CONTINUE
C
C
C  Background constants (no backgound points rejected)
      A = SPOD/SPP
      B = SQOD/SQQ
      C = SOD/S
C
C  Set up PQSUMS
      PQSUMS(1) = SPP
      PQSUMS(2) = SQQ
      PQSUMS(3) = SPQ
      PQSUMS(4) = SP
      PQSUMS(5) = SQ
      PQSUMS(6) = S
      NBKG = S
C
C   Set maximum allowed number of allowed background pixels to be
C   rejected from background plane determination (as fraction of total)
C
      NRMAX = NINT(BGFREJ*NBKG)
C
C          ******************************************************
      CALL EVAL(IA(1),MASK(1),IRAS,PQSUMS,BGSIG,NRMAX,NRFL,
     +          MASKREJ,DEBG,MODE)
C          ******************************************************
C
C---- Check that not too many background points have been rejected
C     (Flagged by NRMAX=-999)
C
      IF (NRMAX.EQ.-999) GOTO 90
C
C
C  Check maximum gradient not exceeded
C
              IF (C.GT.0.0) THEN
                GRADM = MAX(ABS(A),ABS(B))/C
              ELSE
                GRADM = 0.0
              END IF
      IF (GRADM.GT.GRADMAXR) GOTO 100
C  Recalculate SPOT based on new value of C
C
C
C
      ASPOT(2) = T*C
      SPOT  = TOD - ASPOT(2)
C
C---- Catch zero spots
C
      IF (SPOT.NE.0.0) THEN
        DELX = (TPOD-A*TPP)/SPOT*IDR
        DELY = (TQOD-B*TQQ)/SPOT
      ELSE
        DELX = 0.0
        DELY = 0.0
      END IF
C
C---- Calculate errors in c. of g.
C         
C---- Calculate a crude gradient for this spot, used to boost sigma
C     calculation, assuming a scanner error factor of 0.15
C
      GRAD = (FLOAT(IODMAX-IODMIN))/NPKSIZ
      ERR = (GRAD*0.15)**2
      IF ((MACHINE.EQ.'ADSC') .OR. 
     $     ((MACHINE.EQ.'CBF ').AND.(MODEL(1:4).EQ.'ADSC')))THEN
        ERR = (GRAD*0.20)**2
      ENDIF
      IF ((MACHINE.EQ.'MARC').AND.
     $     ((MODEL.EQ.'MOSAIC3').OR.(MODEL.EQ.'MOSAIC4')))
     +     ERR = (GRAD*0.30)**2
      SDELX = 0.0
      SDELY = 0.0
C
C---- remove next two lines before distribution!!!
C
c      SDELX = 1e-5
c      SDELY = 1e-5
      IJ = 0
      IF (SPOT.EQ.0.0) GOTO 65
C
      XSPOT = SPOT/GAIN
C    
      DO 50 P = -HX,HX
C
          XFAC = (P-DELX)/XSPOT
          XFAC = XFAC*XFAC
C
        DO 40 Q = -HY,HY
          IJ = IJ + 1
CAL          IOD = NINT(REAL(IA(IJ))/GAIN)
CAL          IOD = IOD + NINT(ERR)
          XOD = REAL(IA(IJ))/GAIN
          XOD = XOD + ERR
          IF (MASK(IJ).EQ.1) THEN
CAL            SDELX = SDELX + XFAC*IOD
            SDELX = SDELX + XFAC*XOD
CAL            SDELY = SDELY + ((Q-DELY)/XSPOT)**2*IOD
            SDELY = SDELY + ((Q-DELY)/XSPOT)**2*XOD
          END IF 
 40     CONTINUE
 50   CONTINUE
C
C---- Fudge factor 2.5 boosts sigma estimates to get mean weighted residual
C     of about 1.0. The need for this presumably reflects the fact that the
C     accuracy of the centre of gravity determination is not solely determined
C     by counting statistics. Since the strongest reflections are used in
C     refinement, it may be partially due to scanner errors in regions of
C     high gradients, but this is not yet clear. Another possibility is
C     that the interpolation from the spiral scan to the orthogonal scan
C     introduces errors in Mar Research and Mac Science detectors.
C
      SDELX = 2.5*SQRT(SDELX)
      SDELY = 2.5*SQRT(SDELY)
C
C---- Preliminary tests with RaxisIV images suggest an even larger inflation
C     is required (for 100 micron raster). However, is this just because 
C     the spots are so large that the sd's get unreasonably small ?
C
      IF (((MODEL.EQ.'RAXISIV').OR.(MODEL.EQ.'RAXISV'))
     $     .AND.(RAST.LT.0.15)) THEN
        SDELX = 2.0*SDELX
        SDELY = 2.0*SDELY
      END IF
C
C---- Also need to inflate SDs further for ADSC and NOIR CCDs.
C
      IF ((MACHINE.EQ.'ADSC') .OR. (MACHINE.EQ.'NOIR') .OR.
     $     ((MACHINE.EQ.'CBF ').AND.(MODEL(1:4).EQ.'ADSC')))THEN
        SDELX = 2.0*SDELX
        SDELY = 2.0*SDELY
      END IF
C
C---- Jupiter (Saturn, Mercury) values based only on one set of images
C     from a Jupiter...
C
      IF ((MACHINE.EQ.'JUPI').OR.(MACHINE.EQ.'SATU').OR.
     $     (MACHINE.EQ.'MERC').OR.
     $     (MACHINE.EQ.'A200')) THEN
        SDELX = 2.0*SDELX
        SDELY = 2.0*SDELY
      END IF
C
C---- Mar mosaic 3x3 need to inflate sd's
C
      IF ((MACHINE.EQ.'MARC').AND.
     $     ((MODEL.EQ.'MOSAIC3').OR.(MODEL.EQ.'MOSAIC4'))) THEN
        SDELX = 3.0*SDELX
        SDELY = 3.0*SDELY
      END IF
C
C---- is this really necessary for Bruker images? temporarily sets sdlx,
C     sdely to non-zero... there's a nasty crash with Bruker images
C     that needs to be located..
C     
C
      IF (MACHINE.EQ.'BRUK') THEN
        SDELX = (2.0*SDELX)+0.01
        SDELY = (2.0*SDELY)+0.01
      END IF
C
C---- Inflate standard deviations for partially recorded reflections. There
C     is no obvious way to do this, so the following is highly empirical
C     and may need to be revised. IPART is zero for fully recorded reflections
C     and lies between 1 and 99 for partials, 1 is least fully recorded, 100
C     is again fully recorded.
C
      IF (IPART.NE.0) THEN
        IF (IPART.LE.25) THEN
          XMULT = 7.0
        ELSE IF (IPART.LE.50) THEN
          XMULT = 5.0
        ELSE IF (IPART.LE.75) THEN
          XMULT = 4.0
        ELSE IF (IPART.LE.90) THEN
          XMULT = 2.0
        ELSE
          XMULT = 1.5
        END IF
        SDELX = XMULT*SDELX
        SDELY = XMULT*SDELY
      END IF
C
 65   CONTINUE
C
C
      RETURN
C
C  Overloaded spots
C
   70 IFLAG = 4
      SPOT = 0.0
      RETURN
C
C  Spots with zero pixel values
C
   80 IFLAG = 3
      SPOT = 0.0
      DELX = 0.0
      DELY = 0.0
      RETURN
C
C  Spots with too many rejected background points
   90 IFLAG = 2
      SPOT = 0.0
      DELX = 0.0
      DELY = 0.0
      RETURN
C
C  Spots with too steep a gradient
  100 IFLAG = 1
      SPOT = 0.0
      DELX = 0.0
      DELY = 0.0
      END
C== BMATRX ==
C
C
C
      SUBROUTINE BMATRX(B,R,C,WAVE)
C     =============================
      IMPLICIT NONE
C
C---- Build cell orthogonalization matrix B.
C         R are the recip cell parameters
C     and C the real cell parameters.
C
C  Ref: W.R.Busing & H.A.Levy, Acta Cryst. (1967) 22, 457-464
C
C       B =  ( a*       b* cos gamma*   c* cos beta*            )
C            ( 0        b* sin gamma*  -c* sin beta* cos alpha  )
C            ( 0             0            lambda / c            )
C
C
C
C
C
C     .. Scalar Arguments ..
      REAL WAVE
C     ..
C     .. Array Arguments ..
      REAL B(3,3),C(6),R(6)
C     ..
C     .. Local arrays
      DOUBLE PRECISION CD(6),RD(6)
C     ..
C     .. Local Scalars ..
      DOUBLE PRECISION WAVED
      INTEGER I
C     ..
C     .. Intrinsic Functions ..
      INTRINSIC COS,SIN
C     ..
C&&*&& include  ../inc/trigparam.f
C 
C $Id: trigparam.f,v 1.3 2008/07/31 11:46:02 harry Exp $
C
C
C     Trigonometric parameters - set here to highly precise values, don't 
C     calculate in code; values from Clemens Vonrhein
C
C     DTOR.. convert degrees to radians
C     RTOD.. convert radians to degrees
C     PI..   value of PI
      REAL PI
      PARAMETER   ( PI = 3.1415926536 )
      REAL          TWOPI
      PARAMETER   ( TWOPI = 6.2831853072 )
      REAL RTOD
      PARAMETER   ( RTOD = 57.2957795131 )
      REAL          DTOR
      PARAMETER   ( DTOR = 0.0174532925 )
C DOUBLE PRECISION...
      DOUBLE PRECISION PI_DOUBLE
      PARAMETER ( PI_DOUBLE = 3.1415926535897932384626433832795029D0 )
      DOUBLE PRECISION TWOPI_DOUBLE
      PARAMETER ( TWOPI_DOUBLE = 
     $     6.2831853071795864769252867665590058D0 )
      DOUBLE PRECISION RTOD_DOUBLE
      PARAMETER ( RTOD_DOUBLE = 57.2957795130823208768D0 )
      DOUBLE PRECISION DTOR_DOUBLE
      PARAMETER ( DTOR_DOUBLE = 0.01745329251994329576D0 )
c

c
C&&*&& end_include  ../inc/trigparam.f

C
C
      WAVED = DBLE(WAVE)
C
      DO 100 I = 1,6
        CD(I) = DBLE(C(I))
        RD(I) = DBLE(R(I))
 100  ENDDO

      B(1,1) = REAL(RD(1))
      B(1,2) = REAL( COS(DTOR_DOUBLE * RD(6)) * RD(2))
      B(1,3) = REAL(COS(DTOR_DOUBLE*RD(5)) * RD(3))
      B(2,1) = 0.0
      B(2,2) = REAL(SIN(DTOR_DOUBLE * RD(6)) * RD(2))
      B(2,3) = REAL(-SIN(DTOR_DOUBLE * RD(5)) * RD(3) * 
     $     COS(DTOR_DOUBLE * CD(4)))
      B(3,1) = 0.0
      B(3,2) = 0.0
      B(3,3) = REAL(WAVED/CD(3))
C
C
      END
C     $Id: centrs.f,v 1.11 2010/01/26 11:17:47 harry Exp $
C== CENTRS ==
      SUBROUTINE CENTRS(DOPROFILE,NSIG,IXSHIFT,IYSHIFT,NPROFL,LIMIT,SEP,
     +          VLIM,MATCH,PARTLS,OVRLDS,MINREF,OLDLIST,GENLIST,USEBOX,
     +          ADDPART,PTMIN)
C     ==================================================================
C
C
      IMPLICIT NONE
C
C---- Goes through the generate file to
C     find spots suitable for refinement of film centre,
C     crystal to film distance and film orientation
C     If DOPROFILE is true, an average spot profile is
C     accumulated in array IODPROF for display in CHKRAS.
C     See comments in main program about selection of spots
C     for refinement and for average spot profile on vee films.
C
C       MATCH...  true:  Pattern matching, use limited number of
C                        reflections (NSPOT)
C
C       PARTLS... true:  accept partially recorded reflections
C
C       OVRLDS... true:  accept overloaded reflections
C                            
C       MINREF... minimum acceptable number of reflections to be
C                 passed to rdist.
C
C       OLDLIST.. use a list of reflections compiled in a previous
C                 call to centrs
C
C       GENLIST.. select reflections based on intensities measured
C                 on previous film in pack
C
C       USEBOX..  Apply the measurement box peak/background definition
C                 when determining centre of gravity, by calling CGFIT
C                 rather than CGFIND. Usefull if spots are very close.
C
C       ADDPART.. True if partials on adjacent images are added together
C                 during reflection integration.
C                 In this case, if PARTLS is true, select only those
C                 partials at end of current image and add in the other
C                 part of the partial from the next image.
C
C       PTMIN...  If using partials and NOT summing partials (ADDPART)
C                 select ONLY reflections with partiality greater than
C                 PTMIN (range 0 to 1.0)
C---- 12/9/81 Change IWORK to I*4 from I*2, and calls to BEXPAN to BEXPAN4
C     to cope with dynamic range up to 64K
C
C     Reflection flags (IR) (Set by SPTEST called from DSTAR)
C
C       IR      =  0  Spot can be measured
C               =  1  Outside R, X, Y limits
C               =  2  Overlapping spot (set later)
C               =  3  Too wide in phi (more than NWMAX images)
C               =  4  DST .GT. DSTMAX  Not included in final film list -
C                       used only to check for overlaps at edge of film.
C               = 10  Spot is within cusp, but will be observed...not included
C                     in final spot list but must be included in predicted
C                      pattern
C
C               =  21  Spot present on 2 images, this is 1st
C               =  22  Spot present on 2 images, this is 2nd
C
C               =  31  Spot present on 3 images, this is 1st
C               =  32  Spot present on 3 images, this is 2nd
C               =  33  Spot present on 3 images, this is 3rd
C
C               =  41  Spot present on 4 images, this is 1st
C               =  42  Spot present on 4 images, this is 2nd
C               =  43  Spot present on 3 images, this is 3rd
C               =  44  Spot present on 4 images, this is 4th
C
C                 etc etc
C****** DEBUG(6) FOR THIS SUBROUTINE ******
C
C     .. Parameters ..
C&&*&& include  ../inc/parameter.f
C
C $Id: parameter.f,v 1.17 2009/10/28 16:43:34 harry Exp $
C
C--- awk generated include file  parameter.h
C---- START of include file parameter.h
C
C       PARAMETERS
C       IYLENGTH.. maximum number of I*2 words of data in the 
C                  "fast" (ie most rapidly changing) direction in the
C                  digitised image. This will be HALF the number of pixels
C                  for film data (each pixel is stored in one byte)
C                  but will equal the number of pixels for IP data.
C       IXWDTH...  The maximum number of "stripes" of data in the scanned image
C                  ie the number of pixels in the "slow" direction
C                  (This is the Y direction in the MOSFLM convention)
C                  Note that the array "IMAGE" used to store the image is
C                  declared as size IYLENGTH*IXWDTH I*2 words for IP data
C                  and 2*IYLENGTH*IXWDTH BYTES for film data.
C                  If this exceeds the
C                  available memory, set ixwdth=1, recompile program
C                  and use keyword "NOCORE" when running program.
C                  Note that for the POSTREF and ADDPART options,
C                  two images have to be stored in memory at once so
C                  IXWDTH should be twice the number of records in an
C                  image.
C       MAXHEAD    maximum length of image header (in 4 byte words)
C       NREFLS.... maximum number of spots per film in generate file (250,000)
C       MAXBOX.... maximum number of pixels in measurement box (1500)
C       MAXDIM.... maximum box size in either direction (pixels) (41)
C       MAXPAX.... maximum number of packs per generate file (10000)
C       MXDOV2..... maxdim/2
C       MAXBUFF... maximum size of buffer (I*2) for storing ods
C                  of active spots in subroutine meas(21,000).
C                  Must be .GE.  MAXBOX*(NNLINE-1) for subroutine process
C       MREF...... maximum number of reflections to be used in post
C                  refinement (6000)
C       NEXPAND... maximum number of expansions of the input measurement
C                  box (2)
C       NMASKS.... maximum number of different profiles (25). Note the
C                  connection between this parameter and NNLINE
C       NVECT..... maximum number of vectors for storing scanned image
C                  in filmplot (10000)
C       NIMAX..... maximum number of images to be used together in 
C                  postrefinement (NADD or WIDTH options) (100)
C       NNLINE...  maximum number of boundary lines for setting up
C                  the areas for profile fitting. The maximum possible
C                  number of standard profiles will be (NNLINE-1)**2
C                  although for a circular detector the actual number
C                  may be less than this as some boxes will lie entirely
C                  outside the detector.
C       NREJMAX... Maximum number of rejected background pixels, resulting
C                  either from overlap of adjacent spots or outliers from
C                  the background plane
C       NSPOTS...  Maximum number of found spots (for autoindexing) that can
C                  be stored (for all images). Also maximum number in 
C                  a file wriitten by IMSTILLS that can be 
C                  stored/displayed/edited. THis must be an even number
C       MCOLS....  Number of columns in output MTZ file
C       MCOLSTR..  Number of columns in output MTZ file for strategy option
C     
C       MTZ Orientation block
C        MBLENG is total length of block, MBLINT, MBLREA are numbers
C          of integers & reals
C       NDETREF    Maximum number of reflections used for detector parameter
C                  refinement (previously 62)
C       NRPAR....  Maximum number of refineable parameters for detector
C                  positional refinement (subroutine RDIST)
C       NSEGMAX..  Maximum number of segments in STRATEGY
C       NSEGMAXPR  Maximum number of segments in POST-REFINEMENT
C       MULTMAX... Maximum number of observations with same hkl in COMPLETE
C       MAXDIFF... Maximum number of different packs that a given hkl occurs on
C       NRESBIN... Maximum number of resolution bins (COMPLETE)
C
C       MAXIMG...  Maximum number of images that can be read in using the IMAGE
C                  keyword or the "read Image" menu option.
C       MXSPOT...  Maximum number of spots that can be found on one image
C                  (before rejection on spot size).
C       MXCENT...  Maximum number of active spots during spot finding 
C                  (findspots)
C
C       MGRA, NGRA... maximum number of reflections and images over which a 
C                     reflection can be spread for postrefinement.
C       MAXBGBOX    Maximum number of local background background boxes 
C                   in X and Y
C
C       MAXNPEAKS   Maximum number of local maxima within one spot
C       MAXEXCL     Maximum number of excluded areas of the same type
C                   eg reactangles, quadrilaterals, arcs, resolution shells
C
C     .. Parameters ..
      INTEGER IXWDTH
c      PARAMETER (IXWDTH=8192)
      PARAMETER (IXWDTH=12288)
      INTEGER IYLENGTH
c      PARAMETER (IYLENGTH=4096)
      PARAMETER (IYLENGTH=6144)
      INTEGER MAXHEAD
      PARAMETER (MAXHEAD=5120)
      INTEGER MAXBOX
      PARAMETER (MAXBOX=3000)
      INTEGER MAXDIM
      PARAMETER (MAXDIM=41)
      INTEGER MAXPAX
      PARAMETER (MAXPAX=10000)
      INTEGER MXDOV2
      PARAMETER (MXDOV2=MAXDIM/2)
      INTEGER NEXPAND
      PARAMETER (NEXPAND=2)
      INTEGER NNLINE
      PARAMETER (NNLINE=8)
      INTEGER NMASKS
      PARAMETER (NMASKS=49)
      INTEGER MAXBUFF
      PARAMETER (MAXBUFF=21000)
      INTEGER NREFLS
      PARAMETER (NREFLS=250000)
      INTEGER MREF
      PARAMETER (MREF=6000)
      INTEGER NVECT
      PARAMETER (NVECT=10000)
      INTEGER NIMAX
      PARAMETER (NIMAX=100)
      INTEGER NREJMAX
      PARAMETER (NREJMAX=1000)
      INTEGER NSPOTS
      PARAMETER (NSPOTS=5000)
      INTEGER MCOLS
      PARAMETER (MCOLS=18)
      INTEGER MCOLSTR
      PARAMETER (MCOLSTR=6)
      INTEGER NREFSTR
C
C---- Each reflection for strategy run needs MCOLSTR I*2 words
C     plus an I*4 word for the merging
C
      PARAMETER (NREFSTR = IXWDTH*IYLENGTH/(2+MCOLSTR))
      INTEGER MBLENG,MBLINT,MBLREA
      PARAMETER (MBLENG=185,MBLINT=29,MBLREA=156)
      INTEGER NDETREF
      PARAMETER (NDETREF=400)
      INTEGER NRPAR
      PARAMETER (NRPAR=14)
      INTEGER NSEGMAX
      PARAMETER (NSEGMAX=100)
      INTEGER NSEGMAXPR
      PARAMETER (NSEGMAXPR=100)
      INTEGER MULTMAX
      PARAMETER (MULTMAX=100)
      INTEGER MAXDIFF
      PARAMETER (MAXDIFF=100)
      INTEGER NRESBIN
      PARAMETER (NRESBIN=20)
      INTEGER MXSPOT
      PARAMETER (MXSPOT=5000)      
      INTEGER MAXIMG
      PARAMETER (MAXIMG=100)      
      INTEGER NPIXBG
      PARAMETER (NPIXBG=51)
      INTEGER MXCENT
      PARAMETER (MXCENT=500)
      INTEGER    NGRA,MGRA
      PARAMETER (NGRA=20)
      PARAMETER (MGRA=50000)
      INTEGER MAXBGBOX
      PARAMETER (MAXBGBOX=500)
      INTEGER MAXNPEAKS
      PARAMETER (MAXNPEAKS=500)
      INTEGER MAXEXCL
      PARAMETER (MAXEXCL=50)
C&&*&& end_include  ../inc/parameter.f
C     ..
C     .. Scalar Arguments ..
      REAL VLIM,SEP,PTMIN
      INTEGER IXSHIFT,IYSHIFT,LIMIT,MINREF,NPROFL,NSIG
      LOGICAL DOPROFILE,GENLIST,MATCH,OLDLIST,OVRLDS,PARTLS,USEBOX,
     +        ADDPART
C     ..
C     .. Local Scalars ..
      REAL AM,AVBKG,AVOD,CALCSIG,CALCVAR,DELX,DELY,ODSIG,ODVAR,
     +     SOD,SUMBKG,XC,XCAL,XSIZBIN,YC,YCAL,YSIZBIN,BACK,SDELX,SDELY,
     +     SPTMIN,VARTOT,BGND,AJX,AJY,XLIMIT,XDOV2,VXLIMIT
      INTEGER HWX,HWY,I,IADDR,IBACK,IBLK,IFRST,IHALF,II,
     +        ILAST,IND,INDF,INDL,INDX,INT,ISDR,ISEPN,IIY,J,JADD,JMAX,
     +        JREC,JX,JY,K,KMN,KMX,LASTX,LASTY,MAXB,MAXN,MAXW,MINOD,MJ,
     +        NBKG,NC,NCLOSE,NJ,NN,NOVER,NPEAK,NPOSS,NPOVER,NREF,NRSOLD,
     +        NRX,NRY,NSUM,NWEAK,NXS,NXY,NYS,VLIMIT,NBGBAD,NBGBADG,
     +        IPART,NSDRP,IFLAG,NZPBAD,NHX,NHY,IR,IM,NPARTL,NFULLS,
     +        NREFT,IR1,IR2
      LOGICAL FULL,USEOVRLD,EXPART
      CHARACTER CALLEDFROM*80
C     ..
C     .. Local Arrays ..
      INTEGER ISPOT(100),IWX(500),PNTR(100),IWORK(MAXBOX),X(500),
     +        Y(500),IRECNO(500)
      INTEGER*2 IARR(MAXBUFF/2)
C     ..
C     .. External Functions ..
      INTEGER LENSTR
      EXTERNAL LENSTR
C     ..
C     .. External Subroutines ..
      EXTERNAL BSWAP,CGFIND,ODPLOT,PXYCALC,RDBLK,SIZRAS,SORTUP3,MMTOPX,
     +         BEXPAN4,BSWAP2,SHUTDOWN
C     ..
C     .. Intrinsic Functions ..
      INTRINSIC ABS,MOD,NINT,REAL,SQRT
C     ..
C     .. Common blocks ..
C&&*&& include  ../inc/debug.f
C
C $Id: debug.f,v 1.2 2008/07/24 09:42:21 andrew Exp $
C
C--- awk generated include file  debug.h
C---- START of include file debug.h
C
C
C
C     .. Arrays in common /DEBUG/ ..
      REAL XWARN
      INTEGER NDEBUG,IWARN
      LOGICAL DEBUG,LPRINT,DUMP,WARN
C
C     .. Scalars in common /DEBUG/ ..
      REAL BGRLIM
      INTEGER NDUMP,IDUMP,MXDUMP
      LOGICAL SPOT
C     
C     ..
C     .. Common Block /DEBUG/..
      COMMON /DEBUG/XWARN(20,100),BGRLIM,NDEBUG(100),IWARN(20,100),
     $       NDUMP,IDUMP,MXDUMP,DEBUG(100),LPRINT(20),DUMP(30),
     +       WARN(100),SPOT
C     ..
C
C&&*&& end_include  ../inc/debug.f
C&&*&& include  ../inc/gendata.f
C
C $Id: gendata.f,v 1.2 2003/01/10 16:17:53 andrew Exp $
C
C--- awk generated include file  gendata.h
C---- START of include file gendata.h
C
C     IMG       Partiality indicator. 0 for full reflections, 1 to 100
C                   for partials. Negative for partials at the start of the
C                   rotation range, +ve for partials at the end of the 
C                   rotation. Set in subroutine REEK using DELEPS calculated
C                   in subroutine DSTAR
C
C     IRG       Reflection flag  (Set by SPTEST called from DSTAR)
C               =  0  Spot can be measured
C               =  1  Outside R, X, Y limits
C               =  2  Overlapping spot (set later)
C               =  3  Too wide in phi (more than NWMAX images)
C               =  4  DST .GT. DSTMAX  Not included in final film list -
C                       used only to check for overlaps at edge of film.
C               = 10  Spot is within cusp, but will be observed...not included
C                     in final spot list but must be included in predicted
C                      pattern
C
C               =  21  Spot present on 2 images, this is 1st
C               =  22  Spot present on 2 images, this is 2nd
C
C               =  31  Spot present on 3 images, this is 1st
C               =  32  Spot present on 3 images, this is 2nd
C               =  33  Spot present on 3 images, this is 3rd
C
C               =  41  Spot present on 4 images, this is 1st
C               =  42  Spot present on 4 images, this is 2nd
C               =  43  Spot present on 3 images, this is 3rd
C               =  44  Spot present on 4 images, this is 4th
C
C                 etc etc
C
C     XG        Virtual detector X coordinate in 10 micron units, relative to
C               an origin at the direct beam position. X is parallel to the
C               Y axis in the laboratory frame, ie orthogonal to the rotation
C               axis.
C
C     YG        Virtual detector Y coordinate in 10 micron units, relative to
C               an origin at the direct beam position. Y is parallel to the
C               Z axis in the laboratory frame, ie  the rotation axis.
C
C     IX,IY     are the coordinates of the reflection in pixels
C               (integers) wrt the first pixel in the image (lower left corner
C               cameramans view). For testing for spot overlap, these
C               coordinates are in 10 micron units. Also used for display
C               pixel coordinates when displaying predicted pattern.
C
C     IREC      Pointer to the record number of a particular spot in the
C               list of generated reflections.
C
C
C     ..
C     .. Arrays in common /GENDATA/ ..
      REAL FRACG,PHIG,PHIWG,XG,YG,GOODFIT
      INTEGER INTG,IPRO,IX,IY,IREC
      INTEGER*2 IRG,IMG,IGFLAG,ISDPRO,ISDG,IHG,IKG,ILG,IMPARTG,
     +          MISYMG
C     .. Scalars in common /GENDATA/ ..
      INTEGER IPACKREC,IPACKHEAD,IRECLAST
C     ..
C     .. Common block /GENDATA/ ..
      COMMON /GENDATA/FRACG(NREFLS),PHIG(NREFLS),PHIWG(NREFLS),
     $       XG(NREFLS),YG(NREFLS),INTG(NREFLS),IPRO(NREFLS),
     $       IX(NREFLS),IY(NREFLS),IREC(NREFLS),IRG(NREFLS),IMG(NREFLS),
     +       IGFLAG(NREFLS),ISDPRO(NREFLS),ISDG(NREFLS),
     +       IHG(NREFLS),IKG(NREFLS),ILG(NREFLS),IMPARTG(NREFLS),
     +       MISYMG(NREFLS),GOODFIT(NREFLS),IPACKREC,IPACKHEAD,
     +       IRECLAST
C     ..
C
C

C&&*&& end_include  ../inc/gendata.f
C&&*&& include  ../inc/ioo.f
C
C $Id: ioo.f,v 1.7 2009/05/13 11:57:53 harry Exp $
C
C--- awk generated include file  ioo.h
C---- START of include file ioo.h
C
C
C
C     .. Scalars in common block /IOO/ ..
      INTEGER IOUT,IUNIT,ITIN,ITOUT,INOD,INMO,IDU,NWRN,IBRIEF,ISUMMR,
     +        ICOORD,SERVERFD,SERVERFDIN,NSHUTERR,dnafd
      LOGICAL ONLINE,ONEFILE,FHEADER,BRIEF,GRAPH,IOERR,
     $     NODISPLAY,LBELL,JPGOUT,SOCKLO,LBEST,dnaout,INMOOPEN,
     $     XMLOPEN
      CHARACTER dna_image*80,xmlfile*80
C     ..
C     .. Common block /IOO/ ..
c      COMMON /IOO/IOUT,IUNIT,ONLINE,ITIN,ITOUT,INOD,INMO,IDU,NWRN,
c     +            ONEFILE,FHEADER,BRIEF,IBRIEF,GRAPH,ISUMMR,ICOORD,
c     +            IOERR,NODISPLAY,LBELL
C     ..
C
C
      COMMON /IOO/IOUT,IUNIT,ITIN,ITOUT,INOD,INMO,IDU,NWRN,IBRIEF,
     +        ISUMMR,ICOORD,SERVERFD,SERVERFDIN,NSHUTERR,ONLINE,ONEFILE,
     +        FHEADER,BRIEF,GRAPH,IOERR,NODISPLAY,LBELL,JPGOUT,
     $        SOCKLO,LBEST, dnafd, dnaout,INMOOPEN,XMLOPEN
      COMMON /CIOO/dna_image,xmlfile

C&&*&& end_include  ../inc/ioo.f
C&&*&& include  ../inc/iosp.f
C
C $Id: iosp.f,v 1.1 2002/05/02 10:46:53 harry Exp $
C
C--- awk generated include file  iosp.h
C---- START of include file iosp.h
C
C
C     .. Scalars in common block /IOSP/ ..
      INTEGER NSPOT,NFULL,NOUTGEN
C     ..
C     .. Common Block /IOSP/ ..
      COMMON /IOSP/NSPOT,NFULL,NOUTGEN
C     ..
C
C
C&&*&& end_include  ../inc/iosp.f
C&&*&& include  ../inc/lmb.f
C
C $Id: lmb.f,v 1.8 2009/01/08 18:03:14 harry Exp $
C
C--- awk generated include file  lmb.h
C---- START of include file lmb.h
C ODSCAL is to scale image numbers into the range 0-255 for plotting
C average profiles.
C  GAIN should be equal to the overall gain (image counts per X-ray photon)
C of the system, and is used to evaluate standard deviations based on
C counting statistics assuming independent pixels (ie point spread function
C less than pixel size).
C INVERTX true if image is inverted in the slow (X) direction when read in.
C ISCAL is to scale final integrated intensities and sigmas
C IDIVIDE is the adc offset
C ICONST is a constant to be added to all pixels (normally zero) to
C        allow processing of images with zero pixel values in the scanned
C        area.
C IMGP is true if working with image plate data
C SPIRAL is true for scanners with a spiral readout (Mar, DIP2000)
C ORTHOG is true for scanners with orthogonal scan (FUJI, RAXIS, MD)
C NULLPIX is the value of pixels within the image but not in the active
C area of the detector
C TILED is true if there are inactive areas of the detector within the
C       inscribing circle or square.
C
C NTILEX Number of tiles in X direction
C NTILEY Number of tiles in Y direction
C TILEX  X Coordinates of the midpoints of the null areas between tiles
C TILEY  Y Coordinates of the midpoints of the null areas between tiles
C TILEWX Width of the null areas between tiles in X
C TILEWY Width of the null areas between tiles in Y


C MACHINE and MODEL denote the type of detector. 
C
C MACHINE is used in the following subroutines:
C GETBLK, GETHDR, INTPXL, INTPXL2, MXDSPL, OPENODS, PROCESS, PUTPXL
C Currently coded types are:
C
C         MACHINE        MODEL               COMMENTS
C         =======        =====               ========
C         MAR            180, 300, 345
C         RAXI(S)        RAXISII, RAXISIV
C         MD
C         FUJI
C         CCD1           CCD1                Princetown CCD at CHESS,Tiff format
C         CCD2           CCD ?               ESRF CCD detector
C         ADSC           QUAD1               ADSC 2x2 CCD detector
C
C TRUSTED whether or not the image header information can be trusted for 
C         automatic processing
C     .. Scalars in Common Block /LMB/ ..
        REAL ODSCAL,GAIN,LOGA,LOGB
        INTEGER ISCAL,IDIVIDE,ICONST,NULLPIX,NTILEX,NTILEY,
     $    RAXISCOMP,IIDIVIDE,COMPRESSION
        LOGICAL IMGP,INVERTX,SPIRAL,ORTHOG,CIRCULAR,TILED,SETADC,
     $    NEWRAXIS,BRUKNEW,TRUSTED
        CHARACTER MACHINE*4,MODEL*8

C     ..
C     .. Arrays in common /LMB/
        INTEGER TILEX,TILEY,TILEWX,TILEWY
C
C     .. Common Block /LMB/ ..
        COMMON /LMB/ ODSCAL,GAIN,LOGA,LOGB,ISCAL,IDIVIDE,ICONST,
     +       NULLPIX,NTILEX,NTILEY,RAXISCOMP,IIDIVIDE,COMPRESSION,
     +       TILEX(20),TILEY(20),TILEWX(20),TILEWY(20),IMGP,
     +       INVERTX,SPIRAL,ORTHOG,CIRCULAR,TILED,SETADC,
     $       NEWRAXIS,BRUKNEW,TRUSTED
        COMMON /LMBC/ MACHINE,MODEL

C&&*&& end_include  ../inc/lmb.f
C&&*&& include  ../inc/mcs.f
C $Id: mcs.f,v 1.1 2002/05/02 10:46:56 harry Exp $
C
C
C--- awk generated include file  mcs.h
C---- START of include file mcs.h
C
C
C     .. Scalars in common block /MCS/ ..
      REAL BASEOD,G1OD,CURV
      INTEGER FILM,FILMS,CTOFD,PCKIDX,TOSPT,N1OD,XSCMIN,XSCMAX
      LOGICAL VEE,VALONGX
C     ..
C     .. Common block /MCS/ ..
      COMMON /MCS/BASEOD,G1OD,CURV,FILM,FILMS,CTOFD,PCKIDX,TOSPT,
     $            N1OD,XSCMIN,XSCMAX,VEE,VALONGX
C     ..
C     CTOFD.... This was the crystal to detector distance (10 micron units)
C               but it has now been replaced by XTOFD in common block /XY/
C
C&&*&& end_include  ../inc/mcs.f
C&&*&& include  ../inc/ori.f
C
C $Id: ori.f,v 1.2 2007/07/12 13:25:56 andrew Exp $
C
C--- awk generated include file  ori.h
C---- START of include file ori.h
C
C     XCEN,YCEN    Coordinates (in 10 micron units) of the direct beam
C                  position relative to an origin at the position of the
C                  first pixel in the digitised image.(The SCANNER
C                  coordinate frame). These parameters are refined for
C                  each image. 
C
C     XCEN0,YCEN0  Coordinates of direct beam position at zero swing angle.
C                  (Needed for pxtomm conversion for swung detectors)
C                  These values are assigned on the basis of input direct
C                  beam coordinates, corrected for swing angle if necessary.
C                  They are not (currently) updated during refinement.
C
C     XOFF,YOFF    Distance between centre of detector and direct beam.
C
C     ..
C     .. Arrays in common /ORI/ ..
      LOGICAL FIXPAR
C
C     .. Scalars in common block /ORI/ ..
      REAL COSOM0,SINOM0,XTOFRA,YSCAL,TILT,TWIST,BULGE,
     +     VBNEG,VBPOS,VTILT,VTWIST,VVERT,TOFF,BULGE2,PBULGE,ROFF,
     +     RDTOFF,RDROFF,ROFFPHI,TOFFPHI,JUNK3,XCEN,YCEN,XCEN0,YCEN0,
     +     XOFF,YOFF,TILTMAT,TWISTMAT,DETNOR,DPSIX,SMTWIST,SMTILT,
     +     SMOMEGA0,SMYSCAL,SMTOFF,SMROFF,SMXTOFRA
      INTEGER CBAR,NODES,NPHI,NSM1,NSM2
      LOGICAL RESETCCOM,NOSMOOTH
C     ..
C     .. Common Block /ORI/ ..
      COMMON /ORI/COSOM0,SINOM0,XTOFRA,YSCAL,TILT,TWIST,BULGE,
     $       VBNEG,VBPOS,VTILT,VTWIST,VVERT,TOFF,BULGE2,PBULGE,ROFF,
     $       RDTOFF,RDROFF,ROFFPHI,TOFFPHI,JUNK3,XCEN,YCEN,XCEN0,
     +       YCEN0,XOFF,YOFF,TILTMAT,TWISTMAT,DPSIX,DETNOR(3),CBAR,
     +       NODES,NPHI,FIXPAR(NRPAR),
     $       RESETCCOM,SMTWIST,SMTILT,SMOMEGA0,SMYSCAL,SMTOFF,SMROFF,
     +       SMXTOFRA,NSM1,NSM2,NOSMOOTH
C     ..
C
C
C&&*&& end_include  ../inc/ori.f
C&&*&& include  ../inc/ovrld.f
C
C $Id: ovrld.f,v 1.1 2002/05/02 10:47:03 harry Exp $
C
C--- awk generated include file  ovrld.h
C---- START of include file ovrld.h
C
C
C     .. Scalars in Common Block /OVRLD/ ..
      INTEGER NPMAX
C     ..
C     .. Common Block /OVRLD/ ..
      COMMON /OVRLD/NPMAX
C     ..
C
C
C&&*&& end_include  ../inc/ovrld.f
C&&*&& include  ../inc/params.f
C
C $Id: params.f,v 1.1 2002/05/02 10:47:04 harry Exp $
C
C--- awk generated include file  params.h
C---- START of include file params.h
C
C
C     .. Scalars in common block /PARAMS/ ..
      INTEGER NSDR
C     ..
C     .. Common Block /PARAMS/ ..
      COMMON /PARAMS/NSDR
C     ..
C
C
C
C&&*&& end_include  ../inc/params.f
C&&*&& include  ../inc/parm1.f
C
C $Id: parm1.f,v 1.1 2002/05/02 10:47:05 harry Exp $
C
C--- awk generated include file  parm1.h
C---- START of include file parm1.h
C
C
C
C     .. Scalars in common block /PARM1/ ..
      REAL BGSIG,EFAC,EFACSQ,BGFREJ,GRADMAX,GRADMAXR,BGRAT,PKRAT,
     +     RESD,RESDLOW
      INTEGER CUTOFF,NOVPIX,NDSTART,NDTOT,IXDMIN,IXDMAX,IYDMIN,IYDMAX,
     +     IDMIN,IDMAX
      LOGICAL DUMPSPOT,BADPLOT,DUMPALL,BADPLOT2
C     ..
C     .. Common Block /PARM1/ ..
      COMMON /PARM1/BGSIG,EFAC,EFACSQ,BGFREJ,GRADMAX,GRADMAXR,
     +              BGRAT,PKRAT,RESD,RESDLOW,CUTOFF,NOVPIX,
     +              NDSTART,NDTOT,IXDMIN,IXDMAX,IYDMIN,IYDMAX,
     +              IDMIN,IDMAX,DUMPSPOT,BADPLOT,DUMPALL,BADPLOT2
C     ..
C
C
C&&*&& end_include  ../inc/parm1.f
C&&*&& include  ../inc/pel.f
C     **** This is the IMAGE PLATE version of this common block ****
C
C
C---- START of include file pel.h
C
C
C     .. Scalars in common blocks /PEL/ and /PELC/ ..
      INTEGER IBA,IPOINT,ISTART
      LOGICAL INCORE
C     ..
C     .. Arrays in common blocks /PEL/ and /PELC/ ..
      LOGICAL RDSTRIP
      INTEGER*2 BOXOD,IMAGE
C     ..
C     .. Common Blocks /PEL/ and /PELC/ ..
      COMMON /PEL/IBA,IPOINT,INCORE,RDSTRIP(IXWDTH),BOXOD(MAXBOX),
     +            ISTART
      COMMON /PELC/ IMAGE(IYLENGTH*IXWDTH)
C     ..
C
C
C---- END of include file pel.h
C
C&&*&& end_include  ../inc/pel.f
C&&*&& include  ../inc/precession.f
C
C $Id: precession.f,v 1.1 2002/05/02 10:47:08 harry Exp $
C
C--- awk generated include file  precession.h
C---- START of include file precession.h
C
C
C     .. Scalars in common block /PRECESSION/ ..
      REAL D1,D2,PHIPREC,PSIPREC,PCTOFD,XLAMBDA
      LOGICAL PRECESS
C     ..
C     .. Common Block /PRECESSION/ ..
      COMMON /PRECESSION/D1,D2,PHIPREC,PSIPREC,PCTOFD,XLAMBDA,PRECESS
C     ..
C
C
C&&*&& end_include  ../inc/precession.f
C&&*&& include  ../inc/pro.f
C
C $Id: pro.f,v 1.1 2002/05/02 10:47:09 harry Exp $
C
C--- awk generated include file  pro.h
C---- START of include file pro.h
C
C
C     .. Arrays in common block /PRO/ ..
      INTEGER*2 IDUM
C     ..
C     .. Common Block /PRO/ ..
      COMMON /PRO/IDUM(MAXBUFF)
C     ..
C
C
C&&*&& end_include  ../inc/pro.f
C&&*&& include  ../inc/pro2.f
C--- awk generated include file  pro2.h
C---- START of include file pro2.h
C
C     .. Scalars in Common /PRO2/ ..
      REAL PRCENSUM
C
C     .. Arrays in Common Block /PRO2/ ..
      INTEGER IODPROF
C     ..
C     .. Common Block /PRO2/ ..
      COMMON /PRO2/PRCENSUM,IODPROF(MAXBOX)
C     ..
C
C
C&&*&& end_include  ../inc/pro2.f
C&&*&& include  ../inc/ras.f
C
C $Id: ras.f,v 1.1 2002/05/02 10:47:10 harry Exp $
C
C--- awk generated include file  ras.h
C---- START of include file ras.h
C
C
C     .. Scalars in common block /RAS/ ..
      INTEGER NEWRAS,MINT
C     ..
C     .. Arrays in common block /RAS/ ..
      INTEGER IRAS
      REAL VARAS
C     ..
C     .. Common Block /RAS/ ..
      COMMON /RAS/VARAS(5),IRAS(5),NEWRAS,MINT
C     ..
C
C
C&&*&& end_include  ../inc/ras.f
C&&*&& include  ../inc/reeke.f
C
C $Id: reeke.f,v 1.15 2008/10/22 08:50:48 andrew Exp $
C
C--- awk generated include file  reeke.h
C---- START of include file reeke.h
C
C     TOR     For synchrotron sources, degree of polarisation of the beam
C     IMONO   Collimation flag for polarisation.
C             = 0   Pinhole or mirrors
C             = 1   Graphite Monochromator
C             = 2   Synchrotron, use TOR
C     NWMAX   Maximum reflection width in images
C     DSTMAX  dimensionless rlu, = WAVE/RES where RES is the maximum
C             resolution in Angstrom.
C     DSTMIN  dimensionless rlu, = WAVE/DMAX where DMAX is the maximum
C              Bragg spacing
C     S0      radiation source vector (-1,0,0), may be modified by MU values
C     SOURCE  radiation source vector - basis for s0
C     GONIO_angle:  machine angles for generalized goniostats
C     GONIO_angle_SET: fixed offset angles for 3- and 4-circle goniostats
C                      i.e. currently 54.74 deg for Bruker CHI, 50.0deg for
C                      Nonius and Oxford KAPPA 
C     ..
C     .. Arrays in common block /REEKE/ ..
      REAL RMC,AMAT,SCAXIS,S0,s0unit,CAMCON,BEAMMU
C     ..
C     .. Scalars in common block /REEKE/ ..
      REAL X1,X2,Y1,Y2,Z1,Z2,XYS,DSTAR2,DSTMAX,DSTPL,DSTPL2,
     +     DIVH,DIVV,DELAMB,ETA,DELCOR,DSTMAXS,TOR,DSTMIN,WMAX,
     +     ETAFRAC,ETASM,
     $     GON_CHI,GON_PHIS,GON_KAPPA,GON_OMEGAS,GON_2THETA,
     $     GON_PHIE,GON_OMEGAE,
     +     GON_CHI_SET,GON_KAPPA_SET,
     +     BLKSIZE
      INTEGER ISYN,IMONO,NWMAX,IPAD,NSMOOTH,IGON_CHI,IGON_PHI,
     $     IGON_KAPPA,IGON_OMEGA,IGON_2THETA,
     +     IGON_CHI_SET,IGON_KAPPA_SET,IHOSCAXIS
C     ..
C     .. logicals in common block /REEKE/ ..
      LOGICAL LOGETA,NUREEK,LCAMCON,GENGON,FOURCIRCLE,THREECIRCLE
C     ..
C     .. Common Block /REEKE/ ..
      COMMON /REEKE/RMC(3,3),AMAT(3,3),SCAXIS(3),S0(3),s0unit(3),
     $     CAMCON(8),BEAMMU(2),X1,X2,Y1,Y2,
     +     Z1,Z2,XYS,DSTAR2,DSTMAX,DSTPL,DSTPL2,DIVH,DIVV,DELAMB,
     +     ETA,DELCOR,DSTMAXS,TOR,DSTMIN,WMAX,ETAFRAC,ETASM,
     $     GON_CHI,GON_PHIS,GON_KAPPA,GON_OMEGAS,GON_2THETA,
     $     GON_PHIE,GON_OMEGAE,
     +     GON_CHI_SET,GON_KAPPA_SET,ISYN,IMONO,
     $     NWMAX,IPAD,
     $     NSMOOTH,IGON_CHI,IGON_PHI,
     $     IGON_KAPPA,IGON_OMEGA,IGON_2THETA,
     +     IGON_CHI_SET,IGON_KAPPA_SET,IHOSCAXIS,LOGETA,NUREEK,LCAMCON,
     $     GENGON,FOURCIRCLE,THREECIRCLE,
     +     BLKSIZE
C     ..
C
C
C&&*&& end_include  ../inc/reeke.f
C&&*&& include  ../inc/rfs.f
C
C $Id: rfs.f,v 1.2 2007/07/12 13:25:57 andrew Exp $
C
C--- awk generated include file  rfs.h
C---- START of include file rfs.h
C
C
C
C     .. Scalars in common block /RFS/ ..
      REAL FDIST,ESTART,RMSRES,WRMSRES,WESTART
      INTEGER MAXREF,MAXX,MAXY,NRS,MAXR,NREJS,NCENTREF
C     ..
C     .. Arrays in common block /RFS/ ..
      REAL XRS,YRS,WXRS,WYRS
      INTEGER RRS,IHKLR
C     ..
C     .. Common Block /RFS/ ..
      COMMON /RFS/ XRS(NDETREF),YRS(NDETREF),WXRS(NDETREF),
     +       WYRS(NDETREF),FDIST,ESTART,RMSRES,WRMSRES,
     $       WESTART,RRS(NDETREF),IHKLR(3,NDETREF),MAXREF,MAXX,
     +       MAXY,NRS,MAXR,NREJS,NCENTREF
C     ..
C
C
C&&*&& end_include  ../inc/rfs.f
C&&*&& include  ../inc/scn.f
C
C $Id: scn.f,v 1.3 2004/08/16 13:26:48 harry Exp $
C
C--- awk generated include file  scn.h
C---- START of include file scn.h
C
C     SCNSZ   is pixel size (in microns) divided by 25
C     RAST    pixel size in slow direction in mm
C     FACT    multiplying by FACT converts from 10 micron units 
C             (the standard unit internal to the program) into pixels
C     IYLEN   The number of pixels in the Y (fastest changing) direction
C             in the digitised image.
C     NREC    The number of pixels in the X (slow) direction in the 
C             digitised image.
C     NWORD   The number of I*2 words in the Y direction.
C     NBYTE   The number of bytes in Y direction = NWORD/2
C     NHBYTE  Number of bytes in header
C
C     ICURR   When several images are stored in a single file, ICURR is the
C             pointer to the first record of the current image in the direct
C             access file (only implemented for film data)
C     NEXTRA  The number of additional (unused) bytes padding the end of
C             each record in image file
C     BYTSWAP True if the "endedness" (Big-endian/Little-endian) of the 
C             machine that MOSFLM is running on is different to that of the
C             machine on which the image was written. This is determined by
C             looking at the value of NXPIX in the header record of the
C             image file (subroutine GETHDR)
C
C     LACTIVE True if using Rigaku active mask, False if ignoring it
C
C     .. Scalars in common block /SCN/ ..
      REAL FACT,SCNSZ,RAST,RASTY
      INTEGER NBYTE,NREC,NWORD,IYLEN,ICURR,NEXTRA,NHBYTE
      LOGICAL BYTSWAP,LACTIVE
C     ..
C     .. Common Block /SCN/ ..
      COMMON /SCN/ FACT,SCNSZ,RAST,RASTY,NBYTE,NREC,NWORD,IYLEN,
     +     ICURR,NEXTRA,NHBYTE,BYTSWAP,LACTIVE
C&&*&& end_include  ../inc/scn.f
C&&*&& include  ../inc/sums.f
C
C $Id: sums.f,v 1.1 2002/05/02 10:47:21 harry Exp $
C
C--- awk generated include file  sums.h
C---- START of include file sums.h
C
C
C     Elements of ASPOT
C     1 = Summation integration intensity
C     2 = Total background counts under peak assuming peak has mm symmetry
C     3 = Rms variation in background, after rejecting background points.
C         This is evaluated in BGSOLVE called from EVAL.
C     4 = Centre of gravity in X direction (in pixels)
C     5 = Centre of gravity in Y direction (in pixels)
C         These are wrt an origin at the centre of the measurement box
C     6 = sum p*iod for background pixels
C     7 = sum q*iod for background pixels
C     8 = sum iod for background pixels
C     9 = Background plane constant a (gradient in X direction)
C    10 = Background plane constant b (gradient in Y direction)
C    11 = Background plane constant c 
C    12 = Largest deviation from background plane, excluding rejected pixels
C    13 = Profile fitted intensity
C    14 = Variance of profile fitted intensity = sum (deltasq) for peak
C         pixels only. Used to calculate PKRATIO and also profile fitted
C         sigma(I) in unweighted case only.
C    15 = Number of rejected background pixels
C    16 = Variance of profile fitted intensity in weighted case (default)
C    17 = sum W*DELTA**2 for profile fit
C    18   unused
C     .. Arrays in common block /SUMS/ ..
      REAL ASPOT
C     ..
C     .. Common Block /SUMS/ ..
      COMMON /SUMS/ASPOT(18)
C     ..
C
C
C&&*&& end_include  ../inc/sums.f
C&&*&& include  ../inc/test.f
C--- awk generated include file  test.h
C---- START of include file test.h
C
C    Detector limits, used in SPTEST. All are in 10 micron units.
C    In the virtual detector frame, Y is parallel to the rotation axis
C    and X is orthogonal to the rotation axis.
C
C    In the scanner frame, X is parallel to the slow direction in the
C    image, Y is the fast direction.
C
C    RSCANSQ      Radius**2 of the scanned region of the plate (Mar scanners)
C                 This is different to the other limits because it is
C                 applied to the actual scanner coordinates rather than
C                 the virtual detector coordinates. All other limits apply
C                 to virtual detector coordinates.
C    XSCAN        Maximum X coordinate in detector frame (10 micron units)
C    YSCAN        Maximum Y coordinate in detector frame (10 micron units)
C    RSCANX,RSCANY If non-zero, these are the coordinates (10 micron units)
C                 for the centre of the circle radius RSCAN defining the
C                 useable area of the detector.
C    RMINX,RMINY If non-zero, these are the coordinates (10 micron units)
C                 for the centre of the circle radius RMIN defining the
C                 useable area of the detector.
C    RMXSQD       Maximum radius (squared) in virtual detector frame
C    RMNSQD       Minimum radius (squared) in virtual detector frame
C    XMIN         Minimum X coordinate in  detector frame
C    XMAX         Maximum X coordinate in  detector frame
C    YMIN         Minimum Y coordinate in  detector frame
C    YMAX         Maximum Y coordinate in  detector frame
C    NXYEXC       Number of excluded areas set by user (rectangles, arcs)
C    NXYEXCDET    Number of detector specific excluded rectangles (Pilatus)
C
C     .. Scalars in common block /TEST/ ..
      REAL RMXSQD,RMNSQD,XMIN,XMAX,YMIN,YMAX,RSCANSQ,RSCANX,RSCANY,
     +     RMINX,RMINY,XSCAN,YSCAN,CIRRAD
      INTEGER NEXCL,NXYEXC,NXYEXCDET,IQUADNO,IARCNO
C
C     .. Arrays in common block /TEST/
      REAL RESEXL,RESEXH,XYEXC,CNREXC,EXCARC,CIRCEN,PHILIM
      INTEGER IEXCARC
      LOGICAL LEXCARC
C     ..
C     .. Common Block /TEST/ ..
      COMMON /TEST/RESEXL(MAXEXCL),RESEXH(MAXEXCL),XYEXC(4,MAXEXCL),
     +     CNREXC(8,MAXEXCL),
     $     EXCARC(5,MAXEXCL),CIRCEN(2),PHILIM(2),RMXSQD,RMNSQD,XMIN,
     +     XMAX,YMIN,YMAX,RSCANSQ,RSCANX,RSCANY,RMINX,RMINY,XSCAN,
     $     YSCAN,CIRRAD,IEXCARC(6,MAXEXCL),NEXCL,NXYEXC,IQUADNO,
     $     IARCNO,LEXCARC(MAXEXCL),NXYEXCDET
C     ..
C
C

C&&*&& end_include  ../inc/test.f
C&&*&& include  ../inc/xy.f
C
C $Id: xy.f,v 1.1 2002/05/02 10:47:25 harry Exp $
C
C--- awk generated include file  xy.h
C---- START of include file xy.h
C
C     .. Scalars in common block /XY/ ..
      REAL XTOFD,SINV,COSV,TANV,TWOTHETA
      INTEGER ICASS
C     ..
C     .. Common Block /XY/ ..
      COMMON /XY/XTOFD,SINV,COSV,TANV,TWOTHETA,ICASS
C     ..
C
C     XTOFD....  Crystal to detector distance in 10 micron units. Read from
C                keyworded input and never changed.
C
C                Spot positions are calculated in S/R XYSPOT (Called from
C                REEK) and are for an "ideal" detector at a distance of XTOFD.
C                These are converted into pixel positions in S/R MMTOPX
C                which applies the multiplicative factor XTOFRA to allow
C                for refinement of the distance. XTOFRA is the parameter
C                that is actually refined (in RDIST), rather than XTOFD.
C                The refined distance that is printed in the logfile is
C                actually XTOFRA*XTOFD
C
C     ICASS....  Indicates detector type:
C                0     Flat film
C                1     Vee shaped cassettes
C                2     FAST detector (only used in TESTGEN mode of OSCGEN)
C                3     Swung out FAST (ditto)
C                4     IP detector
C     TWOTHETA   Detector swing angle (degrees)
C&&*&& end_include  ../inc/xy.f

C     ..
C     .. Equivalences ..
      EQUIVALENCE (IRAS(1),NXS), (IRAS(2),NYS), (IRAS(3),NC)
      EQUIVALENCE (IRAS(4),NRX), (IRAS(5),NRY)
      EQUIVALENCE (IDUM(1),IARR(1))
      EQUIVALENCE (ASPOT(11),BACK)
C     ..
      SAVE
C     .. Data statements ..
      DATA USEOVRLD/.FALSE./
C     ..
C
C
      CALLEDFROM = 'CENTRS'
      IR1 = 2*IPAD + 1
      IR2 = 2*IPAD + 2
      IR2 = 30*IPAD + 30
      EXPART = .FALSE.
      XLIMIT = LIMIT
      VLIMIT = VLIM
      NBGBAD = 0
      NBGBADG = 0
      NZPBAD = 0
      NHX = NXS/2
      NHY = NYS/2
C
C---- Find number of background points (needed for cgfind)
C
C           ***********************
       CALL SIZRAS(IRAS,NPEAK,NBKG)
C           ***********************
C
C---- If allowing overloads, set npmax to five times the normal limit
C     NOVPIX
C
      IF (OVRLDS .OR. USEOVRLD) THEN
        IF (NOVPIX.GT.0) THEN
          NPMAX = NOVPIX*5
        ELSE
          NPMAX = 0.25*NPEAK
        END IF
      ELSE
        NPMAX = NOVPIX
      END IF
C
C  Convert separation from mm to pixels
      ISEPN = FACT*SEP*100.0
      LASTX = 0
      LASTY = 0
      XDOV2 = XTOFD*XTOFRA/2.0
C
C
      IF (DEBUG(6)) THEN
        IF (ONLINE) WRITE (ITOUT,FMT=6000) DOPROFILE,MATCH,PARTLS,
     +      OVRLDS,GENLIST,OLDLIST,USEOVRLD,NSPOT,ADDPART,USEBOX,
     +      PTMIN
 6000 FORMAT (1X,'Enter CENTRS',/1X,'Logicals DOPROFILE ',L1,' MATCH ',
     +       L1,' PARTLS ',L1,' OVRLDS ',L1,' GENLIST ',L1,' OLDLIST ',
     +        L1,' USEOVRLD ',L1,/,1X,'NSPOT',I5,'  ADDPART ',L1,
     +        '  USEBOX ',L1,'  PTMIN',F5.2)
        WRITE (IOUT,FMT=6000) DOPROFILE,MATCH,PARTLS,OVRLDS,GENLIST,
     +    OLDLIST,USEOVRLD,NSPOT,ADDPART,USEBOX,PTMIN
      END IF
C
C
      IF (DOPROFILE) THEN
C
C
        DO 10 I = 1,MAXBOX
          IODPROF(I) = 0
   10   CONTINUE
C
C
        NPROFL = 0
      END IF
C
C
      IF (OLDLIST) GO TO 180
C
C---- If this call is to calculate average spot profile
C     use previously stored list of reflections, unless this
C     is a vee film, in which case a new list must be created
C     Also, if overloads have been included in the positional
C     refinement, then we need a new reflection list which excludes
C     the overloads.
C
      IF ((.NOT.VEE) .AND. DOPROFILE .AND. (.NOT.USEOVRLD)) GO TO 180
C
C---- Start measuring
C
      IF (GENLIST) GO TO 90
C
C---- Find full spots from generate file and sort
C
C---- Only use every jadd'th spot if more than 500 reflections
C     in central area
C
C---- Set limits for reflection list
C
      JMAX = TOSPT
C
C
      IF (MATCH) THEN
        JMAX = NSPOT
        JADD = NSPOT/500
        GO TO 30
      END IF
C
C
   20 JADD = 0
   30 JADD = JADD + 1
      NREF = 0
      NREFT = 0
C
C
      DO 80 JREC = 1,JMAX,JADD
C
        IR = IRG(JREC)
        IM = IMG(JREC)
C
C
        IF (PARTLS) THEN
C
C
C---- Reject partials and rejected spots, unless partials have been
C     requested.
C     If partials are to be included, then if ADDPART is true only
C     allow partials at end of current oscillation (IM.GT.0) so they can be
C     added in from the next image, if ADDPART is false only
C     allow reflections with a degree of partiality greater than PTMIN
C     In pattern matching, do NOT apply these tests, and note
C     that PTMIN passed in is not the default value but a local variable
C     from subroutine automatch set to 0.1
C
          IF ((IR.EQ.1).OR.(IR.EQ.2).OR.(IR.EQ.4)) GO TO 80
          IF (ADDPART) THEN
            IF ((.NOT.MATCH).AND.((IR.LT.IR1).OR.(IR.GT.IR2))
     +                        .OR.(IM.LT.0)) GOTO 80
          ELSE
            AM = 0.01*ABS(FLOAT(IM))
            IF ((AM.GT.0.0).AND.(AM.LT.PTMIN)) GOTO 80
          END IF
        ELSE
C
C---- Reject all  flagged reflections, don't reject partials yet
C
          IF ((IR.NE.0).AND.(IR.LT.IR1)) GO TO 80
        END IF
C
C
        XC = XG(JREC)
        YC = YG(JREC)
C
C---- For precession photographs, XG,YG are multiples of base
C     vectors and not reflection coordinates,
C     so must calculate coords.
C
        IF (PRECESS) THEN
C
C              ************************
          CALL PXYCALC(XCAL,YCAL,XC,YC)
C              ************************
C
          AJX = ABS(XCAL-XCEN)
          AJY = ABS(YCAL-YCEN)
        ELSE
          AJX = ABS(XC)
          AJY = ABS(YC)
        END IF
C
C
        IF (DEBUG(6) .AND. JREC.LT.NDEBUG(6)) THEN
          IF (ONLINE) WRITE(ITOUT,FMT=6002) JREC,XC,YC,AJX,AJY,XLIMIT,
     +        IR,IM
 6002 FORMAT (1X,'JREC',I5,' X,Y (GENFILE)',2F8.1,'  AJX,Y',2F8.1,
     +       '  LIMIT',F7.1,' IR',I3,' IM',I4)
          WRITE (IOUT,FMT=6002) JREC,XC,YC,AJX,AJY,XLIMIT,IR,IM
        END IF
C
C
        IF (AJY.GT.XLIMIT) GO TO 80
C
C---- Test for area containing unexpanded spots for vee-films.
C
        IF (VEE) GO TO 40
        IF (AJX.GT.XLIMIT) GO TO 80
        GO TO 60
   40   IF (DOPROFILE) GO TO 50
        IF (AJX.GT.VLIMIT) GO TO 80
        GO TO 60
C
   50   IF (ABS(AJX-XDOV2).GT.XLIMIT) GO TO 80
   60   NREFT = NREFT + 1
C
C---- Reject partials now
C
        IF ((.NOT.PARTLS).AND.(IM.NE.0)) GOTO 80
        NREF = NREF + 1
        IRECNO(NREF) = JREC
        IF (IM.NE.0) IRECNO(NREF) = -IRECNO(NREF)
C
C                         ****************************
        IF (.NOT.PRECESS) CALL MMTOPX(XCAL,YCAL,XC,YC)
C                         ****************************
C
C---- Apply box shift. Note that X,Y are spot coordinates in pixels.
C
        X(NREF) = NINT(XCAL*FACT) + IXSHIFT
        Y(NREF) = NINT(YCAL*FACT) + IYSHIFT
C
C---- Test that the edge of the measurement box is not outside the image
C
        IF ((X(NREF)-NHX.LT.6).OR.(X(NREF)+NHX.GT.NREC-5).OR.
     +  (Y(NREF)-NHY.LT.6).OR.(Y(NREF)+NHY.GT.IYLEN-5)) THEN
           NREF = NREF - 1
           GOTO 80
        END IF
        IF (DEBUG(6).AND.NREF.LT.NDEBUG(6))  THEN
          WRITE(IOUT,FMT=6003) NREF,X(NREF),Y(NREF)
          IF (ONLINE) WRITE(ITOUT,FMT=6003) NREF,X(NREF),Y(NREF)
 6003     FORMAT(1X,'SELECTED REFLECTION',I4,' X,Y',2I8)
        END IF
        IF (NREF.EQ.500) GO TO 30
   80 CONTINUE
C
C
      GO TO 200
C
C---- ********** Alternative procedure *************
C     For B and C films using NOFID option,
C     select spots on basis of intensity measured on preceeding film.
C
   90 XSIZBIN = XLIMIT/5.0
      YSIZBIN = XLIMIT/4.0
C
C
      DO 100 I = 1,NDETREF
        ISPOT(I) = 0
  100 CONTINUE
C
C---- Search for the strongest full spot in each
C     subdivision of the film
C
  110 CONTINUE
C
C
      DO 140 I = 1,TOSPT
C
C---- Reject partials and rejected spots
C
        IR = IRG(I)
        IM = IMG(I)
        IF ((IR.NE.0).OR.(IM.NE.0)) GO TO 130
C
C---- Reject overloads or unmeasured spots on preceeding film
C     unless we want to use overloads (but not if forming profile)
C     in which case the first overload in the bin is selected
C
        INT = INTG(I)
        IF (USEOVRLD .AND. (INT.EQ.9999) .AND.
     +      (.NOT.DOPROFILE)) GO TO 120
        IF (INT.EQ.9999 .OR. INT.LE.0) GO TO 130
  120   XC = XG(I)
        YC = YG(I)
        JX = XC
        JY = YC
C
C---- For precession photographs, XG,YG are multiples of
C     base vectors and not reflection coordinates,
C     so must calculate coords.
C
        IF (PRECESS) THEN
C
C              ************************
          CALL PXYCALC(XCAL,YCAL,XC,YC)
C              ************************
C
          AJX = ABS(XCAL-XCEN)
          AJY = ABS(YCAL-YCEN)
        ELSE
          AJX = ABS(XC)
          AJY = ABS(YC)
        END IF
C
C
        IF (AJY.GT.XLIMIT) GO TO 130
C
C---- Test for area containing unexpanded spots for vee-films.
C
        IF (VEE) THEN
C
C
          IF (DOPROFILE) THEN
            IF (ABS(AJX-XDOV2).GT.XLIMIT) GO TO 130
          ELSE
            IF (AJX.GT.VLIMIT) GO TO 130
          END IF
C
C
        ELSE
          IF (AJX.GT.XLIMIT) GO TO 130
        END IF
C
C
        K = (XLIMIT+XC)/XSIZBIN
        IF (PRECESS) K = (XLIMIT+XCAL-XCEN)/XSIZBIN
        IF (K.GT.9) K = 9
        J = (XLIMIT+YC)/YSIZBIN
        IF (PRECESS) J = (XLIMIT+YCAL-YCEN)/YSIZBIN
        IF (J.LT.1) J = 1
        IF (J.GT.6) J = 6
        INDX = 6*K + J
C
C
        IF (USEOVRLD .AND. (.NOT.DOPROFILE) .AND. (INT.EQ.9999)) THEN
          ISDR = 500
        ELSE
          ISDR = INT/ISDG(I)
        END IF
C
C
        IF (ISDR.LT.ISPOT(INDX)) GO TO 130
C
C
        IF (DEBUG(6)) THEN
          IF (PRECESS) THEN
            IF (ONLINE) WRITE (ITOUT,FMT=6004) I,INDX,XG(I),YG(I),
     +          NINT(XCAL-XCEN),NINT(YCAL-YCEN),ISDR
 6004 FORMAT (1X,'REFLECTION',I5,'  INDX',I3,'  N,M',2I5,'  IX,IY',2I6,
     +       '  ISDR',I5)
            WRITE (IOUT,FMT=6004) I,INDX,XG(I),YG(I),NINT(XCAL-XCEN),
     +        NINT(YCAL-YCEN),ISDR
          ELSE
            IF (ONLINE) WRITE (ITOUT,FMT=6006) I,INDX,XG(I),YG(I),ISDR
 6006 FORMAT (1X,'REFLECTION',I5,' INDX',I3,' IX,IY',2F8.1,'  ISDR',I5)
            WRITE (IOUT,FMT=6006) I,INDX,XG(I),YG(I),ISDR
          END IF
        END IF
C
C
        ISPOT(INDX) = ISDR
        IRECNO(INDX) = I
C
C                         ****************************
        IF (.NOT.PRECESS) CALL MMTOPX(XCAL,YCAL,XC,YC)
C                         ****************************
C
        X(INDX) = NINT(XCAL*FACT)
        Y(INDX) = NINT(YCAL*FACT)
C
C---- Increase ISPOT for overloads so that first found in bin is kept
C
        IF (USEOVRLD .AND. (.NOT.DOPROFILE)) ISPOT(INDX) = 600
  130   CONTINUE
  140 CONTINUE
C
C---- Count number of spots found and reject those with
C     I/SD.lt.NSDR (defaults to 25)
C
      IF (DEBUG(6)) THEN
        IF (ONLINE) WRITE (ITOUT,FMT=6008)
 6008 FORMAT (//1X,'Selected reflections in CENTRS')
        WRITE (IOUT,FMT=6008)
      END IF
C
C
      NREF = 0
C
C
      DO 170 I = 1,MAXREF
C
C---- NSDR set by default to 25, may be changed by keyword ISDR
C
        IF (ISPOT(I).LT.NSDR) GO TO 160
        NREF = NREF + 1
        X(NREF) = X(I)
        Y(NREF) = Y(I)
        IRECNO(NREF) = IRECNO(I)
C
C
        IF (DEBUG(13)) THEN
         IF (ONLINE) WRITE(ITOUT,FMT=6010) NREF,X(I),Y(I)
 6010 FORMAT (1X,'NREF=',I5,'  X,Y',2I6)
         WRITE(IOUT,FMT=6010) NREF,X(I),Y(I)
        END IF
C
C
  160   CONTINUE
  170 CONTINUE
C
C---- If not enough reflections, try including reflections that
C     are overloaded on the A film, and allow them to be overloaded
C     (up to 5*NOVPIX pixels) on this film too.
C
      IF ((NREF.LT.MINREF) .AND. (.NOT.USEOVRLD)) THEN
        WRITE (IOUT,FMT=6012)
 6012 FORMAT (/1X,'** NOT enough reflections found for refinement **',
     +       /1X,'Allow inclusion of overloaded reflections')
        IF (ONLINE) WRITE (ITOUT,FMT=6012)
        USEOVRLD = .TRUE.
        IF (NOVPIX.GT.0) THEN
          NPMAX = NOVPIX*5
        ELSE
          NPMAX = 5
        END IF
        GO TO 110
      END IF
C
C
      IF (NREF.LT.MINREF) THEN
        IF (NSDR.GE.3) THEN
          NSDRP = 0.666*NSDR
          WRITE (IOUT,FMT=6014) NREF,NSDR,NSDRP
 6014 FORMAT (/1X,'ONLY',I3,' Reflections found for refinement in cent',
     +       'ral region of film',/1X,'Cutoff (I/sigma) reduced from',
     +       I4,' to',I4)
          IF (ONLINE) WRITE (ITOUT,FMT=6014) NREF,NSDR,NSDRP
          NSDR = NSDRP
          GOTO 110
        ELSE
          WRITE (IOUT,FMT=6015) NREF,NSDR
          IF (ONLINE) WRITE (ITOUT,FMT=6015) NREF,NSDR
 6015     FORMAT (/1X,'ONLY',I3,' Reflections found for refinement in ',
     +    'central region of film',/1X,'with cutoff (I/sigma) set to',
     +     I3)
          NRS = NREF
          RETURN
        END IF
      END IF
C
C
      GO TO 200
C
C---- Use existing list of refinement spots
C
  180 CONTINUE
C
      NPARTL = 0
C
      DO 190 I = 1,NRS
        JREC = RRS(I)
        IRECNO(I) = JREC
        IF (JREC.LT.0) THEN
          JREC = -JREC
C
C---- Count number of partials in list if forming average spot profile
C
          IF (DOPROFILE.AND.(.NOT.ADDPART)) NPARTL = NPARTL + 1
        END IF
        XC = XG(JREC)
        YC = YG(JREC)
C
        IF (PRECESS) THEN
C
C              ************************
          CALL PXYCALC(XCAL,YCAL,XC,YC)
C              ************************
C
        ELSE
C
C              ***********************
          CALL MMTOPX(XCAL,YCAL,XC,YC)
C              ***********************
C
        END IF
C
C
        X(I) = NINT(XCAL*FACT) + IXSHIFT
        Y(I) = NINT(YCAL*FACT) + IYSHIFT
        IF (DEBUG(6)) THEN
          WRITE(IOUT,FMT=6017) I,RRS(I),XG(JREC),YG(JREC),X(I),Y(I)
          IF (ONLINE) WRITE(ITOUT,FMT=6017) I,RRS(I),XG(JREC),YG(JREC),
     +                                      X(I),Y(I)
 6017     FORMAT(1X,'Reflection',I3,' Record number',I6,' XG,YG',2F8.1,
     +           '  Pixel coords',2I10)
        END IF
  190 CONTINUE
C
C
      NREF = NRS
C
C---- If forming average spot profile, exclude partials (providing this
C     leaves at least MINREF reflections)
C
      IF (DOPROFILE) THEN
        NFULLS = NREF - NPARTL
        EXPART = (NFULLS.GT.MINREF)
        IF (.NOT.EXPART) THEN
          WRITE(IOUT,FMT=6013) MINREF
          IF (ONLINE) WRITE(ITOUT,FMT=6013) MINREF
 6013   FORMAT(1X,'Fewer than',I3,' fully recorded reflections, so',
     +         ' average spot profile will include partials')
        END IF
      END IF
C
 200  IF (PARTLS) THEN
          IF (ADDPART) THEN
            WRITE(IOUT,FMT=6050) NREF
            IF (ONLINE) WRITE(ITOUT,FMT=6050) NREF
 6050 FORMAT(1X,I5,' Fulls and summed partials to be measured')
          ELSE IF (PARTLS.AND.EXPART) THEN
            WRITE(IOUT,FMT=6052) NREF-NPARTL
            IF (ONLINE) WRITE(ITOUT,FMT=6052) NREF-NPARTL
 6052 FORMAT(1X,I5,' Fulls to be measured')
          ELSE
            WRITE(IOUT,FMT=6054) NREF
            IF (ONLINE) WRITE(ITOUT,FMT=6054) NREF
 6054 FORMAT(1X,I5,' Fulls and partials to be measured')
          END IF
      ELSE
          WRITE(IOUT,FMT=6052) NREF
          IF (ONLINE) WRITE(ITOUT,FMT=6052) NREF
      END IF
C
C
      IF (NREF.LT.MINREF) THEN
C
C---- Too few reflections in the list. If necessary, include partials, but
C     first check that this really is because most of the reflections are
C     partial. If not, then increase the size of central area.
C
        IF (.NOT.PARTLS) THEN
C
C---- If total number (fulls plus partials) > 3*MINREF, then include
C     partials
C
          IF (NREFT.GE.3*MINREF) THEN
            WRITE(IOUT,FMT=6060) NREF,PTMIN,MINREF
            IF (ONLINE) WRITE(ITOUT,FMT=6060) NREF,PTMIN,MINREF
 6060     FORMAT(/,1X,'**** WARNING ****',/,1X,'There are only',
     +    I4,' fully recorded reflections in',/,1X,'the central ',
     +    'region, so partials will be included in refinement.',/,1X,
     +    'This is equivalent to including keywords: REFINEMENT ',
     +    'INCLUDE PARTIALS',F4.1,/,1X,'To avoid including partials',
     +    ' you may change the minimum number of reflections',/,1X,
     +    '(currently',I3,') using keywords REFINEMENT NREF 12 say,',
     +    ' or reduce',/,1X,'the threshold using keywords REFINEMENT',
     +    ' NSIG 10 say.')
            PARTLS = .TRUE.
            GOTO 20
          ELSE
C
C---- otherwise expand central limit if possible
C
            IF (LIMIT.LT.XMAX) THEN
              LIMIT = LIMIT + 500
              IF (VEE) VLIMIT = VLIMIT + 500
              XLIMIT = LIMIT
              VXLIMIT = VLIMIT
              WRITE(IOUT,FMT=6063) NREF,NREFT,3*MINREF,2*LIMIT/100
              IF (ONLINE) WRITE(ITOUT,FMT=6063) NREF, NREFT, 3*MINREF,
     +                    2*LIMIT/100
              GOTO 20
 6063         FORMAT(/,1X,'***** WARNING ****',/,1X,'Only',I4,' ',
     +        'fully recorded reflections within central region.',/,1X,
     +        'There are only',I5,' reflections even including ',
     +        'partials (which is less than 3*MINREF,',I4,')',/,1X,
     +        'so increas size of central area to',I4,' mm square.')
            ELSE
C
C---- Cannot expand limit any further, include partials
C
              WRITE(IOUT,FMT=6060) NREF,PTMIN,MINREF
              IF (ONLINE) WRITE(ITOUT,FMT=6060) NREF,PTMIN,MINREF
              PARTLS = .TRUE.
              GOTO 20
            END IF
          END IF
        ELSE
C
C---- IF not using ADDPART, try decreasing PTMIN (to a minimum of 0.01)
C
          IF (.NOT.ADDPART) THEN
            IF (PTMIN.LE.0.01) THEN
              WRITE(IOUT,FMT=6061)
              IF (ONLINE) WRITE(ITOUT,FMT=6061)
 6061         FORMAT(1X,'Still cannot find enough reflections ')
C
C---- otherwise expand central limit if possible
C
              IF (LIMIT.LT.XMAX) THEN
                LIMIT = LIMIT + 500
                IF (VEE) VLIMIT = VLIMIT + 500
                XLIMIT = LIMIT
                VXLIMIT = VLIMIT
                WRITE(IOUT,FMT=6063) NREF,NREFT,3*MINREF,2*LIMIT/100
                IF (ONLINE) WRITE(ITOUT,FMT=6063) NREF, NREFT,3*MINREF,
     +                    2*LIMIT/100
                GOTO 20
              ELSE
C
C---- Cannot expand limit any further, give up (drops down to 6020 below)
C
cdms05.1999     Added following GO TO to avoid loop.
                 GO TO 201
              END IF
            END IF
            SPTMIN = PTMIN
            PTMIN = PTMIN - 0.1
            IF (PTMIN.LT.0.01) PTMIN = 0.01
            WRITE(IOUT,FMT=6062) SPTMIN,PTMIN
            IF (ONLINE) WRITE(ITOUT,FMT=6062) SPTMIN,PTMIN
 6062       FORMAT(/,1X,'**** WARNING ****',/,1X,'Still too few ',
     +      'reflections, changing minimum fraction recorded',/,1X,
     +      'for partials from',F5.2,' to',F5.2)
            GOTO 20
          END IF
        END IF
cdms05.1999   Added label needed for GOTO above.
 201    CONTINUE
        NWRN = NWRN + 1           
        WRITE (IOUT,FMT=6020)

 6020 FORMAT(///1X,'****** FATAL ERROR *******',/1X,'There are no FUL',
     +    'LY recorded spots in central area of image',/1X,'If this ',
     +   'is really true, either include partials in the refinement',
     +   /,1X,'by adding keywords: REFINEMENT INCLUDE PARTIALS',/,1X,
     +   'or if the cell is small, change the size of this area using',
     +   ' the REFINEMENT LIMIT x keywords')
        IF (ONLINE) WRITE (ITOUT,FMT=6020)
        NSHUTERR = 1
        CALL SHUTDOWN(CALLEDFROM,LENSTR(CALLEDFROM))
      END IF
C
C          **********************
      CALL SORTUP3(NREF,X,Y,IRECNO)
C          **********************
C
      HWX = NXS/2
      HWY = NYS/2
      NXY = NXS*NYS
C
      MAXW = (NXY+1)/2
      IF (IMGP) MAXW = NXY
      MAXB = 2*MAXW
      IF (IMGP) MAXB = MAXW
      MAXN = 0.5*MAXBUFF/MAXW
      IF (MAXN.GT.100) MAXN = 100
C           
      NRSOLD = NRS
  210 IF (.NOT.DOPROFILE) NRS = 0
C
C---- Counters for number of reflections rejected as overloaded,
C     too close, too weak
C
      NOVER = 0
      NCLOSE = 0
      NWEAK = 0
      SUMBKG = 0.0
      NSUM = 0
      IF (VEE .AND. DOPROFILE) NRS = NRSOLD
      IHALF = (MAXREF+NRS)/2 + 2
C
C---- Modify IHALF to allow for case of offset detector, where direct beam
C     position may be actually at edge of detector !
C
      IF ((XCEN+LIMIT)*FACT.GT.NREC) THEN
        IHALF = 30 + REAL((XCEN+LIMIT)*FACT-NREC)/REAL(LIMIT*FACT)*30
        IF (DEBUG(6)) THEN
          WRITE(IOUT,FMT=6019) IHALF,NINT((XCEN+LIMIT)*FACT)
          IF (ONLINE) WRITE(ITOUT,FMT=6019)IHALF,NINT((XCEN+LIMIT)*FACT)
 6019     FORMAT(1X,'IHALF changed to',I5,' EDGE OF AREA AT RECORD',I3)
        END IF
      END IF
C
C
      DO 220 I = 1,NREF
        IWX(I) = NXS
  220 CONTINUE
C
C
      INDF = 1
      INDL = 1
      IFRST = 1
      ILAST = 0
      FULL = .FALSE.
  230 CONTINUE
C
C---- Get the start of the raster for the first spot or
C     for a spot after a gap
C
      IBLK = X(INDF) - HWX
C
C--- Test this is inside the scanned area (essential for offset detector,
C    the spot centre may lie on the detector but edge of measurement box 
C    may not.
      IF ((IBLK.LT.XSCMIN).OR.(IBLK.GT.XSCMAX)) THEN
        WRITE(IOUT,FMT=6021) IBLK,INDF,X(INDF),HWX
        IF (ONLINE) WRITE(ITOUT,FMT=6021) IBLK,INDF,X(INDF),HWX
 6021 FORMAT(//1X,'** FATAL ERROR **',/,1X,'When finding reflections ',
     +    'for refinement (CENTRE)',/,1X,'part of the measurement ',
     +    'box lies outside the scanned region of the image',/,
     +    1X,'(trying to read record',I10,')',/,1X,'Restrict the ',
     +    'size of the search area for spots using the:',/,1X,
     +    'REFINEMENT LIMIT x',/,1X,
     +    'keywords which will set the search box size to "x" mm',
     +    ' on either side',/,1X,'of the direct beam')
        NSHUTERR = 2
        CALL SHUTDOWN(CALLEDFROM,LENSTR(CALLEDFROM))
      END IF

C
C---- Test if sorted spot has to be included in
C     this scan
C
C      ****************
  240  CALL RDBLK(IBLK)
C      ****************
C
  250 IF (INDL.EQ.NREF) GO TO 260
      IF (FULL) GO TO 260
      IF (IBLK.LT.X(INDL+1)-HWX) GO TO 260
      INDL = INDL + 1
      IF (INDL-INDF.EQ.MAXN-1) FULL = .TRUE.
      GO TO 250
C
C---- Get results from this scan and start the next one
C
  260 IBLK = IBLK + 1
C
C--- Test this is inside the scanned area (essential for offset detector,
C    the spot centre may lie on the detector but edge of measurement box 
C    may not.
C
      IF ((IBLK.LT.XSCMIN).OR.(IBLK.GT.XSCMAX)) THEN
        WRITE(IOUT,FMT=6021) IBLK
        IF (ONLINE) WRITE(ITOUT,FMT=6021) IBLK
        NSHUTERR = 3
        CALL SHUTDOWN(CALLEDFROM,LENSTR(CALLEDFROM))
      END IF
C---- Store optical densities for all spots included in this scan
C     the actual transfer of ods is done in the call to bswap
C
      IF (INDL.LT.INDF) GO TO 290
C
C
      DO 280 J = INDF,INDL
C
C---- MJ is pointer for reflection J, range 1 to MAXN
C
        MJ = MOD(J-1,MAXN) + 1
        IIY = Y(J)
        KMN = IIY - HWY
        KMX = IIY + HWY
        IF ((KMN.LT.1).OR.(KMX.GT.IYLEN)) THEN
          WRITE(IOUT,FMT=6023) KMN,KMX
          IF (ONLINE) WRITE(ITOUT,FMT=6023) KMN,KMX
 6023 FORMAT(//1X,'** FATAL ERROR **',/,1X,'When finding reflections ',
     +   'for refinement (CENTRE)',/,1X,'part of the measurement ',
     +   'box lies outside the scanned region of the image',/,
     +   1X,'(pixel limits in Y are',2I5,')',/,1X,'Restrict the ',
     +    'size of the search area for spots using the:',/,1X,
     +    'REFINEMENT LIMIT x',/,1X,
     +    'keywords which will set the search box size to "x" mm',
     +    ' on either side',/,1X,'of the direct beam')
        NSHUTERR = 4
          CALL SHUTDOWN(CALLEDFROM,LENSTR(CALLEDFROM))
        END IF
        IF (J.NE.IFRST) GO TO 270
C
C---- If this reflection has just started,
C     set byte pointer (PNTR) into BB.
C
C---- NJ is byte pointer to start address for reflection J (MJ)
C
C---- PNTR(J) gives current address in BB for relection J  (MJ)
C
        NJ = (MJ-1)*MAXB
        PNTR(MJ) = NJ + 1
        IFRST = IFRST + 1
  270   IADDR = PNTR(MJ)
C
C            ********************
        CALL BSWAP(KMN,KMX,IADDR)
C            ********************
C
C---- note IADDR is incremented in BSWAP
C
C---- Add in second part for summed partials
C
        IF (ADDPART.AND.(IRECNO(J).LT.0)) THEN
C
C  Reset IADDR (incremented in BSWAP)
          IADDR = IADDR - (KMX - KMN + 1)
C               *******************
          CALL BSWAP2(KMN,KMX,IADDR)
C               *******************
        END IF
C
        PNTR(MJ) = IADDR
        IWX(J) = IWX(J) - 1
  280 CONTINUE
  290 CONTINUE
C
C---- Check if one or more spots are finished
C
      IF (IWX(INDF).EQ.0) GO TO 300
C
      IF (INDF.LE.INDL) GO TO 240
      FULL = .FALSE.
      GO TO 230
C
  300 IND = ILAST*MAXW + 1
C
C  Use measurement box if USEBOX is true
C
      IF (USEBOX) THEN
C
C---- Extract degree of partiality for CGFIT
C
        II = IRECNO(INDF)
        IF (II.LT.0) II = -II
        IPART = IMG(II)
        IF (ADDPART) IPART = 0
C            **************************************
        CALL CGFIT(IARR(IND),IRAS,+1,DELX,DELY,SOD,SDELX,SDELY,IPART,
     +             IFLAG)
C            **************************************
        IBACK = NINT(BACK)
      ELSE
C          **********************************************************
         CALL CGFIND(IARR(IND),1,NXS,NYS,DELX,DELY,SOD,ODVAR,MINOD,NBKG,
     +            IBACK,NPOVER,IFLAG)
C          **********************************************************
      END IF
C
C
      IF (DEBUG(6)) THEN
        IF (ONLINE) WRITE (ITOUT,FMT=6022) INDF,X(INDF),Y(INDF),NPOVER,
     +      SOD,IRECNO(INDF),IPART,IFLAG
 6022 FORMAT (1X,'INDF=',I4,' X,Y',2I6,'  NPOVER=',I3,'  SOD=',F10.1,
     +        ' IRECNO',I5,' IPART',I4,' IFLAG',I3)
        WRITE (IOUT,FMT=6022) INDF,X(INDF),Y(INDF),NPOVER,SOD,
     +                        IRECNO(INDF),IPART,IFLAG
C                 ********************************
        IF (SPOT) CALL ODPLOT(IARR(IND),NXS,NYS,1)
C                 ********************************
      END IF            
C
C
C---- Reject reflections with too steep gradient
C     (only tested with CGFIT).
      IF (IFLAG.EQ.1) THEN
        NBGBADG = NBGBADG + 1
        GOTO 340
      END IF
C---- Reject reflections with too many background points rejected
C     (only tested with CGFIT)
      IF (IFLAG.EQ.2) THEN
        NBGBAD = NBGBAD + 1
        GOTO 340
      END IF
C
C---- Reject reflections containing zero value pixels (outside scanned
C     area)
      IF (IFLAG.EQ.3) THEN
        NZPBAD = NZPBAD + 1
        GOTO 340
      END IF

C---- Reject overloaded spots (flagged with sod=-9999.)
C     if calculating profile, check NPOVER explicitly as
C     NPMAX may have been changed to find enough refinement spots
C
      IF ((IFLAG.EQ.4).OR.(DOPROFILE.AND.(NPOVER.GT.NOVPIX))) THEN
        NOVER = NOVER + 1
        GO TO 340
      END IF
C
C---- No tests needed if using reflection list from previous film
C
      IF (GENLIST) GO TO 310
C
C---- Form sum for average background level
C
      SUMBKG = SUMBKG + IBACK
      NSUM = NSUM + 1
C
C---- Test on minimum intensity using sigma calculated from
C     counting statistics (Selwyn granularity for film)
C     the variance of the spot ods must be greater than
C     NSIG*SIGMA on the first pass or 0.666*NSIG*SIGMA on the second,
C     where SIGMA is calculated using the average od
C     over the whole spot. NSIG defaults to 6, but can be changed
C     by keyword NSIG
C     When using CGFIT rather than CGFIND, ie using the mask to
C     determine the c. of g., the selection test is that the average
C     background subtracted pixel value for pixels in the peak must
C     be gt NSIG times the sigma value for the background (calculated
C     from counting statistics)
C **** Changed 5/3/97 to use I/sig(I) instead when using CGFIT, NSIG
C     now initialised to 20.
C
      IF (USEBOX) THEN
        IF (SOD.LT.0.0) SOD = 0.0
CAL        AVOD = SOD/NPEAK
CAL        ODSIG = AVOD
CAL        CALCSIG = SQRT(GAIN*BACK)
C
C---- Try using I/sig(I) instead
C
        BGND = BACK*NPEAK
        VARTOT = GAIN*(SOD+BGND+BGND*NPEAK/NBKG)
        IF (VARTOT.LT.0) VARTOT = 0.0
        CALCSIG = SQRT(VARTOT)
        ODSIG = SOD
      ELSE
        ODSIG = SQRT(ODVAR)
        AVOD = SOD/NXY
        CALCVAR = (AVOD+MINOD)*GAIN
        CALCSIG = SQRT(CALCVAR)
      END IF
      IF (DEBUG(6)) THEN
        WRITE (IOUT,FMT=6024) X(INDF),Y(INDF),DELX,DELY,
     +    AVOD,MINOD,IBACK,ODSIG,CALCSIG
 6024 FORMAT (1X,'X=',I5,' Y=',I5,' DELX,DELY',2F5.1,' AVOD=',F6.1,' M',
     +       'INOD=',I4,' IBACK=',I4,'  ODSIG=',F8.1,'  CALCSIG=',F6.1)
        IF (ONLINE) WRITE (ITOUT,FMT=6024) X(INDF),Y(INDF),DELX,DELY,
     +    AVOD,MINOD,IBACK,ODSIG,CALCSIG
      END IF
C
C
      IF (ODSIG.LT.NSIG*CALCSIG) THEN
        NWEAK = NWEAK + 1
        GO TO 340
      END IF
C
C
      IF ((.NOT.VEE) .AND. DOPROFILE) GO TO 310
C
C---- Spots seperated by > 4 mm
C
      IF (ABS(X(INDF)-LASTX).GT.ISEPN) LASTY = 0
C
C
      IF (ABS(Y(INDF)-LASTY).LT.ISEPN) THEN
        NCLOSE = NCLOSE + 1
        GO TO 340
      END IF
C
C---- Limit number of spots on lhs of film
C
      IF (NRS.GT.IHALF .AND. X(INDF).LT.XCEN*FACT) GO TO 340
C
      IF (NRS.EQ.MAXREF) GO TO 360
C
C
C---- Store ods for average spot profile
C
  310 IF (DOPROFILE) THEN
C
C---- Exclude partials if possible
C
        IF (EXPART.AND.((IRECNO(INDF).LT.0).AND.(.NOT.ADDPART)))
     +                                               GOTO 340
C
        NPROFL = NPROFL + 1                                   
C
C     Expand into an integer*2 array - this comment is wrong - BEXPAN4
C     expands into an I*4 array.
C
        CALL BEXPAN4(IARR(IND),IWORK,NXY)
C
        DO 320 II = 1,NXY
          IODPROF(II) = IWORK(II) + IODPROF(II)
  320   CONTINUE
C
C
        GO TO 340
      END IF
C
C
      NRS = NRS + 1
      LASTX = X(INDF)
      LASTY = Y(INDF)
      XRS(NRS) = (X(INDF)+DELX)/FACT
      YRS(NRS) = (Y(INDF)+DELY)/FACT
      RRS(NRS) = IRECNO(INDF)
      WXRS(NRS) = SDELX/FACT
      WYRS(NRS) = SDELY/FACT
      IF (DEBUG(6)) THEN
       WRITE(IOUT,6025) NRS,XRS(NRS),YRS(NRS),SDELX/FACT,SDELY/FACT
       IF (ONLINE) WRITE(ITOUT,6025) NRS,XRS(NRS),YRS(NRS),
     +                               SDELX/FACT,SDELY/FACT
 6025  FORMAT(1X,'Stored as refinement reflection number',I5,' XRS',
     +    F8.1,' YRS',F8.1,'  SIGX,SIGY',2F7.2)
      END IF
C
C---- Store indices if pattern matching
C
      IF (MATCH) THEN
        JREC = IRECNO(INDF)
        IF (JREC.LT.0) JREC = -JREC
C
C
          IHKLR(1,NRS) = IHG(JREC)
          IHKLR(2,NRS) = IKG(JREC)
          IHKLR(3,NRS) = ILG(JREC)
C
C
      END IF
C
C
  340 ILAST = ILAST + 1
      IF (ILAST.EQ.MAXN) ILAST = 0
C
C---- Skip these tests for reflection list from previous film
C
      IF (GENLIST) GO TO 350
C
C---- Test for films with high background (eg intense synchrotron
C     films). If 25% of reflections have been measured, and
C     lt (MINREF/4) refinement spots found, then change NSIG on basis of
C     average background and start over again
C     As this is essentially a dynamic range problem, it should not
C     occur with image plates.
C
      IF (INDF.EQ.NREF/4.AND.(NRS.LT.MINREF/4).AND.(.NOT.IMGP)) THEN
        NN = INDF - NOVER
        IF (NN.NE.0) AVBKG = SUMBKG/NN
C
C
        IF (AVBKG.GT.140 .AND. NSIG.GT.4) THEN
          NSIG = 4                            
          WRITE (IOUT,FMT=6026) AVBKG,NSIG
 6026 FORMAT (//1X,'****** WARNING *****',/1X,'Average background in c',
     +       'entral region is ',F5.1,/2X,'and therefore NSIG has bee',
     +       'n reduced to',I3,' to help find refinement spots')
          IF (ONLINE) WRITE (ITOUT,FMT=6026) AVBKG,NSIG
          GO TO 210
        ELSE IF (AVBKG.GT.180 .AND. NSIG.GT.2) THEN
          NSIG = 2
          WRITE (IOUT,FMT=6026) AVBKG,NSIG
          IF (ONLINE) WRITE (ITOUT,FMT=6026) AVBKG,NSIG
          GO TO 210
        END IF
      END IF
C
C
  350 INDF = INDF + 1
      IF (INDF.LE.NREF) GO TO 290
  360 CONTINUE
C
C---- All reflections found
C
      IF (DOPROFILE) THEN
        IF (NPROFL.GT.0) THEN
          IF (EXPART) THEN
            WRITE (IOUT,FMT=6028) NPROFL
            IF (ONLINE) WRITE (ITOUT,FMT=6028) NPROFL
 6028 FORMAT (/1X,I4,' Reflections included in AVERAGE SPOT PROFILE')
          ELSE
            WRITE (IOUT,FMT=6029) NPROFL,NPARTL
            IF (ONLINE) WRITE (ITOUT,FMT=6029) NPROFL,NPARTL
 6029 FORMAT (/1X,I4,' Reflections included in AVERAGE SPOT PROFILE',
     +         ' including',I4,' partials')
          END IF
        ELSE
          WRITE (IOUT,FMT=6030)
 6030 FORMAT (//1X,'** NO reflections for AVERAGE SPOT PROFILE **')
          IF (ONLINE) WRITE (ITOUT,FMT=6030)
        END IF
        RETURN
      END IF
C
C
      IF (NZPBAD.GT.0) THEN
          WARN(14) = .TRUE.
          WRITE (IOUT,FMT=6070) NZPBAD,NULLPIX
 6070     FORMAT (//1X,I3
     $         ,' reflections have been rejected because the '
     $         ,' measurement box contains',/,1X
     $         ,'pixels with values less or equal to',I5,
     +         ' (assumed to '
     $         ,'be outside the scanned area).',/,1X,
     +        'See warning at end of logfile or in summary file.')
          IF (ONLINE) WRITE (ITOUT,FMT=6070) NZPBAD,NULLPIX
      END IF
      IF (NBGBAD.NE.0) THEN
          WRITE (IOUT,FMT=6031) NBGBAD,BGFREJ
 6031 FORMAT (//1X,I3,' reflections rejected because more than a ',
     1    'fraction',F5.2,' of the background pixels were rejected')
          IF (ONLINE) WRITE (ITOUT,FMT=6031) NBGBAD,BGFREJ
      END IF
      IF (NBGBADG.NE.0) THEN
          WRITE (IOUT,FMT=6033) NBGBADG,GRADMAXR
 6033 FORMAT (//1X,I3,' reflections rejected because the gradient',
     1    '/background is greater then',F6.3)
          IF (ONLINE) WRITE (ITOUT,FMT=6033) NBGBADG,GRADMAXR
      END IF
      IF (NRS.GE.MINREF) RETURN
C
C---- Problems... less than MINREF reflections found
C
      NWRN = NWRN + 1
      WRITE (IOUT,FMT=6032) NRS,NOVER,NWEAK,NSIG,NCLOSE
 6032 FORMAT (/1X,'ONLY',I3,' Suitable reflections found',/1X,'There a',
     +       're',I5,' OVERLOADS',I5,' TOO WEAK (NSIG=',I3,') and',I5,
     +       ' TOO CLOSE')
      IF (ONLINE) WRITE (ITOUT,FMT=6032) NRS,NOVER,NWEAK,NSIG,NCLOSE
C
C---- See if reducing spot separation criterion helps
C
      NPOSS = (NREF-NOVER-NWEAK)
      IF (NCLOSE.GT.MINREF/5) THEN
        SEP = 0.5*SEP
        ISEPN = FACT*SEP*100.0
        WRITE (IOUT,FMT=6034) SEP
 6034 FORMAT (1X,'Spot separation test reduced to ',F3.1,' mm')
        IF (ONLINE) WRITE (ITOUT,FMT=6034) SEP
C
C---- Ensure half of remaining reflections are on each side
C
        IF (NPOSS.LT.MAXREF) THEN
          IHALF = NPOSS/2 + 2
          IF (VEE) IHALF = (NPOSS+NRS)/2 + 2
        END IF
C
C
        GO TO 210
C
C     If this is because there are many overloads, allow up to
C     five times the previous limit on the pixels in the peak which can be
C     overloaded before rejecting the reflection.
C     Note NPMAX is passed in common /OVRLD/ to CGFIND,CGFIT
C
      ELSE IF (NOVER.GT.NREF/2 .AND. NPMAX.LT.NOVPIX*5) THEN
        USEOVRLD = .TRUE.
        NPMAX = NOVPIX*5
        WRITE (IOUT,FMT=6036) NPMAX,CUTOFF
 6036 FORMAT (1X,'TOO MANY OVERLOADS in Central box',/1X,'Allow up to',
     +       I3,' Pixels with values greater than',I6,' before ',
     +          'flagging as',
     +       ' overloaded',/2X,'These reflections will not be included',
     +       ' in the AVERAGE SPOT PROFILE ')
        IF (ONLINE) WRITE (ITOUT,FMT=6036) NPMAX,CUTOFF
        GO TO 210
C
C---- Have not got 3*MINREF possible reflections.
C---- If this is because they are all overloads, expand central box,
C     providing it is smaller than the detector size, but before doing this
C     try including partials if this is not already being done
C
      ELSE IF (NREF-NOVER.LT.3*MINREF) THEN
        IF (.NOT.PARTLS) THEN
C
C---- Intensity rejection criterion too high, reduce it (but only down
C     to NSIG=5)
C
          IF (NSIG.GT.5) THEN
            NSIG = NINT(0.666*NSIG)
            WRITE (IOUT,FMT=6040) NSIG
            IF (ONLINE) WRITE (ITOUT,FMT=6040) NSIG
            GO TO 210
          END IF
C
C---- If total number (fulls plus partials) > 3*MINREF, then include
C     partials
C
          IF (NREFT.GE.3*MINREF) THEN
            WRITE(IOUT,FMT=6060) NREF,PTMIN,MINREF
            IF (ONLINE) WRITE(ITOUT,FMT=6060) NREF,PTMIN,MINREF
            PARTLS = .TRUE.
            GOTO 20
          ELSE
C
C---- otherwise expand central limit if possible
C
            IF (LIMIT.LT.XMAX) THEN
              LIMIT = LIMIT + 500
              IF (VEE) VLIMIT = VLIMIT + 500
              XLIMIT = LIMIT
              VXLIMIT = VLIMIT
              WRITE(IOUT,FMT=6063) NREF,NREFT,3*MINREF,2*LIMIT/100
              IF (ONLINE) WRITE(ITOUT,FMT=6063) NREF, NREFT, 3*MINREF,
     +                    2*LIMIT/100
              GOTO 20
            ELSE
C
C---- Cannot expand limit any further, include partials
C
              WRITE(IOUT,FMT=6060) NREF,PTMIN,MINREF
              IF (ONLINE) WRITE(ITOUT,FMT=6060) NREF,PTMIN,MINREF
              PARTLS = .TRUE.
              GOTO 20
            END IF
          END IF
        ELSE
C
C---- IF not using ADDPART, try decreasing PTMIN (to a minimum of 0.01)
C
          IF (.NOT.ADDPART) THEN
            IF (PTMIN.EQ.0.01) GOTO 370
            SPTMIN = PTMIN
            PTMIN = MAX(0.01,PTMIN-0.1)
            WRITE(IOUT,FMT=6062) SPTMIN,PTMIN
            IF (ONLINE) WRITE(ITOUT,FMT=6062) SPTMIN,PTMIN
            GOTO 20
          END IF
        END IF

 370    IF (LIMIT.LT.XMAX) THEN
          LIMIT = LIMIT + 500
          IF (VEE) VLIMIT = VLIMIT + 500
          XLIMIT = LIMIT
          VXLIMIT = VLIMIT
          WRITE (IOUT,FMT=6038) 3*MINREF,2*LIMIT/100
 6038 FORMAT (1X,'Fewer than',I3,' NON-OVERLOADED Reflections in cen',
     +       'tral box',/1X,'Expand central area to',I4,' mm square.')
          IF (ONLINE) WRITE (ITOUT,FMT=6038) 3*MINREF,2*LIMIT/100
          IF (GENLIST) GOTO 90
          GO TO 20
        ELSE
          WRITE (IOUT,FMT=6039) 3*MINREF,MINREF
          IF (ONLINE) WRITE (ITOUT,FMT=6039) 3*MINREF,MINREF
 6039     FORMAT(1X,'Fewer than',I3,' NON-OVERLOADED Reflections on ',
     +        'entire detector !!',/,1X,'Possible courses of action:',
     +        /,1X,'1) Include overloads in refinement:',/,1X,
     +        'REFINEMENT INCLUDE OVERLOADS',//,1X,'2) Include ',
     +        'partials in refinement:',/,1X,
     +        'REFINEMENT INCLUDE PARTIALS',//,1X,'3) Reduce the',
     +        ' minimum acceptable number of reflections for ',
     +        'refinement',/,1X,'(Currently',I3,'):',/,1X,
     +        'REFINEMENT NREF 10 (say)')
          NSHUTERR = 5
          CALL SHUTDOWN(CALLEDFROM,LENSTR(CALLEDFROM))
        END IF
      ELSE
C
C---- Intensity rejection criterion too high, reduce it (but only down
C     to NSIG=1)
C
        IF (NSIG.EQ.1) RETURN
        NSIG = NINT(0.666*NSIG)
        WRITE (IOUT,FMT=6040) NSIG
 6040 FORMAT (1X,'NSIG Reduced to',I3,' Repeating search')
        IF (ONLINE) WRITE (ITOUT,FMT=6040) NSIG
        GO TO 210
      END IF
      RETURN
      END
C
C $Id: dstar.f,v 1.10 2008/10/22 08:51:58 andrew Exp $
C
C== DSTAR ==
C
      SUBROUTINE DSTAR(IP,IQ,IR,KT,KH,DELEPS1,DELEPS2,PHI,PHIW,DRATIO)
C     ================================================================
      IMPLICIT NONE
C
C---- Routine tests spot IP,IQ,IR with lab coord of X12,Y12,Z12
C     (dimensionless rlu's)
C          KT   = -4  Spot is entirely within cusp
C               = -3  Spot is within cusp, but part of rlp touches Ewald
C                     sphere so spot will be observed
C               = -2  Spot has DSTAR .GT. DSTARPLUS (DSTPL)
C               = -1  Spot not recorded
C               =  0  Good spot
C
C          KH   =  0  Full spot
C               =  21  Spot present on 2 images, this is 1st
C               =  22  Spot present on 2 images, this is 2nd
C
C               =  31  Spot present on 3 images, this is 1st
C               =  32  Spot present on 3 images, this is 2nd
C               =  33  Spot present on 3 images, this is 3rd
C
C               =  41  Spot present on 4 images, this is 1st
C               =  42  Spot present on 4 images, this is 2nd
C               =  43  Spot present on 3 images, this is 3rd
C               =  44  Spot present on 4 images, this is 4th
C
C                 etc etc
C
C               =   3  Extends over too many images (more than NWMAX
C                      which can be set by keyword MAXWIDTH)
C
C          DELEPS1   Fraction of spot remaining to pass through Ewald
C                    sphere at start of oscillation.
C          DELEPS2   Fraction of spot that has already passed through
C                    Ewald sphere at end of oscillation.
C          PHI      Phi value when rlp is on the Ewald sphere
C          PHIW     Reflection width
C
C     Passed through common /REEKE/
C     X1,Y1,Z1 - Lab coord at PHI1 (dimensionless rlu's)
C     X2,Y2,Z2 - Lab coord at PHI2 (dimensionless rlu's)
C
C
C       debug(38) this s/r
C
C     .. Scalar Arguments ..
      REAL DELEPS1,DELEPS2,DRATIO,PHI,PHIW
      INTEGER IP,IQ,IR,KH,KT
C     ..
C     .. Local Scalars ..
      DOUBLE PRECISION ARG1,CEA,CEB,CEC,CEABSQ,XE1D,XE3D
      REAL ADEL1,ADEL2,CSIMIN2,DEL1,DEL2,DIST2,DIVERG,DST4,ESYNH,ESYNV,
     +     RSPOT,X1S,Y1S,Y2S,YMID,YMS,Z1S,PHIC,XE1,XE3,
     +     T1,T2,T3,RLORF,OSCRNG,PHIS,
     +     PHIE,PHIA,PHIB,RMIDPHI,DIFF1,DIFF2,DSTR
      INTEGER ISY,ICOUNT,I,ISTART,IEND,IWIDTH
C     ..
C     .. Local Arrays ..
      REAL E1(3),E2(3),E3(3),XRLP(3),XRLPE(3),PHICR(3,3),E3S0(3)
C     ..
C     .. External Functions ..
      REAL DOT
      EXTERNAL DOT
C     ..
C     .. External Subroutines ..
      EXTERNAL CROSS,UNIT,SURMP,MATVEC
C     ..
C     .. Intrinsic Functions ..
      INTRINSIC ABS,NINT,SIGN,SQRT
C     ..
C     .. Common blocks ..
C&&*&& include  ../inc/debug.f
C
C $Id: debug.f,v 1.2 2008/07/24 09:42:21 andrew Exp $
C
C--- awk generated include file  debug.h
C---- START of include file debug.h
C
C
C
C     .. Arrays in common /DEBUG/ ..
      REAL XWARN
      INTEGER NDEBUG,IWARN
      LOGICAL DEBUG,LPRINT,DUMP,WARN
C
C     .. Scalars in common /DEBUG/ ..
      REAL BGRLIM
      INTEGER NDUMP,IDUMP,MXDUMP
      LOGICAL SPOT
C     
C     ..
C     .. Common Block /DEBUG/..
      COMMON /DEBUG/XWARN(20,100),BGRLIM,NDEBUG(100),IWARN(20,100),
     $       NDUMP,IDUMP,MXDUMP,DEBUG(100),LPRINT(20),DUMP(30),
     +       WARN(100),SPOT
C     ..
C
C&&*&& end_include  ../inc/debug.f
C&&*&& include  ../inc/ioo.f
C
C $Id: ioo.f,v 1.7 2009/05/13 11:57:53 harry Exp $
C
C--- awk generated include file  ioo.h
C---- START of include file ioo.h
C
C
C
C     .. Scalars in common block /IOO/ ..
      INTEGER IOUT,IUNIT,ITIN,ITOUT,INOD,INMO,IDU,NWRN,IBRIEF,ISUMMR,
     +        ICOORD,SERVERFD,SERVERFDIN,NSHUTERR,dnafd
      LOGICAL ONLINE,ONEFILE,FHEADER,BRIEF,GRAPH,IOERR,
     $     NODISPLAY,LBELL,JPGOUT,SOCKLO,LBEST,dnaout,INMOOPEN,
     $     XMLOPEN
      CHARACTER dna_image*80,xmlfile*80
C     ..
C     .. Common block /IOO/ ..
c      COMMON /IOO/IOUT,IUNIT,ONLINE,ITIN,ITOUT,INOD,INMO,IDU,NWRN,
c     +            ONEFILE,FHEADER,BRIEF,IBRIEF,GRAPH,ISUMMR,ICOORD,
c     +            IOERR,NODISPLAY,LBELL
C     ..
C
C
      COMMON /IOO/IOUT,IUNIT,ITIN,ITOUT,INOD,INMO,IDU,NWRN,IBRIEF,
     +        ISUMMR,ICOORD,SERVERFD,SERVERFDIN,NSHUTERR,ONLINE,ONEFILE,
     +        FHEADER,BRIEF,GRAPH,IOERR,NODISPLAY,LBELL,JPGOUT,
     $        SOCKLO,LBEST, dnafd, dnaout,INMOOPEN,XMLOPEN
      COMMON /CIOO/dna_image,xmlfile

C&&*&& end_include  ../inc/ioo.f
C&&*&& include  ../inc/misc.f
C
C $Id: misc.f,v 1.2 2009/09/03 16:24:33 harry Exp $
C
C--- awk generated include file  misc.h
C---- START of include file misc.h
C
C
C
C     .. Scalars in common /MISC/ ..
      REAL PHIBEG,PHIEND,PHIRNG,RMIN,RMAX,WAVE
      INTEGER IPACKID,MININT,IERRFLG
C     ..
C     .. Arrays in common /MISC/ ..
      REAL DELPHI,RESANI
      INTEGER IAX
C     ..
C     .. LOGICAL
      LOGICAL ANITES

C     ..
C     .. Common Block /MISC/ ..
      COMMON /MISC/DELPHI(3),RESANI(3),PHIBEG,PHIEND,PHIRNG,RMIN,RMAX,
     $       WAVE,IAX(3),IPACKID,MININT,IERRFLG,ANITES
C     ..
C
C
C&&*&& end_include  ../inc/misc.f
C&&*&& include  ../inc/reeke.f
C
C $Id: reeke.f,v 1.15 2008/10/22 08:50:48 andrew Exp $
C
C--- awk generated include file  reeke.h
C---- START of include file reeke.h
C
C     TOR     For synchrotron sources, degree of polarisation of the beam
C     IMONO   Collimation flag for polarisation.
C             = 0   Pinhole or mirrors
C             = 1   Graphite Monochromator
C             = 2   Synchrotron, use TOR
C     NWMAX   Maximum reflection width in images
C     DSTMAX  dimensionless rlu, = WAVE/RES where RES is the maximum
C             resolution in Angstrom.
C     DSTMIN  dimensionless rlu, = WAVE/DMAX where DMAX is the maximum
C              Bragg spacing
C     S0      radiation source vector (-1,0,0), may be modified by MU values
C     SOURCE  radiation source vector - basis for s0
C     GONIO_angle:  machine angles for generalized goniostats
C     GONIO_angle_SET: fixed offset angles for 3- and 4-circle goniostats
C                      i.e. currently 54.74 deg for Bruker CHI, 50.0deg for
C                      Nonius and Oxford KAPPA 
C     ..
C     .. Arrays in common block /REEKE/ ..
      REAL RMC,AMAT,SCAXIS,S0,s0unit,CAMCON,BEAMMU
C     ..
C     .. Scalars in common block /REEKE/ ..
      REAL X1,X2,Y1,Y2,Z1,Z2,XYS,DSTAR2,DSTMAX,DSTPL,DSTPL2,
     +     DIVH,DIVV,DELAMB,ETA,DELCOR,DSTMAXS,TOR,DSTMIN,WMAX,
     +     ETAFRAC,ETASM,
     $     GON_CHI,GON_PHIS,GON_KAPPA,GON_OMEGAS,GON_2THETA,
     $     GON_PHIE,GON_OMEGAE,
     +     GON_CHI_SET,GON_KAPPA_SET,
     +     BLKSIZE
      INTEGER ISYN,IMONO,NWMAX,IPAD,NSMOOTH,IGON_CHI,IGON_PHI,
     $     IGON_KAPPA,IGON_OMEGA,IGON_2THETA,
     +     IGON_CHI_SET,IGON_KAPPA_SET,IHOSCAXIS
C     ..
C     .. logicals in common block /REEKE/ ..
      LOGICAL LOGETA,NUREEK,LCAMCON,GENGON,FOURCIRCLE,THREECIRCLE
C     ..
C     .. Common Block /REEKE/ ..
      COMMON /REEKE/RMC(3,3),AMAT(3,3),SCAXIS(3),S0(3),s0unit(3),
     $     CAMCON(8),BEAMMU(2),X1,X2,Y1,Y2,
     +     Z1,Z2,XYS,DSTAR2,DSTMAX,DSTPL,DSTPL2,DIVH,DIVV,DELAMB,
     +     ETA,DELCOR,DSTMAXS,TOR,DSTMIN,WMAX,ETAFRAC,ETASM,
     $     GON_CHI,GON_PHIS,GON_KAPPA,GON_OMEGAS,GON_2THETA,
     $     GON_PHIE,GON_OMEGAE,
     +     GON_CHI_SET,GON_KAPPA_SET,ISYN,IMONO,
     $     NWMAX,IPAD,
     $     NSMOOTH,IGON_CHI,IGON_PHI,
     $     IGON_KAPPA,IGON_OMEGA,IGON_2THETA,
     +     IGON_CHI_SET,IGON_KAPPA_SET,IHOSCAXIS,LOGETA,NUREEK,LCAMCON,
     $     GENGON,FOURCIRCLE,THREECIRCLE,
     +     BLKSIZE
C     ..
C
C
C&&*&& end_include  ../inc/reeke.f
C&&*&& include  ../inc/trigparam.f
C 
C $Id: trigparam.f,v 1.3 2008/07/31 11:46:02 harry Exp $
C
C
C     Trigonometric parameters - set here to highly precise values, don't 
C     calculate in code; values from Clemens Vonrhein
C
C     DTOR.. convert degrees to radians
C     RTOD.. convert radians to degrees
C     PI..   value of PI
      REAL PI
      PARAMETER   ( PI = 3.1415926536 )
      REAL          TWOPI
      PARAMETER   ( TWOPI = 6.2831853072 )
      REAL RTOD
      PARAMETER   ( RTOD = 57.2957795131 )
      REAL          DTOR
      PARAMETER   ( DTOR = 0.0174532925 )
C DOUBLE PRECISION...
      DOUBLE PRECISION PI_DOUBLE
      PARAMETER ( PI_DOUBLE = 3.1415926535897932384626433832795029D0 )
      DOUBLE PRECISION TWOPI_DOUBLE
      PARAMETER ( TWOPI_DOUBLE = 
     $     6.2831853071795864769252867665590058D0 )
      DOUBLE PRECISION RTOD_DOUBLE
      PARAMETER ( RTOD_DOUBLE = 57.2957795130823208768D0 )
      DOUBLE PRECISION DTOR_DOUBLE
      PARAMETER ( DTOR_DOUBLE = 0.01745329251994329576D0 )
c

c
C&&*&& end_include  ../inc/trigparam.f
C     ..
      SAVE
      DATA ICOUNT/0/
C
C
      KH = 0
      KT = 0
      DELEPS1 = 0.0
      DELEPS2 = 0.0
      X1S = X1*X1
      Y1S = Y1*Y1
      Y2S = Y2*Y2
      Z1S = Z1*Z1
      XYS = X1S + Y1S
      DSTAR2 = XYS + Z1S
      DSTR = SQRT(DSTAR2)
C
C---- Calculate the phi value for this rlp to be on the Ewald sphere
C     This code based on MADNES Phase 3 notes, p62-64.
C     First set up a set of orthogonal axes:
C     E3 along rotation axis, ie 0,0,1
C     E2 perp to E3 and rlp at start of rotation X1,Y1,Z1
C     E1 perp to E2 and E3.
C
C     Set up beam vector S0 (dimensionless rlu's)
Chrp 12.10.2004 should be set up for COMMON REEK
C      S0(1) = -1.0
C      S0(2) = 0.0
C      S0(3) = 0.0
      E3(1) = 0.0
      E3(2) = 0.0
      E3(3) = 1.0
      XRLP(1) = X1
      XRLP(2) = Y1
      XRLP(3) = Z1
C
C---- E2 = [E3 x XRLP]/| E3 x XRLP |
C
      CALL CROSS(E2,E3,XRLP)
      CALL UNIT(E2)
C
C---- E1 = E2 x E3
C
      CALL CROSS (E1,E2,E3)
C
C---- Phi value for diffraction given by:
C     CEA *cos(phic) + CEB*sin(phic) = CEC
C     where:
C     CEA = (XRLP.E1) * (E1.S0)
C     CEB = (XRLP.E1) * (E2.S0)
C     CEC = 0.5*(XRLP.E1)**2 + 0.5*(XRLP.E3)**2 -(XRLP.E3)*(E3.S0)
C
      XE1 = DOT(XRLP,E1)
      XE3 = DOT(XRLP,E3)
      XE1D = DBLE(XE1)
      XE3D = DBLE(XE3)
      CEA = XE1D * DBLE(DOT(E1,S0))
      CEB = XE1D * DBLE(DOT(E2,S0))
      CEC = 0.5D0 * XE1D*XE1D + 0.5D0 * XE3D * XE3D - XE3D * 
     $     DBLE(DOT(E3,S0))
      CEABSQ = CEA**2 + CEB**2
C
C---- Skip if rlp lies on rotation axis
C
      IF (CEABSQ.LE.0.0) GOTO 10
C
      ARG1 = CEC/SQRT(CEABSQ)
      IF (ARG1.GT.1.0) ARG1 = 1.0D0
      IF (ARG1.LT.-1.0) ARG1 = -1.0D0
C
C---- Equation for PHIC has two solutions, we want the one within or closest
C     to the phi range. Choose the solution closest to the midpoint of the
C     phirange  
C
      OSCRNG = ABS(PHIEND-PHIBEG)
      RMIDPHI = 0.5*(PHIBEG+PHIEND)
      T1 = REAL(ACOS(ARG1))
      T2 = REAL(ATAN2(CEB, CEA))
C
C---- First solution
C
      PHIC = (T1 + T2)/DTOR
      PHIA = PHIBEG + PHIC
C
C---- Second solution
C
      PHIC = (-T1 + T2)/DTOR
      PHIB = PHIBEG + PHIC
C
      DIFF1 = ABS(PHIA-RMIDPHI)
      DIFF2 = ABS(PHIB-RMIDPHI)
      IF (DIFF1.LT.DIFF2) THEN
         PHI = PHIA
      ELSE
         PHI = PHIB
      END IF
C
C---- Now calculate reflection width. First need coordinates of rlp on
C     the Ewald sphere. Apply rotation of PHIC to XRLP.
C
      CALL SURMP(PHIC*DTOR,PHICR)
      CALL MATVEC(XRLPE,PHICR,XRLP)
C
C---- Lorentz factor = | 1.0/(XRLPE.[E3 x S0]) |
C
      CALL CROSS (E3S0,E3,S0)
      T3 = DOT(E3S0,XRLPE)
      RLORF = 0.0
      IF (T3.EQ.0.0) GOTO 10
      RLORF = ABS(1.0/T3)
C
C---- Is this necessary?
C
 10   IF (DSTAR2.EQ.0.0) THEN
         KT = -1
C
C---- Test dstar limit
C
      ELSE IF (DSTAR2.GT.DSTPL2) THEN
         KT = -2
      ELSE
C
C---- Calculate distance from sphere at beginning and end of rotation
C     Negative if within sphere
C
         DEL1 = SQRT((1.0+X1)**2+Y1S+Z1S) - 1.0
         DEL2 = SQRT((1.0+X2)**2+Y2S+Z1S) - 1.0
         ADEL1 = ABS(DEL1)
         ADEL2 = ABS(DEL2)
C     
         DST4 = DSTAR2**2*0.25
         YMID = (Y1+Y2)*0.5
         YMS = YMID*YMID
C
C---- Conventional source geometry
C
C  Radius of reciprocal lattice point along radius of Ewald sphere
C     RSPOT = 0.5*(DIVERGENCE+dispersion*tan(theta) )*DSTAR*COS(THETA)
C     and as DSTAR*COS(THETA) = SQRT(DSTAR**2-0.25*DSTAR**4)
C  Note that the divergence parameters DIVH,DIVV and the mosaic spread
C  are stored in the generate file as the FULL WIDTHS in degrees.
C  These are converted to HALF WIDTHS in radians prior to the prediction
C  calculations.
C  Add the contribution due to finite block size.
C
         IF (ISYN.EQ.0) THEN
            DIVERG = SQRT((DIVH**2*Z1S+DIVV**2*YMS)/ (YMS+Z1S))
            RSPOT = (DIVERG+ETA)*SQRT(DSTAR2-DST4) + 0.25*DELAMB*DSTAR2
     +               + 1.0/(DSTR*BLKSIZE)
         ELSE
C     
C---- Synchrotron source geometry
C
C  REF. J.APPL.CRYST. 15,493-508 GREENHOUGH & HELLIWELL
C  Note that the only difference to above is the inclusion of the
C  correlated dispersion term in the horizontal divergence.
C
            ESYNH = DELCOR*DSTAR2 + Z1*DIVH
            ESYNV = DIVV*YMID
            DIVERG = SQRT((ESYNH*ESYNH+ESYNV*ESYNV)/ (YMS+Z1S))
            RSPOT = (DIVERG+ETA)*SQRT(DSTAR2-DST4) + 0.25*DELAMB*DSTAR2
     +               + 1.0/(DSTR*BLKSIZE)
         END IF
C
C
C---- Reflection width is 2.0*RSPOT*RLORF
C
         PHIW = 2.0*RSPOT*RLORF/DTOR
         PHIS = PHI - 0.5*PHIW
         PHIE = PHIS + PHIW
C
C---- Find smaller ratio of distance of spot from sphere to spot radius.
C     This will be >1 for fulls, and is used as measure of "safeness" of
C     fulls in SCALA? (stored as FRACREJ in MTZ file).
C
         IF (RSPOT.NE.0.0) DRATIO = MIN(ADEL1/RSPOT,ADEL2/RSPOT)    
C
C---- Find over how many images this spot extends and which image this is.
C     NB Following code assumes rotation is positive phi, not negative
C
         DO 20 I = 1,NWMAX+1
            IF ((PHIBEG - (I-1)*OSCRNG).LE.PHIS) THEN
               ISTART = I
               GOTO 22
            END IF         
 20      CONTINUE
C
C---- Spot is too wide
C
         ISTART = NWMAX + 2
C
 22      DO 24 I = 1,NWMAX + 1
            IF ((PHIEND + (I-1)*OSCRNG).GE.PHIE) THEN
               IEND = I
               GOTO 26
            END IF         
 24      CONTINUE
C
C---- Spot is too wide
C
         IEND = NWMAX + 2
C
 26      IWIDTH = ISTART - 1 + IEND - 1 + 1
C
C---- Extra debug
C
         IF (DEBUG(38))
     +        THEN
            WRITE(IOUT,FMT=6010) IP,IQ,IR,PHI,PHIW,PHIS,PHIE,PHIBEG,
     +           PHIEND,OSCRNG,ISTART,IEND,IWIDTH,NWMAX
            IF (ONLINE) WRITE(ITOUT,FMT=6010) IP,IQ,IR,PHI,PHIW,PHIS,
     +           PHIE,PHIBEG,PHIEND,OSCRNG,ISTART,IEND,IWIDTH,NWMAX
 6010       FORMAT(1X,'HKL = ',3I4,' PHI=',F12.7,' width=',F12.7,
     +           ' start=',F12.7,' end=',F12.7,/,' osc start',F12.7,
     +           ' osc end',F12.7,' osc range',F9.6,' ISTART',I3,
     +           '  IEND',I3,/,1X,'IWIDTH',I3,'  NWMAX',I4)
         END IF
C
C
C---- Test for spot within cusp - Radius of spot is same in
C     plane perp to rot
C
C  Note that one should use the horizontal crossfire term here
C  CSIMIN = 0.5*DSTAR2 + RSPOT
C  CSIMIN2 = CSIMIN*CSIMIN = .25*DSTAR2*DSTAR2 + DSTAR2*RSPOT +RSPOT*RSPOT
C  Ignore RSPOT**2 term
C
         CSIMIN2 = RSPOT*DSTAR2 + DST4
C
C
         IF (XYS.LT.CSIMIN2) THEN
            KT = -3
C
C---- What should csimin test be ? The spot can still appear on image
C     even if the centre of the rlp never cuts the sphere (ie lies in
C     the cusp region) providing any part of the rlp touches the sphere.
C     In this case, the test on line below is the right one, but this
C     seems to overpredict in practice, so limit it to case where the
C     centre of the rlp must intersect the sphere.
CAL          IF (XYS.LT.(DST4-RSPOT*DSTAR2)) KT = -4
            IF (XYS.LT.DST4) KT = -4
         ELSE
C
C---- Calculate distance of edge of spot from sphere at end of rotation
C
            DIST2 = ADEL2 - RSPOT
C
C---- Test if spot is cut at beginning of rotation
C  Set DELEPS to a negative value - Fraction recorded set to 100.*DELEPS
C  Note sign change depending on whether Y is +ve or -ve
C
            IF (ADEL1-RSPOT.LE.0.0) THEN
               ISY = NINT(SIGN(1.0,Y1))
               DELEPS1 = - (ISY*DEL1/RSPOT+1.0)*0.5
C
C---- Spot cut at beginning - check for cut at both ends
C
               IF (DIST2.LT.0.0) THEN
                  ISY = NINT(SIGN(1.0,Y2))
                  DELEPS2 = (1.0-ISY*DEL2/RSPOT)*0.5
C
C----  Assign KH flag (see above)
C
                  IF (IWIDTH.GT.NWMAX) THEN
                     KH = 3
                  ELSE
                     KH = IPAD*IWIDTH + ISTART
                  END IF
               ELSE
C
C---- Spot only cut at beginning. 
C
                  IF (IWIDTH.GT.NWMAX) THEN
                     KH = 3
                  ELSE
                     KH = IPAD*IWIDTH + ISTART
                  END IF
              
               END IF
C
C---- Test if spot is only cut at end of rotation
C
            ELSE IF (DIST2.LE.0.0) THEN
               ISY = NINT(SIGN(1.0,Y2))
               DELEPS2 = (1.0-ISY*DEL2/RSPOT)*0.5
               IF (IWIDTH.GT.NWMAX) THEN
                  KH = 3
               ELSE
                  KH = IPAD*IWIDTH + ISTART
               END IF
            ELSE
C
C---- Spot is cut at neither end of rotation.
C     To be recorded spot must lie within one sphere
C     and outside the other
C
               IF (DEL1.LT.0) THEN
                  IF (DEL2.GE.0) GO TO 40
               ELSE IF (DEL2.LT.0) THEN
                  GO TO 40
               END IF
C
C
               KT = -1
 40            IF (DEBUG(38)) THEN
                  ICOUNT = ICOUNT + 1
                  IF (ICOUNT.EQ.1) THEN
                     WRITE(IOUT,FMT=6000) PHIBEG,PHIEND,WAVE,E1,E2,
     +                    E3,S0,IAX
                     IF (ONLINE) WRITE(ITOUT,FMT=6000) PHIBEG,
     +                    PHIEND,WAVE,E1,E2,E3,S0,IAX
 6000                FORMAT(1X,'IN DSTAR PHIBEG,PHIEND,WAVE',2F9.3,
     +                    F9.5,/,1X,'E1',3F10.5,/,1X,'E2',3F10.5,/,
     +                    1X,'E3',3F10.5,/,1X,'S0',3F10.5,/,1X,
     +                    'IP is index',I3,'  IQ is index',I3,
     +                    ' IR is index',I3)
                  END IF
                  IF (ICOUNT.LT.NDEBUG(38)) THEN
                     WRITE(IOUT,FMT=6002) IP,IQ,IR,XRLP,XRLPE,DSTAR2,KT,
     +                    KH,PHI,PHIS,PHIE,PHIW,RLORF,ISTART,IEND,
     +                    IWIDTH,DELEPS1,DELEPS2
                     IF (ONLINE) WRITE(ITOUT,FMT=6002) IP,IQ,IR,XRLP,
     +                    XRLPE,DSTAR2,KT,KH,PHI,PHIS,PHIE,PHIW,RLORF,
     +                    ISTART,IEND,IWIDTH,DELEPS1,DELEPS2
 6002                FORMAT(1X,'IP,IQ,IR',3I5,/,1X,'RLP coordinates at',
     +                    ' PHIBEG (dimensionless rlu)',3F10.5,/,1X,
     +                    'at the diffraction position',18X,3F10.5,/,1X,
     +                    'dstar,KT,KH',F10.5,2I4,/,1X,
     +                    'PHI (on sphere) PHIS, PHIE, PHIWIDTH,',
     +                    'Lor fact',F10.3,3F8.3,F8.2,
     +                    ' ISTART,IEND,IWIDTH',3I3,
     +                    ' DELEPS1',F6.3,' DELEPS2',F6.3)
                  END IF
               END IF
               RETURN
            END IF
         END IF
      END IF
C
      IF (DEBUG(38)) THEN
         ICOUNT = ICOUNT + 1
         IF (ICOUNT.EQ.1) THEN
            WRITE(IOUT,FMT=6000) PHIBEG,PHIEND,WAVE,E1,E2,E3,S0,IAX
            IF (ONLINE) WRITE(ITOUT,FMT=6000) PHIBEG,PHIEND,WAVE,
     +           E1,E2,E3,S0,IAX
         END IF
         IF (ICOUNT.LT.NDEBUG(38)) THEN
            WRITE(IOUT,FMT=6002) IP,IQ,IR,XRLP,XRLPE,DSTAR2,KT,KH,
     +           PHI,PHIS,PHIE,PHIW,RLORF,ISTART,IEND,IWIDTH,
     +           DELEPS1,DELEPS2
            IF (ONLINE) WRITE(ITOUT,FMT=6002) IP,IQ,IR,XRLP,XRLPE,
     +           DSTAR2,KT,KH,PHI,PHIS,PHIE,PHIW,RLORF,ISTART,IEND,
     +          IWIDTH,DELEPS1,DELEPS2
         END IF
      END IF
C
      END
C $Id: gensort.f,v 1.10 2008/09/23 12:22:44 andrew Exp $
C== GENSORT ==
       SUBROUTINE GENSORT(MODE,FORCE,LIMIT,VLIM,NMR,ADDPART,PTMIN,LAST)
C      ================================================================
C
      IMPLICIT NONE
C        This subroutine generates a list of reflections, stored in
C        IREC,IX,IY where IREC contains the generate file record number
C        and IX,IY are the coordinates of the reflection in pixels
C        (integers) wrt the first pixel in the image (lower left corner
C        cameramans view). This list is then sorted on the X (slowly
C        varying) scanner coordinate. This list is used by SEEKRS to search
C        for refinement spots and by MEAS for picking out raster boxes
C        from the image for integration.
C        *** IMPORTANT *** Note that IX,IY are in 10 micron units rather
C        than pixels when used to test for spot overlap (MODE=-1 or -2).
C
C
C      MODE = -2 As used by MASKONE, select all reflections and output
C                coordinates in 10 micron units to file COORDS
C           = -1 As used by MASKIT, select all reflections and output
C                coordinates in 10 micron units, NOT pixels.
C           = 0  As called by SEEKRS, FULLS only outside LIMITS
C           = 1  Measurement mode, all reflections. This is also used in NEWPREF
C                ie new post-refinement, equivalent to POSTREF MULTI
C           = 2  Pattern matching, no limits, include reflections cut off
C                at both ends.
C           = 3  As 0, but include partials.
C
C           = 4 Adding partials mode, for those partials that are present
C               on TWO images only, don't output a record if the
C               reflection is partial at start of oscillation range and
C               write two records (one partial, then one full) for
C               partials at end of oscillation range.  This list is used
C               by MEAS.
C
C           = 5  Old style postrefinement mode based on reflections which
C                are partial over only two images. Write two reflections
C                for partials at end of oscillation, providing they do
C                not extend over more than 2 images. Do not suppress
C                partials at start of range. The list is used by MEAS.
C
C           = 6  Same as MODE = 2 but as called from AUTOMATCH, avoids
C                printing out quite as much. 
C
C
C      FORCE     TRUE if processing a B or C film as an A film, otherwise
C                FALSE.
C
C      LIMIT     Limit for selection of refinement spots from central
C                region of image. The absolute value of the coordinate
C                must be less than LIMIT (in 10 micron units).
C
C      VLIM      Limit on Y coordinate for Vee films.
C
C      NMR       Number of records output by gensort. (Note that when
C                adding partials there are two records per reflection).
C
C      ADDPART   TRUE if adding partials over TWO images, otherwise FALSE
C
C      PTMIN     If using partials for refinement (and not adding partials)
C                then reflections which are at least PTMIN recorded will
C                be selected (range 0 to 1.0)
C
C      LAST      True if this is the last image of a run processed with ADDPART
C                or POSTREF. However, when called from MOSFLM with MODE=-2,
C                if NEWPREF post-refinement is being used LAST is set FALSE
C                for the last image.
C
C     Reflection flags (IR) (Set by SPTEST called from DSTAR)
C       IR      =  0  Spot can be measured
C               =  1  Outside R, X, Y limits
C               =  2  Overlapping spot (set later)
C               =  3  Too wide in phi (more than NWMAX images)
C               =  4  DST .GT. DSTMAX  Not included in final film list -
C                       used only to check for overlaps at edge of film.
C               = 10  Spot is within cusp, but will be observed...not included
C                     in final spot list but must be included in predicted
C                      pattern
C
C               =  21  Spot present on 2 images, this is 1st
C               =  22  Spot present on 2 images, this is 2nd
C
C               =  31  Spot present on 3 images, this is 1st
C               =  32  Spot present on 3 images, this is 2nd
C               =  33  Spot present on 3 images, this is 3rd
C
C               =  41  Spot present on 4 images, this is 1st
C               =  42  Spot present on 4 images, this is 2nd
C               =  43  Spot present on 3 images, this is 3rd
C               =  44  Spot present on 4 images, this is 4th
C
C                 etc etc
C
C
C     IGFLAG is set to one for accepted reflections if MODE>0, but if
C            GENSORT is called again to deal with "dense" images, note
C            that IGFLAG will be reset to zero for all reflections.
C            Thus it CANNOT be used to check for acceptable reflections
C
C     .. Parameters ..                                           
C&&*&& include  ../inc/parameter.f
C
C $Id: parameter.f,v 1.17 2009/10/28 16:43:34 harry Exp $
C
C--- awk generated include file  parameter.h
C---- START of include file parameter.h
C
C       PARAMETERS
C       IYLENGTH.. maximum number of I*2 words of data in the 
C                  "fast" (ie most rapidly changing) direction in the
C                  digitised image. This will be HALF the number of pixels
C                  for film data (each pixel is stored in one byte)
C                  but will equal the number of pixels for IP data.
C       IXWDTH...  The maximum number of "stripes" of data in the scanned image
C                  ie the number of pixels in the "slow" direction
C                  (This is the Y direction in the MOSFLM convention)
C                  Note that the array "IMAGE" used to store the image is
C                  declared as size IYLENGTH*IXWDTH I*2 words for IP data
C                  and 2*IYLENGTH*IXWDTH BYTES for film data.
C                  If this exceeds the
C                  available memory, set ixwdth=1, recompile program
C                  and use keyword "NOCORE" when running program.
C                  Note that for the POSTREF and ADDPART options,
C                  two images have to be stored in memory at once so
C                  IXWDTH should be twice the number of records in an
C                  image.
C       MAXHEAD    maximum length of image header (in 4 byte words)
C       NREFLS.... maximum number of spots per film in generate file (250,000)
C       MAXBOX.... maximum number of pixels in measurement box (1500)
C       MAXDIM.... maximum box size in either direction (pixels) (41)
C       MAXPAX.... maximum number of packs per generate file (10000)
C       MXDOV2..... maxdim/2
C       MAXBUFF... maximum size of buffer (I*2) for storing ods
C                  of active spots in subroutine meas(21,000).
C                  Must be .GE.  MAXBOX*(NNLINE-1) for subroutine process
C       MREF...... maximum number of reflections to be used in post
C                  refinement (6000)
C       NEXPAND... maximum number of expansions of the input measurement
C                  box (2)
C       NMASKS.... maximum number of different profiles (25). Note the
C                  connection between this parameter and NNLINE
C       NVECT..... maximum number of vectors for storing scanned image
C                  in filmplot (10000)
C       NIMAX..... maximum number of images to be used together in 
C                  postrefinement (NADD or WIDTH options) (100)
C       NNLINE...  maximum number of boundary lines for setting up
C                  the areas for profile fitting. The maximum possible
C                  number of standard profiles will be (NNLINE-1)**2
C                  although for a circular detector the actual number
C                  may be less than this as some boxes will lie entirely
C                  outside the detector.
C       NREJMAX... Maximum number of rejected background pixels, resulting
C                  either from overlap of adjacent spots or outliers from
C                  the background plane
C       NSPOTS...  Maximum number of found spots (for autoindexing) that can
C                  be stored (for all images). Also maximum number in 
C                  a file wriitten by IMSTILLS that can be 
C                  stored/displayed/edited. THis must be an even number
C       MCOLS....  Number of columns in output MTZ file
C       MCOLSTR..  Number of columns in output MTZ file for strategy option
C     
C       MTZ Orientation block
C        MBLENG is total length of block, MBLINT, MBLREA are numbers
C          of integers & reals
C       NDETREF    Maximum number of reflections used for detector parameter
C                  refinement (previously 62)
C       NRPAR....  Maximum number of refineable parameters for detector
C                  positional refinement (subroutine RDIST)
C       NSEGMAX..  Maximum number of segments in STRATEGY
C       NSEGMAXPR  Maximum number of segments in POST-REFINEMENT
C       MULTMAX... Maximum number of observations with same hkl in COMPLETE
C       MAXDIFF... Maximum number of different packs that a given hkl occurs on
C       NRESBIN... Maximum number of resolution bins (COMPLETE)
C
C       MAXIMG...  Maximum number of images that can be read in using the IMAGE
C                  keyword or the "read Image" menu option.
C       MXSPOT...  Maximum number of spots that can be found on one image
C                  (before rejection on spot size).
C       MXCENT...  Maximum number of active spots during spot finding 
C                  (findspots)
C
C       MGRA, NGRA... maximum number of reflections and images over which a 
C                     reflection can be spread for postrefinement.
C       MAXBGBOX    Maximum number of local background background boxes 
C                   in X and Y
C
C       MAXNPEAKS   Maximum number of local maxima within one spot
C       MAXEXCL     Maximum number of excluded areas of the same type
C                   eg reactangles, quadrilaterals, arcs, resolution shells
C
C     .. Parameters ..
      INTEGER IXWDTH
c      PARAMETER (IXWDTH=8192)
      PARAMETER (IXWDTH=12288)
      INTEGER IYLENGTH
c      PARAMETER (IYLENGTH=4096)
      PARAMETER (IYLENGTH=6144)
      INTEGER MAXHEAD
      PARAMETER (MAXHEAD=5120)
      INTEGER MAXBOX
      PARAMETER (MAXBOX=3000)
      INTEGER MAXDIM
      PARAMETER (MAXDIM=41)
      INTEGER MAXPAX
      PARAMETER (MAXPAX=10000)
      INTEGER MXDOV2
      PARAMETER (MXDOV2=MAXDIM/2)
      INTEGER NEXPAND
      PARAMETER (NEXPAND=2)
      INTEGER NNLINE
      PARAMETER (NNLINE=8)
      INTEGER NMASKS
      PARAMETER (NMASKS=49)
      INTEGER MAXBUFF
      PARAMETER (MAXBUFF=21000)
      INTEGER NREFLS
      PARAMETER (NREFLS=250000)
      INTEGER MREF
      PARAMETER (MREF=6000)
      INTEGER NVECT
      PARAMETER (NVECT=10000)
      INTEGER NIMAX
      PARAMETER (NIMAX=100)
      INTEGER NREJMAX
      PARAMETER (NREJMAX=1000)
      INTEGER NSPOTS
      PARAMETER (NSPOTS=5000)
      INTEGER MCOLS
      PARAMETER (MCOLS=18)
      INTEGER MCOLSTR
      PARAMETER (MCOLSTR=6)
      INTEGER NREFSTR
C
C---- Each reflection for strategy run needs MCOLSTR I*2 words
C     plus an I*4 word for the merging
C
      PARAMETER (NREFSTR = IXWDTH*IYLENGTH/(2+MCOLSTR))
      INTEGER MBLENG,MBLINT,MBLREA
      PARAMETER (MBLENG=185,MBLINT=29,MBLREA=156)
      INTEGER NDETREF
      PARAMETER (NDETREF=400)
      INTEGER NRPAR
      PARAMETER (NRPAR=14)
      INTEGER NSEGMAX
      PARAMETER (NSEGMAX=100)
      INTEGER NSEGMAXPR
      PARAMETER (NSEGMAXPR=100)
      INTEGER MULTMAX
      PARAMETER (MULTMAX=100)
      INTEGER MAXDIFF
      PARAMETER (MAXDIFF=100)
      INTEGER NRESBIN
      PARAMETER (NRESBIN=20)
      INTEGER MXSPOT
      PARAMETER (MXSPOT=5000)      
      INTEGER MAXIMG
      PARAMETER (MAXIMG=100)      
      INTEGER NPIXBG
      PARAMETER (NPIXBG=51)
      INTEGER MXCENT
      PARAMETER (MXCENT=500)
      INTEGER    NGRA,MGRA
      PARAMETER (NGRA=20)
      PARAMETER (MGRA=50000)
      INTEGER MAXBGBOX
      PARAMETER (MAXBGBOX=500)
      INTEGER MAXNPEAKS
      PARAMETER (MAXNPEAKS=500)
      INTEGER MAXEXCL
      PARAMETER (MAXEXCL=50)
C&&*&& end_include  ../inc/parameter.f
C     ..
C     .. Scalar Arguments ..
      REAL VLIM,PTMIN
      INTEGER LIMIT,MODE,NMR
      LOGICAL FORCE,ADDPART,LAST
C     ..
C     .. Local Scalars ..
      REAL AM,XC,XCAL,YC,YCAL,XLIMIT,SSINOM0,SCOSOM0,OMEGA0
      INTEGER I,IMAX,NC,NFAIL,NFAILY,NRX,NRY,NXS,NYS,
     +        VLIMIT,XHIGH,XLOW,YHIGH,YLOW,IFREC,ISREC,IXI,IXJ,J,K,
     +        IR,IM,NPRINT,IRMAX,IR1,IR2
      CHARACTER CALLEDFROM*80
C     ..
C     .. Local Arrays ..
C     ..
C     .. External Functions ..
      INTEGER LENSTR
      EXTERNAL LENSTR
C     ..
C     .. External Subroutines ..
      EXTERNAL PXYCALC,SORTUP3,MMTOPX,SHUTDOWN
C     ..
C     .. Intrinsic Functions ..
      INTRINSIC ABS,NINT
C     ..
C     .. Common blocks ..
C&&*&& include  ../inc/amatch.f
C
C $Id: amatch.f,v 1.1 2002/05/02 10:46:40 harry Exp $
C
C--- awk generated include file  amatch.h
C---- START of include file amatch.h
C
C
C     .. Scalars in Common /AMATCH/ ..
C     ..
      REAL RCONV,OVRLAP,RESOL1,RESOL2,AELIMIT,ARMSLIM,
     +     SECANGLE,DAMP,TRUECCOM,ETAMAX,AWRMSLIM,MOSNEW,
     $     SLOPE,INTERCEPT
      INTEGER NSTEP,NCYCA,NPASS,N2,N3,N4,N5,N6,N7,N8,N9,N10,NBEAM
      LOGICAL MATCH,NOCENT,NOREFINE,RMOSAIC
C     ..
C     .. Common block /AMATCH/  ..
      COMMON /AMATCH/RCONV,OVRLAP,RESOL1,RESOL2,AELIMIT,ARMSLIM,
     +     SECANGLE,DAMP,TRUECCOM,ETAMAX,AWRMSLIM,MOSNEW,
     $     SLOPE,INTERCEPT,NSTEP,NCYCA,NPASS,N2,N3,N4,N5,N6,N7,
     $     N8,N9,N10,NBEAM,MATCH,NOCENT,NOREFINE,RMOSAIC
C     ..
C
C
C&&*&& end_include  ../inc/amatch.f
C&&*&& include  ../inc/debug.f
C
C $Id: debug.f,v 1.2 2008/07/24 09:42:21 andrew Exp $
C
C--- awk generated include file  debug.h
C---- START of include file debug.h
C
C
C
C     .. Arrays in common /DEBUG/ ..
      REAL XWARN
      INTEGER NDEBUG,IWARN
      LOGICAL DEBUG,LPRINT,DUMP,WARN
C
C     .. Scalars in common /DEBUG/ ..
      REAL BGRLIM
      INTEGER NDUMP,IDUMP,MXDUMP
      LOGICAL SPOT
C     
C     ..
C     .. Common Block /DEBUG/..
      COMMON /DEBUG/XWARN(20,100),BGRLIM,NDEBUG(100),IWARN(20,100),
     $       NDUMP,IDUMP,MXDUMP,DEBUG(100),LPRINT(20),DUMP(30),
     +       WARN(100),SPOT
C     ..
C
C&&*&& end_include  ../inc/debug.f
C&&*&& include  ../inc/fid.f
C
C $Id: fid.f,v 1.5 2007/11/06 12:49:03 harry Exp $
C
C--- awk generated include file  fid.h
C---- START of include file fid.h
C
C     XCENF,YCENF  Coordinates (in 10 micron units) of the direct beam
C                  position relative to an origin at the position of the
C                  first pixel in the digitised image.(The SCANNER
C                  coordinate frame).
C                  For IP data this comes from the defined
C                  direct beam coordinates, for film data it is the
C                  midpoint of fiducials 1 and 3.
C
C     CCX,CCY      The difference (in 10 micron units) between the
C                  refined position of the direct beam (XCEN,YCEN) and
C                  the ideal direct beam coordinates (XCENF,YCENF),
C                  in the SCANNER coordinate frame.
C                  CCX,CCY are updated in RDIST. They are in "pixels"
C                  rather than mm (but expressed in 10micron units).
C
C     DTOFD        The distance (in 10 micron units) from the crystal
C                  to the detector along a normal to the detector.
C                  For flat, unswung detectors, or swung on a 2 theta arm,
C                  this is the same as CTOFD and XTOFD. It differs for
C                  Vee shaped cassettes. Assigned in START and never changed.
C                  Only actually used in RMAXR for calculating box sizes.
C
C     .. Arrays in common /FID/ ..
      REAL CCOMABC
      INTEGER FSPOS,CCXABC,CCYABC
C     ..
C     .. Scalars in common /FID/ ..
      REAL OMEGAF,OMEGAFD,CCOM,DTOFD,XCENF,YCENF
      INTEGER MM,MMDB,NFID,CCX,CCY,IYOFF,LABVIEW
      CHARACTER SPOTFILEORIGIN*2,SPOTFILEAXISORDER*2,SWINGAXIS*2
C     ..
C     .. Common block /FID/ ..
      COMMON /FID/CCOMABC(3),OMEGAF,OMEGAFD,CCOM,DTOFD,XCENF,YCENF,
     $     FSPOS(4,2),
     +     CCXABC(3),CCYABC(3),MM,MMDB,NFID,CCX,CCY,IYOFF,LABVIEW,
     $     SPOTFILEORIGIN,SPOTFILEAXISORDER,SWINGAXIS
C     ..
C
C
C&&*&& end_include  ../inc/fid.f
C&&*&& include  ../inc/gendata.f
C
C $Id: gendata.f,v 1.2 2003/01/10 16:17:53 andrew Exp $
C
C--- awk generated include file  gendata.h
C---- START of include file gendata.h
C
C     IMG       Partiality indicator. 0 for full reflections, 1 to 100
C                   for partials. Negative for partials at the start of the
C                   rotation range, +ve for partials at the end of the 
C                   rotation. Set in subroutine REEK using DELEPS calculated
C                   in subroutine DSTAR
C
C     IRG       Reflection flag  (Set by SPTEST called from DSTAR)
C               =  0  Spot can be measured
C               =  1  Outside R, X, Y limits
C               =  2  Overlapping spot (set later)
C               =  3  Too wide in phi (more than NWMAX images)
C               =  4  DST .GT. DSTMAX  Not included in final film list -
C                       used only to check for overlaps at edge of film.
C               = 10  Spot is within cusp, but will be observed...not included
C                     in final spot list but must be included in predicted
C                      pattern
C
C               =  21  Spot present on 2 images, this is 1st
C               =  22  Spot present on 2 images, this is 2nd
C
C               =  31  Spot present on 3 images, this is 1st
C               =  32  Spot present on 3 images, this is 2nd
C               =  33  Spot present on 3 images, this is 3rd
C
C               =  41  Spot present on 4 images, this is 1st
C               =  42  Spot present on 4 images, this is 2nd
C               =  43  Spot present on 3 images, this is 3rd
C               =  44  Spot present on 4 images, this is 4th
C
C                 etc etc
C
C     XG        Virtual detector X coordinate in 10 micron units, relative to
C               an origin at the direct beam position. X is parallel to the
C               Y axis in the laboratory frame, ie orthogonal to the rotation
C               axis.
C
C     YG        Virtual detector Y coordinate in 10 micron units, relative to
C               an origin at the direct beam position. Y is parallel to the
C               Z axis in the laboratory frame, ie  the rotation axis.
C
C     IX,IY     are the coordinates of the reflection in pixels
C               (integers) wrt the first pixel in the image (lower left corner
C               cameramans view). For testing for spot overlap, these
C               coordinates are in 10 micron units. Also used for display
C               pixel coordinates when displaying predicted pattern.
C
C     IREC      Pointer to the record number of a particular spot in the
C               list of generated reflections.
C
C
C     ..
C     .. Arrays in common /GENDATA/ ..
      REAL FRACG,PHIG,PHIWG,XG,YG,GOODFIT
      INTEGER INTG,IPRO,IX,IY,IREC
      INTEGER*2 IRG,IMG,IGFLAG,ISDPRO,ISDG,IHG,IKG,ILG,IMPARTG,
     +          MISYMG
C     .. Scalars in common /GENDATA/ ..
      INTEGER IPACKREC,IPACKHEAD,IRECLAST
C     ..
C     .. Common block /GENDATA/ ..
      COMMON /GENDATA/FRACG(NREFLS),PHIG(NREFLS),PHIWG(NREFLS),
     $       XG(NREFLS),YG(NREFLS),INTG(NREFLS),IPRO(NREFLS),
     $       IX(NREFLS),IY(NREFLS),IREC(NREFLS),IRG(NREFLS),IMG(NREFLS),
     +       IGFLAG(NREFLS),ISDPRO(NREFLS),ISDG(NREFLS),
     +       IHG(NREFLS),IKG(NREFLS),ILG(NREFLS),IMPARTG(NREFLS),
     +       MISYMG(NREFLS),GOODFIT(NREFLS),IPACKREC,IPACKHEAD,
     +       IRECLAST
C     ..
C
C

C&&*&& end_include  ../inc/gendata.f
C&&*&& include  ../inc/ioo.f
C
C $Id: ioo.f,v 1.7 2009/05/13 11:57:53 harry Exp $
C
C--- awk generated include file  ioo.h
C---- START of include file ioo.h
C
C
C
C     .. Scalars in common block /IOO/ ..
      INTEGER IOUT,IUNIT,ITIN,ITOUT,INOD,INMO,IDU,NWRN,IBRIEF,ISUMMR,
     +        ICOORD,SERVERFD,SERVERFDIN,NSHUTERR,dnafd
      LOGICAL ONLINE,ONEFILE,FHEADER,BRIEF,GRAPH,IOERR,
     $     NODISPLAY,LBELL,JPGOUT,SOCKLO,LBEST,dnaout,INMOOPEN,
     $     XMLOPEN
      CHARACTER dna_image*80,xmlfile*80
C     ..
C     .. Common block /IOO/ ..
c      COMMON /IOO/IOUT,IUNIT,ONLINE,ITIN,ITOUT,INOD,INMO,IDU,NWRN,
c     +            ONEFILE,FHEADER,BRIEF,IBRIEF,GRAPH,ISUMMR,ICOORD,
c     +            IOERR,NODISPLAY,LBELL
C     ..
C
C
      COMMON /IOO/IOUT,IUNIT,ITIN,ITOUT,INOD,INMO,IDU,NWRN,IBRIEF,
     +        ISUMMR,ICOORD,SERVERFD,SERVERFDIN,NSHUTERR,ONLINE,ONEFILE,
     +        FHEADER,BRIEF,GRAPH,IOERR,NODISPLAY,LBELL,JPGOUT,
     $        SOCKLO,LBEST, dnafd, dnaout,INMOOPEN,XMLOPEN
      COMMON /CIOO/dna_image,xmlfile

C&&*&& end_include  ../inc/ioo.f
C&&*&& include  ../inc/iosp.f
C
C $Id: iosp.f,v 1.1 2002/05/02 10:46:53 harry Exp $
C
C--- awk generated include file  iosp.h
C---- START of include file iosp.h
C
C
C     .. Scalars in common block /IOSP/ ..
      INTEGER NSPOT,NFULL,NOUTGEN
C     ..
C     .. Common Block /IOSP/ ..
      COMMON /IOSP/NSPOT,NFULL,NOUTGEN
C     ..
C
C
C&&*&& end_include  ../inc/iosp.f
C&&*&& include  ../inc/mcs.f
C $Id: mcs.f,v 1.1 2002/05/02 10:46:56 harry Exp $
C
C
C--- awk generated include file  mcs.h
C---- START of include file mcs.h
C
C
C     .. Scalars in common block /MCS/ ..
      REAL BASEOD,G1OD,CURV
      INTEGER FILM,FILMS,CTOFD,PCKIDX,TOSPT,N1OD,XSCMIN,XSCMAX
      LOGICAL VEE,VALONGX
C     ..
C     .. Common block /MCS/ ..
      COMMON /MCS/BASEOD,G1OD,CURV,FILM,FILMS,CTOFD,PCKIDX,TOSPT,
     $            N1OD,XSCMIN,XSCMAX,VEE,VALONGX
C     ..
C     CTOFD.... This was the crystal to detector distance (10 micron units)
C               but it has now been replaced by XTOFD in common block /XY/
C
C&&*&& end_include  ../inc/mcs.f
C&&*&& include  ../inc/ori.f
C
C $Id: ori.f,v 1.2 2007/07/12 13:25:56 andrew Exp $
C
C--- awk generated include file  ori.h
C---- START of include file ori.h
C
C     XCEN,YCEN    Coordinates (in 10 micron units) of the direct beam
C                  position relative to an origin at the position of the
C                  first pixel in the digitised image.(The SCANNER
C                  coordinate frame). These parameters are refined for
C                  each image. 
C
C     XCEN0,YCEN0  Coordinates of direct beam position at zero swing angle.
C                  (Needed for pxtomm conversion for swung detectors)
C                  These values are assigned on the basis of input direct
C                  beam coordinates, corrected for swing angle if necessary.
C                  They are not (currently) updated during refinement.
C
C     XOFF,YOFF    Distance between centre of detector and direct beam.
C
C     ..
C     .. Arrays in common /ORI/ ..
      LOGICAL FIXPAR
C
C     .. Scalars in common block /ORI/ ..
      REAL COSOM0,SINOM0,XTOFRA,YSCAL,TILT,TWIST,BULGE,
     +     VBNEG,VBPOS,VTILT,VTWIST,VVERT,TOFF,BULGE2,PBULGE,ROFF,
     +     RDTOFF,RDROFF,ROFFPHI,TOFFPHI,JUNK3,XCEN,YCEN,XCEN0,YCEN0,
     +     XOFF,YOFF,TILTMAT,TWISTMAT,DETNOR,DPSIX,SMTWIST,SMTILT,
     +     SMOMEGA0,SMYSCAL,SMTOFF,SMROFF,SMXTOFRA
      INTEGER CBAR,NODES,NPHI,NSM1,NSM2
      LOGICAL RESETCCOM,NOSMOOTH
C     ..
C     .. Common Block /ORI/ ..
      COMMON /ORI/COSOM0,SINOM0,XTOFRA,YSCAL,TILT,TWIST,BULGE,
     $       VBNEG,VBPOS,VTILT,VTWIST,VVERT,TOFF,BULGE2,PBULGE,ROFF,
     $       RDTOFF,RDROFF,ROFFPHI,TOFFPHI,JUNK3,XCEN,YCEN,XCEN0,
     +       YCEN0,XOFF,YOFF,TILTMAT,TWISTMAT,DPSIX,DETNOR(3),CBAR,
     +       NODES,NPHI,FIXPAR(NRPAR),
     $       RESETCCOM,SMTWIST,SMTILT,SMOMEGA0,SMYSCAL,SMTOFF,SMROFF,
     +       SMXTOFRA,NSM1,NSM2,NOSMOOTH
C     ..
C
C
C&&*&& end_include  ../inc/ori.f
C&&*&& include  ../inc/precession.f
C
C $Id: precession.f,v 1.1 2002/05/02 10:47:08 harry Exp $
C
C--- awk generated include file  precession.h
C---- START of include file precession.h
C
C
C     .. Scalars in common block /PRECESSION/ ..
      REAL D1,D2,PHIPREC,PSIPREC,PCTOFD,XLAMBDA
      LOGICAL PRECESS
C     ..
C     .. Common Block /PRECESSION/ ..
      COMMON /PRECESSION/D1,D2,PHIPREC,PSIPREC,PCTOFD,XLAMBDA,PRECESS
C     ..
C
C
C&&*&& end_include  ../inc/precession.f
C&&*&& include  ../inc/pro.f
C
C $Id: pro.f,v 1.1 2002/05/02 10:47:09 harry Exp $
C
C--- awk generated include file  pro.h
C---- START of include file pro.h
C
C
C     .. Arrays in common block /PRO/ ..
      INTEGER*2 IDUM
C     ..
C     .. Common Block /PRO/ ..
      COMMON /PRO/IDUM(MAXBUFF)
C     ..
C
C
C&&*&& end_include  ../inc/pro.f
C&&*&& include  ../inc/ras.f
C
C $Id: ras.f,v 1.1 2002/05/02 10:47:10 harry Exp $
C
C--- awk generated include file  ras.h
C---- START of include file ras.h
C
C
C     .. Scalars in common block /RAS/ ..
      INTEGER NEWRAS,MINT
C     ..
C     .. Arrays in common block /RAS/ ..
      INTEGER IRAS
      REAL VARAS
C     ..
C     .. Common Block /RAS/ ..
      COMMON /RAS/VARAS(5),IRAS(5),NEWRAS,MINT
C     ..
C
C
C&&*&& end_include  ../inc/ras.f
C&&*&& include  ../inc/reeke.f
C
C $Id: reeke.f,v 1.15 2008/10/22 08:50:48 andrew Exp $
C
C--- awk generated include file  reeke.h
C---- START of include file reeke.h
C
C     TOR     For synchrotron sources, degree of polarisation of the beam
C     IMONO   Collimation flag for polarisation.
C             = 0   Pinhole or mirrors
C             = 1   Graphite Monochromator
C             = 2   Synchrotron, use TOR
C     NWMAX   Maximum reflection width in images
C     DSTMAX  dimensionless rlu, = WAVE/RES where RES is the maximum
C             resolution in Angstrom.
C     DSTMIN  dimensionless rlu, = WAVE/DMAX where DMAX is the maximum
C              Bragg spacing
C     S0      radiation source vector (-1,0,0), may be modified by MU values
C     SOURCE  radiation source vector - basis for s0
C     GONIO_angle:  machine angles for generalized goniostats
C     GONIO_angle_SET: fixed offset angles for 3- and 4-circle goniostats
C                      i.e. currently 54.74 deg for Bruker CHI, 50.0deg for
C                      Nonius and Oxford KAPPA 
C     ..
C     .. Arrays in common block /REEKE/ ..
      REAL RMC,AMAT,SCAXIS,S0,s0unit,CAMCON,BEAMMU
C     ..
C     .. Scalars in common block /REEKE/ ..
      REAL X1,X2,Y1,Y2,Z1,Z2,XYS,DSTAR2,DSTMAX,DSTPL,DSTPL2,
     +     DIVH,DIVV,DELAMB,ETA,DELCOR,DSTMAXS,TOR,DSTMIN,WMAX,
     +     ETAFRAC,ETASM,
     $     GON_CHI,GON_PHIS,GON_KAPPA,GON_OMEGAS,GON_2THETA,
     $     GON_PHIE,GON_OMEGAE,
     +     GON_CHI_SET,GON_KAPPA_SET,
     +     BLKSIZE
      INTEGER ISYN,IMONO,NWMAX,IPAD,NSMOOTH,IGON_CHI,IGON_PHI,
     $     IGON_KAPPA,IGON_OMEGA,IGON_2THETA,
     +     IGON_CHI_SET,IGON_KAPPA_SET,IHOSCAXIS
C     ..
C     .. logicals in common block /REEKE/ ..
      LOGICAL LOGETA,NUREEK,LCAMCON,GENGON,FOURCIRCLE,THREECIRCLE
C     ..
C     .. Common Block /REEKE/ ..
      COMMON /REEKE/RMC(3,3),AMAT(3,3),SCAXIS(3),S0(3),s0unit(3),
     $     CAMCON(8),BEAMMU(2),X1,X2,Y1,Y2,
     +     Z1,Z2,XYS,DSTAR2,DSTMAX,DSTPL,DSTPL2,DIVH,DIVV,DELAMB,
     +     ETA,DELCOR,DSTMAXS,TOR,DSTMIN,WMAX,ETAFRAC,ETASM,
     $     GON_CHI,GON_PHIS,GON_KAPPA,GON_OMEGAS,GON_2THETA,
     $     GON_PHIE,GON_OMEGAE,
     +     GON_CHI_SET,GON_KAPPA_SET,ISYN,IMONO,
     $     NWMAX,IPAD,
     $     NSMOOTH,IGON_CHI,IGON_PHI,
     $     IGON_KAPPA,IGON_OMEGA,IGON_2THETA,
     +     IGON_CHI_SET,IGON_KAPPA_SET,IHOSCAXIS,LOGETA,NUREEK,LCAMCON,
     $     GENGON,FOURCIRCLE,THREECIRCLE,
     +     BLKSIZE
C     ..
C
C
C&&*&& end_include  ../inc/reeke.f
C&&*&& include  ../inc/reprt.f
C--- awk generated include file  reprt.h
C---- START of include file reprt.h
C
C
C
C     .. Scalars in common block /REPRT/ ..
      REAL AVBGRATIO,AVSIG,RFULL,RPART,AVPKRATIO,PKRMAXI,BGRMAXI,
     +     RFACOV,SDRATOV,SDMON,RESCUT,STHCUT
      INTEGER NREF,NOFR,NOLO,MAXBSI,MINBSI,NEDGE,NBOX,NBZERO,NNEG,
     +        NBAD,NBGRJ,NEDGE1,NPARTEND,NSPOVL,NRSYM,NHALF,NSUMPART
      LOGICAL PKACCEPT
C     ..
C     .. Arrays in common block /REPRT/ ..
      REAL RATIO,AVSD,AVSDP,AVSIG1,AVSIG2,AVINTI1,AVINTI2,AVPRI1,
     +     AVPRI2,RMSDELI1,RMSDELI2,ABSDELI1,ABSDELI2,AVPRSIG1,
     +     AVPRSIG2,AVDELSIG1,AVDELSIG2,PKRATIO,RSIGVSM,
     +     FIOVSDP,FIOVSDS,PIOVSDP,PIOVSDS,DBIN
      INTEGER IRANGE,IANAL,IANALF,NRFLS1,NRFLS2,MEANDELI1,MEANDELI2,
     +        NBGRHIST,IVSM,NIVSM,NRESPF,NRESPP,NRESSF,NRESSP,
     +        IRESPF,IRESPP,IRESSF,IRESSP,ISDRESPF,ISDRESPP,
     +        ISDRESSF,ISDRESSP
C     ..
C     .. Common Block /REPRT/ ..
      COMMON /REPRT/RATIO(10),AVSD(10),AVSDP(10),AVSIG1(10,2),
     $       AVSIG2(NMASKS,2),AVINTI1(10,2),AVINTI2(NMASKS,2),
     $       AVPRI1(10,2),AVPRI2(NMASKS,2),RMSDELI1(10,2),
     +       RMSDELI2(NMASKS,2),ABSDELI1(10,2),ABSDELI2(NMASKS,2),
     +       AVPRSIG1(10,2),AVPRSIG2(NMASKS,2),AVDELSIG1(10,2),
     +       AVDELSIG2(NMASKS,2),PKRATIO(10),RSIGVSM(13),FIOVSDP(9),
     $       FIOVSDS(9),PIOVSDP(9),PIOVSDS(9),DBIN(9),
     $       AVBGRATIO,AVSIG,RFULL,RPART,AVPKRATIO,PKRMAXI,BGRMAXI,
     $       RFACOV,SDRATOV,SDMON,RESCUT,STHCUT,
     $       IRANGE(9),IANAL(10),IANALF(10),NRFLS1(10,2),
     +       NRFLS2(NMASKS,2),MEANDELI1(10,2),MEANDELI2(NMASKS,2),
     +       NBGRHIST(32),IVSM(13),NIVSM(13),
     +       NRESPF(9),NRESPP(9),NRESSF(9),NRESSP(9),
     +       IRESPF(9),IRESPP(9),IRESSF(9),IRESSP(9),ISDRESPF(9),
     +       ISDRESPP(9),ISDRESSF(9),ISDRESSP(9),NREF,NOFR,NOLO,
     $       MAXBSI,MINBSI,NEDGE,NBOX,NBZERO,NNEG,NBAD,
     +       NBGRJ,NEDGE1,NPARTEND,NSPOVL,
     +       NRSYM,NHALF,NSUMPART,PKACCEPT
C     ..
C
C
C&&*&& end_include  ../inc/reprt.f
C&&*&& include  ../inc/scn.f
C
C $Id: scn.f,v 1.3 2004/08/16 13:26:48 harry Exp $
C
C--- awk generated include file  scn.h
C---- START of include file scn.h
C
C     SCNSZ   is pixel size (in microns) divided by 25
C     RAST    pixel size in slow direction in mm
C     FACT    multiplying by FACT converts from 10 micron units 
C             (the standard unit internal to the program) into pixels
C     IYLEN   The number of pixels in the Y (fastest changing) direction
C             in the digitised image.
C     NREC    The number of pixels in the X (slow) direction in the 
C             digitised image.
C     NWORD   The number of I*2 words in the Y direction.
C     NBYTE   The number of bytes in Y direction = NWORD/2
C     NHBYTE  Number of bytes in header
C
C     ICURR   When several images are stored in a single file, ICURR is the
C             pointer to the first record of the current image in the direct
C             access file (only implemented for film data)
C     NEXTRA  The number of additional (unused) bytes padding the end of
C             each record in image file
C     BYTSWAP True if the "endedness" (Big-endian/Little-endian) of the 
C             machine that MOSFLM is running on is different to that of the
C             machine on which the image was written. This is determined by
C             looking at the value of NXPIX in the header record of the
C             image file (subroutine GETHDR)
C
C     LACTIVE True if using Rigaku active mask, False if ignoring it
C
C     .. Scalars in common block /SCN/ ..
      REAL FACT,SCNSZ,RAST,RASTY
      INTEGER NBYTE,NREC,NWORD,IYLEN,ICURR,NEXTRA,NHBYTE
      LOGICAL BYTSWAP,LACTIVE
C     ..
C     .. Common Block /SCN/ ..
      COMMON /SCN/ FACT,SCNSZ,RAST,RASTY,NBYTE,NREC,NWORD,IYLEN,
     +     ICURR,NEXTRA,NHBYTE,BYTSWAP,LACTIVE
C&&*&& end_include  ../inc/scn.f
C&&*&& include  ../inc/trev.f
C
C $Id: trev.f,v 1.1 2002/05/02 10:47:24 harry Exp $
C
C--- awk generated include file  trev.h
C---- START of include file trev.h
C
C
C     .. Scalars in Common block /TREV/ ..
      INTEGER NXMAX,NYMAX
C     ..
C     .. Common Block /TREV/ ..
      COMMON /TREV/NXMAX,NYMAX
C     ..
C
C
C&&*&& end_include  ../inc/trev.f
C&&*&& include  ../inc/trigparam.f
C 
C $Id: trigparam.f,v 1.3 2008/07/31 11:46:02 harry Exp $
C
C
C     Trigonometric parameters - set here to highly precise values, don't 
C     calculate in code; values from Clemens Vonrhein
C
C     DTOR.. convert degrees to radians
C     RTOD.. convert radians to degrees
C     PI..   value of PI
      REAL PI
      PARAMETER   ( PI = 3.1415926536 )
      REAL          TWOPI
      PARAMETER   ( TWOPI = 6.2831853072 )
      REAL RTOD
      PARAMETER   ( RTOD = 57.2957795131 )
      REAL          DTOR
      PARAMETER   ( DTOR = 0.0174532925 )
C DOUBLE PRECISION...
      DOUBLE PRECISION PI_DOUBLE
      PARAMETER ( PI_DOUBLE = 3.1415926535897932384626433832795029D0 )
      DOUBLE PRECISION TWOPI_DOUBLE
      PARAMETER ( TWOPI_DOUBLE = 
     $     6.2831853071795864769252867665590058D0 )
      DOUBLE PRECISION RTOD_DOUBLE
      PARAMETER ( RTOD_DOUBLE = 57.2957795130823208768D0 )
      DOUBLE PRECISION DTOR_DOUBLE
      PARAMETER ( DTOR_DOUBLE = 0.01745329251994329576D0 )
c

c
C&&*&& end_include  ../inc/trigparam.f

C     ..
C     .. Equivalences ..
      EQUIVALENCE (IRAS(1),NXS), (IRAS(2),NYS), (IRAS(3),NC)
      EQUIVALENCE (IRAS(4),NRX), (IRAS(5),NRY)
C     ..
      SAVE
C
      CALLEDFROM = 'GENSORT'
C
C---- Initialise IREC
C
      DO 2 I = 1,NREFLS
        IREC(I) = 0
 2    CONTINUE
C
      IR1 = 2*IPAD + 1
      IR2 = 2*IPAD + 2
      IR2 = 30*IPAD + 30
C
      NPARTEND = 0
      VLIMIT = VLIM
      XLIMIT = LIMIT
      XLOW = XSCMIN + (NXMAX/2 + 1)
      XHIGH = XSCMAX - (NXMAX/2 + 1)
      YLOW = NYMAX/2 + 1
      YHIGH = IYLEN - (NYMAX/2 + 1)
C
C
C
        NFAILY = 0
        NFAIL = 0
        NREF = 0
C
C---- Set IRMAX...determines maximum number of images over which a partial
C     can lie and still be included in refinement. Default is 2 unless PTMIN is
C     less than 0.4, in which case it increases
C
      IRMAX = IR2
      IF (PTMIN.LE.0.21) THEN
        IRMAX = 5*IPAD + 5
      ELSE IF (PTMIN.LE.0.31) THEN
        IRMAX = 4*IPAD + 4
      ELSE IF (PTMIN.LE.0.41) THEN
        IRMAX = 3*IPAD + 3
      END IF
C
      IF (DEBUG(16)) THEN
        IF (ONLINE) WRITE(ITOUT,110) MODE,XLOW,XHIGH,YLOW,YHIGH,
     +                 FILM,TOSPT,NSPOT,ADDPART,LAST,PTMIN,IRMAX
        WRITE(IOUT,110) MODE,XLOW,XHIGH,YLOW,YHIGH,
     +                  FILM,TOSPT,NSPOT,ADDPART,LAST,PTMIN,IRMAX
      END IF
C
      IMAX = TOSPT
      IF ((MODE.EQ.2).OR.(MODE.EQ.6)) IMAX = NSPOT
C
C---- If MODE = -2 (writing reflections to COORDS file), must first
C     reset OMEGA0 to its value after the detector parameter refinement,
C     because CCOM is set to zero in REFRT1, otherwise coords will not
C     match those written to the SPOTOD file.
C     Need to reset OMEGA0 to OMEGAF+DPSIX+TRUECCOM
C     Only do this if CCOMEGA has actually been reset (RESETCCOM flag).
C     When using conventional refinement, do not
C     apply this correct for the last image as REFRT1 is not called.
C
      IF ((MODE.EQ.-2).AND.(RESETCCOM).AND.(.NOT.LAST)) THEN
        SSINOM0 = SINOM0
        SCOSOM0 = COSOM0
        OMEGA0 = (DPSIX + TRUECCOM)*DTOR + OMEGAF
        SINOM0 = SIN(OMEGA0)
        COSOM0 = COS(OMEGA0)
      END IF
 
C
C---- Loop over reflections in generate file
C
      DO 10 I = 1,IMAX
        IGFLAG(I) = 0
        IR = IRG(I)
        IM = IMG(I)
        XC = XG(I)
        YC = YG(I)
C
C
      IF (DEBUG(16).AND.(I.LE.NDEBUG(16))) THEN
        IF (ONLINE) WRITE(ITOUT,120) I,XC,YC,IR,IM
        WRITE(IOUT,120) I,XC,YC,IR,IM
      END IF
C
C---- For pattern matching and predicting reflection overlap, allow 
C    reflections too wide in phi (IR = 3) and all partials
C
      IF (((MODE.EQ.2).OR.(MODE.EQ.6).OR.(MODE.LT.0)).AND.
     +                  ((IR.EQ.3).OR.(IR.GE.IR1))) GOTO 6
C
C---- For spot masking, include spatial overlaps for list for MASKONE,
C     but NOT for MASKIT
C
      IF ((MODE.EQ.-2).AND.(IR.EQ.2)) GOTO 6
C
C---- Reject all bad reflections (but allow partials)
C
      IF ((IR.GT.0).AND.(IR.LT.IR1)) GOTO 10
C
C---- Test on LIMITS only for MODE = 0,3
C
 6    IF ((MODE.EQ.0).OR.(MODE.EQ.3)) THEN
C
C---- The following code is for generating a list for SEEKRS. If
C     MODE=0 then only fully recorded are allowed. If MODE=3 then partials
C     (on two images only) are allowed. If ADDPART is true, only partials
C      over 2 images and at the  end of oscillation
C     are output (IM.GT.0), otherwise only partials with partiality greater
C     than PTMIN (but at either start or end of oscillation).
C
        IF (IM.NE.0.AND.MODE.EQ.0) GOTO 10
C
C---- Even if allowing partials, only allow those on not more than IRMAX/10 
C     images, where IRMAX is assigned a value which depends on PTMIN
C
        IF (IM.NE.0.AND.(IR.GT.IRMAX)) GOTO 10
        IF (ADDPART) THEN
          IF (IM.LT.0) GOTO 10
        ELSE
          AM = 0.01*ABS(FLOAT(IM))
          IF ((AM.GT.0.00001).AND.(AM.LT.PTMIN)) GOTO 10
        END IF
        IF(VEE) GOTO 8
        IF(ABS(XC).LT.XLIMIT.AND.ABS(YC).LT.XLIMIT) GOTO 10
        GOTO 9
   8    IF(ABS(XC).LT.VLIMIT.AND.ABS(YC).LT.XLIMIT) GOTO 10
      END IF
C
C---- see if spot is below mint
C ** Note next line has been changed.It will now NOT measure
C    reflections with intensity on previous film .lt.MINT when
C    using BASA or CASA mode.
C
 9    IF (FILM.GT.1.AND.INTG(I).LT.MINT.AND..NOT.FORCE)GOTO 10
C
C----  If adding partials, reject partials at start of oscillation range
C     if they only span two images (pixel values are added for this class
C     of reflection).
C
      IF ((MODE.EQ.4).AND.(IR.EQ.IR2)) GOTO  10
C
C
      NREF = NREF + 1
C
C---- Must test limits for NREF because extra records are generated when
C     doing post-refinement
C
      IF (NREF.GT.NREFLS) GOTO 90
C
      IF (IM.EQ.0) THEN
        IREC(NREF) = I
      ELSE
        IREC(NREF) = -I
      END IF
C
C---- Count partials over 2 images at end of current image for
C     use if POSTHOC post-refinement is in use (otherwise this
C     is not used). Passed via /REPRT/ to meas
C
      IF ((MODE.EQ.1).AND.(IR.EQ.IR1).AND.ADDPART)
     +                                NPARTEND = NPARTEND + 1
C
C
C
      IF (PRECESS) THEN
        CALL PXYCALC(XCAL,YCAL,XC,YC)
      ELSE
        CALL MMTOPX(XCAL,YCAL,XC,YC)
      END IF
C
C---- Test X limits
C
        IX(NREF) = NINT(XCAL*FACT)
        IF(IX(NREF).GT.XLOW.AND.IX(NREF).LT.XHIGH) THEN
C
C---- If calculating spot overlap, change reflection coords to 10 micron
C     units

          IF (MODE.LT.0) IX(NREF) = NINT(XCAL)
          GOTO 7
        END IF
        NFAIL = NFAIL + 1
        NREF = NREF - 1
        IF ((MODE.EQ.1).AND.(IR.EQ.IR1).AND.ADDPART)
     +                                NPARTEND = NPARTEND - 1
        GOTO 10
C
C---- test Y limits
C
   7    IY(NREF) = NINT(YCAL*FACT)
            IF(IY(NREF).GT.YLOW.AND.IY(NREF).LT.YHIGH) THEN
              IF (MODE.LT.0) IY(NREF) = NINT(YCAL)
              GO TO 20
            END IF
            NFAILY = NFAILY + 1
            NREF = NREF - 1
            IF ((MODE.EQ.1).AND.(IR.EQ.IR1).AND.ADDPART)
     +                                NPARTEND = NPARTEND - 1
        GOTO 10
C
C---- flag this as a measured reflection (but NOT when generating list for
C     spot overlap masking (MODE = -1,-2)
C
 20     IF (MODE.GE.0) IGFLAG(I) = 1
C
      IF (DEBUG(16).AND.(NREF.LE.NDEBUG(16))) THEN
        WRITE(IOUT,130) NREF,I,XC,YC,IX(NREF),IY(NREF)
        IF (ONLINE) WRITE(ITOUT,130) NREF,I,XC,YC,IX(NREF),IY(NREF)
      END IF
C
C---- If adding partials (MODE=4), generate a second  reflection
C     for every partial over 2 images at the end of the oscillation
C     range of current image.
C     Similarly if using postrefinement (MODE=5).
C
C---  HRP - We want to keep the data for reflections with (IR .ge. IR1) as
C           well, for SPROCESS. Following code modified so it still works with
C           old-style post-refinement (limited to partials over 2 images only).
C
        IF (((MODE.EQ.4).OR.(MODE.EQ.5)).AND.
     +                                     (.NOT.LAST)) THEN
           IF (IR.EQ.IR1) THEN
              NREF = NREF + 1
C     
C---- Must test limits for NREF because extra records are generated when
C     doing post-refinement
C
              IF (NREF.GT.NREFLS) GOTO 90
              NPARTEND = NPARTEND + 1
              IREC(NREF) = I
              IX(NREF) = IX(NREF-1)
              IY(NREF) = IY(NREF-1)
              IF (DEBUG(16).AND.(NREF.LE.NDEBUG(16))) THEN
                 WRITE(IOUT,132) NREF
                 IF (ONLINE) WRITE(ITOUT,132) NREF
              END IF
           ENDIF
C
C--- back to old code
C
           END IF
C     
C  End of loop over reflections
  10    CONTINUE
C
C---- check that some spots have been found,
C     if not set mode = 999 and return
C
      IF(NREF.GT.0)GO TO 11
CAL      WRITE(IOUT,FMT=1011) NFAIL,NFAILY
CAL      IF (ONLINE)WRITE(ITOUT,FMT=1011)
C
C   If this is a B or C film being treated as an A film,
C   it may be possible
C   to find reflections by reducing MINT.
C
      IF (FILM.GT.1) THEN
      IF (ONLINE) WRITE(ITOUT,FMT=1102) MINT
      WRITE(IOUT,FMT=1102) MINT
      END IF
C
C
      MODE = 999
      RETURN
C
C
 11   CALL SORTUP3(NREF,IX,IY,IREC)
      NMR = NREF
C
C---- Return if list is for detecting spot overlap.
C
      IF (MODE.EQ.-1) RETURN 
      IF (MODE.EQ.-2) THEN
        WRITE(ICOORD) NREF
        WRITE(ICOORD) (IX(I),IY(I),IREC(I),I=1,NREF)
C
C---- Must now reset OMEGA0
C
        IF (RESETCCOM.AND.(.NOT.LAST)) THEN
          SINOM0 = SSINOM0
          COSOM0 = SCOSOM0
        END IF
        RETURN
      END IF
C
C  If adding partials from the next image, or doing postrefinement
C  (MODE = 4,5)  the partial reflection
C  must always come first in the sorted list. This will not necessarily
C  happen in SORTUP3, so must check and resort as necessary. Note that
C  the summed partials may not even be adjacent...they may occur anywhere
C  amongst reflections with the same value of IX
        IF (MODE.GE.4) THEN
          DO 30 I = 1,NREF-1
             IXI = IX(I)
             IFREC = ABS(IREC(I))
             DO 35 J = I+1,NREF
               IXJ = IX(J)
               IF (IXJ.NE.IXI) GOTO 30
               ISREC = ABS(IREC(J))
               IF (ISREC.EQ.IFREC) THEN
C
C---- Pair found, move intervening records up
C
                  IF (J-I.GT.1) THEN
                    DO 37 K = J, I+2, -1
                       IX(K) = IX(K-1)
                       IY(K) = IY(K-1)
                       IREC(K) = IREC(K-1)
 37                 CONTINUE
                  END IF
                  IX(I+1) = IX(I)
                  IY(I+1) = IY(I)
                  IREC(I) = -IFREC
                  IREC(I+1) = IFREC
               END IF
 35          CONTINUE
 30       CONTINUE
        END IF
        IF (DEBUG(16)) THEN
          IF ((MODE.EQ.4).OR.(MODE.EQ.5)) THEN
            WRITE(IOUT,FMT=6006) NPARTEND
            IF (ONLINE) WRITE(ITOUT,FMT=6006) NPARTEND
          ELSE
            WRITE(IOUT,FMT=6007) NPARTEND
            IF (ONLINE) WRITE(ITOUT,FMT=6007) NPARTEND
          END IF
 6006     FORMAT(/1X,I5,' Partials at end of range duplicated')
 6007     FORMAT(/1X,I5,' Partials at end of range')
          WRITE(IOUT,FMT=6008) NREF
          IF (ONLINE) WRITE(ITOUT,FMT=6008) NREF
 6008     FORMAT(1X,I6,' reflections generated in total')
          NPRINT = MIN(NREF,NDEBUG(16))
          WRITE(IOUT,FMT=6002) NPRINT
          IF (ONLINE) WRITE(ITOUT,FMT=6002) NPRINT
 6002     FORMAT(1X,'List of first',I5,'sorted reflections IX,IY,IREC')
          DO 40 I=1,NPRINT
            IF (ONLINE) WRITE(ITOUT,FMT=6004) IX(I),IY(I),IREC(I)
            WRITE(IOUT,FMT=6004) IX(I),IY(I),IREC(I)
 6004       FORMAT(1X,3I6)
 40       CONTINUE
       END IF
C
C---- Set IREC(NREF+1) to zero, so that in MEAS the test for a partial
C     pair is not accidently true for the last reflection
C
      IF (NREF+1.GT.NREFLS) GOTO 90
      IREC(NREF+1) = 0
C
      IF(NFAIL.GT.0) THEN
        NWRN = NWRN + 1
        IF ((ONLINE).AND.(MODE.NE.6))WRITE(ITOUT,FMT=75) NFAIL
        IF (MODE.NE.6) WRITE(IOUT,FMT=75) NFAIL
      END IF
C
C
      IF(NFAILY.GT.0) THEN
        NWRN = NWRN + 1
        IF (MODE.NE.6) WRITE(IOUT,FMT=76) NFAILY
        IF ((ONLINE).AND.(MODE.NE.6))WRITE(ITOUT,FMT=76) NFAILY
      END IF
C
C
      RETURN
C
 90   WRITE(IOUT,FMT=6000) NREFLS
      IF (ONLINE) WRITE(ITOUT,FMT=6000) NREFLS
 6000 FORMAT(//,1X,'***** FATAL ERROR *****'/,1X,'Too many ',
     +        'reflections generated in MEAS (current limit',I6,
     +        ')',/,1X,'Change parameter NREFLS and recompile entire',
     +         ' program')
          NSHUTERR = 1
      CALL SHUTDOWN(CALLEDFROM,LENSTR(CALLEDFROM))
C
 110  FORMAT(/1X,'In GENSORT,MODE=',I2,' XLOW,XHIGH',2I6,
     + ' YLOW,YHIGH',2I6,' FILM=',I2/1X,'TOSPT=',I5,' NSPOT=',I5,
     + ' ADDPART ',L1,' LAST ',L1, '  PTMIN',F6.3,'  IRMAX',I5)
 120  FORMAT(1X,'Reflection',I5,' XC,YC',2F8.1,'  IR,IM',2I5)
 130  FORMAT(1X,'Selected refl',I6,' with record number',I6,
     +       ' has genfile coordinates',2F8.1,' stored coordinates',2I6)
 132  FORMAT(1X,'Generated extra refl',I6,' as summed partial')
 1011 FORMAT(' No suitable spots found for',
     + 1X,'SEEKRS Refinement',/1X,I6,' Spots outside X Limits',
     + I8,' Spots outside Y limits')
 1102  FORMAT(/1X,'It may be possible to find reflections by reducing',
     + ' the value of MINT'/1X,'Current value is',I5)
  75   FORMAT(/5X,I6,' Reflections outside scanned limits on X.'/)
   76  FORMAT(5X,I6,' Reflections outside scanned limits on Y.'/)
        END
C $Id: getbru.f,v 1.6 2007/11/06 12:53:20 harry Exp $
C     
      SUBROUTINE GETBRU(NOVFL,NRECOVFL,IERR)
      IMPLICIT NONE
C
C---- routine to decode Bruker over and underflow tables for both old
C     and new-style images
C
C&&*&& include  ../inc/parameter.f
C
C $Id: parameter.f,v 1.17 2009/10/28 16:43:34 harry Exp $
C
C--- awk generated include file  parameter.h
C---- START of include file parameter.h
C
C       PARAMETERS
C       IYLENGTH.. maximum number of I*2 words of data in the 
C                  "fast" (ie most rapidly changing) direction in the
C                  digitised image. This will be HALF the number of pixels
C                  for film data (each pixel is stored in one byte)
C                  but will equal the number of pixels for IP data.
C       IXWDTH...  The maximum number of "stripes" of data in the scanned image
C                  ie the number of pixels in the "slow" direction
C                  (This is the Y direction in the MOSFLM convention)
C                  Note that the array "IMAGE" used to store the image is
C                  declared as size IYLENGTH*IXWDTH I*2 words for IP data
C                  and 2*IYLENGTH*IXWDTH BYTES for film data.
C                  If this exceeds the
C                  available memory, set ixwdth=1, recompile program
C                  and use keyword "NOCORE" when running program.
C                  Note that for the POSTREF and ADDPART options,
C                  two images have to be stored in memory at once so
C                  IXWDTH should be twice the number of records in an
C                  image.
C       MAXHEAD    maximum length of image header (in 4 byte words)
C       NREFLS.... maximum number of spots per film in generate file (250,000)
C       MAXBOX.... maximum number of pixels in measurement box (1500)
C       MAXDIM.... maximum box size in either direction (pixels) (41)
C       MAXPAX.... maximum number of packs per generate file (10000)
C       MXDOV2..... maxdim/2
C       MAXBUFF... maximum size of buffer (I*2) for storing ods
C                  of active spots in subroutine meas(21,000).
C                  Must be .GE.  MAXBOX*(NNLINE-1) for subroutine process
C       MREF...... maximum number of reflections to be used in post
C                  refinement (6000)
C       NEXPAND... maximum number of expansions of the input measurement
C                  box (2)
C       NMASKS.... maximum number of different profiles (25). Note the
C                  connection between this parameter and NNLINE
C       NVECT..... maximum number of vectors for storing scanned image
C                  in filmplot (10000)
C       NIMAX..... maximum number of images to be used together in 
C                  postrefinement (NADD or WIDTH options) (100)
C       NNLINE...  maximum number of boundary lines for setting up
C                  the areas for profile fitting. The maximum possible
C                  number of standard profiles will be (NNLINE-1)**2
C                  although for a circular detector the actual number
C                  may be less than this as some boxes will lie entirely
C                  outside the detector.
C       NREJMAX... Maximum number of rejected background pixels, resulting
C                  either from overlap of adjacent spots or outliers from
C                  the background plane
C       NSPOTS...  Maximum number of found spots (for autoindexing) that can
C                  be stored (for all images). Also maximum number in 
C                  a file wriitten by IMSTILLS that can be 
C                  stored/displayed/edited. THis must be an even number
C       MCOLS....  Number of columns in output MTZ file
C       MCOLSTR..  Number of columns in output MTZ file for strategy option
C     
C       MTZ Orientation block
C        MBLENG is total length of block, MBLINT, MBLREA are numbers
C          of integers & reals
C       NDETREF    Maximum number of reflections used for detector parameter
C                  refinement (previously 62)
C       NRPAR....  Maximum number of refineable parameters for detector
C                  positional refinement (subroutine RDIST)
C       NSEGMAX..  Maximum number of segments in STRATEGY
C       NSEGMAXPR  Maximum number of segments in POST-REFINEMENT
C       MULTMAX... Maximum number of observations with same hkl in COMPLETE
C       MAXDIFF... Maximum number of different packs that a given hkl occurs on
C       NRESBIN... Maximum number of resolution bins (COMPLETE)
C
C       MAXIMG...  Maximum number of images that can be read in using the IMAGE
C                  keyword or the "read Image" menu option.
C       MXSPOT...  Maximum number of spots that can be found on one image
C                  (before rejection on spot size).
C       MXCENT...  Maximum number of active spots during spot finding 
C                  (findspots)
C
C       MGRA, NGRA... maximum number of reflections and images over which a 
C                     reflection can be spread for postrefinement.
C       MAXBGBOX    Maximum number of local background background boxes 
C                   in X and Y
C
C       MAXNPEAKS   Maximum number of local maxima within one spot
C       MAXEXCL     Maximum number of excluded areas of the same type
C                   eg reactangles, quadrilaterals, arcs, resolution shells
C
C     .. Parameters ..
      INTEGER IXWDTH
c      PARAMETER (IXWDTH=8192)
      PARAMETER (IXWDTH=12288)
      INTEGER IYLENGTH
c      PARAMETER (IYLENGTH=4096)
      PARAMETER (IYLENGTH=6144)
      INTEGER MAXHEAD
      PARAMETER (MAXHEAD=5120)
      INTEGER MAXBOX
      PARAMETER (MAXBOX=3000)
      INTEGER MAXDIM
      PARAMETER (MAXDIM=41)
      INTEGER MAXPAX
      PARAMETER (MAXPAX=10000)
      INTEGER MXDOV2
      PARAMETER (MXDOV2=MAXDIM/2)
      INTEGER NEXPAND
      PARAMETER (NEXPAND=2)
      INTEGER NNLINE
      PARAMETER (NNLINE=8)
      INTEGER NMASKS
      PARAMETER (NMASKS=49)
      INTEGER MAXBUFF
      PARAMETER (MAXBUFF=21000)
      INTEGER NREFLS
      PARAMETER (NREFLS=250000)
      INTEGER MREF
      PARAMETER (MREF=6000)
      INTEGER NVECT
      PARAMETER (NVECT=10000)
      INTEGER NIMAX
      PARAMETER (NIMAX=100)
      INTEGER NREJMAX
      PARAMETER (NREJMAX=1000)
      INTEGER NSPOTS
      PARAMETER (NSPOTS=5000)
      INTEGER MCOLS
      PARAMETER (MCOLS=18)
      INTEGER MCOLSTR
      PARAMETER (MCOLSTR=6)
      INTEGER NREFSTR
C
C---- Each reflection for strategy run needs MCOLSTR I*2 words
C     plus an I*4 word for the merging
C
      PARAMETER (NREFSTR = IXWDTH*IYLENGTH/(2+MCOLSTR))
      INTEGER MBLENG,MBLINT,MBLREA
      PARAMETER (MBLENG=185,MBLINT=29,MBLREA=156)
      INTEGER NDETREF
      PARAMETER (NDETREF=400)
      INTEGER NRPAR
      PARAMETER (NRPAR=14)
      INTEGER NSEGMAX
      PARAMETER (NSEGMAX=100)
      INTEGER NSEGMAXPR
      PARAMETER (NSEGMAXPR=100)
      INTEGER MULTMAX
      PARAMETER (MULTMAX=100)
      INTEGER MAXDIFF
      PARAMETER (MAXDIFF=100)
      INTEGER NRESBIN
      PARAMETER (NRESBIN=20)
      INTEGER MXSPOT
      PARAMETER (MXSPOT=5000)      
      INTEGER MAXIMG
      PARAMETER (MAXIMG=100)      
      INTEGER NPIXBG
      PARAMETER (NPIXBG=51)
      INTEGER MXCENT
      PARAMETER (MXCENT=500)
      INTEGER    NGRA,MGRA
      PARAMETER (NGRA=20)
      PARAMETER (MGRA=50000)
      INTEGER MAXBGBOX
      PARAMETER (MAXBGBOX=500)
      INTEGER MAXNPEAKS
      PARAMETER (MAXNPEAKS=500)
      INTEGER MAXEXCL
      PARAMETER (MAXEXCL=50)
C&&*&& end_include  ../inc/parameter.f
C     ..
C     .. scalar arguments
      INTEGER NOVFL,NRECOVFL,IERR
C     ..
C     .. local scalars
      INTEGER IPT,JPT,K,II,JJ,ISWAP,IOFFSET
C     ..
C     .. local arrays
      INTEGER BRUNDER(256),IBRUK(256)
      INTEGER*1 BRUOVFL(2048)
      CHARACTER*1 BRUOVFLC(2048),LINE(16)
      CHARACTER*9 BRU9
      CHARACTER*7 BRU7
      INTEGER*4 BRUOVFL4(512)
      INTEGER*2 BRUOVFL2(1024)
C     ..
C     .. External Subroutines ..
      EXTERNAL GETBLK
C&&*&& include  ../inc/header.f
C
C $Id: header.f,v 1.13 2009/09/03 16:24:33 harry Exp $
C
C--- awk generated include file  header.h
C---- START of include file header.h
C     .. Scalars in common block /HEADER/
      REAL HDIST,HWAVE,HRAST,HTOR,HPHIS,HPHIE,HPHIR,HOMEGAS,
     $     HOMEGAE,HTWOTHETA,HKAPPA,HCHI,
     $     HBEAMX,HBEAMY,HCCOMEGA,HTWIST,HTILT,HSIZED
      INTEGER NHEAD,NTAIL,HNULLPIX,HSERIAL,HYEAR,HDATE,HCOMPR,
     $     HBIAS,SUMBYTES,HUNDER,HDATEC,HCUTOFF,HPRCUTOFF
      LOGICAL USEHDR,USETAIL,USEDIST,USEWAVE,USEPHI,HDRSIZE
C     ..
C     .. Arrays in common block /HEADER/
      INTEGER IHEAD,HOVER
C     ..
C     .. Common Block /HEADER/
      COMMON /HEADER/ HDIST,HWAVE,HRAST,HTOR,HPHIS,HPHIE,HPHIR,
     $     HOMEGAS,HOMEGAE,HTWOTHETA,HKAPPA,HCHI,
     $     HBEAMX,HBEAMY,HCCOMEGA,HTWIST,HTILT,HSIZED,
     $     IHEAD(MAXHEAD),
     $     HOVER(3),NHEAD,NTAIL,HNULLPIX,HSERIAL,HYEAR,HDATE,
     +     HCOMPR,HBIAS,SUMBYTES,HUNDER,HDATEC,HCUTOFF,HPRCUTOFF,
     $     USEHDR,USETAIL,
     +     USEDIST,USEWAVE,USEPHI,HDRSIZE
C     ..
      CHARACTER HCOMPRESS*3,HMONTH*3,HOSCAXIS*6
      COMMON /CHEADER/ HCOMPRESS,HMONTH,HOSCAXIS
C&&*&& end_include  ../inc/header.f
C&&*&& include  ../inc/lmb.f
C
C $Id: lmb.f,v 1.8 2009/01/08 18:03:14 harry Exp $
C
C--- awk generated include file  lmb.h
C---- START of include file lmb.h
C ODSCAL is to scale image numbers into the range 0-255 for plotting
C average profiles.
C  GAIN should be equal to the overall gain (image counts per X-ray photon)
C of the system, and is used to evaluate standard deviations based on
C counting statistics assuming independent pixels (ie point spread function
C less than pixel size).
C INVERTX true if image is inverted in the slow (X) direction when read in.
C ISCAL is to scale final integrated intensities and sigmas
C IDIVIDE is the adc offset
C ICONST is a constant to be added to all pixels (normally zero) to
C        allow processing of images with zero pixel values in the scanned
C        area.
C IMGP is true if working with image plate data
C SPIRAL is true for scanners with a spiral readout (Mar, DIP2000)
C ORTHOG is true for scanners with orthogonal scan (FUJI, RAXIS, MD)
C NULLPIX is the value of pixels within the image but not in the active
C area of the detector
C TILED is true if there are inactive areas of the detector within the
C       inscribing circle or square.
C
C NTILEX Number of tiles in X direction
C NTILEY Number of tiles in Y direction
C TILEX  X Coordinates of the midpoints of the null areas between tiles
C TILEY  Y Coordinates of the midpoints of the null areas between tiles
C TILEWX Width of the null areas between tiles in X
C TILEWY Width of the null areas between tiles in Y


C MACHINE and MODEL denote the type of detector. 
C
C MACHINE is used in the following subroutines:
C GETBLK, GETHDR, INTPXL, INTPXL2, MXDSPL, OPENODS, PROCESS, PUTPXL
C Currently coded types are:
C
C         MACHINE        MODEL               COMMENTS
C         =======        =====               ========
C         MAR            180, 300, 345
C         RAXI(S)        RAXISII, RAXISIV
C         MD
C         FUJI
C         CCD1           CCD1                Princetown CCD at CHESS,Tiff format
C         CCD2           CCD ?               ESRF CCD detector
C         ADSC           QUAD1               ADSC 2x2 CCD detector
C
C TRUSTED whether or not the image header information can be trusted for 
C         automatic processing
C     .. Scalars in Common Block /LMB/ ..
        REAL ODSCAL,GAIN,LOGA,LOGB
        INTEGER ISCAL,IDIVIDE,ICONST,NULLPIX,NTILEX,NTILEY,
     $    RAXISCOMP,IIDIVIDE,COMPRESSION
        LOGICAL IMGP,INVERTX,SPIRAL,ORTHOG,CIRCULAR,TILED,SETADC,
     $    NEWRAXIS,BRUKNEW,TRUSTED
        CHARACTER MACHINE*4,MODEL*8

C     ..
C     .. Arrays in common /LMB/
        INTEGER TILEX,TILEY,TILEWX,TILEWY
C
C     .. Common Block /LMB/ ..
        COMMON /LMB/ ODSCAL,GAIN,LOGA,LOGB,ISCAL,IDIVIDE,ICONST,
     +       NULLPIX,NTILEX,NTILEY,RAXISCOMP,IIDIVIDE,COMPRESSION,
     +       TILEX(20),TILEY(20),TILEWX(20),TILEWY(20),IMGP,
     +       INVERTX,SPIRAL,ORTHOG,CIRCULAR,TILED,SETADC,
     $       NEWRAXIS,BRUKNEW,TRUSTED
        COMMON /LMBC/ MACHINE,MODEL

C&&*&& end_include  ../inc/lmb.f
C&&*&& include  ../inc/pel.f
C     **** This is the IMAGE PLATE version of this common block ****
C
C
C---- START of include file pel.h
C
C
C     .. Scalars in common blocks /PEL/ and /PELC/ ..
      INTEGER IBA,IPOINT,ISTART
      LOGICAL INCORE
C     ..
C     .. Arrays in common blocks /PEL/ and /PELC/ ..
      LOGICAL RDSTRIP
      INTEGER*2 BOXOD,IMAGE
C     ..
C     .. Common Blocks /PEL/ and /PELC/ ..
      COMMON /PEL/IBA,IPOINT,INCORE,RDSTRIP(IXWDTH),BOXOD(MAXBOX),
     +            ISTART
      COMMON /PELC/ IMAGE(IYLENGTH*IXWDTH)
C     ..
C
C
C---- END of include file pel.h
C
C&&*&& end_include  ../inc/pel.f
C&&*&& include  ../inc/scn.f
C
C $Id: scn.f,v 1.3 2004/08/16 13:26:48 harry Exp $
C
C--- awk generated include file  scn.h
C---- START of include file scn.h
C
C     SCNSZ   is pixel size (in microns) divided by 25
C     RAST    pixel size in slow direction in mm
C     FACT    multiplying by FACT converts from 10 micron units 
C             (the standard unit internal to the program) into pixels
C     IYLEN   The number of pixels in the Y (fastest changing) direction
C             in the digitised image.
C     NREC    The number of pixels in the X (slow) direction in the 
C             digitised image.
C     NWORD   The number of I*2 words in the Y direction.
C     NBYTE   The number of bytes in Y direction = NWORD/2
C     NHBYTE  Number of bytes in header
C
C     ICURR   When several images are stored in a single file, ICURR is the
C             pointer to the first record of the current image in the direct
C             access file (only implemented for film data)
C     NEXTRA  The number of additional (unused) bytes padding the end of
C             each record in image file
C     BYTSWAP True if the "endedness" (Big-endian/Little-endian) of the 
C             machine that MOSFLM is running on is different to that of the
C             machine on which the image was written. This is determined by
C             looking at the value of NXPIX in the header record of the
C             image file (subroutine GETHDR)
C
C     LACTIVE True if using Rigaku active mask, False if ignoring it
C
C     .. Scalars in common block /SCN/ ..
      REAL FACT,SCNSZ,RAST,RASTY
      INTEGER NBYTE,NREC,NWORD,IYLEN,ICURR,NEXTRA,NHBYTE
      LOGICAL BYTSWAP,LACTIVE
C     ..
C     .. Common Block /SCN/ ..
      COMMON /SCN/ FACT,SCNSZ,RAST,RASTY,NBYTE,NREC,NWORD,IYLEN,
     +     ICURR,NEXTRA,NHBYTE,BYTSWAP,LACTIVE
C&&*&& end_include  ../inc/scn.f
      EQUIVALENCE(BRUOVFL(1),BRUOVFL4(1))
      EQUIVALENCE(BRUOVFL(1),BRUOVFLC(1))
      logical litend
      external litend
      IERR = 0
      JPT = 1
C
C---- need to be able to byte swap header items
C
      ISWAP = 1
      DO 295 II = 0,NREC-1
        IOFFSET = IYLEN*II
        DO 296 JJ = 1,IYLEN
          IPT = IOFFSET + JJ
          IF(IMAGE(IPT).EQ.-8193)THEN
c            print*,'ipt (= ibruk(jpt)) = ',ipt,', jpt = ',jpt
            IBRUK(JPT) = IPT
            JPT = JPT + 1
          ENDIF
 296    ENDDO
 295  ENDDO
C     ..
C     .. new-style images first - only need look for 4-byte overflows
      IF(BRUKNEW)THEN
        CALL GETBLK(BRUOVFL,NRECOVFL,1,ISWAP,IERR)
        JPT = 1
C     ..
C     .. underflows .. first get them ... can be 1, 2 or 4 byte
        IF(HOVER(1).GT.0)THEN
          DO 310 IPT = 1,HOVER(1),1
            IF(HUNDER.EQ.1)BRUNDER(IPT) = BRUOVFL(JPT)
            IF(HUNDER.EQ.2)BRUNDER(IPT) = BRUOVFL2(JPT)
            IF(HUNDER.EQ.4)BRUNDER(IPT) = BRUOVFL4(JPT)
            JPT = JPT + 1
 310      ENDDO
        ENDIF
C     ..
C     .. count to end of 16 byte multiple
        IPT = MAX(0,(16/(JPT*HUNDER))-16)
C     ..
C     .. if we had 2 byte overflows the following would be '2*J*HUNDER*I'
C     
        JPT = (4*JPT*HUNDER*IPT)+1
C     ..
C     .. 2 byte overflows .. we shouldn't have any as we're only
C     dealing with 2 byte images 
C     
c     DO 305 IPT = 1,HOVER(2),1
c     BROVER2(IPT) = BRUOVFL2(JPT)
c     JPT = JPT + 1
c     305       ENDDO
C     ..
C     .. 4 byte overflows
        IF(HOVER(3).GT.0)THEN 
          IF(BYTSWAP)CALL SWAPHDR(BRUOVFL4(JPT),HOVER(3))
          DO 300 IPT = 1,HOVER(3),1
            IMAGE(IBRUK(IPT)) = -(BRUOVFL4(JPT)+4)/8 
            JPT = JPT + 1
 300      ENDDO
        ENDIF
C     ..
C     .. now apply the underflows or ADC offset as appropriate - this is
C     .. untested!
C     
        IF(HOVER(1).GT.0)THEN
          JPT = 1
          DO 320 IPT=1,NREC*IYLEN,1
            IF(IMAGE(IPT).EQ.0)THEN
              IMAGE(IPT) = BRUNDER(JPT)
              JPT = JPT + 1
            ELSE
              IMAGE(IPT) = IMAGE(IPT) + ICONST
            ENDIF
 320      ENDDO
        ENDIF
      ELSE
C     .. old-style image
        CALL GETBLK(BRUOVFL,NRECOVFL,1,ISWAP,IERR)
        DO 340 IPT = 1,NOVFL,1
          K = 16 * (IPT-1) + 1
          II = 0
C
          BRU9 = BRUOVFLC(K)//BRUOVFLC(K+1)//BRUOVFLC(K+2)//
     $         BRUOVFLC(K+3)//BRUOVFLC(K+4)//BRUOVFLC(K+5)//
     &         BRUOVFLC(K+6)//BRUOVFLC(K+7)//BRUOVFLC(K+8)
          BRU7 = BRUOVFLC(K+9)//BRUOVFLC(K+10)//BRUOVFLC(K+11)//
     $         BRUOVFLC(K+12)//BRUOVFLC(K+13)//BRUOVFLC(K+14)//
     &         BRUOVFLC(K+15)
          CALL CHAR2INT(II,BRU9,9)
          CALL CHAR2INT(JJ,BRU7,7)
          K = K + 16
C     
C---- Bruker images are inverted, so need to convert JJ to appropriate
C     value
C     
          K = (JJ/NREC)+1
          JPT = (JJ - ((JJ/NREC)*NREC)) + 1
          IMAGE(JPT+(IYLEN*(IYLEN-K))) = -(II+4)/8
 340    ENDDO
        
      ENDIF
      RETURN
      END
C $Id: integ2.f,v 1.9 2009/07/17 12:47:46 andrew Exp $
C== INTEG2 ==
      SUBROUTINE INTEG2(OD,IPROFL,IRAS,MASK,MASKREJ,MASKREJP,LMASKREJP,
     +  MASKREJO,PQVAL,PQSUMS,PQSUMINV,PROFSUMS,WPROFSUMS,IDR,
     +  NBREJ,BGSIG,FULL,IPART,WEIGHT,OVRLFIT,CUTOFF,EDGEFIT,ISUMPART,
     +  PKWDLIM1,PKWDLIM2,PKWDLIM3,XDEBUG,PKONLY,PKWDOUTL,IOUTL1,
     +  IOUTL2,DECONV,BADSPOT)
C      =============================================================
C
      IMPLICIT NONE
C
C
C---- *** WARNING **** ASPOT(14) (PEAKVAR) may well not be correct
C     if there are rejected peak pixels and WEIGHTED profile fitting
C     is NOT being used.
C
C     This subroutine is called from subroutine "process". MASK
C     contains the peak/background mask definition (peak pixels
C     have a value  +1, background pixels -1)and rejected
C     background pixels (due to overlapping neighbouring spots)
C     have been flagged with value 0. (This has been done by
C     subroutine MASKIT).  MASKREJ contains a list of
C     these rejected background pixels.
C
C---- Determine integrated intensities for all spots in final
C     pass. Determines both the simple integrated intensity and
C     the profile fitted intensity with optional weighting.
C     Allows rejection of background points more than BGSIG*RMSBG
C     from best background plane.
C     If changemask is set, the background points may have been
C     modified during formation of the standard profiles.
C     thus the background area may no longer have mm symmetry if
C     NBREJ, the number of points rejected, is non-zero,
C     but **** the peak area is always assumed to have mm symmetry ***
C     and this is implicit in the equations for the integrated intensity.
C
C     OD      Array containing pixel values
C
C     IPROFL  Array conating the profile to be used in evaluating
C             profile fitted intensity for this reflection.
C
C     IRAS    Raster parameters (NX,NY,NC,NRX,NRY)
C
C     MASK    Array defining peak/background and rejected pixels.
C             When using variable profiles this mask can be different
C             for different spots in the same "standard profile area"
C             and is set up in "process" using information from "getprof".
C             This array is unchanged.
C
C     MASKREJ Array containing list of rejected background pixels
C             due to overlap of neighbouring spots.
C             This is unchanged.
C
C     MASKREJP Array containing list of rejected peak pixels
C             due to overlap of neighbouring spots.
C             This is unchanged.
C
C     LMASKREJP Array containing list of rejected peak pixels
C             due to very poor profile fit. This is set up in this
C             subroutine and passed back to PROCESS and PLOTPROF
C
C     MASKREJO Array containing list of rejected background pixels
C              because they are outliers. This is set up in EVAL
C              and passed back to PROCESS for use in PROFPLOT.
C
C     ISUMPART = 0 normally
C              = 1 for a summed partial (need to subtract 2*adcoffset)
C
C     Elements of PROFSUMS
C     1 = sum p*P          p,q are pixel coords wrt centre of box
C     2 = sum q*P          P is the profile value
C     3 = sum P            summations are over peak pixels only
C     4 = sum P*P 
C
C     Elements of WPROFSUMS
C     1 = sum p*P          p,q are pixel coords wrt centre of box
C     2 = sum q*P          P is the profile value
C     3 = sum P            summations is over all pixels except rejected
C     4 = sum P*P          background pixels.
C
C
C     Elements of PQVAL
C     p,q are pixel coords wrt centre of box
C     1 = sum p*p  for peak
C     2 = sum p*p  for background
C     3 = sum q*q  for peak
C     4 = sum q*q  for background
C     5 = number of peak pixels
C     6 = number of background pixels
C
C     Elements of PQSUMS
C     p,q are pixel coords wrt centre of box, all sums are for background
C        points ONLY. Note that these values are copied to a local array 
C        SPOTPQSUM because they are updated for every spot based
C        on rejected background pixels (done in BGTEST)
C     1 = sum p*p  
C     2 = sum q*q
C     3 = sum p*q
C     4 = sum p
C     5 = sum q
C     6 = number of background pixels
C
C     Elements of ASPOT
C     1 = Summation integration intensity
C     2 = Total background counts under peak assuming peak has mm symmetry
C     3 = Rms variation in background, after rejecting background points.
C         This is evaluated in BGSOLVE called from EVAL.
C     4 = Centre of gravity in X direction (in pixels)
C     5 = Centre of gravity in Y direction (in pixels)
C         These are wrt an origin at the centre of the measurement box
C     6 = sum p*iod for background pixels
C     7 = sum q*iod for background pixels
C     8 = sum iod for background pixels
C     9 = Background plane constant a (gradient in X direction)
C    10 = Background plane constant b (gradient in Y direction)
C    11 = Background plane constant c 
C    12 = Largest deviation from background plane, excluding rejected pixels
C    13 = Profile fitted intensity
C    14 = Variance of profile fitted intensity = sum (deltasq) for peak
C         pixels only. Used to calculate PKRATIO and also profile fitted
C         sigma(I) in unweighted case only.
C    15 = Number of rejected background pixels
C    16 = Variance of profile fitted intensity in weighted case (default)
C
C
C    WEIGHT TRUE if using a weighted fit of standard profile to reflection
C           profile. Set TRUE by default, only changed by specific keyword.
C
C    PKONLY TRUE if only peak pixels are to be used in the profile fitting.
C           Normally FALSE, but if the SEPARATION CLOSE option is set then
C           PKONLY is set TRUE, because in this case the background pixels
C           flagged as overlapped are worked out on a spot by spot basis,
C           while the standard profile will be an average of all spots and
C           so will have non-zero values at positions where that background
C           pixel is overlapped for ANY spot in that region of the detector,
C           while it  might not be overlapped for the particular reflection
C           being integrated.
C     ..
C     .. Parameters ..
C&&*&& include  ../inc/parameter.f
C
C $Id: parameter.f,v 1.17 2009/10/28 16:43:34 harry Exp $
C
C--- awk generated include file  parameter.h
C---- START of include file parameter.h
C
C       PARAMETERS
C       IYLENGTH.. maximum number of I*2 words of data in the 
C                  "fast" (ie most rapidly changing) direction in the
C                  digitised image. This will be HALF the number of pixels
C                  for film data (each pixel is stored in one byte)
C                  but will equal the number of pixels for IP data.
C       IXWDTH...  The maximum number of "stripes" of data in the scanned image
C                  ie the number of pixels in the "slow" direction
C                  (This is the Y direction in the MOSFLM convention)
C                  Note that the array "IMAGE" used to store the image is
C                  declared as size IYLENGTH*IXWDTH I*2 words for IP data
C                  and 2*IYLENGTH*IXWDTH BYTES for film data.
C                  If this exceeds the
C                  available memory, set ixwdth=1, recompile program
C                  and use keyword "NOCORE" when running program.
C                  Note that for the POSTREF and ADDPART options,
C                  two images have to be stored in memory at once so
C                  IXWDTH should be twice the number of records in an
C                  image.
C       MAXHEAD    maximum length of image header (in 4 byte words)
C       NREFLS.... maximum number of spots per film in generate file (250,000)
C       MAXBOX.... maximum number of pixels in measurement box (1500)
C       MAXDIM.... maximum box size in either direction (pixels) (41)
C       MAXPAX.... maximum number of packs per generate file (10000)
C       MXDOV2..... maxdim/2
C       MAXBUFF... maximum size of buffer (I*2) for storing ods
C                  of active spots in subroutine meas(21,000).
C                  Must be .GE.  MAXBOX*(NNLINE-1) for subroutine process
C       MREF...... maximum number of reflections to be used in post
C                  refinement (6000)
C       NEXPAND... maximum number of expansions of the input measurement
C                  box (2)
C       NMASKS.... maximum number of different profiles (25). Note the
C                  connection between this parameter and NNLINE
C       NVECT..... maximum number of vectors for storing scanned image
C                  in filmplot (10000)
C       NIMAX..... maximum number of images to be used together in 
C                  postrefinement (NADD or WIDTH options) (100)
C       NNLINE...  maximum number of boundary lines for setting up
C                  the areas for profile fitting. The maximum possible
C                  number of standard profiles will be (NNLINE-1)**2
C                  although for a circular detector the actual number
C                  may be less than this as some boxes will lie entirely
C                  outside the detector.
C       NREJMAX... Maximum number of rejected background pixels, resulting
C                  either from overlap of adjacent spots or outliers from
C                  the background plane
C       NSPOTS...  Maximum number of found spots (for autoindexing) that can
C                  be stored (for all images). Also maximum number in 
C                  a file wriitten by IMSTILLS that can be 
C                  stored/displayed/edited. THis must be an even number
C       MCOLS....  Number of columns in output MTZ file
C       MCOLSTR..  Number of columns in output MTZ file for strategy option
C     
C       MTZ Orientation block
C        MBLENG is total length of block, MBLINT, MBLREA are numbers
C          of integers & reals
C       NDETREF    Maximum number of reflections used for detector parameter
C                  refinement (previously 62)
C       NRPAR....  Maximum number of refineable parameters for detector
C                  positional refinement (subroutine RDIST)
C       NSEGMAX..  Maximum number of segments in STRATEGY
C       NSEGMAXPR  Maximum number of segments in POST-REFINEMENT
C       MULTMAX... Maximum number of observations with same hkl in COMPLETE
C       MAXDIFF... Maximum number of different packs that a given hkl occurs on
C       NRESBIN... Maximum number of resolution bins (COMPLETE)
C
C       MAXIMG...  Maximum number of images that can be read in using the IMAGE
C                  keyword or the "read Image" menu option.
C       MXSPOT...  Maximum number of spots that can be found on one image
C                  (before rejection on spot size).
C       MXCENT...  Maximum number of active spots during spot finding 
C                  (findspots)
C
C       MGRA, NGRA... maximum number of reflections and images over which a 
C                     reflection can be spread for postrefinement.
C       MAXBGBOX    Maximum number of local background background boxes 
C                   in X and Y
C
C       MAXNPEAKS   Maximum number of local maxima within one spot
C       MAXEXCL     Maximum number of excluded areas of the same type
C                   eg reactangles, quadrilaterals, arcs, resolution shells
C
C     .. Parameters ..
      INTEGER IXWDTH
c      PARAMETER (IXWDTH=8192)
      PARAMETER (IXWDTH=12288)
      INTEGER IYLENGTH
c      PARAMETER (IYLENGTH=4096)
      PARAMETER (IYLENGTH=6144)
      INTEGER MAXHEAD
      PARAMETER (MAXHEAD=5120)
      INTEGER MAXBOX
      PARAMETER (MAXBOX=3000)
      INTEGER MAXDIM
      PARAMETER (MAXDIM=41)
      INTEGER MAXPAX
      PARAMETER (MAXPAX=10000)
      INTEGER MXDOV2
      PARAMETER (MXDOV2=MAXDIM/2)
      INTEGER NEXPAND
      PARAMETER (NEXPAND=2)
      INTEGER NNLINE
      PARAMETER (NNLINE=8)
      INTEGER NMASKS
      PARAMETER (NMASKS=49)
      INTEGER MAXBUFF
      PARAMETER (MAXBUFF=21000)
      INTEGER NREFLS
      PARAMETER (NREFLS=250000)
      INTEGER MREF
      PARAMETER (MREF=6000)
      INTEGER NVECT
      PARAMETER (NVECT=10000)
      INTEGER NIMAX
      PARAMETER (NIMAX=100)
      INTEGER NREJMAX
      PARAMETER (NREJMAX=1000)
      INTEGER NSPOTS
      PARAMETER (NSPOTS=5000)
      INTEGER MCOLS
      PARAMETER (MCOLS=18)
      INTEGER MCOLSTR
      PARAMETER (MCOLSTR=6)
      INTEGER NREFSTR
C
C---- Each reflection for strategy run needs MCOLSTR I*2 words
C     plus an I*4 word for the merging
C
      PARAMETER (NREFSTR = IXWDTH*IYLENGTH/(2+MCOLSTR))
      INTEGER MBLENG,MBLINT,MBLREA
      PARAMETER (MBLENG=185,MBLINT=29,MBLREA=156)
      INTEGER NDETREF
      PARAMETER (NDETREF=400)
      INTEGER NRPAR
      PARAMETER (NRPAR=14)
      INTEGER NSEGMAX
      PARAMETER (NSEGMAX=100)
      INTEGER NSEGMAXPR
      PARAMETER (NSEGMAXPR=100)
      INTEGER MULTMAX
      PARAMETER (MULTMAX=100)
      INTEGER MAXDIFF
      PARAMETER (MAXDIFF=100)
      INTEGER NRESBIN
      PARAMETER (NRESBIN=20)
      INTEGER MXSPOT
      PARAMETER (MXSPOT=5000)      
      INTEGER MAXIMG
      PARAMETER (MAXIMG=100)      
      INTEGER NPIXBG
      PARAMETER (NPIXBG=51)
      INTEGER MXCENT
      PARAMETER (MXCENT=500)
      INTEGER    NGRA,MGRA
      PARAMETER (NGRA=20)
      PARAMETER (MGRA=50000)
      INTEGER MAXBGBOX
      PARAMETER (MAXBGBOX=500)
      INTEGER MAXNPEAKS
      PARAMETER (MAXNPEAKS=500)
      INTEGER MAXEXCL
      PARAMETER (MAXEXCL=50)
C&&*&& end_include  ../inc/parameter.f
C     ..
C     .. Scalar Arguments ..
      REAL BGSIG,PKWDLIM1,PKWDLIM2,PKWDLIM3,PKWDOUTL
      INTEGER IDR,NBREJ,CUTOFF,IPART,ISUMPART,IOUTL1,IOUTL2
      LOGICAL FULL,WEIGHT,OVRLFIT,EDGEFIT,XDEBUG,PKONLY,DECONV,
     +        BADSPOT
C     ..
C     .. Array Arguments ..
      REAL PQSUMINV(3,3),PQSUMS(6),PQVAL(6),PROFSUMS(4),WPROFSUMS(4)
      INTEGER IRAS(5),MASK(MAXBOX),OD(MAXBOX),IPROFL(MAXBOX),
     +        MASKREJ(NREJMAX),MASKREJP(NREJMAX),MASKREJO(NREJMAX),
     +        LMASKREJP(NREJMAX)
C     ..
C     .. Local Scalars ..
      REAL A,B,C,RMSBG,SBGOD,SBGPOD,SBGQOD,
     +     SPKOD,SPKODSQ,SPKPOD,SPKQOD,SUMPROD,SWPR,SWPPR,SWPRSQ,
     +     SWQPR,SWPSQ,SWPQ,SWP,SWQSQ,SWQ,SW,SWPOD,SWQOD,SWOD,SWPROD,
     +     WT,WTPR,XJ,BGDEVMAX,WSCAL,PART,AS,BS,CS,RHOC,RHOC1,PSCALE,
     +     SWDELSQ,DEL,SDELSQ,WDELSQ,WDEL,APKWDOUTL
      INTEGER HX,HY,IJ,IOD,K,P,Q,NRLMAX,NRFL,IPROFIJ,I,NXX,NYY,NDBG,
     +     NREJ,NPIX,N,MODE,MULT,MAXPIX,NREJP,NBADP,IPASS,NBADSAVE,
     +     MODEP,IERR
      LOGICAL PEAKREJ,BADPIX,OUTLIERS,SSIGN,INRANGE,ZEROD
      CHARACTER CALLEDFROM*80
C     ..
C     .. Local Arrays ..
      REAL ABC(3),SPOTPQSUM(6),SPQOD(3),PROFSUML(4),PMAT(4,4),
     +     PMATI(4,4),X(4),XR(4),WPROFSUML(4)
      INTEGER LMASK(MAXBOX)
C     ..
C     .. External Subroutines ..
      EXTERNAL SHUTDOWN,PIXOVERLAP,ODPLOT4,
     +         RASPLOT4,EVAL,MINV4,MATVEC4
C     ..
C     .. Intrinsic Functions ..
      INTRINSIC ABS,MAX,SQRT,REAL
C     ..
C     .. Common blocks ..
C&&*&& include  ../inc/backg.f
C
C $Id: backg.f,v 1.1 2002/05/02 10:46:40 harry Exp $
C
C--- awk generated include file  backg.h
C---- START of include file backg.h
C
C
C
C     .. Scalars in common block /BACKG/ ..
      REAL BGFRAC
      INTEGER NBGMIN
C     ..
C     .. Common Block /BACKG/ ..
      COMMON /BACKG/ BGFRAC,NBGMIN
C     ..
C
C
C&&*&& end_include  ../inc/backg.f
C&&*&& include  ../inc/debug.f
C
C $Id: debug.f,v 1.2 2008/07/24 09:42:21 andrew Exp $
C
C--- awk generated include file  debug.h
C---- START of include file debug.h
C
C
C
C     .. Arrays in common /DEBUG/ ..
      REAL XWARN
      INTEGER NDEBUG,IWARN
      LOGICAL DEBUG,LPRINT,DUMP,WARN
C
C     .. Scalars in common /DEBUG/ ..
      REAL BGRLIM
      INTEGER NDUMP,IDUMP,MXDUMP
      LOGICAL SPOT
C     
C     ..
C     .. Common Block /DEBUG/..
      COMMON /DEBUG/XWARN(20,100),BGRLIM,NDEBUG(100),IWARN(20,100),
     $       NDUMP,IDUMP,MXDUMP,DEBUG(100),LPRINT(20),DUMP(30),
     +       WARN(100),SPOT
C     ..
C
C&&*&& end_include  ../inc/debug.f
C&&*&& include  ../inc/ioo.f
C
C $Id: ioo.f,v 1.7 2009/05/13 11:57:53 harry Exp $
C
C--- awk generated include file  ioo.h
C---- START of include file ioo.h
C
C
C
C     .. Scalars in common block /IOO/ ..
      INTEGER IOUT,IUNIT,ITIN,ITOUT,INOD,INMO,IDU,NWRN,IBRIEF,ISUMMR,
     +        ICOORD,SERVERFD,SERVERFDIN,NSHUTERR,dnafd
      LOGICAL ONLINE,ONEFILE,FHEADER,BRIEF,GRAPH,IOERR,
     $     NODISPLAY,LBELL,JPGOUT,SOCKLO,LBEST,dnaout,INMOOPEN,
     $     XMLOPEN
      CHARACTER dna_image*80,xmlfile*80
C     ..
C     .. Common block /IOO/ ..
c      COMMON /IOO/IOUT,IUNIT,ONLINE,ITIN,ITOUT,INOD,INMO,IDU,NWRN,
c     +            ONEFILE,FHEADER,BRIEF,IBRIEF,GRAPH,ISUMMR,ICOORD,
c     +            IOERR,NODISPLAY,LBELL
C     ..
C
C
      COMMON /IOO/IOUT,IUNIT,ITIN,ITOUT,INOD,INMO,IDU,NWRN,IBRIEF,
     +        ISUMMR,ICOORD,SERVERFD,SERVERFDIN,NSHUTERR,ONLINE,ONEFILE,
     +        FHEADER,BRIEF,GRAPH,IOERR,NODISPLAY,LBELL,JPGOUT,
     $        SOCKLO,LBEST, dnafd, dnaout,INMOOPEN,XMLOPEN
      COMMON /CIOO/dna_image,xmlfile

C&&*&& end_include  ../inc/ioo.f
C&&*&& include  ../inc/lmb.f
C
C $Id: lmb.f,v 1.8 2009/01/08 18:03:14 harry Exp $
C
C--- awk generated include file  lmb.h
C---- START of include file lmb.h
C ODSCAL is to scale image numbers into the range 0-255 for plotting
C average profiles.
C  GAIN should be equal to the overall gain (image counts per X-ray photon)
C of the system, and is used to evaluate standard deviations based on
C counting statistics assuming independent pixels (ie point spread function
C less than pixel size).
C INVERTX true if image is inverted in the slow (X) direction when read in.
C ISCAL is to scale final integrated intensities and sigmas
C IDIVIDE is the adc offset
C ICONST is a constant to be added to all pixels (normally zero) to
C        allow processing of images with zero pixel values in the scanned
C        area.
C IMGP is true if working with image plate data
C SPIRAL is true for scanners with a spiral readout (Mar, DIP2000)
C ORTHOG is true for scanners with orthogonal scan (FUJI, RAXIS, MD)
C NULLPIX is the value of pixels within the image but not in the active
C area of the detector
C TILED is true if there are inactive areas of the detector within the
C       inscribing circle or square.
C
C NTILEX Number of tiles in X direction
C NTILEY Number of tiles in Y direction
C TILEX  X Coordinates of the midpoints of the null areas between tiles
C TILEY  Y Coordinates of the midpoints of the null areas between tiles
C TILEWX Width of the null areas between tiles in X
C TILEWY Width of the null areas between tiles in Y


C MACHINE and MODEL denote the type of detector. 
C
C MACHINE is used in the following subroutines:
C GETBLK, GETHDR, INTPXL, INTPXL2, MXDSPL, OPENODS, PROCESS, PUTPXL
C Currently coded types are:
C
C         MACHINE        MODEL               COMMENTS
C         =======        =====               ========
C         MAR            180, 300, 345
C         RAXI(S)        RAXISII, RAXISIV
C         MD
C         FUJI
C         CCD1           CCD1                Princetown CCD at CHESS,Tiff format
C         CCD2           CCD ?               ESRF CCD detector
C         ADSC           QUAD1               ADSC 2x2 CCD detector
C
C TRUSTED whether or not the image header information can be trusted for 
C         automatic processing
C     .. Scalars in Common Block /LMB/ ..
        REAL ODSCAL,GAIN,LOGA,LOGB
        INTEGER ISCAL,IDIVIDE,ICONST,NULLPIX,NTILEX,NTILEY,
     $    RAXISCOMP,IIDIVIDE,COMPRESSION
        LOGICAL IMGP,INVERTX,SPIRAL,ORTHOG,CIRCULAR,TILED,SETADC,
     $    NEWRAXIS,BRUKNEW,TRUSTED
        CHARACTER MACHINE*4,MODEL*8

C     ..
C     .. Arrays in common /LMB/
        INTEGER TILEX,TILEY,TILEWX,TILEWY
C
C     .. Common Block /LMB/ ..
        COMMON /LMB/ ODSCAL,GAIN,LOGA,LOGB,ISCAL,IDIVIDE,ICONST,
     +       NULLPIX,NTILEX,NTILEY,RAXISCOMP,IIDIVIDE,COMPRESSION,
     +       TILEX(20),TILEY(20),TILEWX(20),TILEWY(20),IMGP,
     +       INVERTX,SPIRAL,ORTHOG,CIRCULAR,TILED,SETADC,
     $       NEWRAXIS,BRUKNEW,TRUSTED
        COMMON /LMBC/ MACHINE,MODEL

C&&*&& end_include  ../inc/lmb.f
C&&*&& include  ../inc/sums.f
C
C $Id: sums.f,v 1.1 2002/05/02 10:47:21 harry Exp $
C
C--- awk generated include file  sums.h
C---- START of include file sums.h
C
C
C     Elements of ASPOT
C     1 = Summation integration intensity
C     2 = Total background counts under peak assuming peak has mm symmetry
C     3 = Rms variation in background, after rejecting background points.
C         This is evaluated in BGSOLVE called from EVAL.
C     4 = Centre of gravity in X direction (in pixels)
C     5 = Centre of gravity in Y direction (in pixels)
C         These are wrt an origin at the centre of the measurement box
C     6 = sum p*iod for background pixels
C     7 = sum q*iod for background pixels
C     8 = sum iod for background pixels
C     9 = Background plane constant a (gradient in X direction)
C    10 = Background plane constant b (gradient in Y direction)
C    11 = Background plane constant c 
C    12 = Largest deviation from background plane, excluding rejected pixels
C    13 = Profile fitted intensity
C    14 = Variance of profile fitted intensity = sum (deltasq) for peak
C         pixels only. Used to calculate PKRATIO and also profile fitted
C         sigma(I) in unweighted case only.
C    15 = Number of rejected background pixels
C    16 = Variance of profile fitted intensity in weighted case (default)
C    17 = sum W*DELTA**2 for profile fit
C    18   unused
C     .. Arrays in common block /SUMS/ ..
      REAL ASPOT
C     ..
C     .. Common Block /SUMS/ ..
      COMMON /SUMS/ASPOT(18)
C     ..
C
C
C&&*&& end_include  ../inc/sums.f
C     ..
C     .. Equivalences ..
      EQUIVALENCE (SPQOD(1),SBGPOD), (SPQOD(2),SBGQOD), (SPQOD(3),SBGOD)
      EQUIVALENCE (ASPOT(3),RMSBG)
      EQUIVALENCE (ASPOT(6),SBGPOD)
      EQUIVALENCE (ASPOT(7),SBGQOD), (ASPOT(8),SBGOD), (ASPOT(9),A)
      EQUIVALENCE (ASPOT(10),B), (ASPOT(11),C), (ASPOT(12),BGDEVMAX)
C     ..
      SAVE
C
      DATA NDBG/0/
C
      IF (XDEBUG) DEBUG(34) = .TRUE.

      BADSPOT = .FALSE.
      MAXPIX = 0
      IPASS = 0
      NBADP = 0
      NBADSAVE = 0
      BADPIX = .FALSE.
      OUTLIERS = .FALSE.
      APKWDOUTL = ABS(PKWDOUTL)
C
C---- Number of rejected peak pixels
C
      NREJP = MASKREJP(1)
      PEAKREJ = (NREJP.GT.0)
C
C
C---- Mode for EVAL (signifies we now have flagged overlapped background
C                     pixels)
      MODE = 1
      NRFL = 1
      NXX = IRAS(1)
      NYY = IRAS(2)
      HX = NXX/2
      HY = NYY/2
C
C---- Debug o/p
C
      IF (XDEBUG) THEN
         WRITE(IOUT,FMT=6000)
         IF (ONLINE) WRITE(ITOUT,FMT=6000)
 6000    FORMAT(/,1X,'In INTEG2, Profile for this reflection')
         CALL RASPLOT4(OD,NXX,NYY,MASK(1),
     +                    MASKREJ(1),IDR,1,.FALSE.,.FALSE.)
      END IF
C
C  If fitting an overload, an edge reflection or a reflection with 
C  rejected peak pixels (due to overlapping spots) copy PROFSUMS into
C  a local array as it will be updated
C
      IF (OVRLFIT.OR.EDGEFIT.OR.PEAKREJ) THEN
        DO 2 I=1,4
          PROFSUML(I) = PROFSUMS(I)
          WPROFSUML(I) = WPROFSUMS(I)
 2      CONTINUE
      END IF
C
C
      DO 5 I=1,18                           
 5    ASPOT(I) = 0.0
      IJ = 0
      SPKPOD = 0
      SPKQOD = 0                    
      SPKOD = 0
      SPKODSQ = 0
      SBGPOD = 0
      SBGQOD = 0
      SBGOD = 0
      SUMPROD = 0
      IF (DEBUG(34).AND.SPOT.AND.(NDBG.LE.NDEBUG(34))) 
     +       CALL ODPLOT4(OD(1),NXX,NYY,IDR,MAXPIX)
C                      
C
      DO 40 P = -HX,HX
        DO 30 Q = -HY,HY
          IJ = IJ + 1
C
C---- Set LMASK to 1 for all pixels in box, modified later to zero
C     for background pixels overlapped by neighbouring spots,
C     to 2 for peak pixels overlapped by neighbouring spots,
C     and to -1 for pixels next to these overlapped pixels, and to zero
C     for background outliers, and -2 for pixels adjacent to -1 pixels
C     if DECONV set TRUE.
C
          LMASK(IJ) = 1
          IOD = OD(IJ)
C
C
          IF (MASK(IJ).EQ.0) THEN
            GO TO 30
            ELSE IF (MASK(IJ).GT.0) THEN
            GO TO 20
          END IF
C
C---- Sums for background
C
   10     SBGOD = SBGOD + IOD
          SBGPOD = P*IOD + SBGPOD
          SBGQOD = Q*IOD + SBGQOD
          GO TO 30
C
C---- Sums for peak
C
   20     SPKOD = SPKOD + IOD
C
   30   CONTINUE
   40 CONTINUE
C      IF (DEBUG(34)) WRITE(6,*),'END OF LOOP, NBR,ASPOT',NBREJ,ASPOT
C
C---- Background constants
C
      IF (NBREJ.EQ.0) THEN
        A = SBGPOD/PQVAL(2)
        B = SBGQOD/PQVAL(4)
        C = SBGOD/PQVAL(6)
      ELSE
C
C---- Now set LMASK zero for rejected background pixels from CHANGEMASK
C
        DO 42 N = 1,NBREJ
          IJ = MASKREJ(N+1)
          LMASK(IJ) = 0
 42     CONTINUE
C
C            **************************
        CALL MATVEC(ABC,PQSUMINV,SPQOD)
C            **************************
C
        A = ABC(1)
        B = ABC(2)
        C = ABC(3)
      END IF
C
C
      ASPOT(6) = SBGPOD
      ASPOT(7) = SBGQOD
      ASPOT(8) = SBGOD
      ASPOT(9) = A
      ASPOT(10) = B
      ASPOT(11) = C
      IF (DEBUG(34).AND.(NDBG.LE.NDEBUG(34))) THEN
          WRITE(IOUT,FMT=6010) NBREJ,NREJP,PQSUMINV,PQVAL,ASPOT
          IF (ONLINE) WRITE(ITOUT,FMT=6010) NBREJ,NREJP,
     +      PQSUMINV,PQVAL,ASPOT
6010   FORMAT(/1X,'***DEBUG OUTPUT FROM INTEG2 ***',/,1X,
     +      'NBREJ',I5,' NREJP',I3,'  PQSUMINV',9F12.8,/,1X,
     +      'PQVAL',6F10.1,/,1X,
     +      'Contents of ASPOT after solving for ',
     +      'background',(/1X,5F12.1))
          NDBG = NDBG + 1
      END IF
C
C---- Copy pqsums to a local array because they will be updated in
C     BGTEST called from EVAL
C
        DO 50 K = 1,6
          SPOTPQSUM(K) = PQSUMS(K)
   50   CONTINUE
C
C   Set maximum allowed number of allowed background pixels to be
C   rejected from background plane determination. Must use PQSUMS
C   here in case background pixels have already been rejected by
C   CHANGEMASK...these pixels are not tested again.
C
      NRLMAX = NINT(PQSUMS(6)) - NBGMIN
C
C---- Tets for too few background points
C
      IF (NRLMAX.LT.0) THEN
        ASPOT(1) = -9999.0
        RETURN
      END IF
C
C---- Determine the optimum background plane constants, allowing
C     for the possibility of adjacent spots intruding into the background
C     Returns improved estimates for "A,B,C" via ASPOTS
C
C          ***********************************************
      CALL EVAL(OD(1),MASK(1),IRAS,SPOTPQSUM,BGSIG,NRLMAX,NRFL,
     +          MASKREJO,DEBUG(34),MODE)
C          ***********************************************
C
        IF (DEBUG(34).AND.(NDBG.LE.NDEBUG(34))) THEN
          WRITE(IOUT,FMT=6020) MASKREJO(1),NRLMAX,ASPOT
          IF (ONLINE) WRITE(ITOUT,FMT=6020) MASKREJO(1),NRLMAX,ASPOT
6020   FORMAT(1X,'In INTEG2, NBREJ, NRLMAX',2I5,/,1X,
     +           'Contents of ASPOT after calling EVAL'
     +      ,(/1X,5F12.1))
        END IF
C
C---- Check that not too many background points have been rejected
C     (Flagged by NRLMAX=-999)
C
      IF (NRLMAX.EQ.-999) THEN
        ASPOT(1) = -9999.0
        RETURN
      END IF
C
C---- Total background under peak (assuming peak has mm symmetry)
C
      ASPOT(2) = PQVAL(5)*C
C
C---- Summation integration intensity
C
      ASPOT(1) = SPKOD - ASPOT(2)
C
C     ASPOT(2) is used in calculation of counting statistics errors.
C     Must subtract scanner adc offset here (stored in IDIVIDE). For summed
C     partials, must subtract twice the offset
C
      IF (ISUMPART.EQ.1) THEN
        MULT = 2
      ELSE
        MULT = 1
      END IF
      ASPOT(2) = ASPOT(2) - PQVAL(5)*IDIVIDE*MULT
C
C---- Number of additional (to CHANGEMASK) rejected background pixels
C
      ASPOT(15) = MASKREJO(1)
C
C---- Now evaluate profile fitted intensity. Note that weighted profile
C     fit requires a knowledge of the summation integration intensity
C     and the plane constants
C
      WSCAL = ASPOT(1)/PROFSUMS(3)
C
C---- If WSCAL is negative (ie integrated intensity is negative) then
C     set to zero
C
      IF (WSCAL.LT.0.0) WSCAL = 0.0
C
C---- For partials, correct WSCAL for the degree of partiality. This may
C     introduce a significant error into the estimate of the integrated
C     intensity for spots that are only just recorded (ie are mostly on
C     the abutting image) but the contribution to the total intensity for
C     such spots will only be very small anyway, so an error in the
C     weighting will have a negligable effect
C
      PART = ABS(REAL(IPART))
      IF (.NOT.FULL) WSCAL = WSCAL/(0.01*PART)
C
C
C---- Now set LMASK TO 2 for rejected peak pixels
C
      IF (PEAKREJ) THEN
        DO 52 N = 1,NREJP
          IJ = MASKREJP(N+1)
          LMASK(IJ) = 2
 52    CONTINUE
      END IF
C
C---- Now set LMASK to -1 for pixels adjacent to rejected peak and
C     background pixels due to overlap by neighbouring spots.
C     If DECONV is TRUE set pixels adjacent to -1 pixels to -2.
C
      IF (DECONV) THEN
        MODEP = 2
      ELSE
        MODEP = 1
      END IF
C
      CALL PIXOVERLAP(MODEP,LMASK,NXX,NYY,HX,HY)
C
C---- Now set LMASK zero for additional rejected background pixels 
C     returned from EVAL
C
      NREJ = MASKREJO(1)
      IF (NREJ.GT.0) THEN
        DO 54 N = 1,NREJ
          IJ = MASKREJO(N+1)
          LMASK(IJ) = 0
 54     CONTINUE
      END IF

C---- Print LMASK if debugging
C
      IF (XDEBUG) THEN
        WRITE(IOUT,FMT=6050)
        IF (ONLINE) WRITE(ITOUT,FMT=6050)
 6050   FORMAT(/,1X,'Array LMASK after calling PIXOVERLAP',/,1X,
     +   'Overlapped or background outlier pixels: 0, pixels',
     +   ' adjacent to overlapped pixels: -1',/,1X,'Overlapped',
     +   ' peak pixels: 2, OK pixels: 1, Adjacent to adjacent to',
     +   ' overlapped pixels -2')
        CALL ODPLOT4(LMASK(1),NXX,NYY,IDR,MAXPIX)
      END IF
C
 56   SWPPR = 0
      SWQPR = 0
      SWPR = 0
      SWPRSQ = 0
      SWPSQ = 0
      SWPQ = 0
      SWP = 0
      SWQSQ = 0
      SWQ = 0
      SW = 0
      SWPOD = 0
      SWQOD = 0
      SWOD = 0
      SWPROD = 0
C
      IJ = 0
C
      DO 70 P = -HX,HX
        DO 60 Q = -HY,HY
          IJ = IJ + 1
          IOD = OD(IJ)
C
C---- Consider ALL pixels except rejected background ones
C     LMASK has values:
C     -2        pixels adjacent to pixels flagged as -1 (only if DECONV)
C     -1        pixels next to overlapped pixels
C      0        background pixels rejected either as overlapped or as
C               outliers
C      1        OK pixels (can be peak or background)
C      2        overlapped peak pixels or rejected outlier peak pixels
C
          IF (LMASK(IJ).EQ.0) GOTO 60
C
C---- If only fitting peak pixels, test this too
C
          IF (PKONLY.AND.(MASK(IJ).NE.1)) GOTO 60
C
C----  Check for fitting an overload or reflection partially outside
C      scanned area
C
            IF ((OVRLFIT.AND.(IOD.GT.CUTOFF)).OR.      
     +          (EDGEFIT.AND.(IOD.LE.NULLPIX)).OR.
     +          (PEAKREJ.AND.(LMASK(IJ).EQ.2))) THEN
               IF (MASK(IJ).GT.0) THEN
                 IPROFIJ = IPROFL(IJ)
                 PROFSUML(1) = PROFSUML(1) - P*IPROFIJ
                 PROFSUML(2) = PROFSUML(2) - Q*IPROFIJ
                 PROFSUML(3) = PROFSUML(3) - IPROFIJ
                 PROFSUML(4) = PROFSUML(4) - IPROFIJ*IPROFIJ
               END IF
            ELSE
C
C---- Unweighted sums for peak pixels only
C
              IF (MASK(IJ).GT.0) THEN
                SUMPROD = REAL(IPROFL(IJ))*REAL(IOD) + SUMPROD
                SPKODSQ = REAL(IOD)*REAL(IOD) + SPKODSQ
              END IF
C
C---- Sums for weighted profile fit
C
              IF (WEIGHT) THEN
C
C---- Weight is inverse of expectation value of counts at this pixel
C
                IPROFIJ = IPROFL(IJ)
                IF (IPROFIJ.GE.0) THEN
                  WT = GAIN*(A*P+B*Q+C+WSCAL*IPROFIJ)
                ELSE
                  WT = GAIN*(A*P+B*Q+C)
                END IF
                IF (WT.NE.0) WT = 1.0/WT
C
C---- If deconvoluting adjacent peaks, correct the weight.
C     For first tests, simply set weight to zero for edge pixels
C     adjacent to overlapped background pixels
C
                IF (DECONV.AND.(LMASK(IJ).LE.-1)) WT = 0.0
C
CAL                IF (XDEBUG) WRITE(6,*),'Using pixel',P+HX+1,Q+HY+1,IOD,WT
C
                WTPR = IPROFL(IJ)*WT
                SWPPR = P*WTPR + SWPPR
                SWQPR = Q*WTPR + SWQPR
                SWPR = SWPR + WTPR
CAL                SWPRSQ = WTPR*WTPR/WT + SWPRSQ
                SWPRSQ = WTPR*IPROFL(IJ) + SWPRSQ
                SWPSQ = SWPSQ + WT*P*P
                SWPQ = SWPQ + WT*P*Q
                SWP = SWP + WT*P
                SWQSQ = SWQSQ + WT*Q*Q
                SWQ = SWQ + WT*Q
                SW = SW + WT
                SWPOD = WT*P*IOD + SWPOD
                SWQOD = WT*Q*IOD + SWQOD
                SWOD = WT*IOD + SWOD
                SWPROD = WTPR*IOD + SWPROD
              END IF
            END IF
C
C
          IF ((FULL).AND.(MASK(IJ).GT.0).AND.
     +                   (.NOT.(OVRLFIT.OR.EDGEFIT.OR.PEAKREJ))) THEN
C
C---- Sums for c of g shift and profile sigma
C
            SPKPOD = IOD*P + SPKPOD
            SPKQOD = IOD*Q + SPKQOD
          END IF                  
C
 60     CONTINUE
 70   CONTINUE
C
C---- Profile fitted intensity
C
C
C
        IF (WEIGHT) THEN
C
C---- First evaluate PEAKVAR used to calculate PKRATIO
C     This is done using the old formulation, and does not involve weights
C     **** No longer used ***
CAL          XI = (SUMPROD-PROFSUMS(1)*A-PROFSUMS(2)*B-
CAL     +                PROFSUMS(3)*C)*PROFSUMS(3)/PROFSUMS(4)
CAL
CAL       XJ = XI/PROFSUMS(3)
C          ASPOT(14) = XJ*XJ*PROFSUMS(4) + A*A*PQVAL(1) + B*B*PQVAL(3) +
C     +              C*C*PQVAL(5) + SPKODSQ +
C     +              2*XJ* (PROFSUMS(1)*A+PROFSUMS(2)*B+PROFSUMS(3)*C-
C     +              SUMPROD) - 2*A*SPKPOD - 2*B*SPKQOD - 2*C*SPKOD
C
C
          PMAT(1,1) = SWPRSQ
          PMAT(1,2) = SWPPR
          PMAT(1,3) = SWQPR
          PMAT(1,4) = SWPR
C
          PMAT(2,1) = SWPPR
          PMAT(2,2) = SWPSQ
          PMAT(2,3) = SWPQ
          PMAT(2,4) = SWP
C
          PMAT(3,1) = SWQPR
          PMAT(3,2) = SWPQ
          PMAT(3,3) = SWQSQ
          PMAT(3,4) = SWQ
C
          PMAT(4,1) = SWPR
          PMAT(4,2) = SWP
          PMAT(4,3) = SWQ
          PMAT(4,4) = SW
C
          X(1) = SWPROD
          X(2) = SWPOD
          X(3) = SWQOD
          X(4) = SWOD
C
C---- The four by four matrix solves for the scale factor to scale this 
C     reflection to the standard profile and the 3 background plane
C     constants
C
          ZEROD = .FALSE.
          CALL MINV4(PMAT,PMATI,IERR)
C
C---- Check for zero determinant
C
          IF (IERR.GT.0) THEN
            ZEROD = .TRUE.
            GOTO 74
          END IF
          CALL MATVEC4(XR,PMATI,X)
          PSCALE = XR(1)
          AS = XR(2)
          BS = XR(3)
          CS = XR(4)
          ASPOT(13) = XR(1)*WPROFSUMS(3)
C
C---- For partials, cannot allow the background plane parameters to
C     be determined from profile fit to whole box, use those
C     determined from the (non-rejected) background pixels
C
C---- Also allow this as an option to deal with cases where the profile
C     values are not zero even in the background region, because of
C     high spot density (CLOSE option)
C
C---- Also use this route if the determinant of 4x4 matrix was zero !
C
 74       IF ((.NOT.FULL).OR.PKONLY.OR.ZEROD) THEN
            AS = A
            BS = B
            CS = C
            IF (SWPRSQ.NE.0.0) THEN
               PSCALE = (SWPROD - A*SWPPR - B*SWQPR - C*SWPR)/SWPRSQ 
            ELSE
               PSCALE = 0.0
            END IF
            ASPOT(13) = PSCALE*WPROFSUMS(3)
            IF (PKONLY) ASPOT(13) = PSCALE*PROFSUMS(3)
          END IF
          IF (DEBUG(34).AND.(NDBG.LE.NDEBUG(34))) THEN
             WRITE(IOUT,FMT=6024) A,B,C,AS,BS,CS,ASPOT(13),IPASS,
     +                            PSCALE,WSCAL,NBADP,PQVAL(5)
             IF (ONLINE) WRITE(ITOUT,FMT=6024) A,B,C,AS,BS,CS,
     +                     ASPOT(13),IPASS,PSCALE,WSCAL,NBADP,PQVAL(5)
          END IF
 6024     FORMAT(1X,'Old plane constants',2F9.2,
     +             F9.1,/,1X,'New plane constants and profile',
     +             ' intensity',2F9.2,F8.1,F8.0,/,1X,'IPASS=',I1,
     +             ' PSCALE',F8.5, ' WSCAL',F8.5,' Number of flagged',
     +             ' peak pixels',I3,' number of peak pixels',F4.0)
C
C---- Now need to loop over all pixels again to evaluate sum(w*deltasq)
C     required for sigma calculations
C
          IJ = 0
          NPIX = 0
          SWDELSQ = 0.0
          SDELSQ = 0.0
C
          DO 90 P = -HX,HX
            RHOC1 = P*AS + CS
            DO 80 Q = -HY,HY
              IJ = IJ + 1
C
C---- Consider ALL pixels except rejected background ones
C
              IF (LMASK(IJ).EQ.0) GOTO 80
C
C---- Reject non-peak pixels if only fitting peak pixels
C
              IF (PKONLY.AND.(MASK(IJ).NE.1)) GOTO 80
C
              IOD = OD(IJ)
              RHOC = RHOC1 + Q*BS + PSCALE*IPROFL(IJ) 
              DEL = (REAL(IOD) - RHOC)
C
C----  Check for fitting an overload or reflection partially outside
C      scanned area
C
                IF ((OVRLFIT.AND.(IOD.GT.CUTOFF)) .OR.      
     +              (EDGEFIT.AND.(IOD.LE.NULLPIX)) .OR.
     +              (PEAKREJ.AND.(LMASK(IJ).EQ.2))) THEN
                  GOTO 80
                ELSE
C
C---- Weight is inverse of expectation value of counts at this pixel
C     (Must use same weights here as in previous loop, ie do not use
C     updated A,B,C
C
                    IPROFIJ = IPROFL(IJ)
                    IF (IPROFIJ.GE.0) THEN
                      WT = GAIN*(A*P+B*Q+C+WSCAL*IPROFIJ)
                    ELSE
                      WT = GAIN*(A*P+B*Q+C)
                    END IF
CAL       IF (WT.LE.0.0) WRITE(6,*),'ZERO/NEG WT,WSCAL,NPIX,IJ,IPART',
CAL     +         WT,WSCAL,NPIX,IJ,IPART
                    IF (WT.NE.0) WT = 1.0/WT
C
C---- If deconvoluting adjacent peaks, correct the weight.
C     For first tests, simply set weight to zero for edge pixels
C     adjacent to overlapped background pixels
C
                    IF (DECONV.AND.(LMASK(IJ).LE.-1)) WT = 0.0
C
                    WDELSQ = WT*DEL*DEL
                    IF (WDELSQ.GT.0) WDEL = SQRT(WDELSQ)
C
C---- Outlier detection (eg speckles in Mar scanners)
C
                    SSIGN = (((DEL.LT.0).AND.(PKWDOUTL.LT.0)).OR.
     +                      ((DEL.GT.0).AND.(PKWDOUTL.GT.0)))
                    SSIGN = (SSIGN.AND.(WDEL.GT.APKWDOUTL))
                    INRANGE = ((IOD.GE.IOUTL1).AND.(IOD.LE.IOUTL2))
                    SWDELSQ = SWDELSQ + WDELSQ
C
C---- Flag any peak pixels that fit particularly badly
C
                    IF ((MASK(IJ).GT.0).AND.((WDEL.GT.PKWDLIM1).OR.
     +                                   (WDEL.GT.PKWDLIM2).OR.
     +              (SSIGN.AND.INRANGE))) THEN
     +              
C
C     On the first pass, only flag pixels that are adjacent to
C     overlapped pixels and outliers
C
                      IF (IPASS.EQ.0) THEN
                        BADPIX = .TRUE.
                        IF (((LMASK(IJ).LE.-1).AND.
     +                                   (WDEL.GT.PKWDLIM2)).OR.
     +                       (SSIGN.AND.INRANGE)) THEN
                          NBADP = NBADP + 1
                          LMASKREJP(NBADP+1) = IJ
                        END IF
                      ELSE
C     On second or subsequent passes, reject any pixel, but note
C     different tests are done for pixels with neighbouring overlapped
C     pixels and the rest. Do NOT allow rejections for partials
C     as these are not expected to fit.
C
                        IF (((LMASK(IJ).LE.-1).AND.
     +                                   (WDEL.GT.PKWDLIM2)).OR.
     +                             (FULL.AND.(WDEL.GT.PKWDLIM1)).OR.
     +                             (SSIGN.AND.INRANGE)) THEN
                          NBADP = NBADP + 1
                          LMASKREJP(NBADP+1) = IJ
                        END IF
                      END IF
                    END IF
C
C---- Sum of del**2 for non-rejected peak pixels only, use in PKRATIO
C
                    IF (MASK(IJ).GT.0) SDELSQ = SDELSQ + DEL*DEL
                    NPIX = NPIX + 1
                END IF
C
C---- End of loop over pixels
C
 80         CONTINUE
 90       CONTINUE
C
C---- If there are not too many very badly fitting pixels, repeat profile
C     fit rejecting these pixels. Only allow this if not more than 1/3rd
C     of pixels has been flagged. Otherwise there is probably something wrong
C     with this spot.
C
          LMASKREJP(1) = NBADP
          IF ((NBADP-NBADSAVE).GT.0) THEN
             IF (NBADP.LT.NINT(0.33*PQVAL(5))) THEN
                DO 100 I = 1,NBADP
                  IJ = LMASKREJP(I+1)
                  LMASK(IJ) = 2
 100            CONTINUE
                PEAKREJ = .TRUE.
                IPASS = IPASS + 1
                NBADSAVE = NBADP
                IF (IPASS.LE.2) GOTO 56
             ELSE
C
C---- Too many pixels rejected
C
                IF (DEBUG(34).AND.(NDBG.LE.NDEBUG(34))) THEN
                  WRITE(IOUT,FMT=6060) NBADP
                  IF (ONLINE) WRITE(ITOUT,FMT=6060) NBADP
 6060             FORMAT(/,1X,'Profile fit too poor to allow further ',
     +            'pixel rejection, number rejected is',I4,/)
                END IF
                NBADP = NBADSAVE
                LMASKREJP(1) = NBADP
                GOTO 110
             END IF
          END IF
C
C---- If there are badly fitting pixels not next to overlapped pixels
C     then these should be rejected on a second pass, if this has not
C     been initiated by badly fitting pixels next to overlapped pixels
C
          IF (BADPIX) THEN
            IPASS = IPASS + 1
            BADPIX = .FALSE.
            GOTO 56
          END IF 
C
C---- Calculate the variance in profile scale factor PSCALE and hence the
C     variance in the profile fitted intensity
C
 110      IF (FULL.AND.(DEBUG(34))) 
     +         WRITE(6,*)'SWDELSQ,INT',SWDELSQ/(NPIX-4.0),ASPOT(13)
          IF (NPIX.GT.4) THEN
C
C---- Apparently need to scale up the sum of del**2 (by 1.4) 
C     to get PKRATIO of 1 for "ideal" cases. However, in other cases
C     this gives rather too many badspots rejected on PKRATIO, 
C     so do not scale up for time being.
C     Note that ASPOT(14) is also used to calculate the profile fitted
C     sigma in the PKONLY case.
C
            ASPOT(14) = 1.0*SDELSQ
C
            DEL = SWDELSQ*PMATI(1,1)/REAL(NPIX-4)
            ASPOT(16) = DEL*WPROFSUMS(3)*WPROFSUMS(3)
          ELSE
            ASPOT(14) = 1.0*SDELSQ
            DEL = 0.0
            IF (NPIX.GT.0) DEL = SWDELSQ*PMATI(1,1)/REAL(NPIX)
            ASPOT(16) = DEL*WPROFSUMS(3)*WPROFSUMS(3)
            BADSPOT = .TRUE.
CAL            WRITE(IOUT,FMT=6030) NPIX
CAL            IF (ONLINE) WRITE(ITOUT,FMT=6030) NPIX
 6030 FORMAT(1X,'*** FATAL ERROR ***',/,1X,' There are only',I3,
     + ' pixels being used to evaluate the background plane constants',
     + /,1X,'and profile fitted intensity for this reflection',/,1X,
     +  'This is not sufficient to determine these parameters')
CAL             CALL SHUTDOWN(CALLEDFROM,LENSTR(CALLEDFROM))
           END IF
C
C---- Update the background plane constants to those calculated from the
C     4*4 matrix fit.
C
           A = AS
           B = BS
           C = CS
C
C---- If profile fitting overloaded reflections or "edge" reflections
C     set PEAKVAR to zero and set the summation integration intensity to the
C     profile fitted intensity
C
          IF (OVRLFIT.OR.EDGEFIT) THEN
            ASPOT(14) = 0.0
            ASPOT(1) = ASPOT(13)
          END IF
C
        ELSE
C
C---- UNWEIGHTED profile fitting, use original formulation
C
          ASPOT(13) = (SUMPROD-PROFSUMS(1)*A-PROFSUMS(2)*B-
     +                PROFSUMS(3)*C)*PROFSUMS(3)/PROFSUMS(4)
C
C---- Profile peak sigma
C
          XJ = ASPOT(13)/PROFSUMS(3)
          ASPOT(14) = XJ*XJ*PROFSUMS(4) + A*A*PQVAL(1) + B*B*PQVAL(3) +
     +              C*C*PQVAL(5) + SPKODSQ +
     +              2*XJ* (PROFSUMS(1)*A+PROFSUMS(2)*B+PROFSUMS(3)*C-
     +              SUMPROD) - 2*A*SPKPOD - 2*B*SPKQOD - 2*C*SPKOD
C
C---- Overload fitting, use PROFSUML instead
C
          IF (OVRLFIT.OR.EDGEFIT.OR.PEAKREJ) THEN
            ASPOT(13) = (SUMPROD-PROFSUML(1)*A-PROFSUML(2)*B-
     +                  PROFSUML(3)*C)*PROFSUMS(3)/PROFSUML(4)
            ASPOT(14) = 0.0
            ASPOT(1) = ASPOT(13)
          END IF
C
        END IF
C
      IF (FULL.AND.(.NOT.(OVRLFIT.OR.EDGEFIT))) THEN
C
C----- Catch zero spots
C
        IF (ASPOT(1).NE.0.0) THEN
C
C---- C of g shifts, delx and dely, fully recorded only
C
          ASPOT(4) = (SPKPOD-PQVAL(1)*A)/ASPOT(1)*IDR
          ASPOT(5) = (SPKQOD-PQVAL(3)*B)/ASPOT(1)
C
        ELSE
          ASPOT(4) = 0.0
          ASPOT(5) = 0.0
        END IF
      END IF
C
      IF (XDEBUG) THEN
        WRITE(IOUT,FMT=6040) ASPOT
        IF (ONLINE) WRITE(ITOUT,FMT=6040) ASPOT
 6040   FORMAT(1X,'Final values in ASPOT on returning from INTEG2',/,
     +         (1X,6F12.0))
      END IF
      IF (XDEBUG) DEBUG(34) = .FALSE.
      XDEBUG = .FALSE.
      
C
      END
C== INTEG ==
      SUBROUTINE INTEG(OD,IRAS,MASK,PQVAL,IDR,FULL,BGKSIG,MASKREJ,
     +                 PQSUMS,NRBX)
C     =============================================
      IMPLICIT NONE
C
C---- Evaluate the integrated intensity, centre of gravity, background
C     plane constants and rms variation in background of a spot
C     with the measurement box stored in OD.
C
C     Elements of PQVAL
C     p,q are pixel coords wrt centre of box
C     1 = sum p*p  for peak
C     2 = sum p*p  for background
C     3 = sum q*q  for peak
C     4 = sum q*q  for background
C     5 = number of peak pixels
C     6 = number of background pixels
C
C     Elements of PQSUMS
C     This array is set up int this subroutine, and then updated fro rejected
C     background pixels in BGTEST.
C     p,q are pixel coords wrt centre of box, all sums are for background
C        points ONLY. Note that these sums are updated for every spot based
C        on rejected background pixels (done in BGTEST)
C     1 = sum p*p  
C     2 = sum q*q
C     3 = sum p*q
C     4 = sum p
C     5 = sum q
C     6 = number of background pixels
C
C
C     Modified to deal with background point rejection 14/3/91
C
C     .. Parameters ..
C&&*&& include  ../inc/parameter.f
C
C $Id: parameter.f,v 1.17 2009/10/28 16:43:34 harry Exp $
C
C--- awk generated include file  parameter.h
C---- START of include file parameter.h
C
C       PARAMETERS
C       IYLENGTH.. maximum number of I*2 words of data in the 
C                  "fast" (ie most rapidly changing) direction in the
C                  digitised image. This will be HALF the number of pixels
C                  for film data (each pixel is stored in one byte)
C                  but will equal the number of pixels for IP data.
C       IXWDTH...  The maximum number of "stripes" of data in the scanned image
C                  ie the number of pixels in the "slow" direction
C                  (This is the Y direction in the MOSFLM convention)
C                  Note that the array "IMAGE" used to store the image is
C                  declared as size IYLENGTH*IXWDTH I*2 words for IP data
C                  and 2*IYLENGTH*IXWDTH BYTES for film data.
C                  If this exceeds the
C                  available memory, set ixwdth=1, recompile program
C                  and use keyword "NOCORE" when running program.
C                  Note that for the POSTREF and ADDPART options,
C                  two images have to be stored in memory at once so
C                  IXWDTH should be twice the number of records in an
C                  image.
C       MAXHEAD    maximum length of image header (in 4 byte words)
C       NREFLS.... maximum number of spots per film in generate file (250,000)
C       MAXBOX.... maximum number of pixels in measurement box (1500)
C       MAXDIM.... maximum box size in either direction (pixels) (41)
C       MAXPAX.... maximum number of packs per generate file (10000)
C       MXDOV2..... maxdim/2
C       MAXBUFF... maximum size of buffer (I*2) for storing ods
C                  of active spots in subroutine meas(21,000).
C                  Must be .GE.  MAXBOX*(NNLINE-1) for subroutine process
C       MREF...... maximum number of reflections to be used in post
C                  refinement (6000)
C       NEXPAND... maximum number of expansions of the input measurement
C                  box (2)
C       NMASKS.... maximum number of different profiles (25). Note the
C                  connection between this parameter and NNLINE
C       NVECT..... maximum number of vectors for storing scanned image
C                  in filmplot (10000)
C       NIMAX..... maximum number of images to be used together in 
C                  postrefinement (NADD or WIDTH options) (100)
C       NNLINE...  maximum number of boundary lines for setting up
C                  the areas for profile fitting. The maximum possible
C                  number of standard profiles will be (NNLINE-1)**2
C                  although for a circular detector the actual number
C                  may be less than this as some boxes will lie entirely
C                  outside the detector.
C       NREJMAX... Maximum number of rejected background pixels, resulting
C                  either from overlap of adjacent spots or outliers from
C                  the background plane
C       NSPOTS...  Maximum number of found spots (for autoindexing) that can
C                  be stored (for all images). Also maximum number in 
C                  a file wriitten by IMSTILLS that can be 
C                  stored/displayed/edited. THis must be an even number
C       MCOLS....  Number of columns in output MTZ file
C       MCOLSTR..  Number of columns in output MTZ file for strategy option
C     
C       MTZ Orientation block
C        MBLENG is total length of block, MBLINT, MBLREA are numbers
C          of integers & reals
C       NDETREF    Maximum number of reflections used for detector parameter
C                  refinement (previously 62)
C       NRPAR....  Maximum number of refineable parameters for detector
C                  positional refinement (subroutine RDIST)
C       NSEGMAX..  Maximum number of segments in STRATEGY
C       NSEGMAXPR  Maximum number of segments in POST-REFINEMENT
C       MULTMAX... Maximum number of observations with same hkl in COMPLETE
C       MAXDIFF... Maximum number of different packs that a given hkl occurs on
C       NRESBIN... Maximum number of resolution bins (COMPLETE)
C
C       MAXIMG...  Maximum number of images that can be read in using the IMAGE
C                  keyword or the "read Image" menu option.
C       MXSPOT...  Maximum number of spots that can be found on one image
C                  (before rejection on spot size).
C       MXCENT...  Maximum number of active spots during spot finding 
C                  (findspots)
C
C       MGRA, NGRA... maximum number of reflections and images over which a 
C                     reflection can be spread for postrefinement.
C       MAXBGBOX    Maximum number of local background background boxes 
C                   in X and Y
C
C       MAXNPEAKS   Maximum number of local maxima within one spot
C       MAXEXCL     Maximum number of excluded areas of the same type
C                   eg reactangles, quadrilaterals, arcs, resolution shells
C
C     .. Parameters ..
      INTEGER IXWDTH
c      PARAMETER (IXWDTH=8192)
      PARAMETER (IXWDTH=12288)
      INTEGER IYLENGTH
c      PARAMETER (IYLENGTH=4096)
      PARAMETER (IYLENGTH=6144)
      INTEGER MAXHEAD
      PARAMETER (MAXHEAD=5120)
      INTEGER MAXBOX
      PARAMETER (MAXBOX=3000)
      INTEGER MAXDIM
      PARAMETER (MAXDIM=41)
      INTEGER MAXPAX
      PARAMETER (MAXPAX=10000)
      INTEGER MXDOV2
      PARAMETER (MXDOV2=MAXDIM/2)
      INTEGER NEXPAND
      PARAMETER (NEXPAND=2)
      INTEGER NNLINE
      PARAMETER (NNLINE=8)
      INTEGER NMASKS
      PARAMETER (NMASKS=49)
      INTEGER MAXBUFF
      PARAMETER (MAXBUFF=21000)
      INTEGER NREFLS
      PARAMETER (NREFLS=250000)
      INTEGER MREF
      PARAMETER (MREF=6000)
      INTEGER NVECT
      PARAMETER (NVECT=10000)
      INTEGER NIMAX
      PARAMETER (NIMAX=100)
      INTEGER NREJMAX
      PARAMETER (NREJMAX=1000)
      INTEGER NSPOTS
      PARAMETER (NSPOTS=5000)
      INTEGER MCOLS
      PARAMETER (MCOLS=18)
      INTEGER MCOLSTR
      PARAMETER (MCOLSTR=6)
      INTEGER NREFSTR
C
C---- Each reflection for strategy run needs MCOLSTR I*2 words
C     plus an I*4 word for the merging
C
      PARAMETER (NREFSTR = IXWDTH*IYLENGTH/(2+MCOLSTR))
      INTEGER MBLENG,MBLINT,MBLREA
      PARAMETER (MBLENG=185,MBLINT=29,MBLREA=156)
      INTEGER NDETREF
      PARAMETER (NDETREF=400)
      INTEGER NRPAR
      PARAMETER (NRPAR=14)
      INTEGER NSEGMAX
      PARAMETER (NSEGMAX=100)
      INTEGER NSEGMAXPR
      PARAMETER (NSEGMAXPR=100)
      INTEGER MULTMAX
      PARAMETER (MULTMAX=100)
      INTEGER MAXDIFF
      PARAMETER (MAXDIFF=100)
      INTEGER NRESBIN
      PARAMETER (NRESBIN=20)
      INTEGER MXSPOT
      PARAMETER (MXSPOT=5000)      
      INTEGER MAXIMG
      PARAMETER (MAXIMG=100)      
      INTEGER NPIXBG
      PARAMETER (NPIXBG=51)
      INTEGER MXCENT
      PARAMETER (MXCENT=500)
      INTEGER    NGRA,MGRA
      PARAMETER (NGRA=20)
      PARAMETER (MGRA=50000)
      INTEGER MAXBGBOX
      PARAMETER (MAXBGBOX=500)
      INTEGER MAXNPEAKS
      PARAMETER (MAXNPEAKS=500)
      INTEGER MAXEXCL
      PARAMETER (MAXEXCL=50)
C&&*&& end_include  ../inc/parameter.f
C     ..
C     .. Scalar Arguments ..
      REAL BGKSIG
      INTEGER IDR,NRBX
      LOGICAL FULL
C     ..
C     .. Array Arguments ..
      REAL PQVAL(6),PQSUMS(6)
      INTEGER IRAS(5),MASK(MAXBOX),OD(MAXBOX),MASKREJ(NREJMAX)
C     ..
C     .. Local Scalars ..
      REAL A,B,C,SP,SQ,SPQ,
     +    SOD,SPOD,SQOD,TOD,TPOD,TQOD
      INTEGER HX,HY,IJ,IOD,P,Q,NXY,NBKG,NRLMAX,NDBG,NXX,NYY,MODE

C     ..
C     .. Local Arrays ..
C     ..
C     ..
C     .. External Subroutines ..
      EXTERNAL EVAL
C     .. Intrinsic Functions ..
      INTRINSIC ABS,MAX,SQRT
C     ..
C     .. Common blocks ..
C&&*&& include  ../inc/backg.f
C
C $Id: backg.f,v 1.1 2002/05/02 10:46:40 harry Exp $
C
C--- awk generated include file  backg.h
C---- START of include file backg.h
C
C
C
C     .. Scalars in common block /BACKG/ ..
      REAL BGFRAC
      INTEGER NBGMIN
C     ..
C     .. Common Block /BACKG/ ..
      COMMON /BACKG/ BGFRAC,NBGMIN
C     ..
C
C
C&&*&& end_include  ../inc/backg.f
C&&*&& include  ../inc/debug.f
C
C $Id: debug.f,v 1.2 2008/07/24 09:42:21 andrew Exp $
C
C--- awk generated include file  debug.h
C---- START of include file debug.h
C
C
C
C     .. Arrays in common /DEBUG/ ..
      REAL XWARN
      INTEGER NDEBUG,IWARN
      LOGICAL DEBUG,LPRINT,DUMP,WARN
C
C     .. Scalars in common /DEBUG/ ..
      REAL BGRLIM
      INTEGER NDUMP,IDUMP,MXDUMP
      LOGICAL SPOT
C     
C     ..
C     .. Common Block /DEBUG/..
      COMMON /DEBUG/XWARN(20,100),BGRLIM,NDEBUG(100),IWARN(20,100),
     $       NDUMP,IDUMP,MXDUMP,DEBUG(100),LPRINT(20),DUMP(30),
     +       WARN(100),SPOT
C     ..
C
C&&*&& end_include  ../inc/debug.f
C&&*&& include  ../inc/ioo.f
C
C $Id: ioo.f,v 1.7 2009/05/13 11:57:53 harry Exp $
C
C--- awk generated include file  ioo.h
C---- START of include file ioo.h
C
C
C
C     .. Scalars in common block /IOO/ ..
      INTEGER IOUT,IUNIT,ITIN,ITOUT,INOD,INMO,IDU,NWRN,IBRIEF,ISUMMR,
     +        ICOORD,SERVERFD,SERVERFDIN,NSHUTERR,dnafd
      LOGICAL ONLINE,ONEFILE,FHEADER,BRIEF,GRAPH,IOERR,
     $     NODISPLAY,LBELL,JPGOUT,SOCKLO,LBEST,dnaout,INMOOPEN,
     $     XMLOPEN
      CHARACTER dna_image*80,xmlfile*80
C     ..
C     .. Common block /IOO/ ..
c      COMMON /IOO/IOUT,IUNIT,ONLINE,ITIN,ITOUT,INOD,INMO,IDU,NWRN,
c     +            ONEFILE,FHEADER,BRIEF,IBRIEF,GRAPH,ISUMMR,ICOORD,
c     +            IOERR,NODISPLAY,LBELL
C     ..
C
C
      COMMON /IOO/IOUT,IUNIT,ITIN,ITOUT,INOD,INMO,IDU,NWRN,IBRIEF,
     +        ISUMMR,ICOORD,SERVERFD,SERVERFDIN,NSHUTERR,ONLINE,ONEFILE,
     +        FHEADER,BRIEF,GRAPH,IOERR,NODISPLAY,LBELL,JPGOUT,
     $        SOCKLO,LBEST, dnafd, dnaout,INMOOPEN,XMLOPEN
      COMMON /CIOO/dna_image,xmlfile

C&&*&& end_include  ../inc/ioo.f
C&&*&& include  ../inc/lmb.f
C
C $Id: lmb.f,v 1.8 2009/01/08 18:03:14 harry Exp $
C
C--- awk generated include file  lmb.h
C---- START of include file lmb.h
C ODSCAL is to scale image numbers into the range 0-255 for plotting
C average profiles.
C  GAIN should be equal to the overall gain (image counts per X-ray photon)
C of the system, and is used to evaluate standard deviations based on
C counting statistics assuming independent pixels (ie point spread function
C less than pixel size).
C INVERTX true if image is inverted in the slow (X) direction when read in.
C ISCAL is to scale final integrated intensities and sigmas
C IDIVIDE is the adc offset
C ICONST is a constant to be added to all pixels (normally zero) to
C        allow processing of images with zero pixel values in the scanned
C        area.
C IMGP is true if working with image plate data
C SPIRAL is true for scanners with a spiral readout (Mar, DIP2000)
C ORTHOG is true for scanners with orthogonal scan (FUJI, RAXIS, MD)
C NULLPIX is the value of pixels within the image but not in the active
C area of the detector
C TILED is true if there are inactive areas of the detector within the
C       inscribing circle or square.
C
C NTILEX Number of tiles in X direction
C NTILEY Number of tiles in Y direction
C TILEX  X Coordinates of the midpoints of the null areas between tiles
C TILEY  Y Coordinates of the midpoints of the null areas between tiles
C TILEWX Width of the null areas between tiles in X
C TILEWY Width of the null areas between tiles in Y


C MACHINE and MODEL denote the type of detector. 
C
C MACHINE is used in the following subroutines:
C GETBLK, GETHDR, INTPXL, INTPXL2, MXDSPL, OPENODS, PROCESS, PUTPXL
C Currently coded types are:
C
C         MACHINE        MODEL               COMMENTS
C         =======        =====               ========
C         MAR            180, 300, 345
C         RAXI(S)        RAXISII, RAXISIV
C         MD
C         FUJI
C         CCD1           CCD1                Princetown CCD at CHESS,Tiff format
C         CCD2           CCD ?               ESRF CCD detector
C         ADSC           QUAD1               ADSC 2x2 CCD detector
C
C TRUSTED whether or not the image header information can be trusted for 
C         automatic processing
C     .. Scalars in Common Block /LMB/ ..
        REAL ODSCAL,GAIN,LOGA,LOGB
        INTEGER ISCAL,IDIVIDE,ICONST,NULLPIX,NTILEX,NTILEY,
     $    RAXISCOMP,IIDIVIDE,COMPRESSION
        LOGICAL IMGP,INVERTX,SPIRAL,ORTHOG,CIRCULAR,TILED,SETADC,
     $    NEWRAXIS,BRUKNEW,TRUSTED
        CHARACTER MACHINE*4,MODEL*8

C     ..
C     .. Arrays in common /LMB/
        INTEGER TILEX,TILEY,TILEWX,TILEWY
C
C     .. Common Block /LMB/ ..
        COMMON /LMB/ ODSCAL,GAIN,LOGA,LOGB,ISCAL,IDIVIDE,ICONST,
     +       NULLPIX,NTILEX,NTILEY,RAXISCOMP,IIDIVIDE,COMPRESSION,
     +       TILEX(20),TILEY(20),TILEWX(20),TILEWY(20),IMGP,
     +       INVERTX,SPIRAL,ORTHOG,CIRCULAR,TILED,SETADC,
     $       NEWRAXIS,BRUKNEW,TRUSTED
        COMMON /LMBC/ MACHINE,MODEL

C&&*&& end_include  ../inc/lmb.f
C&&*&& include  ../inc/sums.f
C
C $Id: sums.f,v 1.1 2002/05/02 10:47:21 harry Exp $
C
C--- awk generated include file  sums.h
C---- START of include file sums.h
C
C
C     Elements of ASPOT
C     1 = Summation integration intensity
C     2 = Total background counts under peak assuming peak has mm symmetry
C     3 = Rms variation in background, after rejecting background points.
C         This is evaluated in BGSOLVE called from EVAL.
C     4 = Centre of gravity in X direction (in pixels)
C     5 = Centre of gravity in Y direction (in pixels)
C         These are wrt an origin at the centre of the measurement box
C     6 = sum p*iod for background pixels
C     7 = sum q*iod for background pixels
C     8 = sum iod for background pixels
C     9 = Background plane constant a (gradient in X direction)
C    10 = Background plane constant b (gradient in Y direction)
C    11 = Background plane constant c 
C    12 = Largest deviation from background plane, excluding rejected pixels
C    13 = Profile fitted intensity
C    14 = Variance of profile fitted intensity = sum (deltasq) for peak
C         pixels only. Used to calculate PKRATIO and also profile fitted
C         sigma(I) in unweighted case only.
C    15 = Number of rejected background pixels
C    16 = Variance of profile fitted intensity in weighted case (default)
C    17 = sum W*DELTA**2 for profile fit
C    18   unused
C     .. Arrays in common block /SUMS/ ..
      REAL ASPOT
C     ..
C     .. Common Block /SUMS/ ..
      COMMON /SUMS/ASPOT(18)
C     ..
C
C
C&&*&& end_include  ../inc/sums.f
C
C     .. Equivalences ..
      EQUIVALENCE (ASPOT(6),SPOD)
      EQUIVALENCE (ASPOT(7),SQOD), (ASPOT(8),SOD), (ASPOT(9),A)
      EQUIVALENCE (ASPOT(10),B), (ASPOT(11),C)
C
      SAVE
C     ..
C
C
C---- Mode for EVAL (signifies we have not flagged overlapped background
C                     pixels)
      MODE = 0
      NXX = IRAS(1)
      NYY = IRAS(2)
      HX = NXX/2
      HY = NYY/2
      NXY = NXX*NYY
C
      SP = 0.0
      SQ = 0.0
      SPQ = 0.0
      SPOD = 0.0
      SQOD = 0.0
      SOD = 0.0
      TOD = 0.0
      TPOD = 0.0
      TQOD = 0.0
      IJ = 0
C
C
      DO 40 P = -HX,HX
C
        DO 30 Q = -HY,HY
          IJ = IJ + 1
          IOD = OD(IJ)
          IF (MASK(IJ).EQ.0) THEN
            GOTO 30
          ELSE IF (MASK(IJ).GT.0) THEN
            GOTO 20
          END IF
C
C  Background pixels
              SP = P + SP
              SQ = Q + SQ
              SPQ = P*Q + SPQ
              SPOD = P*IOD + SPOD
              SQOD = Q*IOD + SQOD
              SOD = SOD + IOD
            GOTO 30
C
C  Peak pixels
 20           TPOD = P*IOD + TPOD
              TQOD = Q*IOD + TQOD
              TOD = TOD + IOD
   30   CONTINUE
   40 CONTINUE
C
C
C  Background constants
      A = SPOD/PQVAL(2)
      B = SQOD/PQVAL(4)
      C = SOD/PQVAL(6)
C
C  Set up PQSUMS .
      PQSUMS(1) = PQVAL(2)
      PQSUMS(2) = PQVAL(4)
      PQSUMS(3) = SPQ
      PQSUMS(4) = SP
      PQSUMS(5) = SQ
      PQSUMS(6) = PQVAL(6)
      NBKG = NINT(PQVAL(6))
C
C   Set maximum allowed number of allowed background pixels to be
C   rejected from background plane determination. NBGMIN is keyword set
C   and passed through /BACKG/
C
      NRLMAX = NBKG - NBGMIN
C
C---- Tets for too few background points
C
      IF (NRLMAX.LT.0) THEN
        ASPOT(1) = -9999.0
        RETURN
      END IF
C
C
C          ***********************************************
      CALL EVAL(OD(1),MASK(1),IRAS,PQSUMS,BGKSIG,NRLMAX,NRBX,
     +          MASKREJ(1),DEBUG(43),MODE)
C          ***********************************************
C
C
C---- Check that not too many background points have been rejected
C     (Flagged by NRLMAX=-999)
C
      IF (NRLMAX.EQ.-999) THEN
        ASPOT(1) = -9999.0
        RETURN
      END IF
C
C  Recalculate SPOT based on new value of C
C
C
      ASPOT(2) = PQVAL(5)*C
      ASPOT(1) = TOD - ASPOT(2)
C
C
C     ASPOT(2) is used in calculation of counting statistics errors.
C     Must subtract scanner adc offset here
C
      ASPOT(2) = ASPOT(2) - PQVAL(5)*IDIVIDE
C
      IF (FULL) THEN           
C
C----- Catch zero spots
C
        IF (ASPOT(1).NE.0.0) THEN
          ASPOT(4) = (TPOD-PQVAL(1)*A)/ASPOT(1)*IDR
          ASPOT(5) = (TQOD-PQVAL(3)*B)/ASPOT(1)
        ELSE
          ASPOT(4) = 0.0
          ASPOT(5) = 0.0
        END IF
      END IF
C
      IF (DEBUG(43).AND.(NDBG.LE.NDEBUG(43))) THEN
        WRITE(IOUT,FMT=6000) ASPOT(1),ASPOT(2),
     +                       ASPOT(3),ASPOT(4),TOD,PQVAL
        IF (ONLINE) WRITE(ITOUT,FMT=6000) ASPOT(1),ASPOT(2),
     +                       ASPOT(3),ASPOT(4),TOD,PQVAL
 6000   FORMAT(1X,'From INTEG, ASPOT(1-4)',4F12.0,/,1X,'TOD',F12.0,
     +         '   PQVAL',6F8.0)
        NDBG = NDBG + 1
      END IF
C
      END
C== INTERP ==
      SUBROUTINE INTERP(MASK,NX,NY,DX,DY,ISX,ISY,NOXRIM,NOYRIM,LEN)
C     =============================================================
C
      IMPLICIT NONE
C
C
C
C     .. Parameters ..
C&&*&& include  ../inc/parameter.f
C
C $Id: parameter.f,v 1.17 2009/10/28 16:43:34 harry Exp $
C
C--- awk generated include file  parameter.h
C---- START of include file parameter.h
C
C       PARAMETERS
C       IYLENGTH.. maximum number of I*2 words of data in the 
C                  "fast" (ie most rapidly changing) direction in the
C                  digitised image. This will be HALF the number of pixels
C                  for film data (each pixel is stored in one byte)
C                  but will equal the number of pixels for IP data.
C       IXWDTH...  The maximum number of "stripes" of data in the scanned image
C                  ie the number of pixels in the "slow" direction
C                  (This is the Y direction in the MOSFLM convention)
C                  Note that the array "IMAGE" used to store the image is
C                  declared as size IYLENGTH*IXWDTH I*2 words for IP data
C                  and 2*IYLENGTH*IXWDTH BYTES for film data.
C                  If this exceeds the
C                  available memory, set ixwdth=1, recompile program
C                  and use keyword "NOCORE" when running program.
C                  Note that for the POSTREF and ADDPART options,
C                  two images have to be stored in memory at once so
C                  IXWDTH should be twice the number of records in an
C                  image.
C       MAXHEAD    maximum length of image header (in 4 byte words)
C       NREFLS.... maximum number of spots per film in generate file (250,000)
C       MAXBOX.... maximum number of pixels in measurement box (1500)
C       MAXDIM.... maximum box size in either direction (pixels) (41)
C       MAXPAX.... maximum number of packs per generate file (10000)
C       MXDOV2..... maxdim/2
C       MAXBUFF... maximum size of buffer (I*2) for storing ods
C                  of active spots in subroutine meas(21,000).
C                  Must be .GE.  MAXBOX*(NNLINE-1) for subroutine process
C       MREF...... maximum number of reflections to be used in post
C                  refinement (6000)
C       NEXPAND... maximum number of expansions of the input measurement
C                  box (2)
C       NMASKS.... maximum number of different profiles (25). Note the
C                  connection between this parameter and NNLINE
C       NVECT..... maximum number of vectors for storing scanned image
C                  in filmplot (10000)
C       NIMAX..... maximum number of images to be used together in 
C                  postrefinement (NADD or WIDTH options) (100)
C       NNLINE...  maximum number of boundary lines for setting up
C                  the areas for profile fitting. The maximum possible
C                  number of standard profiles will be (NNLINE-1)**2
C                  although for a circular detector the actual number
C                  may be less than this as some boxes will lie entirely
C                  outside the detector.
C       NREJMAX... Maximum number of rejected background pixels, resulting
C                  either from overlap of adjacent spots or outliers from
C                  the background plane
C       NSPOTS...  Maximum number of found spots (for autoindexing) that can
C                  be stored (for all images). Also maximum number in 
C                  a file wriitten by IMSTILLS that can be 
C                  stored/displayed/edited. THis must be an even number
C       MCOLS....  Number of columns in output MTZ file
C       MCOLSTR..  Number of columns in output MTZ file for strategy option
C     
C       MTZ Orientation block
C        MBLENG is total length of block, MBLINT, MBLREA are numbers
C          of integers & reals
C       NDETREF    Maximum number of reflections used for detector parameter
C                  refinement (previously 62)
C       NRPAR....  Maximum number of refineable parameters for detector
C                  positional refinement (subroutine RDIST)
C       NSEGMAX..  Maximum number of segments in STRATEGY
C       NSEGMAXPR  Maximum number of segments in POST-REFINEMENT
C       MULTMAX... Maximum number of observations with same hkl in COMPLETE
C       MAXDIFF... Maximum number of different packs that a given hkl occurs on
C       NRESBIN... Maximum number of resolution bins (COMPLETE)
C
C       MAXIMG...  Maximum number of images that can be read in using the IMAGE
C                  keyword or the "read Image" menu option.
C       MXSPOT...  Maximum number of spots that can be found on one image
C                  (before rejection on spot size).
C       MXCENT...  Maximum number of active spots during spot finding 
C                  (findspots)
C
C       MGRA, NGRA... maximum number of reflections and images over which a 
C                     reflection can be spread for postrefinement.
C       MAXBGBOX    Maximum number of local background background boxes 
C                   in X and Y
C
C       MAXNPEAKS   Maximum number of local maxima within one spot
C       MAXEXCL     Maximum number of excluded areas of the same type
C                   eg reactangles, quadrilaterals, arcs, resolution shells
C
C     .. Parameters ..
      INTEGER IXWDTH
c      PARAMETER (IXWDTH=8192)
      PARAMETER (IXWDTH=12288)
      INTEGER IYLENGTH
c      PARAMETER (IYLENGTH=4096)
      PARAMETER (IYLENGTH=6144)
      INTEGER MAXHEAD
      PARAMETER (MAXHEAD=5120)
      INTEGER MAXBOX
      PARAMETER (MAXBOX=3000)
      INTEGER MAXDIM
      PARAMETER (MAXDIM=41)
      INTEGER MAXPAX
      PARAMETER (MAXPAX=10000)
      INTEGER MXDOV2
      PARAMETER (MXDOV2=MAXDIM/2)
      INTEGER NEXPAND
      PARAMETER (NEXPAND=2)
      INTEGER NNLINE
      PARAMETER (NNLINE=8)
      INTEGER NMASKS
      PARAMETER (NMASKS=49)
      INTEGER MAXBUFF
      PARAMETER (MAXBUFF=21000)
      INTEGER NREFLS
      PARAMETER (NREFLS=250000)
      INTEGER MREF
      PARAMETER (MREF=6000)
      INTEGER NVECT
      PARAMETER (NVECT=10000)
      INTEGER NIMAX
      PARAMETER (NIMAX=100)
      INTEGER NREJMAX
      PARAMETER (NREJMAX=1000)
      INTEGER NSPOTS
      PARAMETER (NSPOTS=5000)
      INTEGER MCOLS
      PARAMETER (MCOLS=18)
      INTEGER MCOLSTR
      PARAMETER (MCOLSTR=6)
      INTEGER NREFSTR
C
C---- Each reflection for strategy run needs MCOLSTR I*2 words
C     plus an I*4 word for the merging
C
      PARAMETER (NREFSTR = IXWDTH*IYLENGTH/(2+MCOLSTR))
      INTEGER MBLENG,MBLINT,MBLREA
      PARAMETER (MBLENG=185,MBLINT=29,MBLREA=156)
      INTEGER NDETREF
      PARAMETER (NDETREF=400)
      INTEGER NRPAR
      PARAMETER (NRPAR=14)
      INTEGER NSEGMAX
      PARAMETER (NSEGMAX=100)
      INTEGER NSEGMAXPR
      PARAMETER (NSEGMAXPR=100)
      INTEGER MULTMAX
      PARAMETER (MULTMAX=100)
      INTEGER MAXDIFF
      PARAMETER (MAXDIFF=100)
      INTEGER NRESBIN
      PARAMETER (NRESBIN=20)
      INTEGER MXSPOT
      PARAMETER (MXSPOT=5000)      
      INTEGER MAXIMG
      PARAMETER (MAXIMG=100)      
      INTEGER NPIXBG
      PARAMETER (NPIXBG=51)
      INTEGER MXCENT
      PARAMETER (MXCENT=500)
      INTEGER    NGRA,MGRA
      PARAMETER (NGRA=20)
      PARAMETER (MGRA=50000)
      INTEGER MAXBGBOX
      PARAMETER (MAXBGBOX=500)
      INTEGER MAXNPEAKS
      PARAMETER (MAXNPEAKS=500)
      INTEGER MAXEXCL
      PARAMETER (MAXEXCL=50)
C&&*&& end_include  ../inc/parameter.f
C     ..
C     .. Scalar Arguments ..
      REAL DX,DY
      INTEGER ISX,ISY,LEN,NX,NY
      LOGICAL NOXRIM,NOYRIM
C     ..
C     .. Array Arguments ..
      INTEGER MASK(MAXBOX)
C     ..
C     .. Scalars in Common ..
      INTEGER IOD
C     ..
C     .. Arrays in Common ..
      INTEGER*2 BBINT,BBSAVE
C     ..
C     .. Local Scalars ..
      REAL DDX,DDY
      INTEGER HX,HY,IJ,IND,IOD1,IOD2,IOD3,IOD4,NNDBG,NYADD,P,Q,
     +        NXY,I
      LOGICAL XNEG,YNEG
C     ..
C     .. External Subroutines ..
      EXTERNAL GETBYTE ,PACKBYTE
C     ..
C     .. Extrinsic Functions ..
      INTEGER  INTPXL,PUTPXL
      EXTERNAL  INTPXL,PUTPXL
C     ..
C     .. Common blocks ..
C&&*&& include  ../inc/debug.f
C
C $Id: debug.f,v 1.2 2008/07/24 09:42:21 andrew Exp $
C
C--- awk generated include file  debug.h
C---- START of include file debug.h
C
C
C
C     .. Arrays in common /DEBUG/ ..
      REAL XWARN
      INTEGER NDEBUG,IWARN
      LOGICAL DEBUG,LPRINT,DUMP,WARN
C
C     .. Scalars in common /DEBUG/ ..
      REAL BGRLIM
      INTEGER NDUMP,IDUMP,MXDUMP
      LOGICAL SPOT
C     
C     ..
C     .. Common Block /DEBUG/..
      COMMON /DEBUG/XWARN(20,100),BGRLIM,NDEBUG(100),IWARN(20,100),
     $       NDUMP,IDUMP,MXDUMP,DEBUG(100),LPRINT(20),DUMP(30),
     +       WARN(100),SPOT
C     ..
C
C&&*&& end_include  ../inc/debug.f
C&&*&& include  ../inc/lmb.f
C
C $Id: lmb.f,v 1.8 2009/01/08 18:03:14 harry Exp $
C
C--- awk generated include file  lmb.h
C---- START of include file lmb.h
C ODSCAL is to scale image numbers into the range 0-255 for plotting
C average profiles.
C  GAIN should be equal to the overall gain (image counts per X-ray photon)
C of the system, and is used to evaluate standard deviations based on
C counting statistics assuming independent pixels (ie point spread function
C less than pixel size).
C INVERTX true if image is inverted in the slow (X) direction when read in.
C ISCAL is to scale final integrated intensities and sigmas
C IDIVIDE is the adc offset
C ICONST is a constant to be added to all pixels (normally zero) to
C        allow processing of images with zero pixel values in the scanned
C        area.
C IMGP is true if working with image plate data
C SPIRAL is true for scanners with a spiral readout (Mar, DIP2000)
C ORTHOG is true for scanners with orthogonal scan (FUJI, RAXIS, MD)
C NULLPIX is the value of pixels within the image but not in the active
C area of the detector
C TILED is true if there are inactive areas of the detector within the
C       inscribing circle or square.
C
C NTILEX Number of tiles in X direction
C NTILEY Number of tiles in Y direction
C TILEX  X Coordinates of the midpoints of the null areas between tiles
C TILEY  Y Coordinates of the midpoints of the null areas between tiles
C TILEWX Width of the null areas between tiles in X
C TILEWY Width of the null areas between tiles in Y


C MACHINE and MODEL denote the type of detector. 
C
C MACHINE is used in the following subroutines:
C GETBLK, GETHDR, INTPXL, INTPXL2, MXDSPL, OPENODS, PROCESS, PUTPXL
C Currently coded types are:
C
C         MACHINE        MODEL               COMMENTS
C         =======        =====               ========
C         MAR            180, 300, 345
C         RAXI(S)        RAXISII, RAXISIV
C         MD
C         FUJI
C         CCD1           CCD1                Princetown CCD at CHESS,Tiff format
C         CCD2           CCD ?               ESRF CCD detector
C         ADSC           QUAD1               ADSC 2x2 CCD detector
C
C TRUSTED whether or not the image header information can be trusted for 
C         automatic processing
C     .. Scalars in Common Block /LMB/ ..
        REAL ODSCAL,GAIN,LOGA,LOGB
        INTEGER ISCAL,IDIVIDE,ICONST,NULLPIX,NTILEX,NTILEY,
     $    RAXISCOMP,IIDIVIDE,COMPRESSION
        LOGICAL IMGP,INVERTX,SPIRAL,ORTHOG,CIRCULAR,TILED,SETADC,
     $    NEWRAXIS,BRUKNEW,TRUSTED
        CHARACTER MACHINE*4,MODEL*8

C     ..
C     .. Arrays in common /LMB/
        INTEGER TILEX,TILEY,TILEWX,TILEWY
C
C     .. Common Block /LMB/ ..
        COMMON /LMB/ ODSCAL,GAIN,LOGA,LOGB,ISCAL,IDIVIDE,ICONST,
     +       NULLPIX,NTILEX,NTILEY,RAXISCOMP,IIDIVIDE,COMPRESSION,
     +       TILEX(20),TILEY(20),TILEWX(20),TILEWY(20),IMGP,
     +       INVERTX,SPIRAL,ORTHOG,CIRCULAR,TILED,SETADC,
     $       NEWRAXIS,BRUKNEW,TRUSTED
        COMMON /LMBC/ MACHINE,MODEL

C&&*&& end_include  ../inc/lmb.f
C&&*&& include  ../inc/parm1.f
C
C $Id: parm1.f,v 1.1 2002/05/02 10:47:05 harry Exp $
C
C--- awk generated include file  parm1.h
C---- START of include file parm1.h
C
C
C
C     .. Scalars in common block /PARM1/ ..
      REAL BGSIG,EFAC,EFACSQ,BGFREJ,GRADMAX,GRADMAXR,BGRAT,PKRAT,
     +     RESD,RESDLOW
      INTEGER CUTOFF,NOVPIX,NDSTART,NDTOT,IXDMIN,IXDMAX,IYDMIN,IYDMAX,
     +     IDMIN,IDMAX
      LOGICAL DUMPSPOT,BADPLOT,DUMPALL,BADPLOT2
C     ..
C     .. Common Block /PARM1/ ..
      COMMON /PARM1/BGSIG,EFAC,EFACSQ,BGFREJ,GRADMAX,GRADMAXR,
     +              BGRAT,PKRAT,RESD,RESDLOW,CUTOFF,NOVPIX,
     +              NDSTART,NDTOT,IXDMIN,IXDMAX,IYDMIN,IYDMAX,
     +              IDMIN,IDMAX,DUMPSPOT,BADPLOT,DUMPALL,BADPLOT2
C     ..
C
C
C&&*&& end_include  ../inc/parm1.f
      COMMON /BITS/IOD,BBSAVE(MAXBOX),BBINT(MAXBOX)
C     ..
      SAVE
C     .. Data statements ..
      DATA NNDBG/0/
C     ..
C
C
      NNDBG = NNDBG + 1
      XNEG = (ISX.LT.0)
      YNEG = (ISY.LT.0)
      HX = NX/2
      HY = NY/2
      IJ = 0
      DDY = 1.0 - DY
      DDX = 1.0 - DX
      NYADD = ISX*NY
      IND = (NNDBG/100)*100
cc??      if (NNDBG.eq.ind) write(6,201) nx,ny,isx,nyadd,dx,dy
 201   FORMAT(1X,'NX,NY',2I4,' ISX,NYADD',2I4,' DX,DY',2F5.2)
C
C
      DO 20 P = -HX,HX
        IF (NOXRIM) THEN
C
C
          IF ((XNEG.AND. (P.EQ.-HX)) .OR.
     +        ((.NOT.XNEG).AND. (P.EQ.HX))) THEN
            IJ = IJ + NY
            GO TO 20
          END IF
C
C
        END IF
C
C
        DO 10 Q = -HY,HY
          IJ = IJ + 1
C
C
          IF (NOYRIM) THEN
            IF (((Q.EQ.-HY).AND.YNEG) .OR.
     +          ((Q.EQ.HY).AND. (.NOT.YNEG))) GO TO 10
          END IF
C
C
          IF (MASK(IJ).GT.0) THEN
C
C---- Peak area, do interpolation, first unpack bytes if required
C
            IF (IMGP) THEN
              IOD = INTPXL(BBSAVE(IJ))
            ELSE
C                  ***********
              CALL GETBYTE(IJ)
C                  ***********
            END IF
C
            IOD1 = IOD
C
C---- Trap spots with zero pixels
         IF (IOD1.LE.0) GO TO 30
C
         IF (IMGP) THEN
           IOD2 = INTPXL(BBSAVE(IJ+ISY))
           IOD3 = INTPXL(BBSAVE(IJ+NYADD))
           IOD4 = INTPXL(BBSAVE(IJ+ISY+NYADD))
         ELSE
C                ***************
            CALL GETBYTE(IJ+ISY)
C                ***************
            IOD2 = IOD
C                *****************
            CALL GETBYTE(IJ+NYADD)
C                *****************
            IOD3 = IOD
C                *********************
            CALL GETBYTE(IJ+ISY+NYADD)
C                *********************
            IOD4 = IOD
          END IF
            IOD = DDX*DDY*IOD1 + DDX*DY*IOD2 + DX*DDY*IOD3 +
     +            DX*DY*IOD4 + 0.5
cc??       if (NNDBG.eq.ind) write(6,200) p,q,iod,iod1,iod2,iod3,iod4
 200    FORMAT(1X,'P,Q',2I4,' IOD=',I3,' IOD1,2,3,4',4I4)
C

          IF (IMGP) THEN
            IOD = PUTPXL(IOD)
            BBINT(IJ) = IOD
          ELSE
C                ************
            CALL PACKBYTE(IJ)
C                ************
          END IF
C
          END IF
   10   CONTINUE
   20 CONTINUE
C
      RETURN
C
C---- Overloaded reflection, or reflection with pixel values of zero
C     (ie extends beyond scanned area in image plate) ... do not interpolate
C      Need to copy all pixel values (in BBSAVE) into BBINT because some
C     pixels may already have been interpolated.
C
30    CONTINUE
      NXY = NX*NY
      IF (DEBUG(17)) THEN
C             ***********************************
          IF (SPOT) CALL ODPLOT(BBSAVE(1),NX,NY,1)
C             ***********************************
      END IF
C
C
      DO 40 I = 1,NXY
       BBINT(I) = BBSAVE(I)
40    CONTINUE
C
C
      END
C== MINV ==
C $Id: minv.f,v 1.5 2008/05/15 11:39:59 harry Exp $
C
C
      SUBROUTINE MINV(A,N,D,L,M)
      IMPLICIT NONE
C     ==========================
C
C
C
C
C
C     .. Scalar Arguments ..
      REAL D
      INTEGER N
C     ..
C     .. Array Arguments ..
      REAL A(*)
      INTEGER L(*),M(*)
C     ..
C     .. Local Scalars ..
      REAL BIGA,HOLD
      INTEGER I,IJ,IK,IZ,J,JI,JK,JP,JQ,JR,K,KI,KJ,KK,NK
C     ..
C     .. Intrinsic Functions ..
      INTRINSIC ABS
C     ..
C
C
      D = 1.0
      NK = -N
C
C
      DO 90 K = 1,N
        NK = NK + N
        L(K) = K
        M(K) = K
        KK = NK + K
        BIGA = A(KK)
C
C
        DO 20 J = K,N
          IZ = (J-1)*N
C
C
          DO 10 I = K,N
            IJ = IZ + I
C
C
            IF ((ABS(BIGA)-ABS(A(IJ))).LT.0) THEN
              BIGA = A(IJ)
              L(K) = I
              M(K) = J
            END IF
C
C
   10     CONTINUE
   20   CONTINUE
C
C---- Interchange rows
C
        J = L(K)
C
C
        IF ((J-K).GT.0) THEN
          KI = K - N
C
C
          DO 30 I = 1,N
            KI = KI + N
            HOLD = -A(KI)
            JI = KI - K + J
            A(KI) = A(JI)
            A(JI) = HOLD
   30     CONTINUE
C
C
        END IF
C
C---- Interchange columns
C
        I = M(K)
C
C
        IF ((I-K).GT.0) THEN
          JP = (I-1)*N
C
C
          DO 40 J = 1,N
            JK = NK + J
            JI = JP + J
            HOLD = -A(JK)
            A(JK) = A(JI)
            A(JI) = HOLD
   40     CONTINUE
        END IF
C
C---- Divide column by minus pivot
C
        IF (BIGA.EQ.0) THEN
          GO TO 130
        ELSE
C
C
          DO 50 I = 1,N
            IF ((I-K).NE.0) THEN
              IK = NK + I
              A(IK) = A(IK) / (-BIGA)
            END IF
   50     CONTINUE
C
C---- Reduce matrix
C
          DO 70 I = 1,N
            IK = NK + I
            HOLD = A(IK)
            IJ = I - N
C
C
            DO 60 J = 1,N
              IJ = IJ + N
C
C
              IF ((I-K).NE.0) THEN
                IF ((J-K).NE.0) THEN
                  KJ = IJ - I + K
                  A(IJ) = A(KJ) * HOLD + A(IJ)
                END IF
              END IF
C
C
   60       CONTINUE
   70     CONTINUE
C
C---- Divide row by pivot
C
          KJ = K - N
C
C
          DO 80 J = 1,N
            KJ = KJ + N
            IF ((J-K).NE.0) A(KJ) = A(KJ) / BIGA
   80     CONTINUE
C
C---- Product of pivots
C
C        D=D*BIGA
C
C---- Replace pivot by reciprocal
C
          A(KK) = 1.0/BIGA
        END IF
   90 CONTINUE
C
C---- Final row and column interchange
C
      K = N
  100 CONTINUE
      K = (K-1)
C
C
      IF (K.GT.0) THEN
        I = L(K)
C
C
        IF ((I-K).GT.0) THEN
          JQ = (K-1)*N
          JR = (I-1)*N
C
C
          DO 110 J = 1,N
            JK = JQ + J
            HOLD = A(JK)
            JI = JR + J
            A(JK) = -A(JI)
            A(JI) = HOLD
  110     CONTINUE
C
C
        END IF
C
C
        J = M(K)
C
C
        IF ((J-K).GT.0) THEN
          KI = K - N
C
C
          DO 120 I = 1,N
            KI = KI + N
            HOLD = A(KI)
            JI = KI - K + J
            A(KI) = -A(JI)
            A(JI) = HOLD
  120     CONTINUE
C
C
        END IF
        GO TO 100
      END IF
C
C
      RETURN
  130 D = 0.0
C
C
      END
C $Id: minv4.f,v 1.2 2006/02/06 18:04:16 harry Exp $
C== MINV4 ==
      SUBROUTINE MINV4(A,AI,IERR)
C     ===========================
      IMPLICIT NONE
C
C
C
C Subroutine to invert 4*4 matrices for conversion between
C fractional and orthogonal axes
C
C
C PARAMETERS
C
C           A (I)   4*4 MATRIX TO BE INVERTED
C          AI (O)   INVERSE MATRIX
C
C
C     ..
C     .. Scalar Arguments ..
      INTEGER IERR
C     ..
C     .. Array Arguments ..
      REAL A(4,4),AI(4,4)
C     ..           
C     .. Local Scalars ..
      INTEGER II,JJ,I,J,I1,J1
      DOUBLE PRECISION D,AM
C     ..
C     .. Local Arrays ..
      DOUBLE PRECISION C(4,4),X(3,3)
      IERR = 0
C
C---- Get cofactors of 'a' in array 'c'
C
      DO 40 II=1,4
      DO 30 JJ=1,4
      I=0
      DO 20 I1=1,4
      IF(I1.EQ.II)GO TO 20
      I=I+1
      J=0
      DO 10 J1=1,4
      IF(J1.EQ.JJ)GO TO 10
      J=J+1
      X(I,J)=DBLE(A(I1,J1))
10    CONTINUE
20    CONTINUE
      AM=X(1,1)*X(2,2)*X(3,3)-X(1,1)*X(2,3)*X(3,2)+X(1,2)*X(2,3)*X(3,1)
     *  -X(1,2)*X(2,1)*X(3,3)+X(1,3)*X(2,1)*X(3,2)-X(1,3)*X(2,2)*X(3,1)
      C(II,JJ)=(-1)**(II+JJ)*AM
30    CONTINUE
40    CONTINUE
C
C---- Calculate determinant
C
      D=0
      DO 50 I=1,4
      D = D + DBLE(A(I,1)) * C(I,1)
50    CONTINUE
C
C---- Test for zero determinant
C
      IF (ABS(D).LT.0.0000001) THEN
        IERR = 1
        RETURN
      END IF
C
C---- Get inverse matrix
C
      DO 70 I=1,4
      DO 60 J=1,4
      AI(I,J)=REAL(C(J,I)/D)
60    CONTINUE
70    CONTINUE
      RETURN
      END
C== MMTOPX ==
      SUBROUTINE MMTOPX(XC,YC,X,Y)
C     ============================
C
      IMPLICIT NONE
C
C
C
C     .. Parameters ..
C&&*&& include  ../inc/parameter.f
C
C $Id: parameter.f,v 1.17 2009/10/28 16:43:34 harry Exp $
C
C--- awk generated include file  parameter.h
C---- START of include file parameter.h
C
C       PARAMETERS
C       IYLENGTH.. maximum number of I*2 words of data in the 
C                  "fast" (ie most rapidly changing) direction in the
C                  digitised image. This will be HALF the number of pixels
C                  for film data (each pixel is stored in one byte)
C                  but will equal the number of pixels for IP data.
C       IXWDTH...  The maximum number of "stripes" of data in the scanned image
C                  ie the number of pixels in the "slow" direction
C                  (This is the Y direction in the MOSFLM convention)
C                  Note that the array "IMAGE" used to store the image is
C                  declared as size IYLENGTH*IXWDTH I*2 words for IP data
C                  and 2*IYLENGTH*IXWDTH BYTES for film data.
C                  If this exceeds the
C                  available memory, set ixwdth=1, recompile program
C                  and use keyword "NOCORE" when running program.
C                  Note that for the POSTREF and ADDPART options,
C                  two images have to be stored in memory at once so
C                  IXWDTH should be twice the number of records in an
C                  image.
C       MAXHEAD    maximum length of image header (in 4 byte words)
C       NREFLS.... maximum number of spots per film in generate file (250,000)
C       MAXBOX.... maximum number of pixels in measurement box (1500)
C       MAXDIM.... maximum box size in either direction (pixels) (41)
C       MAXPAX.... maximum number of packs per generate file (10000)
C       MXDOV2..... maxdim/2
C       MAXBUFF... maximum size of buffer (I*2) for storing ods
C                  of active spots in subroutine meas(21,000).
C                  Must be .GE.  MAXBOX*(NNLINE-1) for subroutine process
C       MREF...... maximum number of reflections to be used in post
C                  refinement (6000)
C       NEXPAND... maximum number of expansions of the input measurement
C                  box (2)
C       NMASKS.... maximum number of different profiles (25). Note the
C                  connection between this parameter and NNLINE
C       NVECT..... maximum number of vectors for storing scanned image
C                  in filmplot (10000)
C       NIMAX..... maximum number of images to be used together in 
C                  postrefinement (NADD or WIDTH options) (100)
C       NNLINE...  maximum number of boundary lines for setting up
C                  the areas for profile fitting. The maximum possible
C                  number of standard profiles will be (NNLINE-1)**2
C                  although for a circular detector the actual number
C                  may be less than this as some boxes will lie entirely
C                  outside the detector.
C       NREJMAX... Maximum number of rejected background pixels, resulting
C                  either from overlap of adjacent spots or outliers from
C                  the background plane
C       NSPOTS...  Maximum number of found spots (for autoindexing) that can
C                  be stored (for all images). Also maximum number in 
C                  a file wriitten by IMSTILLS that can be 
C                  stored/displayed/edited. THis must be an even number
C       MCOLS....  Number of columns in output MTZ file
C       MCOLSTR..  Number of columns in output MTZ file for strategy option
C     
C       MTZ Orientation block
C        MBLENG is total length of block, MBLINT, MBLREA are numbers
C          of integers & reals
C       NDETREF    Maximum number of reflections used for detector parameter
C                  refinement (previously 62)
C       NRPAR....  Maximum number of refineable parameters for detector
C                  positional refinement (subroutine RDIST)
C       NSEGMAX..  Maximum number of segments in STRATEGY
C       NSEGMAXPR  Maximum number of segments in POST-REFINEMENT
C       MULTMAX... Maximum number of observations with same hkl in COMPLETE
C       MAXDIFF... Maximum number of different packs that a given hkl occurs on
C       NRESBIN... Maximum number of resolution bins (COMPLETE)
C
C       MAXIMG...  Maximum number of images that can be read in using the IMAGE
C                  keyword or the "read Image" menu option.
C       MXSPOT...  Maximum number of spots that can be found on one image
C                  (before rejection on spot size).
C       MXCENT...  Maximum number of active spots during spot finding 
C                  (findspots)
C
C       MGRA, NGRA... maximum number of reflections and images over which a 
C                     reflection can be spread for postrefinement.
C       MAXBGBOX    Maximum number of local background background boxes 
C                   in X and Y
C
C       MAXNPEAKS   Maximum number of local maxima within one spot
C       MAXEXCL     Maximum number of excluded areas of the same type
C                   eg reactangles, quadrilaterals, arcs, resolution shells
C
C     .. Parameters ..
      INTEGER IXWDTH
c      PARAMETER (IXWDTH=8192)
      PARAMETER (IXWDTH=12288)
      INTEGER IYLENGTH
c      PARAMETER (IYLENGTH=4096)
      PARAMETER (IYLENGTH=6144)
      INTEGER MAXHEAD
      PARAMETER (MAXHEAD=5120)
      INTEGER MAXBOX
      PARAMETER (MAXBOX=3000)
      INTEGER MAXDIM
      PARAMETER (MAXDIM=41)
      INTEGER MAXPAX
      PARAMETER (MAXPAX=10000)
      INTEGER MXDOV2
      PARAMETER (MXDOV2=MAXDIM/2)
      INTEGER NEXPAND
      PARAMETER (NEXPAND=2)
      INTEGER NNLINE
      PARAMETER (NNLINE=8)
      INTEGER NMASKS
      PARAMETER (NMASKS=49)
      INTEGER MAXBUFF
      PARAMETER (MAXBUFF=21000)
      INTEGER NREFLS
      PARAMETER (NREFLS=250000)
      INTEGER MREF
      PARAMETER (MREF=6000)
      INTEGER NVECT
      PARAMETER (NVECT=10000)
      INTEGER NIMAX
      PARAMETER (NIMAX=100)
      INTEGER NREJMAX
      PARAMETER (NREJMAX=1000)
      INTEGER NSPOTS
      PARAMETER (NSPOTS=5000)
      INTEGER MCOLS
      PARAMETER (MCOLS=18)
      INTEGER MCOLSTR
      PARAMETER (MCOLSTR=6)
      INTEGER NREFSTR
C
C---- Each reflection for strategy run needs MCOLSTR I*2 words
C     plus an I*4 word for the merging
C
      PARAMETER (NREFSTR = IXWDTH*IYLENGTH/(2+MCOLSTR))
      INTEGER MBLENG,MBLINT,MBLREA
      PARAMETER (MBLENG=185,MBLINT=29,MBLREA=156)
      INTEGER NDETREF
      PARAMETER (NDETREF=400)
      INTEGER NRPAR
      PARAMETER (NRPAR=14)
      INTEGER NSEGMAX
      PARAMETER (NSEGMAX=100)
      INTEGER NSEGMAXPR
      PARAMETER (NSEGMAXPR=100)
      INTEGER MULTMAX
      PARAMETER (MULTMAX=100)
      INTEGER MAXDIFF
      PARAMETER (MAXDIFF=100)
      INTEGER NRESBIN
      PARAMETER (NRESBIN=20)
      INTEGER MXSPOT
      PARAMETER (MXSPOT=5000)      
      INTEGER MAXIMG
      PARAMETER (MAXIMG=100)      
      INTEGER NPIXBG
      PARAMETER (NPIXBG=51)
      INTEGER MXCENT
      PARAMETER (MXCENT=500)
      INTEGER    NGRA,MGRA
      PARAMETER (NGRA=20)
      PARAMETER (MGRA=50000)
      INTEGER MAXBGBOX
      PARAMETER (MAXBGBOX=500)
      INTEGER MAXNPEAKS
      PARAMETER (MAXNPEAKS=500)
      INTEGER MAXEXCL
      PARAMETER (MAXEXCL=50)
C&&*&& end_include  ../inc/parameter.f
C
C
C---- Converts generate file coordinates X,Y in 10micron units
C     (relative to direct beam position)
C     to XC,YC 10micron units in the scanner coordinate frame,
C     with respect to the lower left corner of the image (that is,
C     the first pixel in the digitised image as it is stored internally
C     in MOSFLM IMAGE array) (and not the middle !).
C
C     For the image plate, TOFF is a tangential offset, ROFF is
C     a radial offset, RDTOFF is the radial dependence of TOFF.
C     .. Scalar Arguments ..
      REAL X,XC,Y,YC
C     ..
C     .. Local Scalars ..
      DOUBLE PRECISION PSI
      REAL A0,ABSX,B0,BY,CB,DISTOR,DOV2,DXTOF,FB,FR,R,SB,XD,XDASH,XM,
     +     XMP,XX,YM,YMP,YY,XMID,YMID,RAD,RSCAN,PI,CPSI,SPSI,
     +     CURVE1,CURVE2,XRED,YRED
C     ..
C     .. Intrinsic Functions ..
      INTRINSIC ABS,EXP,SIGN,SQRT,REAL
C     ..
C     .. Common blocks ..
C&&*&& include  ../inc/lmb.f
C
C $Id: lmb.f,v 1.8 2009/01/08 18:03:14 harry Exp $
C
C--- awk generated include file  lmb.h
C---- START of include file lmb.h
C ODSCAL is to scale image numbers into the range 0-255 for plotting
C average profiles.
C  GAIN should be equal to the overall gain (image counts per X-ray photon)
C of the system, and is used to evaluate standard deviations based on
C counting statistics assuming independent pixels (ie point spread function
C less than pixel size).
C INVERTX true if image is inverted in the slow (X) direction when read in.
C ISCAL is to scale final integrated intensities and sigmas
C IDIVIDE is the adc offset
C ICONST is a constant to be added to all pixels (normally zero) to
C        allow processing of images with zero pixel values in the scanned
C        area.
C IMGP is true if working with image plate data
C SPIRAL is true for scanners with a spiral readout (Mar, DIP2000)
C ORTHOG is true for scanners with orthogonal scan (FUJI, RAXIS, MD)
C NULLPIX is the value of pixels within the image but not in the active
C area of the detector
C TILED is true if there are inactive areas of the detector within the
C       inscribing circle or square.
C
C NTILEX Number of tiles in X direction
C NTILEY Number of tiles in Y direction
C TILEX  X Coordinates of the midpoints of the null areas between tiles
C TILEY  Y Coordinates of the midpoints of the null areas between tiles
C TILEWX Width of the null areas between tiles in X
C TILEWY Width of the null areas between tiles in Y


C MACHINE and MODEL denote the type of detector. 
C
C MACHINE is used in the following subroutines:
C GETBLK, GETHDR, INTPXL, INTPXL2, MXDSPL, OPENODS, PROCESS, PUTPXL
C Currently coded types are:
C
C         MACHINE        MODEL               COMMENTS
C         =======        =====               ========
C         MAR            180, 300, 345
C         RAXI(S)        RAXISII, RAXISIV
C         MD
C         FUJI
C         CCD1           CCD1                Princetown CCD at CHESS,Tiff format
C         CCD2           CCD ?               ESRF CCD detector
C         ADSC           QUAD1               ADSC 2x2 CCD detector
C
C TRUSTED whether or not the image header information can be trusted for 
C         automatic processing
C     .. Scalars in Common Block /LMB/ ..
        REAL ODSCAL,GAIN,LOGA,LOGB
        INTEGER ISCAL,IDIVIDE,ICONST,NULLPIX,NTILEX,NTILEY,
     $    RAXISCOMP,IIDIVIDE,COMPRESSION
        LOGICAL IMGP,INVERTX,SPIRAL,ORTHOG,CIRCULAR,TILED,SETADC,
     $    NEWRAXIS,BRUKNEW,TRUSTED
        CHARACTER MACHINE*4,MODEL*8

C     ..
C     .. Arrays in common /LMB/
        INTEGER TILEX,TILEY,TILEWX,TILEWY
C
C     .. Common Block /LMB/ ..
        COMMON /LMB/ ODSCAL,GAIN,LOGA,LOGB,ISCAL,IDIVIDE,ICONST,
     +       NULLPIX,NTILEX,NTILEY,RAXISCOMP,IIDIVIDE,COMPRESSION,
     +       TILEX(20),TILEY(20),TILEWX(20),TILEWY(20),IMGP,
     +       INVERTX,SPIRAL,ORTHOG,CIRCULAR,TILED,SETADC,
     $       NEWRAXIS,BRUKNEW,TRUSTED
        COMMON /LMBC/ MACHINE,MODEL

C&&*&& end_include  ../inc/lmb.f
C&&*&& include  ../inc/mcs.f
C $Id: mcs.f,v 1.1 2002/05/02 10:46:56 harry Exp $
C
C
C--- awk generated include file  mcs.h
C---- START of include file mcs.h
C
C
C     .. Scalars in common block /MCS/ ..
      REAL BASEOD,G1OD,CURV
      INTEGER FILM,FILMS,CTOFD,PCKIDX,TOSPT,N1OD,XSCMIN,XSCMAX
      LOGICAL VEE,VALONGX
C     ..
C     .. Common block /MCS/ ..
      COMMON /MCS/BASEOD,G1OD,CURV,FILM,FILMS,CTOFD,PCKIDX,TOSPT,
     $            N1OD,XSCMIN,XSCMAX,VEE,VALONGX
C     ..
C     CTOFD.... This was the crystal to detector distance (10 micron units)
C               but it has now been replaced by XTOFD in common block /XY/
C
C&&*&& end_include  ../inc/mcs.f
C&&*&& include  ../inc/ori.f
C
C $Id: ori.f,v 1.2 2007/07/12 13:25:56 andrew Exp $
C
C--- awk generated include file  ori.h
C---- START of include file ori.h
C
C     XCEN,YCEN    Coordinates (in 10 micron units) of the direct beam
C                  position relative to an origin at the position of the
C                  first pixel in the digitised image.(The SCANNER
C                  coordinate frame). These parameters are refined for
C                  each image. 
C
C     XCEN0,YCEN0  Coordinates of direct beam position at zero swing angle.
C                  (Needed for pxtomm conversion for swung detectors)
C                  These values are assigned on the basis of input direct
C                  beam coordinates, corrected for swing angle if necessary.
C                  They are not (currently) updated during refinement.
C
C     XOFF,YOFF    Distance between centre of detector and direct beam.
C
C     ..
C     .. Arrays in common /ORI/ ..
      LOGICAL FIXPAR
C
C     .. Scalars in common block /ORI/ ..
      REAL COSOM0,SINOM0,XTOFRA,YSCAL,TILT,TWIST,BULGE,
     +     VBNEG,VBPOS,VTILT,VTWIST,VVERT,TOFF,BULGE2,PBULGE,ROFF,
     +     RDTOFF,RDROFF,ROFFPHI,TOFFPHI,JUNK3,XCEN,YCEN,XCEN0,YCEN0,
     +     XOFF,YOFF,TILTMAT,TWISTMAT,DETNOR,DPSIX,SMTWIST,SMTILT,
     +     SMOMEGA0,SMYSCAL,SMTOFF,SMROFF,SMXTOFRA
      INTEGER CBAR,NODES,NPHI,NSM1,NSM2
      LOGICAL RESETCCOM,NOSMOOTH
C     ..
C     .. Common Block /ORI/ ..
      COMMON /ORI/COSOM0,SINOM0,XTOFRA,YSCAL,TILT,TWIST,BULGE,
     $       VBNEG,VBPOS,VTILT,VTWIST,VVERT,TOFF,BULGE2,PBULGE,ROFF,
     $       RDTOFF,RDROFF,ROFFPHI,TOFFPHI,JUNK3,XCEN,YCEN,XCEN0,
     +       YCEN0,XOFF,YOFF,TILTMAT,TWISTMAT,DPSIX,DETNOR(3),CBAR,
     +       NODES,NPHI,FIXPAR(NRPAR),
     $       RESETCCOM,SMTWIST,SMTILT,SMOMEGA0,SMYSCAL,SMTOFF,SMROFF,
     +       SMXTOFRA,NSM1,NSM2,NOSMOOTH
C     ..
C
C
C&&*&& end_include  ../inc/ori.f
C&&*&& include  ../inc/scn.f
C
C $Id: scn.f,v 1.3 2004/08/16 13:26:48 harry Exp $
C
C--- awk generated include file  scn.h
C---- START of include file scn.h
C
C     SCNSZ   is pixel size (in microns) divided by 25
C     RAST    pixel size in slow direction in mm
C     FACT    multiplying by FACT converts from 10 micron units 
C             (the standard unit internal to the program) into pixels
C     IYLEN   The number of pixels in the Y (fastest changing) direction
C             in the digitised image.
C     NREC    The number of pixels in the X (slow) direction in the 
C             digitised image.
C     NWORD   The number of I*2 words in the Y direction.
C     NBYTE   The number of bytes in Y direction = NWORD/2
C     NHBYTE  Number of bytes in header
C
C     ICURR   When several images are stored in a single file, ICURR is the
C             pointer to the first record of the current image in the direct
C             access file (only implemented for film data)
C     NEXTRA  The number of additional (unused) bytes padding the end of
C             each record in image file
C     BYTSWAP True if the "endedness" (Big-endian/Little-endian) of the 
C             machine that MOSFLM is running on is different to that of the
C             machine on which the image was written. This is determined by
C             looking at the value of NXPIX in the header record of the
C             image file (subroutine GETHDR)
C
C     LACTIVE True if using Rigaku active mask, False if ignoring it
C
C     .. Scalars in common block /SCN/ ..
      REAL FACT,SCNSZ,RAST,RASTY
      INTEGER NBYTE,NREC,NWORD,IYLEN,ICURR,NEXTRA,NHBYTE
      LOGICAL BYTSWAP,LACTIVE
C     ..
C     .. Common Block /SCN/ ..
      COMMON /SCN/ FACT,SCNSZ,RAST,RASTY,NBYTE,NREC,NWORD,IYLEN,
     +     ICURR,NEXTRA,NHBYTE,BYTSWAP,LACTIVE
C&&*&& end_include  ../inc/scn.f
C&&*&& include  ../inc/test.f
C--- awk generated include file  test.h
C---- START of include file test.h
C
C    Detector limits, used in SPTEST. All are in 10 micron units.
C    In the virtual detector frame, Y is parallel to the rotation axis
C    and X is orthogonal to the rotation axis.
C
C    In the scanner frame, X is parallel to the slow direction in the
C    image, Y is the fast direction.
C
C    RSCANSQ      Radius**2 of the scanned region of the plate (Mar scanners)
C                 This is different to the other limits because it is
C                 applied to the actual scanner coordinates rather than
C                 the virtual detector coordinates. All other limits apply
C                 to virtual detector coordinates.
C    XSCAN        Maximum X coordinate in detector frame (10 micron units)
C    YSCAN        Maximum Y coordinate in detector frame (10 micron units)
C    RSCANX,RSCANY If non-zero, these are the coordinates (10 micron units)
C                 for the centre of the circle radius RSCAN defining the
C                 useable area of the detector.
C    RMINX,RMINY If non-zero, these are the coordinates (10 micron units)
C                 for the centre of the circle radius RMIN defining the
C                 useable area of the detector.
C    RMXSQD       Maximum radius (squared) in virtual detector frame
C    RMNSQD       Minimum radius (squared) in virtual detector frame
C    XMIN         Minimum X coordinate in  detector frame
C    XMAX         Maximum X coordinate in  detector frame
C    YMIN         Minimum Y coordinate in  detector frame
C    YMAX         Maximum Y coordinate in  detector frame
C    NXYEXC       Number of excluded areas set by user (rectangles, arcs)
C    NXYEXCDET    Number of detector specific excluded rectangles (Pilatus)
C
C     .. Scalars in common block /TEST/ ..
      REAL RMXSQD,RMNSQD,XMIN,XMAX,YMIN,YMAX,RSCANSQ,RSCANX,RSCANY,
     +     RMINX,RMINY,XSCAN,YSCAN,CIRRAD
      INTEGER NEXCL,NXYEXC,NXYEXCDET,IQUADNO,IARCNO
C
C     .. Arrays in common block /TEST/
      REAL RESEXL,RESEXH,XYEXC,CNREXC,EXCARC,CIRCEN,PHILIM
      INTEGER IEXCARC
      LOGICAL LEXCARC
C     ..
C     .. Common Block /TEST/ ..
      COMMON /TEST/RESEXL(MAXEXCL),RESEXH(MAXEXCL),XYEXC(4,MAXEXCL),
     +     CNREXC(8,MAXEXCL),
     $     EXCARC(5,MAXEXCL),CIRCEN(2),PHILIM(2),RMXSQD,RMNSQD,XMIN,
     +     XMAX,YMIN,YMAX,RSCANSQ,RSCANX,RSCANY,RMINX,RMINY,XSCAN,
     $     YSCAN,CIRRAD,IEXCARC(6,MAXEXCL),NEXCL,NXYEXC,IQUADNO,
     $     IARCNO,LEXCARC(MAXEXCL),NXYEXCDET
C     ..
C
C

C&&*&& end_include  ../inc/test.f
C&&*&& include  ../inc/tiltlog.f
C
C $Id: tiltlog.f,v 1.1 2002/05/02 10:47:23 harry Exp $
C
C---- awk generated include file tiltlog.h
C---- START of include file tiltlog.h
C
C    for things connected with the new definitions of TILT and TWIST 
C
C     .. Scalars in common block /TILTLOG/ ..
      LOGICAL NUTWIST
      COMMON /TILTLOG/NUTWIST
C&&*&& end_include  ../inc/tiltlog.f
C&&*&& include  ../inc/xy.f
C
C $Id: xy.f,v 1.1 2002/05/02 10:47:25 harry Exp $
C
C--- awk generated include file  xy.h
C---- START of include file xy.h
C
C     .. Scalars in common block /XY/ ..
      REAL XTOFD,SINV,COSV,TANV,TWOTHETA
      INTEGER ICASS
C     ..
C     .. Common Block /XY/ ..
      COMMON /XY/XTOFD,SINV,COSV,TANV,TWOTHETA,ICASS
C     ..
C
C     XTOFD....  Crystal to detector distance in 10 micron units. Read from
C                keyworded input and never changed.
C
C                Spot positions are calculated in S/R XYSPOT (Called from
C                REEK) and are for an "ideal" detector at a distance of XTOFD.
C                These are converted into pixel positions in S/R MMTOPX
C                which applies the multiplicative factor XTOFRA to allow
C                for refinement of the distance. XTOFRA is the parameter
C                that is actually refined (in RDIST), rather than XTOFD.
C                The refined distance that is printed in the logfile is
C                actually XTOFRA*XTOFD
C
C     ICASS....  Indicates detector type:
C                0     Flat film
C                1     Vee shaped cassettes
C                2     FAST detector (only used in TESTGEN mode of OSCGEN)
C                3     Swung out FAST (ditto)
C                4     IP detector
C     TWOTHETA   Detector swing angle (degrees)
C&&*&& end_include  ../inc/xy.f
C     ..
      SAVE
C     .. Data statements ..
C
C---- A0 and B0 define shape of bulge for vee films
C     these values give 2% at x=3700 and y=6000
C
      DATA A0/2.86E-7/,B0/2.78E-8/
C     ..
C
C---- XMID, YMID are 10 micron coordinates of centre of image, needed
C     for distortions ROFF and TOFF
C
C---- RSCAN is the radius of the scanner in 10 micron units
C
      PI = 4.0*ATAN(1.0)
      RSCAN = SQRT(RSCANSQ)
      IF (RSCAN.EQ.0.0) RSCAN = 1.0
C
      XMID = 0.5*REAL(NREC)/FACT
      YMID = 0.5*REAL(IYLEN)/FACT
      XM = X*COSOM0 - Y*SINOM0
      YM = X*SINOM0 + Y*COSOM0
C
C
      IF (VEE) THEN
C
C---- confusing choice of variable names
C          BNEG=TWIST*XTOFD(*SIN(VEE))
C          BPOS=BULGE*XTOFD(*SIN(VEE))
C          XSHIFT=TILT*XTOFD(*TAN(VEE))
C
        DOV2 = XTOFD/2
        ABSX = ABS(X)
        XDASH = ABSX - 4300.0
        XD = (ABSX-DOV2)
        XMP = XD*COSOM0 - Y*SINOM0
        YMP = XD*SINOM0 + Y*COSOM0
        XX = XDASH*XDASH*A0
        YY = Y*Y*B0
        FB = EXP(-XX-YY)
        FR = FB*XMP
        BY = FB*YMP
        SB = CBAR*SINOM0
        CB = CBAR*COSOM0
C
        DISTOR = VTILT*X + VTWIST*Y + SIGN(1.0,X)*VVERT
C
C---- following 2 lines are version refining vee xshift parameter
C       xc=xm*xtofra+xcen+absx*tilt
C       yc=ym*xtofra*yscal+ycen+tilt*y*sign(1.0,x)
C
C---- following 2 lines are version refining vee twist parameter
C       xc=xm*xtofra+xcen+tilt*x*y
C       yc=ym*xtofra*yscal+ycen+tilt*y*y
C
C---- coords for refining tilt, twist and vert
C
        XC = (XTOFRA+DISTOR)*XM + XCEN
        YC = (XTOFRA+DISTOR)*YM*YSCAL + YCEN
C
        IF (X.GE.0.0) THEN
C
C---- positive x
C
          XC = XC - VBPOS*FR - CB
          YC = YC - VBPOS*BY - SB
C
C---- negative x
C
        ELSE IF (VALONGX) THEN
          XC = XC - VBNEG*FR + CB
          YC = VBNEG*BY + YC + SB
        ELSE
          XC = VBNEG*FR + XC + CB
          YC = YC - VBNEG*BY + SB
        END IF
      ELSE
C
C---- PSI is the angle between a line joining the centre of rotation
C     of the spiral scan to the spot and the scanner X axis (horizontal
C     for Mar scanner).
C     The centre of rotation is assumed to be the centre of the 
C     digitised image. The direct beam position cannot be used as it is
C     not correct for an offset detector.
C
        IF (((YCEN+YM-YMID).EQ.0.0).AND.((XCEN+XM-XMID).EQ.0)) THEN
          PSI = 0.0D0
        ELSE
          PSI = DBLE(ATAN2(YCEN+YM-YMID,XCEN+XM-XMID))
        END IF
        RAD = SQRT((XCEN+XM-XMID)**2+(YCEN+YM-YMID)**2)
        CPSI = REAL(COS(PSI))
        SPSI = REAL(SIN(PSI))
        R = SQRT(X*X+Y*Y)
c     graeme's change to see if this is at fault.
C        IF (spiral) THEN
           IF(NUTWIST)THEN
C
C---- Normalize components of ray to XTOFRA
C
              XRED = X/XTOFD
              YRED = Y/XTOFD
C     ZRED = XTOFD/XTOFD 
              IF((DETNOR(1).EQ.0.0).AND.(DETNOR(2).EQ.0.0).AND.
     $             (DETNOR(3).EQ.0.0))CALL ROTMAT2(DETNOR,TILT,TWIST)
              DXTOF = 1.0/((XRED*DETNOR(1)) + 
     $             (YRED*DETNOR(2)) + DETNOR(3))
           ELSE
              DXTOF = TILT*X + XTOFRA + TWIST*Y
           ENDIF
           CURVE1 = RDTOFF*SIN(PI*NODES*RAD/RSCAN+TOFFPHI)
           CURVE2 = RDROFF*SIN(PI*NODES*RAD/RSCAN+ROFFPHI)
           XC = DXTOF*XM + XCEN - (TOFF+CURVE1)*SPSI + 
     +          (ROFF+CURVE2)*CPSI
           YC = DXTOF*YM*YSCAL + YCEN + (TOFF+CURVE1)*CPSI + 
     +          (ROFF+CURVE2)*SPSI
C        ELSE
C           DXTOF = TILT*X + XTOFRA + TWIST*Y + BULGE*R
C           XC = DXTOF*XM + XCEN
C           YC = DXTOF*YM*YSCAL + YCEN
C        END IF
      END IF
C
C
      END
C $Id: next.f,v 1.8 2007/07/12 13:26:28 andrew Exp $
C== NEXT ==
      SUBROUTINE NEXT(LIST,IXSHIFT,IYSHIFT,PRECESS,MATCH,IFAIL,PARTLS,
     +                ADDPART,CENTRAL)
C     ================================================================
C
      IMPLICIT NONE
C
C Bug in correction of 14/2/90 fixed 20/3/90
C Last modified 14/2/90 to trap reflections outside scanned limits
C Last modified 11/7/89 to allow use of partials in refinement
C Last modified 6/10/88
C
C****** DEBUG(13) FOR THIS SUBROUTINE ******
C
C       LIST       If  true, find the centre of gravity of an existing
C                  list of reflections.
C
C                  If false, find spots suitable for refinement.
C
C       IXSHIFT     are the measurement box shifts applied to the
C       IYSHIFT     calculated (c of g) positions.
C
C       IFAIL     Flag, normally zero, returned as -1 if no spots found
C                 for refinement.
C
C       PARTLS... true:  accept partially recorded reflections
C                        otherwise reject partials
C
C       ADDPART.. True if partials on adjacent images are added together
C                 during reflection integration.
C                  In this case, if PARTLS is true, select only those
C                 partials at end of current image and add in the other
C                 part of the partial from the next image.
C
C---- Parameters refined are film centre,
C                            crystal to film distance,
C                            film orientation
C                            and distortion parameters
C
C---- Using spots chosen from those measured on a previous film pack.
C     the observed c. of g. of these spots is passed through /rfs/ to
C     rdist (or rvdist).
C
C     .. Parameters ..
C&&*&& include  ../inc/parameter.f
C
C $Id: parameter.f,v 1.17 2009/10/28 16:43:34 harry Exp $
C
C--- awk generated include file  parameter.h
C---- START of include file parameter.h
C
C       PARAMETERS
C       IYLENGTH.. maximum number of I*2 words of data in the 
C                  "fast" (ie most rapidly changing) direction in the
C                  digitised image. This will be HALF the number of pixels
C                  for film data (each pixel is stored in one byte)
C                  but will equal the number of pixels for IP data.
C       IXWDTH...  The maximum number of "stripes" of data in the scanned image
C                  ie the number of pixels in the "slow" direction
C                  (This is the Y direction in the MOSFLM convention)
C                  Note that the array "IMAGE" used to store the image is
C                  declared as size IYLENGTH*IXWDTH I*2 words for IP data
C                  and 2*IYLENGTH*IXWDTH BYTES for film data.
C                  If this exceeds the
C                  available memory, set ixwdth=1, recompile program
C                  and use keyword "NOCORE" when running program.
C                  Note that for the POSTREF and ADDPART options,
C                  two images have to be stored in memory at once so
C                  IXWDTH should be twice the number of records in an
C                  image.
C       MAXHEAD    maximum length of image header (in 4 byte words)
C       NREFLS.... maximum number of spots per film in generate file (250,000)
C       MAXBOX.... maximum number of pixels in measurement box (1500)
C       MAXDIM.... maximum box size in either direction (pixels) (41)
C       MAXPAX.... maximum number of packs per generate file (10000)
C       MXDOV2..... maxdim/2
C       MAXBUFF... maximum size of buffer (I*2) for storing ods
C                  of active spots in subroutine meas(21,000).
C                  Must be .GE.  MAXBOX*(NNLINE-1) for subroutine process
C       MREF...... maximum number of reflections to be used in post
C                  refinement (6000)
C       NEXPAND... maximum number of expansions of the input measurement
C                  box (2)
C       NMASKS.... maximum number of different profiles (25). Note the
C                  connection between this parameter and NNLINE
C       NVECT..... maximum number of vectors for storing scanned image
C                  in filmplot (10000)
C       NIMAX..... maximum number of images to be used together in 
C                  postrefinement (NADD or WIDTH options) (100)
C       NNLINE...  maximum number of boundary lines for setting up
C                  the areas for profile fitting. The maximum possible
C                  number of standard profiles will be (NNLINE-1)**2
C                  although for a circular detector the actual number
C                  may be less than this as some boxes will lie entirely
C                  outside the detector.
C       NREJMAX... Maximum number of rejected background pixels, resulting
C                  either from overlap of adjacent spots or outliers from
C                  the background plane
C       NSPOTS...  Maximum number of found spots (for autoindexing) that can
C                  be stored (for all images). Also maximum number in 
C                  a file wriitten by IMSTILLS that can be 
C                  stored/displayed/edited. THis must be an even number
C       MCOLS....  Number of columns in output MTZ file
C       MCOLSTR..  Number of columns in output MTZ file for strategy option
C     
C       MTZ Orientation block
C        MBLENG is total length of block, MBLINT, MBLREA are numbers
C          of integers & reals
C       NDETREF    Maximum number of reflections used for detector parameter
C                  refinement (previously 62)
C       NRPAR....  Maximum number of refineable parameters for detector
C                  positional refinement (subroutine RDIST)
C       NSEGMAX..  Maximum number of segments in STRATEGY
C       NSEGMAXPR  Maximum number of segments in POST-REFINEMENT
C       MULTMAX... Maximum number of observations with same hkl in COMPLETE
C       MAXDIFF... Maximum number of different packs that a given hkl occurs on
C       NRESBIN... Maximum number of resolution bins (COMPLETE)
C
C       MAXIMG...  Maximum number of images that can be read in using the IMAGE
C                  keyword or the "read Image" menu option.
C       MXSPOT...  Maximum number of spots that can be found on one image
C                  (before rejection on spot size).
C       MXCENT...  Maximum number of active spots during spot finding 
C                  (findspots)
C
C       MGRA, NGRA... maximum number of reflections and images over which a 
C                     reflection can be spread for postrefinement.
C       MAXBGBOX    Maximum number of local background background boxes 
C                   in X and Y
C
C       MAXNPEAKS   Maximum number of local maxima within one spot
C       MAXEXCL     Maximum number of excluded areas of the same type
C                   eg reactangles, quadrilaterals, arcs, resolution shells
C
C     .. Parameters ..
      INTEGER IXWDTH
c      PARAMETER (IXWDTH=8192)
      PARAMETER (IXWDTH=12288)
      INTEGER IYLENGTH
c      PARAMETER (IYLENGTH=4096)
      PARAMETER (IYLENGTH=6144)
      INTEGER MAXHEAD
      PARAMETER (MAXHEAD=5120)
      INTEGER MAXBOX
      PARAMETER (MAXBOX=3000)
      INTEGER MAXDIM
      PARAMETER (MAXDIM=41)
      INTEGER MAXPAX
      PARAMETER (MAXPAX=10000)
      INTEGER MXDOV2
      PARAMETER (MXDOV2=MAXDIM/2)
      INTEGER NEXPAND
      PARAMETER (NEXPAND=2)
      INTEGER NNLINE
      PARAMETER (NNLINE=8)
      INTEGER NMASKS
      PARAMETER (NMASKS=49)
      INTEGER MAXBUFF
      PARAMETER (MAXBUFF=21000)
      INTEGER NREFLS
      PARAMETER (NREFLS=250000)
      INTEGER MREF
      PARAMETER (MREF=6000)
      INTEGER NVECT
      PARAMETER (NVECT=10000)
      INTEGER NIMAX
      PARAMETER (NIMAX=100)
      INTEGER NREJMAX
      PARAMETER (NREJMAX=1000)
      INTEGER NSPOTS
      PARAMETER (NSPOTS=5000)
      INTEGER MCOLS
      PARAMETER (MCOLS=18)
      INTEGER MCOLSTR
      PARAMETER (MCOLSTR=6)
      INTEGER NREFSTR
C
C---- Each reflection for strategy run needs MCOLSTR I*2 words
C     plus an I*4 word for the merging
C
      PARAMETER (NREFSTR = IXWDTH*IYLENGTH/(2+MCOLSTR))
      INTEGER MBLENG,MBLINT,MBLREA
      PARAMETER (MBLENG=185,MBLINT=29,MBLREA=156)
      INTEGER NDETREF
      PARAMETER (NDETREF=400)
      INTEGER NRPAR
      PARAMETER (NRPAR=14)
      INTEGER NSEGMAX
      PARAMETER (NSEGMAX=100)
      INTEGER NSEGMAXPR
      PARAMETER (NSEGMAXPR=100)
      INTEGER MULTMAX
      PARAMETER (MULTMAX=100)
      INTEGER MAXDIFF
      PARAMETER (MAXDIFF=100)
      INTEGER NRESBIN
      PARAMETER (NRESBIN=20)
      INTEGER MXSPOT
      PARAMETER (MXSPOT=5000)      
      INTEGER MAXIMG
      PARAMETER (MAXIMG=100)      
      INTEGER NPIXBG
      PARAMETER (NPIXBG=51)
      INTEGER MXCENT
      PARAMETER (MXCENT=500)
      INTEGER    NGRA,MGRA
      PARAMETER (NGRA=20)
      PARAMETER (MGRA=50000)
      INTEGER MAXBGBOX
      PARAMETER (MAXBGBOX=500)
      INTEGER MAXNPEAKS
      PARAMETER (MAXNPEAKS=500)
      INTEGER MAXEXCL
      PARAMETER (MAXEXCL=50)
C&&*&& end_include  ../inc/parameter.f
C     ..
C     .. Scalar Arguments ..
      INTEGER IFAIL,IXSHIFT,IYSHIFT
      LOGICAL LIST,MATCH,PRECESS,PARTLS,ADDPART,CENTRAL
C     ..
C     .. Local Scalars ..
      REAL DELX,DELY,SOD,XC,XCAL,XSIZBIN,YC,YCAL,YSIZBIN,
     +     SDELX,SDELY
      INTEGER I,IADDR,IBLK,IFRST,IHWX,II,ILAST,IND,INDF,
     +        INDL,INDX,INT,ISDR,IXPIX,IYPIX,J,JREC,K,KMN,KMX,MAXB,
     +        MAXN,MAXW,MINDL,MJ,NC,NECX,NECY,NJ,NREF,NROVR,
     +        NRSOLD,NRX,NRY,NSDRP,NXS,NXX,NYS,NYY,NBGBAD,NBGBADG,
     +        XLOW,XHIGH,YLOW,YHIGH,SHX,SHY,NPBOX,IPART,NDBG,NZPBAD,
     +        IFLAG,IR,IM,IR1,IR2
      LOGICAL FULL,VALONGY
C     ..
C     .. Local Arrays ..
      INTEGER HWX(NDETREF),HWY(NDETREF),ISPOT(NDETREF),IWX(NDETREF),
     +  LRAS(5),PNTR(NDETREF),IRECNO(NDETREF),X(NDETREF),Y(NDETREF)
      INTEGER*2 IARR(MAXBUFF/2)
C     ..
C     .. External Subroutines ..
      EXTERNAL BSWAP,CGFIT,PXYCALC,RDBLK,SORTUP3,MMTOPX,GETBOX,BSWAP2
C     ..
C     .. Intrinsic Functions ..
      INTRINSIC ABS,MOD,NINT
C     ..
C     .. Common blocks ..
C&&*&& include  ../inc/trev.f
C
C $Id: trev.f,v 1.1 2002/05/02 10:47:24 harry Exp $
C
C--- awk generated include file  trev.h
C---- START of include file trev.h
C
C
C     .. Scalars in Common block /TREV/ ..
      INTEGER NXMAX,NYMAX
C     ..
C     .. Common Block /TREV/ ..
      COMMON /TREV/NXMAX,NYMAX
C     ..
C
C
C&&*&& end_include  ../inc/trev.f
C&&*&& include  ../inc/fid.f
C
C $Id: fid.f,v 1.5 2007/11/06 12:49:03 harry Exp $
C
C--- awk generated include file  fid.h
C---- START of include file fid.h
C
C     XCENF,YCENF  Coordinates (in 10 micron units) of the direct beam
C                  position relative to an origin at the position of the
C                  first pixel in the digitised image.(The SCANNER
C                  coordinate frame).
C                  For IP data this comes from the defined
C                  direct beam coordinates, for film data it is the
C                  midpoint of fiducials 1 and 3.
C
C     CCX,CCY      The difference (in 10 micron units) between the
C                  refined position of the direct beam (XCEN,YCEN) and
C                  the ideal direct beam coordinates (XCENF,YCENF),
C                  in the SCANNER coordinate frame.
C                  CCX,CCY are updated in RDIST. They are in "pixels"
C                  rather than mm (but expressed in 10micron units).
C
C     DTOFD        The distance (in 10 micron units) from the crystal
C                  to the detector along a normal to the detector.
C                  For flat, unswung detectors, or swung on a 2 theta arm,
C                  this is the same as CTOFD and XTOFD. It differs for
C                  Vee shaped cassettes. Assigned in START and never changed.
C                  Only actually used in RMAXR for calculating box sizes.
C
C     .. Arrays in common /FID/ ..
      REAL CCOMABC
      INTEGER FSPOS,CCXABC,CCYABC
C     ..
C     .. Scalars in common /FID/ ..
      REAL OMEGAF,OMEGAFD,CCOM,DTOFD,XCENF,YCENF
      INTEGER MM,MMDB,NFID,CCX,CCY,IYOFF,LABVIEW
      CHARACTER SPOTFILEORIGIN*2,SPOTFILEAXISORDER*2,SWINGAXIS*2
C     ..
C     .. Common block /FID/ ..
      COMMON /FID/CCOMABC(3),OMEGAF,OMEGAFD,CCOM,DTOFD,XCENF,YCENF,
     $     FSPOS(4,2),
     +     CCXABC(3),CCYABC(3),MM,MMDB,NFID,CCX,CCY,IYOFF,LABVIEW,
     $     SPOTFILEORIGIN,SPOTFILEAXISORDER,SWINGAXIS
C     ..
C
C
C&&*&& end_include  ../inc/fid.f
C&&*&& include  ../inc/debug.f
C
C $Id: debug.f,v 1.2 2008/07/24 09:42:21 andrew Exp $
C
C--- awk generated include file  debug.h
C---- START of include file debug.h
C
C
C
C     .. Arrays in common /DEBUG/ ..
      REAL XWARN
      INTEGER NDEBUG,IWARN
      LOGICAL DEBUG,LPRINT,DUMP,WARN
C
C     .. Scalars in common /DEBUG/ ..
      REAL BGRLIM
      INTEGER NDUMP,IDUMP,MXDUMP
      LOGICAL SPOT
C     
C     ..
C     .. Common Block /DEBUG/..
      COMMON /DEBUG/XWARN(20,100),BGRLIM,NDEBUG(100),IWARN(20,100),
     $       NDUMP,IDUMP,MXDUMP,DEBUG(100),LPRINT(20),DUMP(30),
     +       WARN(100),SPOT
C     ..
C
C&&*&& end_include  ../inc/debug.f
C&&*&& include  ../inc/gendata.f
C
C $Id: gendata.f,v 1.2 2003/01/10 16:17:53 andrew Exp $
C
C--- awk generated include file  gendata.h
C---- START of include file gendata.h
C
C     IMG       Partiality indicator. 0 for full reflections, 1 to 100
C                   for partials. Negative for partials at the start of the
C                   rotation range, +ve for partials at the end of the 
C                   rotation. Set in subroutine REEK using DELEPS calculated
C                   in subroutine DSTAR
C
C     IRG       Reflection flag  (Set by SPTEST called from DSTAR)
C               =  0  Spot can be measured
C               =  1  Outside R, X, Y limits
C               =  2  Overlapping spot (set later)
C               =  3  Too wide in phi (more than NWMAX images)
C               =  4  DST .GT. DSTMAX  Not included in final film list -
C                       used only to check for overlaps at edge of film.
C               = 10  Spot is within cusp, but will be observed...not included
C                     in final spot list but must be included in predicted
C                      pattern
C
C               =  21  Spot present on 2 images, this is 1st
C               =  22  Spot present on 2 images, this is 2nd
C
C               =  31  Spot present on 3 images, this is 1st
C               =  32  Spot present on 3 images, this is 2nd
C               =  33  Spot present on 3 images, this is 3rd
C
C               =  41  Spot present on 4 images, this is 1st
C               =  42  Spot present on 4 images, this is 2nd
C               =  43  Spot present on 3 images, this is 3rd
C               =  44  Spot present on 4 images, this is 4th
C
C                 etc etc
C
C     XG        Virtual detector X coordinate in 10 micron units, relative to
C               an origin at the direct beam position. X is parallel to the
C               Y axis in the laboratory frame, ie orthogonal to the rotation
C               axis.
C
C     YG        Virtual detector Y coordinate in 10 micron units, relative to
C               an origin at the direct beam position. Y is parallel to the
C               Z axis in the laboratory frame, ie  the rotation axis.
C
C     IX,IY     are the coordinates of the reflection in pixels
C               (integers) wrt the first pixel in the image (lower left corner
C               cameramans view). For testing for spot overlap, these
C               coordinates are in 10 micron units. Also used for display
C               pixel coordinates when displaying predicted pattern.
C
C     IREC      Pointer to the record number of a particular spot in the
C               list of generated reflections.
C
C
C     ..
C     .. Arrays in common /GENDATA/ ..
      REAL FRACG,PHIG,PHIWG,XG,YG,GOODFIT
      INTEGER INTG,IPRO,IX,IY,IREC
      INTEGER*2 IRG,IMG,IGFLAG,ISDPRO,ISDG,IHG,IKG,ILG,IMPARTG,
     +          MISYMG
C     .. Scalars in common /GENDATA/ ..
      INTEGER IPACKREC,IPACKHEAD,IRECLAST
C     ..
C     .. Common block /GENDATA/ ..
      COMMON /GENDATA/FRACG(NREFLS),PHIG(NREFLS),PHIWG(NREFLS),
     $       XG(NREFLS),YG(NREFLS),INTG(NREFLS),IPRO(NREFLS),
     $       IX(NREFLS),IY(NREFLS),IREC(NREFLS),IRG(NREFLS),IMG(NREFLS),
     +       IGFLAG(NREFLS),ISDPRO(NREFLS),ISDG(NREFLS),
     +       IHG(NREFLS),IKG(NREFLS),ILG(NREFLS),IMPARTG(NREFLS),
     +       MISYMG(NREFLS),GOODFIT(NREFLS),IPACKREC,IPACKHEAD,
     +       IRECLAST
C     ..
C
C

C&&*&& end_include  ../inc/gendata.f
C&&*&& include  ../inc/ioo.f
C
C $Id: ioo.f,v 1.7 2009/05/13 11:57:53 harry Exp $
C
C--- awk generated include file  ioo.h
C---- START of include file ioo.h
C
C
C
C     .. Scalars in common block /IOO/ ..
      INTEGER IOUT,IUNIT,ITIN,ITOUT,INOD,INMO,IDU,NWRN,IBRIEF,ISUMMR,
     +        ICOORD,SERVERFD,SERVERFDIN,NSHUTERR,dnafd
      LOGICAL ONLINE,ONEFILE,FHEADER,BRIEF,GRAPH,IOERR,
     $     NODISPLAY,LBELL,JPGOUT,SOCKLO,LBEST,dnaout,INMOOPEN,
     $     XMLOPEN
      CHARACTER dna_image*80,xmlfile*80
C     ..
C     .. Common block /IOO/ ..
c      COMMON /IOO/IOUT,IUNIT,ONLINE,ITIN,ITOUT,INOD,INMO,IDU,NWRN,
c     +            ONEFILE,FHEADER,BRIEF,IBRIEF,GRAPH,ISUMMR,ICOORD,
c     +            IOERR,NODISPLAY,LBELL
C     ..
C
C
      COMMON /IOO/IOUT,IUNIT,ITIN,ITOUT,INOD,INMO,IDU,NWRN,IBRIEF,
     +        ISUMMR,ICOORD,SERVERFD,SERVERFDIN,NSHUTERR,ONLINE,ONEFILE,
     +        FHEADER,BRIEF,GRAPH,IOERR,NODISPLAY,LBELL,JPGOUT,
     $        SOCKLO,LBEST, dnafd, dnaout,INMOOPEN,XMLOPEN
      COMMON /CIOO/dna_image,xmlfile

C&&*&& end_include  ../inc/ioo.f
C&&*&& include  ../inc/mcs.f
C $Id: mcs.f,v 1.1 2002/05/02 10:46:56 harry Exp $
C
C
C--- awk generated include file  mcs.h
C---- START of include file mcs.h
C
C
C     .. Scalars in common block /MCS/ ..
      REAL BASEOD,G1OD,CURV
      INTEGER FILM,FILMS,CTOFD,PCKIDX,TOSPT,N1OD,XSCMIN,XSCMAX
      LOGICAL VEE,VALONGX
C     ..
C     .. Common block /MCS/ ..
      COMMON /MCS/BASEOD,G1OD,CURV,FILM,FILMS,CTOFD,PCKIDX,TOSPT,
     $            N1OD,XSCMIN,XSCMAX,VEE,VALONGX
C     ..
C     CTOFD.... This was the crystal to detector distance (10 micron units)
C               but it has now been replaced by XTOFD in common block /XY/
C
C&&*&& end_include  ../inc/mcs.f
C&&*&& include  ../inc/ori.f
C
C $Id: ori.f,v 1.2 2007/07/12 13:25:56 andrew Exp $
C
C--- awk generated include file  ori.h
C---- START of include file ori.h
C
C     XCEN,YCEN    Coordinates (in 10 micron units) of the direct beam
C                  position relative to an origin at the position of the
C                  first pixel in the digitised image.(The SCANNER
C                  coordinate frame). These parameters are refined for
C                  each image. 
C
C     XCEN0,YCEN0  Coordinates of direct beam position at zero swing angle.
C                  (Needed for pxtomm conversion for swung detectors)
C                  These values are assigned on the basis of input direct
C                  beam coordinates, corrected for swing angle if necessary.
C                  They are not (currently) updated during refinement.
C
C     XOFF,YOFF    Distance between centre of detector and direct beam.
C
C     ..
C     .. Arrays in common /ORI/ ..
      LOGICAL FIXPAR
C
C     .. Scalars in common block /ORI/ ..
      REAL COSOM0,SINOM0,XTOFRA,YSCAL,TILT,TWIST,BULGE,
     +     VBNEG,VBPOS,VTILT,VTWIST,VVERT,TOFF,BULGE2,PBULGE,ROFF,
     +     RDTOFF,RDROFF,ROFFPHI,TOFFPHI,JUNK3,XCEN,YCEN,XCEN0,YCEN0,
     +     XOFF,YOFF,TILTMAT,TWISTMAT,DETNOR,DPSIX,SMTWIST,SMTILT,
     +     SMOMEGA0,SMYSCAL,SMTOFF,SMROFF,SMXTOFRA
      INTEGER CBAR,NODES,NPHI,NSM1,NSM2
      LOGICAL RESETCCOM,NOSMOOTH
C     ..
C     .. Common Block /ORI/ ..
      COMMON /ORI/COSOM0,SINOM0,XTOFRA,YSCAL,TILT,TWIST,BULGE,
     $       VBNEG,VBPOS,VTILT,VTWIST,VVERT,TOFF,BULGE2,PBULGE,ROFF,
     $       RDTOFF,RDROFF,ROFFPHI,TOFFPHI,JUNK3,XCEN,YCEN,XCEN0,
     +       YCEN0,XOFF,YOFF,TILTMAT,TWISTMAT,DPSIX,DETNOR(3),CBAR,
     +       NODES,NPHI,FIXPAR(NRPAR),
     $       RESETCCOM,SMTWIST,SMTILT,SMOMEGA0,SMYSCAL,SMTOFF,SMROFF,
     +       SMXTOFRA,NSM1,NSM2,NOSMOOTH
C     ..
C
C
C&&*&& end_include  ../inc/ori.f
C&&*&& include  ../inc/params.f
C
C $Id: params.f,v 1.1 2002/05/02 10:47:04 harry Exp $
C
C--- awk generated include file  params.h
C---- START of include file params.h
C
C
C     .. Scalars in common block /PARAMS/ ..
      INTEGER NSDR
C     ..
C     .. Common Block /PARAMS/ ..
      COMMON /PARAMS/NSDR
C     ..
C
C
C
C&&*&& end_include  ../inc/params.f
C&&*&& include  ../inc/parm1.f
C
C $Id: parm1.f,v 1.1 2002/05/02 10:47:05 harry Exp $
C
C--- awk generated include file  parm1.h
C---- START of include file parm1.h
C
C
C
C     .. Scalars in common block /PARM1/ ..
      REAL BGSIG,EFAC,EFACSQ,BGFREJ,GRADMAX,GRADMAXR,BGRAT,PKRAT,
     +     RESD,RESDLOW
      INTEGER CUTOFF,NOVPIX,NDSTART,NDTOT,IXDMIN,IXDMAX,IYDMIN,IYDMAX,
     +     IDMIN,IDMAX
      LOGICAL DUMPSPOT,BADPLOT,DUMPALL,BADPLOT2
C     ..
C     .. Common Block /PARM1/ ..
      COMMON /PARM1/BGSIG,EFAC,EFACSQ,BGFREJ,GRADMAX,GRADMAXR,
     +              BGRAT,PKRAT,RESD,RESDLOW,CUTOFF,NOVPIX,
     +              NDSTART,NDTOT,IXDMIN,IXDMAX,IYDMIN,IYDMAX,
     +              IDMIN,IDMAX,DUMPSPOT,BADPLOT,DUMPALL,BADPLOT2
C     ..
C
C
C&&*&& end_include  ../inc/parm1.f
C&&*&& include  ../inc/pel.f
C     **** This is the IMAGE PLATE version of this common block ****
C
C
C---- START of include file pel.h
C
C
C     .. Scalars in common blocks /PEL/ and /PELC/ ..
      INTEGER IBA,IPOINT,ISTART
      LOGICAL INCORE
C     ..
C     .. Arrays in common blocks /PEL/ and /PELC/ ..
      LOGICAL RDSTRIP
      INTEGER*2 BOXOD,IMAGE
C     ..
C     .. Common Blocks /PEL/ and /PELC/ ..
      COMMON /PEL/IBA,IPOINT,INCORE,RDSTRIP(IXWDTH),BOXOD(MAXBOX),
     +            ISTART
      COMMON /PELC/ IMAGE(IYLENGTH*IXWDTH)
C     ..
C
C
C---- END of include file pel.h
C
C&&*&& end_include  ../inc/pel.f
C&&*&& include  ../inc/pro.f
C
C $Id: pro.f,v 1.1 2002/05/02 10:47:09 harry Exp $
C
C--- awk generated include file  pro.h
C---- START of include file pro.h
C
C
C     .. Arrays in common block /PRO/ ..
      INTEGER*2 IDUM
C     ..
C     .. Common Block /PRO/ ..
      COMMON /PRO/IDUM(MAXBUFF)
C     ..
C
C
C&&*&& end_include  ../inc/pro.f
C&&*&& include  ../inc/ras.f
C
C $Id: ras.f,v 1.1 2002/05/02 10:47:10 harry Exp $
C
C--- awk generated include file  ras.h
C---- START of include file ras.h
C
C
C     .. Scalars in common block /RAS/ ..
      INTEGER NEWRAS,MINT
C     ..
C     .. Arrays in common block /RAS/ ..
      INTEGER IRAS
      REAL VARAS
C     ..
C     .. Common Block /RAS/ ..
      COMMON /RAS/VARAS(5),IRAS(5),NEWRAS,MINT
C     ..
C
C
C&&*&& end_include  ../inc/ras.f
C&&*&& include  ../inc/reeke.f
C
C $Id: reeke.f,v 1.15 2008/10/22 08:50:48 andrew Exp $
C
C--- awk generated include file  reeke.h
C---- START of include file reeke.h
C
C     TOR     For synchrotron sources, degree of polarisation of the beam
C     IMONO   Collimation flag for polarisation.
C             = 0   Pinhole or mirrors
C             = 1   Graphite Monochromator
C             = 2   Synchrotron, use TOR
C     NWMAX   Maximum reflection width in images
C     DSTMAX  dimensionless rlu, = WAVE/RES where RES is the maximum
C             resolution in Angstrom.
C     DSTMIN  dimensionless rlu, = WAVE/DMAX where DMAX is the maximum
C              Bragg spacing
C     S0      radiation source vector (-1,0,0), may be modified by MU values
C     SOURCE  radiation source vector - basis for s0
C     GONIO_angle:  machine angles for generalized goniostats
C     GONIO_angle_SET: fixed offset angles for 3- and 4-circle goniostats
C                      i.e. currently 54.74 deg for Bruker CHI, 50.0deg for
C                      Nonius and Oxford KAPPA 
C     ..
C     .. Arrays in common block /REEKE/ ..
      REAL RMC,AMAT,SCAXIS,S0,s0unit,CAMCON,BEAMMU
C     ..
C     .. Scalars in common block /REEKE/ ..
      REAL X1,X2,Y1,Y2,Z1,Z2,XYS,DSTAR2,DSTMAX,DSTPL,DSTPL2,
     +     DIVH,DIVV,DELAMB,ETA,DELCOR,DSTMAXS,TOR,DSTMIN,WMAX,
     +     ETAFRAC,ETASM,
     $     GON_CHI,GON_PHIS,GON_KAPPA,GON_OMEGAS,GON_2THETA,
     $     GON_PHIE,GON_OMEGAE,
     +     GON_CHI_SET,GON_KAPPA_SET,
     +     BLKSIZE
      INTEGER ISYN,IMONO,NWMAX,IPAD,NSMOOTH,IGON_CHI,IGON_PHI,
     $     IGON_KAPPA,IGON_OMEGA,IGON_2THETA,
     +     IGON_CHI_SET,IGON_KAPPA_SET,IHOSCAXIS
C     ..
C     .. logicals in common block /REEKE/ ..
      LOGICAL LOGETA,NUREEK,LCAMCON,GENGON,FOURCIRCLE,THREECIRCLE
C     ..
C     .. Common Block /REEKE/ ..
      COMMON /REEKE/RMC(3,3),AMAT(3,3),SCAXIS(3),S0(3),s0unit(3),
     $     CAMCON(8),BEAMMU(2),X1,X2,Y1,Y2,
     +     Z1,Z2,XYS,DSTAR2,DSTMAX,DSTPL,DSTPL2,DIVH,DIVV,DELAMB,
     +     ETA,DELCOR,DSTMAXS,TOR,DSTMIN,WMAX,ETAFRAC,ETASM,
     $     GON_CHI,GON_PHIS,GON_KAPPA,GON_OMEGAS,GON_2THETA,
     $     GON_PHIE,GON_OMEGAE,
     +     GON_CHI_SET,GON_KAPPA_SET,ISYN,IMONO,
     $     NWMAX,IPAD,
     $     NSMOOTH,IGON_CHI,IGON_PHI,
     $     IGON_KAPPA,IGON_OMEGA,IGON_2THETA,
     +     IGON_CHI_SET,IGON_KAPPA_SET,IHOSCAXIS,LOGETA,NUREEK,LCAMCON,
     $     GENGON,FOURCIRCLE,THREECIRCLE,
     +     BLKSIZE
C     ..
C
C
C&&*&& end_include  ../inc/reeke.f
C&&*&& include  ../inc/rfs.f
C
C $Id: rfs.f,v 1.2 2007/07/12 13:25:57 andrew Exp $
C
C--- awk generated include file  rfs.h
C---- START of include file rfs.h
C
C
C
C     .. Scalars in common block /RFS/ ..
      REAL FDIST,ESTART,RMSRES,WRMSRES,WESTART
      INTEGER MAXREF,MAXX,MAXY,NRS,MAXR,NREJS,NCENTREF
C     ..
C     .. Arrays in common block /RFS/ ..
      REAL XRS,YRS,WXRS,WYRS
      INTEGER RRS,IHKLR
C     ..
C     .. Common Block /RFS/ ..
      COMMON /RFS/ XRS(NDETREF),YRS(NDETREF),WXRS(NDETREF),
     +       WYRS(NDETREF),FDIST,ESTART,RMSRES,WRMSRES,
     $       WESTART,RRS(NDETREF),IHKLR(3,NDETREF),MAXREF,MAXX,
     +       MAXY,NRS,MAXR,NREJS,NCENTREF
C     ..
C
C
C&&*&& end_include  ../inc/rfs.f
C&&*&& include  ../inc/scn.f
C
C $Id: scn.f,v 1.3 2004/08/16 13:26:48 harry Exp $
C
C--- awk generated include file  scn.h
C---- START of include file scn.h
C
C     SCNSZ   is pixel size (in microns) divided by 25
C     RAST    pixel size in slow direction in mm
C     FACT    multiplying by FACT converts from 10 micron units 
C             (the standard unit internal to the program) into pixels
C     IYLEN   The number of pixels in the Y (fastest changing) direction
C             in the digitised image.
C     NREC    The number of pixels in the X (slow) direction in the 
C             digitised image.
C     NWORD   The number of I*2 words in the Y direction.
C     NBYTE   The number of bytes in Y direction = NWORD/2
C     NHBYTE  Number of bytes in header
C
C     ICURR   When several images are stored in a single file, ICURR is the
C             pointer to the first record of the current image in the direct
C             access file (only implemented for film data)
C     NEXTRA  The number of additional (unused) bytes padding the end of
C             each record in image file
C     BYTSWAP True if the "endedness" (Big-endian/Little-endian) of the 
C             machine that MOSFLM is running on is different to that of the
C             machine on which the image was written. This is determined by
C             looking at the value of NXPIX in the header record of the
C             image file (subroutine GETHDR)
C
C     LACTIVE True if using Rigaku active mask, False if ignoring it
C
C     .. Scalars in common block /SCN/ ..
      REAL FACT,SCNSZ,RAST,RASTY
      INTEGER NBYTE,NREC,NWORD,IYLEN,ICURR,NEXTRA,NHBYTE
      LOGICAL BYTSWAP,LACTIVE
C     ..
C     .. Common Block /SCN/ ..
      COMMON /SCN/ FACT,SCNSZ,RAST,RASTY,NBYTE,NREC,NWORD,IYLEN,
     +     ICURR,NEXTRA,NHBYTE,BYTSWAP,LACTIVE
C&&*&& end_include  ../inc/scn.f

C  Extra common blocks
C&&*&& include  ../inc/lmb.f
C
C $Id: lmb.f,v 1.8 2009/01/08 18:03:14 harry Exp $
C
C--- awk generated include file  lmb.h
C---- START of include file lmb.h
C ODSCAL is to scale image numbers into the range 0-255 for plotting
C average profiles.
C  GAIN should be equal to the overall gain (image counts per X-ray photon)
C of the system, and is used to evaluate standard deviations based on
C counting statistics assuming independent pixels (ie point spread function
C less than pixel size).
C INVERTX true if image is inverted in the slow (X) direction when read in.
C ISCAL is to scale final integrated intensities and sigmas
C IDIVIDE is the adc offset
C ICONST is a constant to be added to all pixels (normally zero) to
C        allow processing of images with zero pixel values in the scanned
C        area.
C IMGP is true if working with image plate data
C SPIRAL is true for scanners with a spiral readout (Mar, DIP2000)
C ORTHOG is true for scanners with orthogonal scan (FUJI, RAXIS, MD)
C NULLPIX is the value of pixels within the image but not in the active
C area of the detector
C TILED is true if there are inactive areas of the detector within the
C       inscribing circle or square.
C
C NTILEX Number of tiles in X direction
C NTILEY Number of tiles in Y direction
C TILEX  X Coordinates of the midpoints of the null areas between tiles
C TILEY  Y Coordinates of the midpoints of the null areas between tiles
C TILEWX Width of the null areas between tiles in X
C TILEWY Width of the null areas between tiles in Y


C MACHINE and MODEL denote the type of detector. 
C
C MACHINE is used in the following subroutines:
C GETBLK, GETHDR, INTPXL, INTPXL2, MXDSPL, OPENODS, PROCESS, PUTPXL
C Currently coded types are:
C
C         MACHINE        MODEL               COMMENTS
C         =======        =====               ========
C         MAR            180, 300, 345
C         RAXI(S)        RAXISII, RAXISIV
C         MD
C         FUJI
C         CCD1           CCD1                Princetown CCD at CHESS,Tiff format
C         CCD2           CCD ?               ESRF CCD detector
C         ADSC           QUAD1               ADSC 2x2 CCD detector
C
C TRUSTED whether or not the image header information can be trusted for 
C         automatic processing
C     .. Scalars in Common Block /LMB/ ..
        REAL ODSCAL,GAIN,LOGA,LOGB
        INTEGER ISCAL,IDIVIDE,ICONST,NULLPIX,NTILEX,NTILEY,
     $    RAXISCOMP,IIDIVIDE,COMPRESSION
        LOGICAL IMGP,INVERTX,SPIRAL,ORTHOG,CIRCULAR,TILED,SETADC,
     $    NEWRAXIS,BRUKNEW,TRUSTED
        CHARACTER MACHINE*4,MODEL*8

C     ..
C     .. Arrays in common /LMB/
        INTEGER TILEX,TILEY,TILEWX,TILEWY
C
C     .. Common Block /LMB/ ..
        COMMON /LMB/ ODSCAL,GAIN,LOGA,LOGB,ISCAL,IDIVIDE,ICONST,
     +       NULLPIX,NTILEX,NTILEY,RAXISCOMP,IIDIVIDE,COMPRESSION,
     +       TILEX(20),TILEY(20),TILEWX(20),TILEWY(20),IMGP,
     +       INVERTX,SPIRAL,ORTHOG,CIRCULAR,TILED,SETADC,
     $       NEWRAXIS,BRUKNEW,TRUSTED
        COMMON /LMBC/ MACHINE,MODEL

C&&*&& end_include  ../inc/lmb.f
C     ..
C     .. Equivalences ..
      EQUIVALENCE (IRAS(1),NXS), (IRAS(2),NYS), (IRAS(3),NC)
      EQUIVALENCE (IRAS(4),NRX), (IRAS(5),NRY)
      EQUIVALENCE (IDUM,IARR)
      EQUIVALENCE (LRAS(1),NXX), (LRAS(2),NYY)
C     ..
      SAVE
      DATA NDBG/0/
C
      IR1 = 2*IPAD + 1
      IR2 = 2*IPAD + 2
      IR2 = 30*IPAD + 30
C
C---- Define limits for coordinates of reflections,
C     allowing for maximum possible measurement box size
C
      XLOW = XSCMIN + (NXMAX/2 +1)
      XHIGH = XSCMAX - (NXMAX/2 + 1)
      YLOW = NYMAX/2 + 1
      YHIGH = IYLEN - (NYMAX/2 + 1)
C
C
      IFAIL = 0
      VALONGY = (VEE .AND. (.NOT.VALONGX))
      NBGBAD = 0
      NBGBADG = 0
      NZPBAD = 0
      NROVR = 0
C
C
      DO 10 I = 3,5
        LRAS(I) = IRAS(I)
   10 CONTINUE
C
C
      NECX = XCEN*FACT + 0.5
      NECY = YCEN*FACT + 0.5
      IF (LIST) NRSOLD = NRS
      NRS = 0
C
C
      IF (DEBUG(13)) THEN
        IF (ONLINE) WRITE (ITOUT,FMT=6001) XLOW,XHIGH,YLOW,YHIGH,LIST,
     +                                     NRSOLD
6001    FORMAT(/1X,' In Subroutine NEXT',/1X,' XLOW, XHIGH, YLOW,',
     +             ' YHIGH ',4I6, ' LIST ', L1,'  NRSOLD',I5)
        WRITE (IOUT,FMT=6001) XLOW,XHIGH,YLOW,YHIGH,LIST,NRSOLD
      END IF
C
C---- If using an existing list of reflections, get scanner coords
C
      IF (LIST) THEN
        NREF = NRSOLD
C
C
        DO 20 I = 1,NREF
C
C---- IABS because of option to allow use of partials in positional
C     refinement
C
          JREC = RRS(I)
          IRECNO(I) = JREC
          IF (JREC.LT.0) JREC = -JREC  
          XC = XG(JREC)
          YC = YG(JREC)
C
C
          IF (PRECESS) THEN
C
C                ************************
            CALL PXYCALC(XCAL,YCAL,XC,YC)
C                ************************
C
          ELSE
C
C                ***********************
            CALL MMTOPX(XCAL,YCAL,XC,YC)
C                ***********************
C
          END IF
C
C
          X(I) = NINT(XCAL*FACT)
          Y(I) = NINT(YCAL*FACT)
   20   CONTINUE
C
C
      ELSE
C
C---- No list supplied, test all spots
C
        DO 30 I = 1,NDETREF
          ISPOT(I) = 0
   30   CONTINUE
C
C---- Find maximum X and Y generate file coordinate
C
        DO 32 I = 1,TOSPT
          IXPIX = NINT(XG(I))
          IXPIX = ABS(IXPIX)
          MAXX = MAX(MAXX,IXPIX)
          IYPIX = NINT(YG(I))
          IYPIX = ABS(IYPIX)
          MAXY = MAX(MAXY,IYPIX)
 32     CONTINUE
C
        XSIZBIN = (MAXX/5.0)
        YSIZBIN = (MAXY/4.0)
C
C---- Search for the strongest full spot in each
C     subdivision of the film
C
        DO 40 I = 1,TOSPT
C
C---- Reject partials and rejected spots
C
          IR = IRG(I)
          IM = IMG(I)
C
C---- But if PARTLS set only reject "rejected" spots
C
          IF (PARTLS) THEN
            IF (IR.LT.IR1) GO TO 40
          ELSE
            IF ((IR.NE.0).OR.(IM.NE.0)) GO TO 40
          END IF
C
C
C---- Reject overloads or unmeasured spots on preceeding film
C
            INT = INTG(I)
C
C
            IF (DEBUG(13).AND.NDBG.LT.NDEBUG(13)) THEN
              NDBG = NDBG + 1
              WRITE(IOUT,FMT=6026) I,INTG(I),ISDG(I)
              IF (ONLINE) WRITE(ITOUT,FMT=6026) I,INTG(I),ISDG(I)
 6026         FORMAT(1X,'Reflection',I6,' Intensity',I8,' sigma',I8)
            END IF
            IF (INT.NE.9999 .AND. INT.GT.0) THEN
              XC = XG(I)
              YC = YG(I)
              K = (MAXX+XC)/XSIZBIN
              IF (K.GT.9) K = 9
              J = (MAXY+YC)/YSIZBIN
              IF (J.LT.1) J = 1
              IF (J.GT.6) J = 6
              INDX = 6*K + J
              ISDR = INT/ISDG(I)
C
C
              IF (ISDR.GE.ISPOT(INDX)) THEN
C
C
                IF (DEBUG(13).AND.NDBG.LT.NDEBUG(13)) THEN
                  IF (ONLINE) WRITE (ITOUT,FMT=6000) I,XG(I),YG(I),ISDR
 6000 FORMAT (1X,'Reflection',I5,'  IX,IY',2F8.1,'  ISDR',I5)
                  WRITE (IOUT,FMT=6000) I,XG(I),YG(I),ISDR
                END IF
C
C
                ISPOT(INDX) = ISDR
                IRECNO(INDX) = I
C
C
                IF (PRECESS) THEN
C
C                      ************************
                  CALL PXYCALC(XCAL,YCAL,XC,YC)
C                      ************************
C
                ELSE
C
C                      ***********************
                  CALL MMTOPX(XCAL,YCAL,XC,YC)
C                      ***********************
C
                END IF
C
C
                X(INDX) = NINT(XCAL*FACT)
                Y(INDX) = NINT(YCAL*FACT)
              END IF
            END IF
cc??          end if
   40   CONTINUE
C
C---- Count number of spots found and reject those with
C      I/SD.LT.NSDR (DEFAULTS TO 8)
C
        IF (DEBUG(13)) THEN
          IF (ONLINE) WRITE (ITOUT,FMT=6002)
 6002 FORMAT (//1X,'Selected reflections in NEXT')
          WRITE (IOUT,FMT=6002)
        END IF
C
C
   50   CONTINUE
        NREF = 0
C
C
        DO 60 I = 1,NDETREF
C
C---- NSDR set by default to 8, may be changed by keyword isdr
C
          IF (ISPOT(I).GE.NSDR) THEN
C
C---- Check that the whole measurement box lies within scanned area.
C     Assume max possible box size for this test (as in GENSORT)
C
           IF (X(I).LT.XLOW .OR. X(I).GT.XHIGH .OR.
     +         Y(I).LT.YLOW .OR. Y(I).GT.YHIGH) THEN
C     ..
C     .. bad position for box
             IF(DEBUG(13))THEN
               WRITE(IOUT,FMT=6100)X(I),Y(I)
               IF(ONLINE)WRITE(ITOUT,FMT=6100)X(I),Y(I)
 6100          FORMAT(' Bad box, X,Y =  ',2I6)
             ENDIF
           ELSE
C     ..
C     .. okay to add to list
             NREF = NREF + 1
             Y(NREF) = Y(I)
             IRECNO(NREF) = IRECNO(I)
             X(NREF) = X(I)
C     
C     
             IF (DEBUG(13)) THEN
               IF (ONLINE) WRITE (ITOUT,FMT=6004) NREF,X(I),Y(I)
 6004          FORMAT (1X,'NREF=',I5,'  X,Y ',2I6)
               WRITE (IOUT,FMT=6004) NREF,X(I),Y(I)
             END IF
C     
C     
           END IF
         ENDIF
 60    CONTINUE
C
C
C
C---- Check we have a reasonable number of reflections
C     if not, reduce the ratio to two-thirds of current  value
C     (and keep it at this for otherfilms). set a minimum of 2.
C
        IF (NREF.LT.20) THEN
C
          IF (NSDR.GE.2) THEN
            NSDRP = NINT(0.6667*NSDR)
            IF (ONLINE) WRITE (ITOUT,FMT=6008) NREF,NSDR,NSDRP
 6008 FORMAT (//1X,'***** ONLY',I3,' Reflections found with intensity ',
     +       'greater than',I3,' Sigma ****',/1X,'Ratio reduced to ',I3)
            WRITE (IOUT,FMT=6008) NREF,NSDR,NSDRP
            NSDR = NSDRP
            GO TO 50
          ELSE
            WRITE (IOUT,FMT=6006) NREF,NSDR
 6006 FORMAT (//1X,'***** ONLY',I3,' Reflections found with intensity ',
     +       'greater than',I3,' Sigma ****',/1X,'Abandon processing',
     +       ' of this film')
            IF (ONLINE) WRITE (ITOUT,FMT=6006) NREF,NSDR
            IFAIL = -1
            RETURN
          END IF
C
C
        ELSE
          GO TO 70
        END IF
C
C---- End of "IF LIST" block
C
      END IF
C
C---- Find reflections
C
   70 WRITE (IOUT,FMT=6010) NREF
 6010 FORMAT (I6,' Spots to be measured')
      IF (ONLINE) WRITE (ITOUT,FMT=6010) NREF
C
C          **********************
      CALL SORTUP3(NREF,X,Y,IRECNO)
C          **********************
C
C---- Set up variable rasters
C
      DO 80 I = 1,NREF
C       
C---- Get the raster parameters and box number for this reflection
C
        IXPIX = X(I)
        IYPIX = Y(I)
C       ***********************************
        CALL GETBOX(IXPIX,IYPIX,NXX,NYY,NPBOX)
C       ***********************************
        IHWX = NXX/2
        HWX(I) = IHWX      
        HWY(I) = NYY/2
        IWX(I) = IHWX*2 + 1
C
C---- Add in measurement box shift
C
        X(I) = X(I) + IXSHIFT
        Y(I) = Y(I) + IYSHIFT
   80 CONTINUE
C
C
      MAXB = MAXR
      IF (IMGP) THEN
        MAXW = MAXB
      ELSE
        MAXW = (MAXB+1)/2
        MAXB = 2*MAXW
      END IF
      MAXN = 0.5*MAXBUFF/MAXW
C
      INDF = 1
      INDL = 1
      IFRST = 1
      ILAST = 0
      FULL = .FALSE.
   90 CONTINUE
C
C---- Get the start of the raster for the first spot or
C     for a spot after a gap
C
      IBLK = X(INDF) - HWX(INDF)
  100 CONTINUE
C
C---- Check if trying to read outside limits of image. This can happen if
C     there has been a large shift in the refined parameters. If true,
C     simply reset IBLK to max/min allowed value.
C
      IF ((IBLK.LT.XSCMIN).OR.(IBLK.GT.XSCMAX)) THEN
       IF (IBLK.LT.XSCMIN) IBLK = XSCMIN
       IF (IBLK.GT.XSCMAX) IBLK = XSCMAX
       WRITE(6,*)'In NEXT IBLK,INDF,X,HWX',IBLK,INDF,X(INDF),HWX(INDF)
      END IF
C       ****************
        CALL RDBLK(IBLK)
C       ****************
C
  110 CONTINUE
C
C
      IF (INDL.NE.NREF) THEN
        IF (.NOT.FULL) THEN
C
C---- See if next reflection has become active
C
          MINDL = INDL + 1
C
C
          IF (IBLK.GE.X(MINDL)-HWX(MINDL)) THEN
            INDL = INDL + 1
            IF (INDL-INDF.EQ.MAXN-1) FULL = .TRUE.
            GO TO 110
          END IF
        END IF
      END IF
C
C---- Get results from this scan and start the next one
C
      IBLK = IBLK + 1
C
C---- Store optical densities for all spots included in this scan
C     the ods are transferred to iarr in call to bswap
C
      IF (INDL.GE.INDF) THEN
C
C
        DO 120 J = INDF,INDL
C
C---- MJ is pointer for reflection J, range 1 to MAXN
C
          MJ = MOD(J-1,MAXN) + 1
          IYPIX = Y(J)
          KMN = IYPIX - HWY(J)
          KMX = HWY(J) + IYPIX
C
C
          IF (J.EQ.IFRST) THEN
C
C---- If this reflection has just started,
C     set byte pointer (PNTR) into BB.
C
C---- NJ is byte pointer to start address for reflection J (MJ)
C
C---- PNTR(J) gives current address in BB for relection J  (MJ)
C
            NJ = (MJ-1)*MAXB
            PNTR(MJ) = NJ + 1
            IFRST = IFRST + 1
          END IF
C
C
          IADDR = PNTR(MJ)
C
C              ********************
          CALL BSWAP(KMN,KMX,IADDR)
C              ********************
C
C---- Add in second part for summed partials
C
        IF (ADDPART.AND.(IRECNO(J).LT.0)) THEN
C
C  Reset IADDR (incremented in BSWAP)
          IADDR = IADDR - (KMX - KMN + 1)
C               *******************
          CALL BSWAP2(KMN,KMX,IADDR)
C               *******************
        END IF
C
C---- update pointer PNTR(MJ). Note IADDR is incremented in BSWAP
C
          PNTR(MJ) = IADDR
          IWX(J) = IWX(J) - 1
  120   CONTINUE
      END IF
C
C
  130 CONTINUE
C
C---- Check if one or more spots are finished
C
      IF (IWX(INDF).EQ.0) THEN
        IND = ILAST*MAXW + 1
        ILAST = ILAST + 1
        NXX = HWX(INDF)*2 + 1
        NYY = HWY(INDF)*2 + 1
C
C---- Extract degree of partiality for CGFIT
C
        II = IRECNO(INDF)
        IF (II.LT.0) II = -II
        IPART = IMG(II)
        IF (ADDPART) IPART = 0
        IF (DEBUG(13)) THEN
          IF (ONLINE) WRITE (ITOUT,FMT=6016) X(INDF)/FACT,Y(INDF)/FACT,
     +        IRECNO(INDF),LRAS,IPART
          WRITE (IOUT,FMT=6016) X(INDF)/FACT,Y(INDF)/FACT,IRECNO(INDF),
     +        LRAS,IPART
        END IF
 6016 FORMAT (//1X,'Find C of G for XRS,YRS (10 MU)',2F8.1,' Genfile',
     +        ' record no',I5,/,1X,'Raster parameters',5I6, ' IPART',I4)
C
C            *************************************
      CALL CGFIT(IARR(IND),LRAS,1,DELX,DELY,SOD,SDELX,SDELY,
     +           IPART,IFLAG)
C            *************************************
C
C---- Reject reflections with too steep gradient
C
      IF (IFLAG.EQ.1) THEN
        NBGBADG = NBGBADG + 1
        GOTO 145
      END IF
C---- Reject reflections with too many background points rejected
C     (only tested with CGFIT)
      IF (IFLAG.EQ.2) THEN
        NBGBAD = NBGBAD + 1
        GOTO 145
      END IF
C
C---- Reject reflections containing zero value pixels (outside scanned
C     area)
      IF (IFLAG.EQ.3) THEN
        NZPBAD = NZPBAD + 1
        GOTO 145
      END IF
C
C---- Check for overloads. This should never
C     happen when processing a 'B' or 'C' film
C     since reflection list has been chosen
C     on basis of previous film in the pack, but when 'NEXT' is
C     called with a list of reflections from the central region
C     of the film if the initial residual was high then previously
C     spots which were not overloads can become overloads.
C
C---- Also, if using AUTOMATCH, overloaded reflections are allowed
C     when running CENTRS, and some of these may be selected when
C     the entire film refinement is done. In this case the parameters
C     should be well enough determined by the spots from the outer
C     region of the film, so rejecting a few from the inner region
C     shouldn't hurt.
C
        IF (IFLAG.EQ.4) THEN
          NROVR = NROVR + 1
        ELSE
C
          NRS = NRS + 1
          XRS(NRS) = (X(INDF)+DELX)/FACT
          YRS(NRS) = (Y(INDF)+DELY)/FACT
          RRS(NRS) = IRECNO(INDF)
          WXRS(NRS) = SDELX/FACT
          WYRS(NRS) = SDELY/FACT
C
C
        IF (DEBUG(13)) THEN
          SHX = (DELX+IXSHIFT)/FACT + 0.5
          SHY = (DELY+IYSHIFT)/FACT + 0.5
          WRITE (IOUT,FMT=6012) INDF,X(INDF),Y(INDF),NXX,NYY,
     +        SHX,SHY,SOD,SDELX/FACT,SDELY/FACT
          IF (ONLINE) WRITE (ITOUT,FMT=6012) INDF,X(INDF),
     +        Y(INDF),NXX,NYY,SHX,SHY,SOD,SDELX/FACT,SDELY/FACT
          IF (SPOT) CALL ODPLOT(IARR(IND),NXX,NYY,1)
        END IF
 6012 FORMAT (1X,'INDF=',I3,'   IX,IY',2I6,3X,'NX,NY',2I4,
     +        ' C OF G. SHIFTS',2I6,' SOD',F8.0,' SIGX,SIGY',2F7.2)
C
C---- Store indices if pattern matching
C
          IF (MATCH) THEN
            JREC = IRECNO(INDF)
            IF (JREC.LT.0) JREC = -JREC
C
C
            IHKLR(1,NRS) = IHG(JREC)
            IHKLR(2,NRS) = IKG(JREC)
            IHKLR(3,NRS) = ILG(JREC)
C
C
          END IF
        END IF
C
C
 145    IF (ILAST.EQ.MAXN) ILAST = 0
        INDF = INDF + 1
C
C
        IF (INDF.LE.NREF) THEN
          GO TO 130
        ELSE
          GO TO 150
        END IF
      END IF
C
C
      IF (INDF.LE.INDL) GO TO 100
      FULL = .FALSE.
      GO TO 90
CAL*  150 IF (LIST) NRS = NRSOLD
 150  CONTINUE
C
C
      IF (NROVR.NE.0) THEN
        NWRN = NWRN + 1
        WRITE (IOUT,FMT=6018) NROVR
 6018 FORMAT (/1X,'**** WARNING ****',/1X,I3,' OVERLOADS in spot refin',
     +       'ement list have been rejected')
        IF (ONLINE) WRITE (ITOUT,FMT=6018) NROVR
      END IF
      IF (NBGBAD.NE.0) THEN
          WRITE (IOUT,FMT=6020) NBGBAD,BGFREJ
 6020 FORMAT (//1X,I3,' reflections rejected because more than a ',
     1    'fraction',F5.2,' of the background pixels were rejected')
          IF (ONLINE) WRITE (ITOUT,FMT=6020) NBGBAD,BGFREJ
      END IF
      IF (NBGBADG.NE.0) THEN
          WRITE (IOUT,FMT=6022) NBGBADG,GRADMAXR
 6022 FORMAT (//1X,I3,' reflections rejected because the gradient',
     1    '/(average background) is greater then',F6.3)
          IF (ONLINE) WRITE (ITOUT,FMT=6022) NBGBADG,GRADMAXR
      END IF
      IF (NZPBAD.GT.0) THEN
          IF (CENTRAL) WARN(14) = .TRUE.
          WRITE (IOUT,FMT=6024) NZPBAD,NULLPIX
 6024     FORMAT (//1X,I3
     $         ,' reflections have been rejected because the '
     $         ,' measurement box contains',/,1X
     $         ,'pixels with values less or equal to',I5,
     +         ' (assumed to '
     $         ,'be outside the scanned area).',/,1X,
     +        'See warning at end of logfile or in summary file.')
          IF (ONLINE) WRITE (ITOUT,FMT=6024) NZPBAD,NULLPIX
      END IF
C     ..
      RETURN
      END
C
C $Id: process.f,v 1.44 2009/06/17 17:18:45 andrew Exp $
C
C== PROCESS ==
      SUBROUTINE PROCESS(NFLMO,IXSHIFT,IYSHIFT,ADDPART,ISKIPI,
     +            PLRESID,NEWPREF,NUSPOT,LPINTG,NOBACK,ID,NUMBLOCK,
     +            XMLABORT)
C     ======================================================================
      IMPLICIT NONE
C
C==============  NEW PROFILE FITTING, MASSIVE CHANGES ==========
C
C  Last modified 16/3/90 to fix bug when no reflections found in a
C  given profile box
C
C---- This subroutine reads the shoeboxes written by MEAS, forms the
C     standard profiles and calculates profile fitted and summation
C     integration intensities, monitors for "badspots" and stores
C     intensities and standard deviations to be written back to
C     generate file.
C
C
C
C****** DEBUG(18) FOR THIS SUBROUTINE ******
C
C---- Next arrays for calculating contribution of instrumention
C     errors to intensity sigmas
C     IPNTR(NREFLS)
C     INTEGER*2 NPEAK(NREFLS),IRMSBG(NREFLS),IBGND(NREFLS)
C
C
C---- Array to save averaged profiles during averaging
C     assumes no more than half the total number (nmasks) of
C     profiles will need to be averaged          
C    INTEGER*2 IPRSAVE(MAXBOX,NMASKS)
C
C     Elements of SUMPQ
C     p,q are pixel coords wrt centre of box
C     1 = sum p*p  for peak
C     2 = sum p*p  for background
C     3 = sum q*q  for peak
C     4 = sum q*q  for background
C     5 = number of peak pixels
C     6 = number of background pixels
C
C     Elements of PQSUMS
C     p,q are pixel coords wrt centre of box, all sums are for background
C        points ONLY.
C
C     1 = sum p*p  
C     2 = sum q*q
C     3 = sum p*q
C     4 = sum p
C     5 = sum q
C     6 = number of background pixels
C
C
C     Elements of ASPOT
C     1 = Summation integration intensity
C     2 = Total background counts under peak assuming peak has mm symmetry
C     3 = Rms variation in background, after rejecting background points.
C         This is evaluated in BGSOLVE called from EVAL.
C     4 = Centre of gravity in X direction (in pixels)
C     5 = Centre of gravity in Y direction (in pixels)
C         These are wrt an origin at the centre of the measurement box
C     6 = sum p*iod for background pixels
C     7 = sum q*iod for background pixels
C     8 = sum iod for background pixels
C     9 = Background plane constant a (gradient in X direction)
C    10 = Background plane constant b (gradient in Y direction)
C    11 = Background plane constant c 
C    12 = Largest deviation from background plane, excluding rejected pixels
C    13 = Profile fitted intensity
C    14 = Variance of profile fitted intensity = sum (deltasq) for peak
C         pixels only. Used to calculate PKRATIO and also profile fitted
C         sigma(I) in unweighted case only.
C    15 = Number of rejected background pixels
C    16 = Variance of profile fitted intensity in weighted case (default)
C
C
C
C
C
C
C     .. Parameters ..
C&&*&& include  ../inc/parameter.f
C
C $Id: parameter.f,v 1.17 2009/10/28 16:43:34 harry Exp $
C
C--- awk generated include file  parameter.h
C---- START of include file parameter.h
C
C       PARAMETERS
C       IYLENGTH.. maximum number of I*2 words of data in the 
C                  "fast" (ie most rapidly changing) direction in the
C                  digitised image. This will be HALF the number of pixels
C                  for film data (each pixel is stored in one byte)
C                  but will equal the number of pixels for IP data.
C       IXWDTH...  The maximum number of "stripes" of data in the scanned image
C                  ie the number of pixels in the "slow" direction
C                  (This is the Y direction in the MOSFLM convention)
C                  Note that the array "IMAGE" used to store the image is
C                  declared as size IYLENGTH*IXWDTH I*2 words for IP data
C                  and 2*IYLENGTH*IXWDTH BYTES for film data.
C                  If this exceeds the
C                  available memory, set ixwdth=1, recompile program
C                  and use keyword "NOCORE" when running program.
C                  Note that for the POSTREF and ADDPART options,
C                  two images have to be stored in memory at once so
C                  IXWDTH should be twice the number of records in an
C                  image.
C       MAXHEAD    maximum length of image header (in 4 byte words)
C       NREFLS.... maximum number of spots per film in generate file (250,000)
C       MAXBOX.... maximum number of pixels in measurement box (1500)
C       MAXDIM.... maximum box size in either direction (pixels) (41)
C       MAXPAX.... maximum number of packs per generate file (10000)
C       MXDOV2..... maxdim/2
C       MAXBUFF... maximum size of buffer (I*2) for storing ods
C                  of active spots in subroutine meas(21,000).
C                  Must be .GE.  MAXBOX*(NNLINE-1) for subroutine process
C       MREF...... maximum number of reflections to be used in post
C                  refinement (6000)
C       NEXPAND... maximum number of expansions of the input measurement
C                  box (2)
C       NMASKS.... maximum number of different profiles (25). Note the
C                  connection between this parameter and NNLINE
C       NVECT..... maximum number of vectors for storing scanned image
C                  in filmplot (10000)
C       NIMAX..... maximum number of images to be used together in 
C                  postrefinement (NADD or WIDTH options) (100)
C       NNLINE...  maximum number of boundary lines for setting up
C                  the areas for profile fitting. The maximum possible
C                  number of standard profiles will be (NNLINE-1)**2
C                  although for a circular detector the actual number
C                  may be less than this as some boxes will lie entirely
C                  outside the detector.
C       NREJMAX... Maximum number of rejected background pixels, resulting
C                  either from overlap of adjacent spots or outliers from
C                  the background plane
C       NSPOTS...  Maximum number of found spots (for autoindexing) that can
C                  be stored (for all images). Also maximum number in 
C                  a file wriitten by IMSTILLS that can be 
C                  stored/displayed/edited. THis must be an even number
C       MCOLS....  Number of columns in output MTZ file
C       MCOLSTR..  Number of columns in output MTZ file for strategy option
C     
C       MTZ Orientation block
C        MBLENG is total length of block, MBLINT, MBLREA are numbers
C          of integers & reals
C       NDETREF    Maximum number of reflections used for detector parameter
C                  refinement (previously 62)
C       NRPAR....  Maximum number of refineable parameters for detector
C                  positional refinement (subroutine RDIST)
C       NSEGMAX..  Maximum number of segments in STRATEGY
C       NSEGMAXPR  Maximum number of segments in POST-REFINEMENT
C       MULTMAX... Maximum number of observations with same hkl in COMPLETE
C       MAXDIFF... Maximum number of different packs that a given hkl occurs on
C       NRESBIN... Maximum number of resolution bins (COMPLETE)
C
C       MAXIMG...  Maximum number of images that can be read in using the IMAGE
C                  keyword or the "read Image" menu option.
C       MXSPOT...  Maximum number of spots that can be found on one image
C                  (before rejection on spot size).
C       MXCENT...  Maximum number of active spots during spot finding 
C                  (findspots)
C
C       MGRA, NGRA... maximum number of reflections and images over which a 
C                     reflection can be spread for postrefinement.
C       MAXBGBOX    Maximum number of local background background boxes 
C                   in X and Y
C
C       MAXNPEAKS   Maximum number of local maxima within one spot
C       MAXEXCL     Maximum number of excluded areas of the same type
C                   eg reactangles, quadrilaterals, arcs, resolution shells
C
C     .. Parameters ..
      INTEGER IXWDTH
c      PARAMETER (IXWDTH=8192)
      PARAMETER (IXWDTH=12288)
      INTEGER IYLENGTH
c      PARAMETER (IYLENGTH=4096)
      PARAMETER (IYLENGTH=6144)
      INTEGER MAXHEAD
      PARAMETER (MAXHEAD=5120)
      INTEGER MAXBOX
      PARAMETER (MAXBOX=3000)
      INTEGER MAXDIM
      PARAMETER (MAXDIM=41)
      INTEGER MAXPAX
      PARAMETER (MAXPAX=10000)
      INTEGER MXDOV2
      PARAMETER (MXDOV2=MAXDIM/2)
      INTEGER NEXPAND
      PARAMETER (NEXPAND=2)
      INTEGER NNLINE
      PARAMETER (NNLINE=8)
      INTEGER NMASKS
      PARAMETER (NMASKS=49)
      INTEGER MAXBUFF
      PARAMETER (MAXBUFF=21000)
      INTEGER NREFLS
      PARAMETER (NREFLS=250000)
      INTEGER MREF
      PARAMETER (MREF=6000)
      INTEGER NVECT
      PARAMETER (NVECT=10000)
      INTEGER NIMAX
      PARAMETER (NIMAX=100)
      INTEGER NREJMAX
      PARAMETER (NREJMAX=1000)
      INTEGER NSPOTS
      PARAMETER (NSPOTS=5000)
      INTEGER MCOLS
      PARAMETER (MCOLS=18)
      INTEGER MCOLSTR
      PARAMETER (MCOLSTR=6)
      INTEGER NREFSTR
C
C---- Each reflection for strategy run needs MCOLSTR I*2 words
C     plus an I*4 word for the merging
C
      PARAMETER (NREFSTR = IXWDTH*IYLENGTH/(2+MCOLSTR))
      INTEGER MBLENG,MBLINT,MBLREA
      PARAMETER (MBLENG=185,MBLINT=29,MBLREA=156)
      INTEGER NDETREF
      PARAMETER (NDETREF=400)
      INTEGER NRPAR
      PARAMETER (NRPAR=14)
      INTEGER NSEGMAX
      PARAMETER (NSEGMAX=100)
      INTEGER NSEGMAXPR
      PARAMETER (NSEGMAXPR=100)
      INTEGER MULTMAX
      PARAMETER (MULTMAX=100)
      INTEGER MAXDIFF
      PARAMETER (MAXDIFF=100)
      INTEGER NRESBIN
      PARAMETER (NRESBIN=20)
      INTEGER MXSPOT
      PARAMETER (MXSPOT=5000)      
      INTEGER MAXIMG
      PARAMETER (MAXIMG=100)      
      INTEGER NPIXBG
      PARAMETER (NPIXBG=51)
      INTEGER MXCENT
      PARAMETER (MXCENT=500)
      INTEGER    NGRA,MGRA
      PARAMETER (NGRA=20)
      PARAMETER (MGRA=50000)
      INTEGER MAXBGBOX
      PARAMETER (MAXBGBOX=500)
      INTEGER MAXNPEAKS
      PARAMETER (MAXNPEAKS=500)
      INTEGER MAXEXCL
      PARAMETER (MAXEXCL=50)
C&&*&& end_include  ../inc/parameter.f
c     gw hack - removing the badspots question sometimes. if (nostop)
C&&*&& include  ../inc/gui.f
c     gui.h
c     maintained by G.Winter
c     16th April 2002
c     $Id: gui.f,v 1.16 2003/04/04 14:22:01 harry Exp $
c     
c     This defines the variables and common blocks which are used by the
c     new gui control routine. This will also be used in xdisp and control,
c     to switch the new gui on!
c     
c     

      logical gui_switch, refine_cell(6), refine_detector(11),
     +     autocomplete, autoreturn, newmatstore
      integer nargs
      integer imageno, nstart
      parameter (nargs = 200)

c     refine_detector logical block index:
c     1: beam x 2: beam y 3: ccomega 4: yscale
c     5: distance 6: tilt 7: twist 8: roff 9: toff
c     
c     refine_cell logical block index:
c     1: a 2: b 3: c
c     4: alpha 5: beta 6: gamma
c     
c     
c     

      integer keep_phi_segments, keep_phi_start(20), 
     +     keep_phi_end(20)

      real storemeanmult

      common /gui/ gui_switch, imageno, refine_cell, refine_detector,
     +     autocomplete, nstart, autoreturn, newmatstore

      common /keep_phi/ keep_phi_segments, keep_phi_start, 
     +     keep_phi_end, storemeanmult


c     refine_cell(i) is true if you wish to refine cell(i)
C&&*&& end_include  ../inc/gui.f
      INTEGER NPARM
      PARAMETER (NPARM = 200)
C     ..
C     .. Scalar Arguments ..
      INTEGER NFLMO,IXSHIFT,IYSHIFT,ID,NUMBLOCK
      LOGICAL ADDPART,PLRESID,NEWPREF,NUSPOT,LPINTG,NOBACK,XMLABORT
C     ..
C     .. Array Arguments ..
      INTEGER ISKIPI(MAXPAX)
C     ..
C     .. Local Scalars ..
      REAL A,AX,ASUM,B,BX,BASE,BGDEVMAX,BGND,BGRATIO,BGREXP,BGRMS
     +     ,BOXFAC,BSUM,C,CX,CFAC,DELX,DELY,ERRINST,
     +     ODMIN,PEAKVAR,PI,PKIRATIO,PKRATIOS,PRFACT,
     +     R,RANGE,RMSBG,SCAI,SCAL,SCALE,SIGMAP,FRAC,PRFRAC,
     +     SIGMAPSQ,SOD,SODBG,SODPRO,SPOD,SQOD,TBGND,TPEAK,TRUOD,VBG,
     +     VSPOT,WPX,WPY,X,XR,XX,YR,YY,PKREJS,VARTOT,BGRFRC,XC,YC,
     +     XCG,YCG,XCGCEN,YCGCEN,XCGRMS,YCGRMS,XWCGRMS,YWCGRMS,WTCEN,
     +     WTPRK,WTPRSUM,GMEAN,GRMS,XWIDTH,YWIDTH,LOWPKFR,SUMREJ,SUMBG,
     +     ABSSOD,DBIN1,DBIN2,RAT1,RAT2,DSTSQ,DSPOT,X1,X2,PSCALE,
     +     XWTEMP,YWTEMP
      INTEGER I,ICENBOX,IDR,IFLG,II,IPART,
     +        IMAP,IND,INEIGH,IP,IPASS,IPLOUT,IPNT,
     +        IRECG,ISDBSI,ISIGPRO,ISPOT,ISPOTPRO,ISTRIP,IXPIX,
     +        IXCUR,IXN,IXX,IWTBOX,IYPIX,IYCUR,IYN,IXP,
     +        IYY,J,JBGND,JBOX,JDO,JKBOX,K,KREC,L,LEN,M,
     +        MASKIJ,MAXMAXR,MAXOD,MINOD,MODE,MODEWR,N,NACFILM,NBOXAV,
     +        NBREJ,NECX,NECY,NGO,NMINTR,NNOBOX,NNREJ,NOVR,
     +        NOVRSP,NOVRTOT,NP,NPBOX,NPK,NPRFILM,NRBX,NREJ,
     +        NREXP,NRF,NRFP,NRFTOT,
     +        NTOTBOX,NWKSP,NWKTOT,NXB,NXX,NXY,NXYB,NY,
     +        NYB,NYY,IFAIL,JDUMP,
     +        NSUMR,IA,IB,IC,NOFFEDGBG,NOFFEDGPK,NXYH,NOREAD,IOVER,
     +        NBADBG,ITHBIN,ISTRIPCUR,NFBOX,ICENSTRIP,
     +        ICENY,NNEIGHB,NREFSAVE,LNPARTEND,MASKMODE,NLOWPK,
     +        ISUMPART,ISUMOVER,IBAD,IR,NREJSUM,MAXPIX,NBADPK,IPMAX,
     +        NBIN1,NBIN2,IXM,IYM,LINELEN,NUMLIN,ITOG,IPPINTG,IVHPAR,
     +        IERR,IHX,IHY,IXRIM,IYRIM,IBADP,IJ,MODEBG
      LOGICAL FINISH,FULL,LDUMP,YES,ERRSET,OVRLFIT,
     +        EDGEFIT,FIRSTBOX,CENTRAL,PWARN1,GRADBAD,LBADBG,
     +        FIRSTBLOCK,XDEBUG,RECOVERED,FIRSTSP,KDUMP,MDUMP,
     +        BADSPOT,BADPROF,XMLWRITE
      CHARACTER PASS*10,
     +          BADSTR(17)*37,STR1*1,LINE*80,LINE2*80,VALUESTR*80,
     $        CALLEDFROM*80,XMLLINE*1024,LINE400*400
C     ..
C     .. Local Arrays ..
      REAL PQSUMINV(9,NMASKS),PQSUMS(6,NMASKS),PROFACT(NMASKS),
     +     PROFSUMS(4,NMASKS+1),RMSBGA(NMASKS),RMSBGBOX(NMASKS),
     +     GRADA(NMASKS),GRADASQ(NMASKS),GRADB(NMASKS),GRADBSQ(NMASKS),
     +     SAVERMS(NMASKS),SAVESCAL(NMASKS,2),SUMPQ(6,1:NNLINE-1),
     +     WTPR(9),XSH(16),YSH(16),
     +     RMSBGX(NREFLS),BGNDX(NREFLS),XCGSTRIP(1:NNLINE-1),
     +     YCGSTRIP(1:NNLINE-1),WTSTRIP(1:NNLINE-1),
     +     XCGBOX(NMASKS),YCGBOX(NMASKS),WTBOX(NMASKS),
     +     XCGSP(NMASKS),YCGSP(NMASKS),XWCGSP(NMASKS),YWCGSP(NMASKS),
     +     WCGSP(NMASKS),CBOX(NMASKS),CBOXAV(NMASKS),
     +     WPROFSUMS(4,NMASKS+1),SUMPQW(6),
     +     PQSUMSPOT(6),PQSUMINVSPOT(9),TOLBOX(NMASKS),PRGRAD(NMASKS)
      INTEGER IH(7),ILIM(4),INDEX(9),
     +        IPNTR(NREFLS),IPRNUM(9),
     +        LISTPIX(9,1:NNLINE-1),LRAS(5),MASKREJP(NREJMAX,NMASKS),
     +        MASK(MAXBOX,1:NNLINE-1),MASKREJ(NREJMAX,NMASKS),
     +        MAXODBOX(NMASKS),MINODBOX(NMASKS),
     +        NEIGHBOUR(9,NMASKS),NDSCR(1:NNLINE-1),
     +        NOVRL(NMASKS),NOVRLSAVE(NMASKS),NOVRS(1:NNLINE-1),
     +        NRBOX(1:NNLINE-1),NRFSAVE(NMASKS),NSH(16),
     +        NWK(NMASKS),NWKS(1:NNLINE-1),NWKSAVE(NMASKS), 
     +        OD(MAXBOX),TABLE(0:255),IABC(NREFLS),NCGSP(NMASKS),
     +        IPRSAVE(MAXBOX,NMASKS),IOPTRAS(3,NMASKS),
     +        IWPROFL(MAXBOX),MASKW(MAXBOX),
     +        NRFBOXW(NMASKS),LMASKREJ(NREJMAX),LMASK(MAXBOX),
     +        MASKREJAV(NREJMAX,NMASKS),MASKREJO(NREJMAX),
     +        LMASKREJP(NREJMAX),NDEBUGS(100)
      INTEGER*2 IBUF(12),NPEAK(NREFLS)
      LOGICAL AVERAGE(NMASKS),NOPROFILE(NMASKS),SDEBUG(100)
C
C---- Things for parser
C
      INTEGER IBEG(NPARM),IDEC(NPARM),IEND(NPARM),ITYP(NPARM)
      REAL VALUE(NPARM)
      INTEGER NTOK
C     ..
C     .. External Functions ..
      INTEGER LENSTR
      EXTERNAL LENSTR
C     ..
C     .. External Subroutines ..
      EXTERNAL BGREJECT,CBYTE2,COMPR,CORRELATE,GETHKL,
     +         GETPROF,INTEG2,MEANPRO,PIXLIST,
     +         PLOTPROF,PREAD,PROFREAD,PROFWRITE,PWRGEN,QUICKINT,
     +         RASPLOT,RASPLOT4,RASTOMM,REPORT,SCALEPROF,
     +         SETMASK,SETSUMS,STATS,STDPROF,TOPHAT,VARPROF,
     +         WRGEN,XYSHIFT,YESNO,CCPLWC,MPAUSE,GETSTRIP,GETYIND,
     +         GETBOX,WTPROF,WPRSETUP,PRUPDATE,MASKIT,MASKONE,INTEG3,
     +         SKIPIMG,CCPOPN,GETCENT,GETBIN,WARNINGS,MMTOPX,ODPLOT4,
     +         WRMTZ,SHUTDOWN,DISCR,RECUNPACK,GETREJ,GETMOREBG,
     +         MXD_FLU,MXDCIO,MXDWIO,MXDRIO,MPARSE,
     +         PROFGRAD
C     ..
C     .. Intrinsic Functions ..
      INTRINSIC ABS,AMAX0,ATAN,COS,MAX,MIN,MOD,SIGN,SQRT
C     ..
C     .. Common blocks ..
C&&*&& include  ../inc/backg.f
C
C $Id: backg.f,v 1.1 2002/05/02 10:46:40 harry Exp $
C
C--- awk generated include file  backg.h
C---- START of include file backg.h
C
C
C
C     .. Scalars in common block /BACKG/ ..
      REAL BGFRAC
      INTEGER NBGMIN
C     ..
C     .. Common Block /BACKG/ ..
      COMMON /BACKG/ BGFRAC,NBGMIN
C     ..
C
C
C&&*&& end_include  ../inc/backg.f
C&&*&& include  ../inc/debug.f
C
C $Id: debug.f,v 1.2 2008/07/24 09:42:21 andrew Exp $
C
C--- awk generated include file  debug.h
C---- START of include file debug.h
C
C
C
C     .. Arrays in common /DEBUG/ ..
      REAL XWARN
      INTEGER NDEBUG,IWARN
      LOGICAL DEBUG,LPRINT,DUMP,WARN
C
C     .. Scalars in common /DEBUG/ ..
      REAL BGRLIM
      INTEGER NDUMP,IDUMP,MXDUMP
      LOGICAL SPOT
C     
C     ..
C     .. Common Block /DEBUG/..
      COMMON /DEBUG/XWARN(20,100),BGRLIM,NDEBUG(100),IWARN(20,100),
     $       NDUMP,IDUMP,MXDUMP,DEBUG(100),LPRINT(20),DUMP(30),
     +       WARN(100),SPOT
C     ..
C
C&&*&& end_include  ../inc/debug.f
C&&*&& include  ../inc/dsplyc.f
C
C $Id: dsplyc.f,v 1.6 2009/02/18 14:39:17 harry Exp $
C
C--- awk generated include file  dsplyc.h
C---- START of include file dsplyc.h
C
C*******************************************************************
C
C  COMMON  /DSPLYC/
C
C       IMGLOW, IMGHI   low & high values of 16-bit image for scaling
C                       integer*2 to byte: IMGLOW maps to  0; 
C                       IMGHI to maximum. Note that these are not
C                       necessarily the actual limits of the data
C       IMGMAX          maximum value recorded on the image. Necessary for 
C                       iMosflm.
C       JDSPWD          .LT. 0  before image window has been created
C                       = +-1 for image display that can be panned
C                       = +-2 for non-interactive image display
C       MAXDEN          highest level in colour table to fill up to
C                       must be less than ~240 - number of overlay colours
C       LDSPSG          if .true., treat image as signed, ie after dark
C                          subtraction
C                       if .false., treat image as unsigned
C       NZOOM           zoom factor for image, = 0 if no zoom
C       JYZOOM, JZZOOM  1st pixel in zoomed image
C
C----   WINOPEN Flag for whether or not window is open. Do not
C               confuse with DISPMENU (/CONDATA/)which is true if the run was
C               started with a IMAGE keyword.
C
C
C       CDSPTL          banner title
C
      REAL FTOTAL,AVERAG,IMAGERMS
      INTEGER IMGLOW, IMGHI, IMGMAX,JDSPWD, MAXDEN,
     $     NZOOM, JYZOOM, JZZOOM
      INTEGER PIXEL_INTENSITIES(514)
      LOGICAL LDSPSG,WINOPEN,LPAUSE,LHELP
      COMMON /DSPLYC/ FTOTAL,AVERAG,IMAGERMS,IMGLOW, IMGHI, IMGMAX,
     *     JDSPWD,MAXDEN, NZOOM, JYZOOM, JZZOOM, PIXEL_INTENSITIES,
     $     LDSPSG,WINOPEN,LPAUSE,LHELP
C
      CHARACTER  CDSPTL*200,SHORTFN*200
      COMMON /DSPLCC/  CDSPTL,SHORTFN
C                                                           
C
C*******************************************************************


C&&*&& end_include  ../inc/dsplyc.f
C&&*&& include  ../inc/extras.f
C
C $Id: extras.f,v 1.2 2003/04/04 14:22:01 harry Exp $
C
C--- awk generated include file  extras.h
C---- START of include file extras.h
C
C
C     .. Scalars in common /EXTRAS/ ..
      INTEGER JUMPAX,NPACKS
      LOGICAL ISKIP,AFILM,BFILM,CFILM,STARTA,STARTB,STARTC,NOSTOP
C     ..
C     .. Common block /EXTRAS/ ..
      COMMON /EXTRAS/JUMPAX,NPACKS,ISKIP,AFILM,BFILM,CFILM,STARTA,
     +       STARTB,STARTC,NOSTOP
C     ..
C
C
C&&*&& end_include  ../inc/extras.f
C&&*&& include  ../inc/gendata.f
C
C $Id: gendata.f,v 1.2 2003/01/10 16:17:53 andrew Exp $
C
C--- awk generated include file  gendata.h
C---- START of include file gendata.h
C
C     IMG       Partiality indicator. 0 for full reflections, 1 to 100
C                   for partials. Negative for partials at the start of the
C                   rotation range, +ve for partials at the end of the 
C                   rotation. Set in subroutine REEK using DELEPS calculated
C                   in subroutine DSTAR
C
C     IRG       Reflection flag  (Set by SPTEST called from DSTAR)
C               =  0  Spot can be measured
C               =  1  Outside R, X, Y limits
C               =  2  Overlapping spot (set later)
C               =  3  Too wide in phi (more than NWMAX images)
C               =  4  DST .GT. DSTMAX  Not included in final film list -
C                       used only to check for overlaps at edge of film.
C               = 10  Spot is within cusp, but will be observed...not included
C                     in final spot list but must be included in predicted
C                      pattern
C
C               =  21  Spot present on 2 images, this is 1st
C               =  22  Spot present on 2 images, this is 2nd
C
C               =  31  Spot present on 3 images, this is 1st
C               =  32  Spot present on 3 images, this is 2nd
C               =  33  Spot present on 3 images, this is 3rd
C
C               =  41  Spot present on 4 images, this is 1st
C               =  42  Spot present on 4 images, this is 2nd
C               =  43  Spot present on 3 images, this is 3rd
C               =  44  Spot present on 4 images, this is 4th
C
C                 etc etc
C
C     XG        Virtual detector X coordinate in 10 micron units, relative to
C               an origin at the direct beam position. X is parallel to the
C               Y axis in the laboratory frame, ie orthogonal to the rotation
C               axis.
C
C     YG        Virtual detector Y coordinate in 10 micron units, relative to
C               an origin at the direct beam position. Y is parallel to the
C               Z axis in the laboratory frame, ie  the rotation axis.
C
C     IX,IY     are the coordinates of the reflection in pixels
C               (integers) wrt the first pixel in the image (lower left corner
C               cameramans view). For testing for spot overlap, these
C               coordinates are in 10 micron units. Also used for display
C               pixel coordinates when displaying predicted pattern.
C
C     IREC      Pointer to the record number of a particular spot in the
C               list of generated reflections.
C
C
C     ..
C     .. Arrays in common /GENDATA/ ..
      REAL FRACG,PHIG,PHIWG,XG,YG,GOODFIT
      INTEGER INTG,IPRO,IX,IY,IREC
      INTEGER*2 IRG,IMG,IGFLAG,ISDPRO,ISDG,IHG,IKG,ILG,IMPARTG,
     +          MISYMG
C     .. Scalars in common /GENDATA/ ..
      INTEGER IPACKREC,IPACKHEAD,IRECLAST
C     ..
C     .. Common block /GENDATA/ ..
      COMMON /GENDATA/FRACG(NREFLS),PHIG(NREFLS),PHIWG(NREFLS),
     $       XG(NREFLS),YG(NREFLS),INTG(NREFLS),IPRO(NREFLS),
     $       IX(NREFLS),IY(NREFLS),IREC(NREFLS),IRG(NREFLS),IMG(NREFLS),
     +       IGFLAG(NREFLS),ISDPRO(NREFLS),ISDG(NREFLS),
     +       IHG(NREFLS),IKG(NREFLS),ILG(NREFLS),IMPARTG(NREFLS),
     +       MISYMG(NREFLS),GOODFIT(NREFLS),IPACKREC,IPACKHEAD,
     +       IRECLAST
C     ..
C
C

C&&*&& end_include  ../inc/gendata.f
C&&*&& include  ../inc/ioo.f
C
C $Id: ioo.f,v 1.7 2009/05/13 11:57:53 harry Exp $
C
C--- awk generated include file  ioo.h
C---- START of include file ioo.h
C
C
C
C     .. Scalars in common block /IOO/ ..
      INTEGER IOUT,IUNIT,ITIN,ITOUT,INOD,INMO,IDU,NWRN,IBRIEF,ISUMMR,
     +        ICOORD,SERVERFD,SERVERFDIN,NSHUTERR,dnafd
      LOGICAL ONLINE,ONEFILE,FHEADER,BRIEF,GRAPH,IOERR,
     $     NODISPLAY,LBELL,JPGOUT,SOCKLO,LBEST,dnaout,INMOOPEN,
     $     XMLOPEN
      CHARACTER dna_image*80,xmlfile*80
C     ..
C     .. Common block /IOO/ ..
c      COMMON /IOO/IOUT,IUNIT,ONLINE,ITIN,ITOUT,INOD,INMO,IDU,NWRN,
c     +            ONEFILE,FHEADER,BRIEF,IBRIEF,GRAPH,ISUMMR,ICOORD,
c     +            IOERR,NODISPLAY,LBELL
C     ..
C
C
      COMMON /IOO/IOUT,IUNIT,ITIN,ITOUT,INOD,INMO,IDU,NWRN,IBRIEF,
     +        ISUMMR,ICOORD,SERVERFD,SERVERFDIN,NSHUTERR,ONLINE,ONEFILE,
     +        FHEADER,BRIEF,GRAPH,IOERR,NODISPLAY,LBELL,JPGOUT,
     $        SOCKLO,LBEST, dnafd, dnaout,INMOOPEN,XMLOPEN
      COMMON /CIOO/dna_image,xmlfile

C&&*&& end_include  ../inc/ioo.f
C&&*&& include  ../inc/mcs.f
C $Id: mcs.f,v 1.1 2002/05/02 10:46:56 harry Exp $
C
C
C--- awk generated include file  mcs.h
C---- START of include file mcs.h
C
C
C     .. Scalars in common block /MCS/ ..
      REAL BASEOD,G1OD,CURV
      INTEGER FILM,FILMS,CTOFD,PCKIDX,TOSPT,N1OD,XSCMIN,XSCMAX
      LOGICAL VEE,VALONGX
C     ..
C     .. Common block /MCS/ ..
      COMMON /MCS/BASEOD,G1OD,CURV,FILM,FILMS,CTOFD,PCKIDX,TOSPT,
     $            N1OD,XSCMIN,XSCMAX,VEE,VALONGX
C     ..
C     CTOFD.... This was the crystal to detector distance (10 micron units)
C               but it has now been replaced by XTOFD in common block /XY/
C
C&&*&& end_include  ../inc/mcs.f
C&&*&& include  ../inc/myprof.f
C
C $Id: myprof.f,v 1.2 2007/06/25 16:18:20 andrew Exp $
C
C--- awk generated include file  myprof.h
C---- START of include file myprof.h
C
C
C     .. Arrays in Common Block /MYPROF/ ..
      REAL PRSCALE,XPMAX,YPMAX,XLINE,YLINE,WPROFL,WPRSUMS
      INTEGER ISIZE,NRFBOX,IPROFL,IBOX,IXBOX,IYBOX,NPFIRST
      LOGICAL BOX
C     ..
C     .. Scalars in Common Block /MYPROF/
      REAL TOL,BGPKRAT,FRACREJ,BADTOL,TOLMIN,RECLEVEL
      INTEGER NXLINE,NYLINE,NUMBOX,IBOUND,ITRIM,NOVERLAP,MINPKSIZ
      LOGICAL HIGHRES,LOWRES,PRSET,OFFDET,PROPT,FIXBOX,LINESET,
     +        PROPTCEN,RECOVER,NOFIXBOX
C     ..
C     .. Common Block /MYPROF/ ..
      COMMON /MYPROF/PRSCALE(NMASKS,2),XPMAX(NMASKS),YPMAX(NMASKS),
     $       XLINE(NNLINE),YLINE(NNLINE),
     +       WPROFL(MAXBOX,NMASKS),WPRSUMS(MAXBOX,NMASKS),TOL,
     +       BGPKRAT,FRACREJ,BADTOL,TOLMIN,RECLEVEL,
     $       ISIZE(NMASKS,2),NRFBOX(NMASKS),
     +       IPROFL(MAXBOX,NMASKS+1),IBOX(0:NNLINE,0:NNLINE),
     +       IXBOX(NMASKS,2),IYBOX(NMASKS,2),
     +       NPFIRST(NNLINE-1),NXLINE,NYLINE,NUMBOX,IBOUND,ITRIM,
     $       NOVERLAP,MINPKSIZ,BOX(NMASKS),HIGHRES,LOWRES,PRSET,
     +       OFFDET,PROPT,FIXBOX,LINESET,PROPTCEN,RECOVER,NOFIXBOX
C     ..
C
C
C&&*&& end_include  ../inc/myprof.f
C&&*&& include  ../inc/ori.f
C
C $Id: ori.f,v 1.2 2007/07/12 13:25:56 andrew Exp $
C
C--- awk generated include file  ori.h
C---- START of include file ori.h
C
C     XCEN,YCEN    Coordinates (in 10 micron units) of the direct beam
C                  position relative to an origin at the position of the
C                  first pixel in the digitised image.(The SCANNER
C                  coordinate frame). These parameters are refined for
C                  each image. 
C
C     XCEN0,YCEN0  Coordinates of direct beam position at zero swing angle.
C                  (Needed for pxtomm conversion for swung detectors)
C                  These values are assigned on the basis of input direct
C                  beam coordinates, corrected for swing angle if necessary.
C                  They are not (currently) updated during refinement.
C
C     XOFF,YOFF    Distance between centre of detector and direct beam.
C
C     ..
C     .. Arrays in common /ORI/ ..
      LOGICAL FIXPAR
C
C     .. Scalars in common block /ORI/ ..
      REAL COSOM0,SINOM0,XTOFRA,YSCAL,TILT,TWIST,BULGE,
     +     VBNEG,VBPOS,VTILT,VTWIST,VVERT,TOFF,BULGE2,PBULGE,ROFF,
     +     RDTOFF,RDROFF,ROFFPHI,TOFFPHI,JUNK3,XCEN,YCEN,XCEN0,YCEN0,
     +     XOFF,YOFF,TILTMAT,TWISTMAT,DETNOR,DPSIX,SMTWIST,SMTILT,
     +     SMOMEGA0,SMYSCAL,SMTOFF,SMROFF,SMXTOFRA
      INTEGER CBAR,NODES,NPHI,NSM1,NSM2
      LOGICAL RESETCCOM,NOSMOOTH
C     ..
C     .. Common Block /ORI/ ..
      COMMON /ORI/COSOM0,SINOM0,XTOFRA,YSCAL,TILT,TWIST,BULGE,
     $       VBNEG,VBPOS,VTILT,VTWIST,VVERT,TOFF,BULGE2,PBULGE,ROFF,
     $       RDTOFF,RDROFF,ROFFPHI,TOFFPHI,JUNK3,XCEN,YCEN,XCEN0,
     +       YCEN0,XOFF,YOFF,TILTMAT,TWISTMAT,DPSIX,DETNOR(3),CBAR,
     +       NODES,NPHI,FIXPAR(NRPAR),
     $       RESETCCOM,SMTWIST,SMTILT,SMOMEGA0,SMYSCAL,SMTOFF,SMROFF,
     +       SMXTOFRA,NSM1,NSM2,NOSMOOTH
C     ..
C
C
C&&*&& end_include  ../inc/ori.f
C&&*&& include  ../inc/parm1.f
C
C $Id: parm1.f,v 1.1 2002/05/02 10:47:05 harry Exp $
C
C--- awk generated include file  parm1.h
C---- START of include file parm1.h
C
C
C
C     .. Scalars in common block /PARM1/ ..
      REAL BGSIG,EFAC,EFACSQ,BGFREJ,GRADMAX,GRADMAXR,BGRAT,PKRAT,
     +     RESD,RESDLOW
      INTEGER CUTOFF,NOVPIX,NDSTART,NDTOT,IXDMIN,IXDMAX,IYDMIN,IYDMAX,
     +     IDMIN,IDMAX
      LOGICAL DUMPSPOT,BADPLOT,DUMPALL,BADPLOT2
C     ..
C     .. Common Block /PARM1/ ..
      COMMON /PARM1/BGSIG,EFAC,EFACSQ,BGFREJ,GRADMAX,GRADMAXR,
     +              BGRAT,PKRAT,RESD,RESDLOW,CUTOFF,NOVPIX,
     +              NDSTART,NDTOT,IXDMIN,IXDMAX,IYDMIN,IYDMAX,
     +              IDMIN,IDMAX,DUMPSPOT,BADPLOT,DUMPALL,BADPLOT2
C     ..
C
C
C&&*&& end_include  ../inc/parm1.f
C&&*&& include  ../inc/parm2.f
C
C $Id: parm2.f,v 1.1 2002/05/02 10:47:06 harry Exp $
C
C--- awk generated include file  parm2.h
C---- START of include file parm2.h
C
C
C     .. Scalars in common block /PARM2/ ..
      REAL PRBGSIG,RMSBGPR,DISCRIM,PKWDLIM1,PKWDLIM2,PKWDLIM3,PKWDOUTL
      INTEGER ISDRATIO,PRCUTOFF,IPLOT,NRFMIN,NHKLD,IOUTL1,IOUTL2
      LOGICAL PROFILE,PROCES,SAVEFILE,CHANGEMASK,PRBFILM,PRCFILM,
     +        PRREAD,PRSAVE,WEIGHT,PRPART,USEOVRLD,USEDGE,VARPRO,
     +        WTPROFILE,DISCRIMINATE,PUPDATE,PKONLY,DENSE,PRFULLS,
     +        DECONV
C     ..
C     .. Arrays in common blocks /PEL/ and /PELC/ ..
      INTEGER IHD
C     ..
C     .. Common Block /PARM2/ ..
      COMMON /PARM2/PRBGSIG,RMSBGPR,DISCRIM,PKWDLIM1,PKWDLIM2,
     $       PKWDLIM3,PKWDOUTL,
     $       ISDRATIO,PRCUTOFF,IPLOT,NRFMIN,NHKLD,IOUTL1,IOUTL2,
     $       IHD(3,50),
     $       PROFILE,PROCES,SAVEFILE,CHANGEMASK,PRBFILM,PRCFILM,
     +       PRREAD,PRSAVE,WEIGHT,
     +       PRPART,USEOVRLD,USEDGE,VARPRO,
     +       WTPROFILE,DISCRIMINATE,
     +       PUPDATE,PKONLY,DENSE,
     +       PRFULLS,DECONV
C     ..
C
C
C&&*&& end_include  ../inc/parm2.f
C&&*&& include  ../inc/pel.f
C     **** This is the IMAGE PLATE version of this common block ****
C
C
C---- START of include file pel.h
C
C
C     .. Scalars in common blocks /PEL/ and /PELC/ ..
      INTEGER IBA,IPOINT,ISTART
      LOGICAL INCORE
C     ..
C     .. Arrays in common blocks /PEL/ and /PELC/ ..
      LOGICAL RDSTRIP
      INTEGER*2 BOXOD,IMAGE
C     ..
C     .. Common Blocks /PEL/ and /PELC/ ..
      COMMON /PEL/IBA,IPOINT,INCORE,RDSTRIP(IXWDTH),BOXOD(MAXBOX),
     +            ISTART
      COMMON /PELC/ IMAGE(IYLENGTH*IXWDTH)
C     ..
C
C
C---- END of include file pel.h
C
C&&*&& end_include  ../inc/pel.f
C&&*&& include  ../inc/praccum.f
C
C $Id: praccum.f,v 1.1 2002/05/02 10:47:08 harry Exp $
C
C--- awk generated include file  praccum.h
C---- START of include file praccum.h
C
C
C     ..
C     .. Arrays in common block /PRACCUM/ ..
      REAL PRDATA
C
C     .. Scalars in common block /PRACCUM/ ..
      LOGICAL ACCUMULATE,FIRSTPASS,SECONDPASS,THIRDPASS,FIRSTFILM,
     +        NOTREAD
C     ..
C     .. Common Block /PRACCUM/ ..
      COMMON /PRACCUM/PRDATA(4,50),ACCUMULATE,FIRSTPASS,SECONDPASS,
     +       THIRDPASS,FIRSTFILM,NOTREAD
C     ..
C
C
C&&*&& end_include  ../inc/praccum.f
C&&*&& include  ../inc/precession.f
C
C $Id: precession.f,v 1.1 2002/05/02 10:47:08 harry Exp $
C
C--- awk generated include file  precession.h
C---- START of include file precession.h
C
C
C     .. Scalars in common block /PRECESSION/ ..
      REAL D1,D2,PHIPREC,PSIPREC,PCTOFD,XLAMBDA
      LOGICAL PRECESS
C     ..
C     .. Common Block /PRECESSION/ ..
      COMMON /PRECESSION/D1,D2,PHIPREC,PSIPREC,PCTOFD,XLAMBDA,PRECESS
C     ..
C
C
C&&*&& end_include  ../inc/precession.f
C&&*&& include  ../inc/pro.f
C
C $Id: pro.f,v 1.1 2002/05/02 10:47:09 harry Exp $
C
C--- awk generated include file  pro.h
C---- START of include file pro.h
C
C
C     .. Arrays in common block /PRO/ ..
      INTEGER*2 IDUM
C     ..
C     .. Common Block /PRO/ ..
      COMMON /PRO/IDUM(MAXBUFF)
C     ..
C
C
C&&*&& end_include  ../inc/pro.f
C&&*&& include  ../inc/ras.f
C
C $Id: ras.f,v 1.1 2002/05/02 10:47:10 harry Exp $
C
C--- awk generated include file  ras.h
C---- START of include file ras.h
C
C
C     .. Scalars in common block /RAS/ ..
      INTEGER NEWRAS,MINT
C     ..
C     .. Arrays in common block /RAS/ ..
      INTEGER IRAS
      REAL VARAS
C     ..
C     .. Common Block /RAS/ ..
      COMMON /RAS/VARAS(5),IRAS(5),NEWRAS,MINT
C     ..
C
C
C&&*&& end_include  ../inc/ras.f
C&&*&& include  ../inc/reprt.f
C--- awk generated include file  reprt.h
C---- START of include file reprt.h
C
C
C
C     .. Scalars in common block /REPRT/ ..
      REAL AVBGRATIO,AVSIG,RFULL,RPART,AVPKRATIO,PKRMAXI,BGRMAXI,
     +     RFACOV,SDRATOV,SDMON,RESCUT,STHCUT
      INTEGER NREF,NOFR,NOLO,MAXBSI,MINBSI,NEDGE,NBOX,NBZERO,NNEG,
     +        NBAD,NBGRJ,NEDGE1,NPARTEND,NSPOVL,NRSYM,NHALF,NSUMPART
      LOGICAL PKACCEPT
C     ..
C     .. Arrays in common block /REPRT/ ..
      REAL RATIO,AVSD,AVSDP,AVSIG1,AVSIG2,AVINTI1,AVINTI2,AVPRI1,
     +     AVPRI2,RMSDELI1,RMSDELI2,ABSDELI1,ABSDELI2,AVPRSIG1,
     +     AVPRSIG2,AVDELSIG1,AVDELSIG2,PKRATIO,RSIGVSM,
     +     FIOVSDP,FIOVSDS,PIOVSDP,PIOVSDS,DBIN
      INTEGER IRANGE,IANAL,IANALF,NRFLS1,NRFLS2,MEANDELI1,MEANDELI2,
     +        NBGRHIST,IVSM,NIVSM,NRESPF,NRESPP,NRESSF,NRESSP,
     +        IRESPF,IRESPP,IRESSF,IRESSP,ISDRESPF,ISDRESPP,
     +        ISDRESSF,ISDRESSP
C     ..
C     .. Common Block /REPRT/ ..
      COMMON /REPRT/RATIO(10),AVSD(10),AVSDP(10),AVSIG1(10,2),
     $       AVSIG2(NMASKS,2),AVINTI1(10,2),AVINTI2(NMASKS,2),
     $       AVPRI1(10,2),AVPRI2(NMASKS,2),RMSDELI1(10,2),
     +       RMSDELI2(NMASKS,2),ABSDELI1(10,2),ABSDELI2(NMASKS,2),
     +       AVPRSIG1(10,2),AVPRSIG2(NMASKS,2),AVDELSIG1(10,2),
     +       AVDELSIG2(NMASKS,2),PKRATIO(10),RSIGVSM(13),FIOVSDP(9),
     $       FIOVSDS(9),PIOVSDP(9),PIOVSDS(9),DBIN(9),
     $       AVBGRATIO,AVSIG,RFULL,RPART,AVPKRATIO,PKRMAXI,BGRMAXI,
     $       RFACOV,SDRATOV,SDMON,RESCUT,STHCUT,
     $       IRANGE(9),IANAL(10),IANALF(10),NRFLS1(10,2),
     +       NRFLS2(NMASKS,2),MEANDELI1(10,2),MEANDELI2(NMASKS,2),
     +       NBGRHIST(32),IVSM(13),NIVSM(13),
     +       NRESPF(9),NRESPP(9),NRESSF(9),NRESSP(9),
     +       IRESPF(9),IRESPP(9),IRESSF(9),IRESSP(9),ISDRESPF(9),
     +       ISDRESPP(9),ISDRESSF(9),ISDRESSP(9),NREF,NOFR,NOLO,
     $       MAXBSI,MINBSI,NEDGE,NBOX,NBZERO,NNEG,NBAD,
     +       NBGRJ,NEDGE1,NPARTEND,NSPOVL,
     +       NRSYM,NHALF,NSUMPART,PKACCEPT
C     ..
C
C
C&&*&& end_include  ../inc/reprt.f
C&&*&& include  ../inc/rfs.f
C
C $Id: rfs.f,v 1.2 2007/07/12 13:25:57 andrew Exp $
C
C--- awk generated include file  rfs.h
C---- START of include file rfs.h
C
C
C
C     .. Scalars in common block /RFS/ ..
      REAL FDIST,ESTART,RMSRES,WRMSRES,WESTART
      INTEGER MAXREF,MAXX,MAXY,NRS,MAXR,NREJS,NCENTREF
C     ..
C     .. Arrays in common block /RFS/ ..
      REAL XRS,YRS,WXRS,WYRS
      INTEGER RRS,IHKLR
C     ..
C     .. Common Block /RFS/ ..
      COMMON /RFS/ XRS(NDETREF),YRS(NDETREF),WXRS(NDETREF),
     +       WYRS(NDETREF),FDIST,ESTART,RMSRES,WRMSRES,
     $       WESTART,RRS(NDETREF),IHKLR(3,NDETREF),MAXREF,MAXX,
     +       MAXY,NRS,MAXR,NREJS,NCENTREF
C     ..
C
C
C&&*&& end_include  ../inc/rfs.f
C&&*&& include  ../inc/scn.f
C
C $Id: scn.f,v 1.3 2004/08/16 13:26:48 harry Exp $
C
C--- awk generated include file  scn.h
C---- START of include file scn.h
C
C     SCNSZ   is pixel size (in microns) divided by 25
C     RAST    pixel size in slow direction in mm
C     FACT    multiplying by FACT converts from 10 micron units 
C             (the standard unit internal to the program) into pixels
C     IYLEN   The number of pixels in the Y (fastest changing) direction
C             in the digitised image.
C     NREC    The number of pixels in the X (slow) direction in the 
C             digitised image.
C     NWORD   The number of I*2 words in the Y direction.
C     NBYTE   The number of bytes in Y direction = NWORD/2
C     NHBYTE  Number of bytes in header
C
C     ICURR   When several images are stored in a single file, ICURR is the
C             pointer to the first record of the current image in the direct
C             access file (only implemented for film data)
C     NEXTRA  The number of additional (unused) bytes padding the end of
C             each record in image file
C     BYTSWAP True if the "endedness" (Big-endian/Little-endian) of the 
C             machine that MOSFLM is running on is different to that of the
C             machine on which the image was written. This is determined by
C             looking at the value of NXPIX in the header record of the
C             image file (subroutine GETHDR)
C
C     LACTIVE True if using Rigaku active mask, False if ignoring it
C
C     .. Scalars in common block /SCN/ ..
      REAL FACT,SCNSZ,RAST,RASTY
      INTEGER NBYTE,NREC,NWORD,IYLEN,ICURR,NEXTRA,NHBYTE
      LOGICAL BYTSWAP,LACTIVE
C     ..
C     .. Common Block /SCN/ ..
      COMMON /SCN/ FACT,SCNSZ,RAST,RASTY,NBYTE,NREC,NWORD,IYLEN,
     +     ICURR,NEXTRA,NHBYTE,BYTSWAP,LACTIVE
C&&*&& end_include  ../inc/scn.f
C&&*&& include  ../inc/sums.f
C
C $Id: sums.f,v 1.1 2002/05/02 10:47:21 harry Exp $
C
C--- awk generated include file  sums.h
C---- START of include file sums.h
C
C
C     Elements of ASPOT
C     1 = Summation integration intensity
C     2 = Total background counts under peak assuming peak has mm symmetry
C     3 = Rms variation in background, after rejecting background points.
C         This is evaluated in BGSOLVE called from EVAL.
C     4 = Centre of gravity in X direction (in pixels)
C     5 = Centre of gravity in Y direction (in pixels)
C         These are wrt an origin at the centre of the measurement box
C     6 = sum p*iod for background pixels
C     7 = sum q*iod for background pixels
C     8 = sum iod for background pixels
C     9 = Background plane constant a (gradient in X direction)
C    10 = Background plane constant b (gradient in Y direction)
C    11 = Background plane constant c 
C    12 = Largest deviation from background plane, excluding rejected pixels
C    13 = Profile fitted intensity
C    14 = Variance of profile fitted intensity = sum (deltasq) for peak
C         pixels only. Used to calculate PKRATIO and also profile fitted
C         sigma(I) in unweighted case only.
C    15 = Number of rejected background pixels
C    16 = Variance of profile fitted intensity in weighted case (default)
C    17 = sum W*DELTA**2 for profile fit
C    18   unused
C     .. Arrays in common block /SUMS/ ..
      REAL ASPOT
C     ..
C     .. Common Block /SUMS/ ..
      COMMON /SUMS/ASPOT(18)
C     ..
C
C
C&&*&& end_include  ../inc/sums.f
C&&*&& include  ../inc/spvect.f
C
C $Id: spvect.f,v 1.1 2002/05/02 10:47:19 harry Exp $
C
C--- awk generated include file  spvect.h
C---- START of include file spvect.h
C
C
C     .. Scalars in common block /SPVECT/ ..
      INTEGER NRESID,IDVECT
C
C
C     .. Arrays in Common Block /SPVECT/ ..
      INTEGER IXSBOX,IYSBOX,IXFBOX,IYFBOX
      INTEGER*2 ITXVECT
C     ..
C     .. Common Block /SPVECT/ ..
      COMMON /SPVECT/ IXSBOX(4*NREFLS),IYSBOX(4*NREFLS),
     +               IXFBOX(4*NREFLS),IYFBOX(4*NREFLS),
     +               NRESID,IDVECT,ITXVECT(NREFLS*5)
C     ..
C
C
C&&*&& end_include  ../inc/spvect.f
C
C  Extra common blocks
C&&*&& include  ../inc/lmb.f
C
C $Id: lmb.f,v 1.8 2009/01/08 18:03:14 harry Exp $
C
C--- awk generated include file  lmb.h
C---- START of include file lmb.h
C ODSCAL is to scale image numbers into the range 0-255 for plotting
C average profiles.
C  GAIN should be equal to the overall gain (image counts per X-ray photon)
C of the system, and is used to evaluate standard deviations based on
C counting statistics assuming independent pixels (ie point spread function
C less than pixel size).
C INVERTX true if image is inverted in the slow (X) direction when read in.
C ISCAL is to scale final integrated intensities and sigmas
C IDIVIDE is the adc offset
C ICONST is a constant to be added to all pixels (normally zero) to
C        allow processing of images with zero pixel values in the scanned
C        area.
C IMGP is true if working with image plate data
C SPIRAL is true for scanners with a spiral readout (Mar, DIP2000)
C ORTHOG is true for scanners with orthogonal scan (FUJI, RAXIS, MD)
C NULLPIX is the value of pixels within the image but not in the active
C area of the detector
C TILED is true if there are inactive areas of the detector within the
C       inscribing circle or square.
C
C NTILEX Number of tiles in X direction
C NTILEY Number of tiles in Y direction
C TILEX  X Coordinates of the midpoints of the null areas between tiles
C TILEY  Y Coordinates of the midpoints of the null areas between tiles
C TILEWX Width of the null areas between tiles in X
C TILEWY Width of the null areas between tiles in Y


C MACHINE and MODEL denote the type of detector. 
C
C MACHINE is used in the following subroutines:
C GETBLK, GETHDR, INTPXL, INTPXL2, MXDSPL, OPENODS, PROCESS, PUTPXL
C Currently coded types are:
C
C         MACHINE        MODEL               COMMENTS
C         =======        =====               ========
C         MAR            180, 300, 345
C         RAXI(S)        RAXISII, RAXISIV
C         MD
C         FUJI
C         CCD1           CCD1                Princetown CCD at CHESS,Tiff format
C         CCD2           CCD ?               ESRF CCD detector
C         ADSC           QUAD1               ADSC 2x2 CCD detector
C
C TRUSTED whether or not the image header information can be trusted for 
C         automatic processing
C     .. Scalars in Common Block /LMB/ ..
        REAL ODSCAL,GAIN,LOGA,LOGB
        INTEGER ISCAL,IDIVIDE,ICONST,NULLPIX,NTILEX,NTILEY,
     $    RAXISCOMP,IIDIVIDE,COMPRESSION
        LOGICAL IMGP,INVERTX,SPIRAL,ORTHOG,CIRCULAR,TILED,SETADC,
     $    NEWRAXIS,BRUKNEW,TRUSTED
        CHARACTER MACHINE*4,MODEL*8

C     ..
C     .. Arrays in common /LMB/
        INTEGER TILEX,TILEY,TILEWX,TILEWY
C
C     .. Common Block /LMB/ ..
        COMMON /LMB/ ODSCAL,GAIN,LOGA,LOGB,ISCAL,IDIVIDE,ICONST,
     +       NULLPIX,NTILEX,NTILEY,RAXISCOMP,IIDIVIDE,COMPRESSION,
     +       TILEX(20),TILEY(20),TILEWX(20),TILEWY(20),IMGP,
     +       INVERTX,SPIRAL,ORTHOG,CIRCULAR,TILED,SETADC,
     $       NEWRAXIS,BRUKNEW,TRUSTED
        COMMON /LMBC/ MACHINE,MODEL

C&&*&& end_include  ../inc/lmb.f
      COMMON /XYSCAN/ IXPIX,IYPIX
C     ..
C     .. Equivalences ..
      EQUIVALENCE (ASPOT(1),SOD), (ASPOT(2),BGND), (ASPOT(3),RMSBG)
      EQUIVALENCE (ASPOT(4),DELX), (ASPOT(5),DELY), (ASPOT(6),SPOD)
      EQUIVALENCE (ASPOT(7),SQOD), (ASPOT(8),SODBG), (ASPOT(9),A)
      EQUIVALENCE (ASPOT(10),B), (ASPOT(11),C), (ASPOT(12),BGDEVMAX)
      EQUIVALENCE (ASPOT(13),SODPRO), (ASPOT(14),PEAKVAR)
      EQUIVALENCE (IDUM(1),MASK(1,1))
      EQUIVALENCE (LRAS(1),NXX), (LRAS(2),NYY)
C     ..
      SAVE
C     .. Data statements ..
      DATA INDEX/6,4,7,2,1,3,8,5,9/
      DATA FIRSTBLOCK/.TRUE./
      DATA BADSTR/'Poor fit to background plane',
     +            'Poor profile fit',
     +            'Poor background plane and profile fit',
     +            'Intensity too negative',
     +            'Poor background plane,I too negative',
     +            'Poor profile fit and I too negative',
     +            'Poor bk plane and prof fit, I too -ve',
     +            'Background plane gradient too steep',
     +            'Poor bk plane fit, gradient too steep',
     +            'Poor profile fit, gradient too steep',
     +            'Bkg plane, profile fit and gradient',
     +            'I too -ve and gradient too steep',
     +            'I too -ve, bk plane, gradient',
     +            'I too -ve,bk and profile fit,gradient',
     +            'Everything !!',
     +            'Less than 10 background pixels left',
     +            '  '/
C
C
      CALLEDFROM = 'PROCESS'
      MAXPIX = 0
      XDEBUG = .FALSE.
C
C----- Number of bins for resolution analysis (don't change, formats will not
C      be correct
C      NBIN2 is number of resolution bins when checking to see if data should
C      not be written to MTZ file (RESOLUTION CUTOFF keywords)
C
      NBIN1 = 8
      NBIN2 = 30
C
      IF (FIRSTFILM) THEN
        XWIDTH = 0.0
        YWIDTH = 0.0
C
C---- IDR indicates direction of scanning, +1 for left to right
C
        IDR = 1
C     
C---- NOREAD keeps track of the number of "images" read from SPOTOD.
C     When using postrefinement, if the shift in orientation is large
C     so that the image is remeasured, then the measurement boxes will
C     be written out twice, and the first should be skipped. Array ISKIPI
C     (set in MAIN) keeps track of skipping required.
C
        NOREAD = 0
C
        IF (.NOT.IMGP) THEN
C                                                     
C---- Generate look-up table for corrected ods and sigmas
C                          
          CFAC = CURV/N1OD
          BASE = BASEOD*N1OD
C
C
          DO 10 I = 0,255
            TRUOD = I - BASE
            TABLE(I) = (CFAC*TRUOD+1.0)*TRUOD + 0.5
            TABLE(I) = AMAX0(0,TABLE(I))
   10     CONTINUE
C
        END IF
C
C---- Determine scale factor for intensities
C
C            **********************************
        CALL SETMASK(MASK(1,1),IRAS)
        CALL SETSUMS(MASK(1,1),IRAS,SUMPQ(1,1))
C            **********************************
C
        SCAI = 2.0*FLOAT(ISCAL)/SUMPQ(5,1)
C
C---- IOVER is flag for overloaded reflections, 9999 for film,
C     999999 for IP.
C
        IOVER = 9999
C
C---- For IP, make scale factor 1.0 for Mar scanners and 1.0/GAIN for others
C
C
C      ***** machine specific code follows *****
C
        IF (IMGP) THEN
          IOVER = 999999
          IF (MACHINE.EQ.'MAR ') THEN
            SCAI = 1.0
          ELSE
            SCAI = 1.0/GAIN
          END IF
C
          IRANGE(1) = -750
          IRANGE(2) = 0
          DO 11 I = 3,9
            IRANGE(I) = 1250*2**(I-3)    
 11       CONTINUE
        END IF
C
C---- Set up resolution bins
C
        IRECG = 0
        CALL GETBIN(IRECG,ITHBIN,NBIN1,DSTSQ)
C
C---- END of IF FIRSTFILM block
C
        IF (NUMBLOCK.EQ.1) THEN
          DO 15 I = 1,NMASKS
            DO 13 J = 1,3
              IOPTRAS(J,I) = IRAS(J+2)
 13         CONTINUE
 15       CONTINUE
        END IF
      END IF
C
C
      PI = ATAN(1.0)*4.0
      NLOWPK = 0
      NRESID = 0
C
C---- Initialise AVERAGE here so that it is not reset when returning
C     to reform standard profiles for the first block of images after
C     determining the optimised raster parameters
      DO 12 M = 1,NMASKS
        AVERAGE(M) = .FALSE.
 12   CONTINUE
C
C---- Read XCEN etc from MOSFLM.OUT. First check if this "image" should
C     be skipped (only occures when films are measured twice as a result
C     of a large shift in postrefinement)
C
 14   NOREAD = NOREAD + 1
      IF (ISKIPI(NOREAD).NE.0) THEN
        IF (DEBUG(18)) THEN
          WRITE(IOUT,FMT=6001) NOREAD
          IF (ONLINE) WRITE(ITOUT,FMT=6001) NOREAD
 6001 FORMAT(1X,'Skipping image number',I3)
        END IF
        CALL SKIPIMG(INMO)
        GOTO 14
      END IF
C     
      IF(NUSPOT)THEN
        CALL SPHDREAD(XCEN,YCEN,NREF,MAXR,LNPARTEND)
      ELSE
        READ (INMO) XCEN,YCEN,NREF,MAXR,LNPARTEND
      ENDIF
C
C
      IF (DEBUG(18)) THEN
        IF (ONLINE) WRITE (ITOUT,FMT=6000) MAXR,XCEN,YCEN,NREF
 6000 FORMAT (//1X,'Start PROCESS, MAXR,XCEN,YCEN,NREF',I6,2F7.1,I6)
        WRITE (IOUT,FMT=6000) MAXR,XCEN,YCEN,NREF
      END IF
C
C
      IF (ONLINE) THEN
        IF (FIRSTFILM) THEN
          IF (ONLINE) WRITE (ITOUT,FMT=6002)
          IF (BRIEF) WRITE (IBRIEF,FMT=6002)
        ELSE
          IF (ONLINE) WRITE (ITOUT,FMT=6005)
          IF (BRIEF) WRITE (IBRIEF,FMT=6005)
       END IF
      END IF
 6002 FORMAT(1X,'Forming standard profiles and integrating first',
     +        ' image')
 6005 FORMAT(1X,'Integrating spots by profile fitting')
 6160 FORMAT(1X,'Residual vector plot follows')
C
C---- If profile plotting requested, open output file
C
      IPLOUT = 12
      IFAIL = 1
      IF (IPLOT.GT.0)
C
C           *********************************************
     +      CALL CCPOPN(-IPLOUT,'prplot.dat',1,2,80,IFAIL)
C           *********************************************
C---- Direct beam coordinates in pixels
C
      NECX = XCEN*FACT + 0.5
      NECY = YCEN*FACT + 0.5
C
C
      IF (SECONDPASS) THEN
        PASS = 'SECONDPASS'
      ELSE
        PASS = 'THIRDPASS'
      END IF
C
      K = 0
C
C
      DO 30 M = 1,NMASKS
        CBOX(M) = 0.0
        CBOXAV(M) = 0.0
        DO 20 L = 1,2
          AVINTI2(M,L) = 0.0
          AVPRI2(M,L) = 0.0
          RMSDELI2(M,L) = 0.0
          ABSDELI2(M,L) = 0.0
          NRFLS2(M,L) = 0
          MEANDELI2(M,L) = 0
          AVSIG2(M,L) = 0.0
          AVPRSIG2(M,L) = 0.0
          AVDELSIG2(M,L) = 0.0
          IF (M.GT.10) GO TO 20
          AVINTI1(M,L) = 0.0
          AVPRI1(M,L) = 0.0
          RMSDELI1(M,L) = 0.0
          ABSDELI1(M,L) = 0.0
          NRFLS1(M,L) = 0
          MEANDELI1(M,L) = 0
          AVSIG1(M,L) = 0.0
          AVPRSIG1(M,L) = 0.0
          AVDELSIG1(M,L) = 0.0
   20   CONTINUE
   30 CONTINUE
C
C
      DO 40 M = 1,32
        NBGRHIST(M) = 0
   40 CONTINUE
C
C---- Clear for statistics
C
      NSPOVL = 0
      NBREJ = 0
      NBADBG = 0
      LBADBG = .FALSE.
      NOLO = 0
      NEDGE = 0
      NEDGE1 = 0
      NBOX = 0
      NBZERO = 0
      NOFR = 0
      NNOBOX = 0
      MAXBSI = 0
      MINBSI = 200
C
C
      DO 50 I = 1,10
        IANAL(I) = 0
        IANALF(I) = 0
        PKRATIO(I) = 0.0
        AVSD(I) = 0.0
        AVSDP(I) = 0.0
        RATIO(I) = 0.0
   50 CONTINUE
C
      DO 52 I = 1,9
        NRESPF(I) = 0
        NRESPP(I) = 0
        NRESSF(I) = 0
        NRESSP(I) = 0
        FIOVSDP(I) = 0.0
        FIOVSDS(I) = 0.0
        PIOVSDP(I) = 0.0
        PIOVSDS(I) = 0.0
        IRESPF(I) = 0
        IRESPP(I) = 0
        IRESSF(I) = 0
        IRESSP(I) = 0
        ISDRESPF(I) = 0
        ISDRESPP(I) = 0
        ISDRESSF(I) = 0
        ISDRESSP(I) = 0
 52   CONTINUE
C
C
      DO 60 I = 1,16
        XSH(I) = 0.0
        YSH(I) = 0.0
        NSH(I) = 0
        IF (I.GT.13) GO TO 60
        IVSM(I) = 0
        RSIGVSM(I) = 0
        NIVSM(I) = 0
   60 CONTINUE
C
C---- Set corner cutoff and X and Y rim parameters. These are the same for
C     all measurement boxes (prior to optimisation).
C
      DO 70 I = 3,5
        LRAS(I) = IRAS(I)
   70 CONTINUE
C
C---- If keyword set, read measurement box look-up array ibox
C     and profiles from logical file profile
C
      IF ((PRREAD) .AND. FIRSTFILM .AND. NOTREAD) THEN
        NOTREAD = .FALSE.
        SCALE = 1.0
        ODMIN = 0.0
        CALL PROFREAD(MASKREJ,PQSUMS,PQSUMINV,PROFSUMS,WPROFSUMS,XCGBOX,
     +                 YCGBOX,XCGCEN,YCGCEN,ICENBOX,CENTRAL,IOPTRAS,
     +                 PROFACT)
C
C---- If using variable profiles, set up the quadrilaterals used to
C     define which profiles are to be used in forming the average
C     profile.
        IF (VARPRO) THEN
          MODE = 0
          XR = 0.0
          YR = 0.0
          CALL VARPROF(MODE,XCGBOX,YCGBOX,XCGCEN,YCGCEN,ICENBOX,
     +               CENTRAL,XR,YR,NUMBOX,IPRNUM,WTPR)
          MODE = 1
      END IF
C
C---- Skip profile formation
C
        GO TO 630
      END IF
C
C---- If secondpass, but not firstfilm, need to assign xcen etc
C
      IF (SECONDPASS .AND. (.NOT.FIRSTFILM)) THEN
        NPRFILM = NPRFILM + 1
        IF (DEBUG(18)) THEN
          WRITE (IOUT,FMT=6012) PASS,NPRFILM,XCEN,YCEN,NREF,MAXR
 6012 FORMAT (1X,'Accumulate now in ',A,' on image number',I3,/2X,
     +       'XCEN=',F7.1,' YCEN=',F7.1,' NREF=',I5,' MAXR=',I5)
          IF (ONLINE) WRITE (ITOUT,FMT=6012) PASS,NPRFILM,XCEN,YCEN,
     +        NREF,MAXR
        END IF
      END IF
C
C---- Skip profile formation if accumulating profiles and this is
C     the second pass but not the firstfilm or if it is the
C     third pass
C
      IF (ACCUMULATE .AND. ((SECONDPASS.AND. (.NOT.FIRSTFILM)).OR.
     +    (THIRDPASS))) GO TO 630
C
C---- Ditto for b and c films or if profiles have been read in
C
      IF (BFILM .OR. CFILM .OR. PRREAD) GO TO 630
C
C
      DO 170 M = 1,NMASKS
        MAXODBOX(M) = 0
        MINODBOX(M) = 0
        NOPROFILE(M) = .FALSE.
        GRADA(M) = 0.0
        GRADASQ(M) = 0.0
        GRADB(M) = 0.0
        GRADBSQ(M) = 0.0
        NRFBOX(M) = 0
        NRFBOXW(M) = 0
        NOVRL(M) = 0
        NWK(M) = 0
        RMSBGBOX(M) = 0.0
        XCGBOX(M) = 0.0
        YCGBOX(M) = 0.0
        WTBOX(M) = 0.0
        NCGSP(M) = 0
        XCGSP(M) = 0.0
        YCGSP(M) = 0.0
        XWCGSP(M) = 0.0
        YWCGSP(M) = 0.0
        WCGSP(M) = 0.0
C
        DO 150 L = 1,9
          NEIGHBOUR(L,M) = 0
  150   CONTINUE
C
C
        DO 160 L = 1,MAXBOX
          IPROFL(L,M) = 0
          WPROFL(L,M) = 0.0
          WPRSUMS(L,M) = 0.0
  160   CONTINUE
C
C
  170 CONTINUE
C
C
      XCGCEN = 0.0
      YCGCEN = 0.0
      WTCEN = 0.0
      NPBOX = 0
      IXCUR = 0
      IYCUR = 0
C
C---- NACFILM counts number of films included so far in the average spot
C             profiles in accumulate mode
C
      NACFILM = 0
      MAXMAXR = 0
C
C---- NPRFILM counts number of a films fully processed in accumulate
C             mode
C
      NPRFILM = 1
      FINISH = .FALSE.
      PWARN1 = .FALSE.
C
C
      IF (MAXR.LE.MAXBOX) GO TO 210
      NWRN = NWRN + 1
      WRITE (IOUT,FMT=6014) MAXR,MAXBOX
 6014 FORMAT (/,1x,'***** FATAL ERROR *****',/,1X,
     + 'Measurement box has',I5,' pixels but the maximum',
     + ' allowed is',I5,/,1X,'If the spots really are that big',
     + ' change parameter MAXBOX with a global edit')
      IF (ONLINE) WRITE (ITOUT,FMT=6014) MAXR,MAXBOX
      IF (BRIEF) WRITE (IBRIEF,FMT=6014) MAXR,MAXBOX
      NSHUTERR = 1
      CALL SHUTDOWN(CALLEDFROM,LENSTR(CALLEDFROM))
C
C
C
C$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$
C---- NEW PROFILE FITTING
C$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$
C
C---- Determine average fully recorded spot for each area on the
C     detector.
C
C     If accumulating profiles from several films, retrieve
C     xcen etc for this film
C
  210 NACFILM = NACFILM + 1
C      
      IF (WINOPEN) CALL MXD_FLU(I)
C
      IF (ACCUMULATE) THEN
        FINISH = .FALSE.
C
C
        IF (DEBUG(18)) THEN
          WRITE (IOUT,FMT=6018) PASS,NACFILM,XCEN,YCEN,NREF,MAXR
 6018 FORMAT (1X,'Accumulate now in ',A,
     +       ' adding in ODS for image number',I3,/2X,'XCEN=',F7.1,
     +       ' YCEN=',F7.1,' NREF=',I5,' MAXR=',I5,' MAXMAXR=',I5)
          IF (ONLINE) WRITE (ITOUT,FMT=6018) PASS,NACFILM,XCEN,YCEN,
     +        NREF,MAXR
        END IF
      END IF
C
C
      NECX = XCEN*FACT + 0.5
      NECY = YCEN*FACT + 0.5
C
C
C---- Get box number for central (ie around direct beam) box
C
      CALL GETCENT(NECX,NECY,ICENBOX,CENTRAL)
C
C---- Get strip number and Y index for central box
C
      CALL GETSTRIP(ICENBOX,ICENSTRIP)
      CALL GETYIND(ICENBOX,ICENY)
C
C---- Now set up the TOLerance for each box. The tolerance varies
C     between TOLMIN and TOLMAX dependent on the proximity to the
C     central box.
C
      IPMAX = 0
      DO 212 JBOX = 1,NUMBOX
        IF (.NOT.BOX(JBOX)) GOTO 212
        CALL GETSTRIP(JBOX,ISTRIP)
        CALL GETYIND(JBOX,NY)
        I = ABS(ISTRIP - ICENSTRIP)
        J = ABS(NY - ICENY)
        IP = I + J
        IPMAX = MAX(IPMAX,IP)
 212  CONTINUE
      DO 214 JBOX = 1,NUMBOX
        IF (.NOT.BOX(JBOX)) GOTO 214
        CALL GETSTRIP(JBOX,ISTRIP)
        CALL GETYIND(JBOX,NY)
        I = ABS(ISTRIP - ICENSTRIP)
        J = ABS(NY - ICENY)
        IP = I + J
cdms10.2002   Add check for zero IPMAX
        IF (IPMAX.NE.0) THEN
          XX = REAL(IP)/REAL(IPMAX)
        ELSE
          XX = 0
        ENDIF
        TOLBOX(JBOX) = TOLMIN + XX*(TOL - TOLMIN)
 214  CONTINUE
C
C---- Set up masks allowing for spot overlap. This returns rejected
C     background pixels in MASKREJ and modified background sums in
C     PQSUMS and PQSUMINV for each mask.
C     Note that MASKIT calls GENSORT which will update NREF so
C     save the correct value.
C     For the very first block of images, initially we have no
C     optimised raster parameters to give the spot sizes on different
C     areas of the detector, so must use the raster box parameters
C     determined by RMAXR. Use these to form profiles, then return
C     and redetermine the profiles using the optimised raster box parameters
C     in MASKIT (if PUPDATE is TRUE).
C
C     If using the DENSE option, then the spot overlap is determined 
C     for every spot individually (MASKONE), so we do not need to call
C     MASKIT here.
C
      IF (.NOT.DENSE) THEN
        MASKMODE = 1
        IF (PUPDATE) THEN
          IF (FIRSTBLOCK) THEN
            MASKMODE = 1
          ELSE
            MASKMODE = 2
          END IF
        END IF
        NREFSAVE = NREF
        CALL MASKIT(MASKMODE,MASK(1,1),IOPTRAS(1,1),AVERAGE(1),
     +            MASKREJ(1,1),MASKREJP(1,1),PQSUMS(1,1),PQSUMINV(1,1))
        NREF = NREFSAVE
      END IF
C
C
      ISTRIPCUR = 0
C ********************************************************************
C ********************************************************************
C---- Loop over all reflections to form average profiles in each box
C ********************************************************************
C ********************************************************************
C
      IF (DEBUG(18)) THEN
        WRITE (IOUT,FMT=6020) NREF,NUMBOX,PRCUTOFF
 6020 FORMAT (/1X,'Reading',I5,' Reflections from mosflm.out',/1X,'NBO',
     +       'XES Currently=',I3,' PRCUTOFF=',I8)
        IF (ONLINE) WRITE (ITOUT,FMT=6020) NREF,NUMBOX,PRCUTOFF
      END IF
C
C---- Counter for dumped reflections
C
      JDUMP = 0
C
C---- FIRSTSP is true for the first reflection on each image to be used
C     in forming the standard profiles, FALSE for all others (used by MASKONE)
C
      FIRSTSP = .TRUE.
C
      DO 352 I = 1,NREF

        IF (MOD(I,250).EQ.0.AND.WINOPEN) CALL MXD_FLU(I)
C

        IF(NUSPOT)THEN
          CALL SPBDREAD(BOXOD(1),IBUF,LEN)
        ELSE
          READ (INMO) LEN,IBUF
C     
C         ************************                            
          CALL PREAD(BOXOD(1),LEN,INMO)
C         ************************
        ENDIF
C             
        CALL RECUNPACK(IBUF(1),KREC)
C
C---- Test for dumpspot
C
        IF (DUMPSPOT) THEN
C
C---- Compare indices with list in IHD, set LDUMP true if match found
C     and turn on DEBUG in all subroutines
C              **************************
          CALL COMPR(KREC,IHD,LDUMP,NHKLD)
C              **************************
C
          IF (LDUMP) WRITE(6,*)'Reflection found'
C---- Uncomment next two lines if full debug is wanted when forming
C     the profile as well as integrating reflections
CAL          IF (DUMPALL.AND.(I.GE.NDSTART).AND.((I-NDSTART).LE.NDTOT))
CAL     +      LDUMP = .TRUE.
          IF (LDUMP) THEN
            DO 351 K=1,100
              SDEBUG(K) = DEBUG(K)
              NDEBUGS(K) = NDEBUG(K)
              DEBUG(K) = .TRUE.
              NDEBUG(K) = NDTOT
 351        CONTINUE
            XDEBUG = .TRUE.
          END IF
        END IF
        IXPIX = IBUF(3)
        IYPIX = IBUF(4)
        NXX = IBUF(5)
        NYY = IBUF(6)
        NPBOX = IBUF(7)
C
C---- Flag for summed partial, =1 for summed partial, else 0
C                              =2 for "summed" partial when other half
C                                 was not available !
C
        ISUMPART = IBUF(8)
C
C     A flag for overloaded summed partials ONLY
C                = 0 If not an overload
C                = 1 if overloaded for integration only
C                = 2 if overload for profile  fitting only
C                = 3 if overload for integration and profile fitting
C
        ISUMOVER = IBUF(9)
C
        CALL GETSTRIP(NPBOX,ISTRIP)
C
C
        IF (DUMP(1) .AND. (I/NDUMP)*NDUMP.EQ.I .AND.
     +      JDUMP.LE.MXDUMP) THEN
          WRITE (IOUT,FMT=6022) I,NXX,NYY,IXPIX,IYPIX,KREC,NPBOX,ISTRIP
 6022 FORMAT (1X,'From mosflm.out, reflection',I5,' NXX=',I3,' NYY=',I3,
     +       ' IX=',I5,' IY=',I5,' KREC=',I5,' NPBOX',I3,' ISTRIP',I3)
          IF (ONLINE) WRITE (ITOUT,FMT=6022)I,NXX,NYY,IXPIX,IYPIX,KREC,
     +                                       NPBOX,ISTRIP
          JDUMP = JDUMP + 1            
        END IF
C                             
C             
        NXY = NXX*NYY
C
C
        IF (NXY.GT.MAXR) THEN
          WRITE (IOUT,FMT=6144) MAXR,NXX,NYY,NXY
 6144 FORMAT (1X,'*** SERIOUS ERROR, CONSULT PROGRAMMER ***',/1X,'Meas',
     +       'urement box larger than expected; MAXR=',I6,
     +       ' NX=',I4,' NY=',I4,' NXY=',I4)
          IF (ONLINE) WRITE (ITOUT,FMT=6144) MAXR,NXX,NYY,NXY
        END IF
C
C
C
C---- Test for new strip of profiles
C
        IF (ISTRIP.EQ.ISTRIPCUR) GO TO 310
C
C---- New strip of profiles 
C---- Deal with previous strip
C
C---- Skip this if this is the first x strip
C
  220   IF (ISTRIPCUR.EQ.0) GO TO 270
C
C---- Increment number of raster boxes, set up sizes and box map
C
C
        IF (DEBUG(18)) THEN
          IF (ONLINE) WRITE (ITOUT,FMT=6024) NXX,IXPIX,ISTRIP,NUMBOX
 6024 FORMAT (1X,'New strip with NXX=',I4,'at X coord=',I5,
     +       ' has ISTRIP=',I3,/1X,
     +       ' Starting value for NUMBOX=',I4)
          WRITE (IOUT,FMT=6024) NXX,IXPIX,ISTRIP,NUMBOX
        END IF
C
C---- Loop over different boxes in this strip
C     transfer summed ods stored in mask at array iprofl,
C     adding in the ods if this is the second or subsequent film
C     to be accumulated.
C
        DO 260 J = 1,NYLINE-1
          NPBOX = IBOX(ISTRIPCUR,J)
C
C---- First check if this is a real box (virtual boxes, used in variable
C     profiles, have negative box numbers)
C
          IF (NPBOX.LE.0) GOTO 260
C
C---- Now check that this is a valid area. Some definitions of boundary
C     lines will give areas completely outside the detector boundary.
C
          IF (.NOT.BOX(NPBOX)) GO TO 260
  230     NRF = NRBOX(J)
          NWKSP = NWKS(J)
          NOVRSP = NOVRS(J)
C
C---- Set up size of this box
C
            NXB = ISIZE(NPBOX,1)
            NYB = ISIZE(NPBOX,2)
C
C
          NXYB = NXB*NYB
C
C---- Dump stored ods if flag set
C
          IF (DUMP(2)) THEN
            WRITE (IOUT,FMT=6028) NPBOX,NRF,NXB,NYB
 6028 FORMAT (//1X,'Box number',I3,' NREF=',I3,' NX=',I2,' NY=',I2,/1X,
     +'Summed pixel values in array MASK (unscaled) Y down page,
     +X across')
C
C no need to call ODPLOT4 for both IOUT & ITOUT  since it does the test!
C
C            MAXPIX = 0
C            CALL ODPLOT4(MASK(1,J),NXB,NYB,1,MAXPIX)
            IF (ONLINE) THEN
              WRITE (ITOUT,FMT=6028) NPBOX,NRF,NXB,NYB
            ENDIF
            MAXPIX = 0
            CALL ODPLOT4(MASK(1,J),NXB,NYB,1,MAXPIX)
c            END IF
C
C
          END IF
C
C---- If this box has already been used (on a previous film in
C     accumulate mode) form new totals
C
          NRFP = NRFBOX(NPBOX)
          NRFTOT = NRF + NRFP
          NWKTOT = NWK(NPBOX) + NWKSP
          NOVRTOT = NOVRL(NPBOX) + NOVRSP
C
C
          MAXOD = 0
          MINOD = 99999999
C
C---- Transfer averaged profile to I*4 array IPROFL
C     If a profile already exists for this box, add new values to old
C     skip if no reflections in this box
C
          IF (NRF.EQ.0) GO TO 250
C
C
          DO 240 K = 1,NXYB
            MASKIJ = MASK(K,J)
            MASKIJ = MASKIJ +IPROFL(K,NPBOX)
            IPROFL(K,NPBOX) = MASKIJ
            MAXOD = MAX(MASKIJ,MAXOD)
            MINOD = MIN(MASKIJ,MINOD)
  240     CONTINUE
C
C
C---- Dont update MAX/MIN if no reflections
C
          MAXODBOX(NPBOX) = MAXOD
          MINODBOX(NPBOX) = MINOD
C
C
 250      NRFBOX(NPBOX) = NRFBOX(NPBOX) + NRF
          NOVRL(NPBOX) = NOVRTOT
          NWK(NPBOX) = NWKTOT
          XCGBOX(NPBOX) = XCGBOX(NPBOX) + XCGSTRIP(J)
          YCGBOX(NPBOX) = YCGBOX(NPBOX) + YCGSTRIP(J)
          WTBOX(NPBOX) = WTBOX(NPBOX) + WTSTRIP(J)
  260   CONTINUE
C
        IF (FINISH) GO TO 350
C
C---- Set up list of the central 9 peak pixels to
C     be used for rapid evaluation of intensity to select
C     reflections to be included in average spot profile
C     This needs to be done separately for each new strip
C
C             
 270    NFBOX = NPFIRST(ISTRIP) - 1
        DO 280 J = 1,NYLINE-1
          NFBOX = NFBOX + 1
C
C---- Skip if not a valid box
C
          IF (.NOT.BOX(NFBOX)) GOTO 280
          NYY = ISIZE(NFBOX,2)
C
C---- If using PRUPDATE mode, and this is not the first time through
C     the first block of images, need to reassign LRAS to the
C     optimised parameters as these were used in MASKIT, unless the box
C     was AVERAGEd.
C
          IF (PUPDATE) THEN
            IF (.NOT.FIRSTBLOCK) THEN
              IF (AVERAGE(NFBOX)) THEN
                DO 282 K = 3,5
                  LRAS(K) = IRAS(K)
 282           CONTINUE
              ELSE
                DO 284 K = 3,5
                  LRAS(K) = IOPTRAS(K-2,NFBOX)
 284           CONTINUE
              END IF
            END IF
          END IF
C              ************************************
          CALL SETMASK(MASK(1,J),LRAS)
          CALL PIXLIST(MASK(1,J),LRAS,LISTPIX(1,J))
C              ************************************
C
  280   CONTINUE
C
C---- Reassign nyy,NPBOX
C
        NYY = IBUF(6)
        NPBOX = IBUF(7)
C
C---- Zero arrays
C
        DO 300 J = 1,NYLINE-1
          NRBOX(J) = 0
          NOVRS(J) = 0
          NDSCR(J) = 0
          NWKS(J) = 0
          XCGSTRIP(J) = 0.0
          YCGSTRIP(J) = 0.0
          WTSTRIP(J) = 0.0
C
C
          DO 290 K = 1,MAXBOX
            MASK(K,J) = 0
  290     CONTINUE
  300   CONTINUE
C
C
        ISTRIPCUR = ISTRIP
C
C*************************************************************************
C---- Finished with the previous strip, now add in this reflection
C     for current strip
C     Jump straight to this point if this was not the first reflection
C     in a new strip
C*************************************************************************
C
C---- Find y index for this spot
C
  310   CALL GETYIND(NPBOX,NY)
C
C---- Omit partials from average profiles, unless PARTIALS requested
C     on PROFILE card
C
        IF (KREC.LT.0 .AND. .NOT.PRPART) GO TO 340
C
C---- Omit summed partials with only one half
C
        IF (ISUMPART.EQ.2) GOTO 340
C
C---- Omit summed partials which have been subsequently flagged as
C     spatial overlaps
C     ****** This won't work properly for the second and subsequent
C     images in a block unless we have read in the generate file
C     for those images so that IRG is updated ie this works OK
C     for reflection integration (below) but NOT for formation of the
C     profiles.
C
        IRECG = ABS(KREC)
        IR = IRG(IRECG)
        IF (IR.EQ.2) THEN
          IF (DEBUG(18)) THEN
            CALL GETHKL(IRECG,IH)
            WRITE(IOUT,FMT=6030) (IH(K),K=1,3), IRECG
            IF (ONLINE) WRITE(ITOUT,FMT=6030) (IH(K),K=1,3), IRECG
 6030     FORMAT(1X,'Rejecting spatially overlapped reflection',3I5,
     +           ' Record number',I6)
          END IF
          GOTO 340
        END IF
C
C---- Sum od.s for given raster size
C
        NOVR = 0 
C
        DO 320 K = 1,NXY
C
C              *********
          CALL CBYTE2(K)
C              *********
C
C  Eliminate spots with pixel values le NULLPIX (outside active area)
C  and overloads (anywhere within box)
C
          IF (IBA.LE.NULLPIX) GOTO 340
C
          IF (IBA.GT.PRCUTOFF) NOVR = NOVR + 1
          IF (IMGP) THEN
            OD(K) = IBA
          ELSE
            OD(K) = TABLE(IBA)
          END IF
  320   CONTINUE
C
C---- Eliminate overloads from profile. For summed partials, must
C     use flag set up in MEAS before the 2 halves were added
C
        IF ((ISUMPART.EQ.1).AND.(ISUMOVER.GE.2)) THEN
          IF (DEBUG(18).AND.SPOT) THEN
            WRITE(IOUT,FMT=6029) KREC,ISUMOVER,ISUMPART
            IF (ONLINE) WRITE(ITOUT,FMT=6029) KREC,ISUMOVER,ISUMPART
 6029 FORMAT(1X,'Overloaded summed partial KREC',I6,' ISUMOVER',I3,
     +      ' ISUMPART',I3,' pixel values:')
            MAXPIX = 0
            CALL ODPLOT4(OD,NXX,NYY,1,MAXPIX)
          END IF
          NOVRS(NY) = NOVRS(NY) + 1
          GO TO 340
        ELSE IF (NOVR.GT.NOVPIX) THEN
          IF (DEBUG(18).AND.SPOT) THEN
            WRITE(IOUT,FMT=6031) KREC,ISUMOVER,ISUMPART
            IF (ONLINE) WRITE(ITOUT,FMT=6031) KREC,ISUMOVER,ISUMPART
 6031 FORMAT(1X,'Overloaded full reflection, KREC',I6,' ISUMOVER',I3,
     +      ' ISUMPART',I3,' pixel values:')
            MAXPIX = 0
            CALL ODPLOT4(OD,NXX,NYY,1,MAXPIX)
          END IF
          NOVRS(NY) = NOVRS(NY) + 1
          GO TO 340
        END IF
C
C---- Find rapid estimate of intensity
C
C            *********************************************
        CALL QUICKINT(OD,NXY,LISTPIX(1,NY),PKIRATIO,JDUMP)
C            *********************************************
C
C
        IF (PKIRATIO.LT.ISDRATIO) THEN
          NWKS(NY) = NWKS(NY) + 1
          GO TO 340
        END IF
C
C---- Add this spot into the profile
C
        DO 330 K = 1,NXY
          MASK(K,NY) = MASK(K,NY) + OD(K)
  330   CONTINUE
C
C---- Now add in contribution of this reflection to weighted profile
C     if required
C
        IF (WTPROFILE) THEN
C     First set up peak/background mask.
C
C---- If using PRUPDATE mode, and this is not the first time through
C     the first block of images, need to reassign LRAS to the
C     optimised parameters as these were used in MASKIT, unless the box
C     was AVERAGEd.
C
          IF (PUPDATE) THEN
            IF (.NOT.FIRSTBLOCK) THEN
              IF (AVERAGE(NPBOX)) THEN
                DO 331 K = 3,5
                  LRAS(K) = IRAS(K)
 331            CONTINUE
              ELSE
                DO 333 K = 3,5
                  LRAS(K) = IOPTRAS(K-2,NPBOX)
 333            CONTINUE
              END IF
            END IF
          END IF
C
          CALL SETMASK(MASKW(1),LRAS)
          CALL SETSUMS(MASKW(1),LRAS,SUMPQW(1))
C
C---- Now flag the rejected background pixels determined in MASKIT
C     or if DENSE image, calculate them
C
          IF (DENSE) THEN
            IF (FIRSTSP) THEN
              MASKMODE = 0
              FIRSTSP = .FALSE.
            ELSE
              MASKMODE = 1
            END IF
C
C---- Detemine overlapped pixels for this spot alone, calculating
C     PQSUMS and PQSUMINV for use by INTEG3
C
            CALL MASKONE(MASKMODE,IXPIX,IYPIX,KREC,LRAS,
     +                   MASKREJ(1,NPBOX),MASKREJP(1,NPBOX),
     +                   PQSUMS(1,NPBOX),PQSUMINV(1,NPBOX),XDEBUG,OD,
     +                   IERR)
            IF (IERR.LT.0) THEN
              DO 334 K = 1,NXY
              MASK(K,NY) = MASK(K,NY) - OD(K)
  334         CONTINUE
              GO TO 340
            ENDIF
          END IF
          NBREJ = MASKREJ(1,NPBOX)
          IF (NBREJ.GT.0) THEN
            DO 332 N = 1,NBREJ
              NP = MASKREJ(N+1,NPBOX)
              MASKW(NP) = 0
  332       CONTINUE
          END IF
C
C---- Now get background plane constants and integrated intensity
C     required for weighted profile sums. Note that LMASKREJ is
C     not used in this call (it is need when INTEG3 is called from
C     BESTMASK)
C
C               **********************************************
          CALL INTEG3(OD,LRAS,MASKW(1),SUMPQW(1),PQSUMS(1,NPBOX),
     +               PQSUMINV(1,NPBOX),NBREJ,LMASKREJ,BGSIG,DEBUG(18))
C               **********************************************
C
C
C---- Check that it hasn't rejected too many background points (flagged by
C     ASPOT(1)=-9999
C
          IF (ABS(ASPOT(1)+9999.0).LT.0.1) GOTO 340
C
C---- Now check for discrimination against strong neighbours
C     First set up the mask again but without rejecting any background
C     points
          IF (DISCRIMINATE) THEN
            CALL SETMASK(MASKW(1),LRAS)
C
C---- Now test discrimination
C
            IFAIL = 0
            CALL DISCR(OD,LRAS,MASKW,DISCRIM,IFAIL)
            IF (IFAIL.NE.0) THEN
              NDSCR(NY) = NDSCR(NY) + 1
              GOTO 340
            END IF
          END IF
C
C---- Now add contribution of this reflection to weighted profile sums
C     for this box
C
C              ********************************************
          CALL WTPROF(OD,LRAS,SOD,A,B,C,WPROFL(1,NPBOX),
     +                  WPRSUMS(1,NPBOX))
C              ********************************************
C
C---- Sums for mean and rms gradient in each box
C
          GRADA(NPBOX) = GRADA(NPBOX) + ASPOT(9)
          GRADASQ(NPBOX) = GRADASQ(NPBOX) + ASPOT(9)*ASPOT(9)
          GRADB(NPBOX) = GRADB(NPBOX) + ASPOT(10)
          GRADBSQ(NPBOX) = GRADBSQ(NPBOX) + ASPOT(10)*ASPOT(10)
        END IF 
C
C
        NRBOX(NY) = NRBOX(NY) + 1
C
C---- Sums for weighted centre of gravity of boxes
C
        XCGSTRIP(NY) = XCGSTRIP(NY) + PKIRATIO*IXPIX
        YCGSTRIP(NY) = YCGSTRIP(NY) + PKIRATIO*IYPIX
        WTSTRIP(NY) = WTSTRIP(NY) + PKIRATIO
C
C---- Sum absolute X,Y for central box
C
        IF ((ISTRIP.EQ.ICENSTRIP).AND.(NY.EQ.ICENY)) THEN
          XCGCEN = XCGCEN + ABS(PKIRATIO*(NECX-IXPIX))
          YCGCEN = YCGCEN + ABS(PKIRATIO*(NECY-IYPIX))
          WTCEN = WTCEN + PKIRATIO
        END IF
C
  340   IF (I.EQ.NREF) THEN
          FINISH = .TRUE.
C
C
          IF (DEBUG(18)) THEN
            WRITE (IOUT,FMT=6032)
 6032 FORMAT (/1X,'Last reflection has been read, now deal with the la',
     +       'st stripe of profiles')
            IF (ONLINE) WRITE (ITOUT,FMT=6032)
          END IF
C
C
          GO TO 220
        END IF
C ********************************************************************
C ********************************************************************
C
C---- End of loop over reflections
C
C ********************************************************************
C ********************************************************************
  350   IF (LDUMP) THEN
          DO 353 K = 1,100
            DEBUG(K) = SDEBUG(K)
            NDEBUG(K) = NDEBUGS(K)
 353      CONTINUE
          LDUMP = .FALSE.
          XDEBUG = .FALSE.
        END IF
 352  CONTINUE
C
      IF (DEBUG(18)) THEN
        WRITE (IOUT,FMT=6034) NUMBOX
 6034 FORMAT (/1X,'Total number of Boxes ',I4)
        WRITE (IOUT,FMT=6036) ICENBOX,CENTRAL
 6036 FORMAT (/1X,'BOX Number for central Unexpanded BOX ',I3,
     +         ' CENTRAL is ',L1)
        WRITE (IOUT,FMT=6038)
 6038 FORMAT (/1X,'BOX Number  BOX Indices      Number ',
     +       'of refls      Max counts      Min counts',
     +       '  Optimised raster params'/)
        WRITE (IOUT,FMT=6040) (I, (ISIZE(I,J),J=1,2),
     +    NRFBOX(I),MAXODBOX(I),
     +    MINODBOX(I),(IOPTRAS(K,I),K=1,3),I=1,NUMBOX)
 6040 FORMAT (1X,I6,6X,I4,I6,8X,I6,14X,I8,I12,5X,3I3)

        WRITE (IOUT,FMT=6046)
 6046 FORMAT (/1X,'BOX map, X across, Y down',//)
C
C
        DO 360 JDO = NYLINE,1,-1
          WRITE (IOUT,FMT=6048) (IBOX(I,JDO),I=1,NXLINE)
 6048 FORMAT (1X,40I3)
  360   CONTINUE
C
C
        IF (ONLINE) THEN
          WRITE (ITOUT,FMT=6034) NUMBOX
          WRITE (ITOUT,FMT=6036) ICENBOX,CENTRAL
          WRITE (ITOUT,FMT=6038)
          WRITE (ITOUT,FMT=6040) (I, (ISIZE(I,J),J=1,2),
     +      NRFBOX(I),MAXODBOX(I),
     +      MINODBOX(I),(IOPTRAS(K,I),K=1,3),I=1,NUMBOX)
          WRITE (ITOUT,FMT=6046)
C
C
          DO 370 JDO = NYLINE,1,-1
            WRITE (ITOUT,FMT=6048) (IBOX(I,JDO),I=1,NXLINE)
  370     CONTINUE
C
C
        END IF
      END IF
C
C---- If accumulating profiles and this is the second pass,
C     go back at this point to add in ods from the next film
C     unless this is the last film
C
      IF (SECONDPASS .AND. NACFILM.LT.NFLMO) THEN
C
C---- Check if the next image is to be skipped
C
 372    NOREAD = NOREAD + 1
        IF (ISKIPI(NOREAD).NE.0) THEN
          IF (DEBUG(18)) THEN
            WRITE(IOUT,FMT=6001) NOREAD
            IF (ONLINE) WRITE(ITOUT,FMT=6001) NOREAD
          END IF
          CALL SKIPIMG(INMO)
          GOTO 372
        END IF
        IF(NUSPOT)THEN
          CALL SPHDREAD(XCEN,YCEN,NREF,MAXR,LNPARTEND)
        ELSE
          READ (INMO) XCEN,YCEN,NREF,MAXR,LNPARTEND
        ENDIF
        GO TO 210
      END IF
C
C
C--- Compute neighbours list for profile averaging
C
C---- Index decides which order the neighbours
C     are stored. first is the box itself, followed by 4 nearest
C     followed by 4 diagonals
C                          
C
C
      DO 490 I = 1,NUMBOX
C
C---- Skip invalid boxes
C
        IF (.NOT.BOX(I)) GOTO 490
C
C---- Get the X and Y indices for this box
C
        CALL GETSTRIP(I,IXPIX)
        CALL GETYIND(I,IYPIX)
C
C---- Now consider 4 nearest neighbours above,below and on each side
C
        INEIGH = 0
C
        DO 480 J = -1,1
          IXN = IXPIX + J
C
          DO 470 K = -1,1
            IYN = IYPIX + K
            INEIGH = INEIGH + 1
            IF ((IXN.GT.NXLINE-1) .OR. (IXN.LT.1) .OR.
     +          (IYN.GT.NYLINE-1) .OR. (IYN.LT.1)) GO TO 470
            JKBOX = IBOX(IXN,IYN)
C
C---- First check if this is a real box (virtual boxes, used in variable
C     profiles, have negative box numbers)
C
            IF (JKBOX.LE.0) GOTO 470
C
C---- Test if this is a genuine area
C
            IF (.NOT.BOX(JKBOX)) GO TO 470
C
C---- Check if any fully recorded reflections in this box
C
            IF (NRFBOX(JKBOX).EQ.0) GO TO 470
            IND = INDEX(INEIGH)
            NEIGHBOUR(IND,I) = JKBOX
  470     CONTINUE
  480   CONTINUE
  490 CONTINUE
C
C
      IF (DEBUG(18)) THEN
        WRITE (IOUT,FMT=6058) (I, (NEIGHBOUR(J,I),J=1,9),I=1,NUMBOX)
 6058 FORMAT (/1X,'List of neighbours',/50 (1X,I4,5X,9I4,/))
        IF (ONLINE) WRITE (ITOUT,FMT=6058) (I, (NEIGHBOUR(J,I),J=1,9),
     +      I=1,NUMBOX)
      END IF
C
C
      WRITE (IOUT,FMT=6064)
 6064 FORMAT (/1X,'Statistics on the standard PROFILES (before averagi',
     +       'ng)',/)
      IF (ONLINE) WRITE (ITOUT,FMT=6064)
C
C---- Absolute X,Y for central box
C
      IF (WTCEN.GT.0) THEN
        XCGCEN = XCGCEN/WTCEN
        YCGCEN = YCGCEN/WTCEN
      END IF
C         
C ********************************************************************
C ********************************************************************
C---- Loop over boxes, plot profiles, apply rejection criteria
C     check background points, reject if necessary and update
C     the mask and background sums
C ********************************************************************
C ********************************************************************
C
C
C---- If using DENSE mode, now need to call MASKIT so that the overlapped
C     background pixels are set up correctly for optimising the profiles.
C     The values currently stored in MASKREJ, PQSUMS, PQSUMINV for each box
C     will be those determined for the last spot dealt with in that 
C     particular box, whereas for optimisation we need to eliminate 
C     pixels that are overlapped for ANY of the spots contributing to
C     the profile. ALSO, BESTMASK calls CHECKMASK which uses the spot
C     separations calculated 
C
        IF (DENSE) THEN
          MASKMODE = 1
          NREFSAVE = NREF
C
C---- Modify MODE if using optimised raster parameters for pixel overlap.
C
          IF (PUPDATE) THEN
            IF (FIRSTBLOCK) THEN
              MASKMODE = 1
            ELSE
              MASKMODE = 2
            END IF
          END IF
          CALL MASKIT(MASKMODE,MASK(1,1),IOPTRAS(1,1),AVERAGE(1),
     +            MASKREJ(1,1),MASKREJP(1,1),PQSUMS(1,1),PQSUMINV(1,1))
          NREF = NREFSAVE
       END IF

 516  FIRSTBOX = .TRUE.
C
      DO 550 JBOX = 1,NUMBOX
C
        IF (MOD(JBOX,4).EQ.0.AND.WINOPEN) CALL MXD_FLU(I)

C
C---- Resore LRAS to correct inital values as these may have been changed
C     by optimisation of a previous profile via call to BGREJECT
         DO 518 K = 3,5
           LRAS(K) = IRAS(K)
 518     CONTINUE
C
C---- First time through, set up mask for central box, required
C     in evaluation of correlation coefficient. Put this in MASK(1,2)
C
        IF (JBOX.EQ.1) THEN
          NXX = ISIZE(ICENBOX,1)
          NYY = ISIZE(ICENBOX,2)
C
C---- If using PRUPDATE mode, and this is not the first time through
C     the first block of images, need to reassign LRAS to the
C     optimised parameters.
C
          IF (PUPDATE) THEN
            IF (.NOT.FIRSTBLOCK) THEN
              DO 519 K = 3,5
                LRAS(K) = IOPTRAS(K-2,ICENBOX)
 519          CONTINUE
            END IF
          END IF
C       
C              ***********************
          CALL SETMASK(MASK(1,2),LRAS)
C              ***********************
C
        END IF
C
C---- Skip if not a valid box
C
        IF (.NOT.BOX(JBOX)) GOTO 550
        NRF = NRFBOX(JBOX)
        NRFBOXW(JBOX) = NRF
        NXX = ISIZE(JBOX,1)
        NYY = ISIZE(JBOX,2)
        NXY = NXX*NYY
C
C
C---- If using PRUPDATE mode, and this is not the first time through
C     the first block of images, need to reassign LRAS to the
C     optimised parameters as these were used in MASKIT, unless the box
C     was AVERAGEd.
C
          IF (PUPDATE) THEN
            IF (.NOT.FIRSTBLOCK) THEN
              IF (AVERAGE(JBOX)) THEN
                DO 521 K = 3,5
                  LRAS(K) = IRAS(K)
 521            CONTINUE
              ELSE
                DO 523 K = 3,5
                  LRAS(K) = IOPTRAS(K-2,JBOX)
 523            CONTINUE
              END IF
            END IF
          END IF
C            **********************************
        CALL SETMASK(MASK(1,1),LRAS)
        CALL SETSUMS(MASK(1,1),LRAS,SUMPQ(1,1))
C            **********************************
C
C
C---- Set up background sums for this box
C******* NO LONGER DO THIS BECAUSE PQSUMS HAS BEEN SET UP BY MASKIT *******
C****        PQSUMS(1,JBOX) = SUMPQ(2,1)          
C****        PQSUMS(2,JBOX) = SUMPQ(4,1)
C****        PQSUMS(6,JBOX) = SUMPQ(6,1)
C              
C---- Transfer summed pixel values to I*4 array OD
C
        DO 520 K = 1,NXY
          OD(K) = IPROFL(K,JBOX)
  520   CONTINUE
C
C
        NRBX = NRF
C
C
C**        IF (((.NOT.ACCUMULATE).AND. (NXY.GT.MAXR)) .OR.
C**     +      (ACCUMULATE.AND. (NXY.GT.MAXMAXR))) THEN
        IF (NXY.GT.MAXR) THEN
          WRITE (IOUT,FMT=6144) MAXR,NXX,NYY,NXY
          IF (ONLINE) WRITE (ITOUT,FMT=6144) MAXR,NXX,NYY,NXY
        END IF
C
C
        FULL = .TRUE.
C
C---- Initialise 
C
        DELX = 0.0
        DELY = 0.0
        RMSBG = 0.0
        AX = 0.0
        BX = 0.0
        CX = 0.0
        BGDEVMAX = 0.0
        R = 0.0
        ASPOT(1) = 0.0
C
C---- Calculate mean and rms gradient for this box for use in spot
C     rejection
C
        IF (NRF.GT.0) THEN
          GMEAN = GRADA(JBOX)/NRF
          GRMS = SQRT(GRADASQ(JBOX)/NRF-GMEAN*GMEAN)
          GRADA(JBOX) = GMEAN
          GRADASQ(JBOX) = GRMS
          GMEAN = GRADB(JBOX)/NRF
          GRMS = SQRT(GRADBSQ(JBOX)/NRF-GMEAN*GMEAN)
          GRADB(JBOX) = GMEAN
          GRADBSQ(JBOX) = GRMS
        END IF
C
C---- Calculate correlation coefficient for peak area between
C     this profile and central profile.
C       
        NXB = ISIZE(ICENBOX,1)
        NYB = ISIZE(ICENBOX,2)
C
        IF (NRBX.NE.0) THEN
C                      *****************************************
          CALL CORRELATE(OD,LRAS,IPROFL(1,ICENBOX),
     +                                MASK(1,2),NXB,NYB,R)
C                      *****************************************
C

          WARN(29) = (WARN(29).OR.(R.LT.0.5))
          IF (R.LT.0.5) THEN
            IWARN(1,29) = IWARN(1,29) + 1
            IJ = 2*IWARN(1,29)
            IF (IJ.LE.19) THEN
              IWARN(IJ,29) = ID
              IWARN(IJ+1,29) = JBOX
              IJ = IJ/2 + 1
              XWARN(IJ,29) = R
            END IF
            IF (IJ.EQ.2) XWARN(1,29) = 1.0
          END IF
          XWARN(1,29) = MIN(XWARN(1,29),R)
        END IF
C
C---- Find scale factor to scale profile in the range 0-255
C
        RANGE = FLOAT((MAXODBOX(JBOX)-MINODBOX(JBOX)))
        SCAL = 0.0
        IF (RANGE.NE.0.0) SCAL = 255.0/RANGE
C
C---- Test and reject bad background points
C     this requires recalculating the background plane
C     and if required (CHANGEMASK) updating PQSUMS and PQSUMINV.
C     Optimised raster parameters are also calculated (if requested)
C     by a call to BESTMASK from BGREJECT and returned in IOPTRAS,
C     and LRAS and MASK will also be updated.
C
C            *********************************************************
 522    IF (NRBX.NE.0) CALL BGREJECT(OD(1),MASK(1,1),LRAS,JBOX,
     +                MASKREJ(1,JBOX),SUMPQ(1,1),
     +                PQSUMS(1,JBOX),PQSUMINV(1,JBOX),PRBGSIG,
     +                CHANGEMASK,FULL,NRBX,IOPTRAS(1,JBOX),CBOX(JBOX),
     +                TOLBOX(JBOX),DENSE)
C            *********************************************************
C
        IF (DEBUG(18)) THEN
           NBREJ = MASKREJ(1,JBOX)
           WRITE(IOUT,FMT=6063) JBOX,LRAS,GRADA(JBOX),GRADASQ(JBOX),
     +     GRADB(JBOX),GRADBSQ(JBOX),(SUMPQ(K,1),K=1,6),
     +     (PQSUMS(K,JBOX),K=1,6),(PQSUMINV(K,JBOX),K=1,9),
     +     (IOPTRAS(K,JBOX),K=1,3),MASKREJP(1,JBOX),
     +     NBREJ,(MASKREJ(K,JBOX),K=2,NBREJ+1)
           IF (ONLINE) WRITE(ITOUT,FMT=6063) JBOX,LRAS,
     +     GRADA(JBOX),GRADASQ(JBOX),GRADB(JBOX),GRADBSQ(JBOX),
     +     (SUMPQ(K,1),K=1,6),
     +     (PQSUMS(K,JBOX),K=1,6),(PQSUMINV(K,JBOX),K=1,9),
     +     (IOPTRAS(K,JBOX),K=1,3),MASKREJP(1,JBOX),
     +     NBREJ,(MASKREJ(K,JBOX),K=2,NBREJ+1)
 6063   FORMAT(/1X,'Summary for profile box',I3,1X,'Raster',5I5,/,1X,
     +        'Mean and rms gradient in X',F6.1,' (',F5.1,')',' in Y',
     +        F6.1,' (',F5.1,')',/,1X,
     +        'SUMPQ',6F10.0,/,1X,
     +        'PQSUMS',6F10.0,/,1X,'PQSUMINV',9F9.5,/,1X,'Optimised ',
     +        'raster parameters NC,NRX,NRY',3I4,/,1X,'Number of ',
     +        'rejected peak pixels',I4,/,1X,'Number of ',
     +        'rejected background pixels',I4,' Pixel numbers',/,
     +        (1X,16I5))
        END IF
C---- Test that it has not rejected an unacceptable number of
C     background points. In S/R INTEG ensures at least
C     NBGMIN background pixels left, and if not, flagged with ASPOT(1)=-9999
C
        IF (ABS(ASPOT(1)+9999.0).LT.0.1) THEN
          WRITE(IOUT,6065) JBOX,NBGMIN
          WRITE(ISUMMR,6065) JBOX,NBGMIN
          IF (ONLINE) WRITE(ITOUT,6065) JBOX,NBGMIN
          IF (BRIEF) WRITE(IBRIEF,6065) JBOX,NBGMIN
 6065     FORMAT(//1X,'For profile',I3,
     +     ' there are fewer than',I4,' background pixels remaining'/,
     +     1X,'after rejection (the minimum acceptable number is',
     +     ' set by MINB on REJECTION',
     +     ' keyword)',/,1X,'It is possible that ',
     +     ' the minimum spot separation ',
     +     '(SEPARATION keyword) is too small',/,1X,'or the',
     +     ' optimisation of the measurement box parameters has ',
     +     'produced',/,1X,'profiles that are too wide',/,1X,
     +     'If the spots really are very close, you may wish to ',
     +     'use the SEPARATION CLOSE option (eg SEPARATION 1.0 1.0',
     +     ' CLOSE)',/,1X,'In addition it is sometimes best to ',
     +     'suppress optimisation of the raster parameters of ',
     +     'individual standard profiles',
     +     ' (PROFILE NOOPT)',/,1X,'although the raster parameters',
     +     ' for the profile in the',
     +     ' centre of the detector will still be optimised.',/,1X,
     +     'See help library for further details.')
           IF (RECOVER) THEN
             MODEBG = 2
             CALL GETMOREBG(OD,MODEBG,LRAS,MASK(1,1),MASKREJ(1,JBOX),
     +                      PQSUMS(1,JBOX),PQSUMINV(1,JBOX),JBOX)
             GOTO 522
           ELSE
             NSHUTERR = 2
             CALL SHUTDOWN(CALLEDFROM,LENSTR(CALLEDFROM))
           END IF
        END IF

        RMSBGA(JBOX) = RMSBG*SCAL
C                          
C---- Add the box shift to delx and dely
C
        DELX = (DELX+IXSHIFT)/FACT
        DELY = (DELY+IYSHIFT)/FACT
C
C---- Check against criteria for averaging profiles
C
        AVERAGE(JBOX) = ((SCAL*RMSBG.GT.RMSBGPR) .OR. (NRBX.LT.NRFMIN))
C
C
C---- For profiles which are NOT flagged to be averaged (because optimisation
C     may not be reliable) find the largest spot size in X and Y.
C
        IF (.NOT.AVERAGE(JBOX)) THEN
          XWIDTH = MAX(XWIDTH,(0.01*(LRAS(1)-2*LRAS(4))/FACT))
          YWIDTH = MAX(YWIDTH,(0.01*(LRAS(2)-2*LRAS(5))/FACT))
        END IF
C---- Set up weighted profile  for this box. Note that
C     the updated (if optimising raster parameters)  LRAS
C     will be used. The profile sums (PROFSUMS) are evaluated after 
C     transferring profile into IPROFL to avoid rounding errors.
C
C                      *********************************************
        IF (WTPROFILE.AND.(NRBX.NE.0)) 
     +                CALL WPRSETUP(LRAS,WPROFL(1,JBOX),
     +                          WPRSUMS(1,JBOX),MASK(1,1))
C                      *********************************************
C                         
C
        IF (DUMP(2).AND.WTPROFILE) THEN
          DO 530 K = 1,NXY
             IWPROFL(K) = WPROFL(K,JBOX) + 0.5
 530      CONTINUE
          WRITE(IOUT,FMT=6067) JBOX
 6067     FORMAT(//1X,'Weighted profile for box',I3,'after scaling',
     +                ' max to 10000'/,1X,
     +     '***** IMPORTANT *****',/,1X,'The $ sign in this',
     +     ' profile indicates pixels overlapped by neighbouring',
     +     ' spots, not outliers',/)
          MAXPIX = 0
          LMASKREJP(1) = 0
C          CALL ODPLOT4(IWPROFL(1),NXX,NYY,1,MAXPIX)
          CALL ODPLOT4R(IWPROFL(1),NXX,NYY,1,MASK(1,1),MASKREJ(1,JBOX),
     +                  MASKREJP(1,JBOX),LMASKREJP,MAXPIX)
        END IF
C
        IF ((FIRSTBOX) .OR. (DEBUG(18))) THEN
          FIRSTBOX = .FALSE.
          WRITE (IOUT,FMT=6066)
 6066 FORMAT (3X,'BOX XMIN XMAX YMIN YMAX   NX   NY RMSBG    DELX',
     +       '    DELY   NO     A       B      C  DEVMAX  NBGREJ  NOV',
     +       'ER NWK CORRLN')
          IF (ONLINE) WRITE (ITOUT,FMT=6066)
        END IF
C
C---- Convert box limits to mm
C
C            ******************************************
        CALL RASTOMM(IXBOX,IYBOX,ILIM,JBOX,NMASKS)
C            ******************************************
C
        RMSBGBOX(JBOX) = SCAL*RMSBG
        IF (NRBX.NE.0) THEN
C
C---- Convert background plane constants to average values per spot
          AX = A/NRBX
          BX = B/NRBX
          CX = C/NRBX
C
C---- Total background for this box
C
          CBOX(JBOX) = C
C       
C---- Centre of gravity of box
C
          XCGBOX(JBOX) = XCGBOX(JBOX)/WTBOX(JBOX)
          YCGBOX(JBOX) = YCGBOX(JBOX)/WTBOX(JBOX)
        END IF
        IF (ONLINE) WRITE (ITOUT,FMT=6068) JBOX, (ILIM(K),K=1,4),
     +      NXX,NYY,SCAL*RMSBG,0.01*DELX,0.01*DELY,NRBX,AX,BX,CX,
     +      SCAL*BGDEVMAX,MASKREJ(1,JBOX),NOVRL(JBOX),
     +      NWK(JBOX),R                    
 6068 FORMAT (5I5,1X,2I5,F6.1,2F8.3,I5,2F8.2,F7.1,F6.1,2X,I5,I7,
     +        I5,F7.3)
        WRITE (IOUT,FMT=6068) JBOX, (ILIM(K),K=1,4),
     +      NXX,NYY,SCAL*RMSBG,0.01*DELX,0.01*DELY,NRBX,AX,BX,CX,
     +      SCAL*BGDEVMAX,MASKREJ(1,JBOX),NOVRL(JBOX),
     +      NWK(JBOX),R
C
C---- It is possible for a box to contain no acceptable full
C     reflections, hence this test
C
        IF (NRF.EQ.0) GO TO 550
C
C---- Set up standard profile (background corrected and scaled to
C     maximum of 10000) for this box in array IPROFL using values
C     in array OD. NOTE that OD is returned as background subtracted
C     values from this S/R.
C            ********************************************************
        CALL STDPROF(OD(1),LRAS,MASK(1,1),IPROFL(1,JBOX),SCALE,ODMIN)
C            ********************************************************
C                                  
        IF (DEBUG(18)) THEN
          WRITE (IOUT,FMT=6070) SCALE,ODMIN
 6070 FORMAT (1X,'Profile scale factor',F15.5,' and OFFSET',F12.1)
          IF (ONLINE) WRITE (ITOUT,FMT=6070) SCALE,ODMIN
        END IF
C
C
        PRSCALE(JBOX,1) = SCALE
        PRSCALE(JBOX,2) = ODMIN
C
C---- Save original values of scale,odmin,rmsbg, required to print
C     unaveraged profile if averaging is done
C
        SAVESCAL(JBOX,1) = PRSCALE(JBOX,1)     
        SAVESCAL(JBOX,2) = PRSCALE(JBOX,2)
        SAVERMS(JBOX) = RMSBGBOX(JBOX)
C
        IF (.NOT.DUMP(2)) GO TO 550
C
C---- Dump stored ods if flag set
C
            WRITE (IOUT,FMT=6072) JBOX,NRF,NXX,NYY
 6072 FORMAT (//1X,'Profile ',I3,' NREF=',I3,' NX=',I2,' NY=',I2,/1X,
     + 'This is the summed counts, scaled to a maximum of 10000,',
     + ' and a minimum of 0',/,1X,'after background subtraction',/,1X,
     + 'This is NOT the weighted profile',/,1X,
     +'Profile values, Y down page, X across')
C
C   - odplot4 tests for ONLINE and acts appropriately, so we can get doubled 
C     output if we call it twice here!
Chrp 15.11.2005            CALL ODPLOT4(IPROFL(1,JBOX),NXX,NYY,1,MAXPIX)
            IF (ONLINE) THEN
              WRITE (ITOUT,FMT=6072) JBOX,NRF,NXX,NYY
Chrp 15.11.2005              MAXPIX = 0
            END IF
            MAXPIX = 0
            CALL ODPLOT4(IPROFL(1,JBOX),NXX,NYY,1,MAXPIX)
C
C                                   
C
C---- End of loop over boxes
C
  550 CONTINUE
C                                     
C
C---- Store max spot size
C
      XWARN(3,1) = XWIDTH
      XWARN(4,1) = YWIDTH
C
C---- Set up new masks allowing for spot overlap now using the optimised
C     raster parameters. This returns rejected
C     background pixels in MASKREJ and modified background sums in
C     PQSUMS and PQSUMINV for each mask.
C     Note that MASKIT calls GENSORT which will update NREF so
C     save the correct value.
C     Note also we need to do this BEFORE averaging the profiles
C     Note that the optimised raster parameters are NOT used for
C     profiles flagged for averaging as they may be unreliable.
C
      IF (PROPT) THEN
C
C---- If this is the first BLOCK of images, and this is the first time the
C     profiles have been determined, then go back and redetermine them
C     but now using the optimised raster parameters when MASKIT is called.
C
        IF (FIRSTBLOCK.AND.PUPDATE) THEN
          WRITE(IOUT,FMT=6017)
          IF (ONLINE) WRITE(ITOUT,FMT=6017)
 6017     FORMAT(/1X,'Now repeating formation of standard profiles but',
     +           ' using the optimised raster parameters')
          FIRSTBLOCK = .FALSE.
          NOREAD = 0
          IF(NUSPOT)THEN
            CALL QSEEK(INMO,1,1,1)
          ELSE
            REWIND(INMO)
          ENDIF
          IF (DENSE) REWIND(ICOORD)
          GOTO 14
        END IF
C
C----  This should be done even if DENSE is true I think
C
        IF (.NOT.DENSE) THEN
          MASKMODE = 3
          NREFSAVE = NREF
          CALL MASKIT(MASKMODE,MASK(1,1),IOPTRAS(1,1),AVERAGE(1),
     +            MASKREJ(1,1),MASKREJP(1,1),PQSUMS(1,1),PQSUMINV(1,1))
          NREF = NREFSAVE
        END IF
      END IF
C
C---- Test for more than 50% background pixels overlapped by neighbouring
C     spots in not in DENSE mode
C
      IF (.NOT.DENSE) THEN
        DO 552 J = 1,NUMBOX
          IF (.NOT.BOX(J)) GOTO 552
          X = 0.0
          NTOTBOX = MASKREJ(1,J) + PQSUMS(6,J)
          IF (NTOTBOX.NE.0) X = REAL(MASKREJ(1,J))/REAL(NTOTBOX)
          WARN(21) = (WARN(21).OR.(X.GT.0.5))
          XWARN(1,21) = MAX(XWARN(1,21),X)
 552    CONTINUE
      END IF
C
C
      IF (WARN(1).AND.(.NOT.PWARN1)) THEN
        WRITE(IOUT,FMT=6019)
        IF (ONLINE) WRITE(ITOUT,FMT=6019)
 6019   FORMAT(1X,'**** WARNING **** Peaks of neighbouring reflections',
     +        ' overlap, data quality will be impaired')
        PWARN1 = .TRUE.
      END IF
C---- ************************************************************
C---- ************************************************************
C---- Loop over boxes and perform profile averaging where required
C---- ************************************************************
C---- ************************************************************
C
      NBOXAV = 0
C
C---- Never want to write XML from RASPLOT4 in this loop
C
      XMLWRITE = .FALSE.

      DO 590 JBOX = 1,NUMBOX
C
C---- Skip if not a valid box
C
        IF (MOD(JBOX,4).EQ.0.AND.WINOPEN) CALL MXD_FLU(I)
C
        IF (.NOT.BOX(JBOX)) GOTO 590
C
        IF (.NOT.AVERAGE(JBOX)) GO TO 590
        WARN(8) = .TRUE.
        NBOXAV = NBOXAV + 1
C
        IF (NBOXAV.EQ.1) THEN
          WRITE (IOUT,FMT=6074)
 6074 FORMAT (/1X,'Statistics on averaged profiles',/)
          IF (ONLINE) WRITE (ITOUT,FMT=6074)
          WRITE (IOUT,FMT=6066)
          IF (ONLINE) WRITE (ITOUT,FMT=6066)
        END IF
C
C
        IF (NBOXAV.GT.NMASKS) THEN
          NWRN = NWRN + 1
          WRITE (IOUT,FMT=6076) NMASKS
 6076 FORMAT(//1X,'***** ERROR *****',/1X,'The number of boxes that ',
     +     'require averaging exceeds the maximum of',I3,/,1X,
     +     'This means that the images are very weak, and there',
     +     ' are a number of',/,1X,'possible solutions:',/,1X,
     +     '1) Accumulate the profiles over a larger number of ',
     +     'images.',/,1X,'This is subkeyword BLOCK on PACK keyword.',
     +      /,1X,'2) If the mosaic spread plus beam divergence is',
     +      ' large compared to',/,1X,'the rotation angle per image',
     +      ' there will be very few fully',/,1X,'recorded ',
     +      'reflections per image.',/,1X,'Use the ADDPART keyword so',
     +      ' that partials on abutting images are summed.',
     +      /,1X,'3) Reduce the number of standard profiles. The',
     +      ' boundaries of the',/,1X,'areas over which the standard'
     +      ,' profiles are formed can be defined',/,1X,'using ',
     +      'subkeywords XLINES and YLINES on PROFILE keyword.',/,1X,
     +       '4) Reduce the resolution limit (RESOLUTION).')
          IF (ONLINE) WRITE (ITOUT,FMT=6076) NMASKS
          NSHUTERR = 3
          CALL SHUTDOWN(CALLEDFROM,LENSTR(CALLEDFROM))
        END IF
C
C
        IF (DEBUG(18)) THEN
          IF (ONLINE) WRITE (ITOUT,FMT=6078) JBOX
 6078 FORMAT (///1X,'Forming average profile for box',I3)
          WRITE (IOUT,FMT=6078) JBOX
        END IF
C             
C
        NXX = ISIZE(JBOX,1)
        NYY = ISIZE(JBOX,2)
        NXY = NXX*NYY
C
C            **********************************
        CALL SETMASK(MASK(1,1),LRAS)
        CALL SETSUMS(MASK(1,1),LRAS,SUMPQ(1,1))
C            **********************************
C
C---- Set up background sums for this box
C     (these may have been changed in bgtest in previous loop)
C
        PQSUMS(1,JBOX) = SUMPQ(2,1)
        PQSUMS(2,JBOX) = SUMPQ(4,1)
        PQSUMS(6,JBOX) = SUMPQ(6,1)
C
        IPASS = 1
C
C---- Transfer averaged ods to I*4 array OD
C
C
        DO 560 K = 1,NXY
          OD(K) = IPROFL(K,JBOX)
  560   CONTINUE
C
C---- Form averaged profile using neighbouring boxes. The averaged
C     profile is returned in array OD
C
C            ********************************************************
  570   CALL MEANPRO(OD,JBOX,NEIGHBOUR(1,JBOX),IPASS,NOVRL,NWK,
     +               MAXOD,MINOD,NRFSAVE,NOVRLSAVE,NWKSAVE,SAVESCAL,
     +               CBOX,CBOXAV)
C            ********************************************************
C
C
C---- Get a merged list of rejected background pixels
C
        CALL GETREJ(JBOX,IPASS,NEIGHBOUR(1,JBOX),MASK(1,1),MASKREJ,
     +              MASKREJAV(1,NBOXAV))
        MAXODBOX(JBOX) = MAXOD
        MINODBOX(JBOX) = MINOD
C
C---- Find scale factor to scale profile in range 0-255
C
        SCAL = 0.0
        RANGE = FLOAT((MAXODBOX(JBOX)-MINODBOX(JBOX)))
        IF (RANGE.NE.0.0) SCAL = 255.0/RANGE
        NRBX = NRFSAVE(JBOX)
        FULL = .TRUE.
C
C---- Test and reject bad background points
C     this requires recalculating the background plane
C     and if required (changemask) updating pqsums and pqsuminv
C     NOTE: The profiles have now been background subtracted,
C     so we can no longer use the counting statistics estimate of
C     the expected background variation to reject background pixels.
C     This will therefore be done based on the rms variation. Flag
C     this by setting PRBGSIG -ve. 
CAL     +                MASKREJ(1,JBOX),SUMPQ(1,1),
C            *********************************************************
 572    IF (NRBX.NE.0) CALL BGREJECT(OD(1),MASK(1,1),LRAS,JBOX,
     +                MASKREJAV(1,NBOXAV),SUMPQ(1,1),
     +                PQSUMS(1,JBOX),PQSUMINV(1,JBOX),-PRBGSIG,
     +                CHANGEMASK,FULL,NRBX,IOPTRAS(1,JBOX),CBOXAV(JBOX),
     +                TOLBOX(JBOX),DENSE)
C            *********************************************************
        IF (DEBUG(18)) THEN
           NBREJ = MASKREJAV(1,NBOXAV)
           WRITE(IOUT,FMT=6063) JBOX,LRAS,
     +     GRADA(JBOX),GRADASQ(JBOX),GRADB(JBOX),GRADBSQ(JBOX),
     +     (SUMPQ(K,1),K=1,6),
     +     (PQSUMS(K,JBOX),K=1,6),(PQSUMINV(K,JBOX),K=1,9),
     +     (IOPTRAS(K,JBOX),K=1,3),MASKREJP(1,JBOX),
     +     NBREJ,(MASKREJAV(K,NBOXAV),K=2,NBREJ+1)
           IF (ONLINE) WRITE(ITOUT,FMT=6063) JBOX,LRAS,
     +     GRADA(JBOX),GRADASQ(JBOX),GRADB(JBOX),GRADBSQ(JBOX),
     +     (SUMPQ(K,1),K=1,6),
     +     (PQSUMS(K,JBOX),K=1,6),(PQSUMINV(K,JBOX),K=1,9),
     +     (IOPTRAS(K,JBOX),K=1,3),MASKREJP(1,JBOX),
     +     NBREJ,(MASKREJAV(K,NBOXAV),K=2,NBREJ+1)
        END IF
C---- Test that it has not rejected an unacceptable number of
C     background points. In S/R INTEG ensures at least
C     NBGMIN background pixels left, and if not, flagged with ASPOT(1)=-9999
C
C
        IF (ABS(ASPOT(1)+9999.0).LT.0.1) THEN
          WRITE(IOUT,6065) JBOX,NBGMIN
          IF (ONLINE) WRITE(ITOUT,6065) JBOX,NBGMIN
          IF (BRIEF) WRITE(IBRIEF,6065) JBOX,NBGMIN
           IF (RECOVER) THEN
             MODEBG = 2
             CALL GETMOREBG(OD,MODEBG,LRAS,MASK(1,1),
     +                       MASKREJAV(1,NBOXAV),
     +                      PQSUMS(1,JBOX),PQSUMINV(1,JBOX),JBOX)
             GOTO 572
           ELSE
             NSHUTERR = 4
             CALL SHUTDOWN(CALLEDFROM,LENSTR(CALLEDFROM))
           END IF
        END IF
C
        RMSBGA(JBOX) = RMSBG*SCAL
C
C---- Add box shift to delx,dely
C            
        DELX = (DELX+IXSHIFT)/FACT
        DELY = (DELY+IYSHIFT)/FACT
C
C
C---- Apply rejection criteria
C
        IF ((SCAL*RMSBG.GT.RMSBGPR) .OR. (NRBX.LT.NRFMIN)) THEN
          IPASS = IPASS + 1
          IF (IPASS.GT.2) GO TO 580
          GO TO 570
        END IF
C
C
  580   IF (DEBUG(18)) THEN
          WRITE (IOUT,FMT=6066)
          IF (ONLINE) WRITE (ITOUT,FMT=6066)
        END IF
C
C---- Calculate correlation coefficient for peak area between
C     this profile and central profile.
C
        R = 0.0
C
        NXB = ISIZE(ICENBOX,1)
        NYB = ISIZE(ICENBOX,2)
C
C                      *****************************************
        IF (NRBX.NE.0) CALL CORRELATE(OD,LRAS,IPROFL(1,ICENBOX),
     +                                MASK(1,2),NXB,NYB,R)
C                      *****************************************
C
C---- Convert box limits to mm
C
C            ******************************************     
        CALL RASTOMM(IXBOX,IYBOX,ILIM,JBOX,NMASKS)
C            ******************************************
C
        RMSBGBOX(JBOX) = SCAL*RMSBG
        IF (NRBX.NE.0) THEN
          AX = A/NRBX
          BX = B/NRBX
          CX = C/NRBX
        END IF
        IF (ONLINE) WRITE (ITOUT,FMT=6068) JBOX, (ILIM(K),K=1,4),
     +      NXX,NYY,SCAL*RMSBG,0.01*DELX,0.01*DELY,NRBX,AX,BX,CX,
     +      SCAL*BGDEVMAX,MASKREJAV(1,NBOXAV),NOVRLSAVE(JBOX),
     +      NWKSAVE(JBOX),R
        WRITE (IOUT,FMT=6068) JBOX, (ILIM(K),K=1,4),
     +      NXX,NYY,SCAL*RMSBG,0.01*DELX,0.01*DELY,NRBX,AX,BX,CX,
     +      SCAL*BGDEVMAX,MASKREJAV(1,NBOXAV),NOVRLSAVE(JBOX),
     +      NWKSAVE(JBOX),R
C
C
        IF ((IPASS.GT.2).AND.(.NOT.WTPROFILE)) THEN
          IF (ONLINE) WRITE (ITOUT,FMT=6080)
 6080 FORMAT (1X,'*** Still rejects this profile ***',/1X,'You may wan',
     +       't to change the rejection criteria (keywords RMSBG and N',
     +       'REF)',/1X,'Reflections in this measurement box will be s',
     +       'imply integrated and not profile fitted in the integrati',
     +       'on pass')
          WRITE (IOUT,FMT=6080)
C
C---- Rejected profile, set all peak pixels to 1000 and all background
C     pixels to 0
C
C              ***********************************************
          CALL TOPHAT(OD(1),LRAS,MASK(1,1))
C              ***********************************************
C
C---- Need to assign background plane constants for the modified values
C     in OD (0 and 1000) becasue these are used in STDPROF. A,B,C passed
C     via ASPOT in /SUMS/
C
          A = 0.0
          B = 0.0
          C = 0.0
C
          NOPROFILE(JBOX) = .TRUE.
        END IF
C
C---- Profile now acceptable
C     Set up standard profile (background corrected and scaled to
C     maximum of 10000) for this box in array IPRSAVE using values
C     in array OD. NOTE that OD is returned as background subtracted
C     values from this S/R.
C
C            ***********************************************************
        CALL STDPROF(OD(1),LRAS,MASK(1,1),IPRSAVE(1,NBOXAV),SCALE,ODMIN)
C            ***********************************************************
C       
        IF (DEBUG(18)) THEN
          WRITE (IOUT,FMT=6070) SCALE,ODMIN
          IF (ONLINE) WRITE (ITOUT,FMT=6070) SCALE,ODMIN
        END IF
C
C
        PRSCALE(JBOX,1) = SCALE
        PRSCALE(JBOX,2) = ODMIN
C
C---- If weighted summed profiles are to be used, form the averaged profiles
C     from the neighbouring weighted profiles, weighting each one with the
C     inverse variance in background plane fit (for unweighted profile).
C     First set up the list of profiles to be used in IPRNUM then the weights
C     in WTPR. Average over the same number of neighbours as used in MEANPRO
C     (ie if IPASS.EQ.1, the nearest 4, if IPASS.EQ.2 then the nearest 8)
C
CAL        IF (WTPROFILE.AND.IPASS.LE.2) THEN
C
        IF (WTPROFILE) THEN
          WTPRSUM = 0.0
          IFLG = 1
          NNEIGHB = 5
          IF (IPASS.GE.2) NNEIGHB = 9
          DO 582 K = 1,9
            WTPR(K) = 0.0
            IF (K.GT.NNEIGHB) GOTO 582
            IWTBOX = NEIGHBOUR(K,JBOX)
            IPRNUM(K) = IWTBOX
            IF (IWTBOX.EQ.0) GOTO 582
            RMSBG = SAVERMS(IWTBOX)
            IF (RMSBG.NE.0) WTPRK = 1.0/(RMSBG*RMSBG)
            WTPRSUM = WTPRSUM + WTPRK
            WTPR(K) = WTPRK
 582      CONTINUE
C
C---- Normalise the weights
C
          DO 584 K = 1,9
            IF (WTPRSUM.NE.0.0) WTPR(K) = WTPR(K)/WTPRSUM
 584      CONTINUE
C
C---- Get averaged profile and store in IPRSAVE. Also stores a composite
C     list of rejected background pixels (the sum of those for all
C     profiles used in forming the average) in MASKREJAV.
C
C            **********************************************************
          CALL GETPROF(IFLG,JBOX,IPRNUM,WTPR,MASK(1,1),MASKREJ,
     +                 IPRSAVE(1,NBOXAV),PROFSUMS(1,JBOX),
     +                 WPROFSUMS(1,JBOX),MASKREJAV(1,NBOXAV),PQSUMSPOT,
     +                 PQSUMINVSPOT,XDEBUG)
C            **********************************************************
        END IF
C
C
        IF (.NOT.DUMP(2)) GO TO 588
        WRITE (IOUT,FMT=6072) JBOX
        IF (ONLINE) WRITE (ITOUT,FMT=6072) JBOX
C
C            ********************************************
        CALL RASPLOT4(IPRSAVE(1,NBOXAV),NXX,NYY,MASK(1,1),
     +          MASKREJAV(1,NBOXAV),IDR,JBOX,AVERAGE(JBOX),XMLWRITE)
C
 588    IF (DEBUG(18)) THEN
          WRITE(IOUT,FMT=6168) JBOX,(PROFSUMS(K,JBOX),K=1,4),
     +                         (WPROFSUMS(K,JBOX),K=1,4)
          IF (ONLINE) WRITE(ITOUT,FMT=6168) JBOX,
     +        (PROFSUMS(K,JBOX),K=1,4),(WPROFSUMS(K,JBOX),K=1,4)
 6168     FORMAT(1X,'For profile',I3,' PROFSUMS',4F12.0,/,16X,
     +          'WPROFSUMS',4F12.0)
        END IF
  590 CONTINUE
C
C---- ************************************************************
C---- ************************************************************
C---- END OF Loop over boxes averaging profiles where required
C---- ************************************************************
C---- ************************************************************
C
      NBOXAV = 0
C
      IF (DENSE) THEN
        WRITE(IOUT,FMT=6171)
        IF (ONLINE) WRITE(ITOUT,FMT=6171)
      ELSE
        WRITE(IOUT,FMT=6173)
        IF (ONLINE) WRITE(ITOUT,FMT=6173)
      END IF
 6171 FORMAT(/,1X,'In the following profiles, background pixels are',
     +       ' indictated by a "-" sign and rejected',
     +       ' background pixels (due to',/,1X,'overlap by a ',
     +       'neighbouring spot) are indicated by a "*". Pixels with',
     +       ' negative values are denoted by a "]".'/,1X,'Note that ',
     +       'a background pixel is shown as being rejected if it is',
     +       ' overlapped by a neighbouring spot for ANY',/,1X,
     +       'reflection in that area of the detector. However, ',
     +       'because the SEPARATION CLOSE option is being used',
     +       ' overlapped',/,1X,'pixels will be determined separately',
     +       ' for every spot, and most spots will have far fewer',
     +       ' overlapped pixels than',/,1X,'shown here.')
 6173 FORMAT(/,1X,'In the following profiles, background pixels are',
     +       ' indictated by a "-" sign and rejected',
     +       ' background pixels (due to',/,1X,'overlap by a ',
     +       'neighbouring spot) are indicated by a "*". Pixels with',
     +       ' negative values are denoted by a "]".'/,1X,'Note that ',
     +       'a background pixel is rejected if it is overlapped by',
     +       ' a neighbouring spot for ANY reflection in that',/,1X,
     +       ' area of the detector.',/,1X,'If too many background',
     +       ' pixels are being rejected try the SEPARATION CLOSE ',
     +       'keywords (see help library)')
C
      IF (BRIEF) WRITE(IBRIEF,FMT=6170)
 6170 FORMAT(/1X,'The standard profiles have been determined')
C
      FIRSTBOX = .TRUE.
C
C---- ******************************************************************
C---- ******************************************************************
C
C---- Loop over boxes transferring saved averaged profiles in
C     iprsave back into iprofl and correcting all profiles for the
C     offset iodmin, so that the mean background value is now
C     zero. If weighted profiles are to be used, transfer them into
C     IPROFL arrays and evaluate PROFSUMS and WPROFSUMS
C---- ******************************************************************
C---- ******************************************************************
C
C---- For new GUI, write XML to describe document containing standard profiles.
C
      IF (SOCKLO) THEN
          XMLWRITE = .TRUE.
          WRITE(XMLLINE, FMT=6200)NXLINE - 1,NYLINE - 1
          CALL WRITE_SOCKET_SECTION(SERVERFD, LENSTR(XMLLINE),
     $         XMLLINE)
      END IF
 6200 FORMAT('<?xml version="1.0"?>',
     $     '<!DOCTYPE regional_spot_profile_response>',
     $     '<regional_spot_profile_response>',
     $     '<number_of_profiles_x>',I1,'</number_of_profiles_x>',
     $     '<number_of_profiles_y>',I1,'</number_of_profiles_y>')
C
      IWARN(1,20) = 0
C
      DO 610 JBOX = 1,NUMBOX
C
C---- Skip if not a valid box
C
        IF (.NOT.BOX(JBOX)) GOTO 610
C
        NXX = ISIZE(JBOX,1)
        NYY = ISIZE(JBOX,2)
        NXY = NXX*NYY
C
C---- Set up optimised raster box parameters
C
        IF (PROPT) THEN
          LRAS(3) = IOPTRAS(1,JBOX)
          LRAS(4) = IOPTRAS(2,JBOX)
          LRAS(5) = IOPTRAS(3,JBOX)
        END IF
C
C            ***********************
        CALL SETMASK(MASK(1,1),LRAS)
C            ***********************
C
C- Write XML header for this box
C
            IF (SOCKLO) THEN
              WRITE(XMLLINE,FMT=6202)JBOX,NXX,NYY
              CALL WRITE_SOCKET_SECTION(SERVERFD, LENSTR(XMLLINE),
     $            XMLLINE)
            END IF
 6202       FORMAT('<profile><box>',I2,'</box><width>', I2, '</width>',
     $     '<height>',I2, '</height>')

        IF (AVERAGE(JBOX)) THEN
          NBOXAV = NBOXAV + 1
C
C---- Set up profile if there are any reflections)
C
          IF (NRFBOX(JBOX).GT.0) THEN
            SCALE = SAVESCAL(JBOX,1)
            ODMIN = SAVESCAL(JBOX,2)
C
C---- Remove the offset in profile so that mean background would
C     be zero. Rescale to a maximum of 10000.
C     Evaluate and store sums for this profile
C                ***************************************************
          CALL SCALEPROF(IPROFL(1,JBOX),LRAS,MASK(1,1),MASKREJ(1,JBOX),
     +                 SCALE,ODMIN,PROFSUMS(1,JBOX),WPROFSUMS(1,JBOX))
C                ***************************************************
C
C---- Calculate the profile factor for this profile
C     call setsums to get number of peak pixels
C             
C                **********************************
            CALL SETSUMS(MASK(1,1),LRAS,SUMPQ(1,1))
C                **********************************
C
            NPK = NINT(SUMPQ(5,1))
            SIGMAP = PROFSUMS(3,JBOX)
            SIGMAPSQ = PROFSUMS(4,JBOX)
            PRFACT = SIGMAP*SIGMAP/ (NPK*SIGMAPSQ)
            PROFACT(JBOX) = PRFACT
C
C---- Convert box limits to mm
C
C                ******************************************
            CALL RASTOMM(IXBOX,IYBOX,ILIM,JBOX,NMASKS)
C                ******************************************
C
            WRITE (IOUT,FMT=6082) JBOX, (ILIM(K),K=1,4),NRFBOX(JBOX),
     +        SAVERMS(JBOX),PRFACT
 6082 FORMAT (//1X,'Profile for box',I3,' *** Before averaging ***',/1X,
     +       'X Limits',I4,' to',I4,' mm, Y limits',I4,' to',I4,' mm, ',
     +       /,1X,'Number of reflections in profile',I5,'  RMSBG',F5.1,
     +        ' Profile Factor ',F4.2)
C
            IF (ONLINE) WRITE (ITOUT,FMT=6082) JBOX, (ILIM(K),K=1,4),
     +          NRFBOX(JBOX),SAVERMS(JBOX),PRFACT
            IF (BRIEF) WRITE (IBRIEF,FMT=6082) JBOX, (ILIM(K),K=1,4),
     +          NRFBOX(JBOX),SAVERMS(JBOX),PRFACT
C
C---- Write XML header for original profile values
C
            IF (SOCKLO) THEN
              WRITE(XMLLINE,FMT=6203)
              CALL WRITE_SOCKET_SECTION(SERVERFD, LENSTR(XMLLINE),
     $            XMLLINE)
            END IF
 6203       FORMAT('<original>','<data>')


C
C---- If using weighted profile, transfer WPROFL into IWPROFL and plot
C     this
C           
            IF (WTPROFILE) THEN
              DO 598 K = 1,NXY
                IWPROFL(K) = WPROFL(K,JBOX)
 598          CONTINUE
C                ******************************************
              CALL RASPLOT4(IWPROFL,NXX,NYY,MASK(1,1),
     +               MASKREJ(1,JBOX),IDR,JBOX,AVERAGE(JBOX),XMLWRITE)
C                ******************************************
C             
            ELSE
C                ******************************************
              CALL RASPLOT4(IPROFL(1,JBOX),NXX,NYY,MASK(1,1),
     +               MASKREJ(1,JBOX),IDR,JBOX,AVERAGE(JBOX),XMLWRITE)
C                ******************************************
            END IF
C
C---- Data and mask XML have been written in RASPLOT4, write terminator.
C
            IF (SOCKLO) THEN
              WRITE(XMLLINE,FMT=6204)
              CALL WRITE_SOCKET_SECTION(SERVERFD, LENSTR(XMLLINE),
     $            XMLLINE)
            END IF
 6204       FORMAT('</original>')

C
            IF (BRIEF.AND.(.NOT.GRAPH)) CALL MPAUSE
C
          END IF
C
C---- Update nref,nwk,novrl from saved totals in s/r meanpro
C
          NRFBOX(JBOX) = NRFSAVE(JBOX)
          NOVRL(JBOX) = NOVRLSAVE(JBOX)
          NWK(JBOX) = NWKSAVE(JBOX)
C
C---- Now deal with averaged profile. NOTE that for weighted profiles,
C     this next step is transferring the averaged weighted profile into
C     IPROFL
C
          DO 600 K = 1,NXY
            IPROFL(K,JBOX) = IPRSAVE(K,NBOXAV)
  600     CONTINUE
C
C---- Now move the composite rejected pixel list from MASKREJAV into
C     MASKREJ
C
          NBREJ = MASKREJAV(1,NBOXAV) + 1
          DO 601 K = 1,NBREJ
            MASKREJ(K,JBOX) = MASKREJAV(K,NBOXAV)
 601      CONTINUE
C
        END IF
        SCALE = PRSCALE(JBOX,1)
        ODMIN = PRSCALE(JBOX,2)
C
C---- Remove the offset in profile so that mean background would
C     be zero. rescale to a maximum of 10000.
C     Evaluate and store sums for this profile.
C     Do NOT do this for weighted profiles, because IPROFL contains the
C     weighted profile for averaged boxes, not the summed profile.
         IF (.NOT.WTPROFILE) THEN
C            ***************************************************
          CALL SCALEPROF(IPROFL(1,JBOX),LRAS,MASK(1,1),MASKREJ(1,JBOX),
     +                 SCALE,ODMIN,PROFSUMS(1,JBOX),WPROFSUMS(1,JBOX))
C            ***************************************************
           IF (DEBUG(18)) THEN
             WRITE(IOUT,FMT=6085) JBOX,(PROFSUMS(K,JBOX),K=1,4),
     +                            (WPROFSUMS(K,JBOX),K=1,4)
             IF (ONLINE) WRITE(ITOUT,FMT=6085) JBOX,
     +          (PROFSUMS(K,JBOX),K=1,4),(WPROFSUMS(K,JBOX),K=1,4)
           END IF
 6085      FORMAT(1X,'Scaling profile for box',I3,/,1X,
     +            'Array PROFSUMS',4F12.0,/,1X,'WPROFSUMS',4F12.0)
         END IF
C
C---- If weighted summed profiles are to be used, move them into
C     IPROFL reevaluate PROFSUMS and WPROFSUMS now.
C     Note that WPROFSUMS contains the sums over all box excluding 
C     only background rejected pixels.
C     Do not transfer into IPROFL for averaged profiles because this
C     transfer has already been done above (DO 600 LOOP)
C
        IF (WTPROFILE.AND.(NRFBOXW(JBOX).GT.0)) THEN
           IF (.NOT.AVERAGE(JBOX)) THEN
             DO 602 K = 1,NXY
               IPROFL(K,JBOX) = WPROFL(K,JBOX) + 0.5
 602         CONTINUE
           END IF
C
C               *******************************************************
           CALL PRUPDATE(LRAS,MASK(1,1),MASKREJ(1,JBOX),IPROFL(1,JBOX),
     +                   PROFSUMS(1,JBOX),WPROFSUMS(1,JBOX),NLOWPK)
C               *******************************************************
           IF (DEBUG(18)) THEN
             WRITE(IOUT,FMT=6083) JBOX,(PROFSUMS(K,JBOX),K=1,4),
     +                            (WPROFSUMS(K,JBOX),K=1,4),NLOWPK
             IF (ONLINE) WRITE(ITOUT,FMT=6083) JBOX,
     +          (PROFSUMS(K,JBOX),K=1,4),(WPROFSUMS(K,JBOX),K=1,4),
     +           NLOWPK
           END IF
 6083      FORMAT(1X,'Moving over weighted profile for box',I3,/,1X,
     +            'Array PROFSUMS',4F12.0,/,1X,'WPROFSUMS',4F12.0,
     +            /1X,'NLOWPK',I5)
        END IF
C
C---- Check number of background points, increase if necessary
C
        IF  ((NINT(PQSUMS(6,JBOX)).LT.RECLEVEL*NBGMIN)
     +                                          .AND.(RECOVER)) THEN
          MODEBG = 2
          CALL GETMOREBG(IPROFL(1,JBOX),MODEBG,LRAS,MASK(1,1),
     +          MASKREJ(1,JBOX),PQSUMS(1,JBOX),PQSUMINV(1,JBOX),JBOX)
        END IF
C
C---- Calculate the profile factor for this profile
C     call setsums to get number of peak pixels
C
C            **********************************
        CALL SETSUMS(MASK(1,1),LRAS,SUMPQ(1,1))
C            ***********************************
C
        NPK = NINT(SUMPQ(5,1))
        SIGMAP = PROFSUMS(3,JBOX)
        SIGMAPSQ = PROFSUMS(4,JBOX)
        PRFACT = SIGMAP*SIGMAP/ (NPK*SIGMAPSQ)
        PROFACT(JBOX) = PRFACT
C
C---- Warning about profiles having long tails
C
        LOWPKFR = REAL(NLOWPK)/REAL(NPK)
        WARN(11) = (WARN(11).OR.(LOWPKFR.GT.0.3))
        XWARN(1,11) = MAX(XWARN(1,11),LOWPKFR)
C
C---- Warning about profiles having a high percentage of profile counts
C     outside the peak area. PROFSUMS(3) is sum of profile in peak only,
C     WPROFSUMS(3) is sum over entire box excluding rejected background
C
        IF (WTPROFILE) THEN 
          PRFRAC = 0.0 
          IF (WPROFSUMS(3,JBOX).GT.0) 
     +    PRFRAC = (WPROFSUMS(3,JBOX) - PROFSUMS(3,JBOX))/
     +             WPROFSUMS(3,JBOX)
          WARN(20) = (WARN(20).OR.PRFRAC.GT.0.10)
          IF (PRFRAC.GT.0.1) THEN
            K = IWARN(1,20)
            IF (K.LT.19) THEN
              IWARN(K+2,20) = JBOX
              XWARN(K+2,20) = PRFRAC
            END IF
            IWARN(1,20) = IWARN(1,20) + 1
          END IF
        END IF
C
C---- Print all profiles if requested
C
        IF (LPRINT(11)) THEN
C
C---- Convert box limits to mm
C
C              ******************************************
          CALL RASTOMM(IXBOX,IYBOX,ILIM,JBOX,NMASKS)
C              *******************************************
C
          WRITE (IOUT,FMT=6084) JBOX, (ILIM(K),K=1,4),NRFBOX(JBOX),
     +      RMSBGBOX(JBOX),PRFACT
 6084 FORMAT (//1X,'Profile for box',I3,/1X,'X limits',I4,' to',I4,' m',
     +       'm, Y limits',I4,' to',I4,' mm',/,1X,'Number of ',
     +       'reflections in profile',I5,'  RMSBG',F5.1,
     +       ' Profile factor ',F4.2)
          IF (ONLINE) WRITE (ITOUT,FMT=6084) JBOX, (ILIM(K),K=1,4),
     +        NRFBOX(JBOX),RMSBGBOX(JBOX),PRFACT
          IF (BRIEF) WRITE (IBRIEF,FMT=6084) JBOX, (ILIM(K),K=1,4),
     +        NRFBOX(JBOX),RMSBGBOX(JBOX),PRFACT
C
C---- Write to socket, if this profile has been averaged, this is
C     reflected in the xml
C
          IF (SOCKLO) THEN
            IF (AVERAGE(JBOX)) THEN
              XMLLINE = ' '
              WRITE(XMLLINE,FMT=6206)
 6206         FORMAT('<averaged><data>')
              CALL WRITE_SOCKET_SECTION(SERVERFD, LENSTR(XMLLINE),
     $            XMLLINE)
            ELSE
                WRITE(XMLLINE,FMT=6203) 
                CALL WRITE_SOCKET_SECTION(SERVERFD, LENSTR(XMLLINE),
     $            XMLLINE)
            END IF
          END IF
C           
C              ******************************************
          CALL RASPLOT4(IPROFL(1,JBOX),NXX,NYY,MASK(1,1),
     +             MASKREJ(1,JBOX),IDR,JBOX,AVERAGE(JBOX),XMLWRITE)
C              ******************************************
C
          IF (SOCKLO) THEN
            IF (AVERAGE(JBOX)) THEN
              XMLLINE = ' '
              WRITE(XMLLINE,FMT=6208)
 6208         FORMAT('</averaged>')
              CALL WRITE_SOCKET_SECTION(SERVERFD, LENSTR(XMLLINE),
     $            XMLLINE)
            ELSE
              WRITE(XMLLINE,FMT=6210) 
 6210         FORMAT('</original>')
              CALL WRITE_SOCKET_SECTION(SERVERFD, LENSTR(XMLLINE),
     $            XMLLINE)
            END IF
          END IF


          IF (BRIEF.AND.(.NOT.GRAPH)) CALL MPAUSE
C
        END IF
C
C
        IF (DUMP(2).OR.DUMP(7)) THEN
          WRITE (IOUT,FMT=6086) JBOX
          IF (ONLINE) WRITE (ITOUT,FMT=6086) JBOX
 6086   FORMAT (//1X,'Array IPROFL for box',I3,/,1X,
     +     '***** IMPORTANT *****',/,1X,'The $ sign in this',
     +     ' profile indicates pixels overlapped by neighbouring',
     +     ' spots, not outliers',/)
          IF (WTPROFILE) THEN
             WRITE(IOUT,6087)
             IF (ONLINE) WRITE(ITOUT,6087)
          END IF
 6087   FORMAT(1X,'This is the WEIGHTED profile, not the SUMMED one')
          MAXPIX = 0
C          CALL ODPLOT4(IPROFL(1,JBOX),NXX,NYY,IDR,MAXPIX)
          CALL ODPLOT4R(IPROFL(1,JBOX),NXX,NYY,1,MASK(1,1),
     +            MASKREJ(1,JBOX),MASKREJP(1,JBOX),LMASKREJP,MAXPIX)
C
        END IF
C
C---- Now get a gradient for all profiles, used in scaling up standard
C     deviation estimates to allow for instrument errors.
C
        IHX = LRAS(1)/2
        IHY = LRAS(2)/2
        IXRIM = LRAS(4)
        IYRIM = LRAS(5)
        CALL PROFGRAD(IPROFL(1,JBOX),IHX,IHY,IXRIM,IYRIM,PRGRAD(JBOX))
C
        FIRSTBOX = .FALSE.
C
        IF(SOCKLO)THEN
          WRITE(XMLLINE,FMT=6212) 
 6212     FORMAT('</profile>')
          CALL WRITE_SOCKET_SECTION(SERVERFD, LENSTR(XMLLINE),
     $         XMLLINE)
        ENDIF
  610 CONTINUE
C
C---- If new GUI, close the profiles XML document
C
      IF (SOCKLO) THEN
        XMLLINE = ' '
        WRITE(XMLLINE, FMT=6214)
        CALL WRITE_SOCKET_length(SERVERFD,lenstr(xmlline),
     $         XMLLINE)
      END IF
 6214 FORMAT('</regional_spot_profile_response>')
C
C
C---- Finally, check that all the standard profiles have at least 2*NBGMIN
C     background pixels, but if in DENSE mode skip this test.
C
      IF (.NOT.DENSE) THEN
       DO 612 JBOX = 1,NUMBOX
        IF (.NOT.BOX(JBOX)) GOTO 612
        IF  (NINT(PQSUMS(6,JBOX)).LT.2*NBGMIN) THEN
          WRITE(IOUT,FMT=6091) JBOX, NINT(PQSUMS(6,JBOX)), 2*NBGMIN
          WRITE(ISUMMR,FMT=6091) JBOX, NINT(PQSUMS(6,JBOX)), 2*NBGMIN
          IF (ONLINE) WRITE(ITOUT,FMT=6091) JBOX, NINT(PQSUMS(6,JBOX)),
     +                 2*NBGMIN
 6091     FORMAT(//1X,'***** FATAL ERROR *****',/,1X,'Profile number',
     +     I3,' has only',I3,' background pixels after rejecting',/,1X,
     +     'pixels which are overlapped by neighbouring peaks which',
     +     ' is less than',/,1X,'the minimum acceptable (',I3,' which',
     +     ' is twice the value set by MINB on',/,1X,'REJECTION',
     +     ' keyword)',/,1X,'Either the minimum spot separation ',
     +     '(SEPARATION keyword) is too small',/,1X,'or the',
     +     ' optimisation of the measurement box parameters has ',
     +     'produced',/,1X,'profiles that are too wide',/,1X,
     +     'If the spots really are very close, you may wish to ',
     +     'use the TRIM and OVERLAP',/,1X,'subkeywords of the ',
     +     'SEPARATION keyword...see help library for details.',/,1X,
     +     'Read suggestions below for the best way to proceed')
          NSHUTERR = 5
           CALL SHUTDOWN(CALLEDFROM,LENSTR(CALLEDFROM))
         END IF
 612   CONTINUE
      END IF
C
      IF (DENSE) REWIND(ICOORD)
      IF(NUSPOT)THEN
        CALL QSEEK(INMO,1,1,1)
      ELSE
        REWIND(INMO)
      ENDIF
C
      NOREAD = 0
C
C---- Check if the next image is to be skipped
C
 614  NOREAD = NOREAD + 1
      IF (ISKIPI(NOREAD).NE.0) THEN
        IF (DEBUG(18)) THEN
          WRITE(IOUT,FMT=6001) NOREAD
          IF (ONLINE) WRITE(ITOUT,FMT=6001) NOREAD
        END IF
        CALL SKIPIMG(INMO)
        GOTO 614
      END IF
C
C---- Read XCEN etc for first film
C
      IF(NUSPOT)THEN
        CALL SPHDREAD(XCEN,YCEN,NREF,MAXR,LNPARTEND)
      ELSE
        READ (INMO) XCEN,YCEN,NREF,MAXR,LNPARTEND
      ENDIF
C
C--- END OF IMPERIAL SPOT PROFILE
C*************************************************************
C
C---- If keyword set, write profiles and associated data to
C     logical file 'profile'
C
      IF (PRSAVE) THEN
        CALL PROFWRITE(MASKREJ,PQSUMS,PQSUMINV,PROFSUMS,WPROFSUMS,
     +    RMSBGA,XCGBOX,YCGBOX,XCGCEN,YCGCEN,ICENBOX,CENTRAL,IOPTRAS)
      END IF
C
C---- If using variable profiles, set up the quadrilaterals used to
C     define which profiles are to be used in forming the average
C     profile.
      IF (VARPRO) THEN
        MODE = 0
        XR = 0.0
        YR = 0.0
        CALL VARPROF(MODE,XCGBOX,YCGBOX,XCGCEN,YCGCEN,ICENBOX,
     +               CENTRAL,XR,YR,NUMBOX,IPRNUM,WTPR)
        MODE = 1
      END IF
C
C---- Start calculation of integrated intensities
C
  630 CONTINUE
C
C
      IF (DEBUG(18)) THEN
        IF (ONLINE) WRITE (ITOUT,FMT=6092) XCEN,YCEN,NREF,MAXR
 6092 FORMAT (//1X,'Now integrating intensities, XCEN,YCEN,NREF,MAXR',
     +       2F7.1,2I6)
        WRITE (IOUT,FMT=6092) XCEN,YCEN,NREF,MAXR
      END IF
C
C
       IFAIL = 1
      IF (ONLINE)
C
C                 ********************************
     +       CALL CCPOPN(-46,'BADSPOT',2,2,80,IFAIL)
C                 ********************************
C
      NBAD = 0
      NBADPK = 0
      ISTRIPCUR = 0
      NGO = 1
      JBOX = 0
      NREXP = 0
      BGREXP = 0.0
C                                                      
C---- Sums for instrument error correction
C
      ASUM = 0.0
      BSUM = 0.0
      NSUMR = 0 
      PKREJS = 0.0
C
C---- Use optimised raster parameters for central standard profile
C     instead of IRAS (which is average spot profile in middle of
C     detector for first image in a block) because it is more
C     reliable, but only if optimisation has been done.
C
      IF (PROPT) THEN
        WPX = IRAS(1) - (IOPTRAS(2,ICENBOX)+1)*2
        WPY = IRAS(2) - (IOPTRAS(3,ICENBOX)+1)*2
      ELSE
        WPX = IRAS(1) - (IRAS(4)+1)*2
        WPY = IRAS(2) - (IRAS(5)+1)*2
      END IF
C
C---- Don't allow these to be less than 1 !
C
      WPX = MAX(WPX,1.0)
      WPY = MAX(WPY,1.0)

      BOXFAC = (((WPX+1)/ (WPY+1))**2)*   
     +         ((WPY**2)*3.0 + WPY**3 + 5*WPY + 3)/12.0
C     
      JDUMP = 0
C
C   Flag true if detector error factor has been assigned a value
C   This allows dumping pixel values for "badspots"
C
      ERRSET = (EFAC.GT.-900)
      IF (ERRSET) ERRINST = EFAC*EFAC
      NMINTR = 0
C
C---- Flag for GETPROF
C
      IFLG = 0
C
      IF (FIRSTFILM.AND.BRIEF) THEN
        WRITE(IBRIEF,FMT=6005)
      END IF
C       
C     **********************************************************************
C     **********************************************************************
C---- Loop over reflexions and integrate.
C     **********************************************************************
C     **********************************************************************
C
C---- Initialise counters for mean number of additional background pixels
C     rejected
C
      NREJSUM = 0
      SUMREJ = 0.0
      SUMBG = 0.0
      NHALF = 0
      NSUMPART = 0
      FIRSTSP = .TRUE.
C
      DO 772 I = 1,NREF
        XDEBUG = .FALSE.
C
        IF (MOD(I,250).EQ.0.AND.WINOPEN) CALL MXD_FLU(I)
C
C---- Read ods for this spot from mosflm.out
C
      IF(NUSPOT)THEN
        CALL SPBDREAD(BOXOD,IBUF,LEN)
      ELSE
        
        READ (INMO) LEN,IBUF
C     
C     *********************
        CALL PREAD(BOXOD,LEN,INMO)
C     *********************
C     
      ENDIF
      CALL RECUNPACK(IBUF(1),KREC)

        IXPIX = IBUF(3)
        IYPIX = IBUF(4)
        IRECG = ABS(KREC)
C
C---- Omit summed partials which have been subsequently flagged as
C     spatial overlaps
C
        IR = IRG(IRECG)
        IF (IR.EQ.2) THEN
          IF (DEBUG(18)) THEN
            CALL GETHKL(IRECG,IH)
            WRITE(IOUT,FMT=6030) (IH(K),K=1,3), IRECG
            IF (ONLINE) WRITE(ITOUT,FMT=6030) (IH(K),K=1,3), IRECG
          END IF
          NSPOVL = NSPOVL + 1
          GOTO 772
        END IF
C
C---- Test for dumpspot (set by keyword BAD)
C
        IF (DUMPSPOT) THEN
C
C---- Compare indices with list in IHD, set LDUMP true if match found
C     and turn on DEBUG in all subroutines
C              **************************
          CALL COMPR(KREC,IHD,LDUMP,NHKLD)
C              **************************
C
          KDUMP = .FALSE.
          IF (DUMPALL.AND.(I.GE.NDSTART).AND.(JDUMP.LE.NDTOT)
     +        .AND.((IXPIX.GE.IXDMIN).AND.(IXPIX.LE.IXDMAX))
     +        .AND.((IYPIX.GE.IYDMIN).AND.(IYPIX.LE.IYDMAX)))
     +      KDUMP = .TRUE.
C
C---- Test for resolution limits set
C
          CALL GETBIN(IRECG,ITHBIN,NBIN1,DSTSQ)
          IF (DSTSQ.GT.0.0) DSPOT = 1.0/SQRT(DSTSQ)
          MDUMP = ((DSPOT.LE.RESDLOW).AND.(DSPOT.GE.RESD))
C
C---- If positional restrictions given, apply them, but given
C     indices are dumped independent of position.
C
          IF (DUMPALL) LDUMP = (LDUMP.OR.KDUMP)
C
C---- If resolution limits given, they MUST be satisfied for dumping
C
          IF (RESD.NE.0.0) LDUMP = (LDUMP.AND.MDUMP)
C
          IF (LDUMP) THEN
            XDEBUG = .TRUE.
            DO 771 K=1,100
              SDEBUG(K) = DEBUG(K)
              NDEBUGS(K) = NDEBUG(K)
              DEBUG(K) = .TRUE.
              NDEBUG(K) = NDTOT
 771        CONTINUE
            CALL GETHKL(IRECG,IH)
            WRITE(IOUT,FMT=6093) (IH(K),K=1,3),DSPOT
            IF (ONLINE) WRITE(ITOUT,FMT=6093) (IH(K),K=1,3),DSPOT
 6093       FORMAT(/,1X,'***************************************',
     +                  '***************************************',
     +      /,1X,'Dumping reflection',3I5,' Resolution',F6.2)
          END IF
        END IF
C
C---- If the "process" keyword was given, subroutine gensort will
C     not have been called and hence IGFLAG(I) will not have been set.
C     Also, when accumulating profiles, the IGFLAG values are read in
C     for all contributing images and therefore we no longer have
C     the values for this image in memory (In fact IGFLAG is set to
C     all zero's because of this problem).
C
        IF (PROCES) IGFLAG(IRECG) = 1
C
C---- If the B or C films were used to form the profiles, then the MINT
C     criterion cannot be applied in GENSORT and all reflections are
C     written to MOSFLM.OUT (SPOTOD), so apply MINT test here
C                                            
        IF (((PRBFILM.AND.BFILM).OR. (PRCFILM.AND.CFILM)) .AND.
     +      INTG(IRECG).LT.MINT) THEN
C
C                                 
          IF (DEBUG(18)) THEN
            IF (ONLINE) WRITE (ITOUT,FMT=6094) I,IRECG,INTG(IRECG),MINT
 6094 FORMAT (1X,'REF NUMB',I5,' IRECG',I5,' INT',I6,'  MINT',I5)
            WRITE (IOUT,FMT=6094) I,IRECG,INTG(IRECG),MINT
          END IF
C
C
          IPNTR(I) = 100*KREC
          IGFLAG(IRECG) = 0
          NMINTR = NMINTR + 1
          GO TO 770
        END IF
C
C
        FULL = .FALSE.
        IF (KREC.LT.0) GO TO 640
        FULL = .TRUE.
        NOFR = NOFR + 1
  640   NXX = IBUF(5)
        NPBOX = IBUF(7)
C
C---- Flag for summed partial, =1 for summed partial, else 0
C
        ISUMPART = IBUF(8)
        IF (ISUMPART.EQ.1) NSUMPART = NSUMPART + 1
C
C     A flag for overloaded summed partials ONLY
C                = 0 If not an overload
C                = 1 if overloaded for integration only
C                = 2 if overload for profile  fitting only
C                = 3 if overload for integration and profile fitting
C
        ISUMOVER = IBUF(9)
C
        CALL GETSTRIP(NPBOX,ISTRIP)
C
C---- Test for new strip of profiles
C
        IF (ISTRIP.EQ.ISTRIPCUR) GO TO 670
C
C---- Set up limits of box numbers and box expansion for this strip
C     code is different if profiles have been determined
C           
        ISTRIPCUR = ISTRIP
C
          IF (DEBUG(18)) THEN
            IF (ONLINE) WRITE (ITOUT,FMT=6096) ISTRIP,IXPIX,NXX
 6096 FORMAT (1X,'STRIP',I3,' Starts at IX=',I5,'  NXX=',I4)
            WRITE (IOUT,FMT=6096) ISTRIP,IXPIX,NXX
C
C---- Set up all possible masks for this strip
C
          WRITE (IOUT,FMT=6098) ISTRIP,MAXR
 6098 FORMAT (1X,'Setting up masks at ISTRIP=',I3,' MAXR=',I6)
          IF (ONLINE) WRITE (ITOUT,FMT=6098) ISTRIP,MAXR
        END IF
C
C
        NFBOX = NPFIRST(ISTRIP) - 1
C
        DO 660 K = 1,NYLINE-1
C
          NFBOX = NFBOX + 1
C
C---- Test for valid boxes
C
          IF (.NOT.BOX(NFBOX)) GOTO 660
          NYY = ISIZE(NFBOX,2)
          NXY = NXX*NYY
C
C---- Set up optimised raster box parameters
C
          IF (PROPT) THEN
            LRAS(3) = IOPTRAS(1,NFBOX)
            LRAS(4) = IOPTRAS(2,NFBOX)
            LRAS(5) = IOPTRAS(3,NFBOX)
          END IF
C
          IF (NYY.GT.MAXDIM) GO TO 670
C
C              ***********************
          CALL SETMASK(MASK(1,K),LRAS)
C              ***********************
C                                     
C
C---- Note that if background points have been rejected from the
C     mask, the background sums in SUMPQ(2,4 and 6) will
C     not be correct, but these values are not used in
C     background plane determination so it doesnt matter
C     (uses pqsums instead)
C              ***********************************
          CALL SETSUMS(MASK(1,K),LRAS,SUMPQ(1,K))
C              ***********************************
C
C--- If changemask,
C    see if any background points have been rejected, and if so
C    update the mask
C
          IF (DEBUG(18)) THEN
            WRITE (IOUT,FMT=6100) K,NFBOX,LRAS,(SUMPQ(J,K),J=1,6)
 6100 FORMAT (1X,'Y INDEX=',I3,' NFBOX',I3,' Raster parameters',5I4,/,
     +        1X,'SUMPQ ',6F10.0)
            IF (ONLINE) WRITE (ITOUT,FMT=6100) K,NFBOX,LRAS,
     +             (SUMPQ(J,K),J=1,6)
          END IF
C
          IF (.NOT.CHANGEMASK) GO TO 660
          NBREJ = MASKREJ(1,NFBOX)
          IF (NBREJ.EQ.0) GO TO 660
C
C
          IF (DEBUG(18)) THEN
            IF (ONLINE) WRITE (ITOUT,FMT=6102) NBREJ,NFBOX
 6102 FORMAT (/1X,I4,' Background points rejected for BOX',I3)
            WRITE (IOUT,FMT=6102) NBREJ,NFBOX
          END IF
C
C
          DO 650 N = 1,NBREJ
            NP = MASKREJ(N+1,NFBOX)
            MASK(NP,K) = 0
  650     CONTINUE
C
C---- End of loop over box expansion
C
  660   CONTINUE
C
C
  670   NYY = IBUF(6)
        IF (NXX.GT.MAXDIM .OR. NYY.GT.MAXDIM) GO TO 760
        NXY = NXX*NYY
C
C
        IF (NXY.GT.MAXR) THEN
          WRITE (IOUT,FMT=6144) MAXR,NXX,NYY,NXY
          IF (ONLINE) WRITE (ITOUT,FMT=6144) MAXR,NXX,NYY,NXY
        END IF
C                                      
C
        CALL GETYIND(NPBOX,NY)
        TPEAK = SUMPQ(5,NY)
C
C---- Set up rim raster parameters for this reflection (only used by MASKONE)
C
        IF (PROPT) THEN
                DO 676 K = 3,5
                  LRAS(K) = IOPTRAS(K-2,NPBOX)
 676           CONTINUE
        ELSE
                DO 678 K = 3,5
                  LRAS(K) = IRAS(K)
 678           CONTINUE
        END IF
C
C
C---- Pack KREC and NPBOX into IPNTR
C
          IPNTR(I) = 100*KREC + SIGN(NPBOX,KREC)
C
C---- If profiles have been read from a file, it is possible to
C     get a reflection which has no corresponding measurement box.
C     this reflection will be treated as unmeasured
C
          IF (NPBOX.EQ.0) THEN
            NWRN = NWRN + 1
            NNOBOX = NNOBOX + 1
            IF (ONLINE) WRITE (ITOUT,FMT=6104) I,NPBOX,NY,NXX,NYY,
     +                                         IXPIX,IYPIX
 6104 FORMAT (1X,'NO Profile box for reflection',I3,' with NPBOX=',I3,
     +       ' NY=',I3,' NXX=',I3,' NYY=',I3,'  IX,IY ',2I5)
            WRITE (IOUT,FMT=6104) I,NPBOX,NY,NXX,NYY,IXPIX,IYPIX
            ISDG(IRECG) = -9999
            INTG(IRECG) = -9999
            IPRO(IRECG) = -9999
            ISDPRO(IRECG) = -9999
            GO TO 770
          END IF
C
C---- Must get TBGND =number of background points from PQSUMS
C     rather than SUMPQ in case points have been rejected
C
          TBGND = PQSUMS(6,NPBOX)
C
C---- Read pixel values for this spot
C     correct densities
C
        NOVR = 0
        NOFFEDGPK = 0
        NOFFEDGBG = 0
        OVRLFIT = .FALSE.
        EDGEFIT = .FALSE.
C                                                                    
C
        DO 680 K = 1,NXY
C
C              *********   
          CALL CBYTE2(K)
C              *********
C
C----  Test for pixel le NULLPIX (outside active area) or pixels above cutoff
C      in the peak region
C
CAL          IF (IBA.LE.NULLPIX) NOFFEDG = NOFFEDG + 1
CAL          IF ((IBA.GT.CUTOFF).AND.(MASK(K,NY).EQ.1)) NOVR = NOVR + 1
          IF (MASK(K,NY).EQ.1) THEN
C
C---- Peak pixels, test for overloads and nullpix
C
            IF (IBA.GT.CUTOFF) NOVR = NOVR + 1
            IF (IBA.LE.NULLPIX) NOFFEDGPK = NOFFEDGPK + 1
          ELSE
C
C---- Background pixels, test for nullpix
C
            IF (IBA.LE.NULLPIX) NOFFEDGBG = NOFFEDGBG + 1
          END IF

          IF (IMGP) THEN
            OD(K) = IBA
          ELSE
            OD(K) = TABLE(IBA)
          END IF
  680   CONTINUE
C
C---- Overloads, either reject or profile fit if keyword set
C      For summed partials, must use flag set up in MEAS before the 
C      2 halves were added. Otherwise just test number of pixels
C      above cutoff
C
        IF (ADDPART.AND.((ISUMOVER.EQ.1).OR.(ISUMOVER.EQ.3))) THEN
          IF (DEBUG(18).AND.SPOT) THEN
            WRITE(IOUT,FMT=6029) KREC,ISUMOVER,ISUMPART
            IF (ONLINE) WRITE(ITOUT,FMT=6029) KREC,ISUMOVER,ISUMPART
            MAXPIX = 0
            CALL ODPLOT4(OD,NXX,NYY,1,MAXPIX)
          END IF
C---- Always profile fit overloaded reflections, but flag them so they
C     can be accepted or rejected by SCALA
CAL          IF (USEOVRLD) THEN
            NOLO = NOLO + 1
            OVRLFIT = .TRUE.
CAL          ELSE
CAL            GO TO 750
CAL          END IF
        ELSE IF (NOVR.GT.NOVPIX) THEN
          IF (DEBUG(18).AND.SPOT) THEN
            WRITE(IOUT,FMT=6031) KREC,ISUMOVER,ISUMPART
            IF (ONLINE) WRITE(ITOUT,FMT=6031) KREC,ISUMOVER,ISUMPART
            MAXPIX = 0
            CALL ODPLOT4(OD,NXX,NYY,1,MAXPIX)
          END IF
C---- Always profile fit overloaded reflections, but flag them so they
C     can be accepted or rejected by SCALA
CAL          IF (USEOVRLD) THEN
            NOLO = NOLO + 1
            OVRLFIT = .TRUE.
CAL          ELSE
CAL            GO TO 750
CAL          END IF
        END IF
C
C---- Check reflections which have pixels <= NULLPIX
C
      IF ((NOFFEDGBG.GT.0).OR.(NOFFEDGPK.GT.0)) THEN
           IF (DEBUG(18)) THEN
             CALL GETHKL(IRECG,IH)
             WRITE(IOUT,FMT=6220) (IH(K),K=1,3),NOFFEDGBG,
     +          NOFFEDGPK,NINT(0.33*SUMPQ(5,NY)),
     +          NINT(0.5*TBGND)           
             IF (ONLINE) WRITE(ITOUT,FMT=6220)(IH(K),K=1,3),NOFFEDGBG,
     +          NOFFEDGPK,NINT(0.33*SUMPQ(5,NY)),
     +          NINT(0.5*TBGND)
 6220        FORMAT(/,1X,'Reflection',3I5,'  NOFFEDGBG',I5,
     +          '  NOFFEDGPK',I5,' third peak pixels',I5,
     +          '  Half background pixels',I5)
           END IF
C     Reject if more than half background pixels or one third of
C     peak pixels are flagged.
C
          IF ((NOFFEDGPK.GT.NINT(0.33*SUMPQ(5,NY))).OR.
     +        (NOFFEDGBG.GT.NINT(0.5*TBGND))) GOTO 740
          NEDGE1 = NEDGE1 + 1
          EDGEFIT = .TRUE.
          IF (DEBUG(18)) THEN
            WRITE(IOUT,FMT=6222) NEDGE1
            IF (ONLINE) WRITE(ITOUT,FMT=6222) NEDGE1
 6222       FORMAT(1X,'Accepted, NEDGE1=',I5)
          END IF
      END IF
C
C
C---- Omit summed partials with only one half
C
      IF (ISUMPART.EQ.2) GOTO 738
C
      IF (PROFILE .AND. CHANGEMASK) NBREJ = MASKREJ(1,NPBOX)
C
C---- Get degree of partiality for partials, needed for weighted profile
C     fit and for analysis (below)
C
        IPART = IMG(IRECG)
        IF ((.NOT.FULL).AND.(IPART.EQ.0)) THEN
          WRITE(IOUT,FMT=6101) 
          IF (ONLINE) WRITE(ITOUT,FMT=6101) 
 6101     FORMAT(1X,'*** ERROR ***',/,1X,'Partial reflection with',
     +     ' zero degree of partiality detected',/,1X,'To allow ',
     +     'program to continue partiality has been set to 0.01',
     +     /,1X,'Please inform Andrew Leslie of this error')
          CALL GETHKL(IRECG,IH)
          WRITE(IOUT,FMT=6180) (IH(K),K=1,3),IRECG,IPART
          IF (ONLINE) WRITE(ITOUT,FMT=6180) (IH(K),K=1,3),IRECG,IPART
 6180     FORMAT(1X,'ZERO PARTIAL, indices',3I4,' IRECG=',I5,' IPART=',
     +           I3)
          IPART = 1
        END IF
C
C
C---- SET XDEBUG HERE FOR EXTENSIVE DEBUG OUTPUT
C
CAL          IF (I.EQ.2335) XDEBUG = .TRUE.
        BADPROF = .FALSE.
C
C---- If using variable profiles,set up the weighted profile for
C     this box
        IF (VARPRO) THEN
          XR = IXPIX
          YR = IYPIX
          CALL VARPROF(MODE,XCGBOX,YCGBOX,XCGCEN,YCGCEN,ICENBOX,
     +               CENTRAL,XR,YR,NPBOX,IPRNUM,WTPR)
C
C---- Store the weighted profile in NUMBOX+1 slot in IPROFL and sums
C     in PROFSUMS. Summed rejected pixels (for all contributing profiles)
C     are stored in LMASKREJ returned by GETPROF
C
          IWTBOX = NUMBOX + 1
C            **********************************************************
          CALL GETPROF(IFLG,NPBOX,IPRNUM,WTPR,MASK(1,NY),
     +                 MASKREJ,
     +                 IPROFL(1,IWTBOX),PROFSUMS(1,IWTBOX),
     +                 WPROFSUMS(1,IWTBOX),LMASKREJ,
     +                 PQSUMSPOT,PQSUMINVSPOT,XDEBUG)
C
C---- Reset TBGND, number of background pixels
C
          TBGND = PQSUMSPOT(6)


C
C---- Now flag the rejected background pixels determined in MASKIT
C     or if DENSE image, calculate them
C
          IF (DENSE) THEN
            IF (FIRSTSP) THEN
              MASKMODE = 0
              FIRSTSP = .FALSE.
            ELSE
              MASKMODE = 1
            END IF
C
C---- Detemine overlapped pixels for this spot alone, calculating
C     LMASKREJ,MASKREJP,PQSUMS and PQSUMINV for use by INTEG2
C
            CALL MASKONE(MASKMODE,IXPIX,IYPIX,KREC,LRAS,
     +                   LMASKREJ,MASKREJP(1,NPBOX),
     +                   PQSUMSPOT,PQSUMINVSPOT,XDEBUG,OD,IERR)
            IF (IERR.LT.0) THEN
              GO TO 760
            ENDIF
C
C---- Reset TBGND, number of background pixels
C
            TBGND = PQSUMSPOT(6)
C
C---- Set up LMASK
C
C              ***********************
            CALL SETMASK(LMASK,LRAS)
C              ***********************
            NBREJ = LMASKREJ(1)
            IF (NBREJ.NE.0) THEN
              DO 681 N = 1,NBREJ
                NP = LMASKREJ(N+1)
                LMASK(NP) = 0
 681          CONTINUE
            END IF
          END IF


C
C---- Check number of background points, increase if necessary.
C     GETMOREBG returns an UPDATED list of rejected background pixels
C     in LMASKREJ.
C
          IF  ((NINT(PQSUMSPOT(6)).LT.RECLEVEL*NBGMIN)
     +                                          .AND.(RECOVER)) THEN
            RECOVERED = .TRUE.
            IF (XDEBUG) THEN
              N = NXY - NINT(TPEAK)
              WRITE(IOUT,FMT=6119) NXY,NINT(TPEAK),N,LMASKREJ(1)
              IF (ONLINE) WRITE(ITOUT,FMT=6119) NXY,NINT(TPEAK),N,
     +                      LMASKREJ(1)
            END IF
 6119  FORMAT(1X,'Total number of pixels',I5,' Peak pixels',I5,
     +        ' background pixels',I5,' of which',I5,' rejected')
            MODEBG = 2
            CALL GETMOREBG(IPROFL(1,IWTBOX),MODEBG,LRAS,MASK(1,NY),
     +        LMASKREJ,PQSUMSPOT,PQSUMINVSPOT,I)
C
C---- Reset TBGND, number of background pixels
C
            TBGND = PQSUMSPOT(6)
          END IF
C
C---- If additional pixels have been rejected, need to create a new
C     MASK array for this spot. If GETMOREBG has been called, need
C     to set ALL rejected background pixels to OK initially, then
C     use new list stored in LMASKREJ to reset them. This is because
C     GETMOREBG can reclassify a previously rejected background pixel
C     as being OK, whereas GETPROF will only ADD new rejected pixels.
C
C---- DO NOT DO THIS IF DENSE is TRUE as LMASK has been set up already
C
          IF (.NOT.DENSE) THEN
          DO 682 N = 1,NXY
            LMASK(N) = MASK(N,NY)
            IF (RECOVERED.AND.LMASK(N).EQ.0) LMASK(N) = -1 
 682      CONTINUE
C          WRITE(6,*),'MASKREJ',(MASKREJ(N,NPBOX),N=1,NBREJ)
C          WRITE(6,*),'NBREJ,LMASKREJ(1),NXY',NBREJ,LMASKREJ(1),NXY
          IF ((CHANGEMASK.AND.(LMASKREJ(1).NE.NBREJ)).OR.RECOVERED)THEN
            RECOVERED = .FALSE.
            NBREJ = LMASKREJ(1)
C           WRITE(6,*),'LMASKREJ',(LMASKREJ(N),N=1,NBREJ)
            DO 684 N = 1,NBREJ
              NP = LMASKREJ(N+1)
              LMASK(NP) = 0
C              WRITE(6,*),'REJECT PIXEL, number',NP,N
 684        CONTINUE
          END IF
          END IF
C            **********************************************************
          CALL INTEG2(OD,IPROFL(1,IWTBOX),LRAS,LMASK,
     +               LMASKREJ,MASKREJP(1,NPBOX),LMASKREJP,
     +               MASKREJO,SUMPQ(1,NY),PQSUMSPOT,
     +               PQSUMINVSPOT,PROFSUMS(1,IWTBOX),
     +               WPROFSUMS(1,IWTBOX),
     +              IDR,NBREJ,BGSIG,FULL,IPART,WEIGHT,OVRLFIT,
     +              CUTOFF,EDGEFIT,ISUMPART,PKWDLIM1,PKWDLIM2,PKWDLIM3,
     +             XDEBUG,PKONLY,PKWDOUTL,IOUTL1,IOUTL2,DECONV,BADSPOT)
C            **********************************************************
        ELSE 
C            **********************************************************
         CALL INTEG2(OD,IPROFL(1,NPBOX),LRAS,MASK(1,NY),
     +              MASKREJ(1,NPBOX),MASKREJP(1,NPBOX),LMASKREJP,
     +              MASKREJO,SUMPQ(1,NY),PQSUMS(1,NPBOX),
     +              PQSUMINV(1,NPBOX),PROFSUMS(1,NPBOX),
     +              WPROFSUMS(1,NPBOX),IDR,NBREJ,BGSIG,FULL,IPART,
     +              WEIGHT,OVRLFIT,CUTOFF,EDGEFIT,ISUMPART,
     +              PKWDLIM1,PKWDLIM2,PKWDLIM3,XDEBUG,PKONLY,
     +              PKWDOUTL,IOUTL1,IOUTL2,DECONV,BADSPOT)
C            **********************************************************
        END IF        
C
C---- Count number of spots with rejected peak pixels due to poor profile fit
C
         IF (LMASKREJP(1).GT.0) NBADPK = NBADPK + 1
         IF (LDUMP) THEN
          K = NINT(ASPOT(13))
          IF ((K.GT.IDMIN).AND.(K.LT.IDMAX)) THEN
            CALL GETHKL(IRECG,IH)
            WRITE(IOUT,FMT=6105) (IH(K),K=1,3),NPBOX,NY,LRAS,
     +       (SUMPQ(K,NY),K=1,6),
     +       (PQSUMS(K,NPBOX),K=1,6),(PQSUMINV(K,NPBOX),K=1,9),
     +        NBREJ
            IF (ONLINE) WRITE(ITOUT,FMT=6105) (IH(K),K=1,3),NPBOX,NY,
     +         LRAS,(SUMPQ(K,NY),K=1,6),
     +         (PQSUMS(K,NPBOX),K=1,6),(PQSUMINV(K,NPBOX),K=1,9),
     +          NBREJ
 6105   FORMAT(/1X,'Integrating reflection',3I5,/,1X,
     +        'Profile box',I3,'Y index',I3,'   Raster',5I5,/,1X,
     +        'SUMPQ',6F10.0,/,1X,
     +        'PQSUMS',6F10.0,/,1X,'PQSUMINV',9F9.5,/,1X,
     +        'Number of rejected background pixels',I4)
          END IF
        END IF
C
C---- Check that background under peak is not negative
C
      IF (ASPOT(2).LT.0.0) THEN
        CALL GETHKL(IRECG,IH)
        WRITE(IOUT,FMT=6103) I,(IH(K),K=1,3),ASPOT(2),IDIVIDE
        IF (ONLINE) WRITE(ITOUT,FMT=6103)  I,(IH(K),K=1,3),ASPOT(2),
     +                                      IDIVIDE
 6103   FORMAT(1X,'** SERIOUS ERROR **',/,1X,'Reflection record',
     +       ' number', I6,' indices',3I4,/,1X,'The total background',
     +       ' counts under the peak region has',/,1X,'become ',
     +       'negative (value is',F8.1,')after subtracting the ',
     +       'scanner adc',/,1X,'offset (value currently',I6,/,1X,
     $       'Reset the scanner',
     +       ' offset using keyword ADCOFFSET followed by value',/,
     $       'You should probably examine the spot using the ',
     $       'interactive display, since this error is ',/,1X,'often ',
     $       'associated with detector problems')
      END IF
C---- Test that it has not rejected an unacceptable number of
C     background points. This is set in INTEG2 to ensure at least
C     NBGMIN (set using keywords REJECTION MINBG) background pixels left,
C     and if not, flagged with ASPOT(1)=-9999. No data are available for
C     these reflections asthe background plane is not calculated.
        IF (ABS(ASPOT(1)+9999.0).LT.0.1) THEN
CAL*          LDUMP = .TRUE.
          NBADBG = NBADBG + 1
          ISDG(IRECG) = -9999
          LBADBG = .TRUE.
C
C  If doing a separate pass to update sigmas based on calculated ERRINST,
C  flag these reflections so they can be printed as badspots.
          IF (.NOT.ERRSET) ISDG(IRECG) = -8888
          ISDPRO(IRECG) = -9999

          ISIGPRO = -9999
          ISPOT = 0
          ISDBSI = 0
          BGRATIO = 0.0
          PKRATIOS = 0.0
          A = 0.0
          B = 0.0
          C = 0.0
          GOTO 725
        ELSE
          LBADBG = .FALSE.
        END IF           
C
C---- Set PEAKVAR to zero for partials (it may be very large for partials
C     ie gt 32767 and then can't store it in ISDG
C
        IF (.NOT.FULL) PEAKVAR = 0.0
C
        IF (FULL.AND.(.NOT.(OVRLFIT.OR.EDGEFIT)).AND.(SOD.GT.100.)) THEN
C
C---- Add box shift to delx,dely
C
          DELX = (DELX+IXSHIFT)/FACT
          DELY = (DELY+IYSHIFT)/FACT
          XCGSP(NPBOX) = XCGSP(NPBOX) + DELX*DELX
          YCGSP(NPBOX) = YCGSP(NPBOX) + DELY*DELY
          XWCGSP(NPBOX) = XWCGSP(NPBOX) + DELX*DELX*SOD
          YWCGSP(NPBOX) = YWCGSP(NPBOX) + DELY*DELY*SOD
          WCGSP(NPBOX) = WCGSP(NPBOX) + SOD
          NCGSP(NPBOX) = NCGSP(NPBOX) + 1
        ELSE
          DELX = 0.0
          DELY = 0.0
        END IF
C
C---- NREJ is the number of ADDITIONAL background points rejected (ie not
C     including those masked out by overlapping spots
C
        NREJ = NINT(ASPOT(15))
        SUMREJ = SUMREJ + NREJ
        NREJSUM = NREJSUM + 1
        SUMBG = SUMBG + TBGND
C
C---- Must update number of background points to allow for rejected 
C     pixels. 
C
       TBGND = TBGND - NREJ
C                       
C---- Calculate standard deviation of intensity
C
        VSPOT = GAIN*SOD
C
C---- Next two lines corrected 8/1/86
C     vbg=tpeak*rmsbg
C     vbg=vbg*vbg/tbgnd
C
        VBG = TPEAK*RMSBG*RMSBG
C                        
C
        IF ((VBG.LT.0.0) .OR. (PEAKVAR.LT.0.0)) THEN
          WRITE (IOUT,FMT=6106) VBG,VSPOT,PEAKVAR,NPBOX,NREJ,FULL,
     +         IPART,DELX,DELY,ASPOT(1),ASPOT(13)
 6106 FORMAT (1X,'**** SERIOUS ERROR, CONSULT PROGRAMMER ***',/1X,'***',
     +       '** VBG=',E12.5,' VSPOT=',E12.5,' PEAKVAR=',E12.5,
     +       /,1X,'NPBOX=',I3,' NBKREJ=',I3,' FULL ',L1,' IPART',I3,
     +       ' DELX,Y',2F6.2,/,1X,' SOD',F8.1,' PROF I',F8.1)
          IF (ONLINE) WRITE (ITOUT,FMT=6106) VBG,VSPOT,PEAKVAR,NPBOX,
     +         NREJ,FULL,
     +         IPART,DELX,DELY,ASPOT(1),ASPOT(13)
          IF (PEAKVAR.LT.0.0) PEAKVAR = 0.0
          IF (VBG.LT.0.0) VBG = 0.0
          MAXPIX = 0
          CALL ODPLOT4(OD,NXX,NYY,1,MAXPIX)
        END IF
C
C---- This sigma does not include instrument error correction
C     (added later) unless the detector error factor has been set explicitly
C
C *** Change this to counting statistics based value
C        ISDBSI = SQRT(2*VBG+ABS(VSPOT))*SCAI + 0.5
C
C---- For sigma calculations, use ABS(integrated intensity) to avoid getting
C     anomalously low sigmas for very -ve reflections
C
        ABSSOD = ABS(SOD)
        XX = (ABSSOD/BOXFAC)**2*TPEAK
        IF (ERRSET) THEN
          AX = 1.0
          IF (TBGND.NE.0.0)
     +        AX = GAIN*(ABSSOD+BGND+BGND*TPEAK/TBGND) + ERRINST*XX
          IF (AX.LT.0.0) THEN
            WRITE(IOUT,6107) AX,ABSSOD,BGND,TPEAK,TBGND,XX,ERRINST,NREJ,
     +                       NBREJ,ASPOT
            IF (ONLINE) WRITE(ITOUT,6107) AX,ABSSOD,BGND,TPEAK,TBGND,XX,
     +           ERRINST,NREJ,NBREJ,ASPOT
 6107       FORMAT(//,1X,'****** SERIOUS ERROR *****',/1X,'-VE VAR',
     +         'IANCE',/,1X,'AX ABSSOD BGND TPEAK',4E12.3,/,1X,
     +         ' TBGND,XX ERRINST',2E12.3,E10.2,/,1X,'NREJ,NBREJ',2I6,
     +         /,1X,'ASPOT ',6E12.3/,1X,6E12.3,/,1X,6E12.3)
            MAXPIX = 0
            CALL ODPLOT4(OD,NXX,NYY,1,MAXPIX)
            AX = 1.0
          END IF
cdms05.1999   Add check for negative argument to SQRT
          IF (AX.GT.0.0) THEN
            ISDBSI=SCAI*SQRT(AX) + 0.5
          ELSE
            ISDBSI=0
          ENDIF
        ELSE
          AX = 1.0
          IF (TBGND.NE.0.0) AX = GAIN*(ABSSOD+BGND+BGND*TPEAK/TBGND)
          IF (AX.LT.0.0) THEN
            WRITE(IOUT,6107) AX,ABSSOD,BGND,TPEAK,TBGND,XX,ERRINST,NREJ,
     +                       NBREJ
            IF (ONLINE) WRITE(ITOUT,6107) AX,ABSSOD,BGND,TPEAK,TBGND,XX,
     +           ERRINST,NREJ,NBREJ                 
            MAXPIX = 0
            CALL ODPLOT4(OD,NXX,NYY,1,MAXPIX)
            AX = 1.0
          END IF
cdms05.1999   Add check for negative argument to SQRT
          IF (AX.GT.0.0) THEN
            ISDBSI=SCAI*SQRT(AX) + 0.5
          ELSE
            ISDBSI=0
          ENDIF
         END IF
        ISDBSI = MAX(ISDBSI,1)
C
C---- Check magnitude of ISDBSI and PEAKVAR to avoid I*2 overflow
C
        IF (ISDBSI.GT.32767) THEN
C
C
C---- This now only happens for very intense spots, where the
C     scanner factor makes the estimated sigma too large, so
C     just reset it.
         ISDBSI = 32700
C---- If this is a profile fitted overload, just reset ISDBSI to
C     32000
CAL         IF (OVRLFIT) THEN
CAL           ISDBSI = 32000
CAL         ELSE
CAL           CALL GETHKL(IRECG,IH)
CAL           WRITE (IOUT,FMT=6108) ISDBSI,(IH(K),K=1,3)
CAL           IF (ONLINE) WRITE (ITOUT,FMT=6108) ISDBSI,(IH(K),K=1,3)
 6108 FORMAT(/,/,1X,'Error 6108 in subroutine process',/,
     $        1X,'**** SERIOUS ERROR ****',/,1X,' The standard ',
     +    'deviation of the integrated intensity is',I10,/,1X,
     +    'which is greater than the maximum allowed value (32767)',
     +    'Something may be seriously wrong',/,1X,'h,k,l',3I4,/,1X,
     +    'The pixel values for this spot follow',/)
CAL            MAXPIX = 0
CAL           CALL ODPLOT4(OD,NXX,NYY,1,MAXPIX)
CAL           IF (ERRSET) THEN
CAL             WRITE(IOUT,FMT=6109) EFAC
CAL             IF (ONLINE) WRITE(ITOUT,FMT=6109) EFAC
 6109 FORMAT(/,1X,'Error 6109 in subroutine process',/,1X,
     $     'The value of the detector error factor used ',
     +       'in the calculation of the',/,1X,'standard deviation ',
     +       'is',F12.3,'.. is this correct ?',/,1X,'Usually this ',
     +       'error can be avoided by assigning a small value to',/,1X,
     +    'the detector error factor (keyword DETECTOR): DETECTOR 0.1')
CAL           END IF
CAL         END IF
        END IF
C
CAL
        IF (SQRT(PEAKVAR).GT.32767) THEN
C
C---- Reset PEAKVAR to 32000**2 so it doesn't cause integer overflow
C     problems. These reflections will have the profile fitted measurement
C     rejected anway because PKRATIO will be very high.
           PEAKVAR = 32000.0*32000.0
        END IF
        IF ((ASPOT(16).LE.0.0).OR.BADSPOT) THEN
            BADPROF = .TRUE.
            ASPOT(16) = 10000000.0
            IF (DEBUG(18)) THEN
            CALL GETHKL(IRECG,IH)
            WRITE (IOUT,FMT=6113) 
            IF (ONLINE) WRITE (ITOUT,FMT=6113) 
 6113 FORMAT(1X,'Very poor profile fit for this spot.',
     +    ' The pixel values follow',/)
CAL 6113 FORMAT(//1X,'**** SERIOUS ERROR ****',/,1X,' The ',
CAL     +     'fit of the scaled profile to this reflection is',/,1X,
CAL     +    'very poor. Something may be seriously wrong',/,1X,
CAL     +    'Does the reflection profile (printed below) look ',
CAL     +    ' flat-topped ?',/,1X,'If so, you may need to reduce',
CAL     +    ' the value of CUTOFF',
CAL     +    ' (currently',I7,')',/,1X,'which defines the saturation',
CAL     +    ' point of the detector',/,1X,'Use keywords ',
CAL     +    'OVERLOAD CUTOFF to do this',/,1X,
           MAXPIX = 0
           CALL ODPLOT4(OD,NXX,NYY,1,MAXPIX)
           CALL GETHKL(IRECG,IH)
C
C---- Allow for switch inversion right to left of Mar images
C
          IXP = IXPIX
          IF (INVERTX) IXP = NREC - IXPIX + 1
          IF (TBGND.GT.0) X1 = GAIN*(ABSSOD+BGND+BGND*TPEAK/TBGND)
          X2 = ERRINST*XX
C
          IF (ONLINE) WRITE(ITOUT,FMT=7150)I,(IH(K),K=1,3),
     +         IXP,IYPIX,NPBOX,NXX,NYY,
     +         RMSBG,DELX,DELY,NREJ+NBREJ,A,B,C,BGDEVMAX,
     +                        TBGND,TPEAK,BOXFAC,X1,X2
          WRITE(IOUT,FMT=7150)I,(IH(K),K=1,3),
     +                        IXP,IYPIX,NPBOX,NXX,NYY,RMSBG,
     +                        DELX,DELY,NREJ+NBREJ,A,B,C,BGDEVMAX,
     +                        TBGND,TPEAK,BOXFAC,X1,X2
          IF (ONLINE) WRITE(ITOUT,FMT=7162) ISPOT,ISDBSI,ISPOTPRO,
     +                              ISIGPRO,VBG,VSPOT,PEAKVAR,FULL
          WRITE(IOUT,FMT=7162) ISPOT,ISDBSI,ISPOTPRO,ISIGPRO,VBG,VSPOT,
     +                         PEAKVAR,FULL
C
           IF (VARPRO) THEN
            WRITE(IOUT,7163)(IPRNUM(J),J=1,4),(WTPR(J),J=1,4),
     +         LMASKREJ(1),MASKREJP(1,NPBOX),
     +         MASKREJO(1),LMASKREJP(1),SUMPQ(5,NY)
            IF (ONLINE) WRITE(ITOUT,7163) (IPRNUM(J),J=1,4),
     +         (WTPR(J),J=1,4),LMASKREJ(1),MASKREJP(1,NPBOX),
     +         MASKREJO(1),LMASKREJP(1),SUMPQ(5,NY)
C              ****************************************************
             CALL PLOTPROF(OD,IPROFL(1,IWTBOX),LRAS,
     +                   LMASK,PROFSUMS(1,IWTBOX),WPROFSUMS(1,IWTBOX),
     +                   MASKREJO,MASKREJP(1,NPBOX),LMASKREJP,WEIGHT,
     +                   PKONLY)
C              ****************************************************
           ELSE
C              ****************************************************
              CALL PLOTPROF(OD,IPROFL(1,NPBOX),LRAS,
     +                MASK(1,NY),PROFSUMS(1,NPBOX),WPROFSUMS(1,NPBOX),
     +                MASKREJO,MASKREJP(1,NPBOX),LMASKREJP,WEIGHT,
     +                   PKONLY)
C              ****************************************************
C
           END IF
        END IF
        END IF
        
C
C---- Sums for instrument error correction
C
        IF (FULL.AND.(.NOT.(OVRLFIT.OR.EDGEFIT))) THEN
C                                     
C---- Need to trap outliers  ??
C     Eliminate reflections with PKRATIO > 6
C
C *** Change to counting statistics ***
C        PKRATIOS = SQRT(PEAKVAR/(QFAC*BGND + ABS(VSPOT)))
         PKRATIOS = 0.0
         AX = ABSSOD + BGND
         IF (AX.GT.0.0) PKRATIOS=SQRT(PEAKVAR/(GAIN*AX))
C
C---- For Mar mosaic detector on BM14, PKRATIO is too large for many
C     fully recorded spots. Origin of this is not clear. For present,
C     simply divide by 3.0
C
         IF ((MACHINE.EQ.'MARC').AND.
     $        ((MODEL.EQ.'MOSAIC3').OR.(MODEL.EQ.'MOSAIC4')))
     +        PKRATIOS = 0.333*PKRATIOS
C                                    
            IF (PKRATIOS.GT.6.0) THEN
                NSUMR = NSUMR + 1
                PKREJS = PKREJS + PKRATIOS
            ELSE
C *** Change to counting statistics ***
C                ASUM = (PEAKVAR - (QFAC*BGND + ABS(VSPOT))) + ASUM
                ASUM=ASUM+(PEAKVAR-(ABSSOD+BGND)*GAIN)
                BSUM = XX + BSUM
            END IF
C       
C   If detector error factor already set, calculate true PKRATIO now
           IF (ERRSET) THEN
             PKRATIOS = 0.0
             AX = GAIN*(ABSSOD+BGND)+ERRINST*XX
             IF (AX.GT.0.0) PKRATIOS=SQRT(PEAKVAR/AX)
C
C---- For Mar mosaic detector on BM14, PKRATIO is too large for many
C     fully recorded spots. Origin of this is not clear. For present,
C     simply divide by 3.0
C
             IF ((MACHINE.EQ.'MARC').AND.
     $            ((MODEL.EQ.'MOSAIC3').OR.(MODEL.EQ.'MOSAIC4')))
     +          PKRATIOS = 0.333*PKRATIOS
             END IF
        ELSE
C
C  Partial or fitted overload
        PKRATIOS = 0.0
        END IF
C
C---- Use BADPROF flag to set rejection of spots (full or partial)
C     with very poor profile fit such that ASPOT(16) is negative
        IF (BADPROF) THEN
          PKRATIOS = 99.0
        END IF
C
C---- Store variables for recalculating sigmas and PKRATIO in second pass
C     using calculated ERRINST.
        IF (.NOT.ERRSET) THEN
          NPEAK(I) = TPEAK
          RMSBGX(I) = RMSBG
          BGNDX(I) = BGND
          ISDG(IRECG) = SQRT(PEAKVAR)*SCAI + 0.5
C
C---- Store background plane constants (to be printed for badspots) as
C     integers packed into IABC. Gradients restricted to range +-45
          IA = MAX(0,MIN(NINT(A+45),99))
          IB = MAX(0,MIN(NINT(B+45),99))
          IC = MIN(NINT(C),9999)
          IABC(I) = IA + IB*100 + IC*10000
        END IF                 
C
C---- Calculate profile sigma for fulls on basis of background
C     variation plus fit of ods to the profile.
C     For partials, profile fitted overloads and profile fitted edge
C     reflections, use the integrated sigmas.
C     Note correction to Rossmann formula involving the profile factor.
        IF (FULL.AND.(.NOT.(OVRLFIT.OR.EDGEFIT))) THEN
C  Change to counting statistics
C          ISIGPRO = SQRT(PROFACT(NPBOX)*PEAKVAR + VBG) * SCAI + 0.5
          IF (WEIGHT) THEN
             IF (PKONLY) THEN
cdms05.1999    Add check for negative argument to SQRT
               XWTEMP=PROFACT(NPBOX)*PEAKVAR+VBG
               IF (XWTEMP.GT.0.0) THEN
                 ISIGPRO=SQRT(XWTEMP)*SCAI+0.5
               ELSE
                 ISIGPRO=0
               ENDIF
             ELSE
               IF (ASPOT(16).GT.0.0) THEN
                 ISIGPRO = SCAI*SQRT(ASPOT(16))
               ELSE
                 ISIGPRO=0
               ENDIF
             END IF
          ELSE
             ISIGPRO = -9999
             IF (TBGND.NE.0.0)THEN
cdms05.1999    Add check for negative argument to SQRT
               XWTEMP=GAIN*BGND*TPEAK/TBGND+PROFACT(NPBOX)*PEAKVAR
               IF (XWTEMP.GT.0.0) THEN
                 ISIGPRO=SCAI*SQRT(XWTEMP)+0.5
               ELSE
                 ISIGPRO=0
               ENDIF 
            ENDIF
          END IF
          IF (ISIGPRO.EQ.0) ISIGPRO = 1
        ELSE
          ISIGPRO = ISDBSI                     
        END IF
C
C---- Check ISIGPRO le 32767
C
        IF (ISIGPRO.GT.32767) THEN
           CALL GETHKL(IRECG,IH)
C
C---- Allow for switch inversion right to left of Mar images
C
           IXP = IXPIX
           IF (INVERTX) IXP = NREC - IXPIX + 1
           IF (DEBUG(18)) THEN
             WRITE (IOUT,FMT=6115) CUTOFF,IXP,IYPIX,NPBOX,
     +                           (IH(K),K=1,3)
             IF (ONLINE) WRITE (ITOUT,FMT=6115) CUTOFF,
     +            IXP,IYPIX,NPBOX,(IH(K),K=1,3)
 6115        FORMAT(//1X,'**** SERIOUS ERROR ****',/,1X,' The ',
     +       'fit of the scaled profile to this reflection is',/,1X,
     +      'very poor. Something may be seriously wrong',/,1X,
     +      'Does the reflection profile (printed below) look ',
     +      ' flat-topped ?',/,1X,'If so, you may need to reduce',
     +      ' the value of CUTOFF',
     +      ' (currently',I8,')',/,1X,'which defines the saturation',
     +      ' point of the detector',/,1X,'Use keywords ',
     +      'OVERLOAD CUTOFF to do this eg OVERLOAD CUTOFF 110000',/,1X,
     +      'Pixel coordinates are IX=',I5,' IY=',I5,
     +       ' Profile box number',I3,/,1X,'h,k,l',3I4,/,1X,
     +       'The pixel values for this spot follow')
             MAXPIX = 0
             CALL ODPLOT4(OD,NXX,NYY,1,MAXPIX)
           END IF
           ISIGPRO = 32760
        END IF
C
C
C---- If detector error not set, flag fitted overloads so that the profile
C     fitted sigma will be set to the updated (allowing for instrument
C     error) value of the summation sigma on the second pass through
C     the reflection list (800 loop)
C
        IF ((OVRLFIT.OR.EDGEFIT).AND.(.NOT.ERRSET)) ISIGPRO = 7777
C
C---- Flag reflections where the profiles were rejected
C
        IF (NOPROFILE(NPBOX)) THEN
          ISPOTPRO = ISPOT
C
C---- flag this reflection so that sigma is updated for instrument error
C     if not ERRSET.
C
          IF (ERRSET) THEN
            ISIGPRO = ISDBSI
          ELSE
            ISIGPRO = 7777
          END IF
        END IF
C
C---- Store intensities
C
        ISPOT = SCAI*SOD + 0.5
        ISPOTPRO = SCAI*SODPRO + 0.5
Chrp 14.06.2004 sortmtz can't cope with numbers < -999999
        IF(ISPOTPRO.LT.-100000)ISPOTPRO = -100000
Chrp 11.11.2004 added for summation integration
        IF(ISPOT.LT.-100000)ISPOT = -100000
C
        INTG(IRECG) = ISPOT
C
C---- Allow for outputting non-background corrected integrated intensities
C
        IF (NOBACK) THEN
          ISPOT = SCAI*(SOD+ASPOT(2)) + 0.5
          INTG(IRECG) = ISPOT
          ISDBSI = SQRT(GAIN*ISPOT + ERRINST*XX) + 0.5
        END IF
C
C  Note that if .NOT. ERRSET, ISDG is used to store PEAKVAR, so
C  only assign a correct value if the detector error has been set.
        IF (ERRSET) ISDG(IRECG) = ISDBSI
        IPRO(IRECG) = ISPOTPRO
        ISDPRO(IRECG) = ISIGPRO
C
C---- Fraction of background points rejected for this spot
C
        IF (SUMPQ(6,NY).NE.0) BGRFRC = (SUMPQ(6,NY)-TBGND)/SUMPQ(6,NY)
C
        IF ((DUMP(1) .AND. 
     +  ((I/NDUMP)*NDUMP.EQ.I .AND. ISPOT.GT.IDUMP
     +   .AND. JDUMP.LE.MXDUMP)).OR.
     +  (FULL .AND. (ISPOT.GT.IPLOT) .AND. (IPLOT.GT.0)).OR.
     +  (DUMP(4).AND.(BGRFRC.GT.BGRLIM).AND.(JDUMP.LE.MXDUMP)) .OR.
     +  (DUMP(5).AND.OVRLFIT.AND.(JDUMP.LE.MXDUMP)) .OR.
     +  (DUMP(5).AND.EDGEFIT.AND.(JDUMP.LE.MXDUMP)) .OR.
     +  (DUMP(10).AND.(LMASKREJP(1).GT.NDEBUG(80))).OR.
     +  (LDUMP)) THEN
C
C---- Check for dumping only fully recorded reflections
C
          IF (DUMP(9).AND.(.NOT.FULL)) GOTO 708
C
C---- Check intensity
C
          IF ((ISPOTPRO.LT.IDMIN).OR.(ISPOTPRO.GT.IDMAX)) GOTO 708
C
          JDUMP = JDUMP + 1                 
          CALL GETHKL(IRECG,IH)
C
C---- Allow for switch inversion right to left of Mar images
C
          IXP = IXPIX
          IF (INVERTX) IXP = NREC - IXPIX + 1
          IF (TBGND.GT.0.) X1 = GAIN*(ABSSOD+BGND+BGND*TPEAK/TBGND)
          X2 = ERRINST*XX
          IF (VARPRO) THEN
            PSCALE = ASPOT(13)/PROFSUMS(3,IWTBOX)
            IF (WEIGHT) PSCALE = ASPOT(13)/WPROFSUMS(3,IWTBOX)
            IF (PKONLY) PSCALE = ASPOT(13)/PROFSUMS(3,IWTBOX)
          ELSE
            PSCALE = ASPOT(13)/PROFSUMS(3,NPBOX)
            IF (WEIGHT) PSCALE = ASPOT(13)/WPROFSUMS(3,NPBOX)
            IF (PKONLY) PSCALE = ASPOT(13)/PROFSUMS(3,NPBOX)
          END IF
          IF (ONLINE) WRITE(ITOUT,FMT=7150)I,(IH(K),K=1,3),
     +         IXP,IYPIX,NPBOX,NXX,NYY,
     +         RMSBG,DELX,DELY,NREJ+NBREJ,A,B,C,BGDEVMAX,TBGND,TPEAK,
     +         BOXFAC,X1,X2,PSCALE*PRGRAD(NPBOX)
7150      FORMAT(///1X,'Dumping reflection',I5,'  Indices',3I4,
     +    '  pixel coordinates', 2I6,
     +   /1X,'NPBOX=',I3,'   NXX,NYY',2I3,'   RMSBG=',F6.0,
     +   ' DELX,DELY',2F5.1,'    NREJTOT',I4,/1X,' A,B,C',2F8.2,F9.1,
     +   ' BGDEVMAX',F6.1,' TBGND',F6.0,' TPEAK',F6.0,/,1X,
     +    'Box factor ',F6.3,'  Counting statistics variance',F12.0,
     +   '  detector error variance',F12.0,'  Scaled profile gradient',
     +     F10.2)
          WRITE(IOUT,FMT=7150)I,(IH(K),K=1,3),
     +                        IXP,IYPIX,NPBOX,NXX,NYY,RMSBG,DELX,
     +                    DELY,NREJ+NBREJ,A,B,C,BGDEVMAX,TBGND,TPEAK,
     +         BOXFAC,X1,X2,PSCALE*PRGRAD(NPBOX)
          IF (ONLINE) WRITE(ITOUT,FMT=7162) ISPOT,ISDBSI,ISPOTPRO,
     +             ISIGPRO,VBG,VSPOT,PEAKVAR,FULL,IPART,PSCALE
7162  FORMAT(1X,'ISPOT=',I10,' ISDSBI=',I6,' ISPOTPRO=',I10,
     +     ' ISIGPRO='
     + ,I6,/,' VBG=',F10.0,' VSPOT=',F10.0,' PEAKVAR=',F14.0,
     +  ' FULL=',L1,' IPART=',I4,/,1X,
     +                'Profile scale factor',F9.3)
          WRITE(IOUT,FMT=7162) ISPOT,ISDBSI,ISPOTPRO,ISIGPRO,VBG,VSPOT,
     +                         PEAKVAR,FULL,IPART,PSCALE
          
C
          IF (VARPRO) THEN
            WRITE(IOUT,7163)(IPRNUM(J),J=1,4),(WTPR(J),J=1,4),
     +         LMASKREJ(1),MASKREJP(1,NPBOX),
     +         MASKREJO(1),LMASKREJP(1),SUMPQ(5,NY)
            IF (ONLINE) WRITE(ITOUT,7163) (IPRNUM(J),J=1,4),
     +         (WTPR(J),J=1,4),LMASKREJ(1),MASKREJP(1,NPBOX),
     +         MASKREJO(1),LMASKREJP(1),SUMPQ(5,NY)
 7163       FORMAT(1X,'Profiles used in variable profile',4I4,/,1X,
     +                'Weights:',4F6.2,/,1X,'Number of background',
     +                ' pixels rejected as overlapped',I4,' Number ',
     +                'of peak pixels rejected as overlapped',I3,
     +                /,1X,'Number background pixels rejected as ',
     +                'outliers',I3,
     +                '  Number pixels rejected due to poor profile',
     +                ' fit',I3,/,1X,'Number of peak pixels',F4.0)
C              ****************************************************
             CALL PLOTPROF(OD,IPROFL(1,IWTBOX),LRAS,
     +                   LMASK,PROFSUMS(1,IWTBOX),WPROFSUMS(1,IWTBOX),
     +                   MASKREJO,MASKREJP(1,NPBOX),LMASKREJP,WEIGHT,
     +                   PKONLY)
C              ****************************************************
           ELSE
C              ****************************************************
              CALL PLOTPROF(OD,IPROFL(1,NPBOX),LRAS,
     +                MASK(1,NY),PROFSUMS(1,NPBOX),WPROFSUMS(1,NPBOX),
     +                MASKREJO,MASKREJP(1,NPBOX),LMASKREJP,WEIGHT,
     +                   PKONLY)
C              ****************************************************
C
          END IF
        END IF
C
C
 708    IF (BGND.GT.0.0) GO TO 710
        NWRN = NWRN + 1
        WRITE (IOUT,FMT=6110) IXPIX,IYPIX
 6110 FORMAT (' ZERO Background spot, X,Y ',2I5)
        IF (ONLINE) WRITE (ITOUT,FMT=6110) IXPIX,IYPIX
        MAXPIX = 0
        CALL ODPLOT4(OD,NXX,NYY,1,MAXPIX)
        BGND = 0.01                              
        NBZERO = NBZERO + 1
C
C *** Change to counting statistics ***
C  710   BGRATIO = RMSBG/SQRT(QFAC*BGND/TPEAK)
C  710   IF (BGND.NE.0.0) BGRATIO=RMSBG/SQRT(GAIN*BGND/TPEAK)
cdms05.1999    Add check for zeroes in denom.
  710   IF (BGND.NE.0.0.AND.TPEAK.NE.0.0)  THEN
          XWTEMP=GAIN*BGND/TPEAK
          IF (XWTEMP.GT.0.0) THEN
            BGRATIO=RMSBG/SQRT(XWTEMP)
          ELSE
            BGRATIO=0.0
          ENDIF
        ELSE
          BGRATIO=0.0
        ENDIF
C
C---- Store BGRATIO, PKRATIO, GRADIENT for output to MTZ file
C
        IA = MIN(BGRATIO*10.0,99.0) + NINT(PKRATIOS*100.0)*100
        X = 0.0
        IF (C.GT.0.0) X = MAX(ABS(A/C),ABS(B/C))
        X = MIN(X,0.99)
        GOODFIT(IRECG) = X + IA
C
C---- Compile statistics if ERRSET to avoid another loop over 
C     reflections
C
        IF (ERRSET) THEN
C
C---- Modify IPART if adding partials (ADDPART). If IR=5 this is a
C     partial over 3 images and this is the first, so IPART is correct.
C     If IR=6, this is a partial over 3 images and this is the summed
C     contribution from images 2 and 3, and cannot be used in analysis
C     because we don't know its degree of partiality
C
           IF (ADDPART) THEN
             IF (IR.LT.5) THEN
               IPART = 0
             ELSE IF (IR.EQ.6) THEN
               IPART = -999
             END IF
           END IF
           CALL GETBIN(IRECG,ITHBIN,NBIN1,DSTSQ)
           CALL STATS(ISPOT,ISDBSI,ISPOTPRO,ISIGPRO,BGRATIO,
     +                      PKRATIOS,NPBOX,IPART,FULL,OVRLFIT,
     +                      ITHBIN)
        END IF
C
C             
        IF ((.NOT.FULL).OR.(OVRLFIT.OR.EDGEFIT)) GO TO 720
        XX = IXPIX/FACT
        YY = IYPIX/FACT  
C
C---- May not yer have requested plot after integration, can be activated
C     as a result of wanting to see bad spots
C
C**        IF (PLRESID) THEN 
          ITXVECT(NRESID*5+1) = IXPIX
          ITXVECT(NRESID*5+2) = IYPIX
          ITXVECT(NRESID*5+3) = NINT(DELX)
          ITXVECT(NRESID*5+4) = NINT(DELY)
          ITXVECT(NRESID*5+5) = MIN(ISPOT/100,32767)
          NRESID = NRESID + 1   
C**        END IF
C
        IF (ISPOT.LT.IRANGE(3)) GO TO 720
C
C
        IXX = XX - XCEN
        IYY = YY - YCEN
C
C            ****************************************
        CALL XYSHIFT(DELX,DELY,IXX,IYY,XSH,YSH,NSH,1)
C            ****************************************
C
  720   MAXBSI = MAX(MAXBSI,ISPOTPRO)
        MINBSI = MIN(MINBSI,ISPOTPRO)
C
C---- Background point rejection histogram
C
        NNREJ = NREJ + NBREJ
        II = (NNREJ-1)/5 +2
        IF (NNREJ.EQ.0) II = 1
        IF (II.GT.31) II = 32
        NBGRHIST(II) = NBGRHIST(II) + 1
C
C---- Check for BADSPOTS only if using input error factor
C
 725    IF (ERRSET) THEN
C
C  Test gradient/(average background), flag if more than GRADMAX
C
          IF (C.GT.0.0) THEN
            GRADBAD = ((ABS(A/C).GT.GRADMAX).OR.(ABS(B/C).GT.GRADMAX))
          ELSE
            GRADBAD = .FALSE.
          END IF
C
          IBAD = 0
C
C---- Test EDGEFIT first, because in ADSC Q210 images there are zero value
C     pixels (ie EDGEFIT) in the middle of overloaded spots. These should be
C     clasified as overloads rather than edge spots.
C     The code below means that if a reflection both has a pixel .LE.NULLPIX
C     (ie is classified as "on edge") AND has overloads, it will ONLY be
C     classified as an overload and not as an edge.
C
          IF (EDGEFIT) THEN
            IBAD = 32
            IGFLAG(IRECG) = -IBAD
          END IF
C
          IF (OVRLFIT) THEN
            IBAD = 16
            IGFLAG(IRECG) = -IBAD
          END IF
C
          IF ((BGRATIO.GT.BGRAT) .OR. (ISPOTPRO.LT.-5*ISIGPRO) .OR.
     +      (PKRATIOS.GT.PKRAT) .OR. (GRADBAD) .OR. LBADBG) THEN
CAL     +       LDUMP) THEN
C
            NBAD = NBAD + 1
            IF (BGRATIO.GT.BGRAT) IBAD = IBAD + 1
            IF (PKRATIOS.GT.PKRAT) IBAD = IBAD + 2
            IF (ISPOTPRO.LT.-5*ISIGPRO) IBAD = IBAD + 4
            IF (GRADBAD) IBAD = IBAD + 8
            IF (LBADBG) THEN
              IBAD = 64
              LBADBG = .FALSE.
            END IF
C
C---- Assign IBADP which sets the warning message printed
C
            IBADP = IBAD
            IF (IBAD.EQ.64) THEN
              IBADP = 16
            ELSE IF (IBAD.GT.32) THEN
              IBADP = IBADP - 32
            ELSE IF (IBADP.GT.16) THEN
              IBADP = IBADP - 16
            END IF
cal            IF (IBADP.GT.16) IBADP = IBADP - 16
C
C---- Store "bad" flag in IGFLAG
C
CAL            IF (IBAD.NE.16) IGFLAG(IRECG) = -IBAD

            IGFLAG(IRECG) = -IBAD
C
C---- If online, write badspots to unit 46 for inspection later
C
            IF (ONLINE) THEN
              WRITE (46) KREC,ISPOTPRO,ISIGPRO,JBGND,RMSBG,BGRATIO,
     +                   PKRATIOS,NXY,NXX,NYY,A,B,C,IBADP
              WRITE (46) (OD(II),II=1,NXY)
              IF (DEBUG(18)) WRITE (ITOUT,FMT=6118) KREC,ISPOTPRO,
     +          ISIGPRO,JBGND,RMSBG,BGRATIO,PKRATIOS,NXY,NXX,NYY
            END IF
C
C---- If running in batch mode, flag bad spots as rejected
C
C
              IF (NBAD.EQ.1) THEN
                IF (ONLINE ) WRITE (ITOUT,FMT=6132)
                WRITE (IOUT,FMT=6132)
 6132           FORMAT (/1X,'List of BADSPOTS',/,1X,'INT and SD'
     +           ,' are the profile fitted intensity and sigma.',/,1X,
     +           'A,B,C are the background plane constants. M/100 is',
     +           ' the degree of partiality',/,1X,'(M=0 for fully ',
     +           'recorded). XS, YS are scanner coordinates in pixels',
     +           ' wrt origin',/,1X,'at the first pixel in the image.'
     +          ,/,1X,'BADSPOTS will be written to the output MTZ ',
     +          'file, but will be flagged and will be',/,1X,
     +          ' rejected by SCALA by default.')
                IF ((BADPLOT).OR.(BADPLOT2)) THEN
                  WRITE(IOUT,6133)
                  IF (ONLINE) WRITE(ITOUT,6133)
                END IF
                WRITE (IOUT,FMT=6130)
                IF (ONLINE) WRITE (ITOUT,FMT=6130)
 6130           FORMAT ('    H   K   L   M     XG       YG    XS    ',
     +                  'YS    INT   SD  BGRATIO PKRATIO PLANE A      ',
     +                  'B      C')
 6133           FORMAT(1X,'The pixel values for each badspot will be ',
     +              'printed, with scanner X axis across the page ',/
     +              ,1X,'and scanner Y up the page, origin in lower ',
     +              'left corner')
                IF(SOCKLO)THEN
                  WRITE(XMLLINE,FMT=7000)ID
                  CALL WRITE_SOCKET_SECTION(SERVERFD,LENSTR(XMLLINE),
     $                 XMLLINE)
 7000             FORMAT('<?xml version="1.0"?>',
     $                 '<!DOCTYPE bad_spots_response>',
     $                 '<bad_spots_response>',
     $                 '<image_number>',I6,'</image_number>',
     $                 '<bad_spot_list>')
                ENDIF
              END IF
C
C                ****************
              CALL GETHKL(IRECG,IH)
C                ****************
C                  
              XCG = XG(IRECG)
              YCG = YG(IRECG)
              CALL MMTOPX(XC,YC,XCG,YCG)
              IXPIX = NINT(XC*FACT)
C
C---- Allow for switch inversion right to left of Mar images
C
              IF (INVERTX) IXPIX = NREC - IXPIX + 1
              IYPIX = NINT(YC*FACT)
              WRITE (IOUT,FMT=6134) (IH(II),II=1,4),XG(IRECG),YG(IRECG),
     +          IXPIX,IYPIX,ISPOTPRO,ISIGPRO,BGRATIO,PKRATIOS,A,B,C,
     +          BADSTR(IBADP)
              IF (ONLINE) WRITE(ITOUT,FMT=6134) 
     +          (IH(II),II=1,4),XG(IRECG),YG(IRECG),
     +          IXPIX,IYPIX,ISPOTPRO,ISIGPRO,BGRATIO,PKRATIOS,A,B,C,
     +          BADSTR(IBADP)
              IF(SOCKLO)THEN
                WRITE(XMLLINE,FMT=7010)
     $          IXPIX,IYPIX,(IH(II),II=1,3),
     $          ISPOTPRO,ISIGPRO,BGRATIO,PKRATIOS,A,B,C,
     $          BADSTR(IBADP)(1:LENSTR(BADSTR(IBADP)))
                CALL WRITE_SOCKET_SECTION(SERVERFD,LENSTR(XMLLINE),
     $               XMLLINE)
 7010           FORMAT('<bad_spot>',
     $               '<image_coordinates>',
     $               '<x_coordinate>',I6,'</x_coordinate>',
     $               '<y_coordinate>',I6,'</y_coordinate>',
     $               '<units>pixels</units>',
     $               '</image_coordinates>',
     $               '<miller_indices>',
     $               '<index_h>',I4,'</index_h>',
     $               '<index_k>',I4,'</index_k>',
     $               '<index_l>',I4,'</index_l>',
     $               '</miller_indices>',
     $               '<intensity>',I9,'</intensity>',
     $               '<sigma>',I8,'</sigma>',
     $               '<background_ratio>',F8.1,'</background_ratio>',
     $               '<peak_ratio>',F8.1,'</peak_ratio>',
     $               '<background_slope>',
     $               '<a_slope>',F7.1,'</a_slope>',
     $               '<b_slope>',F7.1,'</b_slope>',
     $               '<c_slope>',F7.1,'</c_slope>',
     $               '</background_slope>',
     $               '<summary>',A,'</summary>',
     $               '</bad_spot>')
              ENDIF
C
              IF (BADPLOT) THEN
                WRITE(IOUT,FMT=6135)
                IF (ONLINE) WRITE(ITOUT,FMT=6135)
 6135           FORMAT(1X,'Pixel values for this spot')
                MAXPIX = 0
                CALL ODPLOT4(OD,NXX,NYY,1,MAXPIX)
                WRITE(IOUT,6137)
                IF (ONLINE) WRITE(ITOUT,6137)
 6137           FORMAT(//)
                WRITE(IOUT,6130)
                IF (ONLINE) WRITE(ITOUT,6130)
              END IF
              IF (BADPLOT2) THEN
                IF (VARPRO) THEN
                  WRITE(IOUT,7163)(IPRNUM(J),J=1,4),(WTPR(J),J=1,4),
     +               LMASKREJ(1),MASKREJP(1,NPBOX),
     +                MASKREJO(1),LMASKREJP(1),SUMPQ(5,NY)
                  IF (ONLINE) WRITE(ITOUT,7163) (IPRNUM(J),J=1,4),
     +                (WTPR(J),J=1,4),LMASKREJ(1),MASKREJP(1,NPBOX),
     +                 MASKREJO(1),LMASKREJP(1),SUMPQ(5,NY)
C              ****************************************************
                  CALL PLOTPROF(OD,IPROFL(1,IWTBOX),LRAS,
     +                   LMASK,PROFSUMS(1,IWTBOX),WPROFSUMS(1,IWTBOX),
     +                   MASKREJO,MASKREJP(1,NPBOX),LMASKREJP,WEIGHT,
     +                   PKONLY)
C              ****************************************************
                ELSE
C              ****************************************************
                  CALL PLOTPROF(OD,IPROFL(1,NPBOX),LRAS,
     +                MASK(1,NY),PROFSUMS(1,NPBOX),WPROFSUMS(1,NPBOX),
     +                MASKREJO,MASKREJP(1,NPBOX),LMASKREJP,WEIGHT,
     +                   PKONLY)
C              ****************************************************
C
                END IF
              END IF
          END IF
        END IF
C
C
        GO TO 770
C
C---- Summed partials with only one half
C
 738    NHALF = NHALF + 1
        GOTO 760
 740    NEDGE = NEDGE + 1
 760    INTG(IRECG) = -9999
        ISDG(IRECG) = -9999
        IPRO(IRECG) = -9999
        ISDPRO(IRECG) = -9999
        IGFLAG(IRECG) = -128
 770    CONTINUE
        IF (LDUMP) THEN
          DO 773 K = 1,100
            NDEBUG(K) = NDEBUGS(K)
            DEBUG(K) = SDEBUG(K)
 773      CONTINUE
          LDUMP = .FALSE.
        END IF
C ********************************************************************
C ********************************************************************
C
C---- End of loop over reflections
C
C ********************************************************************
C ********************************************************************
 772  CONTINUE
C
C---- Calculate the rms c. of g. shift (unweighted and weighted by intensity)
C
      IF(SOCKLO.AND.NBAD.GT.0)THEN
        WRITE(XMLLINE,FMT=7020)
        CALL WRITE_SOCKET_LENGTH(SERVERFD,LENSTR(XMLLINE),
     $       XMLLINE)
 7020   FORMAT('</bad_spot_list>',
     $       '</bad_spots_response>')
      ENDIF
      DO 780 JBOX = 1,NUMBOX
         NRFP = NCGSP(JBOX)
         IF (NRFP.GT.0) THEN
cdms05.1999   Add checks for zeroes in denom.
           XWTEMP=XCGSP(JBOX)/NRFP
           IF (XWTEMP.GT.0.0) THEN
             XCGRMS=SQRT(XWTEMP)
           ELSE
             XCGRMS=0.0
           ENDIF
           YWTEMP=YCGSP(JBOX)/NRFP
           IF (YWTEMP.GT.0.0) THEN
             YCGRMS=SQRT(YWTEMP)
           ELSE
             YCGRMS=0.0
           ENDIF
           IF (WCGSP(JBOX).NE.0.0) THEN
             XWTEMP=XWCGSP(JBOX)/(NRFP*WCGSP(JBOX))
             IF (XWTEMP.GT.0.0) THEN
               XWCGRMS=SQRT(XWTEMP)
             ELSE
               XWCGRMS=0.0
             ENDIF
             YWTEMP=YWCGSP(JBOX)/(NRFP*WCGSP(JBOX))
             IF (YWTEMP.GT.0.0) THEN
               YWCGRMS=SQRT(YWTEMP)
             ELSE
               YWCGRMS=0.0
             ENDIF
           ELSE
             XWCGRMS=0.0
             YWCGRMS=0.0
           ENDIF
         ELSE
           XCGRMS = 0.0
           YCGRMS = 0.0
         END IF
         IF (DEBUG(18)) THEN
           WRITE(IOUT,FMT=6111) JBOX,NRFP,XCGRMS,YCGRMS,
     +                        XWCGRMS,YWCGRMS
           IF (ONLINE) WRITE(ITOUT,FMT=6111) JBOX,NRFP,
     +                    XCGRMS,YCGRMS,XWCGRMS,YWCGRMS
 6111    FORMAT(/,1X,'Box number, nrefls, unweighted and weighted',
     +     ' (by intensity) rms DELX, DELY',/,1X,2I6,4F8.1)
         END IF
 780   CONTINUE
C
C---- Calculate mean number of rejected background pixels as a fraction
C     of the mean number of background points, and compare with fraction
C     expected from a normal distribution.
C
      IF (NREJSUM.GT.0) THEN
        SUMREJ = SUMREJ/REAL(NREJSUM)
        SUMBG = SUMBG/REAL(NREJSUM)
        IF (BGSIG.LE.0.3) THEN
          FRAC =0.80
        ELSE IF (BGSIG.LE.0.5) THEN
          FRAC = 0.62
        ELSE IF (BGSIG.LE.0.7) THEN
          FRAC = 0.48
        ELSE IF (BGSIG.LE.1.0) THEN
          FRAC = 0.32
        ELSE IF (BGSIG.LE.2.0) THEN
          FRAC = 0.045
        ELSE IF (BGSIG.LE.3.0) THEN
          FRAC = 0.0028
        ELSE 
          FRAC = 0.002
        END IF
        WARN(17) = (WARN(17).OR.(SUMREJ.GT.FRAC*SUMBG))
      END IF
C---- Calculate instrument error correction. Can only do this if there are
C     some fully recorded reflections present. With a large mosaic spread
C     (and using ADDPART) the LAST image, which cannot add partials from the 
C     next image, may have no fully recorded reflections. Trap this and set
C     detector error to zero.
C
C
C---- If all fully recorded reflections have been rejected (as badspots)
C     then BSUM will be zero. Trap this.
C
      IF ((NOFR.GT.0).AND.(BSUM.GT.0.0)) THEN
        ERRINST = ASUM/BSUM
C                     
C  If the gain or Selwyn granularity has been overestimated, it is possible
C  for the variance in the fit of the profile to a reflection to be
C  smaller than that expected, calculated on the basis of the granularity or
C  counting statistics ie the profiles will fit better than expected. 
C  This will result in an apparently negative detector error factor. 
C  Hence the need to check the sign of ERRINST. Also when processing very 
C  weak data, it can calculate as negative. Do NOT allow the scanner erro
C  factor to go negative, set it to zero and print a warning.
C
        X = SQRT(ABS(ERRINST))
        IF (ERRINST.LT.0.0) X = -X
        EFACSQ = X
      ELSE
C
C---- No fully recorded reflections, set ERRINST to zero
C
        ERRINST = 0.0
        X = 10000.0
        WRITE(IOUT,FMT=6150)
        IF (ONLINE) WRITE(ITOUT,FMT=6150)
 6150   FORMAT(1X,'**** WARNING ****',/,1X,'There are no fully ',
     +   'recorded non-rejected reflections so the detector error',
     +    /,1X,'factor cannot be calculated')
      END IF 
C
C
      IF (EFAC.LT.-900) THEN
C
C---- Use calculated value unless negative
C           
        IF (X.EQ.10000.0) THEN
          WRITE(IOUT,FMT=6154)
          IF (ONLINE) WRITE(ITOUT,FMT=6154)
 6154     FORMAT(1X,'The detector error factor will be set to zero')
        ELSE IF (X.GT.0.0) THEN
          WRITE (IOUT,FMT=6112) X
 6112 FORMAT (/1X,'Calculated detector error factor',F6.2)
          IF (ONLINE) WRITE (ITOUT,FMT=6112) X
        ELSE IF (X.LT.0.0) THEN
          WRITE (IOUT,FMT=6152) X
 6152 FORMAT (/1X,'detector error factor has been calculated as',F6.2,
     +      /,1X,'Negative values are physically unreasonable, so it',
     +      ' has been set to zero')
          IF (ONLINE) WRITE (ITOUT,FMT=6152) X
          ERRINST = 0.0
        END IF
      ELSE
C
C---- Use input value but print calculated value
C
        IF (X.EQ.10000.0) THEN
          WRITE(IOUT,FMT=6156) EFAC
          IF (ONLINE) WRITE(ITOUT,FMT=6156) EFAC
 6156     FORMAT(1X,'The input detector error factor of ',F5.2,' will ',
     +              'be used')
        ELSE
          WRITE (IOUT,FMT=6114) X,EFAC
 6114 FORMAT (/1X,'Calculated detector error factor is ',F4.2,' but',
     +       ' input value of ',F5.2,' will be used')
          IF (ONLINE) WRITE (ITOUT,FMT=6114) X,EFAC
          ERRINST = EFAC*EFAC
        END IF
      END IF
C
C
        IF (NSUMR.NE.0) THEN
          PKRATIOS = PKREJS/NSUMR
          WRITE(IOUT,FMT=7166) NSUMR,PKRATIOS
          IF (ONLINE) WRITE(ITOUT,FMT=7166) NSUMR,PKRATIOS
7166  FORMAT(1X,I5,' Reflections with a mean PKRATIO (uncorrected ',
     +   'for detector error) of ',F5.1,/,1X,'have been rejected as ',
     +   'outliers in the determination of the detector error')
        END IF
C
C---- Using calculated value for ERRINST, recalculate sigmas and PKRATIO
C     if required
C
      IF (ERRSET) GOTO 805
C
C
      DO 800 I = 1,NREF
C
        IF (MOD(I,250).EQ.0.AND.WINOPEN) CALL MXD_FLU(I)
C
        OVRLFIT = .FALSE.
        KREC = IPNTR(I)/100
        IPNT = ABS(IPNTR(I))
        IRECG = IPNT/100
C
C---- Omit summed partials which have been subsequently flagged as
C     spatial overlaps
C
        IR = IRG(IRECG)
        IF (IR.EQ.2) THEN
          IF (DEBUG(18)) THEN
            CALL GETHKL(IRECG,IH)
            WRITE(IOUT,FMT=6030) (IH(K),K=1,3), IRECG
            IF (ONLINE) WRITE(ITOUT,FMT=6030) (IH(K),K=1,3), IRECG
          END IF
          GOTO 800
        END IF
C
C---- skip reflections not processed above because of MINT test.
C     these are flagged by IGFLAG()=0
C
        IF (IGFLAG(IRECG).EQ.0) GO TO 800
C
C
        ISDBSI = ISDG(IRECG)
C                                          
C---- Skip overloads(unles fitted with profiles), off edge
C
        IF (ISDBSI.EQ.-9999) GO TO 800
C
C---- Reflections with too many background pixels rejected
        IF (ISDBSI.EQ.-8888) THEN
          LDUMP = .TRUE. 
          ISPOT = 0
          ISDBSI = 0
          BGRATIO = 0.0
          PKRATIOS = 0.0
          A = 0.0
          B = 0.0
          C = 0.0
          GOTO 802         
        END IF
C
C---- Extract number required for sigma calculation
C
        TPEAK = NPEAK(I)
C
C
        IF (TPEAK.EQ.0.0) THEN
          IF (ONLINE) WRITE (ITOUT,FMT=6116) I,IRECG,ISDBSI,
     +        IGFLAG(IRECG)
 6116 FORMAT (/1X,'ZERO TPEAK, I,IRECG',2I6,' ISDBSI',I7,'  IGFLAG',I6)
          WRITE (IOUT,FMT=6116) I,IRECG,ISDBSI,IGFLAG(IRECG)
        END IF
C
C
        RMSBG = RMSBGX(I)
        VBG = TPEAK*RMSBG*RMSBG
        BGND = BGNDX(I)
        JBGND = SCAI*BGND + 0.5
C *** change to counting statistics
C        BGRATIO = RMSBG/SQRT(QFAC*BGND/TPEAK)
        IF (BGND.NE.0.0) BGRATIO=RMSBG/SQRT(GAIN*BGND/TPEAK)
        SOD = INTG(IRECG)/SCAI
        PEAKVAR = (ISDBSI/SCAI)**2
        NPBOX = MOD(IPNT,100)
        FULL = (IPNTR(I).GT.0)
        ISPOT = INTG(IRECG)
        ISPOTPRO = IPRO(IRECG)
        ISIGPRO = ISDPRO(IRECG)
CC
C
C---- Extract background plane constants
C
          II = IABC(I)               
          IC = II/10000
          IB = (II-10000*IC)/100
          A = (II-10000*IC-100*IB) -45
          B = IB -45       
          C = IC
        ABSSOD = ABS(SOD)
        XX = (ABSSOD/BOXFAC)**2*TPEAK
C
C
C---- If ERRINST calculates as negative (possible if
C     granularity has been overestimated, see above)
C     must trap -ve sqrt
C        isdbsi = sqrt(2.0*vbg+qfac*sod+errinst*xx)*scai + 0.5
C
C *** change to counting statistics
C
C        VARTOT = 2.0*VBG + QFAC*SOD + ERRINST*XX
        IF (TBGND.NE.0) VARTOT=GAIN*(ABSSOD+BGND+BGND*TPEAK/TBGND)
     1     + ERRINST*XX
        IF (VARTOT.LE.0.0) VARTOT = 0
        ISDBSI = SCAI*SQRT(VARTOT) + 0.5
        ISDBSI = MAX(ISDBSI,1)
        IF (ISDBSI.GT.32767) THEN
          ISDBSI = 32700
CAL           CALL GETHKL(IRECG,IH)
CAL        WRITE (IOUT,FMT=6117) ISDBSI,(IH(K),K=1,3)
CAL           IF (ONLINE) WRITE (ITOUT,FMT=6117) ISDBSI,(IH(K),K=1,3)
 6117 FORMAT(//1X,'**** SERIOUS ERROR ****',/,1X,' The standard ',
     +    'deviation of the integrated intensity is',I10,/,1X,
     +    'which is greater than the maximum allowed value (32767)',
     +    'Something is seriously wrong',/,1X,'h,k,l',3I5)
CAL           WRITE(IOUT,FMT=6109) SQRT(ERRINST)
CAL           IF (ONLINE) WRITE(ITOUT,FMT=6109) SQRT(ERRINST)
CAL           CALL SHUTDOWN(CALLEDFROM,LENSTR(CALLEDFROM))
        END IF
        ISDG(IRECG) = ISDBSI
C
        IPART = IMG(IRECG)
C---- For partials,reflections where profile was rejected, and
C     profile fitted overloads, use summation integration sigma in
C     place of profile fitted sigma. Set OVRLFIT so that fully recorded
C     overloads or fitted edge reflections are not included in PKRATIOS 
C     statistics in call to STATS.
C
        IF (.NOT.FULL .OR. ISIGPRO.EQ.7777) THEN
          OVRLFIT = .TRUE.
          ISIGPRO = ISDBSI
          ISDPRO(IRECG) = ISIGPRO
        END IF
C
C---- PKRATIO is ratio of sigma calculated from selwyn granularity
C     to that calculated from fit of profile. Only applicable to
C     full reflections.
C     Calculate PKRATIO
C
        IF (FULL) THEN
C
C---- If ERRINST calculates as negative (possible if
C     granularity has been overestimated, see above)
C     must trap -ve sqrt and divide by zero
C                                               
C      pkratios = sqrt(peakvar/ (qfac*bgnd+qfac*sod+errinst*xx))
C
C *** change to counting statistics
C          VARTOT = QFAC*BGND + QFAC*SOD + ERRINST*XX
          VARTOT = (GAIN*(BGND+ABSSOD)+ERRINST*XX)
          IF (VARTOT.LE.1.0) VARTOT = 1.0
          PKRATIOS = SQRT(PEAKVAR/VARTOT)
C
C---- For Mar mosaic detector on BM14, PKRATIO is too large for many
C     fully recorded spots. Origin of this is not clear. For present,
C     simply divide by 3.0
C
          IF ((MACHINE.EQ.'MARC').AND.
     $         ((MODEL.EQ.'MOSAIC3').OR.(MODEL.EQ.'MOSAIC4')))
     +       PKRATIOS = 0.333*PKRATIOS
      ELSE
          PKRATIOS = 0.0
      END IF
C
C
C---- Modify IPART if adding partials (ADDPART). If IR=5 this is a
C     partial over 3 images and this is the first, so IPART is correct.
C     If IR=6, this is a partial over 3 images and this is the summed
C     contribution from images 2 and 3, and cannot be used in analysis
C     because we don't know its degree of partiality
C
      IF (ADDPART) THEN
        IF (IR.LT.5) THEN
          IPART = 0
        ELSE IF (IR.EQ.6) THEN
          IPART = -999
        END IF
      END IF
      CALL GETBIN(IRECG,ITHBIN,NBIN1,DSTSQ)
      CALL STATS(ISPOT,ISDBSI,ISPOTPRO,ISIGPRO,BGRATIO,
     +           PKRATIOS,NPBOX,IPART,FULL,OVRLFIT,ITHBIN)
C
        IF (DUMPSPOT) THEN
C
C---- Compare indices with list in IHD, set LDUMP true if match found
C
C              **************************
          CALL COMPR(KREC,IHD,LDUMP,NHKLD)
C              **************************
C
C---- Uncomment next 2 lines if full debugoutput required when scanner
C     factor not initially assigned.
CAL          IF (DUMPALL.AND.(I.GE.NDSTART).AND.((I-NDSTART).LE.NDTOT))
CAL     +      LDUMP = .TRUE.
        END IF
C
C---- Test for badspots
C
C
C  Test gradient/(average background), flag if more than GRADMAX
C
          IF (C.GT.0.0) THEN
            GRADBAD = ((ABS(A/C).GT.GRADMAX).OR.(ABS(B/C).GT.GRADMAX))
          ELSE
            GRADBAD = .FALSE.
          END IF
C
          IBAD = 0
          IF (OVRLFIT) THEN
            IBAD = 16
            IGFLAG(IRECG) = -IBAD
          END IF

 802      IF ((BGRATIO.GT.BGRAT) .OR. (ISPOTPRO.LT.-5*ISIGPRO) .OR.
     +      (PKRATIOS.GT.PKRAT) .OR. (GRADBAD) .OR.
     +       LDUMP) THEN
C
C---- Write badspots to unit 46 if running online. Note we no longer
C     have option of dumping pixel values
C
          LDUMP = .FALSE.
C                                   
          NBAD = NBAD + 1
            IF (BGRATIO.GT.BGRAT) IBAD = IBAD + 1
            IF (PKRATIOS.GT.PKRAT) IBAD = IBAD + 2
            IF (ISPOTPRO.LT.-5*ISIGPRO) IBAD = 4
            IF (GRADBAD) IBAD = IBAD + 8
            IF (IBAD.EQ.0) THEN
              IBADP = 16
            ELSE
              IBADP = IBAD
            END IF
            
C
C---- Store "bad" flag in IGFLAG
C
            IGFLAG(IRECG) = -IBAD
C
          IF (ONLINE) THEN
            WRITE (46) KREC,ISPOTPRO,ISIGPRO,JBGND,RMSBG,BGRATIO,
     +        PKRATIOS,NXY,NXX,NYY,A,B,C,IBADP
            IF (DEBUG(18)) WRITE (ITOUT,FMT=6118) KREC,ISPOTPRO,
     +          ISIGPRO,JBGND,RMSBG,BGRATIO,PKRATIOS,NXY,NXX,NYY
 6118 FORMAT (1X,4I6,3F5.1,3I5)
          ELSE
C
C---- If running in batch mode, flag bad spots as rejected
C
            IF (NBAD.EQ.1) THEN
              WRITE (IOUT,FMT=6132)
              WRITE (IOUT,FMT=6130)
              WRITE (IOUT,FMT=6139)
 6139         FORMAT(1X,'Note that gradients greater than 45 will be',
     +                   ' printed as 45')
            END IF
C
C                ****************
            CALL GETHKL(IRECG,IH)
C                ****************
C                  
            XCG = XG(IRECG)
            YCG = YG(IRECG)
            CALL MMTOPX(XC,YC,XCG,YCG)
            IXPIX = NINT(XC*FACT)
            IYPIX = NINT(YC*FACT)
            WRITE (IOUT,FMT=6134) (IH(II),II=1,4),XG(IRECG),YG(IRECG),
     +        IXPIX,IYPIX,ISPOTPRO,ISIGPRO,BGRATIO,PKRATIOS,A,B,C,
     +        BADSTR(IBADP)
 6134 FORMAT (1X,4I4,2F8.1,2I6,I7,I6,2F8.1,2X,3F7.1,1X,A)
C
C---- Reject the profile fitted I under all circumstances
C
C**              ISDPRO(IRECG) = -9999
C
C---- Do not reject the summation integration value if failure is only on
C     PKRATIO, unless PKREJECT flag set, in which case, do reject it.
C
C**             IF ((BGRATIO.GT.BGRAT) .OR. (ISPOTPRO.LT.-5*ISIGPRO) .OR.
C**     +          (GRADBAD).OR. ((PKRATIOS.GT.PKRAT).AND.PKREJECT))
C**     +           ISDG(IRECG) = -9999

          END IF
        END IF
C
C
C ********************************************************************
C ********************************************************************
C---- End of second pass through reflections
C
C ********************************************************************
C ********************************************************************
  800 CONTINUE
C
C---- Update NREF to allow for those rejected by MINT test (see above)
C
 805  NREF = NREF - NMINTR
C
C---- Calculate averages for intensity analysis
C
      DO 810 I = 1,10
        IF (IANAL(I).EQ.0) GO TO 810
        RATIO(I) = RATIO(I)/IANAL(I)
        AVSD(I) = AVSD(I)/IANAL(I)
        AVSDP(I) = AVSDP(I)/IANAL(I)
        IF (IANALF(I).EQ.0) GO TO 810
        PKRATIO(I) = PKRATIO(I)/IANALF(I)
  810 CONTINUE
C
C
C---- Calculate averages for I/sigma analysis
C
      DO 811 I = 1,9
        IF (I.LE.8) THEN
          FIOVSDP(9) = FIOVSDP(9) + FIOVSDP(I)
          FIOVSDS(9) = FIOVSDS(9) + FIOVSDS(I)
          PIOVSDP(9) = PIOVSDP(9) + PIOVSDP(I)
          PIOVSDS(9) = PIOVSDS(9) + PIOVSDS(I)
          IRESPF(9) = IRESPF(9) + IRESPF(I)
          IRESPP(9) = IRESPP(9) + IRESPP(I)
          IRESSF(9) = IRESSF(9) + IRESSF(I)
          IRESSP(9) = IRESSP(9) + IRESSP(I)
          ISDRESPF(9) = ISDRESPF(9) + ISDRESPF(I)
          ISDRESPP(9) = ISDRESPP(9) + ISDRESPP(I)
          ISDRESSF(9) = ISDRESSF(9) + ISDRESSF(I)
          ISDRESSP(9) = ISDRESSP(9) + ISDRESSP(I)
          NRESPF(9) = NRESPF(9) + NRESPF(I)
          NRESPP(9) = NRESPP(9) + NRESPP(I)
          NRESSF(9) = NRESSF(9) + NRESSF(I)
          NRESSP(9) = NRESSP(9) + NRESSP(I)
        END IF
C
C---- Profile full
C
        N = NRESPF(I)
        IF (N.NE.0) THEN
          FIOVSDP(I) = FIOVSDP(I)/N
          IRESPF(I) = IRESPF(I)/N
          ISDRESPF(I) = ISDRESPF(I)/N
        END IF
C
C---- Profile partial
C
        N = NRESPP(I)
        IF (N.NE.0) THEN
          PIOVSDP(I) = PIOVSDP(I)/N
          IRESPP(I) = IRESPP(I)/N
          ISDRESPP(I) = ISDRESPP(I)/N
        END IF
C
C---- Summation integration full
C
        N = NRESSF(I)
        IF (N.NE.0) THEN
          FIOVSDS(I) = FIOVSDS(I)/N
          IRESSF(I) = IRESSF(I)/N
          ISDRESSF(I) = ISDRESSF(I)/N
        END IF
C
C---- Summation integration partial
C
        N = NRESSP(I)
        IF (N.NE.0) THEN
          PIOVSDS(I) = PIOVSDS(I)/N
          IRESSP(I) = IRESSP(I)/N
          ISDRESSP(I) = ISDRESSP(I)/N
        END IF
  811 CONTINUE
C          ******************************
      CALL REPORT(ID,NUMBOX,USEOVRLD)
      CALL XYSHIFT(0.0,0.0,0,0,XSH,YSH,NSH,2)
C          ******************************
C
C---- If running from new gui, allow for an "abort" here, which is
C     immediately after the integration response has been written by REPORT.
C
      XMLABORT = .FALSE.
      IF (SOCKLO.AND..NOT.XMLOPEN) THEN
        CALL READ_SOCKET(SERVERFD,LINE400,IFAIL)
CAL        read(5,fmt=8888) LINE
CAL 8888   format(a)
        IF (LINE400(1:5).EQ.'abort') XMLABORT = .TRUE.
      END IF   
C       
C-      
C
      REWIND 46  
      IF (ONLINE) WRITE (ITOUT,FMT=6120) NBAD
      IF (BRIEF) WRITE (IBRIEF,FMT=6120) NBAD
 6120 FORMAT (2X,'Number of bad spots =',I4)
      WRITE (IOUT,FMT=6120) NBAD
C
      IF (ONLINE) WRITE (ITOUT,FMT=6123) NBADPK
      IF (BRIEF) WRITE (IBRIEF,FMT=6123) NBADPK
 6123 FORMAT (2X,'Number of spots with rejected peak pixels due to',
     +          ' poor profile fit=',I4)
      WRITE (IOUT,FMT=6123) NBADPK
    
C
      IF (NBADBG.NE.0) THEN
        WARN(10) = (WARN(10).OR.(NBADBG.GT.5))
        IWARN(1,10) = MAX(IWARN(1,10),NBADBG)
        WRITE(IOUT,6121) NBADBG,NBGMIN
        IF (ONLINE) WRITE(ITOUT,6121) NBADBG,NBGMIN
        IF (BRIEF) WRITE(IBRIEF,6121) NBADBG,NBGMIN
 6121   FORMAT(/1X,I5,' Reflections rejected because fewer than',I3,
     +    ' background pixels left after rejection')
      END IF
C
      IF (NREXP.NE.0) THEN
        BGREXP = BGREXP/NREXP
        WRITE (IOUT,FMT=6122) NREXP,BGREXP
 6122 FORMAT (/1X,'Mean BGRATIO for the',I5,' Reflections whose raster',
     +       ' expansion has been suppressed is',F4.1)
        IF (ONLINE) WRITE (ITOUT,FMT=6122) NREXP,BGREXP
      END IF
C
C
      IF (NNOBOX.NE.0) THEN
        WRITE (IOUT,FMT=6124) NNOBOX
 6124 FORMAT (1X,I5,' Reflections not measured because there was no pr',
     +       'ofile for that measurement box')
        IF (ONLINE) WRITE (ITOUT,FMT=6124) NNOBOX
        IF (BRIEF) WRITE (IBRIEF,FMT=6124) NNOBOX
      END IF
C
C---- Skip badspot examination if in batch mode
C
      IF (.NOT.ONLINE) GO TO 860
C
C---- Badspot inspection  (online operation only)
C
      IF (NBAD.EQ.0) GO TO 860
      IF (LPAUSE) GOTO 818
      IF (WINOPEN) THEN
        IXM = 200
        IYM = 200
        LINELEN = 75
        NUMLIN = 6
C     
C     Create IO window
C
        CALL MXDCIO(0,LINELEN, NUMLIN, IXM,IYM)
        WRITE(LINE,FMT=6125) NBAD
 6125   FORMAT('There are',I5,' "bad" spots, which may be ',
     +          'reclassified manually')
        CALL MXDWIO(LINE,1)
        LINE = ' '
        LINE = 'using the "Bad spots" menu option'
        CALL MXDWIO(LINE, 1)
        LINE = ' '
        WRITE(LINE,FMT=6145)
 6145   FORMAT('Do you want reclassify or inspect bad spots (N):')
        CALL MXDWIO(LINE, 1)
        CALL MXDRIO(LINE2)
C
C---- Parse reply
C
C             ******************************************
        CALL MPARSE(LINE2,IBEG,IEND,ITYP,VALUE,IDEC,NTOK)
C             ******************************************
        IF (NTOK.EQ.0) THEN
          STR1 = 'N'
        ELSE
          STR1 = LINE2(IBEG(1):IEND(1))
          CALL CCPUPC(STR1)
        END IF
C
        YES = (STR1.EQ.'Y')
        IF (YES) THEN
          LPINTG = .TRUE.
          LINE = 'After integration'
          VALUESTR = ' '
          ITOG = 3
          IPPINTG = 45
          IVHPAR = 3
          CALL MXDPVL(IVHPAR, .TRUE., ITOG,LINE,
     +                IPPINTG,VALUESTR,IERR)

        END IF
        CALL MXDCIO(1,0,0,0,0)
        CALL MXD_FLU(I)
      ELSE
        IF (ONLINE) WRITE (ITOUT,FMT=6126)
        IF (BRIEF) WRITE (IBRIEF,FMT=6126)
 6126 FORMAT (2X,'Do you want to check BAD SPOTS(Y or N)? ',/,1X,
     +        'If Yes, then ALL badspots must be inspected ',$)
C
C          **********

      if((.not. nostop).and.(.not. socklo)) then
c      if(.not. socklo) then
         CALL YESNO(YES)
      else
         yes = .false.
      end if
      
C          **********
      END IF
C
      IF (LPINTG) GOTO 860
C
      IF (YES) GO TO 830
C
C----- Flag NBAD spots as rejected in generate file
C      and list them on for008 file
C
 818  WRITE (IOUT,FMT=6132)                         
      WRITE (IOUT,FMT=6130)
      IF (.NOT.ERRSET) WRITE (IOUT,FMT=6139)
C                       
C            
      DO 820 I = 1,NBAD
        READ (46) KREC,ISPOTPRO,ISIGPRO,JBGND,BGRMS,
     +            BGRATIO,PKRATIOS,NXY,NXX,NYY,A,B,C,IBAD
C
C  Pixel values only written out if ERRSET true
        IF (ERRSET) READ (46) (OD(II),II=1,NXY)
        IRECG = ABS(KREC)
C
C            ****************
        CALL GETHKL(IRECG,IH)
C            ****************
C
        XCG = IH(6)
        YCG = IH(7)
        CALL MMTOPX(XC,YC,XCG,YCG)
        IXPIX = NINT(XC*FACT)
C
C---- Allow for switch inversion right to left of Mar images
C
        IF (INVERTX) IXPIX = NREC - IXPIX + 1
        IYPIX = NINT(YC*FACT)
CAL        WRITE (IOUT,FMT=6134) (IH(II),II=1,4),XG(IRECG),YG(IRECG),
CAL     +                         IXPIX,IYPIX,ISPOTPRO,ISIGPRO,BGRATIO,
CAL     +                        PKRATIOS,A,B,C,BADSTR(IBAD)
C**        ISDG(IRECG) = -9999
C**        ISDPRO(IRECG) = -9999
  820 CONTINUE
C
      GO TO 860
C
C---- Allow inspection of individual badspots if scanner value assigned
C     (ERRSET) by keyword
C
  830 IMAP = 0
      WRITE (IOUT,FMT=6132)
      IF (ERRSET) THEN
        WRITE (ITOUT,FMT=6128)
        IF (BRIEF) WRITE (IBRIEF,FMT=6128)
 6128   FORMAT (2X,'Do you want a plot of each SPOT? ',$)
C
C          **********
        CALL YESNO(YES)
C          **********
C
        IF (YES) IMAP = 1
      ELSE
        WRITE(ITOUT,FMT=6129)
        IF (BRIEF) WRITE(IBRIEF,FMT=6129)
 6129   FORMAT(1X,'Inspection of pixel values of badspots is only',
     +     ' possible if ',/,1X,'the detector error has been assigned',
     +     ' a value (SCANNER keyword)')
      END IF
C
C
      N = 0
C
C
      DO 850 I = 1,NBAD
        READ (46) KREC,ISPOTPRO,ISIGPRO,JBGND,BGRMS,BGRATIO,
     +            PKRATIOS,NXY,NXX,NYY,A,B,C,IBAD
        IF (ERRSET) READ (46) (OD(II),II=1,NXY)
        IRECG = ABS(KREC)
C
C            ****************
        CALL GETHKL(IRECG,IH)
C            ****************
C
        XCG = IH(6)
        YCG = IH(7)
        CALL MMTOPX(XC,YC,XCG,YCG)
        IXPIX = NINT(XC*FACT)
        IF (BRIEF) WRITE (IBRIEF,FMT=6172)
        WRITE (ITOUT,FMT=6172)
 6172            FORMAT ('    H   K   L   M     XG       YG    XS    ',
     +                  'YS    INT   SD  BGRATIO PKRATIO')
        WRITE (IOUT,FMT=6130)
C
C---- Allow for switch inversion right to left of Mar images
C
        IF (INVERTX) IXPIX = NREC - IXPIX + 1
        IYPIX = NINT(YC*FACT)
        WRITE (IOUT,FMT=6134) (IH(II),II=1,4),XG(IRECG),YG(IRECG),
     +                         IXPIX,IYPIX,ISPOTPRO,ISIGPRO,BGRATIO,
     +                        PKRATIOS,A,B,C,BADSTR(IBAD)
        WRITE (ITOUT,FMT=6134) (IH(II),II=1,4),XG(IRECG),YG(IRECG),
     +                         IXPIX,IYPIX,ISPOTPRO,ISIGPRO,BGRATIO,
     +                        PKRATIOS
        WRITE(ITOUT,FMT=6174) A,B,C,BADSTR(IBAD)
 6174   FORMAT(1X,'Background plane constants',3F7.1,1X,A)
C
        IF (IMAP.EQ.0) GO TO 840
C
C            ****************************************
        CALL SETMASK(MASK(1,1),LRAS)
C        CALL RASPLOT(OD,NXX,NYY,MASK(1,1),IDR,ODSCAL)
        MAXPIX = 0
        CALL ODPLOT4(OD,NXX,NYY,1,MAXPIX)
C            ****************************************
C
  840   CONTINUE
        IF (ONLINE) WRITE (ITOUT,FMT=6136)
        IF (BRIEF) WRITE (IBRIEF,FMT=6136)
 6136 FORMAT (' Reject (Y or N)? ',$)
        WRITE (IOUT,FMT=6136)
C
C            **********
        CALL YESNO(YES)
C            **********
C
        IF (YES) WRITE (IOUT,FMT=6138)
 6138 FORMAT (' Y')
        IF (.NOT.YES) WRITE (IOUT,FMT=6140)
 6140 FORMAT (' N')
C
        IF (.NOT.YES) GO TO 850
C**        ISDPRO(IRECG) = -9999
C**        ISDG(IRECG) = -9999
  850 CONTINUE
C
C---- Write intensities etc back to generate file
C     modewr determines whether or not camera constants are also
C     written back to generate file
C
  860 MODEWR = 0                  
      IF (ACCUMULATE) MODEWR = 2
C
      IF (BRIEF) WRITE(IBRIEF,FMT=6141)
 6141 FORMAT(/,1X,'Writing intensities back to generate file')
C
C---- Determine if a resolution cutoff is to be applied because I/sigma(I)
C     is too small.
CAL   There is a problem of whether to apply this cutoff to fulls or partials,
C     because the I/sig(I) can be quite different. If it is allowed to change
C     between fulls and partials the simple interpolation below can give silly
C     results. Since there are generally far more (or at least as many) partials
C     as fulls, use these.

      STHCUT = 0.0
      IF (RESCUT.NE.0) THEN
        DO 862 I = 2,NBIN1
CAL       IF (NRESPF(I).GT.20) THEN
CAL         RAT1 = FIOVSDP(I-1)
CAL         RAT2 = FIOVSDP(I)
CAL       ELSE IF (NRESPP(I).GT.20) THEN
CAL         RAT1 = PIOVSDP(I-1)
CAL         RAT2 = PIOVSDP(I)
CAL       ELSE IF (NRESPF(I).GT.0) THEN
CAL         RAT1 = FIOVSDP(I-1)
CAL         RAT2 = FIOVSDP(I)
CAL       ELSE  IF (NRESPP(I).GT.0) THEN
CAL         RAT1 = PIOVSDP(I-1)
CAL         RAT2 = PIOVSDP(I)
CAL       ELSE 
CAL         GOTO 864
CAL       END IF
          IF (NRESPP(I).GT.0) THEN
            RAT1 = PIOVSDP(I-1)
            RAT2 = PIOVSDP(I)
          END IF
          IF ((RAT2.LT.RESCUT).AND.(RAT1.NE.0)) THEN
               X = 1.0
               IF (ABS(RAT1-RAT2).GT.0.001)
     1          X = (RAT1-RESCUT)/(RAT1-RAT2)
               DBIN1=1.0
               DBIN2=1.1
               IF (ABS(DBIN(I-1)).GT.0.001) DBIN1 = 1.0/(DBIN(I-1)**2)
               IF (ABS(DBIN(I)).GT.0.001) DBIN2 = 1.0/(DBIN(I)**2)
               STHCUT = DBIN1 + X*(DBIN2-DBIN1)
               GOTO 864
          END IF
 862    CONTINUE
      END IF
C
 864  IF (PRECESS) THEN
C
C            **********************
        CALL PWRGEN(MODEWR,PROFILE)
C            **********************
C
      ELSE
C
C            ****************************
        CALL WRGEN(MODEWR,PROFILE,ADDPART)
C
      END IF
C
C---- Close BADSPOTS file
C
      IF (ONLINE) CLOSE (UNIT=46)
C
      RETURN
      END
C== QUICKINT ==
C $Id: quickint.f,v 1.5 2010/01/05 11:57:30 andrew Exp $
C
C
      SUBROUTINE QUICKINT(OD,NXY,LISTPIX,PKRATIO,JDUMP)
      IMPLICIT NONE
C     =============================================
C
C---- Rapid evaluation of signal to noise in spot.
C     Find smallest pixel value (above zero), take this as
C     the background and calculate expected noise level based
C     on gain of detector. Use 9 peak pixels stored in LISTPIX
C     to get estimate of spot intensity, taking true background to
C     be 2.5*sigma above the lowest value
C
C    Algorithm changed 20/8/92 to deal better with cases where adjacent
C    spots intrude into background region.
C
C
C
C
C
C     .. Scalar Arguments ..
      REAL PKRATIO
      INTEGER JDUMP,NXY
C     ..
C     .. Array Arguments ..
      INTEGER LISTPIX(9),OD(*)
C     ..
C     .. Local Scalars ..
      REAL BG,PK,RMSBG,SUMPK
      INTEGER I,IJ,IOD,MINOD,MINVAL
C     ..
C     .. Intrinsic Functions ..
      INTRINSIC SQRT,REAL
C     ..
C     .. Common blocks ..
C&&*&& include  ../inc/debug.f
C
C $Id: debug.f,v 1.2 2008/07/24 09:42:21 andrew Exp $
C
C--- awk generated include file  debug.h
C---- START of include file debug.h
C
C
C
C     .. Arrays in common /DEBUG/ ..
      REAL XWARN
      INTEGER NDEBUG,IWARN
      LOGICAL DEBUG,LPRINT,DUMP,WARN
C
C     .. Scalars in common /DEBUG/ ..
      REAL BGRLIM
      INTEGER NDUMP,IDUMP,MXDUMP
      LOGICAL SPOT
C     
C     ..
C     .. Common Block /DEBUG/..
      COMMON /DEBUG/XWARN(20,100),BGRLIM,NDEBUG(100),IWARN(20,100),
     $       NDUMP,IDUMP,MXDUMP,DEBUG(100),LPRINT(20),DUMP(30),
     +       WARN(100),SPOT
C     ..
C
C&&*&& end_include  ../inc/debug.f
C&&*&& include  ../inc/ioo.f
C
C $Id: ioo.f,v 1.7 2009/05/13 11:57:53 harry Exp $
C
C--- awk generated include file  ioo.h
C---- START of include file ioo.h
C
C
C
C     .. Scalars in common block /IOO/ ..
      INTEGER IOUT,IUNIT,ITIN,ITOUT,INOD,INMO,IDU,NWRN,IBRIEF,ISUMMR,
     +        ICOORD,SERVERFD,SERVERFDIN,NSHUTERR,dnafd
      LOGICAL ONLINE,ONEFILE,FHEADER,BRIEF,GRAPH,IOERR,
     $     NODISPLAY,LBELL,JPGOUT,SOCKLO,LBEST,dnaout,INMOOPEN,
     $     XMLOPEN
      CHARACTER dna_image*80,xmlfile*80
C     ..
C     .. Common block /IOO/ ..
c      COMMON /IOO/IOUT,IUNIT,ONLINE,ITIN,ITOUT,INOD,INMO,IDU,NWRN,
c     +            ONEFILE,FHEADER,BRIEF,IBRIEF,GRAPH,ISUMMR,ICOORD,
c     +            IOERR,NODISPLAY,LBELL
C     ..
C
C
      COMMON /IOO/IOUT,IUNIT,ITIN,ITOUT,INOD,INMO,IDU,NWRN,IBRIEF,
     +        ISUMMR,ICOORD,SERVERFD,SERVERFDIN,NSHUTERR,ONLINE,ONEFILE,
     +        FHEADER,BRIEF,GRAPH,IOERR,NODISPLAY,LBELL,JPGOUT,
     $        SOCKLO,LBEST, dnafd, dnaout,INMOOPEN,XMLOPEN
      COMMON /CIOO/dna_image,xmlfile

C&&*&& end_include  ../inc/ioo.f
C&&*&& include  ../inc/lmb.f
C
C $Id: lmb.f,v 1.8 2009/01/08 18:03:14 harry Exp $
C
C--- awk generated include file  lmb.h
C---- START of include file lmb.h
C ODSCAL is to scale image numbers into the range 0-255 for plotting
C average profiles.
C  GAIN should be equal to the overall gain (image counts per X-ray photon)
C of the system, and is used to evaluate standard deviations based on
C counting statistics assuming independent pixels (ie point spread function
C less than pixel size).
C INVERTX true if image is inverted in the slow (X) direction when read in.
C ISCAL is to scale final integrated intensities and sigmas
C IDIVIDE is the adc offset
C ICONST is a constant to be added to all pixels (normally zero) to
C        allow processing of images with zero pixel values in the scanned
C        area.
C IMGP is true if working with image plate data
C SPIRAL is true for scanners with a spiral readout (Mar, DIP2000)
C ORTHOG is true for scanners with orthogonal scan (FUJI, RAXIS, MD)
C NULLPIX is the value of pixels within the image but not in the active
C area of the detector
C TILED is true if there are inactive areas of the detector within the
C       inscribing circle or square.
C
C NTILEX Number of tiles in X direction
C NTILEY Number of tiles in Y direction
C TILEX  X Coordinates of the midpoints of the null areas between tiles
C TILEY  Y Coordinates of the midpoints of the null areas between tiles
C TILEWX Width of the null areas between tiles in X
C TILEWY Width of the null areas between tiles in Y


C MACHINE and MODEL denote the type of detector. 
C
C MACHINE is used in the following subroutines:
C GETBLK, GETHDR, INTPXL, INTPXL2, MXDSPL, OPENODS, PROCESS, PUTPXL
C Currently coded types are:
C
C         MACHINE        MODEL               COMMENTS
C         =======        =====               ========
C         MAR            180, 300, 345
C         RAXI(S)        RAXISII, RAXISIV
C         MD
C         FUJI
C         CCD1           CCD1                Princetown CCD at CHESS,Tiff format
C         CCD2           CCD ?               ESRF CCD detector
C         ADSC           QUAD1               ADSC 2x2 CCD detector
C
C TRUSTED whether or not the image header information can be trusted for 
C         automatic processing
C     .. Scalars in Common Block /LMB/ ..
        REAL ODSCAL,GAIN,LOGA,LOGB
        INTEGER ISCAL,IDIVIDE,ICONST,NULLPIX,NTILEX,NTILEY,
     $    RAXISCOMP,IIDIVIDE,COMPRESSION
        LOGICAL IMGP,INVERTX,SPIRAL,ORTHOG,CIRCULAR,TILED,SETADC,
     $    NEWRAXIS,BRUKNEW,TRUSTED
        CHARACTER MACHINE*4,MODEL*8

C     ..
C     .. Arrays in common /LMB/
        INTEGER TILEX,TILEY,TILEWX,TILEWY
C
C     .. Common Block /LMB/ ..
        COMMON /LMB/ ODSCAL,GAIN,LOGA,LOGB,ISCAL,IDIVIDE,ICONST,
     +       NULLPIX,NTILEX,NTILEY,RAXISCOMP,IIDIVIDE,COMPRESSION,
     +       TILEX(20),TILEY(20),TILEWX(20),TILEWY(20),IMGP,
     +       INVERTX,SPIRAL,ORTHOG,CIRCULAR,TILED,SETADC,
     $       NEWRAXIS,BRUKNEW,TRUSTED
        COMMON /LMBC/ MACHINE,MODEL

C&&*&& end_include  ../inc/lmb.f
C              
C
      SAVE
C     ..
C
C
C---- Find smallest non-zero pixel and say this is background
C     Do not allow zero values (can occur with Pilatus images where
C     NULLPIX is -1 and bacvkground is very low)
C     AGWL 14Dec09
C
      MINOD = 999999
      MINVAL = MAX(0,NULLPIX)
      DO 10 I = 1,NXY
        IOD = OD(I)
        IF ((IOD.GT.MINVAL).AND.(IOD.LT.MINOD)) MINOD = IOD
   10 CONTINUE
C
C
      BG = REAL(MINOD)
      RMSBG = SQRT(GAIN*BG)
      BG = BG + 2.5*RMSBG
C
      SUMPK = 0.0
C
C
      DO 20 I = 1,9
        IJ = LISTPIX(I)
        SUMPK = OD(IJ) + SUMPK
   20 CONTINUE
C
C
      PK = SUMPK/9.0 - BG
      PKRATIO = 0.0
      IF (RMSBG.NE.0.0) PKRATIO = PK/RMSBG
C
C
      IF (DUMP(1).AND.(I/NDUMP)*NDUMP.EQ.I.AND.JDUMP.LE.MXDUMP)THEN
        WRITE (IOUT,FMT=6000) BG,PK,RMSBG
        IF (ONLINE) WRITE (ITOUT,FMT=6000) BG,PK,RMSBG
      END IF
C
C---- Format statements
C
 6000 FORMAT (1X,'IN QUICKINT BG=',F7.1,'  PK=',F10.1,'  RMSBG=',F6.1)
C
C
      END
C
C $Id: rdist.f,v 1.41 2009/11/05 17:44:41 harry Exp $
C
C== RDIST ==
      SUBROUTINE RDIST(IPACK,ID,NIMGSM,CENTRE,FINAL,WELIMIT,ELIMIT,
     +              ELIMIT2,ELIMIT3,BADSTART,RWEIGHT,REFREJ,XMLONLY)
C     ==============================================================
C
      IMPLICIT NONE
C     IPACK      Image number, starts at 1, runs to NPACK
C     ID         Image ID
C     NIMGSM     Number of images avaialable to be used in smoothing
C     CENTRE     TRUE if using spots from central region of detector
C     FINAL      TRUE if this is the last cycle of refinement using
C                spots from the centre of the detector only, otherwise
C                FALSE.
C     XMLONLY    TRUE if calling RDIST only to write out XML. This is
C                required if there are no spots in outer region of
C                the detector.
C
C---- Refines detector centre, detector orientation, crystal to
C     detector distance, yscal and detector distortions for flat
C     detectors using a non-linear least squares method and reports
C     new fiducial constants
C
C---- The number of parameters refined depends on the number of
C     refinement spots (NRS). If less than 20, only the detector centre
C     and orientation are refined. This is used in pattern matching.
C     If refining the central region of the film, bulge is not refined.
C     debug(11) this subroutine
C
C
C---- For image plate data from the Mar Research scanner, "Bulge" is
C     replaced by a refineable radial offset (ROFF, independant of radius)
C     and an additional parameter (TOFF) corresponding to a tangential
C     offset has been added and a radial dependend tangential offset RDTOFF.
C     These terms allow for any mis-alignment of the scanning head. They
C     are all in 10 micron units.
C
C---- Last changed 11/7/89 to allow for use of partials in refinement
C
C---- Coordinates used in this subroutine
C
C     (CLCX,CLCY) are from the generate-file and therefore
C                 in 10 micron units relative to the centre
C                 of the diffraction pattern
C
C     (XRS,YRS)   are in 10 micron units (from seekrs or next)
C
C
C---- Least squares refinement of xtofra,xcen,ycen and omega0
C     done by fitting observed positions (xrs,yrs) to those
C     in the generate-file (CLCX,CLCY)
C
C     Individual parameters can be held fixed during refinement by
C     use of REFINEMENT FIX ... keywords.
C
C     Refineable parameters are:
C     1 XCEN
C     2 YCEN
C     3 OMEGA0
C     4 YSCAL
C     5 XTOFRA   (Crystal to detector distance multiplier)
C     6 TILT            
C     7 TWIST
C     8 ROFF for Image Plate, BULGE for film
C     9 TOFF
C     10 RDTOFF
C     11 RDROFF
C
c
c     BEWARE - DO NOT USE fortran-indent-subprogram on this as that will break it -
c     There are lots of lines which are badly formatted to fit within 71 chars. :o(
c
C     .. Parameters ..
C&&*&& include  ../inc/parameter.f
C
C $Id: parameter.f,v 1.17 2009/10/28 16:43:34 harry Exp $
C
C--- awk generated include file  parameter.h
C---- START of include file parameter.h
C
C       PARAMETERS
C       IYLENGTH.. maximum number of I*2 words of data in the 
C                  "fast" (ie most rapidly changing) direction in the
C                  digitised image. This will be HALF the number of pixels
C                  for film data (each pixel is stored in one byte)
C                  but will equal the number of pixels for IP data.
C       IXWDTH...  The maximum number of "stripes" of data in the scanned image
C                  ie the number of pixels in the "slow" direction
C                  (This is the Y direction in the MOSFLM convention)
C                  Note that the array "IMAGE" used to store the image is
C                  declared as size IYLENGTH*IXWDTH I*2 words for IP data
C                  and 2*IYLENGTH*IXWDTH BYTES for film data.
C                  If this exceeds the
C                  available memory, set ixwdth=1, recompile program
C                  and use keyword "NOCORE" when running program.
C                  Note that for the POSTREF and ADDPART options,
C                  two images have to be stored in memory at once so
C                  IXWDTH should be twice the number of records in an
C                  image.
C       MAXHEAD    maximum length of image header (in 4 byte words)
C       NREFLS.... maximum number of spots per film in generate file (250,000)
C       MAXBOX.... maximum number of pixels in measurement box (1500)
C       MAXDIM.... maximum box size in either direction (pixels) (41)
C       MAXPAX.... maximum number of packs per generate file (10000)
C       MXDOV2..... maxdim/2
C       MAXBUFF... maximum size of buffer (I*2) for storing ods
C                  of active spots in subroutine meas(21,000).
C                  Must be .GE.  MAXBOX*(NNLINE-1) for subroutine process
C       MREF...... maximum number of reflections to be used in post
C                  refinement (6000)
C       NEXPAND... maximum number of expansions of the input measurement
C                  box (2)
C       NMASKS.... maximum number of different profiles (25). Note the
C                  connection between this parameter and NNLINE
C       NVECT..... maximum number of vectors for storing scanned image
C                  in filmplot (10000)
C       NIMAX..... maximum number of images to be used together in 
C                  postrefinement (NADD or WIDTH options) (100)
C       NNLINE...  maximum number of boundary lines for setting up
C                  the areas for profile fitting. The maximum possible
C                  number of standard profiles will be (NNLINE-1)**2
C                  although for a circular detector the actual number
C                  may be less than this as some boxes will lie entirely
C                  outside the detector.
C       NREJMAX... Maximum number of rejected background pixels, resulting
C                  either from overlap of adjacent spots or outliers from
C                  the background plane
C       NSPOTS...  Maximum number of found spots (for autoindexing) that can
C                  be stored (for all images). Also maximum number in 
C                  a file wriitten by IMSTILLS that can be 
C                  stored/displayed/edited. THis must be an even number
C       MCOLS....  Number of columns in output MTZ file
C       MCOLSTR..  Number of columns in output MTZ file for strategy option
C     
C       MTZ Orientation block
C        MBLENG is total length of block, MBLINT, MBLREA are numbers
C          of integers & reals
C       NDETREF    Maximum number of reflections used for detector parameter
C                  refinement (previously 62)
C       NRPAR....  Maximum number of refineable parameters for detector
C                  positional refinement (subroutine RDIST)
C       NSEGMAX..  Maximum number of segments in STRATEGY
C       NSEGMAXPR  Maximum number of segments in POST-REFINEMENT
C       MULTMAX... Maximum number of observations with same hkl in COMPLETE
C       MAXDIFF... Maximum number of different packs that a given hkl occurs on
C       NRESBIN... Maximum number of resolution bins (COMPLETE)
C
C       MAXIMG...  Maximum number of images that can be read in using the IMAGE
C                  keyword or the "read Image" menu option.
C       MXSPOT...  Maximum number of spots that can be found on one image
C                  (before rejection on spot size).
C       MXCENT...  Maximum number of active spots during spot finding 
C                  (findspots)
C
C       MGRA, NGRA... maximum number of reflections and images over which a 
C                     reflection can be spread for postrefinement.
C       MAXBGBOX    Maximum number of local background background boxes 
C                   in X and Y
C
C       MAXNPEAKS   Maximum number of local maxima within one spot
C       MAXEXCL     Maximum number of excluded areas of the same type
C                   eg reactangles, quadrilaterals, arcs, resolution shells
C
C     .. Parameters ..
      INTEGER IXWDTH
c      PARAMETER (IXWDTH=8192)
      PARAMETER (IXWDTH=12288)
      INTEGER IYLENGTH
c      PARAMETER (IYLENGTH=4096)
      PARAMETER (IYLENGTH=6144)
      INTEGER MAXHEAD
      PARAMETER (MAXHEAD=5120)
      INTEGER MAXBOX
      PARAMETER (MAXBOX=3000)
      INTEGER MAXDIM
      PARAMETER (MAXDIM=41)
      INTEGER MAXPAX
      PARAMETER (MAXPAX=10000)
      INTEGER MXDOV2
      PARAMETER (MXDOV2=MAXDIM/2)
      INTEGER NEXPAND
      PARAMETER (NEXPAND=2)
      INTEGER NNLINE
      PARAMETER (NNLINE=8)
      INTEGER NMASKS
      PARAMETER (NMASKS=49)
      INTEGER MAXBUFF
      PARAMETER (MAXBUFF=21000)
      INTEGER NREFLS
      PARAMETER (NREFLS=250000)
      INTEGER MREF
      PARAMETER (MREF=6000)
      INTEGER NVECT
      PARAMETER (NVECT=10000)
      INTEGER NIMAX
      PARAMETER (NIMAX=100)
      INTEGER NREJMAX
      PARAMETER (NREJMAX=1000)
      INTEGER NSPOTS
      PARAMETER (NSPOTS=5000)
      INTEGER MCOLS
      PARAMETER (MCOLS=18)
      INTEGER MCOLSTR
      PARAMETER (MCOLSTR=6)
      INTEGER NREFSTR
C
C---- Each reflection for strategy run needs MCOLSTR I*2 words
C     plus an I*4 word for the merging
C
      PARAMETER (NREFSTR = IXWDTH*IYLENGTH/(2+MCOLSTR))
      INTEGER MBLENG,MBLINT,MBLREA
      PARAMETER (MBLENG=185,MBLINT=29,MBLREA=156)
      INTEGER NDETREF
      PARAMETER (NDETREF=400)
      INTEGER NRPAR
      PARAMETER (NRPAR=14)
      INTEGER NSEGMAX
      PARAMETER (NSEGMAX=100)
      INTEGER NSEGMAXPR
      PARAMETER (NSEGMAXPR=100)
      INTEGER MULTMAX
      PARAMETER (MULTMAX=100)
      INTEGER MAXDIFF
      PARAMETER (MAXDIFF=100)
      INTEGER NRESBIN
      PARAMETER (NRESBIN=20)
      INTEGER MXSPOT
      PARAMETER (MXSPOT=5000)      
      INTEGER MAXIMG
      PARAMETER (MAXIMG=100)      
      INTEGER NPIXBG
      PARAMETER (NPIXBG=51)
      INTEGER MXCENT
      PARAMETER (MXCENT=500)
      INTEGER    NGRA,MGRA
      PARAMETER (NGRA=20)
      PARAMETER (MGRA=50000)
      INTEGER MAXBGBOX
      PARAMETER (MAXBGBOX=500)
      INTEGER MAXNPEAKS
      PARAMETER (MAXNPEAKS=500)
      INTEGER MAXEXCL
      PARAMETER (MAXEXCL=50)
C&&*&& end_include  ../inc/parameter.f
C&&*&& include  ../inc/mxdinc.f
C
C $Id: mxdinc.f,v 1.1 2002/05/02 10:47:00 harry Exp $
C
C--- awk generated include file  mxdinc.h
C---- START of include file mxdinc.h
C
C
c common block for mxd routines: various parameters for XDL routines
c
c     base_width    width of base frame
c     base_height   height of base frame
c     men_x,men_y   position of menu area
c     par_x,par_y   position of parameter area
C     

C     IORDER    (R)   Order of the data in the input image 
c                with respect to two local axes ax1, ax2 e.g.
c                (xf, yf) as a number from 1 to 8.
c                    1   +ax1 slow   +ax2 fast    (+xf, +yf)
c                    2   +ax1 slow   -ax2 fast    (+xf, -yf)
c                    3   -ax1 slow   +ax2 fast    (-xf, +yf)
c                    4   -ax1 slow   -ax2 fast    (-xf, -yf)
c                    5   +ax2 slow   +ax1 fast    (+yf, +xf)
c                    6   +ax2 slow   -ax1 fast    (+yf, -xf)
c                    7   -ax2 slow   +ax1 fast    (-yf, +xf)
c                    8   -ax2 slow   -ax1 fast    (-yf, -xf)
c
c
c     JORDER    (R)   Display order with respect to the two
c                local axes (1 to 8) along the X-windows
c                axes X horizontal (left to right), Y vertical 
c                (top to bottom ) with origin at top left
c                1  +ax1 X (horiz)   +ax2 Y (vert)   (+xf, +yf)
c                2  +ax1 X (horiz)   -ax2 Y (vert)   (+xf, -yf)
c                3  -ax1 X (horiz)   +ax2 Y (vert)   (-xf, +yf)
c                4  -ax1 X (horiz)   -ax2 Y (vert)   (-xf, -yf)
c                5  +ax2 X (horiz)   +ax1 Y (vert)   (+yf, +xf)
c                6  +ax2 X (horiz)   -ax1 Y (vert)   (+yf, -xf)
c                7  -ax2 X (horiz)   +ax1 Y (vert)   (-yf, +xf)
c                8  -ax2 X (horiz)   -ax1 Y (vert)   (-yf, -xf)
c                    
c                    (2 was standard for Laue programs)
c
c     nxp_cmp       number of pixels compressed to 1 in horizontal
c                   display direction
c     nyp_cmp       number of pixels compressed to 1 in vertical
c                   display direction
c     nxdpx         number of horizontal pixels in displayed image
c     nydpx         number of vertical pixels in displayed image
c     img_horiz     image direction for horizontal display (=1 fast, 2 slow)
c     img_vert      image direction for vertical display   (=1 fast, 2 slow)
c     img_map(4)    mapping of image to display
c                    imgmap(1)   1st point on fast axis (Yms)
c                    imgmap(2)   1st point on slow axis (Zms)
c                    imgmap(3)   increment on fast axis
c                    imgmap(4)   increment on slow
c     img_x,img_y   x, y position of image
c     men_x, men_y  x, y position of menu
c     par_x, par_y  x, y position of parameter table
c     io_x, io_y    x, y position of IO area
c     not_x, not_y    x, y position of notice area (parameter table
c                     with no values)
c     pmn_x, pmn_y  x, y position of popup abort menu
c     ppb_x, ppb_y  x, y position of popup progress bar
c     busy_x, busy_y x, y position of busy window
c     img_width,img_height   width, height of image window
c     men_width, men_height  width, height of menu window  
c     par_width, par_height  width, height of parameter window
c     io_width, io_height    width, height of IO window
c     not_width, not_height  width, height of notice area
c     pmn_width, pmn_height  width, height of Abort menu
c     ppb_width              width of progress bar
c     busy_width, busy_height  width, height of busy box
c     sub_process    .true. if program is sub-process of eg clips, .false.
c                    if standalone
c
C     IFTYPE      1 = unsigned byte data
C                 2 = unsigned two-byte data (i2)
C                 3 = signed integer data
C                 4 = 'squashed i2' data (if Intensity>32767 
C                    store as 65536-Intensity/8)
      INTEGER BASE_WIDTH,BASE_HEIGHT,
     $     IMAGE_ORDER,JIMAGE_ORDER,NXP_CMP,NYP_CMP,
     $     NXDPX,NYDPX,
     $     IMG_HORIZ,IMG_VERT,IMG_MAP(4),
     $     IMG_X,IMG_Y,MEN_X,MEN_Y,PAR_X,PAR_Y,IO_X,IO_Y,
     $     NOT_X,NOT_Y,PMN_X, PMN_Y,PPB_X, PPB_Y, BUSY_X, BUSY_Y,
     $     BUSY_Y2,IFTYPE
      INTEGER IMG_WIDTH, IMG_HEIGHT, MEN_WIDTH, MEN_HEIGHT,
     $     PAR_WIDTH, PAR_HEIGHT, IO_WIDTH, IO_HEIGHT,
     $     NOT_WIDTH, NOT_HEIGHT, PMN_WIDTH, PMN_HEIGHT,
     $     PPB_WIDTH, BUSY_WIDTH, BUSY_HEIGHT
      LOGICAL SUB_PROCESS, BLANK
C

c  DON'T forget to declare function xdlstr as integer
      INTEGER XDLSTR
      EXTERNAL XDLSTR

c
c     ivhbas        view object handle for base frame
c     ivhimg        view object handle for image
c     ivhpar        view object handle for parameter table
c     ivhmen        view object handle for menu
c     ivhio         view object handle for io area
c     ivhio2        view object handle for second io area (pick option)
c     ivhio3        view object handle for third io area (output)
c     ivhnot        view object handle for notice area (parameter table)
c     ivhpmn        view object handle for popup wait menu
c     ivhppb        view object handle for popup progress bar
c     ivhblank      view object handle for blank object
c     ivhbusy       view object handle for busy object
c     ivhbusy2      view object handle for second (2 line) busy object
      INTEGER IVHBAS, IVHIMG, IVHPAR, IVHMEN, IVHIO, IVHNOT, IVHPMN,
     $     IVHPPB, IVHBLANK, IVHBUSY, IVHIO2, IVHBUSY2, IVHIO3
      PARAMETER (IVHBAS=1, IVHIMG=2, IVHPAR=3, IVHMEN=4, IVHIO=5,
     $     IVHNOT=6, IVHPMN=7, IVHPPB=8, IVHBLANK=9, IVHBUSY=10,
     $     IVHIO2=11, IVHBUSY2=12, IVHIO3=13)

c  Border  boundary between windows
      INTEGER BORDER
      PARAMETER (BORDER = 4)

c     icset   colour set number
      INTEGER ICSET
      PARAMETER (ICSET=1)
c
c     iord    axis order of image
c             = 1  xf slow, yf fast
      INTEGER IORD
      PARAMETER (IORD = 1)
c
c     minw,minh   minimum width and height for image display object
      INTEGER MINW,MINH
      PARAMETER (MINW=0, MINH=0)
c
c     ixopix, iyopix      pixel origin of displayed part
      INTEGER IXOPIX,IYOPIX
      PARAMETER (IXOPIX=1, IYOPIX=1)
c
c     ibg     background menu, =0 for none
      INTEGER IBG
      PARAMETER (IBG=0)
c
c     iovly   overlay option
      INTEGER IOVLY
      PARAMETER (IOVLY=1)
c
c     max_pixel   maximum number of pixels to use for image display:
c                 this will be used to control possible compression
c                 of the image
      INTEGER MAX_PIXEL
      PARAMETER (MAX_PIXEL = 800)
c  Image stuff
c     disp_img        true if image has been displayed
c
      LOGICAL DISP_IMG
c
c     ifd     file descriptor, = -1 for no file
      INTEGER IFD
      PARAMETER (IFD=0)
c

c  Parameter table stuff
c     max_par_col     maximum number of parameter columns
c     max_par_rows    maximum number of parameter rows
c     max_par_name    maximum length of name
c     max_par_str     maximum value length
c     par_title       = -1 no title +1 title present
c     par_font        font (3=medium)
c     par_menu        = 1 if popup menus allowed
c     disp_par        true if parameter table hsa been displayed
c
      LOGICAL DISP_PAR
      INTEGER MAX_PAR_COL, MAX_PAR_ROWS, MAX_PAR_NAME, MAX_PAR_STR,
     $        PAR_TITLE, PAR_FONT, PAR_MENU
      PARAMETER (MAX_PAR_COL = 1, MAX_PAR_ROWS = 50,
     $           MAX_PAR_NAME = 17, MAX_PAR_STR = 7,
     $           PAR_TITLE = 1, PAR_FONT = 2, PAR_MENU = 0)
C
c  Menu stuff
c     max_men_itms    maximum number of menu items
c     max_men_name    maximum number of characters in menu item
c     men_font        menu font number (3=medium)
c     men_quit_flag   = 1 to allow for quit box
c     max_men_title   maximum length of menu title
c     disp_menu       true if menu displayed
      LOGICAL DISP_MENU
      INTEGER MAX_MEN_ITMS, MAX_MEN_NAME, MEN_FONT, MEN_QUIT_FLAG,
     $        MAX_MEN_TITLE 
      PARAMETER (MAX_MEN_ITMS = 19, MAX_MEN_NAME = 19, MEN_FONT = 4,
     $     MEN_QUIT_FLAG = 1, MAX_MEN_TITLE = 9)

c
c IO area stuff
c     io_font         font number
c     disp_io         true if io area displayed
c     disp_io2        true if SECOND io area displayed
c     disp_io3        true if THIRD io area displayed
C     NSCROLL         number of pages to hold for scrolling
      LOGICAL DISP_IO,DISP_IO2,DISP_IO3
      INTEGER IO_FONT,NSCROLL
      PARAMETER (IO_FONT=2)
      PARAMETER (NSCROLL=0)


c  Notice area stuff (notice area is a parameter table with no values)
c     max_not_col     maximum number of parameter columns
c     max_not_rows    maximum number of parameter rows
c     max_not_name    maximum length of name
c     max_not_str     maximum value length
c     not_title       = -1 no title +1 title present
c     not_font        font (3=medium)
c     not_menu        = 1 if popup menus allowed
c     disp_not       true if menu displayed
      LOGICAL DISP_NOT
      INTEGER MAX_NOT_COL, MAX_NOT_ROWS, MAX_NOT_NAME, MAX_NOT_STR,
     $        NOT_TITLE, NOT_FONT, NOT_MENU
      PARAMETER (MAX_NOT_COL = 1, MAX_NOT_ROWS = 18,
     $           MAX_NOT_NAME = 23,
     $           MAX_NOT_STR = 0,
     $           NOT_TITLE = +1, NOT_FONT = 2, NOT_MENU = 0)
c
c  Menu stuff for Abort menu
c     max_pmn_itms    maximum number of menu items
c     max_pmn_name    maximum number of characters in menu item
c     pmn_font        menu font number (3=medium)
c     pmn_quit_flag   = 1 to allow for quit box
c     max_pmn_title   maximum length of menu title
      INTEGER MAX_PMN_ITMS, MAX_PMN_NAME, PMN_FONT, PMN_QUIT_FLAG,
     $        MAX_PMN_TITLE 
      PARAMETER (MAX_PMN_ITMS = 0, MAX_PMN_NAME = 12, PMN_FONT = 4,
     $     PMN_QUIT_FLAG = 1, MAX_PMN_TITLE = 15)

c   Stuff for progress bar
c     ppb_font   font number (3=medium)
c     ppb_colr   colour
      INTEGER PPB_FONT, PPB_COLR
      PARAMETER (PPB_FONT = 4, PPB_COLR=3)

c   Busy box
      INTEGER BUSY_FONT
      PARAMETER (BUSY_FONT = 3)
c
c len_dialog    length of dialog box
      INTEGER LEN_DIALOG
      PARAMETER (LEN_DIALOG = 60)

c
c  Overlays
c
c  Circles
c     cir_ivec    vector set number for circles
c     cir_colr    colour for circles
c     cir_iovl    overlay number for circles
c     cir_symb   symbol for centre
      INTEGER CIR_IVEC, CIR_COLR, CIR_IOVL, CIR_SYMB
      PARAMETER (CIR_IVEC=3, CIR_COLR=6, CIR_IOVL=2, CIR_SYMB=4)

C
C---- Residual vectors
C     IRV_VEC Vector set number
C     IRV_COL Colour  (1 red, 2 yellow, 3 green)
C     IRV_OVL Overlay number
      INTEGER IRV_VEC, IRV_COL, IRV_OVL
      PARAMETER (IRV_VEC=4, IRV_COL=1, IRV_OVL=2)
c  Measure
c
c     mes_colr    colour for measure crosses
      INTEGER MES_COLR
      PARAMETER (MES_COLR=1)

c   Vertical Crosses
c     cross_iovl    overlay number for circles
c     cross_symb   symbol for centre
      INTEGER CROSS_IOVL, CROSS_SYMB
      PARAMETER (CROSS_IOVL=2, CROSS_SYMB=3)
c  Boxes
c     box_iovl    overlay number for boxes
c     box_symb   symbol for centre
      INTEGER BOX_IOVL, BOX_SYMB, BOX_VEC
      PARAMETER (BOX_VEC=2,BOX_IOVL=2, BOX_SYMB=13)
c  Circles
c     CIRC_iovl    overlay number for circles
c     CIRC_symb   symbol for centre
      INTEGER CIRC_IOVL, CIRC_VEC
      PARAMETER (CIRC_VEC=5,CIRC_IOVL=2)
c   Crosses
c     cross_iovl    overlay number for circles
c     cross_symb   symbol for centre
      INTEGER XCROSS_IOVL, XCROSS_SYMB
      PARAMETER (XCROSS_IOVL=2, XCROSS_SYMB=13)
C
C---- common block last of all
C
      COMMON /MXDCMI/ BASE_WIDTH,BASE_HEIGHT,
     $     IMAGE_ORDER,JIMAGE_ORDER,NXP_CMP,NYP_CMP,
     $     NXDPX,NYDPX,
     $     IMG_HORIZ,IMG_VERT,IMG_MAP,
     $     IMG_X,IMG_Y,MEN_X,MEN_Y,PAR_X,PAR_Y,IO_X,IO_Y,
     $     NOT_X,NOT_Y,PMN_X, PMN_Y,PPB_X, PPB_Y, BUSY_X, BUSY_Y,
     $     BUSY_Y2, IFTYPE,
     $     IMG_WIDTH, IMG_HEIGHT, MEN_WIDTH, MEN_HEIGHT,
     $     PAR_WIDTH, PAR_HEIGHT, IO_WIDTH, IO_HEIGHT,
     $     NOT_WIDTH, NOT_HEIGHT, PMN_WIDTH, PMN_HEIGHT,
     $     PPB_WIDTH, BUSY_WIDTH, BUSY_HEIGHT,
     $     SUB_PROCESS,BLANK,DISP_IMG,DISP_PAR,DISP_MENU,
     $     DISP_IO,DISP_IO2,DISP_IO3,DISP_NOT
  
C&&*&& end_include  ../inc/mxdinc.f
C     ..
C     .. Scalar Arguments ..
      REAL WELIMIT,ELIMIT,ELIMIT2,ELIMIT3,REFREJ
      INTEGER IPACK,ID,NIMGSM
      LOGICAL CENTRE,FINAL,BADSTART,RWEIGHT,XMLONLY
C     ..
C     .. Local Scalars ..
      REAL DET,DX,DXTOF,DY,OMEGA0,RES,RESD,RESLIM,RESMX,RG,XC1,XM,XO,
     +     XXG,YC1,YM,YO,YYG,PSI,CPSI,SPSI,WRES,WRESD,WRESMX,WDX,WDY,
     +     WX,WY,WRESLIM,PXCEN,PYCEN,RAD,XMID,YMID,PI,RSCAN,
     +     SWDELSQ,PCCX,RTOD,CRMSRES
      INTEGER I,IBULGE,ICYC,IDX,IDY,IK,IR,ITILT,ITWIST,J,JDO,
     +        K,MXJ,NOTRY,NP,NP2,NXD,IPT,ITWISTSM,ITILTSM,
     +        setsocket
      LOGICAL REPT,BIGDUMP
      CHARACTER*50 LINE
      character*1024 outline
C     ..
C     .. Local Arrays ..
      REAL CLCX(NDETREF),CLCY(NDETREF),DDX(NRPAR),DDY(NRPAR),
     +     RF(NRPAR*NRPAR),W(NRPAR),R(NRPAR)
      INTEGER XXGEN(NDETREF),YYGEN(NDETREF),IWRK1(NRPAR),IWRK2(NRPAR)
      LOGICAL BAD(NDETREF)
C       ..
C       .. External Functions ..
      INTEGER LENSTR
      EXTERNAL LENSTR
      REAL CHKANG
      EXTERNAL CHKANG
C     ..
C     .. External Subroutines ..
      EXTERNAL MINV,MMTOPX,MPAUSE,PARSMOOTH
C     ..
C     .. Intrinsic Functions ..
      INTRINSIC ABS,ATAN2,COS,NINT,SIN,SQRT
C     ..
C     .. Common blocks ..
C&&*&& include  ../inc/debug.f
C
C $Id: debug.f,v 1.2 2008/07/24 09:42:21 andrew Exp $
C
C--- awk generated include file  debug.h
C---- START of include file debug.h
C
C
C
C     .. Arrays in common /DEBUG/ ..
      REAL XWARN
      INTEGER NDEBUG,IWARN
      LOGICAL DEBUG,LPRINT,DUMP,WARN
C
C     .. Scalars in common /DEBUG/ ..
      REAL BGRLIM
      INTEGER NDUMP,IDUMP,MXDUMP
      LOGICAL SPOT
C     
C     ..
C     .. Common Block /DEBUG/..
      COMMON /DEBUG/XWARN(20,100),BGRLIM,NDEBUG(100),IWARN(20,100),
     $       NDUMP,IDUMP,MXDUMP,DEBUG(100),LPRINT(20),DUMP(30),
     +       WARN(100),SPOT
C     ..
C
C&&*&& end_include  ../inc/debug.f
C&&*&& include  ../inc/dsplyc.f
C
C $Id: dsplyc.f,v 1.6 2009/02/18 14:39:17 harry Exp $
C
C--- awk generated include file  dsplyc.h
C---- START of include file dsplyc.h
C
C*******************************************************************
C
C  COMMON  /DSPLYC/
C
C       IMGLOW, IMGHI   low & high values of 16-bit image for scaling
C                       integer*2 to byte: IMGLOW maps to  0; 
C                       IMGHI to maximum. Note that these are not
C                       necessarily the actual limits of the data
C       IMGMAX          maximum value recorded on the image. Necessary for 
C                       iMosflm.
C       JDSPWD          .LT. 0  before image window has been created
C                       = +-1 for image display that can be panned
C                       = +-2 for non-interactive image display
C       MAXDEN          highest level in colour table to fill up to
C                       must be less than ~240 - number of overlay colours
C       LDSPSG          if .true., treat image as signed, ie after dark
C                          subtraction
C                       if .false., treat image as unsigned
C       NZOOM           zoom factor for image, = 0 if no zoom
C       JYZOOM, JZZOOM  1st pixel in zoomed image
C
C----   WINOPEN Flag for whether or not window is open. Do not
C               confuse with DISPMENU (/CONDATA/)which is true if the run was
C               started with a IMAGE keyword.
C
C
C       CDSPTL          banner title
C
      REAL FTOTAL,AVERAG,IMAGERMS
      INTEGER IMGLOW, IMGHI, IMGMAX,JDSPWD, MAXDEN,
     $     NZOOM, JYZOOM, JZZOOM
      INTEGER PIXEL_INTENSITIES(514)
      LOGICAL LDSPSG,WINOPEN,LPAUSE,LHELP
      COMMON /DSPLYC/ FTOTAL,AVERAG,IMAGERMS,IMGLOW, IMGHI, IMGMAX,
     *     JDSPWD,MAXDEN, NZOOM, JYZOOM, JZZOOM, PIXEL_INTENSITIES,
     $     LDSPSG,WINOPEN,LPAUSE,LHELP
C
      CHARACTER  CDSPTL*200,SHORTFN*200
      COMMON /DSPLCC/  CDSPTL,SHORTFN
C                                                           
C
C*******************************************************************


C&&*&& end_include  ../inc/dsplyc.f
C&&*&& include  ../inc/fid.f
C
C $Id: fid.f,v 1.5 2007/11/06 12:49:03 harry Exp $
C
C--- awk generated include file  fid.h
C---- START of include file fid.h
C
C     XCENF,YCENF  Coordinates (in 10 micron units) of the direct beam
C                  position relative to an origin at the position of the
C                  first pixel in the digitised image.(The SCANNER
C                  coordinate frame).
C                  For IP data this comes from the defined
C                  direct beam coordinates, for film data it is the
C                  midpoint of fiducials 1 and 3.
C
C     CCX,CCY      The difference (in 10 micron units) between the
C                  refined position of the direct beam (XCEN,YCEN) and
C                  the ideal direct beam coordinates (XCENF,YCENF),
C                  in the SCANNER coordinate frame.
C                  CCX,CCY are updated in RDIST. They are in "pixels"
C                  rather than mm (but expressed in 10micron units).
C
C     DTOFD        The distance (in 10 micron units) from the crystal
C                  to the detector along a normal to the detector.
C                  For flat, unswung detectors, or swung on a 2 theta arm,
C                  this is the same as CTOFD and XTOFD. It differs for
C                  Vee shaped cassettes. Assigned in START and never changed.
C                  Only actually used in RMAXR for calculating box sizes.
C
C     .. Arrays in common /FID/ ..
      REAL CCOMABC
      INTEGER FSPOS,CCXABC,CCYABC
C     ..
C     .. Scalars in common /FID/ ..
      REAL OMEGAF,OMEGAFD,CCOM,DTOFD,XCENF,YCENF
      INTEGER MM,MMDB,NFID,CCX,CCY,IYOFF,LABVIEW
      CHARACTER SPOTFILEORIGIN*2,SPOTFILEAXISORDER*2,SWINGAXIS*2
C     ..
C     .. Common block /FID/ ..
      COMMON /FID/CCOMABC(3),OMEGAF,OMEGAFD,CCOM,DTOFD,XCENF,YCENF,
     $     FSPOS(4,2),
     +     CCXABC(3),CCYABC(3),MM,MMDB,NFID,CCX,CCY,IYOFF,LABVIEW,
     $     SPOTFILEORIGIN,SPOTFILEAXISORDER,SWINGAXIS
C     ..
C
C
C&&*&& end_include  ../inc/fid.f
C&&*&& include  ../inc/gendata.f
C
C $Id: gendata.f,v 1.2 2003/01/10 16:17:53 andrew Exp $
C
C--- awk generated include file  gendata.h
C---- START of include file gendata.h
C
C     IMG       Partiality indicator. 0 for full reflections, 1 to 100
C                   for partials. Negative for partials at the start of the
C                   rotation range, +ve for partials at the end of the 
C                   rotation. Set in subroutine REEK using DELEPS calculated
C                   in subroutine DSTAR
C
C     IRG       Reflection flag  (Set by SPTEST called from DSTAR)
C               =  0  Spot can be measured
C               =  1  Outside R, X, Y limits
C               =  2  Overlapping spot (set later)
C               =  3  Too wide in phi (more than NWMAX images)
C               =  4  DST .GT. DSTMAX  Not included in final film list -
C                       used only to check for overlaps at edge of film.
C               = 10  Spot is within cusp, but will be observed...not included
C                     in final spot list but must be included in predicted
C                      pattern
C
C               =  21  Spot present on 2 images, this is 1st
C               =  22  Spot present on 2 images, this is 2nd
C
C               =  31  Spot present on 3 images, this is 1st
C               =  32  Spot present on 3 images, this is 2nd
C               =  33  Spot present on 3 images, this is 3rd
C
C               =  41  Spot present on 4 images, this is 1st
C               =  42  Spot present on 4 images, this is 2nd
C               =  43  Spot present on 3 images, this is 3rd
C               =  44  Spot present on 4 images, this is 4th
C
C                 etc etc
C
C     XG        Virtual detector X coordinate in 10 micron units, relative to
C               an origin at the direct beam position. X is parallel to the
C               Y axis in the laboratory frame, ie orthogonal to the rotation
C               axis.
C
C     YG        Virtual detector Y coordinate in 10 micron units, relative to
C               an origin at the direct beam position. Y is parallel to the
C               Z axis in the laboratory frame, ie  the rotation axis.
C
C     IX,IY     are the coordinates of the reflection in pixels
C               (integers) wrt the first pixel in the image (lower left corner
C               cameramans view). For testing for spot overlap, these
C               coordinates are in 10 micron units. Also used for display
C               pixel coordinates when displaying predicted pattern.
C
C     IREC      Pointer to the record number of a particular spot in the
C               list of generated reflections.
C
C
C     ..
C     .. Arrays in common /GENDATA/ ..
      REAL FRACG,PHIG,PHIWG,XG,YG,GOODFIT
      INTEGER INTG,IPRO,IX,IY,IREC
      INTEGER*2 IRG,IMG,IGFLAG,ISDPRO,ISDG,IHG,IKG,ILG,IMPARTG,
     +          MISYMG
C     .. Scalars in common /GENDATA/ ..
      INTEGER IPACKREC,IPACKHEAD,IRECLAST
C     ..
C     .. Common block /GENDATA/ ..
      COMMON /GENDATA/FRACG(NREFLS),PHIG(NREFLS),PHIWG(NREFLS),
     $       XG(NREFLS),YG(NREFLS),INTG(NREFLS),IPRO(NREFLS),
     $       IX(NREFLS),IY(NREFLS),IREC(NREFLS),IRG(NREFLS),IMG(NREFLS),
     +       IGFLAG(NREFLS),ISDPRO(NREFLS),ISDG(NREFLS),
     +       IHG(NREFLS),IKG(NREFLS),ILG(NREFLS),IMPARTG(NREFLS),
     +       MISYMG(NREFLS),GOODFIT(NREFLS),IPACKREC,IPACKHEAD,
     +       IRECLAST
C     ..
C
C

C&&*&& end_include  ../inc/gendata.f
C&&*&& include  ../inc/gui.f
c     gui.h
c     maintained by G.Winter
c     16th April 2002
c     $Id: gui.f,v 1.16 2003/04/04 14:22:01 harry Exp $
c     
c     This defines the variables and common blocks which are used by the
c     new gui control routine. This will also be used in xdisp and control,
c     to switch the new gui on!
c     
c     

      logical gui_switch, refine_cell(6), refine_detector(11),
     +     autocomplete, autoreturn, newmatstore
      integer nargs
      integer imageno, nstart
      parameter (nargs = 200)

c     refine_detector logical block index:
c     1: beam x 2: beam y 3: ccomega 4: yscale
c     5: distance 6: tilt 7: twist 8: roff 9: toff
c     
c     refine_cell logical block index:
c     1: a 2: b 3: c
c     4: alpha 5: beta 6: gamma
c     
c     
c     

      integer keep_phi_segments, keep_phi_start(20), 
     +     keep_phi_end(20)

      real storemeanmult

      common /gui/ gui_switch, imageno, refine_cell, refine_detector,
     +     autocomplete, nstart, autoreturn, newmatstore

      common /keep_phi/ keep_phi_segments, keep_phi_start, 
     +     keep_phi_end, storemeanmult


c     refine_cell(i) is true if you wish to refine cell(i)
C&&*&& end_include  ../inc/gui.f
C&&*&& include  ../inc/ioo.f
C
C $Id: ioo.f,v 1.7 2009/05/13 11:57:53 harry Exp $
C
C--- awk generated include file  ioo.h
C---- START of include file ioo.h
C
C
C
C     .. Scalars in common block /IOO/ ..
      INTEGER IOUT,IUNIT,ITIN,ITOUT,INOD,INMO,IDU,NWRN,IBRIEF,ISUMMR,
     +        ICOORD,SERVERFD,SERVERFDIN,NSHUTERR,dnafd
      LOGICAL ONLINE,ONEFILE,FHEADER,BRIEF,GRAPH,IOERR,
     $     NODISPLAY,LBELL,JPGOUT,SOCKLO,LBEST,dnaout,INMOOPEN,
     $     XMLOPEN
      CHARACTER dna_image*80,xmlfile*80
C     ..
C     .. Common block /IOO/ ..
c      COMMON /IOO/IOUT,IUNIT,ONLINE,ITIN,ITOUT,INOD,INMO,IDU,NWRN,
c     +            ONEFILE,FHEADER,BRIEF,IBRIEF,GRAPH,ISUMMR,ICOORD,
c     +            IOERR,NODISPLAY,LBELL
C     ..
C
C
      COMMON /IOO/IOUT,IUNIT,ITIN,ITOUT,INOD,INMO,IDU,NWRN,IBRIEF,
     +        ISUMMR,ICOORD,SERVERFD,SERVERFDIN,NSHUTERR,ONLINE,ONEFILE,
     +        FHEADER,BRIEF,GRAPH,IOERR,NODISPLAY,LBELL,JPGOUT,
     $        SOCKLO,LBEST, dnafd, dnaout,INMOOPEN,XMLOPEN
      COMMON /CIOO/dna_image,xmlfile

C&&*&& end_include  ../inc/ioo.f
C&&*&& include  ../inc/lmb.f
C
C $Id: lmb.f,v 1.8 2009/01/08 18:03:14 harry Exp $
C
C--- awk generated include file  lmb.h
C---- START of include file lmb.h
C ODSCAL is to scale image numbers into the range 0-255 for plotting
C average profiles.
C  GAIN should be equal to the overall gain (image counts per X-ray photon)
C of the system, and is used to evaluate standard deviations based on
C counting statistics assuming independent pixels (ie point spread function
C less than pixel size).
C INVERTX true if image is inverted in the slow (X) direction when read in.
C ISCAL is to scale final integrated intensities and sigmas
C IDIVIDE is the adc offset
C ICONST is a constant to be added to all pixels (normally zero) to
C        allow processing of images with zero pixel values in the scanned
C        area.
C IMGP is true if working with image plate data
C SPIRAL is true for scanners with a spiral readout (Mar, DIP2000)
C ORTHOG is true for scanners with orthogonal scan (FUJI, RAXIS, MD)
C NULLPIX is the value of pixels within the image but not in the active
C area of the detector
C TILED is true if there are inactive areas of the detector within the
C       inscribing circle or square.
C
C NTILEX Number of tiles in X direction
C NTILEY Number of tiles in Y direction
C TILEX  X Coordinates of the midpoints of the null areas between tiles
C TILEY  Y Coordinates of the midpoints of the null areas between tiles
C TILEWX Width of the null areas between tiles in X
C TILEWY Width of the null areas between tiles in Y


C MACHINE and MODEL denote the type of detector. 
C
C MACHINE is used in the following subroutines:
C GETBLK, GETHDR, INTPXL, INTPXL2, MXDSPL, OPENODS, PROCESS, PUTPXL
C Currently coded types are:
C
C         MACHINE        MODEL               COMMENTS
C         =======        =====               ========
C         MAR            180, 300, 345
C         RAXI(S)        RAXISII, RAXISIV
C         MD
C         FUJI
C         CCD1           CCD1                Princetown CCD at CHESS,Tiff format
C         CCD2           CCD ?               ESRF CCD detector
C         ADSC           QUAD1               ADSC 2x2 CCD detector
C
C TRUSTED whether or not the image header information can be trusted for 
C         automatic processing
C     .. Scalars in Common Block /LMB/ ..
        REAL ODSCAL,GAIN,LOGA,LOGB
        INTEGER ISCAL,IDIVIDE,ICONST,NULLPIX,NTILEX,NTILEY,
     $    RAXISCOMP,IIDIVIDE,COMPRESSION
        LOGICAL IMGP,INVERTX,SPIRAL,ORTHOG,CIRCULAR,TILED,SETADC,
     $    NEWRAXIS,BRUKNEW,TRUSTED
        CHARACTER MACHINE*4,MODEL*8

C     ..
C     .. Arrays in common /LMB/
        INTEGER TILEX,TILEY,TILEWX,TILEWY
C
C     .. Common Block /LMB/ ..
        COMMON /LMB/ ODSCAL,GAIN,LOGA,LOGB,ISCAL,IDIVIDE,ICONST,
     +       NULLPIX,NTILEX,NTILEY,RAXISCOMP,IIDIVIDE,COMPRESSION,
     +       TILEX(20),TILEY(20),TILEWX(20),TILEWY(20),IMGP,
     +       INVERTX,SPIRAL,ORTHOG,CIRCULAR,TILED,SETADC,
     $       NEWRAXIS,BRUKNEW,TRUSTED
        COMMON /LMBC/ MACHINE,MODEL

C&&*&& end_include  ../inc/lmb.f
C&&*&& include  ../inc/mcs.f
C $Id: mcs.f,v 1.1 2002/05/02 10:46:56 harry Exp $
C
C
C--- awk generated include file  mcs.h
C---- START of include file mcs.h
C
C
C     .. Scalars in common block /MCS/ ..
      REAL BASEOD,G1OD,CURV
      INTEGER FILM,FILMS,CTOFD,PCKIDX,TOSPT,N1OD,XSCMIN,XSCMAX
      LOGICAL VEE,VALONGX
C     ..
C     .. Common block /MCS/ ..
      COMMON /MCS/BASEOD,G1OD,CURV,FILM,FILMS,CTOFD,PCKIDX,TOSPT,
     $            N1OD,XSCMIN,XSCMAX,VEE,VALONGX
C     ..
C     CTOFD.... This was the crystal to detector distance (10 micron units)
C               but it has now been replaced by XTOFD in common block /XY/
C
C&&*&& end_include  ../inc/mcs.f
C&&*&& include  ../inc/ori.f
C
C $Id: ori.f,v 1.2 2007/07/12 13:25:56 andrew Exp $
C
C--- awk generated include file  ori.h
C---- START of include file ori.h
C
C     XCEN,YCEN    Coordinates (in 10 micron units) of the direct beam
C                  position relative to an origin at the position of the
C                  first pixel in the digitised image.(The SCANNER
C                  coordinate frame). These parameters are refined for
C                  each image. 
C
C     XCEN0,YCEN0  Coordinates of direct beam position at zero swing angle.
C                  (Needed for pxtomm conversion for swung detectors)
C                  These values are assigned on the basis of input direct
C                  beam coordinates, corrected for swing angle if necessary.
C                  They are not (currently) updated during refinement.
C
C     XOFF,YOFF    Distance between centre of detector and direct beam.
C
C     ..
C     .. Arrays in common /ORI/ ..
      LOGICAL FIXPAR
C
C     .. Scalars in common block /ORI/ ..
      REAL COSOM0,SINOM0,XTOFRA,YSCAL,TILT,TWIST,BULGE,
     +     VBNEG,VBPOS,VTILT,VTWIST,VVERT,TOFF,BULGE2,PBULGE,ROFF,
     +     RDTOFF,RDROFF,ROFFPHI,TOFFPHI,JUNK3,XCEN,YCEN,XCEN0,YCEN0,
     +     XOFF,YOFF,TILTMAT,TWISTMAT,DETNOR,DPSIX,SMTWIST,SMTILT,
     +     SMOMEGA0,SMYSCAL,SMTOFF,SMROFF,SMXTOFRA
      INTEGER CBAR,NODES,NPHI,NSM1,NSM2
      LOGICAL RESETCCOM,NOSMOOTH
C     ..
C     .. Common Block /ORI/ ..
      COMMON /ORI/COSOM0,SINOM0,XTOFRA,YSCAL,TILT,TWIST,BULGE,
     $       VBNEG,VBPOS,VTILT,VTWIST,VVERT,TOFF,BULGE2,PBULGE,ROFF,
     $       RDTOFF,RDROFF,ROFFPHI,TOFFPHI,JUNK3,XCEN,YCEN,XCEN0,
     +       YCEN0,XOFF,YOFF,TILTMAT,TWISTMAT,DPSIX,DETNOR(3),CBAR,
     +       NODES,NPHI,FIXPAR(NRPAR),
     $       RESETCCOM,SMTWIST,SMTILT,SMOMEGA0,SMYSCAL,SMTOFF,SMROFF,
     +       SMXTOFRA,NSM1,NSM2,NOSMOOTH
C     ..
C
C
C&&*&& end_include  ../inc/ori.f
C&&*&& include  ../inc/rfs.f
C
C $Id: rfs.f,v 1.2 2007/07/12 13:25:57 andrew Exp $
C
C--- awk generated include file  rfs.h
C---- START of include file rfs.h
C
C
C
C     .. Scalars in common block /RFS/ ..
      REAL FDIST,ESTART,RMSRES,WRMSRES,WESTART
      INTEGER MAXREF,MAXX,MAXY,NRS,MAXR,NREJS,NCENTREF
C     ..
C     .. Arrays in common block /RFS/ ..
      REAL XRS,YRS,WXRS,WYRS
      INTEGER RRS,IHKLR
C     ..
C     .. Common Block /RFS/ ..
      COMMON /RFS/ XRS(NDETREF),YRS(NDETREF),WXRS(NDETREF),
     +       WYRS(NDETREF),FDIST,ESTART,RMSRES,WRMSRES,
     $       WESTART,RRS(NDETREF),IHKLR(3,NDETREF),MAXREF,MAXX,
     +       MAXY,NRS,MAXR,NREJS,NCENTREF
C     ..
C
C
C&&*&& end_include  ../inc/rfs.f
C&&*&& include  ../inc/scn.f
C
C $Id: scn.f,v 1.3 2004/08/16 13:26:48 harry Exp $
C
C--- awk generated include file  scn.h
C---- START of include file scn.h
C
C     SCNSZ   is pixel size (in microns) divided by 25
C     RAST    pixel size in slow direction in mm
C     FACT    multiplying by FACT converts from 10 micron units 
C             (the standard unit internal to the program) into pixels
C     IYLEN   The number of pixels in the Y (fastest changing) direction
C             in the digitised image.
C     NREC    The number of pixels in the X (slow) direction in the 
C             digitised image.
C     NWORD   The number of I*2 words in the Y direction.
C     NBYTE   The number of bytes in Y direction = NWORD/2
C     NHBYTE  Number of bytes in header
C
C     ICURR   When several images are stored in a single file, ICURR is the
C             pointer to the first record of the current image in the direct
C             access file (only implemented for film data)
C     NEXTRA  The number of additional (unused) bytes padding the end of
C             each record in image file
C     BYTSWAP True if the "endedness" (Big-endian/Little-endian) of the 
C             machine that MOSFLM is running on is different to that of the
C             machine on which the image was written. This is determined by
C             looking at the value of NXPIX in the header record of the
C             image file (subroutine GETHDR)
C
C     LACTIVE True if using Rigaku active mask, False if ignoring it
C
C     .. Scalars in common block /SCN/ ..
      REAL FACT,SCNSZ,RAST,RASTY
      INTEGER NBYTE,NREC,NWORD,IYLEN,ICURR,NEXTRA,NHBYTE
      LOGICAL BYTSWAP,LACTIVE
C     ..
C     .. Common Block /SCN/ ..
      COMMON /SCN/ FACT,SCNSZ,RAST,RASTY,NBYTE,NREC,NWORD,IYLEN,
     +     ICURR,NEXTRA,NHBYTE,BYTSWAP,LACTIVE
C&&*&& end_include  ../inc/scn.f
C&&*&& include  ../inc/test.f
C--- awk generated include file  test.h
C---- START of include file test.h
C
C    Detector limits, used in SPTEST. All are in 10 micron units.
C    In the virtual detector frame, Y is parallel to the rotation axis
C    and X is orthogonal to the rotation axis.
C
C    In the scanner frame, X is parallel to the slow direction in the
C    image, Y is the fast direction.
C
C    RSCANSQ      Radius**2 of the scanned region of the plate (Mar scanners)
C                 This is different to the other limits because it is
C                 applied to the actual scanner coordinates rather than
C                 the virtual detector coordinates. All other limits apply
C                 to virtual detector coordinates.
C    XSCAN        Maximum X coordinate in detector frame (10 micron units)
C    YSCAN        Maximum Y coordinate in detector frame (10 micron units)
C    RSCANX,RSCANY If non-zero, these are the coordinates (10 micron units)
C                 for the centre of the circle radius RSCAN defining the
C                 useable area of the detector.
C    RMINX,RMINY If non-zero, these are the coordinates (10 micron units)
C                 for the centre of the circle radius RMIN defining the
C                 useable area of the detector.
C    RMXSQD       Maximum radius (squared) in virtual detector frame
C    RMNSQD       Minimum radius (squared) in virtual detector frame
C    XMIN         Minimum X coordinate in  detector frame
C    XMAX         Maximum X coordinate in  detector frame
C    YMIN         Minimum Y coordinate in  detector frame
C    YMAX         Maximum Y coordinate in  detector frame
C    NXYEXC       Number of excluded areas set by user (rectangles, arcs)
C    NXYEXCDET    Number of detector specific excluded rectangles (Pilatus)
C
C     .. Scalars in common block /TEST/ ..
      REAL RMXSQD,RMNSQD,XMIN,XMAX,YMIN,YMAX,RSCANSQ,RSCANX,RSCANY,
     +     RMINX,RMINY,XSCAN,YSCAN,CIRRAD
      INTEGER NEXCL,NXYEXC,NXYEXCDET,IQUADNO,IARCNO
C
C     .. Arrays in common block /TEST/
      REAL RESEXL,RESEXH,XYEXC,CNREXC,EXCARC,CIRCEN,PHILIM
      INTEGER IEXCARC
      LOGICAL LEXCARC
C     ..
C     .. Common Block /TEST/ ..
      COMMON /TEST/RESEXL(MAXEXCL),RESEXH(MAXEXCL),XYEXC(4,MAXEXCL),
     +     CNREXC(8,MAXEXCL),
     $     EXCARC(5,MAXEXCL),CIRCEN(2),PHILIM(2),RMXSQD,RMNSQD,XMIN,
     +     XMAX,YMIN,YMAX,RSCANSQ,RSCANX,RSCANY,RMINX,RMINY,XSCAN,
     $     YSCAN,CIRRAD,IEXCARC(6,MAXEXCL),NEXCL,NXYEXC,IQUADNO,
     $     IARCNO,LEXCARC(MAXEXCL),NXYEXCDET
C     ..
C
C

C&&*&& end_include  ../inc/test.f
C&&*&& include  ../inc/xy.f
C
C $Id: xy.f,v 1.1 2002/05/02 10:47:25 harry Exp $
C
C--- awk generated include file  xy.h
C---- START of include file xy.h
C
C     .. Scalars in common block /XY/ ..
      REAL XTOFD,SINV,COSV,TANV,TWOTHETA
      INTEGER ICASS
C     ..
C     .. Common Block /XY/ ..
      COMMON /XY/XTOFD,SINV,COSV,TANV,TWOTHETA,ICASS
C     ..
C
C     XTOFD....  Crystal to detector distance in 10 micron units. Read from
C                keyworded input and never changed.
C
C                Spot positions are calculated in S/R XYSPOT (Called from
C                REEK) and are for an "ideal" detector at a distance of XTOFD.
C                These are converted into pixel positions in S/R MMTOPX
C                which applies the multiplicative factor XTOFRA to allow
C                for refinement of the distance. XTOFRA is the parameter
C                that is actually refined (in RDIST), rather than XTOFD.
C                The refined distance that is printed in the logfile is
C                actually XTOFRA*XTOFD
C
C     ICASS....  Indicates detector type:
C                0     Flat film
C                1     Vee shaped cassettes
C                2     FAST detector (only used in TESTGEN mode of OSCGEN)
C                3     Swung out FAST (ditto)
C                4     IP detector
C     TWOTHETA   Detector swing angle (degrees)
C&&*&& end_include  ../inc/xy.f

C     ..
      SAVE
C
      setsocket = 0
      BIGDUMP = .FALSE.
      PI = 4.0*ATAN(1.0)
      RTOD = 180.0/PI
      RSCAN = SQRT(RSCANSQ)
      IF (RSCAN.EQ.0.0) RSCAN = 1.0
C
C---- Go to write XML if that is all that is wanted
C
      IF (XMLONLY) GOTO 150

c      IF(SOCKLO)THEN
c         WRITE(OUTLINE,FMT=6900)ID
c         CALL WRITE_SOCKET_LENGTH(SERVERFD, LENSTR(OUTLINE),
c     $        OUTLINE)
c      ENDIF
C
C---- XMID, YMID are 10 micron coordinates of centre of image, needed
C     for distortions ROFF and TOFF
C
      XMID = 0.5*REAL(NREC)/FACT
      YMID = 0.5*REAL(IYLEN)/FACT
C
C---- No. of parameters to refine. Additional parameter TOFF
C     for image plates.
C
      NP = 0
      DO 2 I = 1,NRPAR
        IF (.NOT.FIXPAR(I)) NP = NP + 1
 2    CONTINUE
C
C---- For detector centre, do not refine bulge for film data and do
C     not refine radial dependance of TOFF,ROFF for IP data (if these
C     parameters are not fixed)
C
      IF (CENTRE) THEN
        IF (IMGP) THEN
          IF (.NOT.FIXPAR(10)) NP = NP - 1
          IF (.NOT.FIXPAR(11)) NP = NP - 1
        ELSE
          IF (.NOT.FIXPAR(8)) NP = NP - 1
        END IF
      END IF
C
C---- For less than 8 reflections, refine only three params
C
      IF (NRS.LT.8) NP = 3
      NP2 = NP*NP
      IF (DEBUG(11)) THEN
        WRITE(IOUT,FMT=6001) NP,CENTRE,(FIXPAR(I),I=1,NRPAR)
        IF (ONLINE) WRITE(ITOUT,FMT=6001) NP,CENTRE,(FIXPAR(I),
     +                                    I=1,NRPAR)
 6001   FORMAT(/,1X,'Subroutine RDIST',/,1X,'Number of parameters',
     +         ' to be refined',I3,/,1X,'(CENTRE is ',L1,')',/,1X,
     +         'FIXPAR flags: ',20L3)
      END IF
C
C
      OMEGA0 = ATAN2(SINOM0,COSOM0)
C
C
      IF (LPRINT(2)) THEN
        WRITE (IOUT,FMT=6000) NRS
 6000 FORMAT (/' Detector distortion refinement using',I4,' SPOTS')
        IF (ONLINE) WRITE (ITOUT,FMT=6000) NRS
      END IF
C
C---- Get coords from generate file
C
      IF (DEBUG(11)) THEN
        IF (ONLINE) WRITE (ITOUT,FMT=6002)
 6002 FORMAT (/1X,'List of reflections used in refinement',/2X,'NO IRE',
     +       'CG    XG    YG  SDX  SDY')
        WRITE (IOUT,FMT=6002)
      END IF
C
C
      DO 10 J = 1,NRS
C  Take ABS in case partials are being used (flagged by -ve RRS)
        IR = ABS(RRS(J))
        XXGEN(J) = XG(IR)
        YYGEN(J) = YG(IR)
        BAD(J) = .FALSE.
        IF (.NOT.RWEIGHT) THEN
          WXRS(J) = 1.0
          WYRS(J) = 1.0
        END IF
C
C
   10 CONTINUE
C
C---- Initial phase angle for radial dependence of ROFF, TOFF
C
      IF (NPHI.EQ.0) THEN
        ROFFPHI = 0.0
        TOFFPHI = 0.0
      ELSE IF (NPHI.EQ.1) THEN
        ROFFPHI = 0.25*PI
        TOFFPHI = 0.25*PI
      ELSE IF (NPHI.EQ.2) THEN
        ROFFPHI = 0.5*PI
        TOFFPHI = 0.5*PI
      ELSE IF (NPHI.EQ.3) THEN
        ROFFPHI = 0.75*PI
        TOFFPHI = 0.75*PI
      END IF
      NOTRY = 0
C
C---- Return here for each new round of refinement cycles
C
   20 CONTINUE
      RESMX = 0
      RESD = 0.0
      WRESMX = 0.0
      WRESD = 0.0
C
C
      DO 30 J = 1,NRS
        XXG = XXGEN(J)
        YYG = YYGEN(J)
        WX = 1.0/WXRS(J)**2
        WY = 1.0/WYRS(J)**2
C
C            *******************************
        CALL MMTOPX(CLCX(J),CLCY(J),XXG,YYG)
C            *******************************
C
          DX = CLCX(J) - XRS(J)
          DY = CLCY(J) - YRS(J)
        IF (.NOT.BAD(J)) THEN
          RES = DX*DX + DY*DY
          RESD = RESD + RES
          WRES = WX*DX*DX + WY*DY*DY
          WRESD = WRESD + WRES
C
C
          IF (RWEIGHT) THEN
            IF (WRES.GE.WRESMX) THEN
              WRESMX = WRES
              MXJ = J
            END IF
          ELSE
            IF (RES.GE.RESMX) THEN
              RESMX = RES
              MXJ = J
            END IF
          END IF
        END IF
C
        IF (DEBUG(11).AND.BIGDUMP) THEN
          IR = ABS(RRS(J))
          IF (ONLINE) WRITE (ITOUT,FMT=6004) J,RRS(J),XG(IR),YG(IR),
     +    XRS(J),YRS(J),WXRS(J),WYRS(J),DX/WXRS(J),DY/WYRS(J),WRESMX,MXJ    
 6004 FORMAT (1X,I3,I6,4F8.1,2F6.3,5X,2F8.2,F8.0,I3)
          WRITE (IOUT,FMT=6004) J,RRS(J),XG(IR),YG(IR),XRS(J),YRS(J),
     +          WXRS(J),WYRS(J),DX/WXRS(J),DY/WYRS(J),WRESMX,MXJ
        END IF
   30 CONTINUE
C
C
      RESMX = SQRT(RESMX)
      RMSRES = SQRT(RESD/ (NRS-NOTRY+1))
      RESLIM = REFREJ*RMSRES
      WRESMX = SQRT(WRESMX)
      SWDELSQ = SQRT(WRESD)
      WRMSRES = SQRT(WRESD/ (NRS-NOTRY+1))
      WRESLIM = REFREJ*WRMSRES
C
C
      IF (NOTRY.EQ.0) THEN
        IF (LPRINT(2)) THEN
          IF (RWEIGHT) THEN
          WRITE (IOUT,FMT=6006) 0.01*RMSRES,WRMSRES
 6006 FORMAT (1X,'Starting residual=',F5.3,'mm; Weighted residual',F6.2)
          IF (ONLINE) WRITE (ITOUT,FMT=6006) 0.01*RMSRES,WRMSRES
          ELSE
          WRITE (IOUT,FMT=6007) 0.01*RMSRES
 6007 FORMAT (1X,'Starting residual=',F5.3,'mm')
          IF (ONLINE) WRITE (ITOUT,FMT=6007) 0.01*RMSRES
          END IF
        END IF
C
C
        IF (RWEIGHT) WESTART = WRMSRES
        ESTART = RMSRES
      ELSE
C
C
        IF (NOTRY.EQ.1) THEN
          IF (LPRINT(2)) THEN
            IF (RWEIGHT) THEN
            WRITE (IOUT,FMT=6012) 0.01*RMSRES,WRMSRES
 6012 FORMAT (1X,'Residual after 1 CYCLE=',F5.3,'mm; Weighted residual',
     +            F6.2)
            IF (ONLINE) WRITE (ITOUT,FMT=6012) 0.01*RMSRES,WRMSRES
            ELSE
            WRITE (IOUT,FMT=6011) 0.01*RMSRES
 6011 FORMAT (1X,'Residual after 1 CYCLE=',F5.3,'mm')
            IF (ONLINE) WRITE (ITOUT,FMT=6011) 0.01*RMSRES
            END IF
          END IF
        END IF
C
C---- Allow maximum of 10% of reflections to be rejected
C
        IF (NOTRY.GT.NRS/10) GO TO 120
        IF (RWEIGHT) THEN
CAL          IF (WRESMX.LT.WRESLIM) GO TO 120
          IF (WRESMX.LT.REFREJ) GO TO 120
        ELSE
          IF (RESMX.LT.RESLIM) GO TO 120
        END IF
        IF (DEBUG(11).AND.BIGDUMP) THEN
          WRITE(IOUT,FMT=6013) MXJ
         IF (ONLINE) WRITE(ITOUT,FMT=6013) MXJ
 6013     FORMAT(1X,'Rejecting reflection',I3,' in list')
        END IF
        BAD(MXJ) = .TRUE.
      END IF
C
C---- Start main loop
C
C---- Start loop for non-linear refinement
C
      DO 110 ICYC = 1,2
C
C---- Initialize sums
C
        DO 40 K = 1,NP
          W(K) = 0.0
   40   CONTINUE
C
C
        DO 50 K = 1,NP2
          RF(K) = 0.0
   50   CONTINUE
C
C---- Set up normal equations
C
        DO 80 J = 1,NRS
C
C
          IF (.NOT.BAD(J)) THEN
            XXG = XXGEN(J)
            YYG = YYGEN(J)
            RG = SQRT(XXG*XXG+YYG*YYG)
            XM = XXG*COSOM0 - YYG*SINOM0
            YM = YYG*COSOM0 + XXG*SINOM0
C
C                ***********************
            CALL MMTOPX(XC1,YC1,XXG,YYG)
C                ***********************
C
            PSI = ATAN2(YCEN+YM-YMID,XCEN+XM-XMID)
            CPSI = COS(PSI)
            SPSI = SIN(PSI)
            RAD = SQRT((XCEN+XM-XMID)**2+(YCEN+YM-YMID)**2)
CAL   IF (J.LT.3) THEN
CAL   WRITE(6,*),'XG,YG',XXG,YYG
CAL   WRITE(6,*),'YCEN,YMID,YM',YCEN,YMID,YM
CAL   WRITE(6,*),'XCEN,XMID,XM',XCEN,XMID,XM
CAL   WRITE(6,*),'PSI,RAD',PSI*57,RAD
CAL   END IF
            IF (IMGP) THEN
              DXTOF = TILT*XXG + XTOFRA + TWIST*YYG
            ELSE
              DXTOF = TILT*XXG + XTOFRA + TWIST*YYG + BULGE*RG
            END IF
            IPT = 0
C
C    XCEN
C
            IF (.NOT.FIXPAR(1)) THEN
              IPT = IPT + 1
              DDX(IPT) = 1.0
              DDY(IPT) = 0.0
            END IF
C
C    YCEN
C
            IF (.NOT.FIXPAR(2)) THEN
              IPT = IPT + 1
              DDX(IPT) = 0.0
              DDY(IPT) = 1.0
            END IF
C
C    OMEGA0
C
            IF (.NOT.FIXPAR(3)) THEN
              IPT = IPT + 1
              DDX(IPT) = -YM*DXTOF
              DDY(IPT) = XM*DXTOF*YSCAL
            END IF
C
C    YSCAL
C
            IF (.NOT.FIXPAR(4)) THEN
              IPT = IPT + 1
              DDX(IPT) = 0.0
              DDY(IPT) = YM*DXTOF
            END IF
C
C    XTOFRA
C
            IF (.NOT.FIXPAR(5)) THEN
              IPT = IPT + 1
              DDX(IPT) = XM
              DDY(IPT) = YSCAL*YM
            END IF
C
C    TILT
C
            IF (.NOT.FIXPAR(6)) THEN
              IPT = IPT + 1
              DDX(IPT) = XXG*XM
              DDY(IPT) = XXG*YM*YSCAL
            END IF
C
C    TWIST
C
            IF (.NOT.FIXPAR(7)) THEN
              IPT = IPT + 1
              DDX(IPT) = YYG*XM
              DDY(IPT) = YYG*YM*YSCAL
            END IF
C
C
C    ROFF or BULGE
C
C
            IF (.NOT.FIXPAR(8)) THEN
              IF (.NOT.IMGP) THEN
C
C----  Film bulge, do not refine for central region
C
                IF (.NOT.CENTRE) THEN
                  IPT = IPT + 1
                  DDX(IPT) = XM*RG
                  DDY(IPT) = YM*YSCAL*RG
                END IF
              ELSE
C
C----  Image plate, radial offset ROFF
C
                IPT = IPT + 1
                DDX(IPT) = CPSI
                DDY(IPT) = SPSI
              END IF
            END IF
C
C  fixed tangential offset TOFF
C
            IF (.NOT.FIXPAR(9)) THEN
              IPT = IPT + 1
              DDX(IPT) = -SPSI
              DDY(IPT) =  CPSI
            END IF
C
C---- Radially dependent TOFF, amplitude RDTOFF
C     Do not refine if using only spots from centre of detector
C
            IF ((.NOT.FIXPAR(10)).AND.(.NOT.CENTRE)) THEN
              IPT = IPT + 1
              DDX(IPT) = -SPSI*SIN(PI*NODES*RAD/RSCAN+TOFFPHI)
              DDY(IPT) =  CPSI*SIN(PI*NODES*RAD/RSCAN+TOFFPHI)
            END IF
C
C
C---- Radially dependent ROFF, amplitude RDROFF
C     Do not refine if using only spots from centre of detector
C
            IF ((.NOT.FIXPAR(11)).AND.(.NOT.CENTRE)) THEN
              IPT = IPT + 1
              DDX(IPT) =  CPSI*SIN(PI*NODES*RAD/RSCAN+ROFFPHI)
              DDY(IPT) =  SPSI*SIN(PI*NODES*RAD/RSCAN+ROFFPHI)
            END IF
C
C
            IF (IPT.GT.NRPAR) THEN
              WRITE(6,*)'* FATAL ERROR, NUMBER OF REFINED PARAMETERS'
              WRITE(6,*)'EXCEEDS PARAMETER NRPAR IN SUBROUTINE RDIST'
              STOP
            END IF
C
            WX = 1.0/WXRS(J)**2
            WY = 1.0/WYRS(J)**2
C
            XO = XRS(J) - XC1
            YO = YRS(J) - YC1
            IK = 0
C
C
            DO 70 I = 1,NP
              W(I) = DDX(I)*XO*WX + W(I) + DDY(I)*YO*WY
C
C
              DO 60 K = 1,NP
                IK = IK + 1
                RF(IK) = DDX(I)*DDX(K)*WX + RF(IK) + DDY(I)*DDY(K)*WY
   60         CONTINUE
   70       CONTINUE
C
C
          END IF
   80   CONTINUE
C
C
        IF (DEBUG(11).AND.BIGDUMP) THEN
          WRITE (IOUT,FMT=6008)
 6008 FORMAT (/1X,'Normal matrix RF')
          WRITE (IOUT,FMT=6010) (RF(JDO),JDO=1,NP)
 6010 FORMAT (1X,14(E10.2))
C
C
          IF (ONLINE) THEN
            WRITE (ITOUT,FMT=6008)
            WRITE (ITOUT,FMT=6010) (RF(JDO),JDO=1,NP)
          END IF
        END IF
C
C---- Solve
C
C            ********************
        CALL MINV(RF,NP,DET,IWRK1,IWRK2)
C            ********************
C
        IK = 0
C
C
        DO 100 I = 1,NP
          R(I) = 0.0
C
C
          DO 90 K = 1,NP
            IK = IK + 1
            R(I) = RF(IK)*W(K) + R(I)
   90     CONTINUE
  100   CONTINUE
C
C---- Update parameters
C
        IPT = 0
        IF (.NOT.FIXPAR(1)) THEN
          IPT = IPT + 1
          XCEN = R(IPT) + XCEN
        END IF
        IF (.NOT.FIXPAR(2)) THEN
          IPT = IPT + 1
          YCEN = R(IPT) + YCEN
        END IF
        IF (.NOT.FIXPAR(3)) THEN
          IPT = IPT + 1
          OMEGA0 = R(IPT) + OMEGA0
          SINOM0 = SIN(OMEGA0)
          COSOM0 = COS(OMEGA0)
        END IF
        IF (.NOT.FIXPAR(4)) THEN
          IPT = IPT + 1
          YSCAL = R(IPT) + YSCAL
        END IF
        IF (.NOT.FIXPAR(5)) THEN
          IPT = IPT + 1
          XTOFRA = R(IPT) + XTOFRA
        END IF
        IF (.NOT.FIXPAR(6)) THEN
          IPT = IPT + 1
          TILT = R(IPT) + TILT
        END IF
        IF (.NOT.FIXPAR(7)) THEN
          IPT = IPT + 1
          TWIST = R(IPT) + TWIST
        END IF
        IF (.NOT.FIXPAR(8)) THEN
          IF (.NOT.IMGP) THEN
            IF (.NOT.CENTRE) THEN
              IPT = IPT + 1
              BULGE = BULGE + R(IPT)
            END IF
          ELSE
            IPT = IPT + 1
            ROFF = ROFF + R(IPT)
          END IF
        END IF
        IF (.NOT.FIXPAR(9)) THEN
          IPT = IPT + 1
          TOFF = TOFF + R(IPT)
        END IF
        IF ((.NOT.FIXPAR(10)).AND.(.NOT.CENTRE)) THEN
          IPT = IPT + 1
          RDTOFF = RDTOFF + R(IPT)
        END IF
        IF ((.NOT.FIXPAR(11)).AND.(.NOT.CENTRE)) THEN
          IPT = IPT + 1
          RDROFF = RDROFF + R(IPT)
        END IF
C
C
  110 CONTINUE
C
C---- End of non-linear refinement loop
C
C---- Calculate std.devs. and test residuals
C
      NOTRY = NOTRY + 1
      GO TO 20
C
C---- Print out
C
  120 IF (NOTRY.GT.1) THEN
C
C
        IF (LPRINT(2)) THEN
          WRITE (IOUT,FMT=6014) REFREJ
 6014 FORMAT (/,2X,'REJECTS (Error>',F4.1,'*rms RESID.) coords in mm',
     +    /,1X,'      X     DELX  DELX/SIGMA   Y    DELY  DELY/SIGMA')
          IF (ONLINE) WRITE (ITOUT,FMT=6014) REFREJ
        END IF
      END IF
C
C
      NREJS = 0
C
C
      DO 130 J = 1,NRS
C
C
        IF (BAD(J)) THEN
          NREJS = NREJS + 1
          DX = XRS(J) - CLCX(J)
          DY = YRS(J) - CLCY(J)
          WDX = DX/WXRS(J)
          WDY = DY/WYRS(J)
C
C
          IF (LPRINT(2)) THEN
            IDX = XRS(J) - XCEN
            IDY = YRS(J) - YCEN
            WRITE (IOUT,FMT=6016) 0.01*IDX,0.01*DX,WDX,
     +                            0.01*IDY,0.01*DY,WDY
 6016 FORMAT (2(F10.2,F7.2,F7.1))
            IF (ONLINE) WRITE (ITOUT,FMT=6016) 0.01*IDX,0.01*DX,WDX,
     +                            0.01*IDY,0.01*DY,WDY
          END IF
        END IF
  130 CONTINUE
C
C---- Now apply smoothing to parameters
C
C
      IF ((.NOT.CENTRE).AND.(.NOT.NOSMOOTH)) THEN

        IF (DEBUG(11)) THEN
          ITWISTSM = SMTWIST/FDIST
          ITILTSM = SMTILT/FDIST
          CALL SETDIS(ITILT,ITWIST,2)

          WRITE(IOUT,FMT=6100) IPACK,NIMGSM,NSM1,NSM2,ITWISTSM,ITWIST,
     +      ITILTSM,ITILT,SMOMEGA0*RTOD,OMEGA0*RTOD,SMXTOFRA,XTOFRA,
     +      SMYSCAL,YSCAL,0.01*SMROFF,0.01*ROFF,0.01*SMTOFF,0.01*TOFF
          IF (ONLINE) WRITE(ITOUT,FMT=6100) IPACK,NIMGSM,NSM1,NSM2,
     +        ITWISTSM,ITWIST,ITILTSM,ITILT,SMOMEGA0*RTOD,
     +        OMEGA0*RTOD,SMXTOFRA,XTOFRA,SMYSCAL,YSCAL,
     +        0.01*SMROFF,0.01*ROFF,0.01*SMTOFF,0.01*TOFF
 6100     FORMAT(/,/,1X,'Before smoothing, ipack=',I5,' NIMGSM=',I5,
     +         ' NSM1 (ccom,yscal,dist) =',I5,' NSM2 (rest) =',I5,
     +         /,1X,'current twist',I5,6X,'refined twist',I5,
     +         /,1X,'current tilt',I6,6X,'refined tilt',I6,
     +         /,1X,'current omega0',F8.3,'  refined value ',F8.3,
     +         /,1X,'current XTOFRA ',F8.5,' refined value ',F8.5,
     +         /,1X,'current YSCAL',F10.5,' refined value',F9.5,
     +         /,1X,'current ROFF',F8.3,'    refined value',F8.3,
     +         /,1X,'current TOFF',F8.3,'    refined value',F8.3)
        END IF
C
C---- NSM1 no of smoothing images for CCOM,YSCALE,XTOFRA
C---- NSM2 no of smoothing images for TILT,TWIST,ROFF,TOFF
C
        CALL PARSMOOTH(IPACK,NIMGSM,NSM2,SMTWIST,TWIST)
        CALL PARSMOOTH(IPACK,NIMGSM,NSM2,SMTILT,TILT)
        CALL PARSMOOTH(IPACK,NIMGSM,NSM2,SMROFF,ROFF)
        CALL PARSMOOTH(IPACK,NIMGSM,NSM2,SMTOFF,TOFF)
        OMEGA0 = CHKANG(SMOMEGA0,OMEGA0,5.0)
        CALL PARSMOOTH(IPACK,NIMGSM,NSM1,SMOMEGA0,OMEGA0)
        CALL PARSMOOTH(IPACK,NIMGSM,NSM1,SMYSCAL,YSCAL)
        CALL PARSMOOTH(IPACK,NIMGSM,NSM1,SMXTOFRA,XTOFRA)
        TWIST = SMTWIST
        TILT = SMTILT
        ROFF = SMROFF
        TOFF = SMTOFF
        OMEGA0 = SMOMEGA0
        SINOM0 = SIN(OMEGA0)
        COSOM0 = COS(OMEGA0)
        YSCAL = SMYSCAL
        XTOFRA = SMXTOFRA
      END IF
C
      IF (DEBUG(11)) THEN
        ITWISTSM = SMTWIST/FDIST
        ITILTSM = SMTILT/FDIST
        WRITE(IOUT,FMT=6110) ITWISTSM,ITILTSM,SMOMEGA0*RTOD
        IF (ONLINE) WRITE(ITOUT,FMT=6110) ITWISTSM,ITILTSM,
     +        SMOMEGA0*RTOD
 6110   FORMAT(/,1X,'Smoothed new twist',I5,' tilt',I5,' omega0 ',F8.3)
      END IF
C
C
c     this is where things start to get printed out. There are different versions
C     of the formats for weighted and unweighted refinement and for film and other
c     types of detector.
c

      IF (RWEIGHT) THEN
      REPT = ((ESTART.GT.WELIMIT) .OR. (RMSRES.GT.WELIMIT))
      ELSE
      REPT = ((ESTART.GT.ELIMIT2) .OR. (RMSRES.GT.ELIMIT3))
      END IF
      NXD = NINT(XTOFD*XTOFRA)
C      ITILT = TILT/FDIST
C      ITWIST = TWIST/FDIST
      CALL SETDIS(ITILT,ITWIST,2)
      IF (.NOT.IMGP) IBULGE = BULGE/FDIST
      IF (IMGP) THEN
        PXCEN = 0.01*XCEN
        PYCEN = 0.01*YCEN/YSCAL
        IF (INVERTX) PXCEN = NREC*RAST - PXCEN
C
C---- IP data
C
      IF (RWEIGHT) THEN
C
        IF ((BRIEF.AND.FINAL).OR.(BRIEF.AND.(BADSTART.OR.(.NOT.REPT))))
     +    WRITE (IBRIEF,FMT=6017) 0.01*RMSRES,WRMSRES,PXCEN,
     +    PYCEN,XTOFRA,0.01*NXD,YSCAL,ITILT,ITWIST,0.01*ROFF,
     +    0.01*TOFF,0.01*RDROFF,0.01*RDTOFF

        call dna_output_table_start('integration_results')
        call dna_output_list_start('final_residuals')
        call dna_output_real_item('rms', 0.01 * rmsres)
        call dna_output_real_item('weighted', wrmsres)
        call dna_output_real_item('xcen', pxcen)
        call dna_output_real_item('ycen', pycen)
        call dna_output_real_item('xtofra', xtofra)
        call dna_output_real_item('xtofd', 0.01 * nxd)
        call dna_output_real_item('yscale', yscal)
        call dna_output_list_end
        call dna_output_table_end

        IF (DEBUG(11)) THEN
          WRITE(IOUT,FMT=6032) RDROFF,ROFFPHI,RDTOFF,TOFFPHI,NODES,
     +                        SWDELSQ
          IF (ONLINE) WRITE(ITOUT,FMT=6032) RDROFF,ROFFPHI,RDTOFF,
     +                TOFFPHI,NODES,SWDELSQ
 6032     FORMAT(1X,'RDROFF',F8.2,'  ROFFPHI',F7.4,' RDTOFF',F8.2,
     +         '  TOFFPHI',F7.4,'   NODES=',I3,'  SWDELSQ',F10.2)
        END IF
C
        IF (SPIRAL) THEN
          WRITE (IOUT,FMT=6017) 0.01*RMSRES,WRMSRES,PXCEN,PYCEN,
     +     XTOFRA,0.01*NXD,YSCAL,ITILT,ITWIST,0.01*ROFF,0.01*TOFF,
     +     0.01*RDROFF,0.01*RDTOFF
 6017 FORMAT (' Final rms residual:',F8.3,'mm; Weighted residual',F7.1,
     +       /3X,'XCEN    YCEN  XTOFRA ',
     +       '  XTOFD  YSCALE  TILT TWIST   ROFF   TOFF RDROFF RDTOFF',
     +       /1X,F6.2,F8.2,F8.4,F8.2,F8.4,2I6,4F7.3)
          IF (ONLINE) WRITE (ITOUT,FMT=6017) 0.01*RMSRES,WRMSRES,PXCEN,
     +      PYCEN,XTOFRA,0.01*NXD,YSCAL,ITILT,ITWIST,0.01*ROFF,
     +      0.01*TOFF,0.01*RDROFF,0.01*RDTOFF
        ELSE      
          WRITE (IOUT,FMT=6030) 0.01*RMSRES,WRMSRES,PXCEN,PYCEN,
     +     XTOFRA,0.01*NXD,YSCAL,ITILT,ITWIST
 6030 FORMAT (' Final rms residual:',F8.3,'mm; Weighted residual',F7.1,
     +       /3X,'XCEN    YCEN  XTOFRA ',
     +       '  XTOFD  YSCALE  TILT TWIST',
     +       /1X,F6.2,F8.2,F8.4,F8.2,F8.4,2I6)
          IF (ONLINE) WRITE (ITOUT,FMT=6030) 0.01*RMSRES,WRMSRES,PXCEN,
     +      PYCEN,XTOFRA,0.01*NXD,YSCAL,ITILT,ITWIST
        END IF
      ELSE
C
C---- If NOT RWEIGHT
C
        IF ((BRIEF.AND.FINAL).OR.(BRIEF.AND.(BADSTART.OR.(.NOT.REPT))))
     +    WRITE (IBRIEF,FMT=6019) 0.01*RMSRES,PXCEN,
     +    PYCEN,XTOFRA,0.01*NXD,YSCAL,ITILT,ITWIST,0.01*ROFF,
     +    0.01*TOFF,0.01*RDROFF,0.01*RDTOFF

        call dna_output_table_start('integration_results')
        call dna_output_list_start('final_residuals')
        call dna_output_real_item('rms', 0.01 * rmsres)
        call dna_output_real_item('weighted', wrmsres)
        call dna_output_real_item('xcen', xcen)
        call dna_output_real_item('ycen', ycen)
        call dna_output_real_item('xtofra', xtofra)
        call dna_output_real_item('xtofd', 0.01 * nxd)
        call dna_output_real_item('yscale', yscal)
        call dna_output_list_end
        call dna_output_table_end



        IF (SPIRAL) THEN
          WRITE (IOUT,FMT=6019) 0.01*RMSRES,PXCEN,PYCEN,
     +      XTOFRA,0.01*NXD,YSCAL,ITILT,ITWIST,0.01*ROFF,0.01*TOFF,
     +      0.01*RDROFF,0.01*RDTOFF
 6019 FORMAT (' Final rms residual:',F8.3,'mm',
     +       /3X,'XCEN    YCEN  XTOFRA ',
     +       '  XTOFD  YSCALE  TILT TWIST   ROFF   TOFF',
     +       ' RDROFF RDTOFF'/1X,F6.2,
     +       F8.2,F8.4,F8.2,F8.4,2I6,4F7.3)
          IF (ONLINE) WRITE (ITOUT,FMT=6019) 0.01*RMSRES,PXCEN,
     +      PYCEN,XTOFRA,0.01*NXD,YSCAL,ITILT,ITWIST,0.01*ROFF,
     +      0.01*TOFF,0.01*RDROFF,0.01*RDTOFF
        ELSE
          WRITE (IOUT,FMT=6034) 0.01*RMSRES,PXCEN,PYCEN,
     +      XTOFRA,0.01*NXD,YSCAL,ITILT,ITWIST
 6034 FORMAT (' Final rms residual:',F8.3,'mm',
     +       /3X,'XCEN    YCEN  XTOFRA ',
     +       '  XTOFD  YSCALE  TILT TWIST',/1X,F6.2,
     +       F8.2,F8.4,F8.2,F8.4,2I6)
          IF (ONLINE) WRITE (ITOUT,FMT=6034) 0.01*RMSRES,PXCEN,
     +      PYCEN,XTOFRA,0.01*NXD,YSCAL,ITILT,ITWIST
        END IF
      END IF
C
      ELSE
C
C---- Film data
C
      IF (RWEIGHT) THEN
      WRITE (IOUT,FMT=6018) 0.01*RMSRES,WRMSRES,0.01*XCEN,
     +   0.01*YCEN/YSCAL,XTOFRA,0.01*NXD,YSCAL,ITILT,ITWIST,0.01*IBULGE
 6018 FORMAT (' Final rms residual:',F8.3,'mm; Weighted residual',F7.1,
     +       /6X,'XCEN    YCEN  XTOFRA ',
     +       '  XTOFD  YSCALE    TILT   TWIST   BULGE',/2X,2F8.2,F8.4,
     +       F8.2,F8.4,2I8,F8.2)
      IF (ONLINE) WRITE (ITOUT,FMT=6018) 0.01*RMSRES,WRMSRES,0.01*XCEN,
     +      0.01*YCEN/YSCAL,XTOFRA,0.01*NXD,YSCAL,ITILT,ITWIST,
     +      0.01*IBULGE
      ELSE
      WRITE (IOUT,FMT=6021) 0.01*RMSRES,0.01*XCEN,0.01*YCEN/YSCAL,
     +   XTOFRA,0.01*NXD,YSCAL,ITILT,ITWIST,0.01*IBULGE
 6021 FORMAT (' Final rms residual:',F8.3,'mm',
     +       /6X,'XCEN    YCEN  XTOFRA ',
     +       '  XTOFD  YSCALE    TILT   TWIST   BULGE',/2X,2F8.2,F8.4,
     +       F8.2,F8.4,2I8,F8.2)
      IF (ONLINE) WRITE (ITOUT,FMT=6021) 0.01*RMSRES,0.01*XCEN,
     +      0.01*YCEN/YSCAL,XTOFRA,0.01*NXD,YSCAL,ITILT,ITWIST,
     +      0.01*IBULGE
      END IF
      END IF
C
C---- Print refined fiducial constants
C 
      CCX = XCEN - XCENF
      PCCX = CCX
      IF (INVERTX) PCCX = -PCCX
C
C---- CCY is in "pixels" rather than mm, so do NOT divide by YSCAL
C     here, but do divide when printing.
C
CAL      CCY = YCEN/YSCAL - YCENF
      CCY = YCEN - YCENF
C
C
      CCOM = (OMEGA0-OMEGAF)*RTOD
      IF (CCOM.LT.-180.0) CCOM = CCOM + 360.0
      WRITE (IOUT,FMT=6020) 0.01*PCCX,0.01*CCY/YSCAL,CCOM
 6020 FORMAT (' Refined Fiducial constants (mm and degrees)',
     +   /,1X,' CCX: ',F8.2,'   CCY: ',F8.2,'  CCOM:',F10.4)
C
C---- Only write xml for refinement over whole image
C
 150  socklo = ((setsocket.eq.1).or.socklo)
      IF (SOCKLO.AND.((.NOT.CENTRE).OR.XMLONLY)) THEN
         IF(SPIRAL)THEN
           WRITE(OUTLINE,FMT=7000)SHORTFN(1:LENSTR(SHORTFN)),
     $          PXCEN,PYCEN,pycen*yscal,0.01 * NXD,YSCAL,
     $          REAL(ITILT)*0.01,REAL(ITWIST)*0.01,0.01*TOFF,
     $          0.01*ROFF,CCOM,0.01*RMSRES,
     $          WRMSRES,0.01*CRMSRES
         ELSE
            WRITE(OUTLINE,FMT=7100)SHORTFN(1:LENSTR(SHORTFN)),
     $          PXCEN,PYCEN,pycen*yscal,0.01 * NXD,YSCAL,
     $           REAL(ITILT)*0.01,REAL(ITWIST)*0.01,
     $          0.01*RMSRES,WRMSRES,0.01*CRMSRES
         ENDIF
         CALL WRITE_SOCKET_LENGTH(SERVERFD, LENSTR(OUTLINE),
     $        OUTLINE)
         IF (XMLONLY) RETURN
      ENDIF
      IF (ONLINE) WRITE (ITOUT,FMT=6020) 0.01*PCCX,0.01*CCY/YSCAL,CCOM
      IF ((BRIEF.AND.FINAL).OR.(BRIEF.AND.(BADSTART.OR.(.NOT.REPT))))
     +   THEN
           WRITE (IBRIEF,FMT=6020) 0.01*PCCX,0.01*CCY/YSCAL,CCOM
           IF (.NOT.GRAPH) CALL MPAUSE
         END IF
C
C
      IF (WINOPEN.AND.DISP_IO3.AND.(.NOT.CENTRE)) THEN
        WRITE(LINE,FMT=6040) 0.01*RMSRES,WRMSRES
 6040   FORMAT('Rms residual',F6.2,'mm, weighted residual',
     +         F6.1)
        CALL MXDWIO(LINE,22)
      END IF        
C
C---- Save value of residual for centre of image for writing to xml later.
C
      IF (CENTRE) CRMSRES = RMSRES

c     format statements for the writing out of the XML
c     these are down here so that they don't clutter up the code
C     ..
C     .. replacement XML for Geoff's GUI ... 
 6900 FORMAT ('<?xml version="1.0"?>',
     $     '<!DOCTYPE integration_positional_refinement_begin>',
     $     '<integration_positional_refinement_begin>',
     $     '<status>',
     $     '<code>ok</code>',
     $     '</status>',
     $     '<image_name>',A,'</image_name>',
     $     '</integration_positional_refinement_begin>')
 7000 FORMAT ('<?xml version="1.0"?>',
     $     '<!DOCTYPE integration_positional_refinement>',
     $     '<integration_positional_refinement>',
     $     '<status><code>ok</code></status>',
     $     '<image_name>',A,'</image_name>',
     $     '<beam_x>',F8.2,'</beam_x>',
     $     '<beam_y>',F8.2,'</beam_y>',
     $     '<beam_y_corrected>',F8.2,'</beam_y_corrected>',
     $     '<distance>',F7.1,'</distance>',
     $     '<yscale>',F8.4,'</yscale>',
     $     '<tilt>',F7.2,'</tilt>','<twist>',F7.2,'</twist>',
     $     '<tangential_offset>',F7.2,'</tangential_offset>',
     $     '<radial_offset>',F7.2,'</radial_offset>',
     $     '<ccomega>',F7.2,'</ccomega>',
     $     '<global_absolute_rms_residual>',F8.3,
     $     '</global_absolute_rms_residual>',
     $     '<global_weighted_rms_residual>',F7.2,
     $     '</global_weighted_rms_residual>',
     $     '<central_absolute_rms_residual>',F8.3,
     $     '</central_absolute_rms_residual>',
     $     '</integration_positional_refinement>')
C     ..
C     .. need to replace the "0.00" for ROFF & TOFF sometime with an "undefined" value.
 7100 FORMAT ('<?xml version="1.0"?>',
     $     '<!DOCTYPE integration_positional_refinement>',
     $     '<integration_positional_refinement>',
     $     '<status><code>ok</code></status>',
     $     '<image_name>',A,'</image_name>',
     $     '<beam_x>',F8.2,'</beam_x>',
     $     '<beam_y>',F8.2,'</beam_y>',
     $     '<beam_y_corrected>',F8.2,'</beam_y_corrected>',
     $     '<distance>',F7.1,'</distance>',
     $     '<yscale>',F8.4,'</yscale>',
     $     '<tilt>',F7.2,'</tilt>','<twist>',F7.2,'</twist>',
     $     '<tangential_offset>  0.00</tangential_offset>',
     $     '<radial_offset>  0.00</radial_offset>',
     $     '<global_absolute_rms_residual>',F8.3,
     $     '</global_absolute_rms_residual>',
     $     '<global_weighted_rms_residual>',F7.2,
     $     '</global_weighted_rms_residual>',
     $     '<central_absolute_rms_residual>',F8.3,
     $     '</central_absolute_rms_residual>',
     $     '</integration_positional_refinement>')
      END
C $Id: refrt1.f,v 1.19 2008/08/13 13:53:22 harry Exp $
C==   REFRT1 ==
C     
      SUBROUTINE REFRT1(NADD,NPOINT,NIMAG,NOREFCELL,NEWPREF,ISTAT)
C     ===========================================================
      IMPLICIT NONE
C     
C    DEBUG(40) this subroutine, k/w DEBUG REFRT1.
C    also DEBUG(77) DEBUG STATS for histogram output.
C---- Refines orientation and cell parameters
C     either when data from only one image available or
C     if the missetting angles are refined separately for several images.
C     In these cases, the missetting angle around the X-ray beam (PSIX)
C     is not refined as it is not determined.
C     
C     Modifications to allow several images Feb 1992.
C     
C     Correct formulation of weighting in least squares. This will not
C     have any effect as in practice unit weights are always used.
C     2nd June 1994
C     
C    NADD....   For old-style post refinement:
C               Number of images to be added together for use in 
C               post-refinement. Note than when NADD>1 but NIMAG<NADD
C               then the value passed into idxref from postrefl is 1
C               rather than the true NADD.
C
C               For old-style post refinement (NEWPREF):
C               The number of parameters sets to be refined.
C
C     NPOINT...  Pointer to the first reflection to be used in this refinement
C               in the reflection arrays. This is only anything other
C               than 1 when NADD>1 but NIMAG<NADD with traditional
C               post-refinement. 
C               With new style post-refinement it is 1, unless doing 
C               POSTREF SEGMENT and NIMAG<NADD.
C     
C     NIMAG...  The number of images available when doing newstyle
C               post refinement (NEWPREF).
C     
C     The way in which the refined parameters are stored is somewhat complex.
C     The array PARM contains the following
C     
C     1               ThetaX(1)
C     2               ThetaY(1)    Missetting angles
C     3               ThetaZ(1)
C     4               Cell_1
C     5               Cell_2     These are the REFINED cell parameters
C     .                 .           (edges and angles)
C     .                 .
C     .                 .
C     NC+3            Cell_NC
C     NC+3+1          ThetaX(2)
C     NC+3+2          ThetaY(2)  Missets
C     NC+3+3          ThetaZ(2)
C     NC+3+4          ThetaX(3)         
C     NC+3+5          ThetaY(3)  Missets
C     NC+3+6          ThetaZ(3)
C     .
C     .
C     .
C     NC+(NADD-1)*3+1 ThetaX(NADD)
C     NC+(NADD-1)*3+2 ThetaY(NADD)
C     NC+(NADD-1)*3+3 ThetaZ(NADD)
C     Optional
C     NC+NADD*3+1     DIVH or EPS
C     NC+NADD*3+2     DIVV
C     
C     NC is the number of REFINED cell parameters
C     NADD is the number of images included in the refinement
C     Subscripts as in ThetaX(1) are:
C     1 refers to current image
C     2 refers to previous image
C     3 refers to image before that and so on
C     
C     Array DR (contains shifts)
C     1               PsiY(1)
C     2               PsiZ(1)    Missetting angles
C     3               Cell_1
C     4               Cell_2     These are the REFINED cell parameters
C     .                 .           (edges and angles)
C     .                 .
C     .                 .
C     NC+2            Cell_NC
C     NC+2+1          PsiY(2)
C     NC+2+2          PsiZ(2)
C     NC+2+3          PsiY(3)
C     NC+2+4          PsiZ(3)         
C     NC+2+5          PsiY(4)
C     NC+2+6          PsiZ(4)
C     .
C     .
C     .
C     NC+(NADD-1)*2+1 PsiY(NADD)
C     NC+(NADD-1)*2+2 PsiZ(NADD)
C     Optional
C     NC+NADD*2+1     DIVH or EPS
C     NC+NADD*2+2     DIVV
C     ..
C     .. Parameters ..
C&&*&& include  ../inc/parameter.f
C
C $Id: parameter.f,v 1.17 2009/10/28 16:43:34 harry Exp $
C
C--- awk generated include file  parameter.h
C---- START of include file parameter.h
C
C       PARAMETERS
C       IYLENGTH.. maximum number of I*2 words of data in the 
C                  "fast" (ie most rapidly changing) direction in the
C                  digitised image. This will be HALF the number of pixels
C                  for film data (each pixel is stored in one byte)
C                  but will equal the number of pixels for IP data.
C       IXWDTH...  The maximum number of "stripes" of data in the scanned image
C                  ie the number of pixels in the "slow" direction
C                  (This is the Y direction in the MOSFLM convention)
C                  Note that the array "IMAGE" used to store the image is
C                  declared as size IYLENGTH*IXWDTH I*2 words for IP data
C                  and 2*IYLENGTH*IXWDTH BYTES for film data.
C                  If this exceeds the
C                  available memory, set ixwdth=1, recompile program
C                  and use keyword "NOCORE" when running program.
C                  Note that for the POSTREF and ADDPART options,
C                  two images have to be stored in memory at once so
C                  IXWDTH should be twice the number of records in an
C                  image.
C       MAXHEAD    maximum length of image header (in 4 byte words)
C       NREFLS.... maximum number of spots per film in generate file (250,000)
C       MAXBOX.... maximum number of pixels in measurement box (1500)
C       MAXDIM.... maximum box size in either direction (pixels) (41)
C       MAXPAX.... maximum number of packs per generate file (10000)
C       MXDOV2..... maxdim/2
C       MAXBUFF... maximum size of buffer (I*2) for storing ods
C                  of active spots in subroutine meas(21,000).
C                  Must be .GE.  MAXBOX*(NNLINE-1) for subroutine process
C       MREF...... maximum number of reflections to be used in post
C                  refinement (6000)
C       NEXPAND... maximum number of expansions of the input measurement
C                  box (2)
C       NMASKS.... maximum number of different profiles (25). Note the
C                  connection between this parameter and NNLINE
C       NVECT..... maximum number of vectors for storing scanned image
C                  in filmplot (10000)
C       NIMAX..... maximum number of images to be used together in 
C                  postrefinement (NADD or WIDTH options) (100)
C       NNLINE...  maximum number of boundary lines for setting up
C                  the areas for profile fitting. The maximum possible
C                  number of standard profiles will be (NNLINE-1)**2
C                  although for a circular detector the actual number
C                  may be less than this as some boxes will lie entirely
C                  outside the detector.
C       NREJMAX... Maximum number of rejected background pixels, resulting
C                  either from overlap of adjacent spots or outliers from
C                  the background plane
C       NSPOTS...  Maximum number of found spots (for autoindexing) that can
C                  be stored (for all images). Also maximum number in 
C                  a file wriitten by IMSTILLS that can be 
C                  stored/displayed/edited. THis must be an even number
C       MCOLS....  Number of columns in output MTZ file
C       MCOLSTR..  Number of columns in output MTZ file for strategy option
C     
C       MTZ Orientation block
C        MBLENG is total length of block, MBLINT, MBLREA are numbers
C          of integers & reals
C       NDETREF    Maximum number of reflections used for detector parameter
C                  refinement (previously 62)
C       NRPAR....  Maximum number of refineable parameters for detector
C                  positional refinement (subroutine RDIST)
C       NSEGMAX..  Maximum number of segments in STRATEGY
C       NSEGMAXPR  Maximum number of segments in POST-REFINEMENT
C       MULTMAX... Maximum number of observations with same hkl in COMPLETE
C       MAXDIFF... Maximum number of different packs that a given hkl occurs on
C       NRESBIN... Maximum number of resolution bins (COMPLETE)
C
C       MAXIMG...  Maximum number of images that can be read in using the IMAGE
C                  keyword or the "read Image" menu option.
C       MXSPOT...  Maximum number of spots that can be found on one image
C                  (before rejection on spot size).
C       MXCENT...  Maximum number of active spots during spot finding 
C                  (findspots)
C
C       MGRA, NGRA... maximum number of reflections and images over which a 
C                     reflection can be spread for postrefinement.
C       MAXBGBOX    Maximum number of local background background boxes 
C                   in X and Y
C
C       MAXNPEAKS   Maximum number of local maxima within one spot
C       MAXEXCL     Maximum number of excluded areas of the same type
C                   eg reactangles, quadrilaterals, arcs, resolution shells
C
C     .. Parameters ..
      INTEGER IXWDTH
c      PARAMETER (IXWDTH=8192)
      PARAMETER (IXWDTH=12288)
      INTEGER IYLENGTH
c      PARAMETER (IYLENGTH=4096)
      PARAMETER (IYLENGTH=6144)
      INTEGER MAXHEAD
      PARAMETER (MAXHEAD=5120)
      INTEGER MAXBOX
      PARAMETER (MAXBOX=3000)
      INTEGER MAXDIM
      PARAMETER (MAXDIM=41)
      INTEGER MAXPAX
      PARAMETER (MAXPAX=10000)
      INTEGER MXDOV2
      PARAMETER (MXDOV2=MAXDIM/2)
      INTEGER NEXPAND
      PARAMETER (NEXPAND=2)
      INTEGER NNLINE
      PARAMETER (NNLINE=8)
      INTEGER NMASKS
      PARAMETER (NMASKS=49)
      INTEGER MAXBUFF
      PARAMETER (MAXBUFF=21000)
      INTEGER NREFLS
      PARAMETER (NREFLS=250000)
      INTEGER MREF
      PARAMETER (MREF=6000)
      INTEGER NVECT
      PARAMETER (NVECT=10000)
      INTEGER NIMAX
      PARAMETER (NIMAX=100)
      INTEGER NREJMAX
      PARAMETER (NREJMAX=1000)
      INTEGER NSPOTS
      PARAMETER (NSPOTS=5000)
      INTEGER MCOLS
      PARAMETER (MCOLS=18)
      INTEGER MCOLSTR
      PARAMETER (MCOLSTR=6)
      INTEGER NREFSTR
C
C---- Each reflection for strategy run needs MCOLSTR I*2 words
C     plus an I*4 word for the merging
C
      PARAMETER (NREFSTR = IXWDTH*IYLENGTH/(2+MCOLSTR))
      INTEGER MBLENG,MBLINT,MBLREA
      PARAMETER (MBLENG=185,MBLINT=29,MBLREA=156)
      INTEGER NDETREF
      PARAMETER (NDETREF=400)
      INTEGER NRPAR
      PARAMETER (NRPAR=14)
      INTEGER NSEGMAX
      PARAMETER (NSEGMAX=100)
      INTEGER NSEGMAXPR
      PARAMETER (NSEGMAXPR=100)
      INTEGER MULTMAX
      PARAMETER (MULTMAX=100)
      INTEGER MAXDIFF
      PARAMETER (MAXDIFF=100)
      INTEGER NRESBIN
      PARAMETER (NRESBIN=20)
      INTEGER MXSPOT
      PARAMETER (MXSPOT=5000)      
      INTEGER MAXIMG
      PARAMETER (MAXIMG=100)      
      INTEGER NPIXBG
      PARAMETER (NPIXBG=51)
      INTEGER MXCENT
      PARAMETER (MXCENT=500)
      INTEGER    NGRA,MGRA
      PARAMETER (NGRA=20)
      PARAMETER (MGRA=50000)
      INTEGER MAXBGBOX
      PARAMETER (MAXBGBOX=500)
      INTEGER MAXNPEAKS
      PARAMETER (MAXNPEAKS=500)
      INTEGER MAXEXCL
      PARAMETER (MAXEXCL=50)
C&&*&& end_include  ../inc/parameter.f
C     ..
C     .. Scalar arguments
      INTEGER NADD,NPOINT,NIMAG,ISTAT
      LOGICAL NOREFCELL,NEWPREF
C     ..
C     .. Local Scalars ..
      REAL AM,ANG,BBPHI,CAVP,CFX,CFY,CFZ,COSTH,CP,CPX,CPY,CPZ,
     +     DIVERG,DST,DSTSQ,EH,EV,FM,PHIP,PHIX,PHIY,PHIZ,PSIX,PSIY,
     +     PSIZ,RC,RO,SAVP,SFX,SFY,SFZ,SIGRSQ,SP,SPX,SPY,SPZ,TERM,
     +     TWOEPS,XSQ,XX,YSQ,YY,ZSQ,ZZ,PHIOLD,PHIXX,PHIYY,PHIZZ,
     +     PSIXX,PSIYY,PSIZZ,STEMP,OMEGA0
      INTEGER I,IJ,IM,J,JJ,K,KREJ,NANG,NCYC,NNP,NNPHI,NPP,NPS,NPSTOR,
     +     IPT,NTOTVAR,NPLUS,KP,NSEARCH,NSEARCH10,NRREF,NDBG
      LOGICAL LAST,NEWPHI
      CHARACTER CALLEDFROM*80
C     ..
C     .. Local Arrays ..
      REAL C(3,3),CELLX(6),CX(3,3),CY(3,3),CZ(3,3),DANG(MREF),
     +     DR(11+NIMAX*2),P(3,3),PC(3,3),PCA(3,3),PSI(3*NIMAX),
     +     S(11+NIMAX*2),X(3),
     +     R(11+NIMAX*2),Q((11+NIMAX*2)*(11+NIMAX*2)),
     +     PHIPAR(NIMAX)
C     
C---  local arrays for eigenvalue and eigenvector determination, and
C     shift calculation; N.B. the array of eigenvectors is stored in a big 
C     1D matrix which actually makes life easier!
C     
      DOUBLE PRECISION QINV((11+NIMAX*2)*(11+NIMAX*2))
C hrp 01.05.2003 - these don't seem to be used...
C     $     EIGVAL(11+NIMAX*2),
C     $     EIGVEC((11+NIMAX*2)*(11+NIMAX*2))
C      INTEGER IWRK1(11+NIMAX*2),IWRK2(11+NIMAX*2)
      INTEGER NPARTIA(21)
C     ..
C     .. External Subroutines ..
      EXTERNAL CLEAR,MATMUL3,MATSET,MINV,PHTOPS,PSTOPH,RECCEL,
     +     SHUTDOWN
C     ..
C     .. Intrinsic Functions ..
      INTRINSIC ABS,ASIN,ATAN2,REAL,SQRT,COS,SIN
C     ..
C     .. Common blocks ..
C&&*&& include  ../inc/amatch.f
C
C $Id: amatch.f,v 1.1 2002/05/02 10:46:40 harry Exp $
C
C--- awk generated include file  amatch.h
C---- START of include file amatch.h
C
C
C     .. Scalars in Common /AMATCH/ ..
C     ..
      REAL RCONV,OVRLAP,RESOL1,RESOL2,AELIMIT,ARMSLIM,
     +     SECANGLE,DAMP,TRUECCOM,ETAMAX,AWRMSLIM,MOSNEW,
     $     SLOPE,INTERCEPT
      INTEGER NSTEP,NCYCA,NPASS,N2,N3,N4,N5,N6,N7,N8,N9,N10,NBEAM
      LOGICAL MATCH,NOCENT,NOREFINE,RMOSAIC
C     ..
C     .. Common block /AMATCH/  ..
      COMMON /AMATCH/RCONV,OVRLAP,RESOL1,RESOL2,AELIMIT,ARMSLIM,
     +     SECANGLE,DAMP,TRUECCOM,ETAMAX,AWRMSLIM,MOSNEW,
     $     SLOPE,INTERCEPT,NSTEP,NCYCA,NPASS,N2,N3,N4,N5,N6,N7,
     $     N8,N9,N10,NBEAM,MATCH,NOCENT,NOREFINE,RMOSAIC
C     ..
C
C
C&&*&& end_include  ../inc/amatch.f
C&&*&& include  ../inc/cell.f
C
C $Id: cell.f,v 1.3 2005/05/20 15:05:07 harry Exp $
C
C--- awk generated include file  cell.h
C---- START of include file cell.h
C
C     CELL cell dimensions (real space)
C     RCELL reciprocal cell parameters in dimensionless rlu
C
C     .. Arrays in Common /CELLCOM/ ..
      REAL UMAT,BMAT,GMAT,CELL,RCELL,UMATCELL,SOFTCELL,VOLUME
      INTEGER LCELL,ICRYST,NUMSPG,NLAUE
C     ..
C     .. Common Block /CELLCOM/ ..
      COMMON /CELLCOM/UMAT(3,3),BMAT(3,3),GMAT(3,3),CELL(6),RCELL(6),
     $       UMATCELL(6),SOFTCELL,VOLUME,LCELL(6),ICRYST,NUMSPG,NLAUE
C     ..
C
C
C&&*&& end_include  ../inc/cell.f
C&&*&& include  ../inc/debug.f
C
C $Id: debug.f,v 1.2 2008/07/24 09:42:21 andrew Exp $
C
C--- awk generated include file  debug.h
C---- START of include file debug.h
C
C
C
C     .. Arrays in common /DEBUG/ ..
      REAL XWARN
      INTEGER NDEBUG,IWARN
      LOGICAL DEBUG,LPRINT,DUMP,WARN
C
C     .. Scalars in common /DEBUG/ ..
      REAL BGRLIM
      INTEGER NDUMP,IDUMP,MXDUMP
      LOGICAL SPOT
C     
C     ..
C     .. Common Block /DEBUG/..
      COMMON /DEBUG/XWARN(20,100),BGRLIM,NDEBUG(100),IWARN(20,100),
     $       NDUMP,IDUMP,MXDUMP,DEBUG(100),LPRINT(20),DUMP(30),
     +       WARN(100),SPOT
C     ..
C
C&&*&& end_include  ../inc/debug.f
C&&*&& include  ../inc/fid.f
C
C $Id: fid.f,v 1.5 2007/11/06 12:49:03 harry Exp $
C
C--- awk generated include file  fid.h
C---- START of include file fid.h
C
C     XCENF,YCENF  Coordinates (in 10 micron units) of the direct beam
C                  position relative to an origin at the position of the
C                  first pixel in the digitised image.(The SCANNER
C                  coordinate frame).
C                  For IP data this comes from the defined
C                  direct beam coordinates, for film data it is the
C                  midpoint of fiducials 1 and 3.
C
C     CCX,CCY      The difference (in 10 micron units) between the
C                  refined position of the direct beam (XCEN,YCEN) and
C                  the ideal direct beam coordinates (XCENF,YCENF),
C                  in the SCANNER coordinate frame.
C                  CCX,CCY are updated in RDIST. They are in "pixels"
C                  rather than mm (but expressed in 10micron units).
C
C     DTOFD        The distance (in 10 micron units) from the crystal
C                  to the detector along a normal to the detector.
C                  For flat, unswung detectors, or swung on a 2 theta arm,
C                  this is the same as CTOFD and XTOFD. It differs for
C                  Vee shaped cassettes. Assigned in START and never changed.
C                  Only actually used in RMAXR for calculating box sizes.
C
C     .. Arrays in common /FID/ ..
      REAL CCOMABC
      INTEGER FSPOS,CCXABC,CCYABC
C     ..
C     .. Scalars in common /FID/ ..
      REAL OMEGAF,OMEGAFD,CCOM,DTOFD,XCENF,YCENF
      INTEGER MM,MMDB,NFID,CCX,CCY,IYOFF,LABVIEW
      CHARACTER SPOTFILEORIGIN*2,SPOTFILEAXISORDER*2,SWINGAXIS*2
C     ..
C     .. Common block /FID/ ..
      COMMON /FID/CCOMABC(3),OMEGAF,OMEGAFD,CCOM,DTOFD,XCENF,YCENF,
     $     FSPOS(4,2),
     +     CCXABC(3),CCYABC(3),MM,MMDB,NFID,CCX,CCY,IYOFF,LABVIEW,
     $     SPOTFILEORIGIN,SPOTFILEAXISORDER,SWINGAXIS
C     ..
C
C
C&&*&& end_include  ../inc/fid.f
C&&*&& include  ../inc/idxall.f
C
C $Id: idxall.f,v 1.2 2008/08/13 13:53:22 harry Exp $
C
C--- awk generated include file  idxall.h
C---- START of include file idxall.h
C
C     ..
C     .. Scalars in Common /IDXALL/ ..
      REAL ANGLIM,RMSR
      INTEGER IC,ICMAX,IPRINT,NA,NC,NP,NR,NRSEG,OLDSEG,NS
      LOGICAL HKL,ISYNL
C     ..
C     .. Arrays in Common /IDXALL/ ..
      REAL F,PARM,PHI,SIG,WW,PHIIM
      INTEGER IH,IK,IL,IPARPOINT
C     ..
C     .. Common block /IDXALL/  ..
      COMMON /IDXALL/F(MREF),PARM(6+NIMAX*3+2),PHI(MREF),
     $       SIG(11+NIMAX*2),WW(MREF),PHIIM(NIMAX),ANGLIM,
     +       RMSR,IH(MREF),IK(MREF),IL(MREF),IPARPOINT(NIMAX),
     +       IC,ICMAX,IPRINT,NA,NC,NP,NR,NRSEG,OLDSEG,NS,HKL,ISYNL
C     ..
C
C
C&&*&& end_include  ../inc/idxall.f
C&&*&& include  ../inc/idxcell.f
C
C $Id: idxcell.f,v 1.1 2002/05/02 10:46:51 harry Exp $
C
C--- awk generated include file  idxcell.h
C---- START of include file idxcell.h
C
C     ..
C     ..
C     .. Arrays in Common /IDXCELL/  ..
      REAL DUBDCC
C     ..
C     .. Common blocks ..
       COMMON /IDXCELL/ DUBDCC(3,3,6)
C     ..
C
C
C&&*&& end_include  ../inc/idxcell.f
C&&*&& include  ../inc/ioo.f
C
C $Id: ioo.f,v 1.7 2009/05/13 11:57:53 harry Exp $
C
C--- awk generated include file  ioo.h
C---- START of include file ioo.h
C
C
C
C     .. Scalars in common block /IOO/ ..
      INTEGER IOUT,IUNIT,ITIN,ITOUT,INOD,INMO,IDU,NWRN,IBRIEF,ISUMMR,
     +        ICOORD,SERVERFD,SERVERFDIN,NSHUTERR,dnafd
      LOGICAL ONLINE,ONEFILE,FHEADER,BRIEF,GRAPH,IOERR,
     $     NODISPLAY,LBELL,JPGOUT,SOCKLO,LBEST,dnaout,INMOOPEN,
     $     XMLOPEN
      CHARACTER dna_image*80,xmlfile*80
C     ..
C     .. Common block /IOO/ ..
c      COMMON /IOO/IOUT,IUNIT,ONLINE,ITIN,ITOUT,INOD,INMO,IDU,NWRN,
c     +            ONEFILE,FHEADER,BRIEF,IBRIEF,GRAPH,ISUMMR,ICOORD,
c     +            IOERR,NODISPLAY,LBELL
C     ..
C
C
      COMMON /IOO/IOUT,IUNIT,ITIN,ITOUT,INOD,INMO,IDU,NWRN,IBRIEF,
     +        ISUMMR,ICOORD,SERVERFD,SERVERFDIN,NSHUTERR,ONLINE,ONEFILE,
     +        FHEADER,BRIEF,GRAPH,IOERR,NODISPLAY,LBELL,JPGOUT,
     $        SOCKLO,LBEST, dnafd, dnaout,INMOOPEN,XMLOPEN
      COMMON /CIOO/dna_image,xmlfile

C&&*&& end_include  ../inc/ioo.f
C&&*&& include  ../inc/misc.f
C
C $Id: misc.f,v 1.2 2009/09/03 16:24:33 harry Exp $
C
C--- awk generated include file  misc.h
C---- START of include file misc.h
C
C
C
C     .. Scalars in common /MISC/ ..
      REAL PHIBEG,PHIEND,PHIRNG,RMIN,RMAX,WAVE
      INTEGER IPACKID,MININT,IERRFLG
C     ..
C     .. Arrays in common /MISC/ ..
      REAL DELPHI,RESANI
      INTEGER IAX
C     ..
C     .. LOGICAL
      LOGICAL ANITES

C     ..
C     .. Common Block /MISC/ ..
      COMMON /MISC/DELPHI(3),RESANI(3),PHIBEG,PHIEND,PHIRNG,RMIN,RMAX,
     $       WAVE,IAX(3),IPACKID,MININT,IERRFLG,ANITES
C     ..
C
C
C&&*&& end_include  ../inc/misc.f
C&&*&& include  ../inc/ori.f
C
C $Id: ori.f,v 1.2 2007/07/12 13:25:56 andrew Exp $
C
C--- awk generated include file  ori.h
C---- START of include file ori.h
C
C     XCEN,YCEN    Coordinates (in 10 micron units) of the direct beam
C                  position relative to an origin at the position of the
C                  first pixel in the digitised image.(The SCANNER
C                  coordinate frame). These parameters are refined for
C                  each image. 
C
C     XCEN0,YCEN0  Coordinates of direct beam position at zero swing angle.
C                  (Needed for pxtomm conversion for swung detectors)
C                  These values are assigned on the basis of input direct
C                  beam coordinates, corrected for swing angle if necessary.
C                  They are not (currently) updated during refinement.
C
C     XOFF,YOFF    Distance between centre of detector and direct beam.
C
C     ..
C     .. Arrays in common /ORI/ ..
      LOGICAL FIXPAR
C
C     .. Scalars in common block /ORI/ ..
      REAL COSOM0,SINOM0,XTOFRA,YSCAL,TILT,TWIST,BULGE,
     +     VBNEG,VBPOS,VTILT,VTWIST,VVERT,TOFF,BULGE2,PBULGE,ROFF,
     +     RDTOFF,RDROFF,ROFFPHI,TOFFPHI,JUNK3,XCEN,YCEN,XCEN0,YCEN0,
     +     XOFF,YOFF,TILTMAT,TWISTMAT,DETNOR,DPSIX,SMTWIST,SMTILT,
     +     SMOMEGA0,SMYSCAL,SMTOFF,SMROFF,SMXTOFRA
      INTEGER CBAR,NODES,NPHI,NSM1,NSM2
      LOGICAL RESETCCOM,NOSMOOTH
C     ..
C     .. Common Block /ORI/ ..
      COMMON /ORI/COSOM0,SINOM0,XTOFRA,YSCAL,TILT,TWIST,BULGE,
     $       VBNEG,VBPOS,VTILT,VTWIST,VVERT,TOFF,BULGE2,PBULGE,ROFF,
     $       RDTOFF,RDROFF,ROFFPHI,TOFFPHI,JUNK3,XCEN,YCEN,XCEN0,
     +       YCEN0,XOFF,YOFF,TILTMAT,TWISTMAT,DPSIX,DETNOR(3),CBAR,
     +       NODES,NPHI,FIXPAR(NRPAR),
     $       RESETCCOM,SMTWIST,SMTILT,SMOMEGA0,SMYSCAL,SMTOFF,SMROFF,
     +       SMXTOFRA,NSM1,NSM2,NOSMOOTH
C     ..
C
C
C&&*&& end_include  ../inc/ori.f
C&&*&& include  ../inc/reeke.f
C
C $Id: reeke.f,v 1.15 2008/10/22 08:50:48 andrew Exp $
C
C--- awk generated include file  reeke.h
C---- START of include file reeke.h
C
C     TOR     For synchrotron sources, degree of polarisation of the beam
C     IMONO   Collimation flag for polarisation.
C             = 0   Pinhole or mirrors
C             = 1   Graphite Monochromator
C             = 2   Synchrotron, use TOR
C     NWMAX   Maximum reflection width in images
C     DSTMAX  dimensionless rlu, = WAVE/RES where RES is the maximum
C             resolution in Angstrom.
C     DSTMIN  dimensionless rlu, = WAVE/DMAX where DMAX is the maximum
C              Bragg spacing
C     S0      radiation source vector (-1,0,0), may be modified by MU values
C     SOURCE  radiation source vector - basis for s0
C     GONIO_angle:  machine angles for generalized goniostats
C     GONIO_angle_SET: fixed offset angles for 3- and 4-circle goniostats
C                      i.e. currently 54.74 deg for Bruker CHI, 50.0deg for
C                      Nonius and Oxford KAPPA 
C     ..
C     .. Arrays in common block /REEKE/ ..
      REAL RMC,AMAT,SCAXIS,S0,s0unit,CAMCON,BEAMMU
C     ..
C     .. Scalars in common block /REEKE/ ..
      REAL X1,X2,Y1,Y2,Z1,Z2,XYS,DSTAR2,DSTMAX,DSTPL,DSTPL2,
     +     DIVH,DIVV,DELAMB,ETA,DELCOR,DSTMAXS,TOR,DSTMIN,WMAX,
     +     ETAFRAC,ETASM,
     $     GON_CHI,GON_PHIS,GON_KAPPA,GON_OMEGAS,GON_2THETA,
     $     GON_PHIE,GON_OMEGAE,
     +     GON_CHI_SET,GON_KAPPA_SET,
     +     BLKSIZE
      INTEGER ISYN,IMONO,NWMAX,IPAD,NSMOOTH,IGON_CHI,IGON_PHI,
     $     IGON_KAPPA,IGON_OMEGA,IGON_2THETA,
     +     IGON_CHI_SET,IGON_KAPPA_SET,IHOSCAXIS
C     ..
C     .. logicals in common block /REEKE/ ..
      LOGICAL LOGETA,NUREEK,LCAMCON,GENGON,FOURCIRCLE,THREECIRCLE
C     ..
C     .. Common Block /REEKE/ ..
      COMMON /REEKE/RMC(3,3),AMAT(3,3),SCAXIS(3),S0(3),s0unit(3),
     $     CAMCON(8),BEAMMU(2),X1,X2,Y1,Y2,
     +     Z1,Z2,XYS,DSTAR2,DSTMAX,DSTPL,DSTPL2,DIVH,DIVV,DELAMB,
     +     ETA,DELCOR,DSTMAXS,TOR,DSTMIN,WMAX,ETAFRAC,ETASM,
     $     GON_CHI,GON_PHIS,GON_KAPPA,GON_OMEGAS,GON_2THETA,
     $     GON_PHIE,GON_OMEGAE,
     +     GON_CHI_SET,GON_KAPPA_SET,ISYN,IMONO,
     $     NWMAX,IPAD,
     $     NSMOOTH,IGON_CHI,IGON_PHI,
     $     IGON_KAPPA,IGON_OMEGA,IGON_2THETA,
     +     IGON_CHI_SET,IGON_KAPPA_SET,IHOSCAXIS,LOGETA,NUREEK,LCAMCON,
     $     GENGON,FOURCIRCLE,THREECIRCLE,
     +     BLKSIZE
C     ..
C
C
C&&*&& end_include  ../inc/reeke.f
C&&*&& include  ../inc/trigparam.f
C 
C $Id: trigparam.f,v 1.3 2008/07/31 11:46:02 harry Exp $
C
C
C     Trigonometric parameters - set here to highly precise values, don't 
C     calculate in code; values from Clemens Vonrhein
C
C     DTOR.. convert degrees to radians
C     RTOD.. convert radians to degrees
C     PI..   value of PI
      REAL PI
      PARAMETER   ( PI = 3.1415926536 )
      REAL          TWOPI
      PARAMETER   ( TWOPI = 6.2831853072 )
      REAL RTOD
      PARAMETER   ( RTOD = 57.2957795131 )
      REAL          DTOR
      PARAMETER   ( DTOR = 0.0174532925 )
C DOUBLE PRECISION...
      DOUBLE PRECISION PI_DOUBLE
      PARAMETER ( PI_DOUBLE = 3.1415926535897932384626433832795029D0 )
      DOUBLE PRECISION TWOPI_DOUBLE
      PARAMETER ( TWOPI_DOUBLE = 
     $     6.2831853071795864769252867665590058D0 )
      DOUBLE PRECISION RTOD_DOUBLE
      PARAMETER ( RTOD_DOUBLE = 57.2957795130823208768D0 )
      DOUBLE PRECISION DTOR_DOUBLE
      PARAMETER ( DTOR_DOUBLE = 0.01745329251994329576D0 )
c

c
C&&*&& end_include  ../inc/trigparam.f
C     ..
      SAVE
C     .. Equivalences ..
      EQUIVALENCE (PARM(1),PHIX), (PARM(2),PHIY), (PARM(3),PHIZ)
      EQUIVALENCE (PARM(4),CELLX(1))
      EQUIVALENCE (PSI(1),PSIX), (PSI(2),PSIY), (PSI(3),PSIZ)
C     ..
C     
C 
C     .. initialize histogram of partialities
      DO 1789 I = 1,21
        NPARTIA(I) = 0
 1789 ENDDO
      ISTAT = 0
      NDBG = 0
C     
      LAST = .FALSE.
C     
      NP = NC + 2
      NPSTOR = NP           
      IF (IC.EQ.1) NP = 2
      IF (NOREFCELL) NP = 2
      NPP = NP + 1
      BBPHI = PHI(1)
C     
      IF (DEBUG(40)) THEN
        WRITE(IOUT,FMT=6040) NPOINT,IC,NC,NP,NADD,NIMAG,
     +                       (PHIIM(I),I=1,NIMAG)
        IF (ONLINE) WRITE(ITOUT,FMT=6040) NPOINT,IC,NC,NP,NADD, 
     +                   NIMAG,(PHIIM(I),I=1,NIMAG)
      END IF
 6040 FORMAT(/,1X,'IN REFRT1',/,1X,'NPOINT=',I5,' IC=',I2,' NC=',I2,
     +       ' NP=',I3,' NADD=',I3,' NIMAG=',I3,
     +       /,1X,'Phi values for NIMAG images',/,(1X,8F10.2))
C     
C     
C---- Start cycle
C     
      IF (IPRINT.GT.0 .OR. IC.EQ.ICMAX) THEN
         WRITE (IOUT,FMT=6000) IC
         IF (ONLINE) WRITE (ITOUT,FMT=6000) IC
      END IF
C     
      NCYC = 0
 30   CONTINUE
      NCYC = NCYC + 1
C     
C---- NPS is maximum number of parameters
C     
      NPS = NP + NS + 2*(NADD-1)
      IJ = 0
C     
C     
      DO 50 I = 1,NPS
         S(I) = 0.0
         DO 40 J = 1,NPS
            IJ = IJ + 1
            Q(IJ) = 0.0
 40      CONTINUE
 50   CONTINUE
C     
C---- Set up matrices
C     
      DO 70 I = 1,3
         DO 60 J = 1,3
            AMAT(J,I) = 0.0
            DO 58 K=1,6
               DUBDCC(J,I,K) = 0.0
 58         CONTINUE
 60      CONTINUE
 70   CONTINUE
C     
c      WRITE(iout,*),'CALLING MATSET, CELLX',CELLX
c      WRITE(iout,*),'NCYC,NPS,NP,NS,NPP',NCYC,NPS,NP,NS,NPP
c      WRITE(iout,*),'PHIX,Y,Z',PHIX,PHIY,PHIZ,PHIP
C     
C---- Calculate A matrix and derivatives wrt cell parameters.
C     
C     **********************
      CALL MATSET(CELLX,NC,IPRINT)
C     **********************
C     
      SIGRSQ = 0.0
      NANG = 0
C     
C     
      IF (IPRINT.GT.0 .OR. LAST) THEN
         WRITE (IOUT,FMT=6002) ANGLIM
         IF (ONLINE) WRITE (ITOUT,FMT=6002) ANGLIM
      END IF
C     
C     
      IF (IPRINT.GT.0) THEN
         WRITE (IOUT,FMT=6004)
         IF (ONLINE) WRITE (ITOUT,FMT=6004)
      END IF
C     
      KREJ = 0
      PHIOLD = 99999.0
      NRREF = 0
C     
C---- Loop over each reflection
C 
         IF(DEBUG(37).AND.DEBUG(40))THEN
            IF(ONLINE)WRITE(ITOUT,FMT=1341)NADD
            WRITE(IOUT,FMT=1341)NADD
 1341       FORMAT(/,'Reflections used in this round of refinement ',
     $           'with NADD(local) = ',I2)
         ENDIF

      DO 130 KP = 1,MREF
C     
C---- If only one image, set pointer to first reflection to be used. Jump
C     out of loop if this is past the end of the array
         IF (NADD.EQ.1) THEN
            K = KP + NPOINT -1
         ELSE
            K = KP
         END IF
         IF (NEWPREF) K = KP + NPOINT - 1
C
         IF (K.GT.MREF) GOTO 135
C         IF (K.GT.MREF/NADD) GOTO 135
C     
C---- Skip if no reflection stored
C     
         IF (F(K).LT.0.001) GOTO 130
C     
         PHIP = PHI(K)
         IF (ABS(PHIP-PHIOLD).GT.0.001) THEN
C     
C---- First reflection from a new image, extract missets convert to
C     PSI values and get sin/cos
C     
c            PHIOLD = PHIP
            NEWPHI = .TRUE.
            NDBG = 0
C     
C---- Which image is this set of reflections from ?
C     When NADD is one, assign all reflections to current image
C     
C
            NSEARCH = NADD
            IF (NEWPREF) NSEARCH = NIMAG
            DO 74 I = 1,NSEARCH
               IF (ABS(PHIP-PHIIM(I)).LT.0.005) THEN
                 NNPHI = I
C
C---- in new style post-refinement, get the pointer to the parameter
C     set number for this image from IPARPOINT (set up in POSTREFL)
C
                 IF (NEWPREF) NNPHI = IPARPOINT(NNPHI)
C
C---- Must trap reflections from images that are NOT to be used, eg
C     for the first image of a new segment where there are not yet
C     enough reflections for missets to be refined.
C
                 IF (NNPHI.LT.0) THEN
                   IF (DEBUG(40)) THEN
                     WRITE(IOUT,FMT=6080) I                   
                     IF (ONLINE) WRITE(ITOUT,FMT=6080) I
6080                FORMAT(1X,'Rejecting reflection on image',I3)
                   END IF
                   GOTO 130
                 END IF
                 GOTO 76
               END IF
 74         CONTINUE
            IF(NSEARCH.LE.10)THEN
              WRITE(IOUT,FMT=6050) PHIP,NSEARCH,(PHIIM(I),I=1,NSEARCH)
              IF (ONLINE) WRITE(ITOUT,FMT=6050) PHIP,
     +             NSEARCH,(PHIIM(I),I=1,NSEARCH)
 6050         FORMAT(//1X,'**** WARNING ****',/,1X,' In REFRT1, no p',
     +             'ack has the phi value (',F9.4,') of this reflection',
     +             /,1X,'NSEARCH = ',I3,'  phiim values:',10F9.4)
            ELSE
              WRITE(IOUT,FMT=6050) PHIP,NSEARCH,(PHIIM(I),I=1,10)
              IF (ONLINE) WRITE(ITOUT,FMT=6050) PHIP,
     +             NSEARCH,(PHIIM(I),I=1,10)
              NSEARCH10 = (NSEARCH/10) + 1
 6500         FORMAT(16X,10F9.4)
              DO 8000 I=1,NSEARCH10
                WRITE(IOUT,FMT=6500)(PHIIM(I),J=(10*I)+1,(11*I))
                IF(ONLINE)WRITE(ITOUT,FMT=6500)(PHIIM(I),
     $               J=(10*I)+1,(11*I))
 8000         ENDDO
            ENDIF  
C
C---- If in POSTREF SEG mode, and NIMAG<NADD (ie not on last image)
C     then only missets are being refined
            goto 130
C
c            CALL SHUTDOWN(CALLEDFROM,LENSTR(CALLEDFROM))
C     
C---- Get pointer for phi values within array PARM
C     
 76         IF (NNPHI.EQ.1) THEN 
               PHIXX = PHIX
               PHIYY = PHIY
               PHIZZ = PHIZ
            ELSE            
               IPT = NC + (NNPHI-1)*3
               PHIXX = PARM(IPT+1)
               PHIYY = PARM(IPT+2)
               PHIZZ = PARM(IPT+3)
            END IF
            NRREF = NRREF + 1
            PHIPAR(NNPHI) = PHIP
c            IF (DEBUG(40)) THEN
c               WRITE(IOUT,FMT=6052) K,PHIP,NNPHI,PHIXX,PHIYY,PHIZZ
c               IF (ONLINE) WRITE(ITOUT,FMT=6052) K,PHIP,NNPHI,PHIXX,
c     +              PHIYY,PHIZZ
 6052          FORMAT(1X,'Reflection',I5,' phi value',F6.1,' Image no',
     +              I3,'   missets',3F8.2)
c            END IF
            CPX = COS(DTOR*PHIXX)
            SPX = SIN(DTOR*PHIXX)
            CPY = COS(DTOR*PHIYY)
            SPY = SIN(DTOR*PHIYY)
            CPZ = COS(DTOR*PHIZZ)
            SPZ = SIN(DTOR*PHIZZ)
            CAVP = COS(DTOR*PHIP)
            SAVP = SIN(DTOR*PHIP)
C     
C---- Convert PHIXX,PHIYY,PHIZZ to PSI values
C     
C     ***********************************************************
            CALL PHTOPS(CPX,SPX,CPY,SPY,CPZ,SPZ,CAVP,SAVP,
     $           PSI(1+(NNPHI-1)*3))
C     ***********************************************************
C     
C---- For first cycle correct PSIX by change in CCOMEG calculated
C     from refinement and reset CCOM.
C     If there is more than one image in a virtual batch, must ensure
C     that this is done for all 
C     WRITE(6,*),'PSIX,Y,Z',PSIX,PSIY,PSIZ,PHIP
CAL            IF ((IC.EQ.1).AND.(NNPHI.EQ.1).AND.(.NOT.RESETCCOM)) THEN
            IF ((IC.EQ.1).AND.(NNPHI.EQ.1).AND.(NCYC.EQ.1)) THEN
              IF (RESETCCOM) THEN
                PSIXX = PSI(1) + DPSIX
                PSI(1) = PSIXX
                IF (DEBUG(40)) THEN
                  WRITE(IOUT,FMT=6102) DPSIX, PHIP
                  IF (ONLINE) WRITE(ITOUT,FMT=6102)DPSIX,PHIP
 6102             FORMAT(/,1X,'PSIX changed by',F8.3,
     +                   ' CCOMEGA not reset, phi is',F8.3)
                END IF
              ELSE
                RESETCCOM = .TRUE.
                OMEGA0 = ATAN2(SINOM0,COSOM0)
                CCOM = (OMEGA0-OMEGAF)*57.296
                DPSIX = CCOM - TRUECCOM
                OMEGA0 = OMEGAF
                SINOM0 = SIN(OMEGA0)
                COSOM0 = COS(OMEGA0)
                CCOM = TRUECCOM
CAL              PSIXX = PSIXX + DPSIX
                PSIXX = PSI(1) + DPSIX
                PSI(1) = PSIXX
                IF (DEBUG(40)) THEN
                  WRITE(IOUT,FMT=6100) DPSIX, TRUECCOM, NNPHI,PHIP
                  IF (ONLINE) WRITE(ITOUT,FMT=6100)DPSIX,TRUECCOM,
     +                    NNPHI,PHIP
 6100           FORMAT(/,1X,'PSIX changed by',F8.3,' and CCOMEGA',
     +           ' reset to',F8.3,'  for nnphi=',I2,'  phip=',F8.3)
                END IF
              END IF
            ELSE
              PSIXX = PSI(1+(NNPHI-1)*3)
            END IF
            PSIYY = PSI(2+(NNPHI-1)*3)
            PSIZZ = PSI(3+(NNPHI-1)*3)
            CFX = COS(DTOR*PSIXX)
            SFX = SIN(DTOR*PSIXX)
            CFY = COS(DTOR*PSIYY)
            SFY = SIN(DTOR*PSIYY)
            CFZ = COS(DTOR*PSIZZ)
            SFZ = SIN(DTOR*PSIZZ)
C     
C---- End of block for new image
C     
            PHIOLD = PHIP
c            NEWPHI = .TRUE.
         END IF
C
         IF(DEBUG(37).AND.DEBUG(40)) THEN
            NDBG = NDBG + 1
            IF (NDBG.LT.NDEBUG(40)) THEN
              IF(ONLINE)WRITE(ITOUT,FMT=1342)K,IH(K),IK(K),IL(K),
     $           F(K),PHI(K),WW(K),NNPHI
              WRITE(IOUT,FMT=1342)K,IH(K),IK(K),IL(K),F(K),
     $           PHI(K),WW(K),NNPHI
 1342       FORMAT('K = ',I5,', HKL = ',3I4,', Frac = ',F5.2,
     $           ' PHI = ',F7.2,', WW = ',F6.2,' Parameter:',I3)
           ENDIF
         ENDIF
         IF(DEBUG(40).AND.DEBUG(77))THEN
           I = INT(20.*F(K))
           NPARTIA(I) = NPARTIA(I) + 1
         ENDIF
C     
C---- Zero out derivatives (assume 2 beam parameters)
C     
         NRREF = NRREF + 1                   
         NTOTVAR = 2*NADD+NC+2
         DO 78 I = 1,NTOTVAR
            DR(I) = 0.0
 78      CONTINUE
         CP = COS(DTOR*PHIP)
         SP = SIN(DTOR*PHIP)
C     WRITE(6,*),'REFL,PHIP',K,PHIP
C     
C---- Loop over each parameter. Note that I=1 is used to set things up
C     there is no actual parameter  for I=1. NPP = NC + 2 + 1 where NC is the
C     number of refined cell parameters, 2 is for PSIY,PSIZ and 1 is for
C     the setting up.
C     
         DO 90 I = 1,NPP
C     
C     *********
            CALL CLEAR(P)
            CALL CLEAR(CX)
            CALL CLEAR(CY)
            CALL CLEAR(CZ)
C     *********
C     
C---- Set up rotation matrices
C     
            CX(1,1) = 1.0
            CX(2,2) = CFX
            CX(2,3) = -SFX
            CX(3,2) = SFX
            CX(3,3) = CFX
            CY(1,1) = CFY
            CY(1,3) = SFY
            CY(2,2) = 1.0
            CY(3,1) = -SFY
            CY(3,3) = CFY
            CZ(1,1) = CFZ
            CZ(2,1) = SFZ
            CZ(1,2) = -SFZ
            CZ(2,2) = CFZ
            CZ(3,3) = 1.0
            P(1,1) = CP
            P(2,1) = SP
            P(1,2) = -SP
            P(2,2) = CP
            P(3,3) = 1.00
            IM = I
            IF (I.LE.3) IM = 1
C     
C     
            IF (I.EQ.3) THEN
C     
C     *********
               CALL CLEAR(CZ)
C     *********
C     
               CZ(1,1) = -SFZ
               CZ(2,1) = CFZ
               CZ(1,2) = -CFZ
               CZ(2,2) = -SFZ
            ELSE IF (I.EQ.2) THEN
C     
C---- Set up derivatives
C     
C     *********
               CALL CLEAR(CY)
C     *********
C     
               CY(1,1) = -SFY
               CY(1,3) = CFY
               CY(3,1) = -CFY
               CY(3,3) = -SFY
            END IF
C     
C     ****************
            CALL MATMUL3(PC,CX,P)
            CALL MATMUL3(C,CY,PC)
            CALL MATMUL3(PC,CZ,C)
C     ****************
C     
            IF (IM.GE.4) IM = IM - 2
C     
            IF (IM.EQ.1) THEN
C     ************************
               CALL MATMUL3(PCA,PC,AMAT(1,1))
C     ************************
            ELSE
C     ************************
               CALL MATMUL3(PCA,PC,DUBDCC(1,1,IM-1))
C     ************************
            END IF
C     
            DO 80 J = 1,3
               X(J) = PCA(J,1)*IH(K) + PCA(J,2)*IK(K) + PCA(J,3)*IL(K)
 80         CONTINUE
C     
            IF (I.NE.1) THEN
C     
C---- Deriv of rc w.r. to relevant ptr. The pointer calculation is complex.
C     The parameters are:
C     PSIY(1), PSIZ(1), REFINED CELL PARAMETERS, PSIY(2), PSIZ(2), PSIY(3),
C     PSIZ(3) .... PSIY(NADD), PSIZ(NADD), DIVH/EPS, DIVV
C     
C     Where (1) is the current image, (2) is the previous image, (3) is the
C     image before that etc.
C     All reflections contribute to derivatives wrt cell parameters and beam
C     parameters, but then only to the orientation parameters for that image.
C     
               NPLUS = 0
               IF ((I.LE.3).AND.(NNPHI.NE.1)) NPLUS = (NPP-1) +
     +                                                (NNPHI-2)*2
C     
               IF ((DEBUG(40).AND.NEWPHI).AND.(NDBG.LT.NDEBUG(40)))
     +                                                       THEN
                  WRITE(IOUT,FMT=6058) K,I,I-1+NPLUS,PHIP
                  IF (ONLINE) WRITE(ITOUT,FMT=6058) K,I,I-1+NPLUS,PHIP
 6058             FORMAT(1X,'Reflection ',I4,' Parameter ',I2,
     +                 ' Pointer ',I3,'  This phi ',F8.1)
               END IF
C     AL Re-write next two lines to clarify code
C     AL            DR(I-1+NPLUS) = (X(1)*XX+X(1)+X(2)*YY+X(3)*ZZ)/
C     AL     +                                           (RC)/DST*WW(K)
C     
               DR(I-1+NPLUS) = (X(1)*XX+X(1)+X(2)*YY+X(3)*ZZ)/
     +              (RC*DST)
            ELSE
               XX = X(1)
               YY = X(2)
               ZZ = X(3)
               XSQ = XX*XX
               YSQ = YY*YY
               ZSQ = ZZ*ZZ
               DSTSQ = XSQ + YSQ + ZSQ
               STEMP = 1.0 - DSTSQ*0.25
               IF (STEMP.LT.0.0) WRITE(6,8888) STEMP
 8888          FORMAT(' COSTH FROM REFRT1 = ',F20.10)
               COSTH = SQRT(STEMP)
               STEMP = DSTSQ
               IF (STEMP.LT.0.0) WRITE(6,8889) STEMP
 8889          FORMAT(' DST FROM REFRT1 = ',F20.10)
               DST = SQRT(STEMP)
C     
C---- Note change in next lines. If refining one beam parameter, then
C     it should be the mosaic spread, if two, then it is the beam
C     divergences. This does NOT depend on whether or not the data is from
C     a synchrotron.
C     
               IF  (NS.EQ.1) THEN
                  PARM(NC+NADD*3+1) = ETA
               ELSE IF (NS.EQ.2) THEN
                  PARM(NC+NADD*3+1)  = DIVH
                  PARM(NC+NADD*3+2) = DIVV
               END IF
               EH = DIVH*ZZ
               EV = DIVV*YY
C     
C---- Include the beam-divergence contribution from DELCOR
C     
               EH = EH + DELCOR*DSTSQ
               STEMP = (EH*EH + EV*EV)/ (YSQ + ZSQ)
               IF (STEMP.LT.0.0) WRITE(6,8887) STEMP
 8887          FORMAT(' DIVERG FROM REFRT1 = ',F20.10)
               DIVERG = SQRT(STEMP)
C     
               TWOEPS = ((DIVERG+ETA)*COSTH+DELAMB*DST*0.5)*DST
C     
C---- Calculate radius of point H,K,L from centre of sphere
C     
               STEMP = 2.0*XX + 1.0 + DSTSQ
               IF (STEMP.LT.0.0) WRITE(6,8855) STEMP
 8855          FORMAT(' RC FROM REFRT1 = ',F20.10)
               RC = SQRT(STEMP)
C     
C---- Correct for fraction recorded of spot
C     -ve frac denotes phi-start, +ve phi-end.
C     After making all fracs +ve, obsd radius of
C     refln (sphere-origin) is 1-(.5-f)*eps*2 for y-ve phi-end
C     or y+ve phi-start;  or 1+(.5+f)*eps*2 for the other
C     situations.
C     
               IF (YY.LT.0.0) THEN
                  IF (F(K).LT.0.0) THEN
                     AM = -F(K)
                  ELSE
                     AM = 1.0 - F(K)
                  END IF
               ELSE IF (F(K).LT.0.0) THEN
                  AM = F(K) + 1.0
               ELSE
                  AM = F(K)
               END IF
C     
C---- Observed radius set to 1.0 for extra ref
C     put eps term in rc, assume d(rc)/dx remains the same
C     
               FM = 1.0 - 2.0*AM
               IF (ABS(FM).GT.1.0) FM = SIGN(1.0,FM)
               RO = 1.0
               RC = RC - ASIN(FM)*TWOEPS/PI
C     
C     
               DANG(K) = (RO-RC)/DST
               ANG = DANG(K)*RTOD
               IF (ABS(ANG).LT.ANGLIM) THEN
                  NANG = NANG + 1
                  SIGRSQ = DANG(K)*DANG(K) + SIGRSQ
               ELSE
                  GO TO 120
               END IF
            END IF
 90      CONTINUE
C     
C---- Form least squares matrix
C     
C---- Extra ref only on second pass (ic>1)
C     set np to nnp for ref
C     
         NNP = NP + 2*(NADD-1)
         IF (IC.GT.1 .AND. NS.GT.0) THEN
            NNP = NP + NS + 2*(NADD-1)
C     
C---- Derivs for eta and divergence
C     
            TERM = -ASIN(FM)/PI
C     
C---- eta or DIVH = DIVV
C     
C     AL          DR(NP+1+2*(NADD-1)) = TERM*COSTH*WW(K)
            DR(NP+1+2*(NADD-1)) = TERM*COSTH
C     WRITE(6,*),'NS,DR(NP+1)',NS,DR(NP+1)
C     
C---- DIVH and DIVV
C     sqrt(GH*GH*cos*cos + GV*GV*sin*sin)d*costh where
C     alpha = tan-1 yy/zz
C     
            IF (NS.EQ.2) THEN
C     AL            DR(NP+1+2*(NADD-1)) = 
C     AL     +                  TERM*COSTH*DIVH*ZSQ/ (YSQ+ZSQ)/DIVERG*WW(K)
C     AL            DR(NP+2+2*(NADD-1)) = 
C     AL     +                  TERM*COSTH*DIVV*YSQ/ (YSQ+ZSQ)/DIVERG*WW(K)
               DR(NP+1+2*(NADD-1)) = 
     +              TERM*COSTH*DIVH*ZSQ/ (YSQ+ZSQ)/DIVERG
               DR(NP+2+2*(NADD-1)) = 
     +              TERM*COSTH*DIVV*YSQ/ (YSQ+ZSQ)/DIVERG
            END IF
            IF (DEBUG(40).AND.(K.LE.2).AND.(NCYC.EQ.1)) THEN
               WRITE(IOUT,FMT=6064) K,NS,NP+1+2*(NADD-1)
               IF (ONLINE) WRITE(ITOUT,FMT=6064) K,NS,NP+1+2*(NADD-1)
 6064          FORMAT(1X,'Reflection',I2,'; ',I4,' beam parameters ',
     +              'derivs stored starting at position',I3)
            END IF
         END IF
C     
C---- Increment elements of normal matrix. Note that for any given
C     reflection many elements of DR (psiy,psiz for all other images)
C     will be zero, so skip them
C     
         DO 110 I = 1,NNP
           IF (DR(I).NE.0.0) THEN
             S(I) = DANG(K)*DR(I)*WW(K) + S(I)
             DO 100 J = 1,NNP
               IF (DR(J).NE.0.0) THEN
                 IJ = (I-1)*NNP + J
                 Q(IJ) = WW(K)*DR(I)*DR(J) + Q(IJ)
               ENDIF
 100         ENDDO
           ENDIF
 110     ENDDO
         NEWPHI = .FALSE.
         GO TO 130
C     
 120     CONTINUE
         IF (IPRINT.GT.0) THEN
            WRITE (IOUT,FMT=6006) IH(K),IK(K),IL(K),ANG
            IF (ONLINE) WRITE (ITOUT,FMT=6006) IH(K),IK(K),IL(K),ANG
         END IF
C     
         KREJ = KREJ + 1
 130  CONTINUE
C     
      IF (DEBUG(40)) THEN
        WRITE(IOUT,FMT=6070) NRREF
        IF (ONLINE) WRITE(ITOUT,FMT=6070) NRREF
 6070   FORMAT(1X,'Number of reflections used in REFRT1',I5)
      END IF
      IF(DEBUG(40).AND.DEBUG(77))THEN
        WRITE(IOUT,FMT=6090)(FLOAT(I)*0.05-0.05,I=1,21),
     $       (NPARTIA(I),I=1,21)
        IF(ONLINE)WRITE(ITOUT,FMT=6090)(FLOAT(I)*0.05,I=1,21),
     $       (NPARTIA(I),I=1,21)
 6090   FORMAT(/,'**** DEBUG STATS **** ',/,
     $       ' Histogram of fractions of reflections used',/,
     $       ' Fraction ',21(1X,F4.2),/,' Count ',3X,21(1X,I4))
      ENDIF
C     IF (DEBUG(40).AND.(NCYC.EQ.1)) THEN

 135  CONTINUE
C     
C---- Check no.of observations
C     
      IF (NANG.LE.NNP) THEN
         GO TO 230
      ELSE
C     
C---- Invert Normal matrix (Q) and obtain eigenvalues - new code
C     
         CALL INVNOR(Q,NNP,QINV)
C     
C
C---- Solve least squares equations
C
C            ***************************
c         CALL MINV(Q,NNP,DET,IWRK1,IWRK2)
C            ***************************
C     
         IF (DEBUG(40)) THEN
            WRITE(IOUT,FMT=6055) (Q(ij),ij=1,nnp*nnp)
            IF (ONLINE) WRITE(ITOUT,FMT=6055) 
     $           (Q(ij),ij=1,nnp*nnp)
         ENDIF
C
c         IF (DET.EQ.0.0) THEN
c           GO TO 220
c         ELSE
         IJ = 0
         DO 150 I = 1,NNP
            R(I) = 0
            DO 140 J = 1,NNP
               IJ = IJ + 1
               R(I) = Qinv(IJ)*S(J) + R(I)
 140        CONTINUE
 150     CONTINUE
C     
C     IF (DEBUG(40).AND.(NCYC.EQ.1)) THEN
         IF (DEBUG(40)) THEN
            WRITE(IOUT,FMT=6060) (R(I),I=1,NNP)
            IF (ONLINE) WRITE(ITOUT,FMT=6060) (R(I),I=1,NNP)
 6060       FORMAT(/1X,'SHIFT VECTOR',/,(1X,8(E10.3,1X)))
            WRITE(IOUT,FMT=6062) (S(I),I=1,NNP)
            IF (ONLINE) WRITE(ITOUT,FMT=6062) (S(I),I=1,NNP)
 6062       FORMAT(/1X,'RHS VECTOR',/,(1X,8(E10.3,1X)))
         END IF
C     
         JJ = 1 
C     
C---- Reset angle limit to 3*RMS deviation
C     
         STEMP = SIGRSQ/REAL(NANG)
         IF (STEMP.LT.0.0) THEN
            WRITE(IOUT,FMT=6009) SIGRSQ,NANG
            IF (ONLINE) WRITE(ITOUT,FMT=6009)  SIGRSQ,NANG
C     WRITE(6,8844) STEMP
            GOTO 235
         END IF
C     IF (STEMP.LT.0.0) WRITE(6,8877) STEMP
 8877    FORMAT(' RMSR FROM REFRT1 = ',F20.10)
         RMSR = SQRT(STEMP)
         RMSR = RMSR*RTOD
         IF (3.0*RMSR.LT.ANGLIM) ANGLIM = 3.0*RMSR
C     
C---- Calculate standard deviations
C     
         DO 160 J = 1,NNP
            STEMP = Qinv(JJ)*SIGRSQ/ (NANG - NNP)
            IF (STEMP.LT.0.0) THEN
               WRITE(IOUT,FMT=6007) J,Qinv(JJ),SIGRSQ,NANG,NNP
               IF (ONLINE) WRITE(ITOUT,FMT=6007)J,Qinv(JJ),SIGRSQ,
     $              NANG,NNP
C     WRITE(6,8844) STEMP
               GOTO 235
 8844          FORMAT(' SIG(J) FROM REFRT1 = ',F20.10)
            END IF
            SIG(J) = SQRT(STEMP)
            JJ = JJ + NNP + 1
 160     CONTINUE
C     
C     
         IF (LAST .OR. IPRINT.GT.0) THEN
            WRITE (IOUT,FMT=6012) KREJ
            IF (ONLINE) WRITE (ITOUT,FMT=6012) KREJ
            IF (BRIEF) WRITE (IBRIEF,FMT=6012) KREJ
            WRITE (IOUT,FMT=6014) SIGRSQ,RMSR
            IF (ONLINE) WRITE (ITOUT,FMT=6014) SIGRSQ,RMSR
            IF (BRIEF) WRITE (IBRIEF,FMT=6015) RMSR
         END IF
C     
C---- Convert angle parameters to degrees
C     
         DO 170 I = 1,NP+2*(NADD-1)
            IF ((I.LE.2) .OR. I.GT. (2+(NP-2)-NA)) THEN
               R(I) = R(I)*RTOD
               SIG(I) = SIG(I)*RTOD
            END IF
 170     CONTINUE
C     
C---- First do phi + cell only
C     
         JJ = NC + 3
C     
C     
         IF (LAST .OR. IPRINT.GT.0) THEN
            WRITE (IOUT,FMT=6016) PSIX,PSIY,PSIZ, (PARM(I),I=4,JJ)
            IF (ONLINE) WRITE (ITOUT,FMT=6016) PSIX,PSIY,PSIZ,
     +           (PARM(I),I=4,JJ)
            WRITE (IOUT,FMT=6018) (R(I),I=1,NP)
            IF (ONLINE) WRITE (ITOUT,FMT=6018) (R(I),I=1,NP)
         END IF
C     
C---- Add parameter shifts for psi angles of image 1 (current image)
C     and cell parameters only. Do other angles below.
C     
         DO 180 I = 1,NP
C     
C     
            IF (I.GT.2) THEN
               J = I + 1
               PARM(J) = PARM(J) + R(I)
            ELSE
               PSI(I+1) = PSI(I+1) + R(I)
            END IF
 180     CONTINUE
C     
C     **********************************************
         CALL PSTOPH(PSIX,PSIY,PSIZ,PHIX,PHIY,PHIZ,PHIIM(1))
C     **********************************************
C     
         IF (DEBUG(40)) THEN
            I = 1
            WRITE(IOUT,FMT=6056) I,PSIX,PSIY,PSIZ,
     +           PHIX,PHIY,PHIZ,PHIIM(I)
            IF (ONLINE) WRITE(ITOUT,FMT=6056) I,PSIX,PSIY,PSIZ,
     +           PHIX,PHIY,PHIZ,PHIIM(I)
         END IF
C     
         IF (LAST .OR. IPRINT.GT.0) THEN
            WRITE (IOUT,FMT=6020) PSIX,PSIY,PSIZ, (CELLX(I),I=1,NC)
            IF (ONLINE) WRITE (ITOUT,FMT=6020) PSIX,PSIY,PSIZ,
     +           (CELLX(I),I=1,NC)
            WRITE (IOUT,FMT=6022) (SIG(J),J=1,NP)
            IF (ONLINE) WRITE (ITOUT,FMT=6022) (SIG(J),J=1,NP)
         END IF
C     
C---- Add in angle shifts for other images (if any)
C     
         IF (NADD.GT.1) THEN
            DO 182 I=2,NADD
               DO 184 K=2,3
                  PSI(K+(I-1)*3) = PSI(K+(I-1)*3) + R(NP +(I-2)*2 
     $                 +(K-1))
 184           CONTINUE
               PSIXX = PSI(1+(I-1)*3)
               PSIYY = PSI(2+(I-1)*3)
               PSIZZ = PSI(3+(I-1)*3)
C     *********************************************************
               CALL PSTOPH(PSIXX,PSIYY,PSIZZ,PHIXX,PHIYY,PHIZZ,
     $              PHIPAR(I))
CAL     $              PHIIM(I))
C     *********************************************************
C     
C---- Update PHI missets in PARM
C     
               PARM(NC+(I-1)*3+1) = PHIXX
               PARM(NC+(I-1)*3+2) = PHIYY
               PARM(NC+(I-1)*3+3) = PHIZZ
               IF (DEBUG(40)) THEN
                  WRITE(IOUT,FMT=6056) I,PSIXX,PSIYY,PSIZZ,
     +                 PHIXX,PHIYY,PHIZZ,PHIPAR(I)
                  IF (ONLINE) WRITE(ITOUT,FMT=6056) I,PSIXX,PSIYY,
     +                 PSIZZ,PHIXX,PHIYY,PHIZZ,PHIPAR(I)
 6056             FORMAT(1X,'IMAGE',I3,' New PSI angles',3F10.2,
     +                 ' new phi values',3F10.2,' at phi',F10.2)
               END IF
 182        CONTINUE
         END IF
C     
C---- Extra ref output after second pass
C     
         IF (NS.GT.0 .AND. IC.GT.1) THEN
C     
C---- Write out old params
C     
            IF (LAST .OR. IPRINT.GT.0) THEN
               IF (NS.EQ.1) THEN
                  WRITE (IOUT,FMT=6024)
                  IF (ONLINE) WRITE (ITOUT,FMT=6024)
               ELSE
                  WRITE (IOUT,FMT=6028)
                  IF (ONLINE) WRITE (ITOUT,FMT=6028)
               END IF
               WRITE (IOUT,FMT=6030) (PARM(NC+NADD*3+I)*RTOD,I=1,NS)
               IF (ONLINE) WRITE (ITOUT,FMT=6030)
     +              (PARM(NC+NADD*3+I)*RTOD,I=1,NS)
               WRITE (IOUT,FMT=6032) (R(I)*RTOD,I=NP+(NADD-1)*2+1,
     +              NP+(NADD-1)*2+NS)
               IF (ONLINE) WRITE (ITOUT,FMT=6032)
     +              (R(I)*RTOD,I=NP+(NADD-1)*2+1,
     +              NP+(NADD-1)*2+NS)
            END IF
C     
C---- Add parameter shifts
C     
            DO 190 I = 1,NS
               PARM(I+NC+NADD*3) = PARM(I+NC+NADD*3) 
     $              + R(NP+(NADD-1)*2+I)
 190        CONTINUE
C     
            IF  (NS.EQ.1) THEN
               ETA = PARM(NC+NADD*3+1)
            ELSE IF (NS.EQ.2) THEN
               DIVH = PARM(NC+NADD*3+1)
               DIVV = PARM(NC+NADD*3+2)
            END IF
C     
C---- Now write out new extra params
C     
            IF (LAST .OR. IPRINT.GT.0) THEN
               WRITE (IOUT,FMT=6034) (PARM(I+NC+NADD*3)*RTOD,I=1,NS)
               IF (ONLINE) WRITE (ITOUT,FMT=6034)
     +              (PARM(I+NC+NADD*3)*RTOD,I=1,NS)
               WRITE (IOUT,FMT=6036) (SIG(J)*RTOD,
     +              J=NP+(NADD-1)*2+1,NP+(NADD-1)*2+NS)
               IF (ONLINE) WRITE (ITOUT,FMT=6036)(SIG(J)*RTOD,
     +              J=NP+(NADD-1)*2+1,NP+(NADD-1)*2+NS)
            END IF
         END IF
C     
C---- Here if no extra ref
C     
         IF (LAST) THEN
            GO TO 210
         ELSE
C     
C---- If after first cycle of refinement too many reflections
C     are rejected return to re-index
C     
            IF (HKL .OR. NCYC.LE.1 .OR. KREJ.LE.NR/5) THEN
C     
C---- Maximum of 5 cycles of REFRT1 - return to re-index
C     
               IF (NCYC.NE.3) THEN
C     
C---- Test size of shifts
C     
                  DO 200 I = 1,NNP
                     IF (SIG(I).EQ.0.0)SIG(I)=0.00001
                     IF (ABS(R(I)/SIG(I)).GT.0.1) GO TO 30
 200              CONTINUE
C     
C     
               END IF
            END IF
C     
C---- If last full cycle then repeat refinement printing stats
C     
            IF (IC.EQ.ICMAX) THEN
               LAST = .TRUE.
               GO TO 30
            END IF
         END IF
C      END IF
      END IF
      NP = NPSTOR
      RETURN
C     
C---- Finish, prepare for print
C     First deal with normal params
C     
 210  JJ = NC + 3
      RETURN
c     220 WRITE (IOUT,FMT=6010)
c     IF (ONLINE) WRITE (ITOUT,FMT=6010)
c     GOTO 235
 230  WRITE (IOUT,FMT=6008)NANG,NNP
      IF (ONLINE) WRITE (ITOUT,FMT=6008)NANG,NNP
 235  WRITE (IOUT,FMT=6011)
      IF (ONLINE) WRITE (ITOUT,FMT=6011)
      ISTAT = -1
C     
C---- Format statements
C     
 6000 FORMAT (1X,16 ('+++++'),//10X,'PARAMETER REFINEMENT PASS',I3)
 6002 FORMAT (/' Reflections rejected if angular error >',F6.2,' deg.',
     +     /)
 6004 FORMAT (/7X,'H   K   L   ANGERR(degrees)  ')
 6006 FORMAT (4X,3I4,F7.2)
 6007 FORMAT (/,1X,'*** Ill determined normal matrix ***',/,1X,
     +     'Variable',I3,' Diag element of inverse matrix',E10.3,
     +     /,1X,'SIGRSQ',E10.5,'  NANG',I5,'  NNP',I3)
 6008 FORMAT (/,1X,'***  Fewer data than parameters ***',/,
     $     'NANG = ',I6,' and NNP = ',I6)
 6009 FORMAT (/,1X,'*** Ill determined normal matrix ***',/,1X,
     +     'SIGRSQ',F12.6,'   NANG',I8)
 6010 FORMAT (/,1X,'*** Singular equations ***')
 6011 FORMAT (/,1X,'There are insufficient',
     +     ' data to refine all the parameters sensibly',/,1X,
     +     'This can happen if you are using far too small a value',
     +     ' for the mosaic spread.',/,1X,
     +     'Alternatively if you have only weak low resolution data',
     +     ', cell parameters',/,1X,'may not be well defined even',
     +     ' if you have a large number of reflections.',/,1X,
     +     'This will result in excessive parameter shifts which',
     +     ' will lead to the',/,1X,'rejection of many ',
     +     'reflections.',/,1X,
     +     'If you are using the refined beam parameters (USEBEAM) ',
     +     'first check that the',/,1X,'divergence (or mosaicity) ',
     +     'has not refined to either too large or ',
     +     'too small',/,1X,'a value.',/,1X,
     +     'If not the case try using ',
     +     ' more images by increasing WIDTH or ',/,1X,
     +     'NADD (POSTREF',
     +     ' keyword)',/,1X,'or FIX some or ALL  cell parameters.')
 6012 FORMAT (' Number of reflections rejected: ',I5)
 6014 FORMAT (' Sum of (RO-RC)/D*)**2 = ',F12.8,' Rms Resid = ',F8.3,
     +     ' degrees')
 6015 FORMAT (' Rms Resid = ',F8.3,' degrees')
 6016 FORMAT (/11X,'PSIX      PSIY      PSIZ    Refined reciprocal ce',
     +     'll parameters',/'   Old ',3F10.3,3F10.6,3F10.4)
 6018 FORMAT (' Shifts',10X,2F10.3,3F10.6,3F10.4)
 6020 FORMAT ('   New ',3F10.3,3F10.6,3F10.4)
 6022 FORMAT ('  S.D.',11X,2F10.3,3F10.6,3F10.4)
 6024 FORMAT (/9X,'Mosaic spread')
 6028 FORMAT (/10X,'DIVH     DIVV (Horizontal and vertical beam',
     +     ' divergences)')
 6030 FORMAT ('   Old ',2F8.3)
 6032 FORMAT (' Shifts',2F8.3)
 6034 FORMAT ('   New ',2F8.3)
 6036 FORMAT ('  S.D. ',2F8.3)
 6055 FORMAT(//,1X,'Normal Matrix',/,(1X,8E10.3,/))
      END
C== ROTMAT ==
      SUBROUTINE ROTMAT(DELPHI,R,IMODE)
C     ===========================
      IMPLICIT NONE
C
C---- Forms rotation matrix R from the three angles in DELPHI
C     (angles in degrees (IMODE .eq.1) or radians (IMODE .ne. 1), corresponding
C     to
C
C     [R] = [phiz] . [phiy] . [phix]
C
C
C        | cz -sz   0 |   | cy   0  sy |   | 1   0   0 |
C  [R] = | sz  cz   0 | . |  0   1   0 | . | 0  cx -sx |
C        |  0   0   1 |   |-sy   0  cy |   | 0  sx  cx |
C
C     ..
C     .. Array Arguments ..
      REAL DELPHI(3),R(3,3)
C     ..
C     .. Scalar Arguments ..
      INTEGER IMODE
C     ..
C     .. Local Scalars ..
      INTEGER I
C     ..
C     .. Local Arrays ..
      DOUBLE PRECISION C(3),S(3),DELPHID(3)
C     ..
C     .. Intrinsic Functions ..
      INTRINSIC COS,SIN
C     ..
C&&*&& include  ../inc/trigparam.f
C 
C $Id: trigparam.f,v 1.3 2008/07/31 11:46:02 harry Exp $
C
C
C     Trigonometric parameters - set here to highly precise values, don't 
C     calculate in code; values from Clemens Vonrhein
C
C     DTOR.. convert degrees to radians
C     RTOD.. convert radians to degrees
C     PI..   value of PI
      REAL PI
      PARAMETER   ( PI = 3.1415926536 )
      REAL          TWOPI
      PARAMETER   ( TWOPI = 6.2831853072 )
      REAL RTOD
      PARAMETER   ( RTOD = 57.2957795131 )
      REAL          DTOR
      PARAMETER   ( DTOR = 0.0174532925 )
C DOUBLE PRECISION...
      DOUBLE PRECISION PI_DOUBLE
      PARAMETER ( PI_DOUBLE = 3.1415926535897932384626433832795029D0 )
      DOUBLE PRECISION TWOPI_DOUBLE
      PARAMETER ( TWOPI_DOUBLE = 
     $     6.2831853071795864769252867665590058D0 )
      DOUBLE PRECISION RTOD_DOUBLE
      PARAMETER ( RTOD_DOUBLE = 57.2957795130823208768D0 )
      DOUBLE PRECISION DTOR_DOUBLE
      PARAMETER ( DTOR_DOUBLE = 0.01745329251994329576D0 )
c

c
C&&*&& end_include  ../inc/trigparam.f
C
      DO 10 I = 1,3
        DELPHID(I) = DBLE(DELPHI(I))
         IF(IMODE.EQ.1)THEN
            C(I) = COS(DELPHID(I)*DTOR_DOUBLE)
            S(I) = SIN(DELPHID(I)*DTOR_DOUBLE)
         ELSE
            C(I) = COS(DELPHID(I))
            S(I) = SIN(DELPHID(I))
         ENDIF
 10   CONTINUE
C
C
      R(1,1) = REAL(C(2)*C(3))
      R(1,2) = REAL(-C(1)*S(3) + S(1)*S(2)*C(3))
      R(1,3) = REAL(C(1)*S(2)*C(3) + S(1)*S(3))
      R(2,1) = REAL(C(2)*S(3))
      R(2,2) = REAL(S(1)*S(2)*S(3) + C(1)*C(3))
      R(2,3) = REAL(-S(1)*C(3) + C(1)*S(2)*S(3))
      R(3,1) = REAL(-S(2))
      R(3,2) = REAL(S(1)*C(2))
      R(3,3) = REAL(C(1)*C(2))
C
C
      END
C $Id: setdis.f,v 1.11 2007/12/18 14:55:49 harry Exp $
      SUBROUTINE SETDIS(ITILT,ITWIST,IMODE)
      IMPLICIT NONE
C&&*&& include  ../inc/parameter.f
C
C $Id: parameter.f,v 1.17 2009/10/28 16:43:34 harry Exp $
C
C--- awk generated include file  parameter.h
C---- START of include file parameter.h
C
C       PARAMETERS
C       IYLENGTH.. maximum number of I*2 words of data in the 
C                  "fast" (ie most rapidly changing) direction in the
C                  digitised image. This will be HALF the number of pixels
C                  for film data (each pixel is stored in one byte)
C                  but will equal the number of pixels for IP data.
C       IXWDTH...  The maximum number of "stripes" of data in the scanned image
C                  ie the number of pixels in the "slow" direction
C                  (This is the Y direction in the MOSFLM convention)
C                  Note that the array "IMAGE" used to store the image is
C                  declared as size IYLENGTH*IXWDTH I*2 words for IP data
C                  and 2*IYLENGTH*IXWDTH BYTES for film data.
C                  If this exceeds the
C                  available memory, set ixwdth=1, recompile program
C                  and use keyword "NOCORE" when running program.
C                  Note that for the POSTREF and ADDPART options,
C                  two images have to be stored in memory at once so
C                  IXWDTH should be twice the number of records in an
C                  image.
C       MAXHEAD    maximum length of image header (in 4 byte words)
C       NREFLS.... maximum number of spots per film in generate file (250,000)
C       MAXBOX.... maximum number of pixels in measurement box (1500)
C       MAXDIM.... maximum box size in either direction (pixels) (41)
C       MAXPAX.... maximum number of packs per generate file (10000)
C       MXDOV2..... maxdim/2
C       MAXBUFF... maximum size of buffer (I*2) for storing ods
C                  of active spots in subroutine meas(21,000).
C                  Must be .GE.  MAXBOX*(NNLINE-1) for subroutine process
C       MREF...... maximum number of reflections to be used in post
C                  refinement (6000)
C       NEXPAND... maximum number of expansions of the input measurement
C                  box (2)
C       NMASKS.... maximum number of different profiles (25). Note the
C                  connection between this parameter and NNLINE
C       NVECT..... maximum number of vectors for storing scanned image
C                  in filmplot (10000)
C       NIMAX..... maximum number of images to be used together in 
C                  postrefinement (NADD or WIDTH options) (100)
C       NNLINE...  maximum number of boundary lines for setting up
C                  the areas for profile fitting. The maximum possible
C                  number of standard profiles will be (NNLINE-1)**2
C                  although for a circular detector the actual number
C                  may be less than this as some boxes will lie entirely
C                  outside the detector.
C       NREJMAX... Maximum number of rejected background pixels, resulting
C                  either from overlap of adjacent spots or outliers from
C                  the background plane
C       NSPOTS...  Maximum number of found spots (for autoindexing) that can
C                  be stored (for all images). Also maximum number in 
C                  a file wriitten by IMSTILLS that can be 
C                  stored/displayed/edited. THis must be an even number
C       MCOLS....  Number of columns in output MTZ file
C       MCOLSTR..  Number of columns in output MTZ file for strategy option
C     
C       MTZ Orientation block
C        MBLENG is total length of block, MBLINT, MBLREA are numbers
C          of integers & reals
C       NDETREF    Maximum number of reflections used for detector parameter
C                  refinement (previously 62)
C       NRPAR....  Maximum number of refineable parameters for detector
C                  positional refinement (subroutine RDIST)
C       NSEGMAX..  Maximum number of segments in STRATEGY
C       NSEGMAXPR  Maximum number of segments in POST-REFINEMENT
C       MULTMAX... Maximum number of observations with same hkl in COMPLETE
C       MAXDIFF... Maximum number of different packs that a given hkl occurs on
C       NRESBIN... Maximum number of resolution bins (COMPLETE)
C
C       MAXIMG...  Maximum number of images that can be read in using the IMAGE
C                  keyword or the "read Image" menu option.
C       MXSPOT...  Maximum number of spots that can be found on one image
C                  (before rejection on spot size).
C       MXCENT...  Maximum number of active spots during spot finding 
C                  (findspots)
C
C       MGRA, NGRA... maximum number of reflections and images over which a 
C                     reflection can be spread for postrefinement.
C       MAXBGBOX    Maximum number of local background background boxes 
C                   in X and Y
C
C       MAXNPEAKS   Maximum number of local maxima within one spot
C       MAXEXCL     Maximum number of excluded areas of the same type
C                   eg reactangles, quadrilaterals, arcs, resolution shells
C
C     .. Parameters ..
      INTEGER IXWDTH
c      PARAMETER (IXWDTH=8192)
      PARAMETER (IXWDTH=12288)
      INTEGER IYLENGTH
c      PARAMETER (IYLENGTH=4096)
      PARAMETER (IYLENGTH=6144)
      INTEGER MAXHEAD
      PARAMETER (MAXHEAD=5120)
      INTEGER MAXBOX
      PARAMETER (MAXBOX=3000)
      INTEGER MAXDIM
      PARAMETER (MAXDIM=41)
      INTEGER MAXPAX
      PARAMETER (MAXPAX=10000)
      INTEGER MXDOV2
      PARAMETER (MXDOV2=MAXDIM/2)
      INTEGER NEXPAND
      PARAMETER (NEXPAND=2)
      INTEGER NNLINE
      PARAMETER (NNLINE=8)
      INTEGER NMASKS
      PARAMETER (NMASKS=49)
      INTEGER MAXBUFF
      PARAMETER (MAXBUFF=21000)
      INTEGER NREFLS
      PARAMETER (NREFLS=250000)
      INTEGER MREF
      PARAMETER (MREF=6000)
      INTEGER NVECT
      PARAMETER (NVECT=10000)
      INTEGER NIMAX
      PARAMETER (NIMAX=100)
      INTEGER NREJMAX
      PARAMETER (NREJMAX=1000)
      INTEGER NSPOTS
      PARAMETER (NSPOTS=5000)
      INTEGER MCOLS
      PARAMETER (MCOLS=18)
      INTEGER MCOLSTR
      PARAMETER (MCOLSTR=6)
      INTEGER NREFSTR
C
C---- Each reflection for strategy run needs MCOLSTR I*2 words
C     plus an I*4 word for the merging
C
      PARAMETER (NREFSTR = IXWDTH*IYLENGTH/(2+MCOLSTR))
      INTEGER MBLENG,MBLINT,MBLREA
      PARAMETER (MBLENG=185,MBLINT=29,MBLREA=156)
      INTEGER NDETREF
      PARAMETER (NDETREF=400)
      INTEGER NRPAR
      PARAMETER (NRPAR=14)
      INTEGER NSEGMAX
      PARAMETER (NSEGMAX=100)
      INTEGER NSEGMAXPR
      PARAMETER (NSEGMAXPR=100)
      INTEGER MULTMAX
      PARAMETER (MULTMAX=100)
      INTEGER MAXDIFF
      PARAMETER (MAXDIFF=100)
      INTEGER NRESBIN
      PARAMETER (NRESBIN=20)
      INTEGER MXSPOT
      PARAMETER (MXSPOT=5000)      
      INTEGER MAXIMG
      PARAMETER (MAXIMG=100)      
      INTEGER NPIXBG
      PARAMETER (NPIXBG=51)
      INTEGER MXCENT
      PARAMETER (MXCENT=500)
      INTEGER    NGRA,MGRA
      PARAMETER (NGRA=20)
      PARAMETER (MGRA=50000)
      INTEGER MAXBGBOX
      PARAMETER (MAXBGBOX=500)
      INTEGER MAXNPEAKS
      PARAMETER (MAXNPEAKS=500)
      INTEGER MAXEXCL
      PARAMETER (MAXEXCL=50)
C&&*&& end_include  ../inc/parameter.f
C     
C---- subroutine to convert real values of tilt and twist to integer values
C     for i/o in CONTROL.F etc, using either new method or old method.
C     
C     
C..   Integer arguments
      INTEGER ITILT,ITWIST,IMODE
C     
C..   Real arguments
c      REAL TILT,TWIST
C&&*&& include  ../inc/ioo.f
C
C $Id: ioo.f,v 1.7 2009/05/13 11:57:53 harry Exp $
C
C--- awk generated include file  ioo.h
C---- START of include file ioo.h
C
C
C
C     .. Scalars in common block /IOO/ ..
      INTEGER IOUT,IUNIT,ITIN,ITOUT,INOD,INMO,IDU,NWRN,IBRIEF,ISUMMR,
     +        ICOORD,SERVERFD,SERVERFDIN,NSHUTERR,dnafd
      LOGICAL ONLINE,ONEFILE,FHEADER,BRIEF,GRAPH,IOERR,
     $     NODISPLAY,LBELL,JPGOUT,SOCKLO,LBEST,dnaout,INMOOPEN,
     $     XMLOPEN
      CHARACTER dna_image*80,xmlfile*80
C     ..
C     .. Common block /IOO/ ..
c      COMMON /IOO/IOUT,IUNIT,ONLINE,ITIN,ITOUT,INOD,INMO,IDU,NWRN,
c     +            ONEFILE,FHEADER,BRIEF,IBRIEF,GRAPH,ISUMMR,ICOORD,
c     +            IOERR,NODISPLAY,LBELL
C     ..
C
C
      COMMON /IOO/IOUT,IUNIT,ITIN,ITOUT,INOD,INMO,IDU,NWRN,IBRIEF,
     +        ISUMMR,ICOORD,SERVERFD,SERVERFDIN,NSHUTERR,ONLINE,ONEFILE,
     +        FHEADER,BRIEF,GRAPH,IOERR,NODISPLAY,LBELL,JPGOUT,
     $        SOCKLO,LBEST, dnafd, dnaout,INMOOPEN,XMLOPEN
      COMMON /CIOO/dna_image,xmlfile

C&&*&& end_include  ../inc/ioo.f
C&&*&& include  ../inc/ori.f
C
C $Id: ori.f,v 1.2 2007/07/12 13:25:56 andrew Exp $
C
C--- awk generated include file  ori.h
C---- START of include file ori.h
C
C     XCEN,YCEN    Coordinates (in 10 micron units) of the direct beam
C                  position relative to an origin at the position of the
C                  first pixel in the digitised image.(The SCANNER
C                  coordinate frame). These parameters are refined for
C                  each image. 
C
C     XCEN0,YCEN0  Coordinates of direct beam position at zero swing angle.
C                  (Needed for pxtomm conversion for swung detectors)
C                  These values are assigned on the basis of input direct
C                  beam coordinates, corrected for swing angle if necessary.
C                  They are not (currently) updated during refinement.
C
C     XOFF,YOFF    Distance between centre of detector and direct beam.
C
C     ..
C     .. Arrays in common /ORI/ ..
      LOGICAL FIXPAR
C
C     .. Scalars in common block /ORI/ ..
      REAL COSOM0,SINOM0,XTOFRA,YSCAL,TILT,TWIST,BULGE,
     +     VBNEG,VBPOS,VTILT,VTWIST,VVERT,TOFF,BULGE2,PBULGE,ROFF,
     +     RDTOFF,RDROFF,ROFFPHI,TOFFPHI,JUNK3,XCEN,YCEN,XCEN0,YCEN0,
     +     XOFF,YOFF,TILTMAT,TWISTMAT,DETNOR,DPSIX,SMTWIST,SMTILT,
     +     SMOMEGA0,SMYSCAL,SMTOFF,SMROFF,SMXTOFRA
      INTEGER CBAR,NODES,NPHI,NSM1,NSM2
      LOGICAL RESETCCOM,NOSMOOTH
C     ..
C     .. Common Block /ORI/ ..
      COMMON /ORI/COSOM0,SINOM0,XTOFRA,YSCAL,TILT,TWIST,BULGE,
     $       VBNEG,VBPOS,VTILT,VTWIST,VVERT,TOFF,BULGE2,PBULGE,ROFF,
     $       RDTOFF,RDROFF,ROFFPHI,TOFFPHI,JUNK3,XCEN,YCEN,XCEN0,
     +       YCEN0,XOFF,YOFF,TILTMAT,TWISTMAT,DPSIX,DETNOR(3),CBAR,
     +       NODES,NPHI,FIXPAR(NRPAR),
     $       RESETCCOM,SMTWIST,SMTILT,SMOMEGA0,SMYSCAL,SMTOFF,SMROFF,
     +       SMXTOFRA,NSM1,NSM2,NOSMOOTH
C     ..
C
C
C&&*&& end_include  ../inc/ori.f
C&&*&& include  ../inc/rfs.f
C
C $Id: rfs.f,v 1.2 2007/07/12 13:25:57 andrew Exp $
C
C--- awk generated include file  rfs.h
C---- START of include file rfs.h
C
C
C
C     .. Scalars in common block /RFS/ ..
      REAL FDIST,ESTART,RMSRES,WRMSRES,WESTART
      INTEGER MAXREF,MAXX,MAXY,NRS,MAXR,NREJS,NCENTREF
C     ..
C     .. Arrays in common block /RFS/ ..
      REAL XRS,YRS,WXRS,WYRS
      INTEGER RRS,IHKLR
C     ..
C     .. Common Block /RFS/ ..
      COMMON /RFS/ XRS(NDETREF),YRS(NDETREF),WXRS(NDETREF),
     +       WYRS(NDETREF),FDIST,ESTART,RMSRES,WRMSRES,
     $       WESTART,RRS(NDETREF),IHKLR(3,NDETREF),MAXREF,MAXX,
     +       MAXY,NRS,MAXR,NREJS,NCENTREF
C     ..
C
C
C&&*&& end_include  ../inc/rfs.f
C&&*&& include  ../inc/reeke.f
C
C $Id: reeke.f,v 1.15 2008/10/22 08:50:48 andrew Exp $
C
C--- awk generated include file  reeke.h
C---- START of include file reeke.h
C
C     TOR     For synchrotron sources, degree of polarisation of the beam
C     IMONO   Collimation flag for polarisation.
C             = 0   Pinhole or mirrors
C             = 1   Graphite Monochromator
C             = 2   Synchrotron, use TOR
C     NWMAX   Maximum reflection width in images
C     DSTMAX  dimensionless rlu, = WAVE/RES where RES is the maximum
C             resolution in Angstrom.
C     DSTMIN  dimensionless rlu, = WAVE/DMAX where DMAX is the maximum
C              Bragg spacing
C     S0      radiation source vector (-1,0,0), may be modified by MU values
C     SOURCE  radiation source vector - basis for s0
C     GONIO_angle:  machine angles for generalized goniostats
C     GONIO_angle_SET: fixed offset angles for 3- and 4-circle goniostats
C                      i.e. currently 54.74 deg for Bruker CHI, 50.0deg for
C                      Nonius and Oxford KAPPA 
C     ..
C     .. Arrays in common block /REEKE/ ..
      REAL RMC,AMAT,SCAXIS,S0,s0unit,CAMCON,BEAMMU
C     ..
C     .. Scalars in common block /REEKE/ ..
      REAL X1,X2,Y1,Y2,Z1,Z2,XYS,DSTAR2,DSTMAX,DSTPL,DSTPL2,
     +     DIVH,DIVV,DELAMB,ETA,DELCOR,DSTMAXS,TOR,DSTMIN,WMAX,
     +     ETAFRAC,ETASM,
     $     GON_CHI,GON_PHIS,GON_KAPPA,GON_OMEGAS,GON_2THETA,
     $     GON_PHIE,GON_OMEGAE,
     +     GON_CHI_SET,GON_KAPPA_SET,
     +     BLKSIZE
      INTEGER ISYN,IMONO,NWMAX,IPAD,NSMOOTH,IGON_CHI,IGON_PHI,
     $     IGON_KAPPA,IGON_OMEGA,IGON_2THETA,
     +     IGON_CHI_SET,IGON_KAPPA_SET,IHOSCAXIS
C     ..
C     .. logicals in common block /REEKE/ ..
      LOGICAL LOGETA,NUREEK,LCAMCON,GENGON,FOURCIRCLE,THREECIRCLE
C     ..
C     .. Common Block /REEKE/ ..
      COMMON /REEKE/RMC(3,3),AMAT(3,3),SCAXIS(3),S0(3),s0unit(3),
     $     CAMCON(8),BEAMMU(2),X1,X2,Y1,Y2,
     +     Z1,Z2,XYS,DSTAR2,DSTMAX,DSTPL,DSTPL2,DIVH,DIVV,DELAMB,
     +     ETA,DELCOR,DSTMAXS,TOR,DSTMIN,WMAX,ETAFRAC,ETASM,
     $     GON_CHI,GON_PHIS,GON_KAPPA,GON_OMEGAS,GON_2THETA,
     $     GON_PHIE,GON_OMEGAE,
     +     GON_CHI_SET,GON_KAPPA_SET,ISYN,IMONO,
     $     NWMAX,IPAD,
     $     NSMOOTH,IGON_CHI,IGON_PHI,
     $     IGON_KAPPA,IGON_OMEGA,IGON_2THETA,
     +     IGON_CHI_SET,IGON_KAPPA_SET,IHOSCAXIS,LOGETA,NUREEK,LCAMCON,
     $     GENGON,FOURCIRCLE,THREECIRCLE,
     +     BLKSIZE
C     ..
C
C
C&&*&& end_include  ../inc/reeke.f
C&&*&& include  ../inc/tiltlog.f
C
C $Id: tiltlog.f,v 1.1 2002/05/02 10:47:23 harry Exp $
C
C---- awk generated include file tiltlog.h
C---- START of include file tiltlog.h
C
C    for things connected with the new definitions of TILT and TWIST 
C
C     .. Scalars in common block /TILTLOG/ ..
      LOGICAL NUTWIST
      COMMON /TILTLOG/NUTWIST
C&&*&& end_include  ../inc/tiltlog.f
C&&*&& include  ../inc/trigparam.f
C 
C $Id: trigparam.f,v 1.3 2008/07/31 11:46:02 harry Exp $
C
C
C     Trigonometric parameters - set here to highly precise values, don't 
C     calculate in code; values from Clemens Vonrhein
C
C     DTOR.. convert degrees to radians
C     RTOD.. convert radians to degrees
C     PI..   value of PI
      REAL PI
      PARAMETER   ( PI = 3.1415926536 )
      REAL          TWOPI
      PARAMETER   ( TWOPI = 6.2831853072 )
      REAL RTOD
      PARAMETER   ( RTOD = 57.2957795131 )
      REAL          DTOR
      PARAMETER   ( DTOR = 0.0174532925 )
C DOUBLE PRECISION...
      DOUBLE PRECISION PI_DOUBLE
      PARAMETER ( PI_DOUBLE = 3.1415926535897932384626433832795029D0 )
      DOUBLE PRECISION TWOPI_DOUBLE
      PARAMETER ( TWOPI_DOUBLE = 
     $     6.2831853071795864769252867665590058D0 )
      DOUBLE PRECISION RTOD_DOUBLE
      PARAMETER ( RTOD_DOUBLE = 57.2957795130823208768D0 )
      DOUBLE PRECISION DTOR_DOUBLE
      PARAMETER ( DTOR_DOUBLE = 0.01745329251994329576D0 )
c

c
C&&*&& end_include  ../inc/trigparam.f
C&&*&& include  ../inc/xy.f
C
C $Id: xy.f,v 1.1 2002/05/02 10:47:25 harry Exp $
C
C--- awk generated include file  xy.h
C---- START of include file xy.h
C
C     .. Scalars in common block /XY/ ..
      REAL XTOFD,SINV,COSV,TANV,TWOTHETA
      INTEGER ICASS
C     ..
C     .. Common Block /XY/ ..
      COMMON /XY/XTOFD,SINV,COSV,TANV,TWOTHETA,ICASS
C     ..
C
C     XTOFD....  Crystal to detector distance in 10 micron units. Read from
C                keyworded input and never changed.
C
C                Spot positions are calculated in S/R XYSPOT (Called from
C                REEK) and are for an "ideal" detector at a distance of XTOFD.
C                These are converted into pixel positions in S/R MMTOPX
C                which applies the multiplicative factor XTOFRA to allow
C                for refinement of the distance. XTOFRA is the parameter
C                that is actually refined (in RDIST), rather than XTOFD.
C                The refined distance that is printed in the logfile is
C                actually XTOFRA*XTOFD
C
C     ICASS....  Indicates detector type:
C                0     Flat film
C                1     Vee shaped cassettes
C                2     FAST detector (only used in TESTGEN mode of OSCGEN)
C                3     Swung out FAST (ditto)
C                4     IP detector
C     TWOTHETA   Detector swing angle (degrees)
C&&*&& end_include  ../inc/xy.f
C     
C..   Local scalars
      CHARACTER CALLEDFROM*80
C     ..
C     .. External Functions ..
      INTEGER LENSTR
      EXTERNAL LENSTR
C
C..   External subroutines
      EXTERNAL ROTMAT2
      CALLEDFROM = 'SETDIS'
      IF(XTOFD.GT.1E-2)FDIST = DTOR/(XTOFD * 100.0)
C     
C---- 
C     
      IF(NUTWIST)THEN
         IF(IMODE.EQ.1)THEN
            TILT = FLOAT(ITILT) * 1E-2 * RTOD
            TWIST = FLOAT(ITWIST) * 1E-2 * RTOD
            CALL ROTMAT2(DETNOR,TILT,TWIST)
         ELSE IF (IMODE.EQ.2)THEN
            ITILT = NINT(TILT*1E02) * DTOR
            ITWIST = NINT(TWIST*1E02) * DTOR
         ELSE
            WRITE(IOUT,1010)
            IF(ONLINE)WRITE(ITOUT,1010)
            NSHUTERR = 1
            CALL SHUTDOWN(CALLEDFROM,LENSTR(CALLEDFROM))
         ENDIF
      ELSE
         IF(IMODE.EQ.1)THEN
            TILT = REAL(ITILT)*FDIST
c            TWIST = (REAL(ITWIST)*FDIST)-(BEAMMU(2)*DTOR*0.91*1E-4)
            TWIST = REAL(ITWIST*FDIST)
         ELSE IF (IMODE.EQ.2)THEN
            IF(FDIST.NE.0.0)THEN
               ITILT = NINT(TILT/FDIST)
c               ITWIST = NINT((TWIST+(BEAMMU(2)*DTOR*0.91*1E-4))/FDIST)
               ITWIST = NINT(TWIST/FDIST)
            ELSE
               WRITE(IOUT,FMT=1000)
               IF(ONLINE)WRITE(ITOUT,FMT=1000)
            ENDIF
         ELSE
            WRITE(IOUT,1010)
            IF(ONLINE)WRITE(ITOUT,1010)
            NSHUTERR = 2
            CALL SHUTDOWN(CALLEDFROM,LENSTR(CALLEDFROM))
         ENDIF
      ENDIF
      RETURN
 1000 FORMAT(3(5('*'),3(' WARNING '),5('*'),/),1X,'Crystal ',
     $              'to detector distance undefined, therefore TILT ',
     $              'and TWIST are undefined - set to ZERO')
 1010 FORMAT('Error in SETDIS; IMODE MUST BE 1 or 2',/,'Programm',
     $     'er error in calling routine!')
      END
C
C $Id: sprocess.f,v 1.19 2008/09/10 17:05:06 andrew Exp $
C
C==   SPROCESS ==
      SUBROUTINE SPROCESS(LEN,IBUFF,SUMPART,POSTREF,NEWPREF,IERR)
C     ======================================================
C     
      IMPLICIT NONE
C     
C     
C---- This subroutine processes the measurement boxes for each spot
C     as soon as all the pixels have been accumulated in subroutine MEAS.
C     Pixel values are passed in array BOXOD in /PEL/, and extracted by calling
C     CBYTE2, which transfers byte od to I*4 variable IBA in the case of
C     film data, and I*2 words to IBA for image plate data.
C     It thus avoids writing and reading the file MOSFLM.OUT
C     however the array "MASK" can no longer be equivalenced to IDUM.
C     
C     Notice that SUMPART is not actually required for this subroutine itself
C     but has to be passed in call to WRGEN
C     
C******DEBUG(49) FOR THIS SUBROUTINE (DEBUG SPROCESS) ******
C     
C---- LEN is used as a flag
C     = -1 for estimation of resolution from intensities in bins.
C     =0  First call to SPROCESS to initialise parameters
C     =1  Final call to print statistics
C     Otherwise...
C     = Length of od buffer =0.5*(number of pixels in spot) for film data
C     =(number of pixels in spot) for image plates
C     
C     
C     
C     IBUFF (passed from meas) contains:
C     1    Record number
C     2    X coordinate
C     3    Y coordinate
C     4    NXX box size in X
C     5    NYY box size in Y
C     6    Profile box number
C     
C     IERR return error flag =  0 okay 
C                            != 0 unspecified error
C     
C     .. Parameters ..
C&&*&& include  ../inc/parameter.f
C
C $Id: parameter.f,v 1.17 2009/10/28 16:43:34 harry Exp $
C
C--- awk generated include file  parameter.h
C---- START of include file parameter.h
C
C       PARAMETERS
C       IYLENGTH.. maximum number of I*2 words of data in the 
C                  "fast" (ie most rapidly changing) direction in the
C                  digitised image. This will be HALF the number of pixels
C                  for film data (each pixel is stored in one byte)
C                  but will equal the number of pixels for IP data.
C       IXWDTH...  The maximum number of "stripes" of data in the scanned image
C                  ie the number of pixels in the "slow" direction
C                  (This is the Y direction in the MOSFLM convention)
C                  Note that the array "IMAGE" used to store the image is
C                  declared as size IYLENGTH*IXWDTH I*2 words for IP data
C                  and 2*IYLENGTH*IXWDTH BYTES for film data.
C                  If this exceeds the
C                  available memory, set ixwdth=1, recompile program
C                  and use keyword "NOCORE" when running program.
C                  Note that for the POSTREF and ADDPART options,
C                  two images have to be stored in memory at once so
C                  IXWDTH should be twice the number of records in an
C                  image.
C       MAXHEAD    maximum length of image header (in 4 byte words)
C       NREFLS.... maximum number of spots per film in generate file (250,000)
C       MAXBOX.... maximum number of pixels in measurement box (1500)
C       MAXDIM.... maximum box size in either direction (pixels) (41)
C       MAXPAX.... maximum number of packs per generate file (10000)
C       MXDOV2..... maxdim/2
C       MAXBUFF... maximum size of buffer (I*2) for storing ods
C                  of active spots in subroutine meas(21,000).
C                  Must be .GE.  MAXBOX*(NNLINE-1) for subroutine process
C       MREF...... maximum number of reflections to be used in post
C                  refinement (6000)
C       NEXPAND... maximum number of expansions of the input measurement
C                  box (2)
C       NMASKS.... maximum number of different profiles (25). Note the
C                  connection between this parameter and NNLINE
C       NVECT..... maximum number of vectors for storing scanned image
C                  in filmplot (10000)
C       NIMAX..... maximum number of images to be used together in 
C                  postrefinement (NADD or WIDTH options) (100)
C       NNLINE...  maximum number of boundary lines for setting up
C                  the areas for profile fitting. The maximum possible
C                  number of standard profiles will be (NNLINE-1)**2
C                  although for a circular detector the actual number
C                  may be less than this as some boxes will lie entirely
C                  outside the detector.
C       NREJMAX... Maximum number of rejected background pixels, resulting
C                  either from overlap of adjacent spots or outliers from
C                  the background plane
C       NSPOTS...  Maximum number of found spots (for autoindexing) that can
C                  be stored (for all images). Also maximum number in 
C                  a file wriitten by IMSTILLS that can be 
C                  stored/displayed/edited. THis must be an even number
C       MCOLS....  Number of columns in output MTZ file
C       MCOLSTR..  Number of columns in output MTZ file for strategy option
C     
C       MTZ Orientation block
C        MBLENG is total length of block, MBLINT, MBLREA are numbers
C          of integers & reals
C       NDETREF    Maximum number of reflections used for detector parameter
C                  refinement (previously 62)
C       NRPAR....  Maximum number of refineable parameters for detector
C                  positional refinement (subroutine RDIST)
C       NSEGMAX..  Maximum number of segments in STRATEGY
C       NSEGMAXPR  Maximum number of segments in POST-REFINEMENT
C       MULTMAX... Maximum number of observations with same hkl in COMPLETE
C       MAXDIFF... Maximum number of different packs that a given hkl occurs on
C       NRESBIN... Maximum number of resolution bins (COMPLETE)
C
C       MAXIMG...  Maximum number of images that can be read in using the IMAGE
C                  keyword or the "read Image" menu option.
C       MXSPOT...  Maximum number of spots that can be found on one image
C                  (before rejection on spot size).
C       MXCENT...  Maximum number of active spots during spot finding 
C                  (findspots)
C
C       MGRA, NGRA... maximum number of reflections and images over which a 
C                     reflection can be spread for postrefinement.
C       MAXBGBOX    Maximum number of local background background boxes 
C                   in X and Y
C
C       MAXNPEAKS   Maximum number of local maxima within one spot
C       MAXEXCL     Maximum number of excluded areas of the same type
C                   eg reactangles, quadrilaterals, arcs, resolution shells
C
C     .. Parameters ..
      INTEGER IXWDTH
c      PARAMETER (IXWDTH=8192)
      PARAMETER (IXWDTH=12288)
      INTEGER IYLENGTH
c      PARAMETER (IYLENGTH=4096)
      PARAMETER (IYLENGTH=6144)
      INTEGER MAXHEAD
      PARAMETER (MAXHEAD=5120)
      INTEGER MAXBOX
      PARAMETER (MAXBOX=3000)
      INTEGER MAXDIM
      PARAMETER (MAXDIM=41)
      INTEGER MAXPAX
      PARAMETER (MAXPAX=10000)
      INTEGER MXDOV2
      PARAMETER (MXDOV2=MAXDIM/2)
      INTEGER NEXPAND
      PARAMETER (NEXPAND=2)
      INTEGER NNLINE
      PARAMETER (NNLINE=8)
      INTEGER NMASKS
      PARAMETER (NMASKS=49)
      INTEGER MAXBUFF
      PARAMETER (MAXBUFF=21000)
      INTEGER NREFLS
      PARAMETER (NREFLS=250000)
      INTEGER MREF
      PARAMETER (MREF=6000)
      INTEGER NVECT
      PARAMETER (NVECT=10000)
      INTEGER NIMAX
      PARAMETER (NIMAX=100)
      INTEGER NREJMAX
      PARAMETER (NREJMAX=1000)
      INTEGER NSPOTS
      PARAMETER (NSPOTS=5000)
      INTEGER MCOLS
      PARAMETER (MCOLS=18)
      INTEGER MCOLSTR
      PARAMETER (MCOLSTR=6)
      INTEGER NREFSTR
C
C---- Each reflection for strategy run needs MCOLSTR I*2 words
C     plus an I*4 word for the merging
C
      PARAMETER (NREFSTR = IXWDTH*IYLENGTH/(2+MCOLSTR))
      INTEGER MBLENG,MBLINT,MBLREA
      PARAMETER (MBLENG=185,MBLINT=29,MBLREA=156)
      INTEGER NDETREF
      PARAMETER (NDETREF=400)
      INTEGER NRPAR
      PARAMETER (NRPAR=14)
      INTEGER NSEGMAX
      PARAMETER (NSEGMAX=100)
      INTEGER NSEGMAXPR
      PARAMETER (NSEGMAXPR=100)
      INTEGER MULTMAX
      PARAMETER (MULTMAX=100)
      INTEGER MAXDIFF
      PARAMETER (MAXDIFF=100)
      INTEGER NRESBIN
      PARAMETER (NRESBIN=20)
      INTEGER MXSPOT
      PARAMETER (MXSPOT=5000)      
      INTEGER MAXIMG
      PARAMETER (MAXIMG=100)      
      INTEGER NPIXBG
      PARAMETER (NPIXBG=51)
      INTEGER MXCENT
      PARAMETER (MXCENT=500)
      INTEGER    NGRA,MGRA
      PARAMETER (NGRA=20)
      PARAMETER (MGRA=50000)
      INTEGER MAXBGBOX
      PARAMETER (MAXBGBOX=500)
      INTEGER MAXNPEAKS
      PARAMETER (MAXNPEAKS=500)
      INTEGER MAXEXCL
      PARAMETER (MAXEXCL=50)
C&&*&& end_include  ../inc/parameter.f
C     ..
C     .. Scalar Arguments ..
      INTEGER LEN,IERR
      LOGICAL SUMPART,POSTREF,NEWPREF
C     ..
C     .. Array Arguments ..
      INTEGER IBUFF(6)
C     ..
C     .. Local Scalars ..
      REAL BASE,BGDEVMAX,BGND,BGRATIO,BGRMS,BOXFAC,CFAC,DELX,
     +     DELY,PI,RMSBG,SCAI,SOD,TBGND,TPEAK,
     +     TRUOD,VBG,VSPOT,WPX,WPY,XX,YY,XC,YC,XCG,YCG,A,B,C,
     +     RESID,RETA,RDIVH,RDIVV,PKRATIOS,VARTOT,GRADM,DSTSQ
      INTEGER I,IBGND,IDR,II,IMAP,IRECG,ISDBSI,ISPOT,IXPIX,
     +     IXX,IYPIX,IYY,J,JREC,JUNK,K,KREC,MODEWR,N,NBOXES,NC,NY,
     +     NRX,NRY,NSPT,NXS,NXX,NXY,NYS,NYY,IFAIL,NREJ,NRFL,
     +     NCOUNT,IOVER,ISPOTPRO,ISIGPRO,NSBOX,IPART,ITHBIN,
     +     NBADBG,NPBOX,ISTRIP,ISTRIPCUR,NFBOX,MAXPIX,NBIN1,ISTAT,
     +     IMODE,LASTREC,NNN,KHF
      LOGICAL FULL,LDUMP,YES,PROFILEDUM,USEOVRLDDUM,OVRLFITDUM,
     +        FIXEDDUM,BADFLAG,MULTISEG
      CHARACTER CALLEDFROM*80
C     ..
C     .. Local Arrays ..
      REAL SUMPQ(6,1:NNLINE-1),XSH(16),YSH(16),PQSUMS(6)
      INTEGER IH(7),IHD(3,50),LRAS(5),MASK(MAXBOX,1:NNLINE-1),
     +     NSH(16),OD(MAXBOX),TABLE(0:255),MASKREJ(NREJMAX)
C     ..
C     .. External Functions ..
      INTEGER LENSTR
      EXTERNAL LENSTR
C     ..
C     .. External Subroutines ..
      EXTERNAL CBYTE2,COMPR,GETHKL,
     +     INTEG,PWRGEN,RASPLOT,REPORT,
     +     SETMASK,SETSUMS,WRGEN,XYSHIFT,YESNO,POSTREFL,
     +     ODPLOT4,GETYIND,GETSTRIP,GETBIN,MMTOPX,SHUTDOWN
C     ..
C     .. Intrinsic Functions ..
      INTRINSIC ABS,AMAX0,ATAN,COS,MAX,MIN,SQRT
C     ..
C     .. Common blocks ..                  
C&&*&& include  ../inc/amatch.f
C
C $Id: amatch.f,v 1.1 2002/05/02 10:46:40 harry Exp $
C
C--- awk generated include file  amatch.h
C---- START of include file amatch.h
C
C
C     .. Scalars in Common /AMATCH/ ..
C     ..
      REAL RCONV,OVRLAP,RESOL1,RESOL2,AELIMIT,ARMSLIM,
     +     SECANGLE,DAMP,TRUECCOM,ETAMAX,AWRMSLIM,MOSNEW,
     $     SLOPE,INTERCEPT
      INTEGER NSTEP,NCYCA,NPASS,N2,N3,N4,N5,N6,N7,N8,N9,N10,NBEAM
      LOGICAL MATCH,NOCENT,NOREFINE,RMOSAIC
C     ..
C     .. Common block /AMATCH/  ..
      COMMON /AMATCH/RCONV,OVRLAP,RESOL1,RESOL2,AELIMIT,ARMSLIM,
     +     SECANGLE,DAMP,TRUECCOM,ETAMAX,AWRMSLIM,MOSNEW,
     $     SLOPE,INTERCEPT,NSTEP,NCYCA,NPASS,N2,N3,N4,N5,N6,N7,
     $     N8,N9,N10,NBEAM,MATCH,NOCENT,NOREFINE,RMOSAIC
C     ..
C
C
C&&*&& end_include  ../inc/amatch.f
C&&*&& include  ../inc/backg.f
C
C $Id: backg.f,v 1.1 2002/05/02 10:46:40 harry Exp $
C
C--- awk generated include file  backg.h
C---- START of include file backg.h
C
C
C
C     .. Scalars in common block /BACKG/ ..
      REAL BGFRAC
      INTEGER NBGMIN
C     ..
C     .. Common Block /BACKG/ ..
      COMMON /BACKG/ BGFRAC,NBGMIN
C     ..
C
C
C&&*&& end_include  ../inc/backg.f
C&&*&& include  ../inc/comarray.f
C
C $Id: comarray.f,v 1.1 2002/05/02 10:46:43 harry Exp $
C
C
C Common bits for the big array handling for post refinement
C
C---- for passing the summed partials around different routines
C
      INTEGER INTPOST(2),SIGPOST(2)
C
C---- COMMON BLOCK POSTPHI
C
      REAL PHIPOST
      COMMON /POSTPHI/ PHIPOST
C
C---- COMMON block /SUMPARTS/
C
      INTEGER JCOUNT
      COMMON /SUMPARTS/ JCOUNT
C
C---- COMMON block /IMAGENO/
C
      INTEGER   IMAGE_NUMBER
      COMMON /IMAGENO/ IMAGE_NUMBER
C&&*&& end_include  ../inc/comarray.f
C&&*&& include  ../inc/debug.f
C
C $Id: debug.f,v 1.2 2008/07/24 09:42:21 andrew Exp $
C
C--- awk generated include file  debug.h
C---- START of include file debug.h
C
C
C
C     .. Arrays in common /DEBUG/ ..
      REAL XWARN
      INTEGER NDEBUG,IWARN
      LOGICAL DEBUG,LPRINT,DUMP,WARN
C
C     .. Scalars in common /DEBUG/ ..
      REAL BGRLIM
      INTEGER NDUMP,IDUMP,MXDUMP
      LOGICAL SPOT
C     
C     ..
C     .. Common Block /DEBUG/..
      COMMON /DEBUG/XWARN(20,100),BGRLIM,NDEBUG(100),IWARN(20,100),
     $       NDUMP,IDUMP,MXDUMP,DEBUG(100),LPRINT(20),DUMP(30),
     +       WARN(100),SPOT
C     ..
C
C&&*&& end_include  ../inc/debug.f
C&&*&& include  ../inc/film_no.f
C
C $Id: film_no.f,v 1.2 2004/07/20 12:36:58 harry Exp $
C
        INTEGER ID
        COMMON /FILM_NUM/ ID
C&&*&& end_include  ../inc/film_no.f
C&&*&& include  ../inc/gendata.f
C
C $Id: gendata.f,v 1.2 2003/01/10 16:17:53 andrew Exp $
C
C--- awk generated include file  gendata.h
C---- START of include file gendata.h
C
C     IMG       Partiality indicator. 0 for full reflections, 1 to 100
C                   for partials. Negative for partials at the start of the
C                   rotation range, +ve for partials at the end of the 
C                   rotation. Set in subroutine REEK using DELEPS calculated
C                   in subroutine DSTAR
C
C     IRG       Reflection flag  (Set by SPTEST called from DSTAR)
C               =  0  Spot can be measured
C               =  1  Outside R, X, Y limits
C               =  2  Overlapping spot (set later)
C               =  3  Too wide in phi (more than NWMAX images)
C               =  4  DST .GT. DSTMAX  Not included in final film list -
C                       used only to check for overlaps at edge of film.
C               = 10  Spot is within cusp, but will be observed...not included
C                     in final spot list but must be included in predicted
C                      pattern
C
C               =  21  Spot present on 2 images, this is 1st
C               =  22  Spot present on 2 images, this is 2nd
C
C               =  31  Spot present on 3 images, this is 1st
C               =  32  Spot present on 3 images, this is 2nd
C               =  33  Spot present on 3 images, this is 3rd
C
C               =  41  Spot present on 4 images, this is 1st
C               =  42  Spot present on 4 images, this is 2nd
C               =  43  Spot present on 3 images, this is 3rd
C               =  44  Spot present on 4 images, this is 4th
C
C                 etc etc
C
C     XG        Virtual detector X coordinate in 10 micron units, relative to
C               an origin at the direct beam position. X is parallel to the
C               Y axis in the laboratory frame, ie orthogonal to the rotation
C               axis.
C
C     YG        Virtual detector Y coordinate in 10 micron units, relative to
C               an origin at the direct beam position. Y is parallel to the
C               Z axis in the laboratory frame, ie  the rotation axis.
C
C     IX,IY     are the coordinates of the reflection in pixels
C               (integers) wrt the first pixel in the image (lower left corner
C               cameramans view). For testing for spot overlap, these
C               coordinates are in 10 micron units. Also used for display
C               pixel coordinates when displaying predicted pattern.
C
C     IREC      Pointer to the record number of a particular spot in the
C               list of generated reflections.
C
C
C     ..
C     .. Arrays in common /GENDATA/ ..
      REAL FRACG,PHIG,PHIWG,XG,YG,GOODFIT
      INTEGER INTG,IPRO,IX,IY,IREC
      INTEGER*2 IRG,IMG,IGFLAG,ISDPRO,ISDG,IHG,IKG,ILG,IMPARTG,
     +          MISYMG
C     .. Scalars in common /GENDATA/ ..
      INTEGER IPACKREC,IPACKHEAD,IRECLAST
C     ..
C     .. Common block /GENDATA/ ..
      COMMON /GENDATA/FRACG(NREFLS),PHIG(NREFLS),PHIWG(NREFLS),
     $       XG(NREFLS),YG(NREFLS),INTG(NREFLS),IPRO(NREFLS),
     $       IX(NREFLS),IY(NREFLS),IREC(NREFLS),IRG(NREFLS),IMG(NREFLS),
     +       IGFLAG(NREFLS),ISDPRO(NREFLS),ISDG(NREFLS),
     +       IHG(NREFLS),IKG(NREFLS),ILG(NREFLS),IMPARTG(NREFLS),
     +       MISYMG(NREFLS),GOODFIT(NREFLS),IPACKREC,IPACKHEAD,
     +       IRECLAST
C     ..
C
C

C&&*&& end_include  ../inc/gendata.f
C&&*&& include  ../inc/ioo.f
C
C $Id: ioo.f,v 1.7 2009/05/13 11:57:53 harry Exp $
C
C--- awk generated include file  ioo.h
C---- START of include file ioo.h
C
C
C
C     .. Scalars in common block /IOO/ ..
      INTEGER IOUT,IUNIT,ITIN,ITOUT,INOD,INMO,IDU,NWRN,IBRIEF,ISUMMR,
     +        ICOORD,SERVERFD,SERVERFDIN,NSHUTERR,dnafd
      LOGICAL ONLINE,ONEFILE,FHEADER,BRIEF,GRAPH,IOERR,
     $     NODISPLAY,LBELL,JPGOUT,SOCKLO,LBEST,dnaout,INMOOPEN,
     $     XMLOPEN
      CHARACTER dna_image*80,xmlfile*80
C     ..
C     .. Common block /IOO/ ..
c      COMMON /IOO/IOUT,IUNIT,ONLINE,ITIN,ITOUT,INOD,INMO,IDU,NWRN,
c     +            ONEFILE,FHEADER,BRIEF,IBRIEF,GRAPH,ISUMMR,ICOORD,
c     +            IOERR,NODISPLAY,LBELL
C     ..
C
C
      COMMON /IOO/IOUT,IUNIT,ITIN,ITOUT,INOD,INMO,IDU,NWRN,IBRIEF,
     +        ISUMMR,ICOORD,SERVERFD,SERVERFDIN,NSHUTERR,ONLINE,ONEFILE,
     +        FHEADER,BRIEF,GRAPH,IOERR,NODISPLAY,LBELL,JPGOUT,
     $        SOCKLO,LBEST, dnafd, dnaout,INMOOPEN,XMLOPEN
      COMMON /CIOO/dna_image,xmlfile

C&&*&& end_include  ../inc/ioo.f
C&&*&& include  ../inc/lmb.f
C
C $Id: lmb.f,v 1.8 2009/01/08 18:03:14 harry Exp $
C
C--- awk generated include file  lmb.h
C---- START of include file lmb.h
C ODSCAL is to scale image numbers into the range 0-255 for plotting
C average profiles.
C  GAIN should be equal to the overall gain (image counts per X-ray photon)
C of the system, and is used to evaluate standard deviations based on
C counting statistics assuming independent pixels (ie point spread function
C less than pixel size).
C INVERTX true if image is inverted in the slow (X) direction when read in.
C ISCAL is to scale final integrated intensities and sigmas
C IDIVIDE is the adc offset
C ICONST is a constant to be added to all pixels (normally zero) to
C        allow processing of images with zero pixel values in the scanned
C        area.
C IMGP is true if working with image plate data
C SPIRAL is true for scanners with a spiral readout (Mar, DIP2000)
C ORTHOG is true for scanners with orthogonal scan (FUJI, RAXIS, MD)
C NULLPIX is the value of pixels within the image but not in the active
C area of the detector
C TILED is true if there are inactive areas of the detector within the
C       inscribing circle or square.
C
C NTILEX Number of tiles in X direction
C NTILEY Number of tiles in Y direction
C TILEX  X Coordinates of the midpoints of the null areas between tiles
C TILEY  Y Coordinates of the midpoints of the null areas between tiles
C TILEWX Width of the null areas between tiles in X
C TILEWY Width of the null areas between tiles in Y


C MACHINE and MODEL denote the type of detector. 
C
C MACHINE is used in the following subroutines:
C GETBLK, GETHDR, INTPXL, INTPXL2, MXDSPL, OPENODS, PROCESS, PUTPXL
C Currently coded types are:
C
C         MACHINE        MODEL               COMMENTS
C         =======        =====               ========
C         MAR            180, 300, 345
C         RAXI(S)        RAXISII, RAXISIV
C         MD
C         FUJI
C         CCD1           CCD1                Princetown CCD at CHESS,Tiff format
C         CCD2           CCD ?               ESRF CCD detector
C         ADSC           QUAD1               ADSC 2x2 CCD detector
C
C TRUSTED whether or not the image header information can be trusted for 
C         automatic processing
C     .. Scalars in Common Block /LMB/ ..
        REAL ODSCAL,GAIN,LOGA,LOGB
        INTEGER ISCAL,IDIVIDE,ICONST,NULLPIX,NTILEX,NTILEY,
     $    RAXISCOMP,IIDIVIDE,COMPRESSION
        LOGICAL IMGP,INVERTX,SPIRAL,ORTHOG,CIRCULAR,TILED,SETADC,
     $    NEWRAXIS,BRUKNEW,TRUSTED
        CHARACTER MACHINE*4,MODEL*8

C     ..
C     .. Arrays in common /LMB/
        INTEGER TILEX,TILEY,TILEWX,TILEWY
C
C     .. Common Block /LMB/ ..
        COMMON /LMB/ ODSCAL,GAIN,LOGA,LOGB,ISCAL,IDIVIDE,ICONST,
     +       NULLPIX,NTILEX,NTILEY,RAXISCOMP,IIDIVIDE,COMPRESSION,
     +       TILEX(20),TILEY(20),TILEWX(20),TILEWY(20),IMGP,
     +       INVERTX,SPIRAL,ORTHOG,CIRCULAR,TILED,SETADC,
     $       NEWRAXIS,BRUKNEW,TRUSTED
        COMMON /LMBC/ MACHINE,MODEL

C&&*&& end_include  ../inc/lmb.f
C&&*&& include  ../inc/mcs.f
C $Id: mcs.f,v 1.1 2002/05/02 10:46:56 harry Exp $
C
C
C--- awk generated include file  mcs.h
C---- START of include file mcs.h
C
C
C     .. Scalars in common block /MCS/ ..
      REAL BASEOD,G1OD,CURV
      INTEGER FILM,FILMS,CTOFD,PCKIDX,TOSPT,N1OD,XSCMIN,XSCMAX
      LOGICAL VEE,VALONGX
C     ..
C     .. Common block /MCS/ ..
      COMMON /MCS/BASEOD,G1OD,CURV,FILM,FILMS,CTOFD,PCKIDX,TOSPT,
     $            N1OD,XSCMIN,XSCMAX,VEE,VALONGX
C     ..
C     CTOFD.... This was the crystal to detector distance (10 micron units)
C               but it has now been replaced by XTOFD in common block /XY/
C
C&&*&& end_include  ../inc/mcs.f
C&&*&& include  ../inc/myprof.f
C
C $Id: myprof.f,v 1.2 2007/06/25 16:18:20 andrew Exp $
C
C--- awk generated include file  myprof.h
C---- START of include file myprof.h
C
C
C     .. Arrays in Common Block /MYPROF/ ..
      REAL PRSCALE,XPMAX,YPMAX,XLINE,YLINE,WPROFL,WPRSUMS
      INTEGER ISIZE,NRFBOX,IPROFL,IBOX,IXBOX,IYBOX,NPFIRST
      LOGICAL BOX
C     ..
C     .. Scalars in Common Block /MYPROF/
      REAL TOL,BGPKRAT,FRACREJ,BADTOL,TOLMIN,RECLEVEL
      INTEGER NXLINE,NYLINE,NUMBOX,IBOUND,ITRIM,NOVERLAP,MINPKSIZ
      LOGICAL HIGHRES,LOWRES,PRSET,OFFDET,PROPT,FIXBOX,LINESET,
     +        PROPTCEN,RECOVER,NOFIXBOX
C     ..
C     .. Common Block /MYPROF/ ..
      COMMON /MYPROF/PRSCALE(NMASKS,2),XPMAX(NMASKS),YPMAX(NMASKS),
     $       XLINE(NNLINE),YLINE(NNLINE),
     +       WPROFL(MAXBOX,NMASKS),WPRSUMS(MAXBOX,NMASKS),TOL,
     +       BGPKRAT,FRACREJ,BADTOL,TOLMIN,RECLEVEL,
     $       ISIZE(NMASKS,2),NRFBOX(NMASKS),
     +       IPROFL(MAXBOX,NMASKS+1),IBOX(0:NNLINE,0:NNLINE),
     +       IXBOX(NMASKS,2),IYBOX(NMASKS,2),
     +       NPFIRST(NNLINE-1),NXLINE,NYLINE,NUMBOX,IBOUND,ITRIM,
     $       NOVERLAP,MINPKSIZ,BOX(NMASKS),HIGHRES,LOWRES,PRSET,
     +       OFFDET,PROPT,FIXBOX,LINESET,PROPTCEN,RECOVER,NOFIXBOX
C     ..
C
C
C&&*&& end_include  ../inc/myprof.f
C&&*&& include  ../inc/ori.f
C
C $Id: ori.f,v 1.2 2007/07/12 13:25:56 andrew Exp $
C
C--- awk generated include file  ori.h
C---- START of include file ori.h
C
C     XCEN,YCEN    Coordinates (in 10 micron units) of the direct beam
C                  position relative to an origin at the position of the
C                  first pixel in the digitised image.(The SCANNER
C                  coordinate frame). These parameters are refined for
C                  each image. 
C
C     XCEN0,YCEN0  Coordinates of direct beam position at zero swing angle.
C                  (Needed for pxtomm conversion for swung detectors)
C                  These values are assigned on the basis of input direct
C                  beam coordinates, corrected for swing angle if necessary.
C                  They are not (currently) updated during refinement.
C
C     XOFF,YOFF    Distance between centre of detector and direct beam.
C
C     ..
C     .. Arrays in common /ORI/ ..
      LOGICAL FIXPAR
C
C     .. Scalars in common block /ORI/ ..
      REAL COSOM0,SINOM0,XTOFRA,YSCAL,TILT,TWIST,BULGE,
     +     VBNEG,VBPOS,VTILT,VTWIST,VVERT,TOFF,BULGE2,PBULGE,ROFF,
     +     RDTOFF,RDROFF,ROFFPHI,TOFFPHI,JUNK3,XCEN,YCEN,XCEN0,YCEN0,
     +     XOFF,YOFF,TILTMAT,TWISTMAT,DETNOR,DPSIX,SMTWIST,SMTILT,
     +     SMOMEGA0,SMYSCAL,SMTOFF,SMROFF,SMXTOFRA
      INTEGER CBAR,NODES,NPHI,NSM1,NSM2
      LOGICAL RESETCCOM,NOSMOOTH
C     ..
C     .. Common Block /ORI/ ..
      COMMON /ORI/COSOM0,SINOM0,XTOFRA,YSCAL,TILT,TWIST,BULGE,
     $       VBNEG,VBPOS,VTILT,VTWIST,VVERT,TOFF,BULGE2,PBULGE,ROFF,
     $       RDTOFF,RDROFF,ROFFPHI,TOFFPHI,JUNK3,XCEN,YCEN,XCEN0,
     +       YCEN0,XOFF,YOFF,TILTMAT,TWISTMAT,DPSIX,DETNOR(3),CBAR,
     +       NODES,NPHI,FIXPAR(NRPAR),
     $       RESETCCOM,SMTWIST,SMTILT,SMOMEGA0,SMYSCAL,SMTOFF,SMROFF,
     +       SMXTOFRA,NSM1,NSM2,NOSMOOTH
C     ..
C
C
C&&*&& end_include  ../inc/ori.f
C&&*&& include  ../inc/parm1.f
C
C $Id: parm1.f,v 1.1 2002/05/02 10:47:05 harry Exp $
C
C--- awk generated include file  parm1.h
C---- START of include file parm1.h
C
C
C
C     .. Scalars in common block /PARM1/ ..
      REAL BGSIG,EFAC,EFACSQ,BGFREJ,GRADMAX,GRADMAXR,BGRAT,PKRAT,
     +     RESD,RESDLOW
      INTEGER CUTOFF,NOVPIX,NDSTART,NDTOT,IXDMIN,IXDMAX,IYDMIN,IYDMAX,
     +     IDMIN,IDMAX
      LOGICAL DUMPSPOT,BADPLOT,DUMPALL,BADPLOT2
C     ..
C     .. Common Block /PARM1/ ..
      COMMON /PARM1/BGSIG,EFAC,EFACSQ,BGFREJ,GRADMAX,GRADMAXR,
     +              BGRAT,PKRAT,RESD,RESDLOW,CUTOFF,NOVPIX,
     +              NDSTART,NDTOT,IXDMIN,IXDMAX,IYDMIN,IYDMAX,
     +              IDMIN,IDMAX,DUMPSPOT,BADPLOT,DUMPALL,BADPLOT2
C     ..
C
C
C&&*&& end_include  ../inc/parm1.f
C&&*&& include  ../inc/pel.f
C     **** This is the IMAGE PLATE version of this common block ****
C
C
C---- START of include file pel.h
C
C
C     .. Scalars in common blocks /PEL/ and /PELC/ ..
      INTEGER IBA,IPOINT,ISTART
      LOGICAL INCORE
C     ..
C     .. Arrays in common blocks /PEL/ and /PELC/ ..
      LOGICAL RDSTRIP
      INTEGER*2 BOXOD,IMAGE
C     ..
C     .. Common Blocks /PEL/ and /PELC/ ..
      COMMON /PEL/IBA,IPOINT,INCORE,RDSTRIP(IXWDTH),BOXOD(MAXBOX),
     +            ISTART
      COMMON /PELC/ IMAGE(IYLENGTH*IXWDTH)
C     ..
C
C
C---- END of include file pel.h
C
C&&*&& end_include  ../inc/pel.f
C&&*&& include  ../inc/precession.f
C
C $Id: precession.f,v 1.1 2002/05/02 10:47:08 harry Exp $
C
C--- awk generated include file  precession.h
C---- START of include file precession.h
C
C
C     .. Scalars in common block /PRECESSION/ ..
      REAL D1,D2,PHIPREC,PSIPREC,PCTOFD,XLAMBDA
      LOGICAL PRECESS
C     ..
C     .. Common Block /PRECESSION/ ..
      COMMON /PRECESSION/D1,D2,PHIPREC,PSIPREC,PCTOFD,XLAMBDA,PRECESS
C     ..
C
C
C&&*&& end_include  ../inc/precession.f
C&&*&& include  ../inc/ras.f
C
C $Id: ras.f,v 1.1 2002/05/02 10:47:10 harry Exp $
C
C--- awk generated include file  ras.h
C---- START of include file ras.h
C
C
C     .. Scalars in common block /RAS/ ..
      INTEGER NEWRAS,MINT
C     ..
C     .. Arrays in common block /RAS/ ..
      INTEGER IRAS
      REAL VARAS
C     ..
C     .. Common Block /RAS/ ..
      COMMON /RAS/VARAS(5),IRAS(5),NEWRAS,MINT
C     ..
C
C
C&&*&& end_include  ../inc/ras.f
C&&*&& include  ../inc/reflist.f
C
C $Id: reflist.f,v 1.1 2002/05/02 10:47:12 harry Exp $
C
C--- awk generated include file  reflist.h
C---- START of include file reflist.h
C
C
C     .. Arrays in common block /REFLIST/ ..
      INTEGER XREF,YREF,INTREF,ISDREF
C     ..
C     .. Common Block /REFLIST/ ..
      COMMON /REFLIST/XREF(NREFLS),YREF(NREFLS),INTREF(NREFLS),
     +       ISDREF(NREFLS)
C     ..
C
C
C&&*&& end_include  ../inc/reflist.f
C&&*&& include  ../inc/reprt.f
C--- awk generated include file  reprt.h
C---- START of include file reprt.h
C
C
C
C     .. Scalars in common block /REPRT/ ..
      REAL AVBGRATIO,AVSIG,RFULL,RPART,AVPKRATIO,PKRMAXI,BGRMAXI,
     +     RFACOV,SDRATOV,SDMON,RESCUT,STHCUT
      INTEGER NREF,NOFR,NOLO,MAXBSI,MINBSI,NEDGE,NBOX,NBZERO,NNEG,
     +        NBAD,NBGRJ,NEDGE1,NPARTEND,NSPOVL,NRSYM,NHALF,NSUMPART
      LOGICAL PKACCEPT
C     ..
C     .. Arrays in common block /REPRT/ ..
      REAL RATIO,AVSD,AVSDP,AVSIG1,AVSIG2,AVINTI1,AVINTI2,AVPRI1,
     +     AVPRI2,RMSDELI1,RMSDELI2,ABSDELI1,ABSDELI2,AVPRSIG1,
     +     AVPRSIG2,AVDELSIG1,AVDELSIG2,PKRATIO,RSIGVSM,
     +     FIOVSDP,FIOVSDS,PIOVSDP,PIOVSDS,DBIN
      INTEGER IRANGE,IANAL,IANALF,NRFLS1,NRFLS2,MEANDELI1,MEANDELI2,
     +        NBGRHIST,IVSM,NIVSM,NRESPF,NRESPP,NRESSF,NRESSP,
     +        IRESPF,IRESPP,IRESSF,IRESSP,ISDRESPF,ISDRESPP,
     +        ISDRESSF,ISDRESSP
C     ..
C     .. Common Block /REPRT/ ..
      COMMON /REPRT/RATIO(10),AVSD(10),AVSDP(10),AVSIG1(10,2),
     $       AVSIG2(NMASKS,2),AVINTI1(10,2),AVINTI2(NMASKS,2),
     $       AVPRI1(10,2),AVPRI2(NMASKS,2),RMSDELI1(10,2),
     +       RMSDELI2(NMASKS,2),ABSDELI1(10,2),ABSDELI2(NMASKS,2),
     +       AVPRSIG1(10,2),AVPRSIG2(NMASKS,2),AVDELSIG1(10,2),
     +       AVDELSIG2(NMASKS,2),PKRATIO(10),RSIGVSM(13),FIOVSDP(9),
     $       FIOVSDS(9),PIOVSDP(9),PIOVSDS(9),DBIN(9),
     $       AVBGRATIO,AVSIG,RFULL,RPART,AVPKRATIO,PKRMAXI,BGRMAXI,
     $       RFACOV,SDRATOV,SDMON,RESCUT,STHCUT,
     $       IRANGE(9),IANAL(10),IANALF(10),NRFLS1(10,2),
     +       NRFLS2(NMASKS,2),MEANDELI1(10,2),MEANDELI2(NMASKS,2),
     +       NBGRHIST(32),IVSM(13),NIVSM(13),
     +       NRESPF(9),NRESPP(9),NRESSF(9),NRESSP(9),
     +       IRESPF(9),IRESPP(9),IRESSF(9),IRESSP(9),ISDRESPF(9),
     +       ISDRESPP(9),ISDRESSF(9),ISDRESSP(9),NREF,NOFR,NOLO,
     $       MAXBSI,MINBSI,NEDGE,NBOX,NBZERO,NNEG,NBAD,
     +       NBGRJ,NEDGE1,NPARTEND,NSPOVL,
     +       NRSYM,NHALF,NSUMPART,PKACCEPT
C     ..
C
C
C&&*&& end_include  ../inc/reprt.f
C&&*&& include  ../inc/resest.f
C
C $Id: resest.f,v 1.1 2002/05/02 10:47:13 harry Exp $
C
C---- Start of include file resest.h
      LOGICAL RESEST
      COMMON/ESTIMATOR/RESEST
C&&*&& end_include  ../inc/resest.f
C&&*&& include  ../inc/rfs.f
C
C $Id: rfs.f,v 1.2 2007/07/12 13:25:57 andrew Exp $
C
C--- awk generated include file  rfs.h
C---- START of include file rfs.h
C
C
C
C     .. Scalars in common block /RFS/ ..
      REAL FDIST,ESTART,RMSRES,WRMSRES,WESTART
      INTEGER MAXREF,MAXX,MAXY,NRS,MAXR,NREJS,NCENTREF
C     ..
C     .. Arrays in common block /RFS/ ..
      REAL XRS,YRS,WXRS,WYRS
      INTEGER RRS,IHKLR
C     ..
C     .. Common Block /RFS/ ..
      COMMON /RFS/ XRS(NDETREF),YRS(NDETREF),WXRS(NDETREF),
     +       WYRS(NDETREF),FDIST,ESTART,RMSRES,WRMSRES,
     $       WESTART,RRS(NDETREF),IHKLR(3,NDETREF),MAXREF,MAXX,
     +       MAXY,NRS,MAXR,NREJS,NCENTREF
C     ..
C
C
C&&*&& end_include  ../inc/rfs.f
C&&*&& include  ../inc/scn.f
C
C $Id: scn.f,v 1.3 2004/08/16 13:26:48 harry Exp $
C
C--- awk generated include file  scn.h
C---- START of include file scn.h
C
C     SCNSZ   is pixel size (in microns) divided by 25
C     RAST    pixel size in slow direction in mm
C     FACT    multiplying by FACT converts from 10 micron units 
C             (the standard unit internal to the program) into pixels
C     IYLEN   The number of pixels in the Y (fastest changing) direction
C             in the digitised image.
C     NREC    The number of pixels in the X (slow) direction in the 
C             digitised image.
C     NWORD   The number of I*2 words in the Y direction.
C     NBYTE   The number of bytes in Y direction = NWORD/2
C     NHBYTE  Number of bytes in header
C
C     ICURR   When several images are stored in a single file, ICURR is the
C             pointer to the first record of the current image in the direct
C             access file (only implemented for film data)
C     NEXTRA  The number of additional (unused) bytes padding the end of
C             each record in image file
C     BYTSWAP True if the "endedness" (Big-endian/Little-endian) of the 
C             machine that MOSFLM is running on is different to that of the
C             machine on which the image was written. This is determined by
C             looking at the value of NXPIX in the header record of the
C             image file (subroutine GETHDR)
C
C     LACTIVE True if using Rigaku active mask, False if ignoring it
C
C     .. Scalars in common block /SCN/ ..
      REAL FACT,SCNSZ,RAST,RASTY
      INTEGER NBYTE,NREC,NWORD,IYLEN,ICURR,NEXTRA,NHBYTE
      LOGICAL BYTSWAP,LACTIVE
C     ..
C     .. Common Block /SCN/ ..
      COMMON /SCN/ FACT,SCNSZ,RAST,RASTY,NBYTE,NREC,NWORD,IYLEN,
     +     ICURR,NEXTRA,NHBYTE,BYTSWAP,LACTIVE
C&&*&& end_include  ../inc/scn.f
C&&*&& include  ../inc/sums.f
C
C $Id: sums.f,v 1.1 2002/05/02 10:47:21 harry Exp $
C
C--- awk generated include file  sums.h
C---- START of include file sums.h
C
C
C     Elements of ASPOT
C     1 = Summation integration intensity
C     2 = Total background counts under peak assuming peak has mm symmetry
C     3 = Rms variation in background, after rejecting background points.
C         This is evaluated in BGSOLVE called from EVAL.
C     4 = Centre of gravity in X direction (in pixels)
C     5 = Centre of gravity in Y direction (in pixels)
C         These are wrt an origin at the centre of the measurement box
C     6 = sum p*iod for background pixels
C     7 = sum q*iod for background pixels
C     8 = sum iod for background pixels
C     9 = Background plane constant a (gradient in X direction)
C    10 = Background plane constant b (gradient in Y direction)
C    11 = Background plane constant c 
C    12 = Largest deviation from background plane, excluding rejected pixels
C    13 = Profile fitted intensity
C    14 = Variance of profile fitted intensity = sum (deltasq) for peak
C         pixels only. Used to calculate PKRATIO and also profile fitted
C         sigma(I) in unweighted case only.
C    15 = Number of rejected background pixels
C    16 = Variance of profile fitted intensity in weighted case (default)
C    17 = sum W*DELTA**2 for profile fit
C    18   unused
C     .. Arrays in common block /SUMS/ ..
      REAL ASPOT
C     ..
C     .. Common Block /SUMS/ ..
      COMMON /SUMS/ASPOT(18)
C     ..
C
C
C&&*&& end_include  ../inc/sums.f
C     
      COMMON /XYSCAN/ IXPIX,IYPIX
C     ..
C     .. Equivalences ..
      EQUIVALENCE (IRAS(1),NXS), (IRAS(2),NYS), (IRAS(3),NC)
      EQUIVALENCE (IRAS(4),NRX), (IRAS(5),NRY)
      EQUIVALENCE (LRAS(1),NXX), (LRAS(2),NYY)
      EQUIVALENCE (ASPOT(1),SOD), (ASPOT(2),BGND), (ASPOT(3),RMSBG)
      EQUIVALENCE (ASPOT(4),DELX), (ASPOT(5),DELY),(ASPOT(9),A)
      EQUIVALENCE (ASPOT(10),B), (ASPOT(11),C), (ASPOT(12),BGDEVMAX)
C     ..
      SAVE
C     ..
C     
C     .. Data statements ..
C     
C---- These variables are required for consistency in calls to WRGEN
C     and REPORT from subroutine PROCESS, although they must both be
C     FALSE when not using profile fitting.
C     
      DATA PROFILEDUM/.FALSE./,USEOVRLDDUM/.FALSE./,NCOUNT/0/,
     +     OVRLFITDUM/.FALSE./,ISPOTPRO/0/,ISIGPRO/0/,PKRATIOS/0.0/,
     +     NSBOX/0/,FIXEDDUM/.FALSE./
C     
      CALLEDFROM = 'SPROCESS'
      NBIN1 = 8
      NRFL = 1
      MAXPIX = 0
      NNN = 1
C     *******************************************************************
C---- Initialise arrays and variables
C     *******************************************************************
      IF (LEN.EQ.0) THEN
         IF (BRIEF.AND.(.NOT.POSTREF)) WRITE(IBRIEF,FMT=6000)
         IF (ONLINE.AND.(.NOT.POSTREF)) WRITE (ITOUT,FMT=6000)
 6000    FORMAT (1X,'Integrating reflections')
         IF (DEBUG(49)) THEN
            WRITE(IOUT,FMT=6001) 
            IF (ONLINE) WRITE(ITOUT,FMT=6001)
         END IF
 6001    FORMAT(1X,'Initialising variables in SPROCESS')
C     
C---- IDR gives direction of scanning, +1 for left to right.
C     
         IDR = 1
C     
         IF (.NOT.IMGP) THEN
C     
C---- Generate look-up table
C     
            CFAC = CURV/N1OD
            BASE = BASEOD*N1OD
C     
C     
            DO 140 I = 0,255
               TRUOD = I - BASE
               TABLE(I) = (CFAC*TRUOD+1.0)*TRUOD + 0.5
               TABLE(I) = AMAX0(0,TABLE(I))
 140        CONTINUE
C     
         END IF
C     
C     
C---- Determine scale factor for intensities
C     
C     **********************************
         CALL SETMASK(MASK(1,1),IRAS)
         CALL SETSUMS(MASK(1,1),IRAS,SUMPQ(1,1))
C     **********************************
C 
         if(abs(sumpq(5,1)).lt.1e-4)then
           write(iout,fmt=1066)sumpq(5,1)
           if(online)write(itout,fmt=1066)sumpq(5,1)
 1066      format(' ****** SEVERE TICKING OFF *******',/,
     $          'Divisor in SPROCESS.F is ',F9.5,
     $          ' so we are returning from here',/)
           IERR = -1
           return ! call shutdown
         endif
         SCAI = 2.0*FLOAT(ISCAL)/SUMPQ(5,1)
C     
C     
C---- IOVER is flag for overloaded reflections, 9999 for film,
C     999999 for IP.
C     
         IOVER = 9999
C     
C---- For IP, make scale factor unity and change values in IRANGE
C     
         IF (IMGP) THEN
            IOVER = 999999
            SCAI = 1.0
            IRANGE(1) = -750
            IRANGE(2) = 0
            DO 11 I = 3,9
               IRANGE(I) = 1250*2**(I-3)    
 11         CONTINUE
         END IF
C     
C     
C---- Set up resolution bins
C     
         IRECG = 0
         CALL GETBIN(IRECG,ITHBIN,NBIN1,DSTSQ)
C     
         DO 180 I = 3,5
            LRAS(I) = IRAS(I)
C     
C---- Increase the rim and corner cutoff by 1 for post refinement
C     as this gives a "cleaner" signal and copes better with cases where
C     the slippage is large. Check that this still leaves at least 3
C     pixels in peak 
            IF (POSTREF) THEN
               IF ((I.EQ.3).OR.
     +              ((I.EQ.4).AND.((NXS - 2*NRX).GE.5)).OR.
     +              ((I.EQ.5).AND.((NYS - 2*NRY).GE.5))) THEN
                  LRAS(I) = LRAS(I) + 1
               END IF
            END IF
 180     CONTINUE
C     
C---- Calculate BOXFAC, used in calculation of contribution to spot
C     intensity variance due to scanner instrument errors
C     
         WPX = IRAS(1) - (IRAS(4)+1)*2
         WPY = IRAS(2) - (IRAS(5)+1)*2
         BOXFAC = (((WPX+1)/ (WPY+1))**2)* (WPY**2*3.0+WPY**3+5*WPY+3)/
     +        12.0
C     
         ISTRIPCUR = 0
         J = 0
         PI = ATAN(1.0)*4.0
C     
C---- Do not initialise arrays if only calling SPROCESS for postrefinement
C     
         IF (POSTREF) THEN
           IERR = 0
           RETURN
         ENDIF
C     
C---- Only open file for BADSPOTS if running online
C     
         IFAIL = 1
C     
C     *************************************
         IF (ONLINE.AND.(.NOT.MATCH))
     +        CALL CCPOPN(46,'BADSPOT',2,2,80,IFAIL)
C     *************************************
C     
C     
         IF (MAXR.GT.MAXBOX) THEN
            WRITE (IOUT,FMT=6002) MAXR,MAXBOX
 6002       FORMAT (' Measurement box size of',I5,' is greater than ',
     +           'MAXBOX=',I5)
            IF (BRIEF) WRITE (IBRIEF,FMT=6002) MAXR,MAXBOX
            IF (ONLINE) WRITE (ITOUT,FMT=6002) MAXR,MAXBOX
            NSHUTERR = 1
            CALL SHUTDOWN(CALLEDFROM,LENSTR(CALLEDFROM))
         END IF
C     
C---- Open file for dumping specified reflections to badspots file
C     
         IF (DUMPSPOT) THEN
            IF (ONLINE) WRITE (ITOUT,FMT=6004)
 6004       FORMAT (/,' Badspots output will contain specified ',
     +           'reflections read in from SPOTDUMP input file ')
            WRITE (IOUT,FMT=6004)
            IFAIL = 1
C     
C     ***********************************
            CALL CCPOPN(IDU,'SPOTDUMP',3,1,80,IFAIL)
C     ***********************************
C     
            I = 0
 120        CONTINUE
            I = I + 1
            IF (I.LE.50) THEN
               READ (IDU,FMT=*,END=130) (IHD(K,I),K=1,3)
               GO TO 120
            END IF
         END IF
C     
C---- Clear for statistics
C     
 130     NBADBG = 0
         NBAD = 0
         NOLO = 0
         NEDGE = 0
         NBOX = 0
         NBZERO = 0
         NOFR = 0
         MAXBSI = 0
         MINBSI = 200
C     
C     
         DO 145 I = 1,32
            NBGRHIST(I) = 0
 145     CONTINUE
C     
C     
         DO 150 I = 1,10
            IANAL(I) = 0
            AVSD(I) = 0.0
            RATIO(I) = 0.0
 150     CONTINUE
C     
         DO 152 I = 1,9
            NRESSF(I) = 0
            NRESSP(I) = 0
            FIOVSDS(I) = 0.0
            PIOVSDS(I) = 0.0
            IRESSF(I) = 0
            IRESSP(I) = 0
            ISDRESSF(I) = 0
            ISDRESSP(I) = 0
 152     CONTINUE
C     
         DO 160 I = 1,13
            IVSM(I) = 0
            RSIGVSM(I) = 0
            NIVSM(I) = 0
 160     CONTINUE
C     
C     
         DO 170 I = 1,16
            XSH(I) = 0.0
            YSH(I) = 0.0
            NSH(I) = 0
 170     CONTINUE
C     
C     
C---- Write header for badspots
C     
         IF (.NOT.ONLINE .AND. .NOT.MATCH) THEN
            WRITE (IOUT,FMT=6006)
 6006       FORMAT (1X,'List of badspots')
            WRITE (IOUT,FMT=6024)
         END IF
C     
C     
C     
C     *******************************************************************
C---- Final call, calculate and print statistics
C     *******************************************************************
C     
      ELSE IF (LEN.EQ.1) THEN
C     
         DO 90 I = 1,10
C     
C     
            IF (IANAL(I).NE.0) THEN
               RATIO(I) = RATIO(I)/IANAL(I)
               AVSD(I) = AVSD(I)/IANAL(I)
            END IF
C     
C     
 90      CONTINUE
C     
C     
C     
C---- Calculate averages for I/sigma analysis
C     
         DO 92 I = 1,9
            IF (I.LE.8) THEN
               FIOVSDS(9) = FIOVSDS(9) + FIOVSDS(I)
               PIOVSDS(9) = PIOVSDS(9) + PIOVSDS(I)
               IRESSF(9) = IRESSF(9) + IRESSF(I)
               IRESSP(9) = IRESSP(9) + IRESSP(I)
               ISDRESSF(9) = ISDRESSF(9) + ISDRESSF(I)
               ISDRESSP(9) = ISDRESSP(9) + ISDRESSP(I)
               NRESSF(9) = NRESSF(9) + NRESSF(I)
               NRESSP(9) = NRESSP(9) + NRESSP(I)
            END IF
C     
C---- Summation integration full
C     
            N = NRESSF(I)
            IF (N.NE.0) THEN
               FIOVSDS(I) = FIOVSDS(I)/N
               IRESSF(I) = IRESSF(I)/N
               ISDRESSF(I) = ISDRESSF(I)/N
            END IF
C     
C---- Summation integration partial
C     
            N = NRESSP(I)
            IF (N.NE.0) THEN
               PIOVSDS(I) = PIOVSDS(I)/N
               IRESSP(I) = IRESSP(I)/N
               ISDRESSP(I) = ISDRESSP(I)/N
            END IF
 92      CONTINUE
         
C     
C     
C     ******************************
         CALL REPORT(ID,NBOXES,USEOVRLDDUM)
         CALL XYSHIFT(0.0,0.0,0,0,XSH,YSH,NSH,2)
C     ******************************
C     
         IF (.NOT.MATCH) REWIND 46
         IF (ONLINE) WRITE (ITOUT,FMT=6018) NBAD
         IF (BRIEF) WRITE (IBRIEF,FMT=6018) NBAD
 6018    FORMAT (2X,'Number of bad spots =',I4)
         WRITE (IOUT,FMT=6018) NBAD
         IF (NBADBG.NE.0) THEN
            WRITE(IOUT,6019) NBADBG,NBGMIN
            IF (ONLINE) WRITE(ITOUT,6019) NBADBG,NBGMIN
            IF (BRIEF) WRITE(IBRIEF,6019) NBADBG,NBGMIN
 6019       FORMAT(/1X,I5,'Reflections rejected because fewer than',I4,
     +           ' background pixels left after rejection')
         END IF
C     
C---- Skip badspot examination if in batch mode
C     
         IF (ONLINE.AND.(.NOT.MATCH)) THEN
C     
C     
            IF (NBAD.NE.0) THEN
               IF (BRIEF) WRITE (IBRIEF,FMT=6020)
               WRITE (ITOUT,FMT=6020)
 6020          FORMAT (2X,'Do you want to check bad spots(Y OR N)? ',$)
C     
C     **********
               CALL YESNO(YES)
C     **********
C     
               IF (YES) THEN
                  IMAP = 0
                  IF (BRIEF) WRITE (IBRIEF,FMT=6022)
                  WRITE (ITOUT,FMT=6022)
 6022             FORMAT (2X,'Do you want a plot of each spot? ',$)
C     
C     **********
                   CALL YESNO(YES)
C     **********
C     
                  IF (.NOT.YES) IMAP = 1
C     
                  N = 0
C     
C     
                  DO 100 I = 1,NBAD
                     READ (46) KREC,ISPOT,ISDBSI,IBGND,BGRMS,BGRATIO,
     +                    NXY,NXX,NYY,A,B,C
                     READ (46) (OD(II),II=1,NXY)
                     JREC = ABS(KREC)
C     
C     ***************
                     CALL GETHKL(JREC,IH)
C     ***************
C     
                     XCG = IH(6)
                     YCG = IH(7)
                     CALL MMTOPX(XC,YC,XCG,YCG)
                     IXPIX = NINT(XC*FACT)
                     IYPIX = NINT(YC*FACT)
                     WRITE (ITOUT,FMT=6024)
                     IF (BRIEF) WRITE (IBRIEF,FMT=6024)
 6024                FORMAT ('    H   K   L   M    XG    YG    XS    ',
     +                    'YS   INT S.D.  BGRATIO PLANE A       B',
     $                    '       C')
                     WRITE (IOUT,FMT=6024)
                     WRITE (IOUT,FMT=6016) IH,IXPIX,IYPIX,ISPOT,ISDBSI,
     +                    BGRATIO,A,B,C
                     WRITE (ITOUT,FMT=6016) IH,ISPOT,ISDBSI,BGRATIO,
     $                    A,B,C
                     IF (BRIEF) WRITE (IBRIEF,FMT=6016) IH,ISPOT,
     +                    ISDBSI,BGRATIO,A,B,C
C     
C     
                     IF (IMAP.NE.1) THEN
C     
C     *****************************************
                        CALL SETMASK(MASK(1,1),LRAS)
C     CALL RASPLOT(OD,NXX,NYY,MASK(1,1),IDR,ODSCAL)
                        MAXPIX = 0
                        CALL ODPLOT4(OD,NXX,NYY,1,MAXPIX)
C     *****************************************
C     
                     END IF
C     
C     
                     WRITE (ITOUT,FMT=6028)
                     IF (BRIEF) WRITE (IBRIEF,FMT=6028)
 6028                FORMAT (' Reject (Y or N)? ',$)
                     WRITE (IOUT,FMT=6028)
C     
C     **********
                     CALL YESNO(YES)
C     **********
C     
                     IF (YES) WRITE (IOUT,FMT=6030)
 6030                FORMAT (' Y')
                     IF (.NOT.YES) WRITE (IOUT,FMT=6032)
 6032                FORMAT (' N')
C     
                     IF (YES) THEN
                        IRECG = ABS(KREC)
                        ISDG(IRECG) = -9999
                     END IF
C     
C     
 100              CONTINUE
               ELSE
C---- No inspection of bad spots
C     
C-----Flag nbad spots as rejected in generate file
C     
                  DO 110 I = 1,NBAD
                     READ (46) KREC,ISPOT
                     READ (46) JUNK
                     IRECG = ABS(KREC)
                     ISDG(IRECG) = -9999
 110              CONTINUE
C     
C     
               END IF
            END IF
         END IF
C     
C---- Write intensities etc back to generate file
C     
         MODEWR = 0
C     
         IF (BRIEF) WRITE(IBRIEF,FMT=6033)
 6033    FORMAT(/,1X,'Writing intensities back to generate file')
C     
         IF (PRECESS) THEN
C     
C     **********************
            CALL PWRGEN(MODEWR,PROFILEDUM)
C     **********************
C     
         ELSE
C     
C     ****************************
            CALL WRGEN(MODEWR,PROFILEDUM,SUMPART)
C     ****************************
C     
         END IF
C     
C     
         IF (ONLINE.AND.(.NOT.MATCH)) CLOSE (UNIT=46)
C     
         WRITE (IOUT,FMT=6034)
 6034    FORMAT (1X,/15 ('@@@@'),/)
         IF (ONLINE) WRITE (ITOUT,FMT=6034)
         IF (BRIEF) WRITE (IBRIEF,FMT=6034)
C     
C     
C     *******************************************************************
C---- Integrate reflection passed via /PEL/
C     *******************************************************************
C     
      ELSE IF (LEN.GT.1) THEN
C     
C---- Start calculation of integrated intensities
C     
C     
         KREC = IBUFF(1)
         IRECG = ABS(KREC)
         IXPIX = IBUFF(2)
         IYPIX = IBUFF(3)
         NXX = IBUFF(4)
         NYY = IBUFF(5)
         NPBOX = IBUFF(6)
C     
C---- If storing an expanded reflection list for automatch,
C     set XREF,YREF to the sorted scanner coords
C     note that IRECG is then the number of the reflection in
C     the sorted list produced by GENSORT, not the record
C     number in the generate file.
C     

         IF (MATCH) THEN
            XREF(IRECG) = IXPIX
            YREF(IRECG) = IYPIX
         END IF
C     
C     
         FULL = .FALSE.
C     
C     
         IF (KREC.GE.0.AND.(.NOT.POSTREF)) THEN
            FULL = .TRUE.
            NOFR = NOFR + 1
         END IF
C     
C     
C     
C---- Test for change of masks
C     
         CALL GETSTRIP(NPBOX,ISTRIP)
         IF (ISTRIP.EQ.ISTRIPCUR) GO TO 30
C     
         IF (DEBUG(49)) THEN
            WRITE(IOUT,FMT=6035) ISTRIP,NPBOX
            IF (ONLINE) WRITE(ITOUT,FMT=6035) ISTRIP,NPBOX
         END IF
 6035    FORMAT(1X,'SPROCESS, Setting up new masks for strip',I3,
     +        '  NPBOX',I3)
C     
         ISTRIPCUR = ISTRIP
         NFBOX = NPFIRST(ISTRIP)
         DO 20 K = 1,NYLINE-1
C     
C---- Test for valid box
C     
            IF (.NOT.BOX(NFBOX)) GOTO 22
            NYY = ISIZE(NFBOX,2)
C     
C     ***********************
            CALL SETMASK(MASK(1,K),LRAS)
            CALL SETSUMS(MASK(1,K),LRAS,SUMPQ(1,K))
C     ***********************
C     
            IF (DEBUG(49)) THEN
               WRITE(IOUT,FMT=6037) K,NFBOX,NXX,NYY
               IF (ONLINE) WRITE(ITOUT,FMT=6037) K,NFBOX,NXX,NYY
 6037          FORMAT(1X,'Y index',I3,' NFBOX',I3,' NXX,NYY',2I4)
            END IF
 22         NFBOX = NFBOX + 1
 20      CONTINUE
C     
C     
 30      NYY = IBUFF(5)
C     
C     
         NXY = NXX*NYY
C     
C     
         CALL GETYIND(NPBOX,NY)
C     
C     
C---- Debug
C     
         IF (DEBUG(49).AND.(NCOUNT.LT.NDEBUG(49))) THEN
            WRITE (IOUT,FMT=6010) IRECG,IXPIX,IYPIX,NOFR,NXX,NYY,
     +           NXY,ISTRIPCUR,SCAI,EFAC
            IF (ONLINE) WRITE (ITOUT,FMT=6010) IRECG,IXPIX,IYPIX,
     +           NOFR,NXX,NYY,NXY,ISTRIPCUR,SCAI,EFAC
 6010       FORMAT (1X,'IRECG =',I5,'  IX,IY ',2I6,'  NOFR=',I5,
     +           'NXX,NYY,NXY,ISTRIPCUR ',2I3,I5,I4,/1X,'SCAI ',
     $           F8.4,'  EFAC ',F10.4)
         END IF
C     
         TPEAK = SUMPQ(5,NY)
         TBGND = SUMPQ(6,NY)
C     
C---- Read densities for one spot
C     
         N = 0
C     
C---- Correct densities
C     
         DO 40 K = 1,NXY
C     
C     *********
            CALL CBYTE2(K)
C     *********
C     
            IF (IBA.LE.NULLPIX) THEN
               GO TO 70
            ELSE
               IF (IBA.GT.CUTOFF) N = N + 1
               IF (IMGP) THEN
                  OD(K) = IBA
               ELSE
                  OD(K) = TABLE(IBA)
               END IF
            END IF
C     
C     
 40      CONTINUE
C     
C---- Dump pixel values if debug set
C     
         IF ((DEBUG(49).AND.SPOT)) THEN
C     
C     *****************************************
            MAXPIX = 0
            CALL ODPLOT4(OD,NXX,NYY,1,MAXPIX)
C     CALL RASPLOT(OD,NXX,NYY,MASK(1,NY),IDR,ODSCAL)
C     *****************************************
C     
         END IF
C     
C---- If more than NOVPIX pixels have od.gt.cutoff, flag as overloaded
C     except when doing pattern matching
C     
         IF ((N.GT.NOVPIX) .AND. (.NOT.MATCH)) THEN
            NOLO = NOLO + 1
            GO TO 80
         END IF
C     
C     
C     
C     Note that MASKREJ, PQSUMS are not used in this S/R,
C     but are required when INTEG is called from PROCESS. They are
C     essentially dummy arguments here. (Declared Local Variables)
C     **********************************************
         CALL INTEG(OD,LRAS,MASK(1,NY),SUMPQ(1,NY),IDR,FULL,
     +        BGSIG,MASKREJ,PQSUMS,NRFL)
C     **********************************************
C     
C     
C---- Check that background under peak is not negative
C     
         IF (ASPOT(2).LT.0.0) THEN
            WRITE(IOUT,FMT=6103) ASPOT(2),IDIVIDE
            IF (ONLINE) WRITE(ITOUT,FMT=6103) ASPOT(2),IDIVIDE
 6103       FORMAT(1X,'** WARNING **',/,1X,'The total background',
     +           '  counts under the peak region has',/,1X,'become ',
     +           'negative (value is',F8.1,')after subtracting the ', 
     +           'scanner adc',/,1X,'offset (value currently',I6,/,
     $           1X,'Reset the scanner offset using',
     +           ' keyword ADCOFFSET followed by value')
         END IF
         IF (DEBUG(49).AND.(NCOUNT.LT.NDEBUG(49))) THEN
            NCOUNT = NCOUNT + 1
            WRITE(IOUT,FMT=6011) ASPOT
            IF (ONLINE) WRITE(ITOUT,FMT=6011) ASPOT
         END IF
 6011    FORMAT(1X,'SPROCESS, after calling INTEG, ASPOT:',/,
     +        (1X,6F12.0))
C---- Test that it has not rejected an unacceptable number of
C     background points. This is set in INTEG to ensure at least
C     NBGMIN (set using keywords REJECTION MINBG) background pixels left,
C     and if not, flagged with ASPOT(1)=-9999. No data are available for
C     these reflections as the background plane is not calculated.
         IF (ASPOT(1).EQ.-9999.0) THEN
            NBADBG = NBADBG + 1
            ISDG(IRECG) = -9999
            ISDPRO(IRECG) = -9999
            IF (MATCH) THEN
               INTREF(IRECG) = 0
               ISDREF(IRECG) = -9999
            END IF
            ISPOT = -9999
            ISDBSI = 0
            IBGND = 0
            RMSBG = 0.0
            BGRATIO = 0.0
C     
C---- If this is a spot for post refinement, just return
C     
            IF (POSTREF) THEN
              IERR = 0
              RETURN
            ENDIF
            GOTO 65
         END IF
C     
C---- Calculate standard deviation of intensity
C     
         VSPOT = GAIN*SOD
         VBG = TPEAK*RMSBG
         VBG = VBG*VBG/TBGND
         XX = (SOD/BOXFAC)**2*TPEAK
C     
C---- Last term is to allow for scanner instrument errors
C     
C     change to counting statistics
C     ISDBSI = SQRT(2*VBG+ABS(VSPOT)+EFAC*EFAC*XX)*SCAI + 0.5
C
C----- Now that the default EFAC is used rather than the value calculated
C      for this image, no longer make the distinction on how variance is 
C      calculated. A.G.W.L. 12/11/01
C
C         IF (POSTREF.OR.MATCH) THEN
C            VARTOT=GAIN*(SOD+BGND+BGND*TPEAK/TBGND)
C         ELSE
C
            VARTOT=GAIN*(SOD+BGND+BGND*TPEAK/TBGND)+EFAC*EFAC*XX
C
C         END IF
         IF (VARTOT.LE.0.0) VARTOT = 0
         ISDBSI = SCAI*SQRT(VARTOT) + 0.5
         ISPOT = SCAI*SOD + 0.5
C     
C---- Test for unreasonable standard deviation (and too large to store
C     as I*2). This can only result from an error except when pattern
C     matching where overloads are allowed (so just reset and continue).
C     
 1067    FORMAT(60('-'),/,'IH = ',3i4,4i8,/,'IXPIX, IYPIX = ',2I10,/,
     $        'NXX,NYY,NXY = ',3I6,' ISTRIPCUR = ',I5,/,
     $        'SCAI = ',F8.3,' EFAC = ',F8.3,' SOD = ',E12.4,
     $        ' BGND = ',F12.3,' TPEAK = ',F12.4,' TBGND = ',F12.4,/,
     $        'XX = ',E12.4,' BOXFAC = ',F10.3,' RMSBG = ',F9.4,
     $        ' ISDBSI = ',I10)
         IF (ISDBSI.GT.32767) THEN
            ISDBSI = 32000
            IF (DEBUG(49)) THEN
                WRITE(IOUT,FMT=6110)ISDBSI
                IF (ONLINE) WRITE (ITOUT,FMT=6110) ISDBSI
                IF (BRIEF) WRITE (IBRIEF,FMT=6110) ISDBSI
 6110           FORMAT(/,/,1X,'Error 6110 in subroutine sprocess',
     $               /,4(1X,'**** WARNING ****'),/,1X,
     $               'The standard deviation of the integrated ',
     $               'intensity is',I10,/,1X,'which is greater t',
     $               'han the maximum allowed value (32767) Somet',
     $               'hing is wrong',/,1X,'The value has been re-',
     $               'set to 32000, but you should examine this ',
     $               'spot carefully. The pixel va',
     $               'lues for this spot follow',/)
                MAXPIX = 0
                WRITE(IOUT,FMT=1067)IH,IXPIX,IYPIX,NXX,NYY,NXY,
     $               ISTRIPCUR,SCAI,EFAC,SOD,BGND,TPEAK,TBGND,
     $               XX,BOXFAC,RMSBG,ISDBSI
                IF(ONLINE)WRITE(ITOUT,FMT=1067)IH,IXPIX,IYPIX,NXX,
     $               NYY,NXY,ISTRIPCUR,SCAI,EFAC,SOD,BGND,TPEAK,
     $               TBGND,XX,BOXFAC,RMSBG,ISDBSI
                CALL ODPLOT4(OD,NXX,NYY,1,MAXPIX)
                WRITE(IOUT,FMT=6109) EFAC
                IF (ONLINE) WRITE(ITOUT,FMT=6109) EFAC
 6109           FORMAT(/,1X
     &               ,'The value of the scanner error factor used '
     &               ,'in the calculation of the',/,1X
     &               ,'standard deviation',' is',F12.3
     &               ,'. Is this correct ?')
            END IF
         END IF
C     
         IF (BGND.LE.0.0) THEN
            WRITE (ITOUT,FMT=6012) IXPIX,IYPIX
            IF (BRIEF) WRITE (IBRIEF,FMT=6012) IXPIX,IYPIX
 6012       FORMAT (' Zero background spot, X,Y ',2I5)
            BGND = 0.01
            NBZERO = NBZERO + 1
         END IF
C     
C     
         BGRATIO = RMSBG/SQRT(GAIN*BGND/TPEAK)
         IBGND = SCAI*BGND + 0.5
C     
C     Calculate maximum gradient
C     
         IF (C.GT.0.0) THEN
            GRADM = MAX(ABS(A),ABS(B))/C
         ELSE
            GRADM = 0.0
         END IF
C     
C     
C---- For postrefinement, save this reflection if not a "badspot"
C     
         IF (POSTREF) THEN       
            CALL GETHKL(IRECG,IH)
C     
C---- C is the local background for the spot
C     
            IF((BGRATIO.LE.BGRAT).AND.(GRADM.LT.GRADMAX))THEN
               IF(.NOT.NEWPREF)THEN
                  INTPOST(1) = ISPOT
                  SIGPOST(1) = ISDBSI
                  INTPOST(2) = 0
                  SIGPOST(2) = 0
                  PHIPOST = 0.0
c 21032002
c---- g77 compiler points out that call to postref has an inconsistent 
c     number of arguments below. Should 'multiseg' be .false. or .true.?)
c
                  MULTISEG = .FALSE.
                  CALL POSTREFL(IRECG,INTPOST,SIGPOST,C,
     +                 RESID,RETA,RDIVH,RDIVV,FIXEDDUM,
     +                 ISTAT,LASTREC,NEWPREF,0,MULTISEG)
               ELSE
                  KHF = IRG(IRECG)
                  IF (KHF.GT.0) THEN
                    IMODE = 2
C
C---- Transfer intensity and sigma into INTPOST,SIGPOST for partials only
C
                    INTPOST(1) = ISPOT
                    SIGPOST(1) = ISDBSI
                    CALL MODARRAY(IMODE,C,IRECG,LASTREC,
     $                 INTPOST,SIGPOST)
C
C---- LASTREC is set equal to IRECG for completed reflections by MODARRAY
C
                    IF (LASTREC.EQ.IRECG)THEN
c 21032002
c---- g77 compiler points out that call to postref has an inconsistent 
c     number of arguments below. Should 'multiseg' be .false. or .true.?)
c
                       CALL POSTREFL(IRECG,INTPOST,SIGPOST,
     +                    C,RESID,RETA,
     +                    RDIVH,RDIVV,FIXEDDUM,ISTAT,LASTREC,
     +                    NEWPREF,0,.false.)
                    ENDIF
                  ENDIF
               ENDIF
            ENDIF
            IF (DEBUG(49).AND.(NCOUNT.LT.NDEBUG(49))) THEN
               BADFLAG = ((BGRATIO.GT.BGRAT).OR.(GRADM.GT.GRADMAX))
               WRITE(IOUT,FMT=6013) 
     +              (IH(I),I=1,3),ISPOT,IRECG, IXPIX,IYPIX,
     +              ISDBSI,BADFLAG
               IF (ONLINE) WRITE(ITOUT,FMT=6013) 
     +              (IH(I),I=1,3),IRECG,IXPIX,IYPIX,
     +              ISPOT,ISDBSI,BADFLAG
            END IF
 6013       FORMAT(1X,'H,K,L = ',3I4,
     +           ' IRECG = ',I8,' IXPIX, IYPIX = ',2I5,
     +           ' I,SIGMA',2I8,'  Badspot flag ',L1)
            IERR = 0
            RETURN
         END IF
 65      IF (MATCH) THEN
            IF (ASPOT(1).NE.-9999.0) THEN
               INTREF(IRECG) = ISPOT
C     
C---- Do not use EFAC when pattern matching (it will have its default
C     value of -999 if profile fitting!!
C     
               ISDREF(IRECG) = SQRT(VARTOT)*SCAI + 0.5
               if(resest)then
                  CALL GETBIN(IRECG,ITHBIN,NBIN1,DSTSQ)
                  IPART = IMG(IRECG)
                  CALL STATS(ISPOT,ISDBSI,ISPOTPRO,ISIGPRO,BGRATIO,
     +                 PKRATIOS,NSBOX,IPART,FULL,OVRLFITDUM,ITHBIN)
               ENDIF
            END IF
         ELSE
            IF (ASPOT(1).EQ.-9999.0) GOTO 66
            INTG(IRECG) = ISPOT
            ISDG(IRECG) = ISDBSI
C     
            IF (FULL) THEN
               IF (ISPOT.GE.IRANGE(3)) THEN
                  XX = IXPIX/FACT
                  YY = IYPIX/FACT
                  DELX = DELX/FACT
                  DELY = DELY/FACT
C     
                  IXX = XX - XCEN
                  IYY = YY - YCEN
C     
C     ****************************************
                  CALL XYSHIFT(DELX,DELY,IXX,IYY,XSH,YSH,NSH,1)
C     ****************************************
C     
               END IF
            END IF
C     
C     
            MAXBSI = MAX(MAXBSI,ISPOT)
            MINBSI = MIN(MINBSI,ISPOT)
C     
C---- Background point rejection histogram
C     
            NREJ = ASPOT(15)
            II = (NREJ-1)/5 +2
            IF (NREJ.EQ.0) II = 1                
            IF (II.GT.31) II = 32
            NBGRHIST(II) = NBGRHIST(II) + 1
C     
C---- Add contributions for statistics
C     
C     
            CALL GETBIN(IRECG,ITHBIN,NBIN1,DSTSQ)
            IPART = IMG(IRECG)
            CALL STATS(ISPOT,ISDBSI,ISPOTPRO,ISIGPRO,BGRATIO,
     +           PKRATIOS,NSBOX,IPART,FULL,OVRLFITDUM,ITHBIN)
C     
C---- Only allow dumping specific reflections to badspot file if online.
C     
 66         IF ((DUMPSPOT) .AND. (ONLINE) .AND.(.NOT.MATCH)) THEN
C     
C     **************************
               CALL COMPR(KREC,IHD,LDUMP,NSPT)
C     **************************
C     
               IF (LDUMP) THEN
                  WRITE (46) KREC,ISPOT,ISDBSI,IBGND,RMSBG,BGRATIO,NXY,
     +                 NXX,NYY,A,B,C
                  WRITE (46) (OD(II),II=1,NXY)
                  NBAD = NBAD + 1
               ELSE
                 IERR = 0
                 RETURN
               END IF
            END IF
         END IF
C     
C---- Test for badspots
C     If pattern matching, only test bgratio for spots with
C     negative intensity
C     
         IF (((BGRATIO.GT.BGRAT).AND. ((.NOT.MATCH).OR.
     +        (MATCH.AND. (ISPOT.LT.0)))) .OR.
     +        (ISPOT.LT.-5*ISDBSI).OR.(GRADM.GT.GRADMAX)) THEN
            IF (MATCH) THEN
               ISDREF(IRECG) = -9999
            ELSE
C     
C---- Only write badspots to file if running online
C     
               IF (ONLINE.AND.(.NOT.MATCH)) THEN
                  WRITE (46) KREC,ISPOT,ISDBSI,IBGND,RMSBG,BGRATIO,NXY,
     +                 NXX,NYY,A,B,C
                  WRITE (46) (OD(II),II=1,NXY)
               END IF
C     
C     
               NBAD = NBAD + 1
               IF (DEBUG(49)) THEN
                  WRITE (IOUT,FMT=6014) KREC,ISPOT,
     +                 ISDBSI,IBGND,RMSBG,BGRATIO,NXY,NXX,NYY
                  IF (ONLINE) WRITE (ITOUT,FMT=6014) KREC,ISPOT,
     +                 ISDBSI,IBGND,RMSBG,BGRATIO,NXY,NXX,NYY
 6014             FORMAT (1X,'BADSPOT, KREC,ISPOT,ISDBSI,IBGND:',4I6,
     $                 /,1X,' RMSBG, BGRATIO',2F5.1,' NXY,NXX,NYY',3I5)
               END IF
C     
C---- If running in batch mode, flag bad spots as rejected
C     
               IF (.NOT.ONLINE) THEN
C     
C     ****************
                  CALL GETHKL(IRECG,IH)
C     ****************
C     

                  XCG = XG(IRECG)
                  YCG = YG(IRECG)
                  CALL MMTOPX(XC,YC,XCG,YCG)
                  IXPIX = NINT(XC*FACT)
                  IYPIX = NINT(YC*FACT)
                  IF (BADPLOT) WRITE(IOUT,6024)
                  WRITE (IOUT,FMT=6016) (IH(II),II=1,4),XG(IRECG),
     +                 YG(IRECG),IXPIX,IYPIX,ISPOT,ISDBSI,BGRATIO,
     $                 A,B,C
 6016             FORMAT (1X,4I4,2F8.1,4I6,4F8.1)
                  IF (BADPLOT) THEN
                     WRITE(IOUT,FMT=6017)
 6017                FORMAT(1X,'Pixel values for this spot')
                     MAXPIX = 0
                     CALL ODPLOT4(OD,NXX,NYY,1,MAXPIX)
                     WRITE(IOUT,6015)
 6015                FORMAT(//)
                  END IF
                  ISDG(IRECG) = -9999
               END IF
            END IF
         END IF
C     
C     
         IERR = 0
         RETURN
C     
C     
 70      NEDGE = NEDGE + 1
         INTG(IRECG) = -9999
         ISDG(IRECG) = -9999
         IERR = 0
         RETURN
C     
C     
 80      INTG(IRECG) = IOVER
         ISDG(IRECG) = -9999
      END IF
      IERR = 0
      RETURN
      END
C== STDPROF ==
      SUBROUTINE STDPROF(OD,IRAS,MASK,IPROFL,SCALE,ODMIN)
C     ===================================================
      IMPLICIT NONE
C
C
C---- Apply background correction to obtain standard profile
C     for this box and scale to peak value 10000
C     Evaluate and store sums for this profile in IPROFL
C     Note that OD is background subtracted when returned from
C     this S/R
C
C
C     .. Scalar Arguments ..
      REAL ODMIN,SCALE
C     ..
C     .. Array Arguments ..
      INTEGER IRAS(5),MASK(*),OD(*),IPROFL(*)
C     ..
C     .. Local Scalars ..
      REAL A,APC,B,C
      INTEGER HX,HY,IJ,IOD,IODMAX,IODMIN,K,NBREJ,NXY,P,Q
C     ..
C     .. Intrinsic Functions ..
      INTRINSIC MAX,MIN
C     ..
C     .. Common blocks ..
C&&*&& include  ../inc/sums.f
C
C $Id: sums.f,v 1.1 2002/05/02 10:47:21 harry Exp $
C
C--- awk generated include file  sums.h
C---- START of include file sums.h
C
C
C     Elements of ASPOT
C     1 = Summation integration intensity
C     2 = Total background counts under peak assuming peak has mm symmetry
C     3 = Rms variation in background, after rejecting background points.
C         This is evaluated in BGSOLVE called from EVAL.
C     4 = Centre of gravity in X direction (in pixels)
C     5 = Centre of gravity in Y direction (in pixels)
C         These are wrt an origin at the centre of the measurement box
C     6 = sum p*iod for background pixels
C     7 = sum q*iod for background pixels
C     8 = sum iod for background pixels
C     9 = Background plane constant a (gradient in X direction)
C    10 = Background plane constant b (gradient in Y direction)
C    11 = Background plane constant c 
C    12 = Largest deviation from background plane, excluding rejected pixels
C    13 = Profile fitted intensity
C    14 = Variance of profile fitted intensity = sum (deltasq) for peak
C         pixels only. Used to calculate PKRATIO and also profile fitted
C         sigma(I) in unweighted case only.
C    15 = Number of rejected background pixels
C    16 = Variance of profile fitted intensity in weighted case (default)
C    17 = sum W*DELTA**2 for profile fit
C    18   unused
C     .. Arrays in common block /SUMS/ ..
      REAL ASPOT
C     ..
C     .. Common Block /SUMS/ ..
      COMMON /SUMS/ASPOT(18)
C     ..
C
C
C&&*&& end_include  ../inc/sums.f
C     ..
C     .. Equivalences ..
      EQUIVALENCE (ASPOT(9),A), (ASPOT(10),B), (ASPOT(11),C)
C     ..
C
       SAVE
C
      HX = IRAS(1)/2
      HY = IRAS(2)/2
      NXY = IRAS(1)*IRAS(2)
      NBREJ = 0
      IJ = 0
C
C
      IODMIN = 999999
      IODMAX = 0
C
C
      DO 20 P = -HX,HX
        APC = A*P + C
C
C
        DO 10 Q = -HY,HY
          IJ = IJ + 1
          IOD = OD(IJ) - (B*Q+APC)
          IODMIN = MIN(IODMIN,IOD)
C
C---- Limit max value to peak pixels
C
          IF (MASK(IJ).EQ.1) IODMAX = MAX(IODMAX,IOD)
          OD(IJ) = IOD
   10   CONTINUE
   20 CONTINUE
C
C---- Scale profile in range 0 to 10000
C
      SCALE = 10000.0/ (IODMAX-IODMIN)
C
C
      DO 30 K = 1,NXY
        IOD = (OD(K)-IODMIN)*SCALE + 0.5
        IPROFL(K) = IOD
   30 CONTINUE
C
C
      ODMIN = IODMIN
C
C
      END
      SUBROUTINE SMOOTHETA(NIMAG,NDONE)
C     ===========================================
C
      IMPLICIT NONE
C
C
C     .. Parameters ..
C&&*&& include  ../inc/reeke.f
C
C $Id: reeke.f,v 1.15 2008/10/22 08:50:48 andrew Exp $
C
C--- awk generated include file  reeke.h
C---- START of include file reeke.h
C
C     TOR     For synchrotron sources, degree of polarisation of the beam
C     IMONO   Collimation flag for polarisation.
C             = 0   Pinhole or mirrors
C             = 1   Graphite Monochromator
C             = 2   Synchrotron, use TOR
C     NWMAX   Maximum reflection width in images
C     DSTMAX  dimensionless rlu, = WAVE/RES where RES is the maximum
C             resolution in Angstrom.
C     DSTMIN  dimensionless rlu, = WAVE/DMAX where DMAX is the maximum
C              Bragg spacing
C     S0      radiation source vector (-1,0,0), may be modified by MU values
C     SOURCE  radiation source vector - basis for s0
C     GONIO_angle:  machine angles for generalized goniostats
C     GONIO_angle_SET: fixed offset angles for 3- and 4-circle goniostats
C                      i.e. currently 54.74 deg for Bruker CHI, 50.0deg for
C                      Nonius and Oxford KAPPA 
C     ..
C     .. Arrays in common block /REEKE/ ..
      REAL RMC,AMAT,SCAXIS,S0,s0unit,CAMCON,BEAMMU
C     ..
C     .. Scalars in common block /REEKE/ ..
      REAL X1,X2,Y1,Y2,Z1,Z2,XYS,DSTAR2,DSTMAX,DSTPL,DSTPL2,
     +     DIVH,DIVV,DELAMB,ETA,DELCOR,DSTMAXS,TOR,DSTMIN,WMAX,
     +     ETAFRAC,ETASM,
     $     GON_CHI,GON_PHIS,GON_KAPPA,GON_OMEGAS,GON_2THETA,
     $     GON_PHIE,GON_OMEGAE,
     +     GON_CHI_SET,GON_KAPPA_SET,
     +     BLKSIZE
      INTEGER ISYN,IMONO,NWMAX,IPAD,NSMOOTH,IGON_CHI,IGON_PHI,
     $     IGON_KAPPA,IGON_OMEGA,IGON_2THETA,
     +     IGON_CHI_SET,IGON_KAPPA_SET,IHOSCAXIS
C     ..
C     .. logicals in common block /REEKE/ ..
      LOGICAL LOGETA,NUREEK,LCAMCON,GENGON,FOURCIRCLE,THREECIRCLE
C     ..
C     .. Common Block /REEKE/ ..
      COMMON /REEKE/RMC(3,3),AMAT(3,3),SCAXIS(3),S0(3),s0unit(3),
     $     CAMCON(8),BEAMMU(2),X1,X2,Y1,Y2,
     +     Z1,Z2,XYS,DSTAR2,DSTMAX,DSTPL,DSTPL2,DIVH,DIVV,DELAMB,
     +     ETA,DELCOR,DSTMAXS,TOR,DSTMIN,WMAX,ETAFRAC,ETASM,
     $     GON_CHI,GON_PHIS,GON_KAPPA,GON_OMEGAS,GON_2THETA,
     $     GON_PHIE,GON_OMEGAE,
     +     GON_CHI_SET,GON_KAPPA_SET,ISYN,IMONO,
     $     NWMAX,IPAD,
     $     NSMOOTH,IGON_CHI,IGON_PHI,
     $     IGON_KAPPA,IGON_OMEGA,IGON_2THETA,
     +     IGON_CHI_SET,IGON_KAPPA_SET,IHOSCAXIS,LOGETA,NUREEK,LCAMCON,
     $     GENGON,FOURCIRCLE,THREECIRCLE,
     +     BLKSIZE
C     ..
C
C
C&&*&& end_include  ../inc/reeke.f
C
C     ..
C     .. Scalar Arguments ..
      INTEGER NIMAG,NDONE
C
C     ..
C     .. Array Arguments ..
C     ..
C     .. Local Scalars ..
      DOUBLE PRECISION ETAOLDD,ETASMD,ETAD,ETAFRACD
      REAL ETAOLD
      INTEGER NOFFSET
C     ..
C     .. Local Arrays ..
C     ..
C     .. External Functions ..
C     ..
C     .. External Subroutines ..
C     ..
C     .. Intrinsic Functions ..
C     ..
C     .. Common blocks ..
C     ..
C     .. Equivalences ..
      SAVE
C     ..
C     .. Data ..
C     ..
C---- cast reals to doubles
C
      ETAD = DBLE(ETA)
      ETAFRACD = DBLE(ETAFRAC)
C
C
C---- Check if this is the first time a refined value has been obtained
C     in this run.
C
      IF (NDONE.EQ.0) THEN
        NOFFSET = NIMAG
        NDONE = 1
        ETAOLDD = ETAD
        ETAOLD = REAL(ETAOLDD)
        ETASMD = ETAD + ( ETAFRACD * ETAD )
        ETASM = REAL(ETASMD)
      ELSE
C
C---- Set up the weighting for this value
C
        NDONE = NIMAG - NOFFSET + 1
        NDONE = MIN(NDONE,NSMOOTH)
        IF (NDONE.GT.0) THEN
          ETASMD = (DBLE(NDONE-1)/DBLE(NDONE)) * ETAOLDD + 
     +         (1.0/DBLE(NDONE)) * ETAD
        ELSE
          ETASMD = ETAD
        END IF
        ETAOLDD = ETASMD
C     
        ETASMD = ETASMD + (ETAFRACD * ETASMD)
        ETAOLD = REAL(ETAOLDD)
        ETASM = REAL(ETASMD)
C      
      ENDIF
      RETURN
      END
C
C
C
C
C     =======================================
      SUBROUTINE DGELS(R,A,M,N,EPS,IRANK,AUX)
C     =======================================
      IMPLICIT NONE
C
C
C
C
C     PURPOSE
C         TO SOLVE A SYSTEM OF SIMULTANEOUS LINEAR EQUATIONS WITH
C         SYMMETRIC COEFFICIENT MATRIX UPPER TRIANGULAR PART OF
C         WHICH IS ASSUMED TO BE STORED COLUMNWISE.
C
C     DESCRIPTION OF PARAMETERS
C         R        - M BY N RIGHT HAND SIDE MATRIX. (DESTROYED)
C                    ON RETURN R CONTAINS THE SOLUTION OF THE EQUATIONS.
C         A        - UPPER TRIANGULAR PART OF THE SYMMETRIC M BY M
C                    COEFFICIENT MATRIX. (DESTROYED)
C         M        - THE NUMBER OF EQUATIONS IN THE SYSTEM.
C         N        - THE NUMBER OF RIGHT HAND SIDE VECTORS.
C         EPS      - AN INPUT CONSTANT WHICH IS USED AS RELATIVE
C                    TOLERANCE FOR TEST ON LOSS OF SIGNIFICANCE.
C       IRANK      - RANK OF MATRIX
C         AUX      - AN  AUXILIARY STORAGE ARRAY OF DIMENSION M-1.
C
C     REMARKS
C         UPPER TRIANGULAR PART OF MATRIX A IS ASSUMED TO BE STORED
C         COLUMNWISE IN M*(M+1)/2 SUCCESSIVE STORAGE LOCATIONS,
C         RIGHT HAND SIDE MATRIX R COLUMNWISE IN N*M SUCCESSIVE
C         STORAGE LOCATIONS. ON RETURN SOLUTION MATRIX R IS STORED
C         COLUMNWISE TOO.
C
C     METHOD
C         SOLUTION IS DONE BY MEANS OF GAUSS-ELIMINATION WITH PIVOTING
C         IN MAIN DIAGONAL, IN ORDER TO PRESERVE SYMMETRY IN REMAINING
C         COEFFICIENT MATRICES.
C
C
      INTEGER   II,I,J,K,L,LL,LLD,LLST,LR,LST,LT,LEND,M,N,NM,IRANK
      REAL*8   A(*),R(*),AUX(*),TB,PIV,PIVI,TOL,EPS,ZERO,ONE
      PARAMETER (ZERO=0.0D+00,ONE=1.0D+00)
C
C
C
C---- search for greatest main diagonal element
C
      i = 0
      j = 0
      IRANK=0
      IF (M.LT.1)RETURN
      PIV=ZERO
      L=0
      DO 10 K=1,M
      L=L+K
      TB=DABS(A(L))
      IF (TB.LE.PIV)GO TO 10
      PIV=TB
      I=L
      J=K
10    CONTINUE
      TOL=EPS*PIV
      IF (TOL.LE.ZERO)RETURN
C
C---- start elimination loop
C
      LST=0
      NM=N*M
      LEND=M-1
      DO 100 K=1,M
C
C---- test on usefulness of symmetric algorithm
C
      IF (PIV.LE.TOL)THEN
	  PIVI=ZERO
      ELSE
	  PIVI=ONE/A(I)
	  IRANK=IRANK+1
      ENDIF
      LT=J-K
      LST=LST+K
C
C---- pivot row reduction and row interchange in right hand side r
C
      DO 20 L=K,NM,M
      LL=L+LT
      TB=PIVI*R(LL)
      R(LL)=R(L)
20    R(L)=TB
C
C---- check if elimination is terminated
C
      IF (K.GE.M)GO TO 110
C
C---- row and column interchange and pivot row reduction in matrix a.
C     elements of pivot column are saved in auxiliary vector aux.
C
      LR=LST+(LT*(K+J-1))/2
      LL=LR
      L=LST
      DO 70 II=K,LEND
      L=L+II
      LL=LL+1
      IF (L-LR)50,30,40
30    A(LL)=A(LST)
      TB=A(L)
      GO TO 60
40    LL=L+LT
50    TB=A(LL)
      A(LL)=A(L)
60    AUX(II)=TB
70    A(L)=PIVI*TB
C
C---- save column interchange information
C
      A(LST)=LT
C
C---- element reduction and search for next pivot
C
      PIV=ZERO
      LLST=LST
      LT=0
      DO 100 II=K,LEND
      PIVI=-AUX(II)
      LL=LLST
      LT=LT+1
      DO 80 LLD=II,LEND
      LL=LL+LLD
      L=LL+LT
80    A(L)=A(L)+PIVI*A(LL)
      LLST=LLST+II
      LR=LLST+LT
      TB=DABS(A(LR))
      IF (TB.LE.PIV)GO TO 90
      PIV=TB
      I=LR
      J=II+1
90    DO 100 LR=K,NM,M
      LL=LR+LT
100   R(LL)=R(LL)+PIVI*R(LR)
C
C----  end of elimination loop
C      back substitution and back interchange
C
110   IF (LEND.LT.1)RETURN
      II=M
      DO 130 I=2,M
      LST=LST-II
      II=II-1
      L=A(LST)+.5
      DO 130 J=II,NM,M
      TB=R(J)
      LL=J
      K=LST
      DO 120 LT=II,LEND
      LL=LL+1
      K=K+LT
120   TB=TB-A(K)*R(LL)
      K=J+L
      R(J)=R(K)
130   R(K)=TB
      RETURN
      END
